/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the ARM target                             *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 85;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(ARMInstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(ARMInstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static ARMInstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static ARMInstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(0),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_v2s1,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s1,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v4s64,
  GILLT_v8s1,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v8s64,
  GILLT_v16s1,
  GILLT_v16s8,
};
const static size_t NumTypeObjects = 16;
const static LLT TypeObjects[] = {
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::vector(ElementCount::getFixed(2), 1),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 1),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(4), 64),
  LLT::vector(ElementCount::getFixed(8), 1),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(8), 64),
  LLT::vector(ElementCount::getFixed(16), 1),
  LLT::vector(ElementCount::getFixed(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_NoHonorSignDependentRoundingBit = 75,
  Feature_HasV4TBit = 6,
  Feature_NoV4TBit = 7,
  Feature_HasV5TBit = 13,
  Feature_NoV5TBit = 65,
  Feature_HasV5TEBit = 11,
  Feature_HasV6Bit = 0,
  Feature_NoV6Bit = 9,
  Feature_HasV6MBit = 28,
  Feature_HasV8MBaselineBit = 35,
  Feature_HasV8_1MMainlineBit = 41,
  Feature_HasMVEIntBit = 63,
  Feature_HasMVEFloatBit = 64,
  Feature_HasCDEBit = 84,
  Feature_HasFPRegsBit = 42,
  Feature_HasFPRegs16Bit = 43,
  Feature_HasFPRegs64Bit = 76,
  Feature_HasV6T2Bit = 8,
  Feature_HasV6KBit = 18,
  Feature_HasV7Bit = 3,
  Feature_HasV8Bit = 55,
  Feature_PreV8Bit = 19,
  Feature_HasV8_1aBit = 78,
  Feature_HasV8_3aBit = 79,
  Feature_NoVFPBit = 22,
  Feature_HasVFP2Bit = 21,
  Feature_HasVFP3Bit = 52,
  Feature_HasVFP4Bit = 50,
  Feature_HasDPVFPBit = 44,
  Feature_HasFPARMv8Bit = 47,
  Feature_HasNEONBit = 53,
  Feature_HasSHA2Bit = 62,
  Feature_HasAESBit = 54,
  Feature_HasDotProdBit = 56,
  Feature_HasCRCBit = 14,
  Feature_HasLOBBit = 40,
  Feature_HasFP16Bit = 61,
  Feature_HasFullFP16Bit = 46,
  Feature_HasMatMulInt8Bit = 57,
  Feature_HasDivideInThumbBit = 37,
  Feature_HasDivideInARMBit = 12,
  Feature_HasDSPBit = 36,
  Feature_HasDBBit = 15,
  Feature_HasV7ClrexBit = 17,
  Feature_HasAcquireReleaseBit = 16,
  Feature_HasMPBit = 2,
  Feature_Has8MSecExtBit = 29,
  Feature_HasZCZBit = 58,
  Feature_UseNEONForFPBit = 82,
  Feature_DontUseNEONForFPBit = 45,
  Feature_IsThumbBit = 26,
  Feature_IsThumb1OnlyBit = 27,
  Feature_IsThumb2Bit = 34,
  Feature_IsNotMClassBit = 38,
  Feature_IsARMBit = 1,
  Feature_IsWindowsBit = 30,
  Feature_IsNotWindowsBit = 31,
  Feature_IsReadTPTPIDRURWBit = 68,
  Feature_IsReadTPTPIDRUROBit = 69,
  Feature_IsReadTPTPIDRPRWBit = 70,
  Feature_IsReadTPSoftBit = 20,
  Feature_UseNaClTrapBit = 4,
  Feature_DontUseNaClTrapBit = 5,
  Feature_UseMovtBit = 39,
  Feature_DontUseMovtBit = 23,
  Feature_UseMovtInPicBit = 24,
  Feature_DontUseMovtInPicBit = 25,
  Feature_UseFPVMLxBit = 49,
  Feature_SLSBLRMitigationBit = 67,
  Feature_NoSLSBLRMitigationBit = 66,
  Feature_UseMulOpsBit = 10,
  Feature_UseFusedMACBit = 51,
  Feature_HasFastVGETLNi32Bit = 59,
  Feature_HasSlowVGETLNi32Bit = 80,
  Feature_HasFastVDUP32Bit = 60,
  Feature_HasSlowVDUP32Bit = 81,
  Feature_UseVMOVSRBit = 48,
  Feature_DontUseVMOVSRBit = 83,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 77,
  Feature_GenExecuteOnlyBit = 33,
  Feature_DontGenExecuteOnlyBit = 32,
  Feature_GenT1ExecuteOnlyBit = 73,
  Feature_SignRetAddrBit = 72,
  Feature_NoSignRetAddrBit = 71,
};

PredicateBitset ARMInstructionSelector::
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const {
  PredicateBitset Features{};
  if (!TM.Options.HonorSignDependentRoundingFPMath())
    Features.set(Feature_NoHonorSignDependentRoundingBit);
  if (Subtarget->hasV4TOps())
    Features.set(Feature_HasV4TBit);
  if (!Subtarget->hasV4TOps())
    Features.set(Feature_NoV4TBit);
  if (Subtarget->hasV5TOps())
    Features.set(Feature_HasV5TBit);
  if (!Subtarget->hasV5TOps())
    Features.set(Feature_NoV5TBit);
  if (Subtarget->hasV5TEOps())
    Features.set(Feature_HasV5TEBit);
  if (Subtarget->hasV6Ops())
    Features.set(Feature_HasV6Bit);
  if (!Subtarget->hasV6Ops())
    Features.set(Feature_NoV6Bit);
  if (Subtarget->hasV6MOps())
    Features.set(Feature_HasV6MBit);
  if (Subtarget->hasV8MBaselineOps())
    Features.set(Feature_HasV8MBaselineBit);
  if (Subtarget->hasV8_1MMainlineOps())
    Features.set(Feature_HasV8_1MMainlineBit);
  if (Subtarget->hasMVEIntegerOps())
    Features.set(Feature_HasMVEIntBit);
  if (Subtarget->hasMVEFloatOps())
    Features.set(Feature_HasMVEFloatBit);
  if (Subtarget->hasCDEOps())
    Features.set(Feature_HasCDEBit);
  if (Subtarget->hasFPRegs())
    Features.set(Feature_HasFPRegsBit);
  if (Subtarget->hasFPRegs16())
    Features.set(Feature_HasFPRegs16Bit);
  if (Subtarget->hasFPRegs64())
    Features.set(Feature_HasFPRegs64Bit);
  if (Subtarget->hasV6T2Ops())
    Features.set(Feature_HasV6T2Bit);
  if (Subtarget->hasV6KOps())
    Features.set(Feature_HasV6KBit);
  if (Subtarget->hasV7Ops())
    Features.set(Feature_HasV7Bit);
  if (Subtarget->hasV8Ops())
    Features.set(Feature_HasV8Bit);
  if (!Subtarget->hasV8Ops())
    Features.set(Feature_PreV8Bit);
  if (Subtarget->hasV8_1aOps())
    Features.set(Feature_HasV8_1aBit);
  if (Subtarget->hasV8_3aOps())
    Features.set(Feature_HasV8_3aBit);
  if (!Subtarget->hasVFP2Base())
    Features.set(Feature_NoVFPBit);
  if (Subtarget->hasVFP2Base())
    Features.set(Feature_HasVFP2Bit);
  if (Subtarget->hasVFP3Base())
    Features.set(Feature_HasVFP3Bit);
  if (Subtarget->hasVFP4Base())
    Features.set(Feature_HasVFP4Bit);
  if (Subtarget->hasFP64())
    Features.set(Feature_HasDPVFPBit);
  if (Subtarget->hasFPARMv8Base())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasLOB())
    Features.set(Feature_HasLOBBit);
  if (Subtarget->hasFP16())
    Features.set(Feature_HasFP16Bit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasDivideInThumbMode())
    Features.set(Feature_HasDivideInThumbBit);
  if (Subtarget->hasDivideInARMMode())
    Features.set(Feature_HasDivideInARMBit);
  if (Subtarget->hasDSP())
    Features.set(Feature_HasDSPBit);
  if (Subtarget->hasDataBarrier())
    Features.set(Feature_HasDBBit);
  if (Subtarget->hasV7Clrex())
    Features.set(Feature_HasV7ClrexBit);
  if (Subtarget->hasAcquireRelease())
    Features.set(Feature_HasAcquireReleaseBit);
  if (Subtarget->hasMPExtension())
    Features.set(Feature_HasMPBit);
  if (Subtarget->has8MSecExt())
    Features.set(Feature_Has8MSecExtBit);
  if (Subtarget->hasZeroCycleZeroing())
    Features.set(Feature_HasZCZBit);
  if (Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseNEONForFPBit);
  if (!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseNEONForFPBit);
  if (Subtarget->isThumb())
    Features.set(Feature_IsThumbBit);
  if (Subtarget->isThumb1Only())
    Features.set(Feature_IsThumb1OnlyBit);
  if (Subtarget->isThumb2())
    Features.set(Feature_IsThumb2Bit);
  if (!Subtarget->isMClass())
    Features.set(Feature_IsNotMClassBit);
  if (!Subtarget->isThumb())
    Features.set(Feature_IsARMBit);
  if (Subtarget->isTargetWindows())
    Features.set(Feature_IsWindowsBit);
  if (!Subtarget->isTargetWindows())
    Features.set(Feature_IsNotWindowsBit);
  if (Subtarget->isReadTPTPIDRURW())
    Features.set(Feature_IsReadTPTPIDRURWBit);
  if (Subtarget->isReadTPTPIDRURO())
    Features.set(Feature_IsReadTPTPIDRUROBit);
  if (Subtarget->isReadTPTPIDRPRW())
    Features.set(Feature_IsReadTPTPIDRPRWBit);
  if (Subtarget->isReadTPSoft())
    Features.set(Feature_IsReadTPSoftBit);
  if (Subtarget->useNaClTrap())
    Features.set(Feature_UseNaClTrapBit);
  if (!Subtarget->useNaClTrap())
    Features.set(Feature_DontUseNaClTrapBit);
  if (Subtarget->useMulOps())
    Features.set(Feature_UseMulOpsBit);
  if (TM.Options.AllowFPOpFusion ==  FPOpFusion::Fast && Subtarget->useFPVFMx())
    Features.set(Feature_UseFusedMACBit);
  if (!Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasFastVGETLNi32Bit);
  if (Subtarget->hasSlowVGETLNi32())
    Features.set(Feature_HasSlowVGETLNi32Bit);
  if (!Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasFastVDUP32Bit);
  if (Subtarget->hasSlowVDUP32())
    Features.set(Feature_HasSlowVDUP32Bit);
  if (Subtarget->preferVMOVSR() ||!Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_UseVMOVSRBit);
  if (!Subtarget->preferVMOVSR() &&Subtarget->useNEONForSinglePrecisionFP())
    Features.set(Feature_DontUseVMOVSRBit);
  if (Subtarget->genExecuteOnly())
    Features.set(Feature_GenExecuteOnlyBit);
  if (!Subtarget->genExecuteOnly())
    Features.set(Feature_DontGenExecuteOnlyBit);
  if (Subtarget->genExecuteOnly() && Subtarget->isThumb1Only() && !Subtarget->hasV8MBaselineOps())
    Features.set(Feature_GenT1ExecuteOnlyBit);
  return Features;
}

void ARMInstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const ARMSubtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset ARMInstructionSelector::
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (Subtarget->useMovt())
    Features.set(Feature_UseMovtBit);
  if (!Subtarget->useMovt())
    Features.set(Feature_DontUseMovtBit);
  if (Subtarget->useMovt() && Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_UseMovtInPicBit);
  if (!Subtarget->useMovt() || !Subtarget->allowPositionIndependentMovt())
    Features.set(Feature_DontUseMovtInPicBit);
  if (((Subtarget->useFPVMLx() &&  TM.Options.AllowFPOpFusion != FPOpFusion::Fast) ||Subtarget->hasMinSize()))
    Features.set(Feature_UseFPVMLxBit);
  if ( MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<ARMSubtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (MF->getDataLayout().isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (MF->getDataLayout().isBigEndian())
    Features.set(Feature_IsBEBit);
  if ( MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_SignRetAddrBit);
  if ( !MF->getInfo<ARMFunctionInfo>()->shouldSignReturnAddress(true) )
    Features.set(Feature_NoSignRetAddrBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasDotProd,
  GIFBS_HasFP16,
  GIFBS_HasFPARMv8,
  GIFBS_HasFPRegs,
  GIFBS_HasFullFP16,
  GIFBS_HasMVEFloat,
  GIFBS_HasMVEInt,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasVFP2,
  GIFBS_HasVFP3,
  GIFBS_HasVFP4,
  GIFBS_IsARM,
  GIFBS_IsThumb,
  GIFBS_IsThumb2,
  GIFBS_NoHonorSignDependentRounding,
  GIFBS_DontUseNEONForFP_HasVFP2,
  GIFBS_DontUseNaClTrap_IsARM,
  GIFBS_DontUseVMOVSR_HasNEON,
  GIFBS_Has8MSecExt_IsThumb,
  GIFBS_HasAES_HasV8,
  GIFBS_HasCRC_IsARM,
  GIFBS_HasCRC_IsThumb2,
  GIFBS_HasDB_IsARM,
  GIFBS_HasDB_IsThumb,
  GIFBS_HasDPVFP_HasFPARMv8,
  GIFBS_HasDPVFP_HasVFP2,
  GIFBS_HasDPVFP_HasVFP3,
  GIFBS_HasDPVFP_HasVFP4,
  GIFBS_HasDPVFP_NoHonorSignDependentRounding,
  GIFBS_HasDSP_IsThumb2,
  GIFBS_HasDivideInARM_IsARM,
  GIFBS_HasFP16_HasNEON,
  GIFBS_HasFPARMv8_HasNEON,
  GIFBS_HasFPRegs_HasFastVGETLNi32,
  GIFBS_HasFPRegs_UseVMOVSR,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasMVEInt_HasV8_1MMainline,
  GIFBS_HasMVEInt_IsBE,
  GIFBS_HasMVEInt_IsLE,
  GIFBS_HasNEON_HasV8,
  GIFBS_HasNEON_HasV8_1a,
  GIFBS_HasNEON_HasV8_3a,
  GIFBS_HasNEON_HasVFP4,
  GIFBS_HasNEON_IsBE,
  GIFBS_HasNEON_IsLE,
  GIFBS_HasNEON_UseNEONForFP,
  GIFBS_HasSHA2_HasV8,
  GIFBS_HasV5T_IsARM,
  GIFBS_HasV5T_IsThumb,
  GIFBS_HasV5TE_IsARM,
  GIFBS_HasV6_IsARM,
  GIFBS_HasV6K_IsARM,
  GIFBS_HasV6M_IsThumb,
  GIFBS_HasV6T2_IsARM,
  GIFBS_HasV7_IsARM,
  GIFBS_HasV7Clrex_IsThumb,
  GIFBS_HasV8MBaseline_IsThumb,
  GIFBS_IsARM_NoV5T,
  GIFBS_IsARM_NoV6,
  GIFBS_IsARM_PreV8,
  GIFBS_IsARM_UseNaClTrap,
  GIFBS_IsThumb_IsThumb1Only,
  GIFBS_IsThumb_IsWindows,
  GIFBS_IsThumb_NoV5T,
  GIFBS_IsThumb_UseMovt,
  GIFBS_IsThumb2_PreV8,
  GIFBS_IsThumb2_UseMulOps,
  GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only,
  GIFBS_HasDSP_IsThumb2_UseMulOps,
  GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb,
  GIFBS_HasFPARMv8_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEON_HasV8,
  GIFBS_HasFullFP16_HasNEON_HasV8_3a,
  GIFBS_HasFullFP16_HasNEON_UseFPVMLx,
  GIFBS_HasFullFP16_HasNEON_UseFusedMAC,
  GIFBS_HasLOB_HasV8_1MMainline_IsThumb2,
  GIFBS_HasNEON_UseFPVMLx_UseNEONForFP,
  GIFBS_HasV5TE_IsARM_UseMulOps,
  GIFBS_HasV6_IsARM_UseMulOps,
  GIFBS_HasV6_IsThumb_IsThumb1Only,
  GIFBS_HasV6T2_IsARM_UseMulOps,
  GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP,
  GIFBS_IsARM_NoV6_UseMulOps,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasDotProdBit, },
  {Feature_HasFP16Bit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFPRegsBit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasMVEFloatBit, },
  {Feature_HasMVEIntBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasVFP2Bit, },
  {Feature_HasVFP3Bit, },
  {Feature_HasVFP4Bit, },
  {Feature_IsARMBit, },
  {Feature_IsThumbBit, },
  {Feature_IsThumb2Bit, },
  {Feature_NoHonorSignDependentRoundingBit, },
  {Feature_DontUseNEONForFPBit, Feature_HasVFP2Bit, },
  {Feature_DontUseNaClTrapBit, Feature_IsARMBit, },
  {Feature_DontUseVMOVSRBit, Feature_HasNEONBit, },
  {Feature_Has8MSecExtBit, Feature_IsThumbBit, },
  {Feature_HasAESBit, Feature_HasV8Bit, },
  {Feature_HasCRCBit, Feature_IsARMBit, },
  {Feature_HasCRCBit, Feature_IsThumb2Bit, },
  {Feature_HasDBBit, Feature_IsARMBit, },
  {Feature_HasDBBit, Feature_IsThumbBit, },
  {Feature_HasDPVFPBit, Feature_HasFPARMv8Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP2Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP3Bit, },
  {Feature_HasDPVFPBit, Feature_HasVFP4Bit, },
  {Feature_HasDPVFPBit, Feature_NoHonorSignDependentRoundingBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, },
  {Feature_HasDivideInARMBit, Feature_IsARMBit, },
  {Feature_HasFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFPARMv8Bit, Feature_HasNEONBit, },
  {Feature_HasFPRegsBit, Feature_HasFastVGETLNi32Bit, },
  {Feature_HasFPRegsBit, Feature_UseVMOVSRBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasMVEIntBit, Feature_HasV8_1MMainlineBit, },
  {Feature_HasMVEIntBit, Feature_IsBEBit, },
  {Feature_HasMVEIntBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasNEONBit, Feature_HasV8_1aBit, },
  {Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasNEONBit, Feature_HasVFP4Bit, },
  {Feature_HasNEONBit, Feature_IsBEBit, },
  {Feature_HasNEONBit, Feature_IsLEBit, },
  {Feature_HasNEONBit, Feature_UseNEONForFPBit, },
  {Feature_HasSHA2Bit, Feature_HasV8Bit, },
  {Feature_HasV5TBit, Feature_IsARMBit, },
  {Feature_HasV5TBit, Feature_IsThumbBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, },
  {Feature_HasV6KBit, Feature_IsARMBit, },
  {Feature_HasV6MBit, Feature_IsThumbBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, },
  {Feature_HasV7Bit, Feature_IsARMBit, },
  {Feature_HasV7ClrexBit, Feature_IsThumbBit, },
  {Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_IsARMBit, Feature_NoV5TBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, },
  {Feature_IsARMBit, Feature_PreV8Bit, },
  {Feature_IsARMBit, Feature_UseNaClTrapBit, },
  {Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_IsThumbBit, Feature_IsWindowsBit, },
  {Feature_IsThumbBit, Feature_NoV5TBit, },
  {Feature_IsThumbBit, Feature_UseMovtBit, },
  {Feature_IsThumb2Bit, Feature_PreV8Bit, },
  {Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_DontUseMovtBit, Feature_GenExecuteOnlyBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasDSPBit, Feature_IsThumb2Bit, Feature_UseMulOpsBit, },
  {Feature_HasDivideInThumbBit, Feature_HasV8MBaselineBit, Feature_IsThumbBit, },
  {Feature_HasFPARMv8Bit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8Bit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_HasV8_3aBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFPVMLxBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, Feature_UseFusedMACBit, },
  {Feature_HasLOBBit, Feature_HasV8_1MMainlineBit, Feature_IsThumb2Bit, },
  {Feature_HasNEONBit, Feature_UseFPVMLxBit, Feature_UseNEONForFPBit, },
  {Feature_HasV5TEBit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasV6Bit, Feature_IsThumbBit, Feature_IsThumb1OnlyBit, },
  {Feature_HasV6T2Bit, Feature_IsARMBit, Feature_UseMulOpsBit, },
  {Feature_HasVFP4Bit, Feature_UseFusedMACBit, Feature_UseNEONForFPBit, },
  {Feature_IsARMBit, Feature_NoV6Bit, Feature_UseMulOpsBit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
};
// See constructor for table contents

ARMInstructionSelector::ComplexMatcherMemFn
ARMInstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_bf_inv_mask_imm = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_vfp_f32imm,
  GICXXPred_MI_Predicate_vfp_f64imm,
};
bool ARMInstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_bf_inv_mask_imm: {
    
        // There's better methods of implementing this check. IntImmLeaf<> would be
        // equivalent and have less boilerplate but we need a test for C++
        // predicates and this one causes new rules to be imported into GlobalISel
        // without requiring additional features first.
        const auto &MO = MI.getOperand(1);
        if (!MO.isCImm())
          return false;
        return ARM::isBitFieldInvertedMask(MO.getCImm()->getZExtValue());
      
    llvm_unreachable("bf_inv_mask_imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f32imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP32Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f32imm should have returned");
  }
  case GICXXPred_MI_Predicate_vfp_f64imm: {
    
          const auto &MO = MI.getOperand(1);
          if (!MO.isFPImm())
            return false;
          return ARM_AM::getFP64Imm(MO.getFPImm()->getValueAPF()) != -1;
        
    llvm_unreachable("vfp_f64imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex8 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex16,
  GICXXPred_I64_Predicate_VectorIndex32,
  GICXXPred_I64_Predicate_VectorIndex64,
  GICXXPred_I64_Predicate_asr_imm,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_32,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_239,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm0_255_expr,
  GICXXPred_I64_Predicate_imm0_4095,
  GICXXPred_I64_Predicate_imm0_65535,
  GICXXPred_I64_Predicate_imm0_65535_expr,
  GICXXPred_I64_Predicate_imm0_65535_neg,
  GICXXPred_I64_Predicate_imm1_7,
  GICXXPred_I64_Predicate_imm1_15,
  GICXXPred_I64_Predicate_imm1_16,
  GICXXPred_I64_Predicate_imm1_31,
  GICXXPred_I64_Predicate_imm8,
  GICXXPred_I64_Predicate_imm8_255,
  GICXXPred_I64_Predicate_imm8_or_16,
  GICXXPred_I64_Predicate_imm16,
  GICXXPred_I64_Predicate_imm16_31,
  GICXXPred_I64_Predicate_imm24b,
  GICXXPred_I64_Predicate_imm32,
  GICXXPred_I64_Predicate_imm256_510,
  GICXXPred_I64_Predicate_imm_3b,
  GICXXPred_I64_Predicate_imm_4b,
  GICXXPred_I64_Predicate_imm_6b,
  GICXXPred_I64_Predicate_imm_7b,
  GICXXPred_I64_Predicate_imm_9b,
  GICXXPred_I64_Predicate_imm_11b,
  GICXXPred_I64_Predicate_imm_12b,
  GICXXPred_I64_Predicate_imm_13b,
  GICXXPred_I64_Predicate_imm_even,
  GICXXPred_I64_Predicate_imm_odd,
  GICXXPred_I64_Predicate_imm_sr,
  GICXXPred_I64_Predicate_long_shift,
  GICXXPred_I64_Predicate_mod_imm,
  GICXXPred_I64_Predicate_mod_imm_not,
  GICXXPred_I64_Predicate_pkh_asr_amt,
  GICXXPred_I64_Predicate_pkh_lsl_amt,
  GICXXPred_I64_Predicate_shr_imm8,
  GICXXPred_I64_Predicate_shr_imm16,
  GICXXPred_I64_Predicate_shr_imm32,
  GICXXPred_I64_Predicate_shr_imm64,
  GICXXPred_I64_Predicate_t2_so_imm,
  GICXXPred_I64_Predicate_t2_so_imm_neg,
};
bool ARMInstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex8: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex16: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex32: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_VectorIndex64: {
    
      return ((uint64_t)Imm) < 1;
    
  }
  case GICXXPred_I64_Predicate_asr_imm: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return Imm >= 0 && Imm < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return Imm >= 0 && Imm < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return Imm >= 0 && Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_32: {
    
      return Imm >= 0 && Imm < 33;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return Imm >= 0 && Imm < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_239: {
     return Imm >= 0 && Imm < 240; 
  }
  case GICXXPred_I64_Predicate_imm0_255: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_255_expr: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_imm0_4095: {
    
      return Imm >= 0 && Imm < 4096;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_expr: {
    
      return Imm >= 0 && Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm0_65535_neg: {
    
      return -Imm >= 0 && -Imm < 65536;
    
  }
  case GICXXPred_I64_Predicate_imm1_7: {
     return Imm > 0 && Imm < 8; 
  }
  case GICXXPred_I64_Predicate_imm1_15: {
     return Imm > 0 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_imm1_16: {
    
        return Imm > 0 && Imm <= 16;
      
  }
  case GICXXPred_I64_Predicate_imm1_31: {
     return Imm > 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_imm8: {
     return Imm == 8; 
  }
  case GICXXPred_I64_Predicate_imm8_255: {
    
      return Imm >= 8 && Imm < 256;
    
  }
  case GICXXPred_I64_Predicate_imm8_or_16: {
     return Imm == 8 || Imm == 16;
  }
  case GICXXPred_I64_Predicate_imm16: {
     return Imm == 16; 
  }
  case GICXXPred_I64_Predicate_imm16_31: {
    
      return (int32_t)Imm >= 16 && (int32_t)Imm < 32;
    
  }
  case GICXXPred_I64_Predicate_imm24b: {
    
      return Imm >= 0 && Imm <= 0xffffff;
    
  }
  case GICXXPred_I64_Predicate_imm32: {
     return Imm == 32; 
  }
  case GICXXPred_I64_Predicate_imm256_510: {
    
      return Imm >= 256 && Imm < 511;
    
  }
  case GICXXPred_I64_Predicate_imm_3b: {
    { return Imm >= 0 && Imm < (1 << 3); }
    llvm_unreachable("imm_3b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_4b: {
    { return Imm >= 0 && Imm < (1 << 4); }
    llvm_unreachable("imm_4b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_6b: {
    { return Imm >= 0 && Imm < (1 << 6); }
    llvm_unreachable("imm_6b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_7b: {
    { return Imm >= 0 && Imm < (1 << 7); }
    llvm_unreachable("imm_7b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_9b: {
    { return Imm >= 0 && Imm < (1 << 9); }
    llvm_unreachable("imm_9b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_11b: {
    { return Imm >= 0 && Imm < (1 << 11); }
    llvm_unreachable("imm_11b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_12b: {
    { return Imm >= 0 && Imm < (1 << 12); }
    llvm_unreachable("imm_12b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_13b: {
    { return Imm >= 0 && Imm < (1 << 13); }
    llvm_unreachable("imm_13b should have returned");
  }
  case GICXXPred_I64_Predicate_imm_even: {
     return (Imm & 1) == 0; 
  }
  case GICXXPred_I64_Predicate_imm_odd: {
     return (Imm & 1) == 1; 
  }
  case GICXXPred_I64_Predicate_imm_sr: {
    
      return Imm > 0 && Imm <= 32;
    
  }
  case GICXXPred_I64_Predicate_long_shift: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_mod_imm: {
    
        return ARM_AM::getSOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_mod_imm_not: {
    
        return ARM_AM::getSOImmVal(~(uint32_t)Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_pkh_asr_amt: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_pkh_lsl_amt: {
     return Imm >= 0 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm8: {
     return Imm > 0 && Imm <= 8; 
  }
  case GICXXPred_I64_Predicate_shr_imm16: {
     return Imm > 0 && Imm <= 16; 
  }
  case GICXXPred_I64_Predicate_shr_imm32: {
     return Imm > 0 && Imm <= 32; 
  }
  case GICXXPred_I64_Predicate_shr_imm64: {
     return Imm > 0 && Imm <= 64; 
  }
  case GICXXPred_I64_Predicate_t2_so_imm: {
    
        return ARM_AM::getT2SOImmVal(Imm) != -1;
      
  }
  case GICXXPred_I64_Predicate_t2_so_imm_neg: {
    
      return Imm && ARM_AM::getT2SOImmVal(-(uint32_t)Imm) != -1;
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
bool ARMInstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_arm_i32imm = GICXXPred_Invalid + 1,
};
bool ARMInstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_arm_i32imm: {
    
      if (Subtarget->useMovt())
        return true;
      if (ARM_AM::isSOImmTwoPartVal(Imm.getZExtValue()))
        return true;
      return ARM_AM::isSOImmTwoPartValNeg(Imm.getZExtValue());
    
    llvm_unreachable("arm_i32imm should have returned");
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool ARMInstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("ARMInstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderInvertedImm,
  GICR_renderVFPF32Imm,
  GICR_renderVFPF64Imm,
};
ARMInstructionSelector::CustomRendererFn
ARMInstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &ARMInstructionSelector::renderInvertedImm,
  &ARMInstructionSelector::renderVFPF32Imm,
  &ARMInstructionSelector::renderVFPF64Imm,
};

bool ARMInstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool ARMInstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("ARMInstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *ARMInstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(308), /*)*//*default:*//*Label 78*/ GIMT_Encode4(130922),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(1030),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(10357),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(13601),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(15305),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(15401), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(15497),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(18677),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(24486), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(26181), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(26568), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(35580),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(35876), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 12*/ GIMT_Encode4(36139), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 13*/ GIMT_Encode4(36302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 14*/ GIMT_Encode4(36323),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 15*/ GIMT_Encode4(91495), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 16*/ GIMT_Encode4(99157),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 17*/ GIMT_Encode4(99315),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 18*/ GIMT_Encode4(99473),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 19*/ GIMT_Encode4(99794), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 20*/ GIMT_Encode4(99890),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 21*/ GIMT_Encode4(100048),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 22*/ GIMT_Encode4(100653),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 23*/ GIMT_Encode4(100811),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 24*/ GIMT_Encode4(101027),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 25*/ GIMT_Encode4(101135), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 26*/ GIMT_Encode4(101408), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 27*/ GIMT_Encode4(101740),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 28*/ GIMT_Encode4(101988),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 29*/ GIMT_Encode4(102357),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 30*/ GIMT_Encode4(103002),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 31*/ GIMT_Encode4(104302),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 32*/ GIMT_Encode4(104947), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 33*/ GIMT_Encode4(105967),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 34*/ GIMT_Encode4(108320),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 35*/ GIMT_Encode4(109997),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 36*/ GIMT_Encode4(110978), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 37*/ GIMT_Encode4(113069), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 38*/ GIMT_Encode4(113234),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 39*/ GIMT_Encode4(114765),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 40*/ GIMT_Encode4(115001),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 41*/ GIMT_Encode4(115273),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 42*/ GIMT_Encode4(116607),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 43*/ GIMT_Encode4(117941),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 44*/ GIMT_Encode4(118593), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 45*/ GIMT_Encode4(119245), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 46*/ GIMT_Encode4(120021),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 47*/ GIMT_Encode4(120613), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 48*/ GIMT_Encode4(121205),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 49*/ GIMT_Encode4(121939), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    670 */ /*TargetOpcode::G_GET_FPENV*//*Label 50*/ GIMT_Encode4(122673),
     /*    674 */ /*TargetOpcode::G_SET_FPENV*//*Label 51*/ GIMT_Encode4(122706),
     /*    678 */ /*TargetOpcode::G_RESET_FPENV*//*Label 52*/ GIMT_Encode4(122742),
     /*    682 */ /*TargetOpcode::G_GET_FPMODE*//*Label 53*/ GIMT_Encode4(122871), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 54*/ GIMT_Encode4(122904),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 55*/ GIMT_Encode4(123447),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 56*/ GIMT_Encode4(123990),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 57*/ GIMT_Encode4(124911),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 58*/ GIMT_Encode4(125832), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 59*/ GIMT_Encode4(126303), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 60*/ GIMT_Encode4(126376),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 61*/ GIMT_Encode4(126676), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 62*/ GIMT_Encode4(126733), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 63*/ GIMT_Encode4(127294),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 64*/ GIMT_Encode4(127402),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 65*/ GIMT_Encode4(127692),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 66*/ GIMT_Encode4(128124), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 67*/ GIMT_Encode4(128387),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 68*/ GIMT_Encode4(128525),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 69*/ GIMT_Encode4(128788),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 70*/ GIMT_Encode4(129084), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 71*/ GIMT_Encode4(129222),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 72*/ GIMT_Encode4(129268), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 73*/ GIMT_Encode4(129355), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 74*/ GIMT_Encode4(129776),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 75*/ GIMT_Encode4(130056),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 76*/ GIMT_Encode4(130345),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 77*/ GIMT_Encode4(130626),
     /*   1030 */ // Label 0: @1030
     /*   1030 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 88*/ GIMT_Encode4(10356),
     /*   1041 */ /*GILLT_s32*//*Label 79*/ GIMT_Encode4(1101),
     /*   1045 */ /*GILLT_s64*//*Label 80*/ GIMT_Encode4(6877), GIMT_Encode4(0),
     /*   1053 */ /*GILLT_v2s32*//*Label 81*/ GIMT_Encode4(6924),
     /*   1057 */ /*GILLT_v2s64*//*Label 82*/ GIMT_Encode4(7109), GIMT_Encode4(0),
     /*   1065 */ /*GILLT_v4s16*//*Label 83*/ GIMT_Encode4(7820),
     /*   1069 */ /*GILLT_v4s32*//*Label 84*/ GIMT_Encode4(8005), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1081 */ /*GILLT_v8s8*//*Label 85*/ GIMT_Encode4(8961),
     /*   1085 */ /*GILLT_v8s16*//*Label 86*/ GIMT_Encode4(9146), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1097 */ /*GILLT_v16s8*//*Label 87*/ GIMT_Encode4(10102),
     /*   1101 */ // Label 79: @1101
     /*   1101 */ GIM_Try, /*On fail goto*//*Label 89*/ GIMT_Encode4(6876),
     /*   1106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   1109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   1112 */   GIM_Try, /*On fail goto*//*Label 90*/ GIMT_Encode4(1187), // Rule ID 5667 //
     /*   1117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1145 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1162 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1173 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1185 */     GIR_RootConstrainSelectedInstOperands,
     /*   1186 */     // GIR_Coverage, 5667,
     /*   1186 */     GIR_EraseRootFromParent_Done,
     /*   1187 */   // Label 90: @1187
     /*   1187 */   GIM_Try, /*On fail goto*//*Label 91*/ GIMT_Encode4(1262), // Rule ID 5668 //
     /*   1192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1220 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1235 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1237 */     // (add:{ *:[i32] } (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1251 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1254 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1260 */     GIR_RootConstrainSelectedInstOperands,
     /*   1261 */     // GIR_Coverage, 5668,
     /*   1261 */     GIR_EraseRootFromParent_Done,
     /*   1262 */   // Label 91: @1262
     /*   1262 */   GIM_Try, /*On fail goto*//*Label 92*/ GIMT_Encode4(1337), // Rule ID 5702 //
     /*   1267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1274 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1278 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1282 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1286 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1295 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1312 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1335 */     GIR_RootConstrainSelectedInstOperands,
     /*   1336 */     // GIR_Coverage, 5702,
     /*   1336 */     GIR_EraseRootFromParent_Done,
     /*   1337 */   // Label 92: @1337
     /*   1337 */   GIM_Try, /*On fail goto*//*Label 93*/ GIMT_Encode4(1412), // Rule ID 5703 //
     /*   1342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1361 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1370 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1387 */     // (add:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1410 */     GIR_RootConstrainSelectedInstOperands,
     /*   1411 */     // GIR_Coverage, 5703,
     /*   1411 */     GIR_EraseRootFromParent_Done,
     /*   1412 */   // Label 93: @1412
     /*   1412 */   GIM_Try, /*On fail goto*//*Label 94*/ GIMT_Encode4(1487), // Rule ID 1997 //
     /*   1417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1449 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1460 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1462 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (UXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB),
     /*   1465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1485 */     GIR_RootConstrainSelectedInstOperands,
     /*   1486 */     // GIR_Coverage, 1997,
     /*   1486 */     GIR_EraseRootFromParent_Done,
     /*   1487 */   // Label 94: @1487
     /*   1487 */   GIM_Try, /*On fail goto*//*Label 95*/ GIMT_Encode4(1562), // Rule ID 1998 //
     /*   1492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   1495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   1499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   1524 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1537 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (UXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAH),
     /*   1540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1551 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1554 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1560 */     GIR_RootConstrainSelectedInstOperands,
     /*   1561 */     // GIR_Coverage, 1998,
     /*   1561 */     GIR_EraseRootFromParent_Done,
     /*   1562 */   // Label 95: @1562
     /*   1562 */   GIM_Try, /*On fail goto*//*Label 96*/ GIMT_Encode4(1637), // Rule ID 2236 //
     /*   1567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1590 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1594 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1599 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*   1610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1612 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] }))  =>  (t2UXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB),
     /*   1615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1617 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1623 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1635 */     GIR_RootConstrainSelectedInstOperands,
     /*   1636 */     // GIR_Coverage, 2236,
     /*   1636 */     GIR_EraseRootFromParent_Done,
     /*   1637 */   // Label 96: @1637
     /*   1637 */   GIM_Try, /*On fail goto*//*Label 97*/ GIMT_Encode4(1712), // Rule ID 2237 //
     /*   1642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*   1661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   1669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1674 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*   1685 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   1687 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] }))  =>  (t2UXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   1687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAH),
     /*   1690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   1694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   1698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   1701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1710 */     GIR_RootConstrainSelectedInstOperands,
     /*   1711 */     // GIR_Coverage, 2237,
     /*   1711 */     GIR_EraseRootFromParent_Done,
     /*   1712 */   // Label 97: @1712
     /*   1712 */   GIM_Try, /*On fail goto*//*Label 98*/ GIMT_Encode4(1840), // Rule ID 5678 //
     /*   1717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1748 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1752 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1756 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1760 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1764 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1773 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   1777 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1781 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1785 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1789 */     // MIs[4] Rm
     /*   1789 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1794 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   1798 */     // MIs[1] Operand 2
     /*   1798 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1813 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1815 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1838 */     GIR_RootConstrainSelectedInstOperands,
     /*   1839 */     // GIR_Coverage, 5678,
     /*   1839 */     GIR_EraseRootFromParent_Done,
     /*   1840 */   // Label 98: @1840
     /*   1840 */   GIM_Try, /*On fail goto*//*Label 99*/ GIMT_Encode4(1968), // Rule ID 5679 //
     /*   1845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   1856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   1868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   1872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   1876 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   1880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   1884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   1888 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   1892 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   1896 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1901 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   1905 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   1909 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   1913 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   1917 */     // MIs[4] Rm
     /*   1917 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   1922 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   1926 */     // MIs[1] Operand 2
     /*   1926 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   1937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1941 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   1943 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   1943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   1946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   1948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   1950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   1954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   1957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   1960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   1966 */     GIR_RootConstrainSelectedInstOperands,
     /*   1967 */     // GIR_Coverage, 5679,
     /*   1967 */     GIR_EraseRootFromParent_Done,
     /*   1968 */   // Label 99: @1968
     /*   1968 */   GIM_Try, /*On fail goto*//*Label 100*/ GIMT_Encode4(2096), // Rule ID 2103 //
     /*   1973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   1976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   1984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   1988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   1992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   1996 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2000 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2004 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2008 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2012 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2016 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2020 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2024 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2028 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2033 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 24,
     /*   2037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2041 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2045 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2049 */     // MIs[4] Rm
     /*   2049 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2054 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*   2058 */     // MIs[1] Operand 2
     /*   2058 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2069 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2071 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2094 */     GIR_RootConstrainSelectedInstOperands,
     /*   2095 */     // GIR_Coverage, 2103,
     /*   2095 */     GIR_EraseRootFromParent_Done,
     /*   2096 */   // Label 100: @2096
     /*   2096 */   GIM_Try, /*On fail goto*//*Label 101*/ GIMT_Encode4(2224), // Rule ID 5677 //
     /*   2101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   2104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*   2132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2136 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2140 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*   2144 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*   2148 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2152 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2156 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2161 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 8,
     /*   2165 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*   2169 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*   2173 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*   2177 */     // MIs[4] Rm
     /*   2177 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*   2182 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*   2186 */     // MIs[1] Operand 2
     /*   2186 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   2197 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   2199 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] })), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   2199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   2202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2204 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   2206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2210 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   2213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2222 */     GIR_RootConstrainSelectedInstOperands,
     /*   2223 */     // GIR_Coverage, 5677,
     /*   2223 */     GIR_EraseRootFromParent_Done,
     /*   2224 */   // Label 101: @2224
     /*   2224 */   GIM_Try, /*On fail goto*//*Label 102*/ GIMT_Encode4(2334), // Rule ID 5446 //
     /*   2229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2248 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2273 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2281 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2285 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2289 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2293 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2298 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2308 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2332 */     GIR_RootConstrainSelectedInstOperands,
     /*   2333 */     // GIR_Coverage, 5446,
     /*   2333 */     GIR_EraseRootFromParent_Done,
     /*   2334 */   // Label 102: @2334
     /*   2334 */   GIM_Try, /*On fail goto*//*Label 103*/ GIMT_Encode4(2444), // Rule ID 5483 //
     /*   2339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2366 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2370 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2374 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2383 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2395 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2399 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2403 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2408 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2416 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2418 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2436 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2442 */     GIR_RootConstrainSelectedInstOperands,
     /*   2443 */     // GIR_Coverage, 5483,
     /*   2443 */     GIR_EraseRootFromParent_Done,
     /*   2444 */   // Label 103: @2444
     /*   2444 */   GIM_Try, /*On fail goto*//*Label 104*/ GIMT_Encode4(2554), // Rule ID 192 //
     /*   2449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2476 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2480 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2484 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2488 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2497 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2513 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2517 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2522 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2528 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLATT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*   2531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2546 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2552 */     GIR_RootConstrainSelectedInstOperands,
     /*   2553 */     // GIR_Coverage, 192,
     /*   2553 */     GIR_EraseRootFromParent_Done,
     /*   2554 */   // Label 104: @2554
     /*   2554 */   GIM_Try, /*On fail goto*//*Label 105*/ GIMT_Encode4(2664), // Rule ID 521 //
     /*   2559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   2574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2582 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2598 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2607 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2627 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2632 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2636 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2638 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLATT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*   2641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2651 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   2653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2662 */     GIR_RootConstrainSelectedInstOperands,
     /*   2663 */     // GIR_Coverage, 521,
     /*   2663 */     GIR_EraseRootFromParent_Done,
     /*   2664 */   // Label 105: @2664
     /*   2664 */   GIM_Try, /*On fail goto*//*Label 106*/ GIMT_Encode4(2777), // Rule ID 5445 //
     /*   2669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2688 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2704 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2708 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2729 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2734 */     // MIs[3] Operand 2
     /*   2734 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2751 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2775 */     GIR_RootConstrainSelectedInstOperands,
     /*   2776 */     // GIR_Coverage, 5445,
     /*   2776 */     GIR_EraseRootFromParent_Done,
     /*   2777 */   // Label 106: @2777
     /*   2777 */   GIM_Try, /*On fail goto*//*Label 107*/ GIMT_Encode4(2890), // Rule ID 5482 //
     /*   2782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   2785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2813 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2817 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   2821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2826 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   2830 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2834 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2838 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2842 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2847 */     // MIs[3] Operand 2
     /*   2847 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   2858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   2862 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2864 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   2864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   2867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*   2873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   2877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2882 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   2888 */     GIR_RootConstrainSelectedInstOperands,
     /*   2889 */     // GIR_Coverage, 5482,
     /*   2889 */     GIR_EraseRootFromParent_Done,
     /*   2890 */   // Label 107: @2890
     /*   2890 */   GIM_Try, /*On fail goto*//*Label 108*/ GIMT_Encode4(3003), // Rule ID 5444 //
     /*   2895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   2898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   2906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   2910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   2914 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   2918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   2922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   2926 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   2930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2935 */     // MIs[2] Operand 2
     /*   2935 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   2946 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   2950 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   2954 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   2958 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   2962 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   2967 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   2971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   2975 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   2977 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   2977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   2980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   2982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   2986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   2990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   2992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   2995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3001 */     GIR_RootConstrainSelectedInstOperands,
     /*   3002 */     // GIR_Coverage, 5444,
     /*   3002 */     GIR_EraseRootFromParent_Done,
     /*   3003 */   // Label 108: @3003
     /*   3003 */   GIM_Try, /*On fail goto*//*Label 109*/ GIMT_Encode4(3116), // Rule ID 5481 //
     /*   3008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3023 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3027 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3048 */     // MIs[2] Operand 2
     /*   3048 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3059 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3063 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3067 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3071 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3075 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3080 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3088 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3090 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3114 */     GIR_RootConstrainSelectedInstOperands,
     /*   3115 */     // GIR_Coverage, 5481,
     /*   3115 */     GIR_EraseRootFromParent_Done,
     /*   3116 */   // Label 109: @3116
     /*   3116 */   GIM_Try, /*On fail goto*//*Label 110*/ GIMT_Encode4(3229), // Rule ID 191 //
     /*   3121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3156 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3160 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3164 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3169 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3173 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3177 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3181 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3190 */     // MIs[3] Operand 2
     /*   3190 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3201 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3203 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLATB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*   3206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3212 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3227 */     GIR_RootConstrainSelectedInstOperands,
     /*   3228 */     // GIR_Coverage, 191,
     /*   3228 */     GIR_EraseRootFromParent_Done,
     /*   3229 */   // Label 110: @3229
     /*   3229 */   GIM_Try, /*On fail goto*//*Label 111*/ GIMT_Encode4(3342), // Rule ID 520 //
     /*   3234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3282 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*   3286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3303 */     // MIs[3] Operand 2
     /*   3303 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3316 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLATB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*   3319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3340 */     GIR_RootConstrainSelectedInstOperands,
     /*   3341 */     // GIR_Coverage, 520,
     /*   3341 */     GIR_EraseRootFromParent_Done,
     /*   3342 */   // Label 111: @3342
     /*   3342 */   GIM_Try, /*On fail goto*//*Label 112*/ GIMT_Encode4(3455), // Rule ID 190 //
     /*   3347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3386 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3391 */     // MIs[2] Operand 2
     /*   3391 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3402 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3406 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3410 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3414 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3418 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3423 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3429 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (SMLABT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*   3432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3453 */     GIR_RootConstrainSelectedInstOperands,
     /*   3454 */     // GIR_Coverage, 190,
     /*   3454 */     GIR_EraseRootFromParent_Done,
     /*   3455 */   // Label 112: @3455
     /*   3455 */   GIM_Try, /*On fail goto*//*Label 113*/ GIMT_Encode4(3568), // Rule ID 519 //
     /*   3460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3504 */     // MIs[2] Operand 2
     /*   3504 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*   3523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3527 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*   3531 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3536 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*   3540 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3542 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] })))  =>  (t2SMLABT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   3557 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3560 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3566 */     GIR_RootConstrainSelectedInstOperands,
     /*   3567 */     // GIR_Coverage, 519,
     /*   3567 */     GIR_EraseRootFromParent_Done,
     /*   3568 */   // Label 113: @3568
     /*   3568 */   GIM_Try, /*On fail goto*//*Label 114*/ GIMT_Encode4(3659), // Rule ID 5676 //
     /*   3573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3613 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3617 */     // MIs[1] Operand 2
     /*   3617 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3634 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3657 */     GIR_RootConstrainSelectedInstOperands,
     /*   3658 */     // GIR_Coverage, 5676,
     /*   3658 */     GIR_EraseRootFromParent_Done,
     /*   3659 */   // Label 114: @3659
     /*   3659 */   GIM_Try, /*On fail goto*//*Label 115*/ GIMT_Encode4(3750), // Rule ID 2102 //
     /*   3664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   3667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3671 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   3679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ROTR),
     /*   3695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3699 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*   3703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3708 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*   3712 */     // MIs[1] Operand 2
     /*   3712 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   3723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3725 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 3:{ *:[i32] })
     /*   3725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   3728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3730 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   3732 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   3736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*   3739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3748 */     GIR_RootConstrainSelectedInstOperands,
     /*   3749 */     // GIR_Coverage, 2102,
     /*   3749 */     GIR_EraseRootFromParent_Done,
     /*   3750 */   // Label 115: @3750
     /*   3750 */   GIM_Try, /*On fail goto*//*Label 116*/ GIMT_Encode4(3866), // Rule ID 5443 //
     /*   3755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3778 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3782 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3786 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3795 */     // MIs[2] Operand 2
     /*   3795 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3823 */     // MIs[3] Operand 2
     /*   3823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3838 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3840 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })), GPR:{ *:[i32] }:$Ra)  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   3840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   3843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3864 */     GIR_RootConstrainSelectedInstOperands,
     /*   3865 */     // GIR_Coverage, 5443,
     /*   3865 */     GIR_EraseRootFromParent_Done,
     /*   3866 */   // Label 116: @3866
     /*   3866 */   GIM_Try, /*On fail goto*//*Label 117*/ GIMT_Encode4(3982), // Rule ID 5480 //
     /*   3871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   3874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   3886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   3890 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   3894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3902 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   3906 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3911 */     // MIs[2] Operand 2
     /*   3911 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   3922 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   3926 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   3930 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   3934 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3939 */     // MIs[3] Operand 2
     /*   3939 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   3950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   3954 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   3956 */     // (add:{ *:[i32] } (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   3956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   3959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   3965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   3969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   3971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   3974 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   3980 */     GIR_RootConstrainSelectedInstOperands,
     /*   3981 */     // GIR_Coverage, 5480,
     /*   3981 */     GIR_EraseRootFromParent_Done,
     /*   3982 */   // Label 117: @3982
     /*   3982 */   GIM_Try, /*On fail goto*//*Label 118*/ GIMT_Encode4(4098), // Rule ID 189 //
     /*   3987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM_UseMulOps),
     /*   3990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   3994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   3998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4022 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4026 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4031 */     // MIs[2] Operand 2
     /*   4031 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4042 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4046 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4050 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4054 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4059 */     // MIs[3] Operand 2
     /*   4059 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4070 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4072 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (SMLABB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   4072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*   4075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4096 */     GIR_RootConstrainSelectedInstOperands,
     /*   4097 */     // GIR_Coverage, 189,
     /*   4097 */     GIR_EraseRootFromParent_Done,
     /*   4098 */   // Label 118: @4098
     /*   4098 */   GIM_Try, /*On fail goto*//*Label 119*/ GIMT_Encode4(4214), // Rule ID 518 //
     /*   4103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   4106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4110 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4114 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4118 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4122 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   4126 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   4130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   4142 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4147 */     // MIs[2] Operand 2
     /*   4147 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*   4158 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   4162 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   4166 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   4170 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4175 */     // MIs[3] Operand 2
     /*   4175 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(16),
     /*   4186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   4188 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })))  =>  (t2SMLABB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   4188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*   4191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   4197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   4201 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   4203 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4206 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4212 */     GIR_RootConstrainSelectedInstOperands,
     /*   4213 */     // GIR_Coverage, 518,
     /*   4213 */     GIR_EraseRootFromParent_Done,
     /*   4214 */   // Label 119: @4214
     /*   4214 */   GIM_Try, /*On fail goto*//*Label 120*/ GIMT_Encode4(4302), // Rule ID 3245 //
     /*   4219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4238 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4242 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4246 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4250 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4254 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4268 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4270 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4275 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4285 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4300 */     GIR_RootConstrainSelectedInstOperands,
     /*   4301 */     // GIR_Coverage, 3245,
     /*   4301 */     GIR_EraseRootFromParent_Done,
     /*   4302 */   // Label 120: @4302
     /*   4302 */   GIM_Try, /*On fail goto*//*Label 121*/ GIMT_Encode4(4390), // Rule ID 3246 //
     /*   4307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4338 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4347 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4358 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4363 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4388 */     GIR_RootConstrainSelectedInstOperands,
     /*   4389 */     // GIR_Coverage, 3246,
     /*   4389 */     GIR_EraseRootFromParent_Done,
     /*   4390 */   // Label 121: @4390
     /*   4390 */   GIM_Try, /*On fail goto*//*Label 122*/ GIMT_Encode4(4478), // Rule ID 3249 //
     /*   4395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4426 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4430 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4435 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4446 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)), tGPREven:{ *:[i32] }:$src3)  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4451 */     GIR_RootToRootCopy, /*OpIdx*/2, // src3
     /*   4453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4470 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4476 */     GIR_RootConstrainSelectedInstOperands,
     /*   4477 */     // GIR_Coverage, 3249,
     /*   4477 */     GIR_EraseRootFromParent_Done,
     /*   4478 */   // Label 122: @4478
     /*   4478 */   GIM_Try, /*On fail goto*//*Label 123*/ GIMT_Encode4(4566), // Rule ID 5947 //
     /*   4483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   4518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   4522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4534 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)))  =>  (MVE_VMLADAVau32:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /*   4534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*   4537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4539 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4564 */     GIR_RootConstrainSelectedInstOperands,
     /*   4565 */     // GIR_Coverage, 5947,
     /*   4565 */     GIR_EraseRootFromParent_Done,
     /*   4566 */   // Label 123: @4566
     /*   4566 */   GIM_Try, /*On fail goto*//*Label 124*/ GIMT_Encode4(4654), // Rule ID 5948 //
     /*   4571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   4606 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   4610 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4620 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4622 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)))  =>  (MVE_VMLADAVau16:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /*   4622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*   4625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4627 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4652 */     GIR_RootConstrainSelectedInstOperands,
     /*   4653 */     // GIR_Coverage, 5948,
     /*   4653 */     GIR_EraseRootFromParent_Done,
     /*   4654 */   // Label 124: @4654
     /*   4654 */   GIM_Try, /*On fail goto*//*Label 125*/ GIMT_Encode4(4742), // Rule ID 5951 //
     /*   4659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   4670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   4678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   4690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   4694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*   4698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4703 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   4708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4710 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$src3, (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2)))  =>  (MVE_VMLADAVau8:{ *:[i32] } ?:{ *:[i32] }:$src3, ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /*   4710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*   4713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*   4715 */     GIR_RootToRootCopy, /*OpIdx*/1, // src3
     /*   4717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*   4721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // src2
     /*   4725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   4728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4740 */     GIR_RootConstrainSelectedInstOperands,
     /*   4741 */     // GIR_Coverage, 5951,
     /*   4741 */     GIR_EraseRootFromParent_Done,
     /*   4742 */   // Label 125: @4742
     /*   4742 */   GIM_Try, /*On fail goto*//*Label 126*/ GIMT_Encode4(4799), // Rule ID 72 //
     /*   4747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   4750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4766 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*   4770 */     // MIs[1] Operand 1
     /*   4770 */     // No operand predicates
     /*   4770 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4772 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ADDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDri),
     /*   4775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4797 */     GIR_RootConstrainSelectedInstOperands,
     /*   4798 */     // GIR_Coverage, 72,
     /*   4798 */     GIR_EraseRootFromParent_Done,
     /*   4799 */   // Label 126: @4799
     /*   4799 */   GIM_Try, /*On fail goto*//*Label 127*/ GIMT_Encode4(4856), // Rule ID 303 //
     /*   4804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4823 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*   4827 */     // MIs[1] Operand 1
     /*   4827 */     // No operand predicates
     /*   4827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4829 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm3)  =>  (tADDi3:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm3)
     /*   4829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi3),
     /*   4832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   4842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm3
     /*   4845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4854 */     GIR_RootConstrainSelectedInstOperands,
     /*   4855 */     // GIR_Coverage, 303,
     /*   4855 */     GIR_EraseRootFromParent_Done,
     /*   4856 */   // Label 127: @4856
     /*   4856 */   GIM_Try, /*On fail goto*//*Label 128*/ GIMT_Encode4(4913), // Rule ID 304 //
     /*   4861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   4864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   4872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4880 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*   4884 */     // MIs[1] Operand 1
     /*   4884 */     // No operand predicates
     /*   4884 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4886 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8)  =>  (tADDi8:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm8)
     /*   4886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDi8),
     /*   4889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   4891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   4897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*   4902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4911 */     GIR_RootConstrainSelectedInstOperands,
     /*   4912 */     // GIR_Coverage, 304,
     /*   4912 */     GIR_EraseRootFromParent_Done,
     /*   4913 */   // Label 128: @4913
     /*   4913 */   GIM_Try, /*On fail goto*//*Label 129*/ GIMT_Encode4(4970), // Rule ID 407 //
     /*   4918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   4929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4937 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*   4941 */     // MIs[1] Operand 1
     /*   4941 */     // No operand predicates
     /*   4941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   4943 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ADDri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   4943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri),
     /*   4946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   4953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   4956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   4968 */     GIR_RootConstrainSelectedInstOperands,
     /*   4969 */     // GIR_Coverage, 407,
     /*   4969 */     GIR_EraseRootFromParent_Done,
     /*   4970 */   // Label 129: @4970
     /*   4970 */   GIM_Try, /*On fail goto*//*Label 130*/ GIMT_Encode4(5021), // Rule ID 408 //
     /*   4975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   4978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   4982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   4986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   4994 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*   4998 */     // MIs[1] Operand 1
     /*   4998 */     // No operand predicates
     /*   4998 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5000 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2ADDri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*   5000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDri12),
     /*   5003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   5007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*   5010 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5019 */     GIR_RootConstrainSelectedInstOperands,
     /*   5020 */     // GIR_Coverage, 408,
     /*   5020 */     GIR_EraseRootFromParent_Done,
     /*   5021 */   // Label 130: @5021
     /*   5021 */   GIM_Try, /*On fail goto*//*Label 131*/ GIMT_Encode4(5097), // Rule ID 171 //
     /*   5026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5054 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5063 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5065 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5070 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5095 */     GIR_RootConstrainSelectedInstOperands,
     /*   5096 */     // GIR_Coverage, 171,
     /*   5096 */     GIR_EraseRootFromParent_Done,
     /*   5097 */   // Label 131: @5097
     /*   5097 */   GIM_Try, /*On fail goto*//*Label 132*/ GIMT_Encode4(5173), // Rule ID 172 //
     /*   5102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5125 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5130 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5135 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5141 */     // (add:{ *:[i32] } (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm), GPRnopc:{ *:[i32] }:$Ra)  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5156 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5171 */     GIR_RootConstrainSelectedInstOperands,
     /*   5172 */     // GIR_Coverage, 172,
     /*   5172 */     GIR_EraseRootFromParent_Done,
     /*   5173 */   // Label 132: @5173
     /*   5173 */   GIM_Try, /*On fail goto*//*Label 133*/ GIMT_Encode4(5243), // Rule ID 503 //
     /*   5178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   5181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5217 */     // (add:{ *:[i32] } (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm), rGPR:{ *:[i32] }:$Ra)  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   5220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5235 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5241 */     GIR_RootConstrainSelectedInstOperands,
     /*   5242 */     // GIR_Coverage, 503,
     /*   5242 */     GIR_EraseRootFromParent_Done,
     /*   5243 */   // Label 133: @5243
     /*   5243 */   GIM_Try, /*On fail goto*//*Label 134*/ GIMT_Encode4(5314), // Rule ID 5669 //
     /*   5248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5263 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5272 */     // MIs[1] Operand 2
     /*   5272 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5289 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   5292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5312 */     GIR_RootConstrainSelectedInstOperands,
     /*   5313 */     // GIR_Coverage, 5669,
     /*   5313 */     GIR_EraseRootFromParent_Done,
     /*   5314 */   // Label 134: @5314
     /*   5314 */   GIM_Try, /*On fail goto*//*Label 135*/ GIMT_Encode4(5385), // Rule ID 5670 //
     /*   5319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   5322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5343 */     // MIs[1] Operand 2
     /*   5343 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5360 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }), GPR:{ *:[i32] }:$Rn)  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   5363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5383 */     GIR_RootConstrainSelectedInstOperands,
     /*   5384 */     // GIR_Coverage, 5670,
     /*   5384 */     GIR_EraseRootFromParent_Done,
     /*   5385 */   // Label 135: @5385
     /*   5385 */   GIM_Try, /*On fail goto*//*Label 136*/ GIMT_Encode4(5456), // Rule ID 5704 //
     /*   5390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5414 */     // MIs[1] Operand 2
     /*   5414 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   5425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5431 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   5434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5448 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5454 */     GIR_RootConstrainSelectedInstOperands,
     /*   5455 */     // GIR_Coverage, 5704,
     /*   5455 */     GIR_EraseRootFromParent_Done,
     /*   5456 */   // Label 136: @5456
     /*   5456 */   GIM_Try, /*On fail goto*//*Label 137*/ GIMT_Encode4(5527), // Rule ID 5705 //
     /*   5461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   5464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   5476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5485 */     // MIs[1] Operand 2
     /*   5485 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   5496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5500 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5502 */     // (add:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   5502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   5505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   5509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5525 */     GIR_RootConstrainSelectedInstOperands,
     /*   5526 */     // GIR_Coverage, 5705,
     /*   5526 */     GIR_EraseRootFromParent_Done,
     /*   5527 */   // Label 137: @5527
     /*   5527 */   GIM_Try, /*On fail goto*//*Label 138*/ GIMT_Encode4(5597), // Rule ID 180 //
     /*   5532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   5569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5571 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm), GPR:{ *:[i32] }:$Ra)  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   5571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   5574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5595 */     GIR_RootConstrainSelectedInstOperands,
     /*   5596 */     // GIR_Coverage, 180,
     /*   5596 */     GIR_EraseRootFromParent_Done,
     /*   5597 */   // Label 138: @5597
     /*   5597 */   GIM_Try, /*On fail goto*//*Label 139*/ GIMT_Encode4(5667), // Rule ID 509 //
     /*   5602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   5605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   5617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   5639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5641 */     // (add:{ *:[i32] } (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Ra)  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   5641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   5644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   5650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   5654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   5656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5665 */     GIR_RootConstrainSelectedInstOperands,
     /*   5666 */     // GIR_Coverage, 509,
     /*   5666 */     GIR_EraseRootFromParent_Done,
     /*   5667 */   // Label 139: @5667
     /*   5667 */   GIM_Try, /*On fail goto*//*Label 140*/ GIMT_Encode4(5730), // Rule ID 3050 //
     /*   5672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   5691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5702 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   5702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   5705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5707 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5713 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5716 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5728 */     GIR_RootConstrainSelectedInstOperands,
     /*   5729 */     // GIR_Coverage, 3050,
     /*   5729 */     GIR_EraseRootFromParent_Done,
     /*   5730 */   // Label 140: @5730
     /*   5730 */   GIM_Try, /*On fail goto*//*Label 141*/ GIMT_Encode4(5793), // Rule ID 3078 //
     /*   5735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   5754 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5765 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   5765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   5768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5770 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5791 */     GIR_RootConstrainSelectedInstOperands,
     /*   5792 */     // GIR_Coverage, 3078,
     /*   5792 */     GIR_EraseRootFromParent_Done,
     /*   5793 */   // Label 141: @5793
     /*   5793 */   GIM_Try, /*On fail goto*//*Label 142*/ GIMT_Encode4(5856), // Rule ID 3088 //
     /*   5798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   5801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   5813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   5817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   5822 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   5826 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5828 */     // (add:{ *:[i32] } (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec), tGPREven:{ *:[i32] }:$acc)  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   5828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   5831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   5833 */     GIR_RootToRootCopy, /*OpIdx*/2, // acc
     /*   5835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   5839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   5842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5854 */     GIR_RootConstrainSelectedInstOperands,
     /*   5855 */     // GIR_Coverage, 3088,
     /*   5855 */     GIR_EraseRootFromParent_Done,
     /*   5856 */   // Label 142: @5856
     /*   5856 */   GIM_Try, /*On fail goto*//*Label 143*/ GIMT_Encode4(5932), // Rule ID 5440 //
     /*   5861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   5864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5898 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5900 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLA),
     /*   5903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   5930 */     GIR_RootConstrainSelectedInstOperands,
     /*   5931 */     // GIR_Coverage, 5440,
     /*   5931 */     GIR_EraseRootFromParent_Done,
     /*   5932 */   // Label 143: @5932
     /*   5932 */   GIM_Try, /*On fail goto*//*Label 144*/ GIMT_Encode4(6008), // Rule ID 5441 //
     /*   5937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6),
     /*   5940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   5956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   5960 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   5964 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   5974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   5976 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm))  =>  (MLAv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*   5976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLAv5),
     /*   5979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   5981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   5985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   5989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   5991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   5994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6006 */     GIR_RootConstrainSelectedInstOperands,
     /*   6007 */     // GIR_Coverage, 5441,
     /*   6007 */     GIR_EraseRootFromParent_Done,
     /*   6008 */   // Label 144: @6008
     /*   6008 */   GIM_Try, /*On fail goto*//*Label 145*/ GIMT_Encode4(6078), // Rule ID 5478 //
     /*   6013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*   6016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6020 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6032 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6036 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6050 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6052 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLA),
     /*   6055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6076 */     GIR_RootConstrainSelectedInstOperands,
     /*   6077 */     // GIR_Coverage, 5478,
     /*   6077 */     GIR_EraseRootFromParent_Done,
     /*   6078 */   // Label 145: @6078
     /*   6078 */   GIM_Try, /*On fail goto*//*Label 146*/ GIMT_Encode4(6149), // Rule ID 2001 //
     /*   6083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6111 */     // MIs[1] Operand 2
     /*   6111 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6124 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (SXTAB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB),
     /*   6127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6147 */     GIR_RootConstrainSelectedInstOperands,
     /*   6148 */     // GIR_Coverage, 2001,
     /*   6148 */     GIR_EraseRootFromParent_Done,
     /*   6149 */   // Label 146: @6149
     /*   6149 */   GIM_Try, /*On fail goto*//*Label 147*/ GIMT_Encode4(6220), // Rule ID 2002 //
     /*   6154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*   6157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6182 */     // MIs[1] Operand 2
     /*   6182 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6195 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SXTAH:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAH),
     /*   6198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6200 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6218 */     GIR_RootConstrainSelectedInstOperands,
     /*   6219 */     // GIR_Coverage, 2002,
     /*   6219 */     GIR_EraseRootFromParent_Done,
     /*   6220 */   // Label 147: @6220
     /*   6220 */   GIM_Try, /*On fail goto*//*Label 148*/ GIMT_Encode4(6291), // Rule ID 2240 //
     /*   6225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6232 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6253 */     // MIs[1] Operand 2
     /*   6253 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*   6264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6266 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] }))  =>  (t2SXTAB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB),
     /*   6269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6289 */     GIR_RootConstrainSelectedInstOperands,
     /*   6290 */     // GIR_Coverage, 2240,
     /*   6290 */     GIR_EraseRootFromParent_Done,
     /*   6291 */   // Label 148: @6291
     /*   6291 */   GIM_Try, /*On fail goto*//*Label 149*/ GIMT_Encode4(6362), // Rule ID 2241 //
     /*   6296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*   6299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6303 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   6315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6324 */     // MIs[1] Operand 2
     /*   6324 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*   6335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6337 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SXTAH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*   6337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAH),
     /*   6340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6344 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6351 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6354 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6360 */     GIR_RootConstrainSelectedInstOperands,
     /*   6361 */     // GIR_Coverage, 2241,
     /*   6361 */     GIR_EraseRootFromParent_Done,
     /*   6362 */   // Label 149: @6362
     /*   6362 */   GIM_Try, /*On fail goto*//*Label 150*/ GIMT_Encode4(6432), // Rule ID 5442 //
     /*   6367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM_UseMulOps),
     /*   6370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6386 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6394 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6406 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (SMMLA:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*   6406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMLA),
     /*   6409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   6415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*   6419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6424 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6430 */     GIR_RootConstrainSelectedInstOperands,
     /*   6431 */     // GIR_Coverage, 5442,
     /*   6431 */     GIR_EraseRootFromParent_Done,
     /*   6432 */   // Label 150: @6432
     /*   6432 */   GIM_Try, /*On fail goto*//*Label 151*/ GIMT_Encode4(6502), // Rule ID 5479 //
     /*   6437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2_UseMulOps),
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SMULH),
     /*   6456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*   6460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*   6464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6476 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn))  =>  (t2SMMLA:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*   6476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMLA),
     /*   6479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*   6485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*   6489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   6491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6494 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6500 */     GIR_RootConstrainSelectedInstOperands,
     /*   6501 */     // GIR_Coverage, 5479,
     /*   6501 */     GIR_EraseRootFromParent_Done,
     /*   6502 */   // Label 151: @6502
     /*   6502 */   GIM_Try, /*On fail goto*//*Label 152*/ GIMT_Encode4(6565), // Rule ID 5923 //
     /*   6507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6514 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6518 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6522 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6526 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*   6530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6537 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec))  =>  (MVE_VADDVu8acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v16i8] }:$vec)
     /*   6537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8acc),
     /*   6540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6542 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6563 */     GIR_RootConstrainSelectedInstOperands,
     /*   6564 */     // GIR_Coverage, 5923,
     /*   6564 */     GIR_EraseRootFromParent_Done,
     /*   6565 */   // Label 152: @6565
     /*   6565 */   GIM_Try, /*On fail goto*//*Label 153*/ GIMT_Encode4(6628), // Rule ID 5937 //
     /*   6570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   6593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6600 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec))  =>  (MVE_VADDVu16acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v8i16] }:$vec)
     /*   6600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16acc),
     /*   6603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6605 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6614 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6626 */     GIR_RootConstrainSelectedInstOperands,
     /*   6627 */     // GIR_Coverage, 5937,
     /*   6627 */     GIR_EraseRootFromParent_Done,
     /*   6628 */   // Label 153: @6628
     /*   6628 */   GIM_Try, /*On fail goto*//*Label 154*/ GIMT_Encode4(6691), // Rule ID 5942 //
     /*   6633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   6636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*   6644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   6648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_VECREDUCE_ADD),
     /*   6652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   6656 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   6661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6663 */     // (add:{ *:[i32] } tGPREven:{ *:[i32] }:$acc, (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec))  =>  (MVE_VADDVu32acc:{ *:[i32] } ?:{ *:[i32] }:$acc, ?:{ *:[v4i32] }:$vec)
     /*   6663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32acc),
     /*   6666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*   6668 */     GIR_RootToRootCopy, /*OpIdx*/1, // acc
     /*   6670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /*   6674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   6677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6689 */     GIR_RootConstrainSelectedInstOperands,
     /*   6690 */     // GIR_Coverage, 5942,
     /*   6690 */     GIR_EraseRootFromParent_Done,
     /*   6691 */   // Label 154: @6691
     /*   6691 */   GIM_Try, /*On fail goto*//*Label 155*/ GIMT_Encode4(6737), // Rule ID 73 //
     /*   6696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*   6699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6703 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*   6711 */     // (add:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ADDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*   6711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ADDrr),
     /*   6714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6735 */     GIR_RootConstrainSelectedInstOperands,
     /*   6736 */     // GIR_Coverage, 73,
     /*   6736 */     GIR_EraseRootFromParent_Done,
     /*   6737 */   // Label 155: @6737
     /*   6737 */   GIM_Try, /*On fail goto*//*Label 156*/ GIMT_Encode4(6783), // Rule ID 305 //
     /*   6742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*   6745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*   6757 */     // (add:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tADDrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*   6757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tADDrr),
     /*   6760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6762 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*   6768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6772 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6781 */     GIR_RootConstrainSelectedInstOperands,
     /*   6782 */     // GIR_Coverage, 305,
     /*   6782 */     GIR_EraseRootFromParent_Done,
     /*   6783 */   // Label 156: @6783
     /*   6783 */   GIM_Try, /*On fail goto*//*Label 157*/ GIMT_Encode4(6829), // Rule ID 409 //
     /*   6788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6803 */     // (add:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*   6812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6827 */     GIR_RootConstrainSelectedInstOperands,
     /*   6828 */     // GIR_Coverage, 409,
     /*   6828 */     GIR_EraseRootFromParent_Done,
     /*   6829 */   // Label 157: @6829
     /*   6829 */   GIM_Try, /*On fail goto*//*Label 158*/ GIMT_Encode4(6875), // Rule ID 5460 //
     /*   6834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*   6837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6841 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*   6845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*   6849 */     // (add:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2ADDrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*   6849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ADDrr),
     /*   6852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6854 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6856 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*   6858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6873 */     GIR_RootConstrainSelectedInstOperands,
     /*   6874 */     // GIR_Coverage, 5460,
     /*   6874 */     GIR_EraseRootFromParent_Done,
     /*   6875 */   // Label 158: @6875
     /*   6875 */   GIM_Reject,
     /*   6876 */ // Label 89: @6876
     /*   6876 */ GIM_Reject,
     /*   6877 */ // Label 80: @6877
     /*   6877 */ GIM_Try, /*On fail goto*//*Label 159*/ GIMT_Encode4(6923), // Rule ID 759 //
     /*   6882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6888 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6891 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6895 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6899 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6903 */   // (add:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VADDv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*   6903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv1i64),
     /*   6906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   6910 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   6912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6915 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   6921 */   GIR_RootConstrainSelectedInstOperands,
     /*   6922 */   // GIR_Coverage, 759,
     /*   6922 */   GIR_EraseRootFromParent_Done,
     /*   6923 */ // Label 159: @6923
     /*   6923 */ GIM_Reject,
     /*   6924 */ // Label 81: @6924
     /*   6924 */ GIM_Try, /*On fail goto*//*Label 160*/ GIMT_Encode4(7108),
     /*   6929 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6932 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6939 */   GIM_Try, /*On fail goto*//*Label 161*/ GIMT_Encode4(7005), // Rule ID 5529 //
     /*   6944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   6947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   6955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   6963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6968 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   6977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   6979 */     // (add:{ *:[v2i32] } (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), DPR:{ *:[v2i32] }:$src1)  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   6979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   6982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   6984 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   6986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   6990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   6994 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   6997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7003 */     GIR_RootConstrainSelectedInstOperands,
     /*   7004 */     // GIR_Coverage, 5529,
     /*   7004 */     GIR_EraseRootFromParent_Done,
     /*   7005 */   // Label 161: @7005
     /*   7005 */   GIM_Try, /*On fail goto*//*Label 162*/ GIMT_Encode4(7071), // Rule ID 886 //
     /*   7010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7013 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7025 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7029 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   7033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7038 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7043 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7045 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLAv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv2i32),
     /*   7048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7050 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7069 */     GIR_RootConstrainSelectedInstOperands,
     /*   7070 */     // GIR_Coverage, 886,
     /*   7070 */     GIR_EraseRootFromParent_Done,
     /*   7071 */   // Label 162: @7071
     /*   7071 */   GIM_Try, /*On fail goto*//*Label 163*/ GIMT_Encode4(7107), // Rule ID 755 //
     /*   7076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7087 */     // (add:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VADDv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i32),
     /*   7090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7092 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7105 */     GIR_RootConstrainSelectedInstOperands,
     /*   7106 */     // GIR_Coverage, 755,
     /*   7106 */     GIR_EraseRootFromParent_Done,
     /*   7107 */   // Label 163: @7107
     /*   7107 */   GIM_Reject,
     /*   7108 */ // Label 160: @7108
     /*   7108 */ GIM_Reject,
     /*   7109 */ // Label 82: @7109
     /*   7109 */ GIM_Try, /*On fail goto*//*Label 164*/ GIMT_Encode4(7819),
     /*   7114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7117 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*   7120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7124 */   GIM_Try, /*On fail goto*//*Label 165*/ GIMT_Encode4(7192), // Rule ID 779 //
     /*   7129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7144 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7149 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7153 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7157 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7168 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7190 */     GIR_RootConstrainSelectedInstOperands,
     /*   7191 */     // GIR_Coverage, 779,
     /*   7191 */     GIR_EraseRootFromParent_Done,
     /*   7192 */   // Label 165: @7192
     /*   7192 */   GIM_Try, /*On fail goto*//*Label 166*/ GIMT_Encode4(7260), // Rule ID 778 //
     /*   7197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7234 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7236 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7258 */     GIR_RootConstrainSelectedInstOperands,
     /*   7259 */     // GIR_Coverage, 778,
     /*   7259 */     GIR_EraseRootFromParent_Done,
     /*   7260 */   // Label 166: @7260
     /*   7260 */   GIM_Try, /*On fail goto*//*Label 167*/ GIMT_Encode4(7328), // Rule ID 767 //
     /*   7265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7268 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7272 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7276 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7297 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7302 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7304 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv2i64),
     /*   7307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7326 */     GIR_RootConstrainSelectedInstOperands,
     /*   7327 */     // GIR_Coverage, 767,
     /*   7327 */     GIR_EraseRootFromParent_Done,
     /*   7328 */   // Label 167: @7328
     /*   7328 */   GIM_Try, /*On fail goto*//*Label 168*/ GIMT_Encode4(7396), // Rule ID 777 //
     /*   7333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7348 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7353 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7357 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7361 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7372 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7388 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7394 */     GIR_RootConstrainSelectedInstOperands,
     /*   7395 */     // GIR_Coverage, 777,
     /*   7395 */     GIR_EraseRootFromParent_Done,
     /*   7396 */   // Label 168: @7396
     /*   7396 */   GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(7464), // Rule ID 776 //
     /*   7401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7429 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7433 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7440 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv2i64),
     /*   7443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   7453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7462 */     GIR_RootConstrainSelectedInstOperands,
     /*   7463 */     // GIR_Coverage, 776,
     /*   7463 */     GIR_EraseRootFromParent_Done,
     /*   7464 */   // Label 169: @7464
     /*   7464 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(7517), // Rule ID 5508 //
     /*   7469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7495 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7515 */     GIR_RootConstrainSelectedInstOperands,
     /*   7516 */     // GIR_Coverage, 5508,
     /*   7516 */     GIR_EraseRootFromParent_Done,
     /*   7517 */   // Label 170: @7517
     /*   7517 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(7570), // Rule ID 5502 //
     /*   7522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7548 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7568 */     GIR_RootConstrainSelectedInstOperands,
     /*   7569 */     // GIR_Coverage, 5502,
     /*   7569 */     GIR_EraseRootFromParent_Done,
     /*   7570 */   // Label 171: @7570
     /*   7570 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(7623), // Rule ID 5507 //
     /*   7575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7599 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7601 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$Vn)  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   7608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7621 */     GIR_RootConstrainSelectedInstOperands,
     /*   7622 */     // GIR_Coverage, 5507,
     /*   7622 */     GIR_EraseRootFromParent_Done,
     /*   7623 */   // Label 172: @7623
     /*   7623 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(7676), // Rule ID 788 //
     /*   7628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   7643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7647 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7652 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7654 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7659 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7665 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7668 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7674 */     GIR_RootConstrainSelectedInstOperands,
     /*   7675 */     // GIR_Coverage, 788,
     /*   7675 */     GIR_EraseRootFromParent_Done,
     /*   7676 */   // Label 173: @7676
     /*   7676 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(7729), // Rule ID 782 //
     /*   7681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7684 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7705 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7707 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv2i64),
     /*   7710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7714 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7718 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7721 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7727 */     GIR_RootConstrainSelectedInstOperands,
     /*   7728 */     // GIR_Coverage, 782,
     /*   7728 */     GIR_EraseRootFromParent_Done,
     /*   7729 */   // Label 174: @7729
     /*   7729 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(7782), // Rule ID 787 //
     /*   7734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   7753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7760 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VADDWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*   7760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv2i64),
     /*   7763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   7771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7780 */     GIR_RootConstrainSelectedInstOperands,
     /*   7781 */     // GIR_Coverage, 787,
     /*   7781 */     GIR_EraseRootFromParent_Done,
     /*   7782 */   // Label 175: @7782
     /*   7782 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(7818), // Rule ID 760 //
     /*   7787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   7798 */     // (add:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VADDv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*   7798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv2i64),
     /*   7801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7803 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7816 */     GIR_RootConstrainSelectedInstOperands,
     /*   7817 */     // GIR_Coverage, 760,
     /*   7817 */     GIR_EraseRootFromParent_Done,
     /*   7818 */   // Label 176: @7818
     /*   7818 */   GIM_Reject,
     /*   7819 */ // Label 164: @7819
     /*   7819 */ GIM_Reject,
     /*   7820 */ // Label 83: @7820
     /*   7820 */ GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(8004),
     /*   7825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7828 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7835 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(7901), // Rule ID 5528 //
     /*   7840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7875 */     // (add:{ *:[v4i16] } (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), DPR:{ *:[v4i16] }:$src1)  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7880 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   7882 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7893 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7899 */     GIR_RootConstrainSelectedInstOperands,
     /*   7900 */     // GIR_Coverage, 5528,
     /*   7900 */     GIR_EraseRootFromParent_Done,
     /*   7901 */   // Label 178: @7901
     /*   7901 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(7967), // Rule ID 885 //
     /*   7906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   7925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*   7929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   7941 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLAv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i16),
     /*   7944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7946 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   7948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   7952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   7956 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   7965 */     GIR_RootConstrainSelectedInstOperands,
     /*   7966 */     // GIR_Coverage, 885,
     /*   7966 */     GIR_EraseRootFromParent_Done,
     /*   7967 */   // Label 179: @7967
     /*   7967 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(8003), // Rule ID 754 //
     /*   7972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   7975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   7983 */     // (add:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VADDv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   7983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i16),
     /*   7986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   7988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   7990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   7992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   7995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8001 */     GIR_RootConstrainSelectedInstOperands,
     /*   8002 */     // GIR_Coverage, 754,
     /*   8002 */     GIR_EraseRootFromParent_Done,
     /*   8003 */   // Label 180: @8003
     /*   8003 */   GIM_Reject,
     /*   8004 */ // Label 177: @8004
     /*   8004 */ GIM_Reject,
     /*   8005 */ // Label 84: @8005
     /*   8005 */ GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(8960),
     /*   8010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8016 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(8088), // Rule ID 775 //
     /*   8021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8040 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8064 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8086 */     GIR_RootConstrainSelectedInstOperands,
     /*   8087 */     // GIR_Coverage, 775,
     /*   8087 */     GIR_EraseRootFromParent_Done,
     /*   8088 */   // Label 182: @8088
     /*   8088 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(8160), // Rule ID 774 //
     /*   8093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8129 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8136 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8158 */     GIR_RootConstrainSelectedInstOperands,
     /*   8159 */     // GIR_Coverage, 774,
     /*   8159 */     GIR_EraseRootFromParent_Done,
     /*   8160 */   // Label 183: @8160
     /*   8160 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(8232), // Rule ID 766 //
     /*   8165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8197 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8206 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8208 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv4i32),
     /*   8211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8230 */     GIR_RootConstrainSelectedInstOperands,
     /*   8231 */     // GIR_Coverage, 766,
     /*   8231 */     GIR_EraseRootFromParent_Done,
     /*   8232 */   // Label 184: @8232
     /*   8232 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(8304), // Rule ID 773 //
     /*   8237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8248 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8252 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8273 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8280 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8302 */     GIR_RootConstrainSelectedInstOperands,
     /*   8303 */     // GIR_Coverage, 773,
     /*   8303 */     GIR_EraseRootFromParent_Done,
     /*   8304 */   // Label 185: @8304
     /*   8304 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(8376), // Rule ID 772 //
     /*   8309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   8337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8341 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8345 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8352 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv4i32),
     /*   8355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   8365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8368 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8374 */     GIR_RootConstrainSelectedInstOperands,
     /*   8375 */     // GIR_Coverage, 772,
     /*   8375 */     GIR_EraseRootFromParent_Done,
     /*   8376 */   // Label 186: @8376
     /*   8376 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(8446), // Rule ID 5532 //
     /*   8381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8400 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8404 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8409 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8420 */     // (add:{ *:[v4i32] } (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8425 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   8427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8435 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8444 */     GIR_RootConstrainSelectedInstOperands,
     /*   8445 */     // GIR_Coverage, 5532,
     /*   8445 */     GIR_EraseRootFromParent_Done,
     /*   8446 */   // Label 187: @8446
     /*   8446 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(8503), // Rule ID 5506 //
     /*   8451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8481 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8488 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8501 */     GIR_RootConstrainSelectedInstOperands,
     /*   8502 */     // GIR_Coverage, 5506,
     /*   8502 */     GIR_EraseRootFromParent_Done,
     /*   8503 */   // Label 188: @8503
     /*   8503 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(8560), // Rule ID 5501 //
     /*   8508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8527 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8538 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8558 */     GIR_RootConstrainSelectedInstOperands,
     /*   8559 */     // GIR_Coverage, 5501,
     /*   8559 */     GIR_EraseRootFromParent_Done,
     /*   8560 */   // Label 189: @8560
     /*   8560 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(8617), // Rule ID 5505 //
     /*   8565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8584 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8595 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$Vn)  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   8602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8615 */     GIR_RootConstrainSelectedInstOperands,
     /*   8616 */     // GIR_Coverage, 5505,
     /*   8616 */     GIR_EraseRootFromParent_Done,
     /*   8617 */   // Label 190: @8617
     /*   8617 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(8687), // Rule ID 889 //
     /*   8622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8629 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*   8645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*   8649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8659 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8661 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLAv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv4i32),
     /*   8664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8666 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   8668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   8672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   8676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8685 */     GIR_RootConstrainSelectedInstOperands,
     /*   8686 */     // GIR_Coverage, 889,
     /*   8686 */     GIR_EraseRootFromParent_Done,
     /*   8687 */   // Label 191: @8687
     /*   8687 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(8744), // Rule ID 786 //
     /*   8692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   8711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8715 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8720 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8722 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8742 */     GIR_RootConstrainSelectedInstOperands,
     /*   8743 */     // GIR_Coverage, 786,
     /*   8743 */     GIR_EraseRootFromParent_Done,
     /*   8744 */   // Label 192: @8744
     /*   8744 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(8801), // Rule ID 781 //
     /*   8749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8779 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv4i32),
     /*   8782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8799 */     GIR_RootConstrainSelectedInstOperands,
     /*   8800 */     // GIR_Coverage, 781,
     /*   8800 */     GIR_EraseRootFromParent_Done,
     /*   8801 */   // Label 193: @8801
     /*   8801 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(8858), // Rule ID 785 //
     /*   8806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*   8829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8836 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VADDWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*   8836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv4i32),
     /*   8839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   8847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8856 */     GIR_RootConstrainSelectedInstOperands,
     /*   8857 */     // GIR_Coverage, 785,
     /*   8857 */     GIR_EraseRootFromParent_Done,
     /*   8858 */   // Label 194: @8858
     /*   8858 */   GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(8898), // Rule ID 758 //
     /*   8863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   8878 */     // (add:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VADDv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*   8878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv4i32),
     /*   8881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   8883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   8885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   8887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   8890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8896 */     GIR_RootConstrainSelectedInstOperands,
     /*   8897 */     // GIR_Coverage, 758,
     /*   8897 */     GIR_EraseRootFromParent_Done,
     /*   8898 */   // Label 195: @8898
     /*   8898 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(8959), // Rule ID 3493 //
     /*   8903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*   8906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*   8918 */     // (add:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*   8918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*   8921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   8925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi32),
     /*   8933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*   8935 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*   8937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*   8939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*   8942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   8954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8957 */     GIR_RootConstrainSelectedInstOperands,
     /*   8958 */     // GIR_Coverage, 3493,
     /*   8958 */     GIR_EraseRootFromParent_Done,
     /*   8959 */   // Label 196: @8959
     /*   8959 */   GIM_Reject,
     /*   8960 */ // Label 181: @8960
     /*   8960 */ GIM_Reject,
     /*   8961 */ // Label 85: @8961
     /*   8961 */ GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(9145),
     /*   8966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   8972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   8976 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(9042), // Rule ID 5527 //
     /*   8981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   8984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   8996 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9000 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9016 */     // (add:{ *:[v8i8] } (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm), DPR:{ *:[v8i8] }:$src1)  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9040 */     GIR_RootConstrainSelectedInstOperands,
     /*   9041 */     // GIR_Coverage, 5527,
     /*   9041 */     GIR_EraseRootFromParent_Done,
     /*   9042 */   // Label 198: @9042
     /*   9042 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(9108), // Rule ID 884 //
     /*   9047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9054 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9058 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9062 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*   9070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9080 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9082 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLAv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i8),
     /*   9085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9087 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9106 */     GIR_RootConstrainSelectedInstOperands,
     /*   9107 */     // GIR_Coverage, 884,
     /*   9107 */     GIR_EraseRootFromParent_Done,
     /*   9108 */   // Label 199: @9108
     /*   9108 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(9144), // Rule ID 753 //
     /*   9113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9124 */     // (add:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VADDv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i8),
     /*   9127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9129 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*   9133 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9142 */     GIR_RootConstrainSelectedInstOperands,
     /*   9143 */     // GIR_Coverage, 753,
     /*   9143 */     GIR_EraseRootFromParent_Done,
     /*   9144 */   // Label 200: @9144
     /*   9144 */   GIM_Reject,
     /*   9145 */ // Label 197: @9145
     /*   9145 */ GIM_Reject,
     /*   9146 */ // Label 86: @9146
     /*   9146 */ GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(10101),
     /*   9151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9154 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9157 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(9229), // Rule ID 771 //
     /*   9162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9186 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9190 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9194 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9198 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9205 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9214 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9227 */     GIR_RootConstrainSelectedInstOperands,
     /*   9228 */     // GIR_Coverage, 771,
     /*   9228 */     GIR_EraseRootFromParent_Done,
     /*   9229 */   // Label 202: @9229
     /*   9229 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(9301), // Rule ID 770 //
     /*   9234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9245 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9249 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9275 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9277 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9299 */     GIR_RootConstrainSelectedInstOperands,
     /*   9300 */     // GIR_Coverage, 770,
     /*   9300 */     GIR_EraseRootFromParent_Done,
     /*   9301 */   // Label 203: @9301
     /*   9301 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(9373), // Rule ID 765 //
     /*   9306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9342 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9349 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLsv8i16),
     /*   9352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9365 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9371 */     GIR_RootConstrainSelectedInstOperands,
     /*   9372 */     // GIR_Coverage, 765,
     /*   9372 */     GIR_EraseRootFromParent_Done,
     /*   9373 */   // Label 204: @9373
     /*   9373 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(9445), // Rule ID 769 //
     /*   9378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9402 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9406 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9410 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9414 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9421 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9430 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9443 */     GIR_RootConstrainSelectedInstOperands,
     /*   9444 */     // GIR_Coverage, 769,
     /*   9444 */     GIR_EraseRootFromParent_Done,
     /*   9445 */   // Label 205: @9445
     /*   9445 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(9517), // Rule ID 768 //
     /*   9450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9469 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   9478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9486 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9491 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9493 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDLuv8i16),
     /*   9496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*   9506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9515 */     GIR_RootConstrainSelectedInstOperands,
     /*   9516 */     // GIR_Coverage, 768,
     /*   9516 */     GIR_EraseRootFromParent_Done,
     /*   9517 */   // Label 206: @9517
     /*   9517 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(9587), // Rule ID 5531 //
     /*   9522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9533 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9537 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9541 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9559 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9561 */     // (add:{ *:[v8i16] } (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm), QPR:{ *:[v8i16] }:$src1)  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9566 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*   9568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9585 */     GIR_RootConstrainSelectedInstOperands,
     /*   9586 */     // GIR_Coverage, 5531,
     /*   9586 */     GIR_EraseRootFromParent_Done,
     /*   9587 */   // Label 207: @9587
     /*   9587 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(9644), // Rule ID 5504 //
     /*   9592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9620 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9622 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9636 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9642 */     GIR_RootConstrainSelectedInstOperands,
     /*   9643 */     // GIR_Coverage, 5504,
     /*   9643 */     GIR_EraseRootFromParent_Done,
     /*   9644 */   // Label 208: @9644
     /*   9644 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(9701), // Rule ID 5500 //
     /*   9649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9668 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9677 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9679 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9690 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9693 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9699 */     GIR_RootConstrainSelectedInstOperands,
     /*   9700 */     // GIR_Coverage, 5500,
     /*   9700 */     GIR_EraseRootFromParent_Done,
     /*   9701 */   // Label 209: @9701
     /*   9701 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(9758), // Rule ID 5503 //
     /*   9706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9725 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9734 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9736 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm), QPR:{ *:[v8i16] }:$Vn)  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*   9743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9747 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9750 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9756 */     GIR_RootConstrainSelectedInstOperands,
     /*   9757 */     // GIR_Coverage, 5503,
     /*   9757 */     GIR_EraseRootFromParent_Done,
     /*   9758 */   // Label 210: @9758
     /*   9758 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(9828), // Rule ID 888 //
     /*   9763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9778 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   9782 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*   9786 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*   9790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9802 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLAv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*   9802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv8i16),
     /*   9805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9807 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*   9809 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*   9813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*   9817 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9820 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9826 */     GIR_RootConstrainSelectedInstOperands,
     /*   9827 */     // GIR_Coverage, 888,
     /*   9827 */     GIR_EraseRootFromParent_Done,
     /*   9828 */   // Label 211: @9828
     /*   9828 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(9885), // Rule ID 784 //
     /*   9833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9840 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9856 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9861 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9863 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9870 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9883 */     GIR_RootConstrainSelectedInstOperands,
     /*   9884 */     // GIR_Coverage, 784,
     /*   9884 */     GIR_EraseRootFromParent_Done,
     /*   9885 */   // Label 212: @9885
     /*   9885 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(9942), // Rule ID 780 //
     /*   9890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9913 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9918 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9920 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWsv8i16),
     /*   9923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9940 */     GIR_RootConstrainSelectedInstOperands,
     /*   9941 */     // GIR_Coverage, 780,
     /*   9941 */     GIR_EraseRootFromParent_Done,
     /*   9942 */   // Label 213: @9942
     /*   9942 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(9999), // Rule ID 783 //
     /*   9947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*   9950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*   9958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*   9970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*   9975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   9977 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VADDWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*   9977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDWuv8i16),
     /*   9980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*   9982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*   9984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*   9988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*   9991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*   9997 */     GIR_RootConstrainSelectedInstOperands,
     /*   9998 */     // GIR_Coverage, 783,
     /*   9998 */     GIR_EraseRootFromParent_Done,
     /*   9999 */   // Label 214: @9999
     /*   9999 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(10039), // Rule ID 757 //
     /*  10004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10011 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10019 */     // (add:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VADDv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  10019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv8i16),
     /*  10022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10037 */     GIR_RootConstrainSelectedInstOperands,
     /*  10038 */     // GIR_Coverage, 757,
     /*  10038 */     GIR_EraseRootFromParent_Done,
     /*  10039 */   // Label 215: @10039
     /*  10039 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(10100), // Rule ID 3489 //
     /*  10044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10059 */     // (add:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  10059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi16),
     /*  10074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10076 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10098 */     GIR_RootConstrainSelectedInstOperands,
     /*  10099 */     // GIR_Coverage, 3489,
     /*  10099 */     GIR_EraseRootFromParent_Done,
     /*  10100 */   // Label 216: @10100
     /*  10100 */   GIM_Reject,
     /*  10101 */ // Label 201: @10101
     /*  10101 */ GIM_Reject,
     /*  10102 */ // Label 87: @10102
     /*  10102 */ GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(10355),
     /*  10107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10113 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(10183), // Rule ID 5530 //
     /*  10118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10155 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10157 */     // (add:{ *:[v16i8] } (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm), QPR:{ *:[v16i8] }:$src1)  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10162 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  10164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10181 */     GIR_RootConstrainSelectedInstOperands,
     /*  10182 */     // GIR_Coverage, 5530,
     /*  10182 */     GIR_EraseRootFromParent_Done,
     /*  10183 */   // Label 218: @10183
     /*  10183 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(10253), // Rule ID 887 //
     /*  10188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10195 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  10211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  10215 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10227 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLAv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLAv16i8),
     /*  10230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10232 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  10234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  10238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  10242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10251 */     GIR_RootConstrainSelectedInstOperands,
     /*  10252 */     // GIR_Coverage, 887,
     /*  10252 */     GIR_EraseRootFromParent_Done,
     /*  10253 */   // Label 219: @10253
     /*  10253 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(10293), // Rule ID 756 //
     /*  10258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  10261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  10273 */     // (add:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VADDv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  10273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDv16i8),
     /*  10276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  10278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  10280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  10282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10291 */     GIR_RootConstrainSelectedInstOperands,
     /*  10292 */     // GIR_Coverage, 756,
     /*  10292 */     GIR_EraseRootFromParent_Done,
     /*  10293 */   // Label 220: @10293
     /*  10293 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(10354), // Rule ID 3485 //
     /*  10298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  10301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  10313 */     // (add:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  10313 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  10316 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10320 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDi8),
     /*  10328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  10330 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  10332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  10334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  10337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10343 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10352 */     GIR_RootConstrainSelectedInstOperands,
     /*  10353 */     // GIR_Coverage, 3485,
     /*  10353 */     GIR_EraseRootFromParent_Done,
     /*  10354 */   // Label 221: @10354
     /*  10354 */   GIM_Reject,
     /*  10355 */ // Label 217: @10355
     /*  10355 */ GIM_Reject,
     /*  10356 */ // Label 88: @10356
     /*  10356 */ GIM_Reject,
     /*  10357 */ // Label 1: @10357
     /*  10357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 231*/ GIMT_Encode4(13600),
     /*  10368 */ /*GILLT_s32*//*Label 222*/ GIMT_Encode4(10428),
     /*  10372 */ /*GILLT_s64*//*Label 223*/ GIMT_Encode4(11042), GIMT_Encode4(0),
     /*  10380 */ /*GILLT_v2s32*//*Label 224*/ GIMT_Encode4(11089),
     /*  10384 */ /*GILLT_v2s64*//*Label 225*/ GIMT_Encode4(11204), GIMT_Encode4(0),
     /*  10392 */ /*GILLT_v4s16*//*Label 226*/ GIMT_Encode4(11756),
     /*  10396 */ /*GILLT_v4s32*//*Label 227*/ GIMT_Encode4(11871), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10408 */ /*GILLT_v8s8*//*Label 228*/ GIMT_Encode4(12586),
     /*  10412 */ /*GILLT_v8s16*//*Label 229*/ GIMT_Encode4(12701), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  10424 */ /*GILLT_v16s8*//*Label 230*/ GIMT_Encode4(13416),
     /*  10428 */ // Label 222: @10428
     /*  10428 */ GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(11041),
     /*  10433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  10436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  10439 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10483), // Rule ID 330 //
     /*  10444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  10455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10459 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, tGPR:{ *:[i32] }:$Rn)  =>  (tRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  10459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tRSB),
     /*  10462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10464 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10481 */     GIR_RootConstrainSelectedInstOperands,
     /*  10482 */     // GIR_Coverage, 330,
     /*  10482 */     GIR_EraseRootFromParent_Done,
     /*  10483 */   // Label 233: @10483
     /*  10483 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10540), // Rule ID 96 //
     /*  10488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10503 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10507 */     // MIs[1] Operand 1
     /*  10507 */     // No operand predicates
     /*  10507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10511 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10513 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, GPR:{ *:[i32] }:$Rn)  =>  (RSBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RSBri),
     /*  10516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10520 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10523 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10532 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10538 */     GIR_RootConstrainSelectedInstOperands,
     /*  10539 */     // GIR_Coverage, 96,
     /*  10539 */     GIR_EraseRootFromParent_Done,
     /*  10540 */   // Label 234: @10540
     /*  10540 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10597), // Rule ID 427 //
     /*  10545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10560 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10564 */     // MIs[1] Operand 1
     /*  10564 */     // No operand predicates
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10570 */     // (sub:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, rGPR:{ *:[i32] }:$Rn)  =>  (t2RSBri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RSBri),
     /*  10573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10595 */     GIR_RootConstrainSelectedInstOperands,
     /*  10596 */     // GIR_Coverage, 427,
     /*  10596 */     GIR_EraseRootFromParent_Done,
     /*  10597 */   // Label 235: @10597
     /*  10597 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10654), // Rule ID 76 //
     /*  10602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  10625 */     // MIs[1] Operand 1
     /*  10625 */     // No operand predicates
     /*  10625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10627 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (SUBri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBri),
     /*  10630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10652 */     GIR_RootConstrainSelectedInstOperands,
     /*  10653 */     // GIR_Coverage, 76,
     /*  10653 */     GIR_EraseRootFromParent_Done,
     /*  10654 */   // Label 236: @10654
     /*  10654 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10711), // Rule ID 411 //
     /*  10659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  10670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10678 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  10682 */     // MIs[1] Operand 1
     /*  10682 */     // No operand predicates
     /*  10682 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10684 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2SUBri:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri),
     /*  10687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10689 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10709 */     GIR_RootConstrainSelectedInstOperands,
     /*  10710 */     // GIR_Coverage, 411,
     /*  10710 */     GIR_EraseRootFromParent_Done,
     /*  10711 */   // Label 237: @10711
     /*  10711 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10762), // Rule ID 412 //
     /*  10716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  10719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  10735 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_4095),
     /*  10739 */     // MIs[1] Operand 1
     /*  10739 */     // No operand predicates
     /*  10739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10741 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_imm0_4095>>:$imm)  =>  (t2SUBri12:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  10741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBri12),
     /*  10744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  10751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10760 */     GIR_RootConstrainSelectedInstOperands,
     /*  10761 */     // GIR_Coverage, 412,
     /*  10761 */     GIR_EraseRootFromParent_Done,
     /*  10762 */   // Label 238: @10762
     /*  10762 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10832), // Rule ID 173 //
     /*  10767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM_UseMulOps),
     /*  10770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10804 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10806 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm))  =>  (MLS:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  10806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MLS),
     /*  10809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10815 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10819 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10830 */     GIR_RootConstrainSelectedInstOperands,
     /*  10831 */     // GIR_Coverage, 173,
     /*  10831 */     GIR_EraseRootFromParent_Done,
     /*  10832 */   // Label 239: @10832
     /*  10832 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10902), // Rule ID 504 //
     /*  10837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_UseMulOps),
     /*  10840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10856 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  10860 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  10864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  10874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10876 */     // (sub:{ *:[i32] } rGPR:{ *:[i32] }:$Ra, (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm))  =>  (t2MLS:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  10876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MLS),
     /*  10879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  10885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  10889 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10891 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10894 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10900 */     GIR_RootConstrainSelectedInstOperands,
     /*  10901 */     // GIR_Coverage, 504,
     /*  10901 */     GIR_EraseRootFromParent_Done,
     /*  10902 */   // Label 240: @10902
     /*  10902 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10948), // Rule ID 77 //
     /*  10907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  10910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  10922 */     // (sub:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SUBrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  10922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SUBrr),
     /*  10925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10946 */     GIR_RootConstrainSelectedInstOperands,
     /*  10947 */     // GIR_Coverage, 77,
     /*  10947 */     GIR_EraseRootFromParent_Done,
     /*  10948 */   // Label 241: @10948
     /*  10948 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10994), // Rule ID 333 //
     /*  10953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  10956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  10968 */     // (sub:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tSUBrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  10968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSUBrr),
     /*  10971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  10979 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  10983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  10986 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  10992 */     GIR_RootConstrainSelectedInstOperands,
     /*  10993 */     // GIR_Coverage, 333,
     /*  10993 */     GIR_EraseRootFromParent_Done,
     /*  10994 */   // Label 242: @10994
     /*  10994 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(11040), // Rule ID 413 //
     /*  10999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  11002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  11010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  11014 */     // (sub:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SUBrr:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  11014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SUBrr),
     /*  11017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11019 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  11023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11038 */     GIR_RootConstrainSelectedInstOperands,
     /*  11039 */     // GIR_Coverage, 413,
     /*  11039 */     GIR_EraseRootFromParent_Done,
     /*  11040 */   // Label 243: @11040
     /*  11040 */   GIM_Reject,
     /*  11041 */ // Label 232: @11041
     /*  11041 */ GIM_Reject,
     /*  11042 */ // Label 223: @11042
     /*  11042 */ GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11088), // Rule ID 963 //
     /*  11047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  11053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  11056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11060 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11064 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11068 */   // (sub:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VSUBv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  11068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv1i64),
     /*  11071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11073 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11075 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11077 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11080 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11086 */   GIR_RootConstrainSelectedInstOperands,
     /*  11087 */   // GIR_Coverage, 963,
     /*  11087 */   GIR_EraseRootFromParent_Done,
     /*  11088 */ // Label 244: @11088
     /*  11088 */ GIM_Reject,
     /*  11089 */ // Label 224: @11089
     /*  11089 */ GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11203),
     /*  11094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11097 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11104 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11108 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11170), // Rule ID 914 //
     /*  11113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11144 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VMLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv2i32),
     /*  11147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11149 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11168 */     GIR_RootConstrainSelectedInstOperands,
     /*  11169 */     // GIR_Coverage, 914,
     /*  11169 */     GIR_EraseRootFromParent_Done,
     /*  11170 */   // Label 246: @11170
     /*  11170 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11202), // Rule ID 959 //
     /*  11175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11182 */     // (sub:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VSUBv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i32),
     /*  11185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11200 */     GIR_RootConstrainSelectedInstOperands,
     /*  11201 */     // GIR_Coverage, 959,
     /*  11201 */     GIR_EraseRootFromParent_Done,
     /*  11202 */   // Label 247: @11202
     /*  11202 */   GIM_Reject,
     /*  11203 */ // Label 245: @11203
     /*  11203 */ GIM_Reject,
     /*  11204 */ // Label 225: @11204
     /*  11204 */ GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11755),
     /*  11209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  11212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  11215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11219 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11287), // Rule ID 983 //
     /*  11224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11261 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11263 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11268 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11272 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11285 */     GIR_RootConstrainSelectedInstOperands,
     /*  11286 */     // GIR_Coverage, 983,
     /*  11286 */     GIR_EraseRootFromParent_Done,
     /*  11287 */   // Label 249: @11287
     /*  11287 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11355), // Rule ID 982 //
     /*  11292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11331 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11353 */     GIR_RootConstrainSelectedInstOperands,
     /*  11354 */     // GIR_Coverage, 982,
     /*  11354 */     GIR_EraseRootFromParent_Done,
     /*  11355 */   // Label 250: @11355
     /*  11355 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11423), // Rule ID 971 //
     /*  11360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11392 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11397 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11399 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv2i64),
     /*  11402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11421 */     GIR_RootConstrainSelectedInstOperands,
     /*  11422 */     // GIR_Coverage, 971,
     /*  11422 */     GIR_EraseRootFromParent_Done,
     /*  11423 */   // Label 251: @11423
     /*  11423 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11491), // Rule ID 981 //
     /*  11428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11448 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11452 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11456 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11460 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11465 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11467 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 981,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 252: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11559), // Rule ID 980 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11511 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11535 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn), (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv2i64),
     /*  11538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11557 */     GIR_RootConstrainSelectedInstOperands,
     /*  11558 */     // GIR_Coverage, 980,
     /*  11558 */     GIR_EraseRootFromParent_Done,
     /*  11559 */   // Label 253: @11559
     /*  11559 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11612), // Rule ID 992 //
     /*  11564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11583 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11610 */     GIR_RootConstrainSelectedInstOperands,
     /*  11611 */     // GIR_Coverage, 992,
     /*  11611 */     GIR_EraseRootFromParent_Done,
     /*  11612 */   // Label 254: @11612
     /*  11612 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11665), // Rule ID 986 //
     /*  11617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  11632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11643 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv2i64),
     /*  11646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11650 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11663 */     GIR_RootConstrainSelectedInstOperands,
     /*  11664 */     // GIR_Coverage, 986,
     /*  11664 */     GIR_EraseRootFromParent_Done,
     /*  11665 */   // Label 255: @11665
     /*  11665 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11718), // Rule ID 991 //
     /*  11670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  11689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11696 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm))  =>  (VSUBWuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  11696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv2i64),
     /*  11699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  11707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11710 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11716 */     GIR_RootConstrainSelectedInstOperands,
     /*  11717 */     // GIR_Coverage, 991,
     /*  11717 */     GIR_EraseRootFromParent_Done,
     /*  11718 */   // Label 256: @11718
     /*  11718 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11754), // Rule ID 964 //
     /*  11723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11726 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11734 */     // (sub:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VSUBv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  11734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv2i64),
     /*  11737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11739 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11752 */     GIR_RootConstrainSelectedInstOperands,
     /*  11753 */     // GIR_Coverage, 964,
     /*  11753 */     GIR_EraseRootFromParent_Done,
     /*  11754 */   // Label 257: @11754
     /*  11754 */   GIM_Reject,
     /*  11755 */ // Label 248: @11755
     /*  11755 */ GIM_Reject,
     /*  11756 */ // Label 226: @11756
     /*  11756 */ GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11870),
     /*  11761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11775 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11837), // Rule ID 913 //
     /*  11780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  11791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  11799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11811 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VMLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i16),
     /*  11814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11816 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  11818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11822 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  11826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11835 */     GIR_RootConstrainSelectedInstOperands,
     /*  11836 */     // GIR_Coverage, 913,
     /*  11836 */     GIR_EraseRootFromParent_Done,
     /*  11837 */   // Label 259: @11837
     /*  11837 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11869), // Rule ID 958 //
     /*  11842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11849 */     // (sub:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VSUBv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i16),
     /*  11852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  11856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  11858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11867 */     GIR_RootConstrainSelectedInstOperands,
     /*  11868 */     // GIR_Coverage, 958,
     /*  11868 */     GIR_EraseRootFromParent_Done,
     /*  11869 */   // Label 260: @11869
     /*  11869 */   GIM_Reject,
     /*  11870 */ // Label 258: @11870
     /*  11870 */ GIM_Reject,
     /*  11871 */ // Label 227: @11871
     /*  11871 */ GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(12585),
     /*  11876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  11879 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  11882 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(11954), // Rule ID 979 //
     /*  11887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11928 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11930 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  11930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  11933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  11935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  11939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  11943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  11946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  11952 */     GIR_RootConstrainSelectedInstOperands,
     /*  11953 */     // GIR_Coverage, 979,
     /*  11953 */     GIR_EraseRootFromParent_Done,
     /*  11954 */   // Label 262: @11954
     /*  11954 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12026), // Rule ID 978 //
     /*  11959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  11966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  11974 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  11983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  11987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  11991 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  11995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12002 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12024 */     GIR_RootConstrainSelectedInstOperands,
     /*  12025 */     // GIR_Coverage, 978,
     /*  12025 */     GIR_EraseRootFromParent_Done,
     /*  12026 */   // Label 263: @12026
     /*  12026 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12098), // Rule ID 970 //
     /*  12031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12074 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv4i32),
     /*  12077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12096 */     GIR_RootConstrainSelectedInstOperands,
     /*  12097 */     // GIR_Coverage, 970,
     /*  12097 */     GIR_EraseRootFromParent_Done,
     /*  12098 */   // Label 264: @12098
     /*  12098 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12170), // Rule ID 977 //
     /*  12103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12146 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12168 */     GIR_RootConstrainSelectedInstOperands,
     /*  12169 */     // GIR_Coverage, 977,
     /*  12169 */     GIR_EraseRootFromParent_Done,
     /*  12170 */   // Label 265: @12170
     /*  12170 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12242), // Rule ID 976 //
     /*  12175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12190 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12194 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12199 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12203 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12207 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12211 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12218 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn), (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv4i32),
     /*  12221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12240 */     GIR_RootConstrainSelectedInstOperands,
     /*  12241 */     // GIR_Coverage, 976,
     /*  12241 */     GIR_EraseRootFromParent_Done,
     /*  12242 */   // Label 266: @12242
     /*  12242 */   GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(12312), // Rule ID 917 //
     /*  12247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12254 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  12274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12286 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm))  =>  (VMLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv4i32),
     /*  12289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12291 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12310 */     GIR_RootConstrainSelectedInstOperands,
     /*  12311 */     // GIR_Coverage, 917,
     /*  12311 */     GIR_EraseRootFromParent_Done,
     /*  12312 */   // Label 267: @12312
     /*  12312 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12369), // Rule ID 990 //
     /*  12317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12324 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12347 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12367 */     GIR_RootConstrainSelectedInstOperands,
     /*  12368 */     // GIR_Coverage, 990,
     /*  12368 */     GIR_EraseRootFromParent_Done,
     /*  12369 */   // Label 268: @12369
     /*  12369 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12426), // Rule ID 985 //
     /*  12374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12397 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12404 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv4i32),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12409 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12424 */     GIR_RootConstrainSelectedInstOperands,
     /*  12425 */     // GIR_Coverage, 985,
     /*  12425 */     GIR_EraseRootFromParent_Done,
     /*  12426 */   // Label 269: @12426
     /*  12426 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12483), // Rule ID 989 //
     /*  12431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12454 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12459 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12461 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm))  =>  (VSUBWuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  12461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv4i32),
     /*  12464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12466 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  12472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12481 */     GIR_RootConstrainSelectedInstOperands,
     /*  12482 */     // GIR_Coverage, 989,
     /*  12482 */     GIR_EraseRootFromParent_Done,
     /*  12483 */   // Label 270: @12483
     /*  12483 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12523), // Rule ID 962 //
     /*  12488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12503 */     // (sub:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VSUBv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  12503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv4i32),
     /*  12506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12521 */     GIR_RootConstrainSelectedInstOperands,
     /*  12522 */     // GIR_Coverage, 962,
     /*  12522 */     GIR_EraseRootFromParent_Done,
     /*  12523 */   // Label 271: @12523
     /*  12523 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(12584), // Rule ID 3505 //
     /*  12528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  12531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  12543 */     // (sub:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VSUBi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  12543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  12550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi32),
     /*  12558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  12560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  12562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  12564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  12567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12579 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  12582 */     GIR_RootConstrainSelectedInstOperands,
     /*  12583 */     // GIR_Coverage, 3505,
     /*  12583 */     GIR_EraseRootFromParent_Done,
     /*  12584 */   // Label 272: @12584
     /*  12584 */   GIM_Reject,
     /*  12585 */ // Label 261: @12585
     /*  12585 */ GIM_Reject,
     /*  12586 */ // Label 228: @12586
     /*  12586 */ GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(12700),
     /*  12591 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12594 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12605 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(12667), // Rule ID 912 //
     /*  12610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  12621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  12629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12641 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm))  =>  (VMLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i8),
     /*  12644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12646 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  12648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  12656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12665 */     GIR_RootConstrainSelectedInstOperands,
     /*  12666 */     // GIR_Coverage, 912,
     /*  12666 */     GIR_EraseRootFromParent_Done,
     /*  12667 */   // Label 274: @12667
     /*  12667 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(12699), // Rule ID 957 //
     /*  12672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12679 */     // (sub:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSUBv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i8),
     /*  12682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12684 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  12686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  12688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12697 */     GIR_RootConstrainSelectedInstOperands,
     /*  12698 */     // GIR_Coverage, 957,
     /*  12698 */     GIR_EraseRootFromParent_Done,
     /*  12699 */   // Label 275: @12699
     /*  12699 */   GIM_Reject,
     /*  12700 */ // Label 273: @12700
     /*  12700 */ GIM_Reject,
     /*  12701 */ // Label 229: @12701
     /*  12701 */ GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13415),
     /*  12706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  12709 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  12712 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(12784), // Rule ID 975 //
     /*  12717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12749 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12753 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12760 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12765 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12773 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12776 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12782 */     GIR_RootConstrainSelectedInstOperands,
     /*  12783 */     // GIR_Coverage, 975,
     /*  12783 */     GIR_EraseRootFromParent_Done,
     /*  12784 */   // Label 277: @12784
     /*  12784 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(12856), // Rule ID 974 //
     /*  12789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12825 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12832 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12854 */     GIR_RootConstrainSelectedInstOperands,
     /*  12855 */     // GIR_Coverage, 974,
     /*  12855 */     GIR_EraseRootFromParent_Done,
     /*  12856 */   // Label 278: @12856
     /*  12856 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(12928), // Rule ID 969 //
     /*  12861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12897 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12904 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLsv8i16),
     /*  12907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12926 */     GIR_RootConstrainSelectedInstOperands,
     /*  12927 */     // GIR_Coverage, 969,
     /*  12927 */     GIR_EraseRootFromParent_Done,
     /*  12928 */   // Label 279: @12928
     /*  12928 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(13000), // Rule ID 973 //
     /*  12933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  12940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12957 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  12961 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12965 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  12969 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  12974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  12976 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  12976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  12979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  12981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  12985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  12989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  12992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  12998 */     GIR_RootConstrainSelectedInstOperands,
     /*  12999 */     // GIR_Coverage, 973,
     /*  12999 */     GIR_EraseRootFromParent_Done,
     /*  13000 */   // Label 280: @13000
     /*  13000 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(13072), // Rule ID 972 //
     /*  13005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13020 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13024 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13037 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13041 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13048 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn), (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBLuv8i16),
     /*  13051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /*  13061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13070 */     GIR_RootConstrainSelectedInstOperands,
     /*  13071 */     // GIR_Coverage, 972,
     /*  13071 */     GIR_EraseRootFromParent_Done,
     /*  13072 */   // Label 281: @13072
     /*  13072 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(13142), // Rule ID 916 //
     /*  13077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  13100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  13104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13116 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm))  =>  (VMLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv8i16),
     /*  13119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13140 */     GIR_RootConstrainSelectedInstOperands,
     /*  13141 */     // GIR_Coverage, 916,
     /*  13141 */     GIR_EraseRootFromParent_Done,
     /*  13142 */   // Label 282: @13142
     /*  13142 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(13199), // Rule ID 988 //
     /*  13147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13154 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13177 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13197 */     GIR_RootConstrainSelectedInstOperands,
     /*  13198 */     // GIR_Coverage, 988,
     /*  13198 */     GIR_EraseRootFromParent_Done,
     /*  13199 */   // Label 283: @13199
     /*  13199 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(13256), // Rule ID 984 //
     /*  13204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13234 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWsv8i16),
     /*  13237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13254 */     GIR_RootConstrainSelectedInstOperands,
     /*  13255 */     // GIR_Coverage, 984,
     /*  13255 */     GIR_EraseRootFromParent_Done,
     /*  13256 */   // Label 284: @13256
     /*  13256 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(13313), // Rule ID 987 //
     /*  13261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  13284 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  13289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13291 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm))  =>  (VSUBWuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  13291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBWuv8i16),
     /*  13294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  13302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13311 */     GIR_RootConstrainSelectedInstOperands,
     /*  13312 */     // GIR_Coverage, 987,
     /*  13312 */     GIR_EraseRootFromParent_Done,
     /*  13313 */   // Label 285: @13313
     /*  13313 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(13353), // Rule ID 961 //
     /*  13318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13325 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13333 */     // (sub:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VSUBv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  13333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv8i16),
     /*  13336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13351 */     GIR_RootConstrainSelectedInstOperands,
     /*  13352 */     // GIR_Coverage, 961,
     /*  13352 */     GIR_EraseRootFromParent_Done,
     /*  13353 */   // Label 286: @13353
     /*  13353 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(13414), // Rule ID 3501 //
     /*  13358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13365 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13373 */     // (sub:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VSUBi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi16),
     /*  13388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13412 */     GIR_RootConstrainSelectedInstOperands,
     /*  13413 */     // GIR_Coverage, 3501,
     /*  13413 */     GIR_EraseRootFromParent_Done,
     /*  13414 */   // Label 287: @13414
     /*  13414 */   GIM_Reject,
     /*  13415 */ // Label 276: @13415
     /*  13415 */ GIM_Reject,
     /*  13416 */ // Label 230: @13416
     /*  13416 */ GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(13599),
     /*  13421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13424 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13427 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(13497), // Rule ID 915 //
     /*  13432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13439 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  13447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  13451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  13455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  13459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13464 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13469 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  13471 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm))  =>  (VMLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src1, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLSv16i8),
     /*  13474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /*  13478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  13482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  13486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13495 */     GIR_RootConstrainSelectedInstOperands,
     /*  13496 */     // GIR_Coverage, 915,
     /*  13496 */     GIR_EraseRootFromParent_Done,
     /*  13497 */   // Label 289: @13497
     /*  13497 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(13537), // Rule ID 960 //
     /*  13502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  13505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  13517 */     // (sub:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSUBv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  13517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBv16i8),
     /*  13520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  13522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  13524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  13526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13535 */     GIR_RootConstrainSelectedInstOperands,
     /*  13536 */     // GIR_Coverage, 960,
     /*  13536 */     GIR_EraseRootFromParent_Done,
     /*  13537 */   // Label 290: @13537
     /*  13537 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(13598), // Rule ID 3497 //
     /*  13542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  13545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  13557 */     // (sub:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VSUBi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  13557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBi8),
     /*  13572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  13574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  13576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  13578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  13581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  13596 */     GIR_RootConstrainSelectedInstOperands,
     /*  13597 */     // GIR_Coverage, 3497,
     /*  13597 */     GIR_EraseRootFromParent_Done,
     /*  13598 */   // Label 291: @13598
     /*  13598 */   GIM_Reject,
     /*  13599 */ // Label 288: @13599
     /*  13599 */ GIM_Reject,
     /*  13600 */ // Label 231: @13600
     /*  13600 */ GIM_Reject,
     /*  13601 */ // Label 2: @13601
     /*  13601 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 299*/ GIMT_Encode4(15304),
     /*  13612 */ /*GILLT_s32*//*Label 292*/ GIMT_Encode4(13672), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13624 */ /*GILLT_v2s32*//*Label 293*/ GIMT_Encode4(14591), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13636 */ /*GILLT_v4s16*//*Label 294*/ GIMT_Encode4(14638),
     /*  13640 */ /*GILLT_v4s32*//*Label 295*/ GIMT_Encode4(14685), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13652 */ /*GILLT_v8s8*//*Label 296*/ GIMT_Encode4(14914),
     /*  13656 */ /*GILLT_v8s16*//*Label 297*/ GIMT_Encode4(14961), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  13668 */ /*GILLT_v16s8*//*Label 298*/ GIMT_Encode4(15190),
     /*  13672 */ // Label 292: @13672
     /*  13672 */ GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(14590),
     /*  13677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  13680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  13683 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(13771), // Rule ID 186 //
     /*  13688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13716 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13728 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13732 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13736 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13741 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13745 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13747 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  13750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13769 */     GIR_RootConstrainSelectedInstOperands,
     /*  13770 */     // GIR_Coverage, 186,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 301: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(13859), // Rule ID 515 //
     /*  13776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  13824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13829 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  13833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13835 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  13835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  13838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13857 */     GIR_RootConstrainSelectedInstOperands,
     /*  13858 */     // GIR_Coverage, 515,
     /*  13858 */     GIR_EraseRootFromParent_Done,
     /*  13859 */   // Label 302: @13859
     /*  13859 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(13950), // Rule ID 185 //
     /*  13864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  13867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  13913 */     // MIs[2] Operand 2
     /*  13913 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  13924 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13926 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  13926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  13929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  13931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  13935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  13942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  13948 */     GIR_RootConstrainSelectedInstOperands,
     /*  13949 */     // GIR_Coverage, 185,
     /*  13949 */     GIR_EraseRootFromParent_Done,
     /*  13950 */   // Label 303: @13950
     /*  13950 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(14041), // Rule ID 514 //
     /*  13955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  13958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  13970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  13974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  13978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  13983 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  13987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  13991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  13995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  13999 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14004 */     // MIs[2] Operand 2
     /*  14004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14015 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14017 */     // (mul:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 16:{ *:[i32] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  14020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14039 */     GIR_RootConstrainSelectedInstOperands,
     /*  14040 */     // GIR_Coverage, 514,
     /*  14040 */     GIR_EraseRootFromParent_Done,
     /*  14041 */   // Label 304: @14041
     /*  14041 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(14132), // Rule ID 184 //
     /*  14046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14070 */     // MIs[1] Operand 2
     /*  14070 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14089 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14093 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14097 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14102 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14106 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14108 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  14111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14130 */     GIR_RootConstrainSelectedInstOperands,
     /*  14131 */     // GIR_Coverage, 184,
     /*  14131 */     GIR_EraseRootFromParent_Done,
     /*  14132 */   // Label 305: @14132
     /*  14132 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(14223), // Rule ID 513 //
     /*  14137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14161 */     // MIs[1] Operand 2
     /*  14161 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  14180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14184 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  14188 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 16,
     /*  14197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14199 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16:{ *:[i32] }))  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  14202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14221 */     GIR_RootConstrainSelectedInstOperands,
     /*  14222 */     // GIR_Coverage, 513,
     /*  14222 */     GIR_EraseRootFromParent_Done,
     /*  14223 */   // Label 306: @14223
     /*  14223 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(14317), // Rule ID 183 //
     /*  14228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  14231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14247 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14252 */     // MIs[1] Operand 2
     /*  14252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14263 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14267 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  14280 */     // MIs[2] Operand 2
     /*  14280 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14293 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  14293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  14296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14298 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14315 */     GIR_RootConstrainSelectedInstOperands,
     /*  14316 */     // GIR_Coverage, 183,
     /*  14316 */     GIR_EraseRootFromParent_Done,
     /*  14317 */   // Label 307: @14317
     /*  14317 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(14411), // Rule ID 512 //
     /*  14322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  14325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  14341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14346 */     // MIs[1] Operand 2
     /*  14346 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14365 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  14369 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14374 */     // MIs[2] Operand 2
     /*  14374 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14385 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14387 */     // (mul:{ *:[i32] } (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] }))  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  14390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  14396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14409 */     GIR_RootConstrainSelectedInstOperands,
     /*  14410 */     // GIR_Coverage, 512,
     /*  14410 */     GIR_EraseRootFromParent_Done,
     /*  14411 */   // Label 308: @14411
     /*  14411 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(14457), // Rule ID 169 //
     /*  14416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  14419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14431 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MUL:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MUL),
     /*  14434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14455 */     GIR_RootConstrainSelectedInstOperands,
     /*  14456 */     // GIR_Coverage, 169,
     /*  14456 */     GIR_EraseRootFromParent_Done,
     /*  14457 */   // Label 309: @14457
     /*  14457 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(14503), // Rule ID 170 //
     /*  14462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV6_UseMulOps),
     /*  14465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14469 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  14477 */     // (mul:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (MULv5:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  14477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MULv5),
     /*  14480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14501 */     GIR_RootConstrainSelectedInstOperands,
     /*  14502 */     // GIR_Coverage, 170,
     /*  14502 */     GIR_EraseRootFromParent_Done,
     /*  14503 */   // Label 310: @14503
     /*  14503 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(14549), // Rule ID 323 //
     /*  14508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  14511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  14523 */     // (mul:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tMUL:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  14523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMUL),
     /*  14526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14528 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  14534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14547 */     GIR_RootConstrainSelectedInstOperands,
     /*  14548 */     // GIR_Coverage, 323,
     /*  14548 */     GIR_EraseRootFromParent_Done,
     /*  14549 */   // Label 311: @14549
     /*  14549 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(14589), // Rule ID 502 //
     /*  14554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  14557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  14569 */     // (mul:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2MUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  14569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MUL),
     /*  14572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  14574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  14576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  14578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14587 */     GIR_RootConstrainSelectedInstOperands,
     /*  14588 */     // GIR_Coverage, 502,
     /*  14588 */     GIR_EraseRootFromParent_Done,
     /*  14589 */   // Label 312: @14589
     /*  14589 */   GIM_Reject,
     /*  14590 */ // Label 300: @14590
     /*  14590 */ GIM_Reject,
     /*  14591 */ // Label 293: @14591
     /*  14591 */ GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(14637), // Rule ID 834 //
     /*  14596 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14599 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  14602 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14613 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14617 */   // (mul:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMULv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  14617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv2i32),
     /*  14620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14622 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14624 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14626 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14629 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14635 */   GIR_RootConstrainSelectedInstOperands,
     /*  14636 */   // GIR_Coverage, 834,
     /*  14636 */   GIR_EraseRootFromParent_Done,
     /*  14637 */ // Label 313: @14637
     /*  14637 */ GIM_Reject,
     /*  14638 */ // Label 294: @14638
     /*  14638 */ GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(14684), // Rule ID 833 //
     /*  14643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14649 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14656 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14660 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14664 */   // (mul:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMULv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  14664 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i16),
     /*  14667 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14669 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14671 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14673 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14676 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14682 */   GIR_RootConstrainSelectedInstOperands,
     /*  14683 */   // GIR_Coverage, 833,
     /*  14683 */   GIR_EraseRootFromParent_Done,
     /*  14684 */ // Label 314: @14684
     /*  14684 */ GIM_Reject,
     /*  14685 */ // Label 295: @14685
     /*  14685 */ GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(14913),
     /*  14690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14693 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  14696 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(14811), // Rule ID 4418 //
     /*  14701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14725 */     // MIs[1] Operand 2
     /*  14725 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /*  14736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  14740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14744 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14753 */     // MIs[2] Operand 2
     /*  14753 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /*  14764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14766 */     // (mul:{ *:[v4i32] } (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, v4i16:{ *:[Other] }), (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src2, v4i16:{ *:[Other] }))  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2)
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  14781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  14787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  14791 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14794 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14809 */     GIR_RootConstrainSelectedInstOperands,
     /*  14810 */     // GIR_Coverage, 4418,
     /*  14810 */     GIR_EraseRootFromParent_Done,
     /*  14811 */   // Label 316: @14811
     /*  14811 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(14851), // Rule ID 837 //
     /*  14816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14823 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  14831 */     // (mul:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMULv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  14831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv4i32),
     /*  14834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14849 */     GIR_RootConstrainSelectedInstOperands,
     /*  14850 */     // GIR_Coverage, 837,
     /*  14850 */     GIR_EraseRootFromParent_Done,
     /*  14851 */   // Label 317: @14851
     /*  14851 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(14912), // Rule ID 3463 //
     /*  14856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14871 */     // (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  14871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi32),
     /*  14886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  14888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  14890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  14892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  14895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14907 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  14910 */     GIR_RootConstrainSelectedInstOperands,
     /*  14911 */     // GIR_Coverage, 3463,
     /*  14911 */     GIR_EraseRootFromParent_Done,
     /*  14912 */   // Label 318: @14912
     /*  14912 */   GIM_Reject,
     /*  14913 */ // Label 315: @14913
     /*  14913 */ GIM_Reject,
     /*  14914 */ // Label 296: @14914
     /*  14914 */ GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(14960), // Rule ID 832 //
     /*  14919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  14925 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  14928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14936 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  14940 */   // (mul:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  14940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i8),
     /*  14943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  14945 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  14947 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  14949 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  14952 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  14958 */   GIR_RootConstrainSelectedInstOperands,
     /*  14959 */   // GIR_Coverage, 832,
     /*  14959 */   GIR_EraseRootFromParent_Done,
     /*  14960 */ // Label 319: @14960
     /*  14960 */ GIM_Reject,
     /*  14961 */ // Label 297: @14961
     /*  14961 */ GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(15189),
     /*  14966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14969 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  14972 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(15087), // Rule ID 4423 //
     /*  14977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  14980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  14984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  14992 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  14996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15001 */     // MIs[1] Operand 2
     /*  15001 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /*  15012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  15016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  15020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  15024 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15029 */     // MIs[2] Operand 2
     /*  15029 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /*  15040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15042 */     // (mul:{ *:[v8i16] } (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, v8i8:{ *:[Other] }), (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src2, v8i8:{ *:[Other] }))  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2)
     /*  15042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  15057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  15063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  15067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15070 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15085 */     GIR_RootConstrainSelectedInstOperands,
     /*  15086 */     // GIR_Coverage, 4423,
     /*  15086 */     GIR_EraseRootFromParent_Done,
     /*  15087 */   // Label 321: @15087
     /*  15087 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(15127), // Rule ID 836 //
     /*  15092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15107 */     // (mul:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMULv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  15107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv8i16),
     /*  15110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15125 */     GIR_RootConstrainSelectedInstOperands,
     /*  15126 */     // GIR_Coverage, 836,
     /*  15126 */     GIR_EraseRootFromParent_Done,
     /*  15127 */   // Label 322: @15127
     /*  15127 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(15188), // Rule ID 3459 //
     /*  15132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15147 */     // (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  15147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi16),
     /*  15162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15164 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15186 */     GIR_RootConstrainSelectedInstOperands,
     /*  15187 */     // GIR_Coverage, 3459,
     /*  15187 */     GIR_EraseRootFromParent_Done,
     /*  15188 */   // Label 323: @15188
     /*  15188 */   GIM_Reject,
     /*  15189 */ // Label 320: @15189
     /*  15189 */ GIM_Reject,
     /*  15190 */ // Label 298: @15190
     /*  15190 */ GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(15303),
     /*  15195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  15198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  15201 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(15241), // Rule ID 835 //
     /*  15206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  15221 */     // (mul:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  15221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULv16i8),
     /*  15224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  15226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  15228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  15230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15239 */     GIR_RootConstrainSelectedInstOperands,
     /*  15240 */     // GIR_Coverage, 835,
     /*  15240 */     GIR_EraseRootFromParent_Done,
     /*  15241 */   // Label 325: @15241
     /*  15241 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(15302), // Rule ID 3455 //
     /*  15246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  15249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  15261 */     // (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  15261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  15264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  15268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  15273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULi8),
     /*  15276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  15278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  15280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  15282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  15300 */     GIR_RootConstrainSelectedInstOperands,
     /*  15301 */     // GIR_Coverage, 3455,
     /*  15301 */     GIR_EraseRootFromParent_Done,
     /*  15302 */   // Label 326: @15302
     /*  15302 */   GIM_Reject,
     /*  15303 */ // Label 324: @15303
     /*  15303 */ GIM_Reject,
     /*  15304 */ // Label 299: @15304
     /*  15304 */ GIM_Reject,
     /*  15305 */ // Label 3: @15305
     /*  15305 */ GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(15400),
     /*  15310 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15319 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(15359), // Rule ID 195 //
     /*  15324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15339 */     // (sdiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SDIV),
     /*  15342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15348 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15357 */     GIR_RootConstrainSelectedInstOperands,
     /*  15358 */     // GIR_Coverage, 195,
     /*  15358 */     GIR_EraseRootFromParent_Done,
     /*  15359 */   // Label 328: @15359
     /*  15359 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(15399), // Rule ID 532 //
     /*  15364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15379 */     // (sdiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SDIV),
     /*  15382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15391 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15397 */     GIR_RootConstrainSelectedInstOperands,
     /*  15398 */     // GIR_Coverage, 532,
     /*  15398 */     GIR_EraseRootFromParent_Done,
     /*  15399 */   // Label 329: @15399
     /*  15399 */   GIM_Reject,
     /*  15400 */ // Label 327: @15400
     /*  15400 */ GIM_Reject,
     /*  15401 */ // Label 4: @15401
     /*  15401 */ GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(15496),
     /*  15406 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  15409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15415 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(15455), // Rule ID 196 //
     /*  15420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInARM_IsARM),
     /*  15423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15435 */     // (udiv:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (UDIV:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  15435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDIV),
     /*  15438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15440 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15453 */     GIR_RootConstrainSelectedInstOperands,
     /*  15454 */     // GIR_Coverage, 196,
     /*  15454 */     GIR_EraseRootFromParent_Done,
     /*  15455 */   // Label 331: @15455
     /*  15455 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(15495), // Rule ID 533 //
     /*  15460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDivideInThumb_HasV8MBaseline_IsThumb),
     /*  15463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15475 */     // (udiv:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UDIV:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  15475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDIV),
     /*  15478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15480 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  15482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  15484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15493 */     GIR_RootConstrainSelectedInstOperands,
     /*  15494 */     // GIR_Coverage, 533,
     /*  15494 */     GIR_EraseRootFromParent_Done,
     /*  15495 */   // Label 332: @15495
     /*  15495 */   GIM_Reject,
     /*  15496 */ // Label 330: @15496
     /*  15496 */ GIM_Reject,
     /*  15497 */ // Label 5: @15497
     /*  15497 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 346*/ GIMT_Encode4(18676),
     /*  15508 */ /*GILLT_s32*//*Label 333*/ GIMT_Encode4(15568),
     /*  15512 */ /*GILLT_s64*//*Label 334*/ GIMT_Encode4(17560),
     /*  15516 */ /*GILLT_v2s1*//*Label 335*/ GIMT_Encode4(17607),
     /*  15520 */ /*GILLT_v2s32*//*Label 336*/ GIMT_Encode4(17725),
     /*  15524 */ /*GILLT_v2s64*//*Label 337*/ GIMT_Encode4(17772),
     /*  15528 */ /*GILLT_v4s1*//*Label 338*/ GIMT_Encode4(17886),
     /*  15532 */ /*GILLT_v4s16*//*Label 339*/ GIMT_Encode4(18004),
     /*  15536 */ /*GILLT_v4s32*//*Label 340*/ GIMT_Encode4(18051), GIMT_Encode4(0),
     /*  15544 */ /*GILLT_v8s1*//*Label 341*/ GIMT_Encode4(18165),
     /*  15548 */ /*GILLT_v8s8*//*Label 342*/ GIMT_Encode4(18283),
     /*  15552 */ /*GILLT_v8s16*//*Label 343*/ GIMT_Encode4(18330), GIMT_Encode4(0),
     /*  15560 */ /*GILLT_v16s1*//*Label 344*/ GIMT_Encode4(18444),
     /*  15564 */ /*GILLT_v16s8*//*Label 345*/ GIMT_Encode4(18562),
     /*  15568 */ // Label 333: @15568
     /*  15568 */ GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(17559),
     /*  15573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  15576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  15579 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(15652), // Rule ID 1852 //
     /*  15584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15595 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15599 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15603 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15607 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15612 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15616 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15629 */     // (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15634 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15650 */     GIR_RootConstrainSelectedInstOperands,
     /*  15651 */     // GIR_Coverage, 1852,
     /*  15651 */     GIR_EraseRootFromParent_Done,
     /*  15652 */   // Label 348: @15652
     /*  15652 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(15725), // Rule ID 2109 //
     /*  15657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  15672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  15676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  15680 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15685 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 8,
     /*  15689 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15700 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15702 */     // (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 8:{ *:[i32] }), 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 1:{ *:[i32] })
     /*  15702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Src
     /*  15711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  15714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15723 */     GIR_RootConstrainSelectedInstOperands,
     /*  15724 */     // GIR_Coverage, 2109,
     /*  15724 */     GIR_EraseRootFromParent_Done,
     /*  15725 */   // Label 349: @15725
     /*  15725 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(15773), // Rule ID 1994 //
     /*  15730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15737 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15741 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15752 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 255:{ *:[i32] })  =>  (UXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB),
     /*  15755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15771 */     GIR_RootConstrainSelectedInstOperands,
     /*  15772 */     // GIR_Coverage, 1994,
     /*  15772 */     GIR_EraseRootFromParent_Done,
     /*  15773 */   // Label 350: @15773
     /*  15773 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(15821), // Rule ID 1995 //
     /*  15778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15789 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15800 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 65535:{ *:[i32] })  =>  (UXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTH),
     /*  15803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15819 */     GIR_RootConstrainSelectedInstOperands,
     /*  15820 */     // GIR_Coverage, 1995,
     /*  15820 */     GIR_EraseRootFromParent_Done,
     /*  15821 */   // Label 351: @15821
     /*  15821 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(15869), // Rule ID 1996 //
     /*  15826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  15829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  15833 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  15837 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15848 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Src, 16711935:{ *:[i32] })  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  15848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  15851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /*  15855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15867 */     GIR_RootConstrainSelectedInstOperands,
     /*  15868 */     // GIR_Coverage, 1996,
     /*  15868 */     GIR_EraseRootFromParent_Done,
     /*  15869 */   // Label 352: @15869
     /*  15869 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(15917), // Rule ID 2233 //
     /*  15874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15885 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  15896 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (t2UXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB),
     /*  15899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15901 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15915 */     GIR_RootConstrainSelectedInstOperands,
     /*  15916 */     // GIR_Coverage, 2233,
     /*  15916 */     GIR_EraseRootFromParent_Done,
     /*  15917 */   // Label 353: @15917
     /*  15917 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(15965), // Rule ID 2234 //
     /*  15922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  15925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15933 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  15944 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (t2UXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTH),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  15954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  15957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 2234,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 354: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(16013), // Rule ID 2235 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  15981 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16711935),
     /*  15992 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 16711935:{ *:[i32] })  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  15992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  15995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  15997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  15999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  16002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16011 */     GIR_RootConstrainSelectedInstOperands,
     /*  16012 */     // GIR_Coverage, 2235,
     /*  16012 */     GIR_EraseRootFromParent_Done,
     /*  16013 */   // Label 355: @16013
     /*  16013 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(16090), // Rule ID 5436 //
     /*  16018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16041 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16053 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16057 */     // MIs[2] Operand 1
     /*  16057 */     // No operand predicates
     /*  16057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16063 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16082 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16088 */     GIR_RootConstrainSelectedInstOperands,
     /*  16089 */     // GIR_Coverage, 5436,
     /*  16089 */     GIR_EraseRootFromParent_Done,
     /*  16090 */   // Label 356: @16090
     /*  16090 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(16167), // Rule ID 5469 //
     /*  16095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16114 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16134 */     // MIs[2] Operand 1
     /*  16134 */     // No operand predicates
     /*  16134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16140 */     // (and:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16159 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16165 */     GIR_RootConstrainSelectedInstOperands,
     /*  16166 */     // GIR_Coverage, 5469,
     /*  16166 */     GIR_EraseRootFromParent_Done,
     /*  16167 */   // Label 357: @16167
     /*  16167 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(16244), // Rule ID 5435 //
     /*  16172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16203 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16207 */     // MIs[2] Operand 1
     /*  16207 */     // No operand predicates
     /*  16207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16217 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16236 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16242 */     GIR_RootConstrainSelectedInstOperands,
     /*  16243 */     // GIR_Coverage, 5435,
     /*  16243 */     GIR_EraseRootFromParent_Done,
     /*  16244 */   // Label 358: @16244
     /*  16244 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(16321), // Rule ID 5468 //
     /*  16249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16280 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16284 */     // MIs[2] Operand 1
     /*  16284 */     // No operand predicates
     /*  16284 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16294 */     // (and:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16301 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16319 */     GIR_RootConstrainSelectedInstOperands,
     /*  16320 */     // GIR_Coverage, 5468,
     /*  16320 */     GIR_EraseRootFromParent_Done,
     /*  16321 */   // Label 359: @16321
     /*  16321 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(16398), // Rule ID 5434 //
     /*  16326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16349 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16353 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16357 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16361 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16365 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16369 */     // MIs[2] Operand 1
     /*  16369 */     // No operand predicates
     /*  16369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16371 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16378 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16381 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16384 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16396 */     GIR_RootConstrainSelectedInstOperands,
     /*  16397 */     // GIR_Coverage, 5434,
     /*  16397 */     GIR_EraseRootFromParent_Done,
     /*  16398 */   // Label 360: @16398
     /*  16398 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(16475), // Rule ID 5467 //
     /*  16403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16430 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  16434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16442 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16446 */     // MIs[2] Operand 1
     /*  16446 */     // No operand predicates
     /*  16446 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16448 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16453 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16473 */     GIR_RootConstrainSelectedInstOperands,
     /*  16474 */     // GIR_Coverage, 5467,
     /*  16474 */     GIR_EraseRootFromParent_Done,
     /*  16475 */   // Label 361: @16475
     /*  16475 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(16552), // Rule ID 159 //
     /*  16480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16487 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16503 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16515 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  16519 */     // MIs[2] Operand 1
     /*  16519 */     // No operand predicates
     /*  16519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16523 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16525 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm, -1:{ *:[i32] }))  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  16528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16530 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16550 */     GIR_RootConstrainSelectedInstOperands,
     /*  16551 */     // GIR_Coverage, 159,
     /*  16551 */     GIR_EraseRootFromParent_Done,
     /*  16552 */   // Label 362: @16552
     /*  16552 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(16629), // Rule ID 490 //
     /*  16557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16564 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16580 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16592 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  16596 */     // MIs[2] Operand 1
     /*  16596 */     // No operand predicates
     /*  16596 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16602 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2BICri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  16602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICri),
     /*  16605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16607 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16609 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  16612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16627 */     GIR_RootConstrainSelectedInstOperands,
     /*  16628 */     // GIR_Coverage, 490,
     /*  16628 */     GIR_EraseRootFromParent_Done,
     /*  16629 */   // Label 363: @16629
     /*  16629 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(16700), // Rule ID 5437 //
     /*  16634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16672 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR:{ *:[i32] }:$Rn)  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16686 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16692 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16698 */     GIR_RootConstrainSelectedInstOperands,
     /*  16699 */     // GIR_Coverage, 5437,
     /*  16699 */     GIR_EraseRootFromParent_Done,
     /*  16700 */   // Label 364: @16700
     /*  16700 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(16771), // Rule ID 5458 //
     /*  16705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16728 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16733 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16743 */     // (and:{ *:[i32] } (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), tGPR:{ *:[i32] }:$Rn)  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16748 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16769 */     GIR_RootConstrainSelectedInstOperands,
     /*  16770 */     // GIR_Coverage, 5458,
     /*  16770 */     GIR_EraseRootFromParent_Done,
     /*  16771 */   // Label 365: @16771
     /*  16771 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(16842), // Rule ID 5470 //
     /*  16776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16804 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16812 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16814 */     // (and:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  16814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  16817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  16821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16840 */     GIR_RootConstrainSelectedInstOperands,
     /*  16841 */     // GIR_Coverage, 5470,
     /*  16841 */     GIR_EraseRootFromParent_Done,
     /*  16842 */   // Label 366: @16842
     /*  16842 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(16913), // Rule ID 160 //
     /*  16847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  16850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16870 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  16879 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16883 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16885 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  16885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICrr),
     /*  16888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  16890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16911 */     GIR_RootConstrainSelectedInstOperands,
     /*  16912 */     // GIR_Coverage, 160,
     /*  16912 */     GIR_EraseRootFromParent_Done,
     /*  16913 */   // Label 367: @16913
     /*  16913 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(16984), // Rule ID 313 //
     /*  16918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  16921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  16937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  16941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  16945 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  16950 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  16954 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  16956 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (tBIC:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  16956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBIC),
     /*  16959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  16961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  16967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  16969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  16973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  16976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  16982 */     GIR_RootConstrainSelectedInstOperands,
     /*  16983 */     // GIR_Coverage, 313,
     /*  16983 */     GIR_EraseRootFromParent_Done,
     /*  16984 */   // Label 368: @16984
     /*  16984 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(17055), // Rule ID 491 //
     /*  16989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  16992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  16996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  17008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  17012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  17016 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17021 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  17025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17027 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2BICrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BICrr),
     /*  17030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17034 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  17038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17053 */     GIR_RootConstrainSelectedInstOperands,
     /*  17054 */     // GIR_Coverage, 491,
     /*  17054 */     GIR_EraseRootFromParent_Done,
     /*  17055 */   // Label 369: @17055
     /*  17055 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(17100), // Rule ID 345 //
     /*  17060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17067 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17071 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  17082 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 255:{ *:[i32] })  =>  (tUXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTB),
     /*  17085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17098 */     GIR_RootConstrainSelectedInstOperands,
     /*  17099 */     // GIR_Coverage, 345,
     /*  17099 */     GIR_EraseRootFromParent_Done,
     /*  17100 */   // Label 370: @17100
     /*  17100 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(17145), // Rule ID 346 //
     /*  17105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  17108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17116 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  17127 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, 65535:{ *:[i32] })  =>  (tUXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /*  17127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUXTH),
     /*  17130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  17134 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17143 */     GIR_RootConstrainSelectedInstOperands,
     /*  17144 */     // GIR_Coverage, 346,
     /*  17144 */     GIR_EraseRootFromParent_Done,
     /*  17145 */   // Label 371: @17145
     /*  17145 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(17204), // Rule ID 1891 //
     /*  17150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17169 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  17173 */     // MIs[1] Operand 1
     /*  17173 */     // No operand predicates
     /*  17173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17175 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm)  =>  (BICri:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>>:$imm))
     /*  17175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BICri),
     /*  17178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17180 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17182 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  17187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17202 */     GIR_RootConstrainSelectedInstOperands,
     /*  17203 */     // GIR_Coverage, 1891,
     /*  17203 */     GIR_EraseRootFromParent_Done,
     /*  17204 */   // Label 372: @17204
     /*  17204 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(17261), // Rule ID 147 //
     /*  17209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  17232 */     // MIs[1] Operand 1
     /*  17232 */     // No operand predicates
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17234 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ANDri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDri),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17241 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17259 */     GIR_RootConstrainSelectedInstOperands,
     /*  17260 */     // GIR_Coverage, 147,
     /*  17260 */     GIR_EraseRootFromParent_Done,
     /*  17261 */   // Label 373: @17261
     /*  17261 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(17318), // Rule ID 481 //
     /*  17266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17273 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  17289 */     // MIs[1] Operand 1
     /*  17289 */     // No operand predicates
     /*  17289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17291 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ANDri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  17291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDri),
     /*  17294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17310 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17316 */     GIR_RootConstrainSelectedInstOperands,
     /*  17317 */     // GIR_Coverage, 481,
     /*  17317 */     GIR_EraseRootFromParent_Done,
     /*  17318 */   // Label 374: @17318
     /*  17318 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(17369), // Rule ID 163 //
     /*  17323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  17326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17334 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17338 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17342 */     // MIs[1] Operand 1
     /*  17342 */     // No operand predicates
     /*  17342 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17348 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (BFC:{ *:[i32] } GPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BFC),
     /*  17351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17353 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17355 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 163,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 375: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(17420), // Rule ID 493 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17393 */     // MIs[1] Operand 1
     /*  17393 */     // No operand predicates
     /*  17393 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_bf_inv_mask_imm),
     /*  17397 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  17399 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_bf_inv_mask_imm>>:$imm)  =>  (t2BFC:{ *:[i32] } rGPR:{ *:[i32] }:$src, (imm:{ *:[i32] }):$imm)
     /*  17399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2BFC),
     /*  17402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17404 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  17406 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  17409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17418 */     GIR_RootConstrainSelectedInstOperands,
     /*  17419 */     // GIR_Coverage, 493,
     /*  17419 */     GIR_EraseRootFromParent_Done,
     /*  17420 */   // Label 376: @17420
     /*  17420 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(17466), // Rule ID 148 //
     /*  17425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  17428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  17440 */     // (and:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ANDrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  17440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ANDrr),
     /*  17443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17464 */     GIR_RootConstrainSelectedInstOperands,
     /*  17465 */     // GIR_Coverage, 148,
     /*  17465 */     GIR_EraseRootFromParent_Done,
     /*  17466 */   // Label 377: @17466
     /*  17466 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(17512), // Rule ID 310 //
     /*  17471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  17474 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  17486 */     // (and:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tAND:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  17486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tAND),
     /*  17489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  17491 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  17497 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17504 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17510 */     GIR_RootConstrainSelectedInstOperands,
     /*  17511 */     // GIR_Coverage, 310,
     /*  17511 */     GIR_EraseRootFromParent_Done,
     /*  17512 */   // Label 378: @17512
     /*  17512 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(17558), // Rule ID 482 //
     /*  17517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  17520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17532 */     // (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ANDrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  17532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  17539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  17541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17556 */     GIR_RootConstrainSelectedInstOperands,
     /*  17557 */     // GIR_Coverage, 482,
     /*  17557 */     GIR_EraseRootFromParent_Done,
     /*  17558 */   // Label 379: @17558
     /*  17558 */   GIM_Reject,
     /*  17559 */ // Label 347: @17559
     /*  17559 */ GIM_Reject,
     /*  17560 */ // Label 334: @17560
     /*  17560 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(17606), // Rule ID 2523 //
     /*  17565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  17571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  17574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17578 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17582 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17586 */   // (and:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VANDd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  17586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17591 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17593 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17595 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17604 */   GIR_RootConstrainSelectedInstOperands,
     /*  17605 */   // GIR_Coverage, 2523,
     /*  17605 */   GIR_EraseRootFromParent_Done,
     /*  17606 */ // Label 380: @17606
     /*  17606 */ GIM_Reject,
     /*  17607 */ // Label 335: @17607
     /*  17607 */ GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(17724), // Rule ID 1823 //
     /*  17612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  17618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  17621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17629 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17633 */   // (and:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17633 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17636 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17640 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17645 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17649 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17654 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17657 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17661 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17666 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17670 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17687 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17690 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17693 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17696 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17702 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17713 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17715 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17723 */   // GIR_Coverage, 1823,
     /*  17723 */   GIR_EraseRootFromParent_Done,
     /*  17724 */ // Label 381: @17724
     /*  17724 */ GIM_Reject,
     /*  17725 */ // Label 336: @17725
     /*  17725 */ GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(17771), // Rule ID 1130 //
     /*  17730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17736 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17747 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  17751 */   // (and:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VANDd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  17751 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  17754 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17756 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  17758 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  17760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17769 */   GIR_RootConstrainSelectedInstOperands,
     /*  17770 */   // GIR_Coverage, 1130,
     /*  17770 */   GIR_EraseRootFromParent_Done,
     /*  17771 */ // Label 382: @17771
     /*  17771 */ GIM_Reject,
     /*  17772 */ // Label 337: @17772
     /*  17772 */ GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(17885),
     /*  17777 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  17780 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  17783 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(17823), // Rule ID 2526 //
     /*  17788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  17803 */     // (and:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VANDq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  17803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  17806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  17808 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  17810 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  17812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  17815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17821 */     GIR_RootConstrainSelectedInstOperands,
     /*  17822 */     // GIR_Coverage, 2526,
     /*  17822 */     GIR_EraseRootFromParent_Done,
     /*  17823 */   // Label 384: @17823
     /*  17823 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(17884), // Rule ID 3367 //
     /*  17828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  17843 */     // (and:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VAND:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  17843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  17846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  17850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  17858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  17860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  17862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  17864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  17867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17882 */     GIR_RootConstrainSelectedInstOperands,
     /*  17883 */     // GIR_Coverage, 3367,
     /*  17883 */     GIR_EraseRootFromParent_Done,
     /*  17884 */   // Label 385: @17884
     /*  17884 */   GIM_Reject,
     /*  17885 */ // Label 383: @17885
     /*  17885 */ GIM_Reject,
     /*  17886 */ // Label 338: @17886
     /*  17886 */ GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(18003), // Rule ID 1824 //
     /*  17891 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  17894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  17897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  17900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17908 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  17912 */   // (and:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  17912 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  17915 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17919 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17924 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  17928 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17933 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  17936 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17940 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17945 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  17949 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  17954 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  17957 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  17961 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  17966 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  17969 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  17972 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  17975 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17981 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  17987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  17989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  17992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17994 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  17997 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18002 */   // GIR_Coverage, 1824,
     /*  18002 */   GIR_EraseRootFromParent_Done,
     /*  18003 */ // Label 386: @18003
     /*  18003 */ GIM_Reject,
     /*  18004 */ // Label 339: @18004
     /*  18004 */ GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(18050), // Rule ID 2522 //
     /*  18009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  18015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  18018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18030 */   // (and:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VANDd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  18030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18035 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18037 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18039 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18042 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18048 */   GIR_RootConstrainSelectedInstOperands,
     /*  18049 */   // GIR_Coverage, 2522,
     /*  18049 */   GIR_EraseRootFromParent_Done,
     /*  18050 */ // Label 387: @18050
     /*  18050 */ GIM_Reject,
     /*  18051 */ // Label 340: @18051
     /*  18051 */ GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(18164),
     /*  18056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  18062 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(18102), // Rule ID 1131 //
     /*  18067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18074 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18082 */     // (and:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VANDq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  18082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18087 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  18089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  18091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18100 */     GIR_RootConstrainSelectedInstOperands,
     /*  18101 */     // GIR_Coverage, 1131,
     /*  18101 */     GIR_EraseRootFromParent_Done,
     /*  18102 */   // Label 389: @18102
     /*  18102 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(18163), // Rule ID 3363 //
     /*  18107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18122 */     // (and:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VAND:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  18122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18146 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18158 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18161 */     GIR_RootConstrainSelectedInstOperands,
     /*  18162 */     // GIR_Coverage, 3363,
     /*  18162 */     GIR_EraseRootFromParent_Done,
     /*  18163 */   // Label 390: @18163
     /*  18163 */   GIM_Reject,
     /*  18164 */ // Label 388: @18164
     /*  18164 */ GIM_Reject,
     /*  18165 */ // Label 341: @18165
     /*  18165 */ GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(18282), // Rule ID 1825 //
     /*  18170 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  18176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  18179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18191 */   // (and:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18191 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18194 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18198 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18203 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18207 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18212 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18215 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18219 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18224 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18228 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18233 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18236 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18240 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18245 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18248 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18251 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18254 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18260 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18266 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18273 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18276 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18281 */   // GIR_Coverage, 1825,
     /*  18281 */   GIR_EraseRootFromParent_Done,
     /*  18282 */ // Label 391: @18282
     /*  18282 */ GIM_Reject,
     /*  18283 */ // Label 342: @18283
     /*  18283 */ GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(18329), // Rule ID 2521 //
     /*  18288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  18294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  18297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18305 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  18309 */   // (and:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VANDd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  18309 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDd),
     /*  18312 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18314 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18316 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18318 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18321 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18327 */   GIR_RootConstrainSelectedInstOperands,
     /*  18328 */   // GIR_Coverage, 2521,
     /*  18328 */   GIR_EraseRootFromParent_Done,
     /*  18329 */ // Label 392: @18329
     /*  18329 */ GIM_Reject,
     /*  18330 */ // Label 343: @18330
     /*  18330 */ GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(18443),
     /*  18335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  18338 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  18341 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(18381), // Rule ID 2525 //
     /*  18346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18353 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18361 */     // (and:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VANDq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  18361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18366 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18368 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18370 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18379 */     GIR_RootConstrainSelectedInstOperands,
     /*  18380 */     // GIR_Coverage, 2525,
     /*  18380 */     GIR_EraseRootFromParent_Done,
     /*  18381 */   // Label 394: @18381
     /*  18381 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(18442), // Rule ID 3359 //
     /*  18386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18401 */     // (and:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VAND:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  18401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18422 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18437 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18440 */     GIR_RootConstrainSelectedInstOperands,
     /*  18441 */     // GIR_Coverage, 3359,
     /*  18441 */     GIR_EraseRootFromParent_Done,
     /*  18442 */   // Label 395: @18442
     /*  18442 */   GIM_Reject,
     /*  18443 */ // Label 393: @18443
     /*  18443 */ GIM_Reject,
     /*  18444 */ // Label 344: @18444
     /*  18444 */ GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(18561), // Rule ID 1826 //
     /*  18449 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18452 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  18455 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  18458 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18462 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18466 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18470 */   // (and:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ANDrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  18470 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  18473 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18477 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18482 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  18486 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18491 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  18494 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18498 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18503 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  18507 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  18515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ANDrr),
     /*  18519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18524 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  18527 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  18530 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  18533 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18539 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  18547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  18550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  18560 */   // GIR_Coverage, 1826,
     /*  18560 */   GIR_EraseRootFromParent_Done,
     /*  18561 */ // Label 396: @18561
     /*  18561 */ GIM_Reject,
     /*  18562 */ // Label 345: @18562
     /*  18562 */ GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(18675),
     /*  18567 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  18570 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  18573 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(18613), // Rule ID 2524 //
     /*  18578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  18593 */     // (and:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VANDq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  18593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VANDq),
     /*  18596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  18598 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  18600 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  18602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18611 */     GIR_RootConstrainSelectedInstOperands,
     /*  18612 */     // GIR_Coverage, 2524,
     /*  18612 */     GIR_EraseRootFromParent_Done,
     /*  18613 */   // Label 398: @18613
     /*  18613 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(18674), // Rule ID 3355 //
     /*  18618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  18621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  18633 */     // (and:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VAND:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  18633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  18636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  18640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  18645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VAND),
     /*  18648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  18650 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  18652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  18654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  18657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  18672 */     GIR_RootConstrainSelectedInstOperands,
     /*  18673 */     // GIR_Coverage, 3355,
     /*  18673 */     GIR_EraseRootFromParent_Done,
     /*  18674 */   // Label 399: @18674
     /*  18674 */   GIM_Reject,
     /*  18675 */ // Label 397: @18675
     /*  18675 */ GIM_Reject,
     /*  18676 */ // Label 346: @18676
     /*  18676 */ GIM_Reject,
     /*  18677 */ // Label 6: @18677
     /*  18677 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 413*/ GIMT_Encode4(24485),
     /*  18688 */ /*GILLT_s32*//*Label 400*/ GIMT_Encode4(18748),
     /*  18692 */ /*GILLT_s64*//*Label 401*/ GIMT_Encode4(23369),
     /*  18696 */ /*GILLT_v2s1*//*Label 402*/ GIMT_Encode4(23416),
     /*  18700 */ /*GILLT_v2s32*//*Label 403*/ GIMT_Encode4(23534),
     /*  18704 */ /*GILLT_v2s64*//*Label 404*/ GIMT_Encode4(23581),
     /*  18708 */ /*GILLT_v4s1*//*Label 405*/ GIMT_Encode4(23695),
     /*  18712 */ /*GILLT_v4s16*//*Label 406*/ GIMT_Encode4(23813),
     /*  18716 */ /*GILLT_v4s32*//*Label 407*/ GIMT_Encode4(23860), GIMT_Encode4(0),
     /*  18724 */ /*GILLT_v8s1*//*Label 408*/ GIMT_Encode4(23974),
     /*  18728 */ /*GILLT_v8s8*//*Label 409*/ GIMT_Encode4(24092),
     /*  18732 */ /*GILLT_v8s16*//*Label 410*/ GIMT_Encode4(24139), GIMT_Encode4(0),
     /*  18740 */ /*GILLT_v16s1*//*Label 411*/ GIMT_Encode4(24253),
     /*  18744 */ /*GILLT_v16s8*//*Label 412*/ GIMT_Encode4(24371),
     /*  18748 */ // Label 400: @18748
     /*  18748 */ GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(23368),
     /*  18753 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  18756 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  18759 */   GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(18886), // Rule ID 5652 //
     /*  18764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  18767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  18808 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18812 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18831 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18835 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18839 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18843 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18847 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18851 */     // MIs[4] Rm
     /*  18851 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18856 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18860 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18864 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18866 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  18866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  18869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  18875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  18878 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  18884 */     GIR_RootConstrainSelectedInstOperands,
     /*  18885 */     // GIR_Coverage, 5652,
     /*  18885 */     GIR_EraseRootFromParent_Done,
     /*  18886 */   // Label 415: @18886
     /*  18886 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(19013), // Rule ID 5694 //
     /*  18891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  18894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  18906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  18910 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  18914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  18922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  18926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  18930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  18935 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  18939 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /*  18950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  18954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  18958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  18962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  18966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  18970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  18974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  18978 */     // MIs[4] Rm
     /*  18978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  18983 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 24,
     /*  18987 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 16,
     /*  18991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18993 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }), (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  18993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  18996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  18998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19011 */     GIR_RootConstrainSelectedInstOperands,
     /*  19012 */     // GIR_Coverage, 5694,
     /*  19012 */     GIR_EraseRootFromParent_Done,
     /*  19013 */   // Label 416: @19013
     /*  19013 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(19140), // Rule ID 1911 //
     /*  19018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  19062 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19066 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19086 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19090 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19094 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19098 */     // MIs[4] Rm
     /*  19098 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19103 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19107 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19120 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  19120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /*  19123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19138 */     GIR_RootConstrainSelectedInstOperands,
     /*  19139 */     // GIR_Coverage, 1911,
     /*  19139 */     GIR_EraseRootFromParent_Done,
     /*  19140 */   // Label 417: @19140
     /*  19140 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(19267), // Rule ID 2193 //
     /*  19145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  19148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19168 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19172 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19176 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19180 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19189 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 24,
     /*  19193 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /*  19197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  19201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  19209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  19213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  19217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19225 */     // MIs[4] Rm
     /*  19225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  19230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  19234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(255),
     /*  19245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19247 */     // (or:{ *:[i32] } (sra:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 24:{ *:[i32] }), 16:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 8:{ *:[i32] }), 255:{ *:[i32] }))  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  19247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /*  19250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19265 */     GIR_RootConstrainSelectedInstOperands,
     /*  19266 */     // GIR_Coverage, 2193,
     /*  19266 */     GIR_EraseRootFromParent_Done,
     /*  19267 */   // Label 418: @19267
     /*  19267 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(19400), // Rule ID 5450 //
     /*  19272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19291 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19307 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19311 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19316 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19320 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19324 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19328 */     // MIs[3] Operand 1
     /*  19328 */     // No operand predicates
     /*  19328 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19339 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19343 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19347 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19351 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19355 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19360 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19373 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19398 */     GIR_RootConstrainSelectedInstOperands,
     /*  19399 */     // GIR_Coverage, 5450,
     /*  19399 */     GIR_EraseRootFromParent_Done,
     /*  19400 */   // Label 419: @19400
     /*  19400 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(19533), // Rule ID 5487 //
     /*  19405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  19436 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19440 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19444 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19449 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19453 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19457 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  19461 */     // MIs[3] Operand 1
     /*  19461 */     // No operand predicates
     /*  19461 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19476 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19480 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19484 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19493 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19504 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19506 */     // (or:{ *:[i32] } (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19531 */     GIR_RootConstrainSelectedInstOperands,
     /*  19532 */     // GIR_Coverage, 5487,
     /*  19532 */     GIR_EraseRootFromParent_Done,
     /*  19533 */   // Label 420: @19533
     /*  19533 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(19666), // Rule ID 5657 //
     /*  19538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19557 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19573 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19577 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19582 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19586 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19590 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19594 */     // MIs[3] Operand 1
     /*  19594 */     // No operand predicates
     /*  19594 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19605 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19609 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19613 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19617 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19621 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19626 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19637 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19639 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  19642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19652 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19664 */     GIR_RootConstrainSelectedInstOperands,
     /*  19665 */     // GIR_Coverage, 5657,
     /*  19665 */     GIR_EraseRootFromParent_Done,
     /*  19666 */   // Label 421: @19666
     /*  19666 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(19799), // Rule ID 5699 //
     /*  19671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  19702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19706 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19710 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19723 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  19727 */     // MIs[3] Operand 1
     /*  19727 */     // No operand predicates
     /*  19727 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  19738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19746 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19750 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19754 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19759 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19770 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19772 */     // (or:{ *:[i32] } (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  19772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  19775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // src1
     /*  19781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  19785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19797 */     GIR_RootConstrainSelectedInstOperands,
     /*  19798 */     // GIR_Coverage, 5699,
     /*  19798 */     GIR_EraseRootFromParent_Done,
     /*  19799 */   // Label 422: @19799
     /*  19799 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(19932), // Rule ID 5449 //
     /*  19804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19827 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19831 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19835 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19839 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19843 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19848 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19852 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19856 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19860 */     // MIs[3] Operand 1
     /*  19860 */     // No operand predicates
     /*  19860 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  19871 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  19875 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19879 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  19883 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  19887 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  19892 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  19903 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  19905 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  19905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  19908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  19914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  19921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  19924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  19930 */     GIR_RootConstrainSelectedInstOperands,
     /*  19931 */     // GIR_Coverage, 5449,
     /*  19931 */     GIR_EraseRootFromParent_Done,
     /*  19932 */   // Label 423: @19932
     /*  19932 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(20065), // Rule ID 5486 //
     /*  19937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  19940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  19952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  19956 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  19960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  19968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  19972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  19976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  19981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  19993 */     // MIs[3] Operand 1
     /*  19993 */     // No operand predicates
     /*  19993 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20004 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  20008 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20012 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /*  20016 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s32,
     /*  20020 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20025 */     GIM_CheckConstantInt, /*MI*/4, /*Op*/2, GIMT_Encode8(65535),
     /*  20036 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20038 */     // (or:{ *:[i32] } (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  20047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20051 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  20054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20063 */     GIR_RootConstrainSelectedInstOperands,
     /*  20064 */     // GIR_Coverage, 5486,
     /*  20064 */     GIR_EraseRootFromParent_Done,
     /*  20065 */   // Label 424: @20065
     /*  20065 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(20198), // Rule ID 203 //
     /*  20070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20098 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20117 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20121 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20125 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20129 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20133 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20137 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20141 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20146 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20150 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20154 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20158 */     // MIs[4] Operand 1
     /*  20158 */     // No operand predicates
     /*  20158 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20169 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20171 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20176 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20187 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20196 */     GIR_RootConstrainSelectedInstOperands,
     /*  20197 */     // GIR_Coverage, 203,
     /*  20197 */     GIR_EraseRootFromParent_Done,
     /*  20198 */   // Label 425: @20198
     /*  20198 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(20331), // Rule ID 540 //
     /*  20203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20222 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20231 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20242 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20246 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20250 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20254 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20258 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20262 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  20266 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20270 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20274 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20279 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20283 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20287 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_asr_amt),
     /*  20291 */     // MIs[4] Operand 1
     /*  20291 */     // No operand predicates
     /*  20291 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20304 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_asr_amt>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20317 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20320 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20323 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20329 */     GIR_RootConstrainSelectedInstOperands,
     /*  20330 */     // GIR_Coverage, 540,
     /*  20330 */     GIR_EraseRootFromParent_Done,
     /*  20331 */   // Label 426: @20331
     /*  20331 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(20464), // Rule ID 1916 //
     /*  20336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20364 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20391 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20395 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20399 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20403 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20407 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20420 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20424 */     // MIs[4] Operand 1
     /*  20424 */     // No operand predicates
     /*  20424 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20435 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20437 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  20440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20442 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20462 */     GIR_RootConstrainSelectedInstOperands,
     /*  20463 */     // GIR_Coverage, 1916,
     /*  20463 */     GIR_EraseRootFromParent_Done,
     /*  20464 */   // Label 427: @20464
     /*  20464 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(20597), // Rule ID 2198 //
     /*  20469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20497 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20508 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20512 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20516 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20520 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20524 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20528 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  20532 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20536 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20540 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20553 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_15),
     /*  20557 */     // MIs[4] Operand 1
     /*  20557 */     // No operand predicates
     /*  20557 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  20568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20570 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (and:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh), 65535:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm1_15>>:$sh)
     /*  20570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  20573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  20579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src2
     /*  20583 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20595 */     GIR_RootConstrainSelectedInstOperands,
     /*  20596 */     // GIR_Coverage, 2198,
     /*  20596 */     GIR_EraseRootFromParent_Done,
     /*  20597 */   // Label 428: @20597
     /*  20597 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(20730), // Rule ID 202 //
     /*  20602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20630 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20657 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20661 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20665 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20669 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20673 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20678 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20682 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20686 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20690 */     // MIs[4] Operand 1
     /*  20690 */     // No operand predicates
     /*  20690 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20701 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20703 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20719 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20722 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20728 */     GIR_RootConstrainSelectedInstOperands,
     /*  20729 */     // GIR_Coverage, 202,
     /*  20729 */     GIR_EraseRootFromParent_Done,
     /*  20730 */   // Label 429: @20730
     /*  20730 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(20863), // Rule ID 539 //
     /*  20735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20758 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20763 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  20794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  20798 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  20802 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  20806 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20811 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  20815 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20819 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_pkh_lsl_amt),
     /*  20823 */     // MIs[4] Operand 1
     /*  20823 */     // No operand predicates
     /*  20823 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  20836 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_pkh_lsl_amt>>:$sh), 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$sh)
     /*  20836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  20839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  20849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // sh
     /*  20852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20861 */     GIR_RootConstrainSelectedInstOperands,
     /*  20862 */     // GIR_Coverage, 539,
     /*  20862 */     GIR_EraseRootFromParent_Done,
     /*  20863 */   // Label 430: @20863
     /*  20863 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(20968), // Rule ID 1912 //
     /*  20868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  20871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20896 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  20907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  20919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  20923 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  20928 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  20939 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20941 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  20941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  20944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  20957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  20960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  20966 */     GIR_RootConstrainSelectedInstOperands,
     /*  20967 */     // GIR_Coverage, 1912,
     /*  20967 */     GIR_EraseRootFromParent_Done,
     /*  20968 */   // Label 431: @20968
     /*  20968 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(21073), // Rule ID 2194 //
     /*  20973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  20976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  20980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  20988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  20992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  20996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21001 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21033 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21046 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21051 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21059 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21071 */     GIR_RootConstrainSelectedInstOperands,
     /*  21072 */     // GIR_Coverage, 2194,
     /*  21072 */     GIR_EraseRootFromParent_Done,
     /*  21073 */   // Label 432: @21073
     /*  21073 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(21178), // Rule ID 5653 //
     /*  21078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21106 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21133 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21138 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21151 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, 4294901760:{ *:[i32] }), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  21151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21160 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21176 */     GIR_RootConstrainSelectedInstOperands,
     /*  21177 */     // GIR_Coverage, 5653,
     /*  21177 */     GIR_EraseRootFromParent_Done,
     /*  21178 */   // Label 433: @21178
     /*  21178 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(21283), // Rule ID 5695 //
     /*  21183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21211 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21230 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21234 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21243 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /*  21254 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  21256 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src2, 4294901760:{ *:[i32] }), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, 0:{ *:[i32] })
     /*  21256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src1
     /*  21265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  21269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  21272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21281 */     GIR_RootConstrainSelectedInstOperands,
     /*  21282 */     // GIR_Coverage, 5695,
     /*  21282 */     GIR_EraseRootFromParent_Done,
     /*  21283 */   // Label 434: @21283
     /*  21283 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(21389), // Rule ID 1915 //
     /*  21288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21316 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21335 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21339 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21343 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21356 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21360 */     // MIs[3] Operand 1
     /*  21360 */     // No operand predicates
     /*  21360 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21362 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21381 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21387 */     GIR_RootConstrainSelectedInstOperands,
     /*  21388 */     // GIR_Coverage, 1915,
     /*  21388 */     GIR_EraseRootFromParent_Done,
     /*  21389 */   // Label 435: @21389
     /*  21389 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(21495), // Rule ID 2197 //
     /*  21394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21422 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21466 */     // MIs[3] Operand 1
     /*  21466 */     // No operand predicates
     /*  21466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21468 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21487 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21493 */     GIR_RootConstrainSelectedInstOperands,
     /*  21494 */     // GIR_Coverage, 2197,
     /*  21494 */     GIR_EraseRootFromParent_Done,
     /*  21495 */   // Label 436: @21495
     /*  21495 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(21601), // Rule ID 1914 //
     /*  21500 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21528 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21547 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21551 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21555 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21560 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21564 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21568 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21572 */     // MIs[3] Operand 1
     /*  21572 */     // No operand predicates
     /*  21572 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21574 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  21577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21599 */     GIR_RootConstrainSelectedInstOperands,
     /*  21600 */     // GIR_Coverage, 1914,
     /*  21600 */     GIR_EraseRootFromParent_Done,
     /*  21601 */   // Label 437: @21601
     /*  21601 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(21707), // Rule ID 2196 //
     /*  21606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21634 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  21653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  21678 */     // MIs[3] Operand 1
     /*  21678 */     // No operand predicates
     /*  21678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21680 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }), (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  21680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  21683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21693 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21705 */     GIR_RootConstrainSelectedInstOperands,
     /*  21706 */     // GIR_Coverage, 2196,
     /*  21706 */     GIR_EraseRootFromParent_Done,
     /*  21707 */   // Label 438: @21707
     /*  21707 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(21813), // Rule ID 1913 //
     /*  21712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21731 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21740 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21767 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21780 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21784 */     // MIs[3] Operand 1
     /*  21784 */     // No operand predicates
     /*  21784 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21786 */     // (or:{ *:[i32] } (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  21789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  21799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21811 */     GIR_RootConstrainSelectedInstOperands,
     /*  21812 */     // GIR_Coverage, 1913,
     /*  21812 */     GIR_EraseRootFromParent_Done,
     /*  21813 */   // Label 439: @21813
     /*  21813 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(21919), // Rule ID 2195 //
     /*  21818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  21821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21841 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21846 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /*  21857 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  21861 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  21865 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  21869 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /*  21873 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  21878 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  21882 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21886 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21890 */     // MIs[3] Operand 1
     /*  21890 */     // No operand predicates
     /*  21890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21892 */     // (or:{ *:[i32] } (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }), (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  21895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /*  21901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // src2
     /*  21905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // sh
     /*  21908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  21911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  21917 */     GIR_RootConstrainSelectedInstOperands,
     /*  21918 */     // GIR_Coverage, 2195,
     /*  21918 */     GIR_EraseRootFromParent_Done,
     /*  21919 */   // Label 440: @21919
     /*  21919 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(22025), // Rule ID 5656 //
     /*  21924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  21927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  21939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  21943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  21947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  21956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  21960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  21964 */     // MIs[2] Operand 1
     /*  21964 */     // No operand predicates
     /*  21964 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21968 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  21972 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  21976 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  21980 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  21985 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  21996 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  21998 */     // (or:{ *:[i32] } (sra:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22011 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22023 */     GIR_RootConstrainSelectedInstOperands,
     /*  22024 */     // GIR_Coverage, 5656,
     /*  22024 */     GIR_EraseRootFromParent_Done,
     /*  22025 */   // Label 441: @22025
     /*  22025 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(22131), // Rule ID 5698 //
     /*  22030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22041 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ASHR),
     /*  22045 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22049 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22053 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22058 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22062 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22066 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22070 */     // MIs[2] Operand 1
     /*  22070 */     // No operand predicates
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22082 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22086 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22091 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22102 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22104 */     // (or:{ *:[i32] } (sra:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22117 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22120 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22123 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22129 */     GIR_RootConstrainSelectedInstOperands,
     /*  22130 */     // GIR_Coverage, 5698,
     /*  22130 */     GIR_EraseRootFromParent_Done,
     /*  22131 */   // Label 442: @22131
     /*  22131 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(22237), // Rule ID 5655 //
     /*  22136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22172 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22176 */     // MIs[2] Operand 1
     /*  22176 */     // No operand predicates
     /*  22176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22184 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22188 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22192 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22197 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22210 */     // (or:{ *:[i32] } (srl:{ *:[i32] } GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (PKHTB:{ *:[i32] } GPRnopc:{ *:[i32] }:$src1, GPRnopc:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHTB),
     /*  22213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22226 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22235 */     GIR_RootConstrainSelectedInstOperands,
     /*  22236 */     // GIR_Coverage, 5655,
     /*  22236 */     GIR_EraseRootFromParent_Done,
     /*  22237 */   // Label 443: @22237
     /*  22237 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(22343), // Rule ID 5697 //
     /*  22242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  22257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22270 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22274 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22278 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16),
     /*  22282 */     // MIs[2] Operand 1
     /*  22282 */     // No operand predicates
     /*  22282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22290 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22294 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22298 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22303 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(4294901760),
     /*  22314 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22316 */     // (or:{ *:[i32] } (srl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 4294901760:{ *:[i32] }))  =>  (t2PKHTB:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16>>:$sh)
     /*  22316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHTB),
     /*  22319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22329 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22341 */     GIR_RootConstrainSelectedInstOperands,
     /*  22342 */     // GIR_Coverage, 5697,
     /*  22342 */     GIR_EraseRootFromParent_Done,
     /*  22343 */   // Label 444: @22343
     /*  22343 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(22449), // Rule ID 5654 //
     /*  22348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  22351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22388 */     // MIs[2] Operand 1
     /*  22388 */     // No operand predicates
     /*  22388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  22409 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22420 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22422 */     // (or:{ *:[i32] } (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, 65535:{ *:[i32] }))  =>  (PKHBT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::PKHBT),
     /*  22425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  22431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22447 */     GIR_RootConstrainSelectedInstOperands,
     /*  22448 */     // GIR_Coverage, 5654,
     /*  22448 */     GIR_EraseRootFromParent_Done,
     /*  22449 */   // Label 445: @22449
     /*  22449 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(22555), // Rule ID 5696 //
     /*  22454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  22457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  22469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22490 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm16_31),
     /*  22494 */     // MIs[2] Operand 1
     /*  22494 */     // No operand predicates
     /*  22494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  22502 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  22506 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /*  22510 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22515 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(65535),
     /*  22526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  22528 */     // (or:{ *:[i32] } (shl:{ *:[i32] } rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh), (and:{ *:[i32] } rGPR:{ *:[i32] }:$src1, 65535:{ *:[i32] }))  =>  (t2PKHBT:{ *:[i32] } rGPR:{ *:[i32] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] })<<P:Predicate_imm16_31>>:$sh)
     /*  22528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2PKHBT),
     /*  22531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // src1
     /*  22537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src2
     /*  22541 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // sh
     /*  22544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22553 */     GIR_RootConstrainSelectedInstOperands,
     /*  22554 */     // GIR_Coverage, 5696,
     /*  22554 */     GIR_EraseRootFromParent_Done,
     /*  22555 */   // Label 446: @22555
     /*  22555 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(22632), // Rule ID 5474 //
     /*  22560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22583 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22595 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22599 */     // MIs[2] Operand 1
     /*  22599 */     // No operand predicates
     /*  22599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22605 */     // (or:{ *:[i32] } (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22630 */     GIR_RootConstrainSelectedInstOperands,
     /*  22631 */     // GIR_Coverage, 5474,
     /*  22631 */     GIR_EraseRootFromParent_Done,
     /*  22632 */   // Label 447: @22632
     /*  22632 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(22709), // Rule ID 5473 //
     /*  22637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22652 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22656 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22668 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22672 */     // MIs[2] Operand 1
     /*  22672 */     // No operand predicates
     /*  22672 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22680 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22682 */     // (or:{ *:[i32] } (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22689 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22707 */     GIR_RootConstrainSelectedInstOperands,
     /*  22708 */     // GIR_Coverage, 5473,
     /*  22708 */     GIR_EraseRootFromParent_Done,
     /*  22709 */   // Label 448: @22709
     /*  22709 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(22786), // Rule ID 5472 //
     /*  22714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22737 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22741 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, uint8_t(-1),
     /*  22745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  22749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22753 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22757 */     // MIs[2] Operand 1
     /*  22757 */     // No operand predicates
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22764 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22778 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22784 */     GIR_RootConstrainSelectedInstOperands,
     /*  22785 */     // GIR_Coverage, 5472,
     /*  22785 */     GIR_EraseRootFromParent_Done,
     /*  22786 */   // Label 449: @22786
     /*  22786 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(22863), // Rule ID 496 //
     /*  22791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  22826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  22830 */     // MIs[2] Operand 1
     /*  22830 */     // No operand predicates
     /*  22830 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22836 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] }))  =>  (t2ORNri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  22836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNri),
     /*  22839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  22846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22855 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22861 */     GIR_RootConstrainSelectedInstOperands,
     /*  22862 */     // GIR_Coverage, 496,
     /*  22862 */     GIR_EraseRootFromParent_Done,
     /*  22863 */   // Label 450: @22863
     /*  22863 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(22934), // Rule ID 5475 //
     /*  22868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22896 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22906 */     // (or:{ *:[i32] } (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }), rGPR:{ *:[i32] }:$Rn)  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  22913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22920 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22932 */     GIR_RootConstrainSelectedInstOperands,
     /*  22933 */     // GIR_Coverage, 5475,
     /*  22933 */     GIR_EraseRootFromParent_Done,
     /*  22934 */   // Label 451: @22934
     /*  22934 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(23005), // Rule ID 497 //
     /*  22939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  22942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22946 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  22954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  22958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  22962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  22966 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  22971 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  22975 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  22977 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (t2ORNrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  22977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORNrr),
     /*  22980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  22982 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  22984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  22988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  22991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  22997 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23003 */     GIR_RootConstrainSelectedInstOperands,
     /*  23004 */     // GIR_Coverage, 497,
     /*  23004 */     GIR_EraseRootFromParent_Done,
     /*  23005 */   // Label 452: @23005
     /*  23005 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(23060), // Rule ID 1845 //
     /*  23010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  23013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  23017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23021 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23032 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (MOVTi16:{ *:[i32] } GPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVTi16),
     /*  23035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23037 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23039 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23058 */     GIR_RootConstrainSelectedInstOperands,
     /*  23059 */     // GIR_Coverage, 1845,
     /*  23059 */     GIR_EraseRootFromParent_Done,
     /*  23060 */   // Label 453: @23060
     /*  23060 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(23115), // Rule ID 2091 //
     /*  23065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23076 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294901760),
     /*  23087 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$src, 4294901760:{ *:[i32] })  =>  (t2MOVTi16:{ *:[i32] } rGPR:{ *:[i32] }:$src, 65535:{ *:[i32] })
     /*  23087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVTi16),
     /*  23090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23092 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  23094 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(65535),
     /*  23104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23113 */     GIR_RootConstrainSelectedInstOperands,
     /*  23114 */     // GIR_Coverage, 2091,
     /*  23114 */     GIR_EraseRootFromParent_Done,
     /*  23115 */   // Label 454: @23115
     /*  23115 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(23172), // Rule ID 151 //
     /*  23120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23139 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  23143 */     // MIs[1] Operand 1
     /*  23143 */     // No operand predicates
     /*  23143 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23145 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (ORRri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRri),
     /*  23148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23150 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23170 */     GIR_RootConstrainSelectedInstOperands,
     /*  23171 */     // GIR_Coverage, 151,
     /*  23171 */     GIR_EraseRootFromParent_Done,
     /*  23172 */   // Label 455: @23172
     /*  23172 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(23229), // Rule ID 484 //
     /*  23177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  23196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  23200 */     // MIs[1] Operand 1
     /*  23200 */     // No operand predicates
     /*  23200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  23202 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2ORRri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  23202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRri),
     /*  23205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23209 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  23212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23227 */     GIR_RootConstrainSelectedInstOperands,
     /*  23228 */     // GIR_Coverage, 484,
     /*  23228 */     GIR_EraseRootFromParent_Done,
     /*  23229 */   // Label 456: @23229
     /*  23229 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(23275), // Rule ID 152 //
     /*  23234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  23237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  23249 */     // (or:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (ORRrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  23249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ORRrr),
     /*  23252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23267 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23273 */     GIR_RootConstrainSelectedInstOperands,
     /*  23274 */     // GIR_Coverage, 152,
     /*  23274 */     GIR_EraseRootFromParent_Done,
     /*  23275 */   // Label 457: @23275
     /*  23275 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(23321), // Rule ID 325 //
     /*  23280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  23283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  23295 */     // (or:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tORR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  23295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tORR),
     /*  23298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  23300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  23306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23319 */     GIR_RootConstrainSelectedInstOperands,
     /*  23320 */     // GIR_Coverage, 325,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 458: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(23367), // Rule ID 485 //
     /*  23326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  23329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23341 */     // (or:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ORRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  23341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  23346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  23348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  23350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23365 */     GIR_RootConstrainSelectedInstOperands,
     /*  23366 */     // GIR_Coverage, 485,
     /*  23366 */     GIR_EraseRootFromParent_Done,
     /*  23367 */   // Label 459: @23367
     /*  23367 */   GIM_Reject,
     /*  23368 */ // Label 414: @23368
     /*  23368 */ GIM_Reject,
     /*  23369 */ // Label 401: @23369
     /*  23369 */ GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(23415), // Rule ID 2529 //
     /*  23374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  23380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  23383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23395 */   // (or:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VORRd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  23395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23400 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23402 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23413 */   GIR_RootConstrainSelectedInstOperands,
     /*  23414 */   // GIR_Coverage, 2529,
     /*  23414 */   GIR_EraseRootFromParent_Done,
     /*  23415 */ // Label 460: @23415
     /*  23415 */ GIM_Reject,
     /*  23416 */ // Label 402: @23416
     /*  23416 */ GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(23533), // Rule ID 1831 //
     /*  23421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  23427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  23430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23442 */   // (or:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23442 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23445 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23449 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23454 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23458 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23463 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23466 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23470 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23475 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23479 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23484 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23487 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23491 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23496 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23499 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23502 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23505 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23511 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23527 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23532 */   // GIR_Coverage, 1831,
     /*  23532 */   GIR_EraseRootFromParent_Done,
     /*  23533 */ // Label 461: @23533
     /*  23533 */ GIM_Reject,
     /*  23534 */ // Label 403: @23534
     /*  23534 */ GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(23580), // Rule ID 1134 //
     /*  23539 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  23545 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  23548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23552 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23556 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23560 */   // (or:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VORRd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  23560 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23563 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23565 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23567 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23569 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23572 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23578 */   GIR_RootConstrainSelectedInstOperands,
     /*  23579 */   // GIR_Coverage, 1134,
     /*  23579 */   GIR_EraseRootFromParent_Done,
     /*  23580 */ // Label 462: @23580
     /*  23580 */ GIM_Reject,
     /*  23581 */ // Label 404: @23581
     /*  23581 */ GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(23694),
     /*  23586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  23589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  23592 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(23632), // Rule ID 2532 //
     /*  23597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23604 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23612 */     // (or:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VORRq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  23612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23617 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23619 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23630 */     GIR_RootConstrainSelectedInstOperands,
     /*  23631 */     // GIR_Coverage, 2532,
     /*  23631 */     GIR_EraseRootFromParent_Done,
     /*  23632 */   // Label 464: @23632
     /*  23632 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(23693), // Rule ID 3381 //
     /*  23637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23644 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23652 */     // (or:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VORR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  23652 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23655 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23659 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23669 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23676 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23682 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23688 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23691 */     GIR_RootConstrainSelectedInstOperands,
     /*  23692 */     // GIR_Coverage, 3381,
     /*  23692 */     GIR_EraseRootFromParent_Done,
     /*  23693 */   // Label 465: @23693
     /*  23693 */   GIM_Reject,
     /*  23694 */ // Label 463: @23694
     /*  23694 */ GIM_Reject,
     /*  23695 */ // Label 405: @23695
     /*  23695 */ GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(23812), // Rule ID 1832 //
     /*  23700 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23703 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  23706 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  23709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23713 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23717 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23721 */   // (or:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  23721 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  23724 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23728 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23733 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  23737 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23742 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  23745 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23749 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23754 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  23758 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  23763 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  23766 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  23770 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23775 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  23781 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  23784 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23790 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23796 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23801 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23803 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23811 */   // GIR_Coverage, 1832,
     /*  23811 */   GIR_EraseRootFromParent_Done,
     /*  23812 */ // Label 466: @23812
     /*  23812 */ GIM_Reject,
     /*  23813 */ // Label 406: @23813
     /*  23813 */ GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(23859), // Rule ID 2528 //
     /*  23818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  23824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  23827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23835 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  23839 */   // (or:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VORRd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  23839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  23842 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23844 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  23846 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  23848 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23851 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23857 */   GIR_RootConstrainSelectedInstOperands,
     /*  23858 */   // GIR_Coverage, 2528,
     /*  23858 */   GIR_EraseRootFromParent_Done,
     /*  23859 */ // Label 467: @23859
     /*  23859 */ GIM_Reject,
     /*  23860 */ // Label 407: @23860
     /*  23860 */ GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(23973),
     /*  23865 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  23868 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  23871 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(23911), // Rule ID 1135 //
     /*  23876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  23879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23883 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  23891 */     // (or:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VORRq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  23891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  23894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  23896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  23898 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  23900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  23903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23909 */     GIR_RootConstrainSelectedInstOperands,
     /*  23910 */     // GIR_Coverage, 1135,
     /*  23910 */     GIR_EraseRootFromParent_Done,
     /*  23911 */   // Label 469: @23911
     /*  23911 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(23972), // Rule ID 3377 //
     /*  23916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  23931 */     // (or:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VORR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  23931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  23934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  23946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  23948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  23950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  23952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  23955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  23967 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  23970 */     GIR_RootConstrainSelectedInstOperands,
     /*  23971 */     // GIR_Coverage, 3377,
     /*  23971 */     GIR_EraseRootFromParent_Done,
     /*  23972 */   // Label 470: @23972
     /*  23972 */   GIM_Reject,
     /*  23973 */ // Label 468: @23973
     /*  23973 */ GIM_Reject,
     /*  23974 */ // Label 408: @23974
     /*  23974 */ GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(24091), // Rule ID 1833 //
     /*  23979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  23982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  23985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  23988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  23996 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24000 */   // (or:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24000 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24003 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24007 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24012 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24016 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24021 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24024 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24028 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24033 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24037 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24042 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24045 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24049 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24054 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24057 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24060 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24063 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24069 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24082 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24090 */   // GIR_Coverage, 1833,
     /*  24090 */   GIR_EraseRootFromParent_Done,
     /*  24091 */ // Label 471: @24091
     /*  24091 */ GIM_Reject,
     /*  24092 */ // Label 409: @24092
     /*  24092 */ GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(24138), // Rule ID 2527 //
     /*  24097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  24118 */   // (or:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VORRd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  24118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRd),
     /*  24121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24123 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24125 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24136 */   GIR_RootConstrainSelectedInstOperands,
     /*  24137 */   // GIR_Coverage, 2527,
     /*  24137 */   GIR_EraseRootFromParent_Done,
     /*  24138 */ // Label 472: @24138
     /*  24138 */ GIM_Reject,
     /*  24139 */ // Label 410: @24139
     /*  24139 */ GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(24252),
     /*  24144 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24147 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  24150 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(24190), // Rule ID 2531 //
     /*  24155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24162 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24170 */     // (or:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VORRq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  24170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24175 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24177 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24179 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24188 */     GIR_RootConstrainSelectedInstOperands,
     /*  24189 */     // GIR_Coverage, 2531,
     /*  24189 */     GIR_EraseRootFromParent_Done,
     /*  24190 */   // Label 474: @24190
     /*  24190 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(24251), // Rule ID 3373 //
     /*  24195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24210 */     // (or:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VORR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  24210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24234 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24249 */     GIR_RootConstrainSelectedInstOperands,
     /*  24250 */     // GIR_Coverage, 3373,
     /*  24250 */     GIR_EraseRootFromParent_Done,
     /*  24251 */   // Label 475: @24251
     /*  24251 */   GIM_Reject,
     /*  24252 */ // Label 473: @24252
     /*  24252 */ GIM_Reject,
     /*  24253 */ // Label 411: @24253
     /*  24253 */ GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(24370), // Rule ID 1834 //
     /*  24258 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  24264 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  24267 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24271 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24275 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24279 */   // (or:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2ORRrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  24279 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  24282 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24286 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24291 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  24295 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24300 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  24303 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24307 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24312 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  24316 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24321 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  24324 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2ORRrr),
     /*  24328 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24333 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24336 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  24339 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  24342 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24348 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24354 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24359 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24361 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24364 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  24369 */   // GIR_Coverage, 1834,
     /*  24369 */   GIR_EraseRootFromParent_Done,
     /*  24370 */ // Label 476: @24370
     /*  24370 */ GIM_Reject,
     /*  24371 */ // Label 412: @24371
     /*  24371 */ GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(24484),
     /*  24376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  24379 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  24382 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(24422), // Rule ID 2530 //
     /*  24387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  24402 */     // (or:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VORRq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  24402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VORRq),
     /*  24405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  24407 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  24409 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  24411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24420 */     GIR_RootConstrainSelectedInstOperands,
     /*  24421 */     // GIR_Coverage, 2530,
     /*  24421 */     GIR_EraseRootFromParent_Done,
     /*  24422 */   // Label 478: @24422
     /*  24422 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(24483), // Rule ID 3369 //
     /*  24427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  24430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  24442 */     // (or:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VORR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  24442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  24445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VORR),
     /*  24457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  24459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  24461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  24463 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  24466 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  24481 */     GIR_RootConstrainSelectedInstOperands,
     /*  24482 */     // GIR_Coverage, 3369,
     /*  24482 */     GIR_EraseRootFromParent_Done,
     /*  24483 */   // Label 479: @24483
     /*  24483 */   GIM_Reject,
     /*  24484 */ // Label 477: @24484
     /*  24484 */ GIM_Reject,
     /*  24485 */ // Label 413: @24485
     /*  24485 */ GIM_Reject,
     /*  24486 */ // Label 7: @24486
     /*  24486 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 493*/ GIMT_Encode4(26180),
     /*  24497 */ /*GILLT_s32*//*Label 480*/ GIMT_Encode4(24557),
     /*  24501 */ /*GILLT_s64*//*Label 481*/ GIMT_Encode4(25064),
     /*  24505 */ /*GILLT_v2s1*//*Label 482*/ GIMT_Encode4(25111),
     /*  24509 */ /*GILLT_v2s32*//*Label 483*/ GIMT_Encode4(25229),
     /*  24513 */ /*GILLT_v2s64*//*Label 484*/ GIMT_Encode4(25276),
     /*  24517 */ /*GILLT_v4s1*//*Label 485*/ GIMT_Encode4(25390),
     /*  24521 */ /*GILLT_v4s16*//*Label 486*/ GIMT_Encode4(25508),
     /*  24525 */ /*GILLT_v4s32*//*Label 487*/ GIMT_Encode4(25555), GIMT_Encode4(0),
     /*  24533 */ /*GILLT_v8s1*//*Label 488*/ GIMT_Encode4(25669),
     /*  24537 */ /*GILLT_v8s8*//*Label 489*/ GIMT_Encode4(25787),
     /*  24541 */ /*GILLT_v8s16*//*Label 490*/ GIMT_Encode4(25834), GIMT_Encode4(0),
     /*  24549 */ /*GILLT_v16s1*//*Label 491*/ GIMT_Encode4(25948),
     /*  24553 */ /*GILLT_v16s8*//*Label 492*/ GIMT_Encode4(26066),
     /*  24557 */ // Label 480: @24557
     /*  24557 */ GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(25063),
     /*  24562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  24565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  24568 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(24623), // Rule ID 5477 //
     /*  24573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, uint8_t(-1),
     /*  24584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24592 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24596 */     // MIs[1] Operand 1
     /*  24596 */     // No operand predicates
     /*  24596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24598 */     // (xor:{ *:[i32] } -1:{ *:[i32] }, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24603 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24621 */     GIR_RootConstrainSelectedInstOperands,
     /*  24622 */     // GIR_Coverage, 5477,
     /*  24622 */     GIR_EraseRootFromParent_Done,
     /*  24623 */   // Label 495: @24623
     /*  24623 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(24678), // Rule ID 499 //
     /*  24628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24643 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24647 */     // MIs[1] Operand 1
     /*  24647 */     // No operand predicates
     /*  24647 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24651 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24653 */     // (xor:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm, -1:{ *:[i32] })  =>  (t2MVNi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  24653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /*  24656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24658 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24664 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24670 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24676 */     GIR_RootConstrainSelectedInstOperands,
     /*  24677 */     // GIR_Coverage, 499,
     /*  24677 */     GIR_EraseRootFromParent_Done,
     /*  24678 */   // Label 496: @24678
     /*  24678 */   GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(24722), // Rule ID 500 //
     /*  24683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24686 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24694 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24698 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (t2MVNr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /*  24698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MVNr),
     /*  24701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24703 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24705 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24720 */     GIR_RootConstrainSelectedInstOperands,
     /*  24721 */     // GIR_Coverage, 500,
     /*  24721 */     GIR_EraseRootFromParent_Done,
     /*  24722 */   // Label 497: @24722
     /*  24722 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(24766), // Rule ID 165 //
     /*  24727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24734 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24742 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rm, -1:{ *:[i32] })  =>  (MVNr:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /*  24742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNr),
     /*  24745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  24749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24758 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24764 */     GIR_RootConstrainSelectedInstOperands,
     /*  24765 */     // GIR_Coverage, 165,
     /*  24765 */     GIR_EraseRootFromParent_Done,
     /*  24766 */   // Label 498: @24766
     /*  24766 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(24810), // Rule ID 324 //
     /*  24771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24782 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  24786 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, -1:{ *:[i32] })  =>  (tMVN:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)
     /*  24786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMVN),
     /*  24789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  24797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24802 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24808 */     GIR_RootConstrainSelectedInstOperands,
     /*  24809 */     // GIR_Coverage, 324,
     /*  24809 */     GIR_EraseRootFromParent_Done,
     /*  24810 */   // Label 499: @24810
     /*  24810 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(24867), // Rule ID 155 //
     /*  24815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24834 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  24838 */     // MIs[1] Operand 1
     /*  24838 */     // No operand predicates
     /*  24838 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24840 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm)  =>  (EORri:{ *:[i32] } GPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORri),
     /*  24843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24865 */     GIR_RootConstrainSelectedInstOperands,
     /*  24866 */     // GIR_Coverage, 155,
     /*  24866 */     GIR_EraseRootFromParent_Done,
     /*  24867 */   // Label 500: @24867
     /*  24867 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(24924), // Rule ID 487 //
     /*  24872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  24875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  24883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  24895 */     // MIs[1] Operand 1
     /*  24895 */     // No operand predicates
     /*  24895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24897 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm)  =>  (t2EORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORri),
     /*  24900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  24907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24922 */     GIR_RootConstrainSelectedInstOperands,
     /*  24923 */     // GIR_Coverage, 487,
     /*  24923 */     GIR_EraseRootFromParent_Done,
     /*  24924 */   // Label 501: @24924
     /*  24924 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(24970), // Rule ID 156 //
     /*  24929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  24932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24936 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  24944 */     // (xor:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (EORrr:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  24944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::EORrr),
     /*  24947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  24949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  24951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  24953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  24956 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24962 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  24968 */     GIR_RootConstrainSelectedInstOperands,
     /*  24969 */     // GIR_Coverage, 156,
     /*  24969 */     GIR_EraseRootFromParent_Done,
     /*  24970 */   // Label 502: @24970
     /*  24970 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(25016), // Rule ID 317 //
     /*  24975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  24978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  24990 */     // (xor:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tEOR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /*  24990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tEOR),
     /*  24993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  24995 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  25001 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25008 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25014 */     GIR_RootConstrainSelectedInstOperands,
     /*  25015 */     // GIR_Coverage, 317,
     /*  25015 */     GIR_EraseRootFromParent_Done,
     /*  25016 */   // Label 503: @25016
     /*  25016 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(25062), // Rule ID 488 //
     /*  25021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  25024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25036 */     // (xor:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2EORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  25036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  25041 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  25043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  25045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25048 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25060 */     GIR_RootConstrainSelectedInstOperands,
     /*  25061 */     // GIR_Coverage, 488,
     /*  25061 */     GIR_EraseRootFromParent_Done,
     /*  25062 */   // Label 504: @25062
     /*  25062 */   GIM_Reject,
     /*  25063 */ // Label 494: @25063
     /*  25063 */ GIM_Reject,
     /*  25064 */ // Label 481: @25064
     /*  25064 */ GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(25110), // Rule ID 2535 //
     /*  25069 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25072 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  25075 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  25078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25086 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25090 */   // (xor:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)  =>  (VEORd:{ *:[v1i64] } DPR:{ *:[v1i64] }:$LHS, DPR:{ *:[v1i64] }:$RHS)
     /*  25090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25095 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25097 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25099 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25102 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25108 */   GIR_RootConstrainSelectedInstOperands,
     /*  25109 */   // GIR_Coverage, 2535,
     /*  25109 */   GIR_EraseRootFromParent_Done,
     /*  25110 */ // Label 505: @25110
     /*  25110 */ GIM_Reject,
     /*  25111 */ // Label 482: @25111
     /*  25111 */ GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(25228), // Rule ID 1827 //
     /*  25116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s1,
     /*  25122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s1,
     /*  25125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25129 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25133 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25137 */   // (xor:{ *:[v2i1] } VCCR:{ *:[v2i1] }:$p1, VCCR:{ *:[v2i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v2i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v2i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25137 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25140 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25144 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25149 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25158 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25161 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25165 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25170 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25174 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25191 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25194 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25197 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25200 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25206 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25212 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25214 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25217 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25219 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25222 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25227 */   // GIR_Coverage, 1827,
     /*  25227 */   GIR_EraseRootFromParent_Done,
     /*  25228 */ // Label 506: @25228
     /*  25228 */ GIM_Reject,
     /*  25229 */ // Label 483: @25229
     /*  25229 */ GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(25275), // Rule ID 1132 //
     /*  25234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  25240 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  25243 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25247 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25251 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25255 */   // (xor:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VEORd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  25255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25260 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25262 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25273 */   GIR_RootConstrainSelectedInstOperands,
     /*  25274 */   // GIR_Coverage, 1132,
     /*  25274 */   GIR_EraseRootFromParent_Done,
     /*  25275 */ // Label 507: @25275
     /*  25275 */ GIM_Reject,
     /*  25276 */ // Label 484: @25276
     /*  25276 */ GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(25389),
     /*  25281 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  25284 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  25287 */   GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(25327), // Rule ID 2538 //
     /*  25292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25299 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25303 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25307 */     // (xor:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)  =>  (VEORq:{ *:[v2i64] } QPR:{ *:[v2i64] }:$LHS, QPR:{ *:[v2i64] }:$RHS)
     /*  25307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25312 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25314 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25325 */     GIR_RootConstrainSelectedInstOperands,
     /*  25326 */     // GIR_Coverage, 2538,
     /*  25326 */     GIR_EraseRootFromParent_Done,
     /*  25327 */   // Label 509: @25327
     /*  25327 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(25388), // Rule ID 3395 //
     /*  25332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25347 */     // (xor:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)  =>  (MVE_VEOR:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$Qm, MQPR:{ *:[v2i64] }:$Qn)
     /*  25347 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25350 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25354 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25364 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25377 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25386 */     GIR_RootConstrainSelectedInstOperands,
     /*  25387 */     // GIR_Coverage, 3395,
     /*  25387 */     GIR_EraseRootFromParent_Done,
     /*  25388 */   // Label 510: @25388
     /*  25388 */   GIM_Reject,
     /*  25389 */ // Label 508: @25389
     /*  25389 */ GIM_Reject,
     /*  25390 */ // Label 485: @25390
     /*  25390 */ GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(25507), // Rule ID 1828 //
     /*  25395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s1,
     /*  25401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s1,
     /*  25404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25412 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25416 */   // (xor:{ *:[v4i1] } VCCR:{ *:[v4i1] }:$p1, VCCR:{ *:[v4i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v4i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v4i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25416 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25419 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25423 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25428 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25432 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25437 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25440 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25444 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25449 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25453 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25458 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25461 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25465 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25470 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25473 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25476 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25479 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25485 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25491 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25498 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25506 */   // GIR_Coverage, 1828,
     /*  25506 */   GIR_EraseRootFromParent_Done,
     /*  25507 */ // Label 511: @25507
     /*  25507 */ GIM_Reject,
     /*  25508 */ // Label 486: @25508
     /*  25508 */ GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(25554), // Rule ID 2534 //
     /*  25513 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25516 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25519 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25530 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25534 */   // (xor:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)  =>  (VEORd:{ *:[v4i16] } DPR:{ *:[v4i16] }:$LHS, DPR:{ *:[v4i16] }:$RHS)
     /*  25534 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25537 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25539 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25541 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25543 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25546 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25552 */   GIR_RootConstrainSelectedInstOperands,
     /*  25553 */   // GIR_Coverage, 2534,
     /*  25553 */   GIR_EraseRootFromParent_Done,
     /*  25554 */ // Label 512: @25554
     /*  25554 */ GIM_Reject,
     /*  25555 */ // Label 487: @25555
     /*  25555 */ GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(25668),
     /*  25560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25563 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25566 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(25606), // Rule ID 1133 //
     /*  25571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25582 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25586 */     // (xor:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VEORq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  25586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  25593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  25595 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25598 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25604 */     GIR_RootConstrainSelectedInstOperands,
     /*  25605 */     // GIR_Coverage, 1133,
     /*  25605 */     GIR_EraseRootFromParent_Done,
     /*  25606 */   // Label 514: @25606
     /*  25606 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(25667), // Rule ID 3391 //
     /*  25611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25626 */     // (xor:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VEOR:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  25626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25665 */     GIR_RootConstrainSelectedInstOperands,
     /*  25666 */     // GIR_Coverage, 3391,
     /*  25666 */     GIR_EraseRootFromParent_Done,
     /*  25667 */   // Label 515: @25667
     /*  25667 */   GIM_Reject,
     /*  25668 */ // Label 513: @25668
     /*  25668 */ GIM_Reject,
     /*  25669 */ // Label 488: @25669
     /*  25669 */ GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(25786), // Rule ID 1829 //
     /*  25674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s1,
     /*  25680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s1,
     /*  25683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25687 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25691 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25695 */   // (xor:{ *:[v8i1] } VCCR:{ *:[v8i1] }:$p1, VCCR:{ *:[v8i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v8i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v8i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25695 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25698 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25702 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25707 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25711 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25728 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  25732 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25737 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  25740 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  25744 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25749 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  25752 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  25755 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  25758 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25764 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  25772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25775 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25780 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25785 */   // GIR_Coverage, 1829,
     /*  25785 */   GIR_EraseRootFromParent_Done,
     /*  25786 */ // Label 516: @25786
     /*  25786 */ GIM_Reject,
     /*  25787 */ // Label 489: @25787
     /*  25787 */ GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(25833), // Rule ID 2533 //
     /*  25792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  25801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25805 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25809 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  25813 */   // (xor:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)  =>  (VEORd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$LHS, DPR:{ *:[v8i8] }:$RHS)
     /*  25813 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORd),
     /*  25816 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25818 */   GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25820 */   GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25822 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25825 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25831 */   GIR_RootConstrainSelectedInstOperands,
     /*  25832 */   // GIR_Coverage, 2533,
     /*  25832 */   GIR_EraseRootFromParent_Done,
     /*  25833 */ // Label 517: @25833
     /*  25833 */ GIM_Reject,
     /*  25834 */ // Label 490: @25834
     /*  25834 */ GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(25947),
     /*  25839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  25845 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(25885), // Rule ID 2537 //
     /*  25850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  25865 */     // (xor:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)  =>  (VEORq:{ *:[v8i16] } QPR:{ *:[v8i16] }:$LHS, QPR:{ *:[v8i16] }:$RHS)
     /*  25865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  25868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  25870 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  25872 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  25874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  25877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25883 */     GIR_RootConstrainSelectedInstOperands,
     /*  25884 */     // GIR_Coverage, 2537,
     /*  25884 */     GIR_EraseRootFromParent_Done,
     /*  25885 */   // Label 519: @25885
     /*  25885 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(25946), // Rule ID 3387 //
     /*  25890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  25905 */     // (xor:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VEOR:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  25905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  25908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  25912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  25920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  25922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  25924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  25926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  25929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  25941 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  25944 */     GIR_RootConstrainSelectedInstOperands,
     /*  25945 */     // GIR_Coverage, 3387,
     /*  25945 */     GIR_EraseRootFromParent_Done,
     /*  25946 */   // Label 520: @25946
     /*  25946 */   GIM_Reject,
     /*  25947 */ // Label 518: @25947
     /*  25947 */ GIM_Reject,
     /*  25948 */ // Label 491: @25948
     /*  25948 */ GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(26065), // Rule ID 1830 //
     /*  25953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  25956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s1,
     /*  25959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s1,
     /*  25962 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25966 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25970 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  25974 */   // (xor:{ *:[v16i1] } VCCR:{ *:[v16i1] }:$p1, VCCR:{ *:[v16i1] }:$p2)  =>  (COPY_TO_REGCLASS:{ *:[v16i1] } (t2EORrr:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p1, rGPR:{ *:[i32] }), (COPY_TO_REGCLASS:{ *:[i32] } VCCR:{ *:[v16i1] }:$p2, rGPR:{ *:[i32] })), VCCR:{ *:[i32] })
     /*  25974 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /*  25977 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  25981 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  25986 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // p2
     /*  25990 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  25995 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  25998 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26002 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26007 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // p1
     /*  26011 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  26016 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  26019 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2EORrr),
     /*  26023 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26028 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  26031 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /*  26034 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26037 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26043 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26056 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::VCCRRegClassID),
     /*  26064 */   // GIR_Coverage, 1830,
     /*  26064 */   GIR_EraseRootFromParent_Done,
     /*  26065 */ // Label 521: @26065
     /*  26065 */ GIM_Reject,
     /*  26066 */ // Label 492: @26066
     /*  26066 */ GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(26179),
     /*  26071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  26074 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  26077 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(26117), // Rule ID 2536 //
     /*  26082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26089 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26097 */     // (xor:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)  =>  (VEORq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$LHS, QPR:{ *:[v16i8] }:$RHS)
     /*  26097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VEORq),
     /*  26100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  26102 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  26104 */     GIR_RootToRootCopy, /*OpIdx*/2, // RHS
     /*  26106 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26115 */     GIR_RootConstrainSelectedInstOperands,
     /*  26116 */     // GIR_Coverage, 2536,
     /*  26116 */     GIR_EraseRootFromParent_Done,
     /*  26117 */   // Label 523: @26117
     /*  26117 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(26178), // Rule ID 3383 //
     /*  26122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  26125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  26137 */     // (xor:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VEOR:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  26137 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  26140 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  26144 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VEOR),
     /*  26152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  26154 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /*  26156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  26158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  26161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  26176 */     GIR_RootConstrainSelectedInstOperands,
     /*  26177 */     // GIR_Coverage, 3383,
     /*  26177 */     GIR_EraseRootFromParent_Done,
     /*  26178 */   // Label 524: @26178
     /*  26178 */   GIM_Reject,
     /*  26179 */ // Label 522: @26179
     /*  26179 */ GIM_Reject,
     /*  26180 */ // Label 493: @26180
     /*  26180 */ GIM_Reject,
     /*  26181 */ // Label 8: @26181
     /*  26181 */ GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(26567),
     /*  26186 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  26189 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(16), /*)*//*default:*//*Label 530*/ GIMT_Encode4(26566),
     /*  26200 */   /*GILLT_v2s64*//*Label 526*/ GIMT_Encode4(26244), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26212 */   /*GILLT_v4s32*//*Label 527*/ GIMT_Encode4(26302), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26228 */   /*GILLT_v8s16*//*Label 528*/ GIMT_Encode4(26405), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26240 */   /*GILLT_v16s8*//*Label 529*/ GIMT_Encode4(26508),
     /*  26244 */   // Label 526: @26244
     /*  26244 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(26301), // Rule ID 3021 //
     /*  26249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26252 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  26258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26270 */     // (concat_vectors:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Dn, DPR:{ *:[v1i64] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v2i64] } QPR:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v1i64] }:$Dm, dsub_1:{ *:[i32] })
     /*  26270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26277 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26282 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26285 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26300 */     // GIR_Coverage, 3021,
     /*  26300 */     GIR_EraseRootFromParent_Done,
     /*  26301 */   // Label 531: @26301
     /*  26301 */   GIM_Reject,
     /*  26302 */   // Label 527: @26302
     /*  26302 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(26404),
     /*  26307 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  26313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26325 */     GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(26364), // Rule ID 3022 //
     /*  26330 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26333 */       // (concat_vectors:{ *:[v4i32] } DPR:{ *:[v2i32] }:$Dn, DPR:{ *:[v2i32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4i32] } QPR:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2i32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26340 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26343 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26345 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26348 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26353 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26358 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26363 */       // GIR_Coverage, 3022,
     /*  26363 */       GIR_EraseRootFromParent_Done,
     /*  26364 */     // Label 533: @26364
     /*  26364 */     GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(26403), // Rule ID 3025 //
     /*  26369 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26372 */       // (concat_vectors:{ *:[v4f32] } DPR:{ *:[v2f32] }:$Dn, DPR:{ *:[v2f32] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v4f32] } QPR:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v2f32] }:$Dm, dsub_1:{ *:[i32] })
     /*  26372 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26375 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26377 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26379 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26382 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26384 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26387 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26392 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26397 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26402 */       // GIR_Coverage, 3025,
     /*  26402 */       GIR_EraseRootFromParent_Done,
     /*  26403 */     // Label 534: @26403
     /*  26403 */     GIM_Reject,
     /*  26404 */   // Label 532: @26404
     /*  26404 */   GIM_Reject,
     /*  26405 */   // Label 528: @26405
     /*  26405 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(26507),
     /*  26410 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26428 */     GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(26467), // Rule ID 3023 //
     /*  26433 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26436 */       // (concat_vectors:{ *:[v8i16] } DPR:{ *:[v4i16] }:$Dn, DPR:{ *:[v4i16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8i16] } QPR:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4i16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26436 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26439 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26441 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26443 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26446 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26448 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26451 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26456 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26461 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26466 */       // GIR_Coverage, 3023,
     /*  26466 */       GIR_EraseRootFromParent_Done,
     /*  26467 */     // Label 536: @26467
     /*  26467 */     GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(26506), // Rule ID 3026 //
     /*  26472 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26475 */       // (concat_vectors:{ *:[v8f16] } DPR:{ *:[v4f16] }:$Dn, DPR:{ *:[v4f16] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v8f16] } QPR:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v4f16] }:$Dm, dsub_1:{ *:[i32] })
     /*  26475 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26478 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26480 */       GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26482 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26485 */       GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26487 */       GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26490 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26495 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26500 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26505 */       // GIR_Coverage, 3026,
     /*  26505 */       GIR_EraseRootFromParent_Done,
     /*  26506 */     // Label 537: @26506
     /*  26506 */     GIM_Reject,
     /*  26507 */   // Label 535: @26507
     /*  26507 */   GIM_Reject,
     /*  26508 */   // Label 529: @26508
     /*  26508 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(26565), // Rule ID 3024 //
     /*  26513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26516 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  26522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  26526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26534 */     // (concat_vectors:{ *:[v16i8] } DPR:{ *:[v8i8] }:$Dn, DPR:{ *:[v8i8] }:$Dm)  =>  (REG_SEQUENCE:{ *:[v16i8] } QPR:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dn, dsub_0:{ *:[i32] }, DPR:{ *:[v8i8] }:$Dm, dsub_1:{ *:[i32] })
     /*  26534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  26537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /*  26541 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/1,
     /*  26544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  26546 */     GIR_AddImm8, /*InsnID*/0, /*SubRegIndex*/2,
     /*  26549 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  26554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26564 */     // GIR_Coverage, 3024,
     /*  26564 */     GIR_EraseRootFromParent_Done,
     /*  26565 */   // Label 538: @26565
     /*  26565 */   GIM_Reject,
     /*  26566 */   // Label 530: @26566
     /*  26566 */   GIM_Reject,
     /*  26567 */ // Label 525: @26567
     /*  26567 */ GIM_Reject,
     /*  26568 */ // Label 9: @26568
     /*  26568 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 548*/ GIMT_Encode4(35579),
     /*  26579 */ /*GILLT_s32*//*Label 539*/ GIMT_Encode4(26639),
     /*  26583 */ /*GILLT_s64*//*Label 540*/ GIMT_Encode4(26787), GIMT_Encode4(0),
     /*  26591 */ /*GILLT_v2s32*//*Label 541*/ GIMT_Encode4(27542),
     /*  26595 */ /*GILLT_v2s64*//*Label 542*/ GIMT_Encode4(28297), GIMT_Encode4(0),
     /*  26603 */ /*GILLT_v4s16*//*Label 543*/ GIMT_Encode4(30016),
     /*  26607 */ /*GILLT_v4s32*//*Label 544*/ GIMT_Encode4(30771), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26619 */ /*GILLT_v8s8*//*Label 545*/ GIMT_Encode4(32490),
     /*  26623 */ /*GILLT_v8s16*//*Label 546*/ GIMT_Encode4(32905), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  26635 */ /*GILLT_v16s8*//*Label 547*/ GIMT_Encode4(34624),
     /*  26639 */ // Label 539: @26639
     /*  26639 */ GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(26786),
     /*  26644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  26647 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(26681), // Rule ID 689 //
     /*  26652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  26655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26663 */     // (bitconvert:{ *:[i32] } SPR:{ *:[f32] }:$Sn)  =>  (VMOVRS:{ *:[i32] } SPR:{ *:[f32] }:$Sn)
     /*  26663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVRS),
     /*  26666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  26668 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /*  26670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26679 */     GIR_RootConstrainSelectedInstOperands,
     /*  26680 */     // GIR_Coverage, 689,
     /*  26680 */     GIR_EraseRootFromParent_Done,
     /*  26681 */   // Label 550: @26681
     /*  26681 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(26715), // Rule ID 690 //
     /*  26686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_UseVMOVSR),
     /*  26689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26693 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26697 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$Rt)  =>  (VMOVSR:{ *:[f32] } GPR:{ *:[i32] }:$Rt)
     /*  26697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVSR),
     /*  26700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sn]
     /*  26702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  26704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  26707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26713 */     GIR_RootConstrainSelectedInstOperands,
     /*  26714 */     // GIR_Coverage, 690,
     /*  26714 */     GIR_EraseRootFromParent_Done,
     /*  26715 */   // Label 551: @26715
     /*  26715 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(26785), // Rule ID 2715 //
     /*  26720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseVMOVSR_HasNEON),
     /*  26723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  26727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  26731 */     // (bitconvert:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VMOVDRR:{ *:[f64] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$a), ssub_0:{ *:[i32] })
     /*  26731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  26734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VMOVDRR),
     /*  26738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  26743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26747 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /*  26751 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  26754 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  26760 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  26762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26767 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  26774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  26779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /*  26784 */     // GIR_Coverage, 2715,
     /*  26784 */     GIR_EraseRootFromParent_Done,
     /*  26785 */   // Label 552: @26785
     /*  26785 */   GIM_Reject,
     /*  26786 */ // Label 549: @26786
     /*  26786 */ GIM_Reject,
     /*  26787 */ // Label 540: @26787
     /*  26787 */ GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(26819), // Rule ID 2717 //
     /*  26792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26806 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26818 */   // GIR_Coverage, 2717,
     /*  26818 */   GIR_EraseRootFromParent_Done,
     /*  26819 */ // Label 553: @26819
     /*  26819 */ GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(26851), // Rule ID 2718 //
     /*  26824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  26830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26838 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  26838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26850 */   // GIR_Coverage, 2718,
     /*  26850 */   GIR_EraseRootFromParent_Done,
     /*  26851 */ // Label 554: @26851
     /*  26851 */ GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(26883), // Rule ID 2729 //
     /*  26856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26870 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26882 */   // GIR_Coverage, 2729,
     /*  26882 */   GIR_EraseRootFromParent_Done,
     /*  26883 */ // Label 555: @26883
     /*  26883 */ GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(26915), // Rule ID 2730 //
     /*  26888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  26894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26902 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26914 */   // GIR_Coverage, 2730,
     /*  26914 */   GIR_EraseRootFromParent_Done,
     /*  26915 */ // Label 556: @26915
     /*  26915 */ GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(26947), // Rule ID 2731 //
     /*  26920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26934 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26946 */   // GIR_Coverage, 2731,
     /*  26946 */   GIR_EraseRootFromParent_Done,
     /*  26947 */ // Label 557: @26947
     /*  26947 */ GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(26979), // Rule ID 2732 //
     /*  26952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26966 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  26969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  26971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  26973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  26978 */   // GIR_Coverage, 2732,
     /*  26978 */   GIR_EraseRootFromParent_Done,
     /*  26979 */ // Label 558: @26979
     /*  26979 */ GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(27011), // Rule ID 2733 //
     /*  26984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  26987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  26990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  26998 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[f64] }:$src
     /*  26998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27010 */   // GIR_Coverage, 2733,
     /*  27010 */   GIR_EraseRootFromParent_Done,
     /*  27011 */ // Label 559: @27011
     /*  27011 */ GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(27043), // Rule ID 2734 //
     /*  27016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27030 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27042 */   // GIR_Coverage, 2734,
     /*  27042 */   GIR_EraseRootFromParent_Done,
     /*  27043 */ // Label 560: @27043
     /*  27043 */ GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(27075), // Rule ID 2735 //
     /*  27048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27062 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27062 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27065 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27067 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27069 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27074 */   // GIR_Coverage, 2735,
     /*  27074 */   GIR_EraseRootFromParent_Done,
     /*  27075 */ // Label 561: @27075
     /*  27075 */ GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(27107), // Rule ID 2736 //
     /*  27080 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27090 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27094 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27097 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27099 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27106 */   // GIR_Coverage, 2736,
     /*  27106 */   GIR_EraseRootFromParent_Done,
     /*  27107 */ // Label 562: @27107
     /*  27107 */ GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(27139), // Rule ID 2737 //
     /*  27112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27126 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27129 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27131 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27133 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27138 */   // GIR_Coverage, 2737,
     /*  27138 */   GIR_EraseRootFromParent_Done,
     /*  27139 */ // Label 563: @27139
     /*  27139 */ GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(27171), // Rule ID 2738 //
     /*  27144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27154 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27158 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v1i64] }:$src
     /*  27158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27161 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27163 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27170 */   // GIR_Coverage, 2738,
     /*  27170 */   GIR_EraseRootFromParent_Done,
     /*  27171 */ // Label 564: @27171
     /*  27171 */ GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(27208), // Rule ID 2801 //
     /*  27176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27190 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2f32] }:$src)
     /*  27190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27206 */   GIR_RootConstrainSelectedInstOperands,
     /*  27207 */   // GIR_Coverage, 2801,
     /*  27207 */   GIR_EraseRootFromParent_Done,
     /*  27208 */ // Label 565: @27208
     /*  27208 */ GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(27245), // Rule ID 2802 //
     /*  27213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27227 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[f64] } DPR:{ *:[v2i32] }:$src)
     /*  27227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27230 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27234 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27237 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27243 */   GIR_RootConstrainSelectedInstOperands,
     /*  27244 */   // GIR_Coverage, 2802,
     /*  27244 */   GIR_EraseRootFromParent_Done,
     /*  27245 */ // Label 566: @27245
     /*  27245 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(27282), // Rule ID 2803 //
     /*  27250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27264 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4f16] }:$src)
     /*  27264 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27267 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27269 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27271 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27274 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27280 */   GIR_RootConstrainSelectedInstOperands,
     /*  27281 */   // GIR_Coverage, 2803,
     /*  27281 */   GIR_EraseRootFromParent_Done,
     /*  27282 */ // Label 567: @27282
     /*  27282 */ GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(27319), // Rule ID 2804 //
     /*  27287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27301 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[f64] } DPR:{ *:[v4i16] }:$src)
     /*  27301 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27304 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27306 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27308 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27311 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27317 */   GIR_RootConstrainSelectedInstOperands,
     /*  27318 */   // GIR_Coverage, 2804,
     /*  27318 */   GIR_EraseRootFromParent_Done,
     /*  27319 */ // Label 568: @27319
     /*  27319 */ GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(27356), // Rule ID 2805 //
     /*  27324 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27327 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27334 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27338 */   // (bitconvert:{ *:[f64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[f64] } DPR:{ *:[v8i8] }:$src)
     /*  27338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27343 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27345 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27348 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27354 */   GIR_RootConstrainSelectedInstOperands,
     /*  27355 */   // GIR_Coverage, 2805,
     /*  27355 */   GIR_EraseRootFromParent_Done,
     /*  27356 */ // Label 569: @27356
     /*  27356 */ GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(27393), // Rule ID 2806 //
     /*  27361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27375 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2f32] }:$src)
     /*  27375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27380 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27391 */   GIR_RootConstrainSelectedInstOperands,
     /*  27392 */   // GIR_Coverage, 2806,
     /*  27392 */   GIR_EraseRootFromParent_Done,
     /*  27393 */ // Label 570: @27393
     /*  27393 */ GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(27430), // Rule ID 2807 //
     /*  27398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27412 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)  =>  (VREV64d32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$src)
     /*  27412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27419 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27422 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27428 */   GIR_RootConstrainSelectedInstOperands,
     /*  27429 */   // GIR_Coverage, 2807,
     /*  27429 */   GIR_EraseRootFromParent_Done,
     /*  27430 */ // Label 571: @27430
     /*  27430 */ GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(27467), // Rule ID 2808 //
     /*  27435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27449 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4f16] }:$src)
     /*  27449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27454 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27456 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27459 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27465 */   GIR_RootConstrainSelectedInstOperands,
     /*  27466 */   // GIR_Coverage, 2808,
     /*  27466 */   GIR_EraseRootFromParent_Done,
     /*  27467 */ // Label 572: @27467
     /*  27467 */ GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(27504), // Rule ID 2809 //
     /*  27472 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27482 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27486 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)  =>  (VREV64d16:{ *:[v1i64] } DPR:{ *:[v4i16] }:$src)
     /*  27486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  27489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27491 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27493 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27502 */   GIR_RootConstrainSelectedInstOperands,
     /*  27503 */   // GIR_Coverage, 2809,
     /*  27503 */   GIR_EraseRootFromParent_Done,
     /*  27504 */ // Label 573: @27504
     /*  27504 */ GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(27541), // Rule ID 2810 //
     /*  27509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27523 */   // (bitconvert:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)  =>  (VREV64d8:{ *:[v1i64] } DPR:{ *:[v8i8] }:$src)
     /*  27523 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  27526 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27528 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27533 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27539 */   GIR_RootConstrainSelectedInstOperands,
     /*  27540 */   // GIR_Coverage, 2810,
     /*  27540 */   GIR_EraseRootFromParent_Done,
     /*  27541 */ // Label 574: @27541
     /*  27541 */ GIM_Reject,
     /*  27542 */ // Label 541: @27542
     /*  27542 */ GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(27574), // Rule ID 2719 //
     /*  27547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27557 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27561 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27561 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27564 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27566 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27573 */   // GIR_Coverage, 2719,
     /*  27573 */   GIR_EraseRootFromParent_Done,
     /*  27574 */ // Label 575: @27574
     /*  27574 */ GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(27606), // Rule ID 2720 //
     /*  27579 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  27585 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27589 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27593 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27593 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27596 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27598 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27600 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27605 */   // GIR_Coverage, 2720,
     /*  27605 */   GIR_EraseRootFromParent_Done,
     /*  27606 */ // Label 576: @27606
     /*  27606 */ GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(27638), // Rule ID 2739 //
     /*  27611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27621 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27625 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27625 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27628 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27630 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27632 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27637 */   // GIR_Coverage, 2739,
     /*  27637 */   GIR_EraseRootFromParent_Done,
     /*  27638 */ // Label 577: @27638
     /*  27638 */ GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(27670), // Rule ID 2740 //
     /*  27643 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27646 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27649 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27653 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27657 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27657 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27660 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27662 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27664 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27669 */   // GIR_Coverage, 2740,
     /*  27669 */   GIR_EraseRootFromParent_Done,
     /*  27670 */ // Label 578: @27670
     /*  27670 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(27702), // Rule ID 2741 //
     /*  27675 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27685 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27689 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27692 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27694 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27696 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27701 */   // GIR_Coverage, 2741,
     /*  27701 */   GIR_EraseRootFromParent_Done,
     /*  27702 */ // Label 579: @27702
     /*  27702 */ GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(27734), // Rule ID 2742 //
     /*  27707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27721 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27724 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27726 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27728 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27733 */   // GIR_Coverage, 2742,
     /*  27733 */   GIR_EraseRootFromParent_Done,
     /*  27734 */ // Label 580: @27734
     /*  27734 */ GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(27766), // Rule ID 2743 //
     /*  27739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27753 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2f32] }:$src
     /*  27753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27756 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27758 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27760 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27765 */   // GIR_Coverage, 2743,
     /*  27765 */   GIR_EraseRootFromParent_Done,
     /*  27766 */ // Label 581: @27766
     /*  27766 */ GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(27798), // Rule ID 2744 //
     /*  27771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27785 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27788 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27790 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27797 */   // GIR_Coverage, 2744,
     /*  27797 */   GIR_EraseRootFromParent_Done,
     /*  27798 */ // Label 582: @27798
     /*  27798 */ GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(27830), // Rule ID 2745 //
     /*  27803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27817 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27817 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27820 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27822 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27824 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27829 */   // GIR_Coverage, 2745,
     /*  27829 */   GIR_EraseRootFromParent_Done,
     /*  27830 */ // Label 583: @27830
     /*  27830 */ GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(27862), // Rule ID 2746 //
     /*  27835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27849 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27852 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27856 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27861 */   // GIR_Coverage, 2746,
     /*  27861 */   GIR_EraseRootFromParent_Done,
     /*  27862 */ // Label 584: @27862
     /*  27862 */ GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(27894), // Rule ID 2747 //
     /*  27867 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27870 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27873 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27877 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27881 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27884 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27886 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27888 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27893 */   // GIR_Coverage, 2747,
     /*  27893 */   GIR_EraseRootFromParent_Done,
     /*  27894 */ // Label 585: @27894
     /*  27894 */ GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(27926), // Rule ID 2748 //
     /*  27899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  27902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  27905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27913 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v2i32] }:$src
     /*  27913 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  27916 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  27918 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  27925 */   // GIR_Coverage, 2748,
     /*  27925 */   GIR_EraseRootFromParent_Done,
     /*  27926 */ // Label 586: @27926
     /*  27926 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(27963), // Rule ID 2811 //
     /*  27931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27945 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[f64] }:$src)
     /*  27945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27950 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27952 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27955 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27961 */   GIR_RootConstrainSelectedInstOperands,
     /*  27962 */   // GIR_Coverage, 2811,
     /*  27962 */   GIR_EraseRootFromParent_Done,
     /*  27963 */ // Label 587: @27963
     /*  27963 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(28000), // Rule ID 2812 //
     /*  27968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  27971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  27974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  27982 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2f32] } DPR:{ *:[v1i64] }:$src)
     /*  27982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  27985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  27987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  27989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  27992 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  27998 */   GIR_RootConstrainSelectedInstOperands,
     /*  27999 */   // GIR_Coverage, 2812,
     /*  27999 */   GIR_EraseRootFromParent_Done,
     /*  28000 */ // Label 588: @28000
     /*  28000 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(28037), // Rule ID 2813 //
     /*  28005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28015 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28019 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4f16] }:$src)
     /*  28019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28024 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28026 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28029 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28035 */   GIR_RootConstrainSelectedInstOperands,
     /*  28036 */   // GIR_Coverage, 2813,
     /*  28036 */   GIR_EraseRootFromParent_Done,
     /*  28037 */ // Label 589: @28037
     /*  28037 */ GIM_Try, /*On fail goto*//*Label 590*/ GIMT_Encode4(28074), // Rule ID 2814 //
     /*  28042 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28056 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2f32] } DPR:{ *:[v4i16] }:$src)
     /*  28056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28072 */   GIR_RootConstrainSelectedInstOperands,
     /*  28073 */   // GIR_Coverage, 2814,
     /*  28073 */   GIR_EraseRootFromParent_Done,
     /*  28074 */ // Label 590: @28074
     /*  28074 */ GIM_Try, /*On fail goto*//*Label 591*/ GIMT_Encode4(28111), // Rule ID 2815 //
     /*  28079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28093 */   // (bitconvert:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2f32] } DPR:{ *:[v8i8] }:$src)
     /*  28093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28098 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28100 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28103 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28109 */   GIR_RootConstrainSelectedInstOperands,
     /*  28110 */   // GIR_Coverage, 2815,
     /*  28110 */   GIR_EraseRootFromParent_Done,
     /*  28111 */ // Label 591: @28111
     /*  28111 */ GIM_Try, /*On fail goto*//*Label 592*/ GIMT_Encode4(28148), // Rule ID 2816 //
     /*  28116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28130 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[f64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[f64] }:$src)
     /*  28130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28133 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28137 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28140 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28146 */   GIR_RootConstrainSelectedInstOperands,
     /*  28147 */   // GIR_Coverage, 2816,
     /*  28147 */   GIR_EraseRootFromParent_Done,
     /*  28148 */ // Label 592: @28148
     /*  28148 */ GIM_Try, /*On fail goto*//*Label 593*/ GIMT_Encode4(28185), // Rule ID 2817 //
     /*  28153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  28159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28167 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d32:{ *:[v2i32] } DPR:{ *:[v1i64] }:$src)
     /*  28167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d32),
     /*  28170 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28183 */   GIR_RootConstrainSelectedInstOperands,
     /*  28184 */   // GIR_Coverage, 2817,
     /*  28184 */   GIR_EraseRootFromParent_Done,
     /*  28185 */ // Label 593: @28185
     /*  28185 */ GIM_Try, /*On fail goto*//*Label 594*/ GIMT_Encode4(28222), // Rule ID 2818 //
     /*  28190 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28193 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28196 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28204 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4f16] }:$src)
     /*  28204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28209 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28211 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28214 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28220 */   GIR_RootConstrainSelectedInstOperands,
     /*  28221 */   // GIR_Coverage, 2818,
     /*  28221 */   GIR_EraseRootFromParent_Done,
     /*  28222 */ // Label 594: @28222
     /*  28222 */ GIM_Try, /*On fail goto*//*Label 595*/ GIMT_Encode4(28259), // Rule ID 2819 //
     /*  28227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28241 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)  =>  (VREV32d16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$src)
     /*  28241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  28244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28246 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28248 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28251 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28257 */   GIR_RootConstrainSelectedInstOperands,
     /*  28258 */   // GIR_Coverage, 2819,
     /*  28258 */   GIR_EraseRootFromParent_Done,
     /*  28259 */ // Label 595: @28259
     /*  28259 */ GIM_Try, /*On fail goto*//*Label 596*/ GIMT_Encode4(28296), // Rule ID 2820 //
     /*  28264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  28270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  28278 */   // (bitconvert:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)  =>  (VREV32d8:{ *:[v2i32] } DPR:{ *:[v8i8] }:$src)
     /*  28278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  28281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28283 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28285 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28288 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28294 */   GIR_RootConstrainSelectedInstOperands,
     /*  28295 */   // GIR_Coverage, 2820,
     /*  28295 */   GIR_EraseRootFromParent_Done,
     /*  28296 */ // Label 596: @28296
     /*  28296 */ GIM_Reject,
     /*  28297 */ // Label 542: @28297
     /*  28297 */ GIM_Try, /*On fail goto*//*Label 597*/ GIMT_Encode4(28329), // Rule ID 2723 //
     /*  28302 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28312 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28316 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28316 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28319 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28321 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28323 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28328 */   // GIR_Coverage, 2723,
     /*  28328 */   GIR_EraseRootFromParent_Done,
     /*  28329 */ // Label 597: @28329
     /*  28329 */ GIM_Try, /*On fail goto*//*Label 598*/ GIMT_Encode4(28361), // Rule ID 2724 //
     /*  28334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  28340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28348 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28351 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28353 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28360 */   // GIR_Coverage, 2724,
     /*  28360 */   GIR_EraseRootFromParent_Done,
     /*  28361 */ // Label 598: @28361
     /*  28361 */ GIM_Try, /*On fail goto*//*Label 599*/ GIMT_Encode4(28393), // Rule ID 2765 //
     /*  28366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28372 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28376 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28380 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28380 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28383 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28385 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28387 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28392 */   // GIR_Coverage, 2765,
     /*  28392 */   GIR_EraseRootFromParent_Done,
     /*  28393 */ // Label 599: @28393
     /*  28393 */ GIM_Try, /*On fail goto*//*Label 600*/ GIMT_Encode4(28425), // Rule ID 2766 //
     /*  28398 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28401 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28408 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28412 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28415 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28417 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28419 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28424 */   // GIR_Coverage, 2766,
     /*  28424 */   GIR_EraseRootFromParent_Done,
     /*  28425 */ // Label 600: @28425
     /*  28425 */ GIM_Try, /*On fail goto*//*Label 601*/ GIMT_Encode4(28457), // Rule ID 2767 //
     /*  28430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28444 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28447 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28449 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28456 */   // GIR_Coverage, 2767,
     /*  28456 */   GIR_EraseRootFromParent_Done,
     /*  28457 */ // Label 601: @28457
     /*  28457 */ GIM_Try, /*On fail goto*//*Label 602*/ GIMT_Encode4(28489), // Rule ID 2768 //
     /*  28462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28476 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28476 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28479 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28481 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28483 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28488 */   // GIR_Coverage, 2768,
     /*  28488 */   GIR_EraseRootFromParent_Done,
     /*  28489 */ // Label 602: @28489
     /*  28489 */ GIM_Try, /*On fail goto*//*Label 603*/ GIMT_Encode4(28521), // Rule ID 2769 //
     /*  28494 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28508 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2f64] }:$src
     /*  28508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28511 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28513 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28515 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28520 */   // GIR_Coverage, 2769,
     /*  28520 */   GIR_EraseRootFromParent_Done,
     /*  28521 */ // Label 603: @28521
     /*  28521 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(28553), // Rule ID 2770 //
     /*  28526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28540 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28543 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28545 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28552 */   // GIR_Coverage, 2770,
     /*  28552 */   GIR_EraseRootFromParent_Done,
     /*  28553 */ // Label 604: @28553
     /*  28553 */ GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(28585), // Rule ID 2771 //
     /*  28558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28572 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28575 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28577 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28579 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28584 */   // GIR_Coverage, 2771,
     /*  28584 */   GIR_EraseRootFromParent_Done,
     /*  28585 */ // Label 605: @28585
     /*  28585 */ GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(28617), // Rule ID 2772 //
     /*  28590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28604 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28607 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28611 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28616 */   // GIR_Coverage, 2772,
     /*  28616 */   GIR_EraseRootFromParent_Done,
     /*  28617 */ // Label 606: @28617
     /*  28617 */ GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(28649), // Rule ID 2773 //
     /*  28622 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28632 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28636 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28639 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28641 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28643 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28648 */   // GIR_Coverage, 2773,
     /*  28648 */   GIR_EraseRootFromParent_Done,
     /*  28649 */ // Label 607: @28649
     /*  28649 */ GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(28681), // Rule ID 2774 //
     /*  28654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  28657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28668 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v2i64] }:$src
     /*  28668 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  28671 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  28673 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28675 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  28680 */   // GIR_Coverage, 2774,
     /*  28680 */   GIR_EraseRootFromParent_Done,
     /*  28681 */ // Label 608: @28681
     /*  28681 */ GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(28718), // Rule ID 2837 //
     /*  28686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28700 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4f32] }:$src)
     /*  28700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28705 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28716 */   GIR_RootConstrainSelectedInstOperands,
     /*  28717 */   // GIR_Coverage, 2837,
     /*  28717 */   GIR_EraseRootFromParent_Done,
     /*  28718 */ // Label 609: @28718
     /*  28718 */ GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(28755), // Rule ID 2838 //
     /*  28723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28737 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2f64] } QPR:{ *:[v4i32] }:$src)
     /*  28737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28740 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28753 */   GIR_RootConstrainSelectedInstOperands,
     /*  28754 */   // GIR_Coverage, 2838,
     /*  28754 */   GIR_EraseRootFromParent_Done,
     /*  28755 */ // Label 610: @28755
     /*  28755 */ GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(28792), // Rule ID 2839 //
     /*  28760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28774 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8f16] }:$src)
     /*  28774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28777 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28781 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28784 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28790 */   GIR_RootConstrainSelectedInstOperands,
     /*  28791 */   // GIR_Coverage, 2839,
     /*  28791 */   GIR_EraseRootFromParent_Done,
     /*  28792 */ // Label 611: @28792
     /*  28792 */ GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(28829), // Rule ID 2840 //
     /*  28797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28811 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2f64] } QPR:{ *:[v8i16] }:$src)
     /*  28811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28816 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28818 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28821 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28827 */   GIR_RootConstrainSelectedInstOperands,
     /*  28828 */   // GIR_Coverage, 2840,
     /*  28828 */   GIR_EraseRootFromParent_Done,
     /*  28829 */ // Label 612: @28829
     /*  28829 */ GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(28866), // Rule ID 2841 //
     /*  28834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  28840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28848 */   // (bitconvert:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2f64] } QPR:{ *:[v16i8] }:$src)
     /*  28848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  28851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28853 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28855 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28858 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28864 */   GIR_RootConstrainSelectedInstOperands,
     /*  28865 */   // GIR_Coverage, 2841,
     /*  28865 */   GIR_EraseRootFromParent_Done,
     /*  28866 */ // Label 613: @28866
     /*  28866 */ GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(28903), // Rule ID 2842 //
     /*  28871 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28877 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28881 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28885 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4f32] }:$src)
     /*  28885 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28888 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28890 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28892 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28895 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28901 */   GIR_RootConstrainSelectedInstOperands,
     /*  28902 */   // GIR_Coverage, 2842,
     /*  28902 */   GIR_EraseRootFromParent_Done,
     /*  28903 */ // Label 614: @28903
     /*  28903 */ GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(28940), // Rule ID 2843 //
     /*  28908 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  28914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28922 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)  =>  (VREV64q32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$src)
     /*  28922 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  28925 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28927 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28929 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28932 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28938 */   GIR_RootConstrainSelectedInstOperands,
     /*  28939 */   // GIR_Coverage, 2843,
     /*  28939 */   GIR_EraseRootFromParent_Done,
     /*  28940 */ // Label 615: @28940
     /*  28940 */ GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(28977), // Rule ID 2844 //
     /*  28945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28959 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8f16] }:$src)
     /*  28959 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28962 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  28964 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  28966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  28969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  28975 */   GIR_RootConstrainSelectedInstOperands,
     /*  28976 */   // GIR_Coverage, 2844,
     /*  28976 */   GIR_EraseRootFromParent_Done,
     /*  28977 */ // Label 616: @28977
     /*  28977 */ GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(29014), // Rule ID 2845 //
     /*  28982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  28985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  28996 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)  =>  (VREV64q16:{ *:[v2i64] } QPR:{ *:[v8i16] }:$src)
     /*  28996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  28999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29012 */   GIR_RootConstrainSelectedInstOperands,
     /*  29013 */   // GIR_Coverage, 2845,
     /*  29013 */   GIR_EraseRootFromParent_Done,
     /*  29014 */ // Label 617: @29014
     /*  29014 */ GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(29051), // Rule ID 2846 //
     /*  29019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  29022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29025 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29029 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  29033 */   // (bitconvert:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)  =>  (VREV64q8:{ *:[v2i64] } QPR:{ *:[v16i8] }:$src)
     /*  29033 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  29036 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  29038 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29040 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  29043 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29049 */   GIR_RootConstrainSelectedInstOperands,
     /*  29050 */   // GIR_Coverage, 2846,
     /*  29050 */   GIR_EraseRootFromParent_Done,
     /*  29051 */ // Label 618: @29051
     /*  29051 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(29083), // Rule ID 5280 //
     /*  29056 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29070 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29073 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29075 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29077 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29082 */   // GIR_Coverage, 5280,
     /*  29082 */   GIR_EraseRootFromParent_Done,
     /*  29083 */ // Label 619: @29083
     /*  29083 */ GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(29115), // Rule ID 5281 //
     /*  29088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  29091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  29094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29102 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29105 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29107 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29109 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29114 */   // GIR_Coverage, 5281,
     /*  29114 */   GIR_EraseRootFromParent_Done,
     /*  29115 */ // Label 620: @29115
     /*  29115 */ GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(29147), // Rule ID 5286 //
     /*  29120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29134 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29134 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29137 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29139 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29141 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29146 */   // GIR_Coverage, 5286,
     /*  29146 */   GIR_EraseRootFromParent_Done,
     /*  29147 */ // Label 621: @29147
     /*  29147 */ GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(29179), // Rule ID 5287 //
     /*  29152 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29166 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29166 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29169 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29171 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29173 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29178 */   // GIR_Coverage, 5287,
     /*  29178 */   GIR_EraseRootFromParent_Done,
     /*  29179 */ // Label 622: @29179
     /*  29179 */ GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(29211), // Rule ID 5288 //
     /*  29184 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29187 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29198 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29201 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29203 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29205 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29210 */   // GIR_Coverage, 5288,
     /*  29210 */   GIR_EraseRootFromParent_Done,
     /*  29211 */ // Label 623: @29211
     /*  29211 */ GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(29243), // Rule ID 5289 //
     /*  29216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29230 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29233 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29237 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29242 */   // GIR_Coverage, 5289,
     /*  29242 */   GIR_EraseRootFromParent_Done,
     /*  29243 */ // Label 624: @29243
     /*  29243 */ GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(29275), // Rule ID 5290 //
     /*  29248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29262 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2f64] }:$src
     /*  29262 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29265 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29267 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29269 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29274 */   // GIR_Coverage, 5290,
     /*  29274 */   GIR_EraseRootFromParent_Done,
     /*  29275 */ // Label 625: @29275
     /*  29275 */ GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(29307), // Rule ID 5291 //
     /*  29280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29294 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29294 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29297 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29299 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29301 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29306 */   // GIR_Coverage, 5291,
     /*  29306 */   GIR_EraseRootFromParent_Done,
     /*  29307 */ // Label 626: @29307
     /*  29307 */ GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(29339), // Rule ID 5292 //
     /*  29312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29326 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29329 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29331 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29333 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29338 */   // GIR_Coverage, 5292,
     /*  29338 */   GIR_EraseRootFromParent_Done,
     /*  29339 */ // Label 627: @29339
     /*  29339 */ GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(29371), // Rule ID 5293 //
     /*  29344 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29347 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29350 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29358 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29361 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29363 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29370 */   // GIR_Coverage, 5293,
     /*  29370 */   GIR_EraseRootFromParent_Done,
     /*  29371 */ // Label 628: @29371
     /*  29371 */ GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(29403), // Rule ID 5294 //
     /*  29376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29386 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29390 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29393 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29395 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29397 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29402 */   // GIR_Coverage, 5294,
     /*  29402 */   GIR_EraseRootFromParent_Done,
     /*  29403 */ // Label 629: @29403
     /*  29403 */ GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(29435), // Rule ID 5295 //
     /*  29408 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  29411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29414 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29418 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29422 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v2i64] }:$src
     /*  29422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  29425 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  29427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29434 */   // GIR_Coverage, 5295,
     /*  29434 */   GIR_EraseRootFromParent_Done,
     /*  29435 */ // Label 630: @29435
     /*  29435 */ GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(29493), // Rule ID 5322 //
     /*  29440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29454 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4f32] }:$src)
     /*  29454 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29457 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29461 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29466 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29469 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29471 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29473 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29476 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29482 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29488 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29491 */   GIR_RootConstrainSelectedInstOperands,
     /*  29492 */   // GIR_Coverage, 5322,
     /*  29492 */   GIR_EraseRootFromParent_Done,
     /*  29493 */ // Label 631: @29493
     /*  29493 */ GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(29551), // Rule ID 5323 //
     /*  29498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29512 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2f64] } MQPR:{ *:[v4i32] }:$src)
     /*  29512 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29515 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29519 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29524 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29527 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29529 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29531 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29534 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29546 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29549 */   GIR_RootConstrainSelectedInstOperands,
     /*  29550 */   // GIR_Coverage, 5323,
     /*  29550 */   GIR_EraseRootFromParent_Done,
     /*  29551 */ // Label 632: @29551
     /*  29551 */ GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(29609), // Rule ID 5324 //
     /*  29556 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29559 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29566 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29570 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8f16] }:$src)
     /*  29570 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29573 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29577 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29587 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29589 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29592 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29598 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29604 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29607 */   GIR_RootConstrainSelectedInstOperands,
     /*  29608 */   // GIR_Coverage, 5324,
     /*  29608 */   GIR_EraseRootFromParent_Done,
     /*  29609 */ // Label 633: @29609
     /*  29609 */ GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(29667), // Rule ID 5325 //
     /*  29614 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29624 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29628 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2f64] } MQPR:{ *:[v8i16] }:$src)
     /*  29628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29643 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29647 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29650 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29656 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29662 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29665 */   GIR_RootConstrainSelectedInstOperands,
     /*  29666 */   // GIR_Coverage, 5325,
     /*  29666 */   GIR_EraseRootFromParent_Done,
     /*  29667 */ // Label 634: @29667
     /*  29667 */ GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(29725), // Rule ID 5326 //
     /*  29672 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29678 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29682 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29686 */   // (bitconvert:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2f64] } MQPR:{ *:[v16i8] }:$src)
     /*  29686 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29689 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29693 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29703 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29705 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29708 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29714 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29723 */   GIR_RootConstrainSelectedInstOperands,
     /*  29724 */   // GIR_Coverage, 5326,
     /*  29724 */   GIR_EraseRootFromParent_Done,
     /*  29725 */ // Label 635: @29725
     /*  29725 */ GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(29783), // Rule ID 5327 //
     /*  29730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29740 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29744 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4f32] }:$src)
     /*  29744 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29747 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29751 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29761 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29763 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29766 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29772 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29778 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29781 */   GIR_RootConstrainSelectedInstOperands,
     /*  29782 */   // GIR_Coverage, 5327,
     /*  29782 */   GIR_EraseRootFromParent_Done,
     /*  29783 */ // Label 636: @29783
     /*  29783 */ GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(29841), // Rule ID 5328 //
     /*  29788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29802 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV64_32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$src)
     /*  29802 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29805 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29809 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  29817 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29821 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29824 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29830 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29839 */   GIR_RootConstrainSelectedInstOperands,
     /*  29840 */   // GIR_Coverage, 5328,
     /*  29840 */   GIR_EraseRootFromParent_Done,
     /*  29841 */ // Label 637: @29841
     /*  29841 */ GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(29899), // Rule ID 5329 //
     /*  29846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29860 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8f16] }:$src)
     /*  29860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29888 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29897 */   GIR_RootConstrainSelectedInstOperands,
     /*  29898 */   // GIR_Coverage, 5329,
     /*  29898 */   GIR_EraseRootFromParent_Done,
     /*  29899 */ // Label 638: @29899
     /*  29899 */ GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(29957), // Rule ID 5330 //
     /*  29904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29918 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV64_16:{ *:[v2i64] } MQPR:{ *:[v8i16] }:$src)
     /*  29918 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29921 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29925 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29930 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  29933 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29935 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29937 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29940 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29946 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  29952 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  29955 */   GIR_RootConstrainSelectedInstOperands,
     /*  29956 */   // GIR_Coverage, 5330,
     /*  29956 */   GIR_EraseRootFromParent_Done,
     /*  29957 */ // Label 639: @29957
     /*  29957 */ GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(30015), // Rule ID 5331 //
     /*  29962 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  29965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  29968 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29972 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  29976 */   // (bitconvert:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV64_8:{ *:[v2i64] } MQPR:{ *:[v16i8] }:$src)
     /*  29976 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  29979 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  29983 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  29988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  29991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  29993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  29995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  29998 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30004 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30010 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  30013 */   GIR_RootConstrainSelectedInstOperands,
     /*  30014 */   // GIR_Coverage, 5331,
     /*  30014 */   GIR_EraseRootFromParent_Done,
     /*  30015 */ // Label 640: @30015
     /*  30015 */ GIM_Reject,
     /*  30016 */ // Label 543: @30016
     /*  30016 */ GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(30048), // Rule ID 2721 //
     /*  30021 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30027 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30031 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30035 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30035 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30038 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30040 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30042 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30047 */   // GIR_Coverage, 2721,
     /*  30047 */   GIR_EraseRootFromParent_Done,
     /*  30048 */ // Label 641: @30048
     /*  30048 */ GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(30080), // Rule ID 2722 //
     /*  30053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30063 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30067 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30070 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30072 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30074 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30079 */   // GIR_Coverage, 2722,
     /*  30079 */   GIR_EraseRootFromParent_Done,
     /*  30080 */ // Label 642: @30080
     /*  30080 */ GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(30112), // Rule ID 2749 //
     /*  30085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30099 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30099 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30102 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30104 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30106 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30111 */   // GIR_Coverage, 2749,
     /*  30111 */   GIR_EraseRootFromParent_Done,
     /*  30112 */ // Label 643: @30112
     /*  30112 */ GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(30144), // Rule ID 2750 //
     /*  30117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30127 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30131 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30134 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30136 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30138 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30143 */   // GIR_Coverage, 2750,
     /*  30143 */   GIR_EraseRootFromParent_Done,
     /*  30144 */ // Label 644: @30144
     /*  30144 */ GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(30176), // Rule ID 2751 //
     /*  30149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30155 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30163 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30163 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30166 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30168 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30175 */   // GIR_Coverage, 2751,
     /*  30175 */   GIR_EraseRootFromParent_Done,
     /*  30176 */ // Label 645: @30176
     /*  30176 */ GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(30208), // Rule ID 2752 //
     /*  30181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30191 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30195 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30198 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30200 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30202 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30207 */   // GIR_Coverage, 2752,
     /*  30207 */   GIR_EraseRootFromParent_Done,
     /*  30208 */ // Label 646: @30208
     /*  30208 */ GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(30240), // Rule ID 2753 //
     /*  30213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30227 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4f16] }:$src
     /*  30227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30230 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30232 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30234 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30239 */   // GIR_Coverage, 2753,
     /*  30239 */   GIR_EraseRootFromParent_Done,
     /*  30240 */ // Label 647: @30240
     /*  30240 */ GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(30272), // Rule ID 2754 //
     /*  30245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30259 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30271 */   // GIR_Coverage, 2754,
     /*  30271 */   GIR_EraseRootFromParent_Done,
     /*  30272 */ // Label 648: @30272
     /*  30272 */ GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(30304), // Rule ID 2755 //
     /*  30277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30291 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30303 */   // GIR_Coverage, 2755,
     /*  30303 */   GIR_EraseRootFromParent_Done,
     /*  30304 */ // Label 649: @30304
     /*  30304 */ GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(30336), // Rule ID 2756 //
     /*  30309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30323 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30335 */   // GIR_Coverage, 2756,
     /*  30335 */   GIR_EraseRootFromParent_Done,
     /*  30336 */ // Label 650: @30336
     /*  30336 */ GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(30368), // Rule ID 2757 //
     /*  30341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30355 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30367 */   // GIR_Coverage, 2757,
     /*  30367 */   GIR_EraseRootFromParent_Done,
     /*  30368 */ // Label 651: @30368
     /*  30368 */ GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(30400), // Rule ID 2758 //
     /*  30373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30387 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  DPR:{ *:[v4i16] }:$src
     /*  30387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  30399 */   // GIR_Coverage, 2758,
     /*  30399 */   GIR_EraseRootFromParent_Done,
     /*  30400 */ // Label 652: @30400
     /*  30400 */ GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(30437), // Rule ID 2821 //
     /*  30405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30419 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[f64] }:$src)
     /*  30419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30435 */   GIR_RootConstrainSelectedInstOperands,
     /*  30436 */   // GIR_Coverage, 2821,
     /*  30436 */   GIR_EraseRootFromParent_Done,
     /*  30437 */ // Label 653: @30437
     /*  30437 */ GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(30474), // Rule ID 2822 //
     /*  30442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30456 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4f16] } DPR:{ *:[v1i64] }:$src)
     /*  30456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30472 */   GIR_RootConstrainSelectedInstOperands,
     /*  30473 */   // GIR_Coverage, 2822,
     /*  30473 */   GIR_EraseRootFromParent_Done,
     /*  30474 */ // Label 654: @30474
     /*  30474 */ GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(30511), // Rule ID 2823 //
     /*  30479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30493 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2f32] }:$src)
     /*  30493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30509 */   GIR_RootConstrainSelectedInstOperands,
     /*  30510 */   // GIR_Coverage, 2823,
     /*  30510 */   GIR_EraseRootFromParent_Done,
     /*  30511 */ // Label 655: @30511
     /*  30511 */ GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(30548), // Rule ID 2824 //
     /*  30516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30530 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4f16] } DPR:{ *:[v2i32] }:$src)
     /*  30530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30546 */   GIR_RootConstrainSelectedInstOperands,
     /*  30547 */   // GIR_Coverage, 2824,
     /*  30547 */   GIR_EraseRootFromParent_Done,
     /*  30548 */ // Label 656: @30548
     /*  30548 */ GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(30585), // Rule ID 2825 //
     /*  30553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30567 */   // (bitconvert:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4f16] } DPR:{ *:[v8i8] }:$src)
     /*  30567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30583 */   GIR_RootConstrainSelectedInstOperands,
     /*  30584 */   // GIR_Coverage, 2825,
     /*  30584 */   GIR_EraseRootFromParent_Done,
     /*  30585 */ // Label 657: @30585
     /*  30585 */ GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(30622), // Rule ID 2826 //
     /*  30590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30604 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[f64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[f64] }:$src)
     /*  30604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30620 */   GIR_RootConstrainSelectedInstOperands,
     /*  30621 */   // GIR_Coverage, 2826,
     /*  30621 */   GIR_EraseRootFromParent_Done,
     /*  30622 */ // Label 658: @30622
     /*  30622 */ GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(30659), // Rule ID 2827 //
     /*  30627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  30633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30641 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d16:{ *:[v4i16] } DPR:{ *:[v1i64] }:$src)
     /*  30641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d16),
     /*  30644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30657 */   GIR_RootConstrainSelectedInstOperands,
     /*  30658 */   // GIR_Coverage, 2827,
     /*  30658 */   GIR_EraseRootFromParent_Done,
     /*  30659 */ // Label 659: @30659
     /*  30659 */ GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(30696), // Rule ID 2828 //
     /*  30664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30678 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2f32] }:$src)
     /*  30678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30681 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30688 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30694 */   GIR_RootConstrainSelectedInstOperands,
     /*  30695 */   // GIR_Coverage, 2828,
     /*  30695 */   GIR_EraseRootFromParent_Done,
     /*  30696 */ // Label 660: @30696
     /*  30696 */ GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(30733), // Rule ID 2829 //
     /*  30701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  30707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30715 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d16:{ *:[v4i16] } DPR:{ *:[v2i32] }:$src)
     /*  30715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d16),
     /*  30718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30720 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30731 */   GIR_RootConstrainSelectedInstOperands,
     /*  30732 */   // GIR_Coverage, 2829,
     /*  30732 */   GIR_EraseRootFromParent_Done,
     /*  30733 */ // Label 661: @30733
     /*  30733 */ GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(30770), // Rule ID 2830 //
     /*  30738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  30741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  30744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  30752 */   // (bitconvert:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)  =>  (VREV16d8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$src)
     /*  30752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  30755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  30757 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30759 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  30762 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  30768 */   GIR_RootConstrainSelectedInstOperands,
     /*  30769 */   // GIR_Coverage, 2830,
     /*  30769 */   GIR_EraseRootFromParent_Done,
     /*  30770 */ // Label 662: @30770
     /*  30770 */ GIM_Reject,
     /*  30771 */ // Label 544: @30771
     /*  30771 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(30803), // Rule ID 2725 //
     /*  30776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30790 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  30790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30802 */   // GIR_Coverage, 2725,
     /*  30802 */   GIR_EraseRootFromParent_Done,
     /*  30803 */ // Label 663: @30803
     /*  30803 */ GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(30835), // Rule ID 2726 //
     /*  30808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30822 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30822 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30825 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30827 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30829 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30834 */   // GIR_Coverage, 2726,
     /*  30834 */   GIR_EraseRootFromParent_Done,
     /*  30835 */ // Label 664: @30835
     /*  30835 */ GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(30867), // Rule ID 2775 //
     /*  30840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30846 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30850 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30854 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30857 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30859 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30861 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30866 */   // GIR_Coverage, 2775,
     /*  30866 */   GIR_EraseRootFromParent_Done,
     /*  30867 */ // Label 665: @30867
     /*  30867 */ GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(30899), // Rule ID 2776 //
     /*  30872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  30878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30886 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30889 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30893 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30898 */   // GIR_Coverage, 2776,
     /*  30898 */   GIR_EraseRootFromParent_Done,
     /*  30899 */ // Label 666: @30899
     /*  30899 */ GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(30931), // Rule ID 2777 //
     /*  30904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30918 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30918 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30921 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30923 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30930 */   // GIR_Coverage, 2777,
     /*  30930 */   GIR_EraseRootFromParent_Done,
     /*  30931 */ // Label 667: @30931
     /*  30931 */ GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(30963), // Rule ID 2778 //
     /*  30936 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30939 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30950 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30953 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30955 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30957 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30962 */   // GIR_Coverage, 2778,
     /*  30962 */   GIR_EraseRootFromParent_Done,
     /*  30963 */ // Label 668: @30963
     /*  30963 */ GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(30995), // Rule ID 2779 //
     /*  30968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  30971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  30974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  30982 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4f32] }:$src
     /*  30982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  30985 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  30987 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  30989 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  30994 */   // GIR_Coverage, 2779,
     /*  30994 */   GIR_EraseRootFromParent_Done,
     /*  30995 */ // Label 669: @30995
     /*  30995 */ GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(31027), // Rule ID 2780 //
     /*  31000 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31010 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31014 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31017 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31019 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31021 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31026 */   // GIR_Coverage, 2780,
     /*  31026 */   GIR_EraseRootFromParent_Done,
     /*  31027 */ // Label 670: @31027
     /*  31027 */ GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(31059), // Rule ID 2781 //
     /*  31032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31038 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31042 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31046 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31046 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31049 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31051 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31053 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31058 */   // GIR_Coverage, 2781,
     /*  31058 */   GIR_EraseRootFromParent_Done,
     /*  31059 */ // Label 671: @31059
     /*  31059 */ GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(31091), // Rule ID 2782 //
     /*  31064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31070 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31074 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31078 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31078 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31081 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31083 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31090 */   // GIR_Coverage, 2782,
     /*  31090 */   GIR_EraseRootFromParent_Done,
     /*  31091 */ // Label 672: @31091
     /*  31091 */ GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(31123), // Rule ID 2783 //
     /*  31096 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31099 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31102 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31106 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31110 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31113 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31115 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31117 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31122 */   // GIR_Coverage, 2783,
     /*  31122 */   GIR_EraseRootFromParent_Done,
     /*  31123 */ // Label 673: @31123
     /*  31123 */ GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(31155), // Rule ID 2784 //
     /*  31128 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  31131 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31138 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31142 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v4i32] }:$src
     /*  31142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31145 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31147 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31149 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  31154 */   // GIR_Coverage, 2784,
     /*  31154 */   GIR_EraseRootFromParent_Done,
     /*  31155 */ // Label 674: @31155
     /*  31155 */ GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(31192), // Rule ID 2847 //
     /*  31160 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31163 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31174 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2f64] }:$src)
     /*  31174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31179 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31181 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31184 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31190 */   GIR_RootConstrainSelectedInstOperands,
     /*  31191 */   // GIR_Coverage, 2847,
     /*  31191 */   GIR_EraseRootFromParent_Done,
     /*  31192 */ // Label 675: @31192
     /*  31192 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(31229), // Rule ID 2848 //
     /*  31197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31203 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31207 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31211 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4f32] } QPR:{ *:[v2i64] }:$src)
     /*  31211 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31214 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31216 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31218 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31221 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31227 */   GIR_RootConstrainSelectedInstOperands,
     /*  31228 */   // GIR_Coverage, 2848,
     /*  31228 */   GIR_EraseRootFromParent_Done,
     /*  31229 */ // Label 676: @31229
     /*  31229 */ GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(31266), // Rule ID 2849 //
     /*  31234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31248 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8f16] }:$src)
     /*  31248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31264 */   GIR_RootConstrainSelectedInstOperands,
     /*  31265 */   // GIR_Coverage, 2849,
     /*  31265 */   GIR_EraseRootFromParent_Done,
     /*  31266 */ // Label 677: @31266
     /*  31266 */ GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(31303), // Rule ID 2850 //
     /*  31271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31285 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4f32] } QPR:{ *:[v8i16] }:$src)
     /*  31285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31295 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31301 */   GIR_RootConstrainSelectedInstOperands,
     /*  31302 */   // GIR_Coverage, 2850,
     /*  31302 */   GIR_EraseRootFromParent_Done,
     /*  31303 */ // Label 678: @31303
     /*  31303 */ GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(31340), // Rule ID 2851 //
     /*  31308 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31311 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31318 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31322 */   // (bitconvert:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4f32] } QPR:{ *:[v16i8] }:$src)
     /*  31322 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31325 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31327 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31329 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31332 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31338 */   GIR_RootConstrainSelectedInstOperands,
     /*  31339 */   // GIR_Coverage, 2851,
     /*  31339 */   GIR_EraseRootFromParent_Done,
     /*  31340 */ // Label 679: @31340
     /*  31340 */ GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(31377), // Rule ID 2852 //
     /*  31345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31351 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31355 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31359 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2f64] }:$src)
     /*  31359 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31362 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31364 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31369 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31375 */   GIR_RootConstrainSelectedInstOperands,
     /*  31376 */   // GIR_Coverage, 2852,
     /*  31376 */   GIR_EraseRootFromParent_Done,
     /*  31377 */ // Label 680: @31377
     /*  31377 */ GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(31414), // Rule ID 2853 //
     /*  31382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31396 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q32:{ *:[v4i32] } QPR:{ *:[v2i64] }:$src)
     /*  31396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q32),
     /*  31399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31401 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31403 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31406 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31412 */   GIR_RootConstrainSelectedInstOperands,
     /*  31413 */   // GIR_Coverage, 2853,
     /*  31413 */   GIR_EraseRootFromParent_Done,
     /*  31414 */ // Label 681: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(31451), // Rule ID 2854 //
     /*  31419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31425 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31429 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31433 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8f16] }:$src)
     /*  31433 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31436 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31438 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31440 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31443 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31449 */   GIR_RootConstrainSelectedInstOperands,
     /*  31450 */   // GIR_Coverage, 2854,
     /*  31450 */   GIR_EraseRootFromParent_Done,
     /*  31451 */ // Label 682: @31451
     /*  31451 */ GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(31488), // Rule ID 2855 //
     /*  31456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31470 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)  =>  (VREV32q16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$src)
     /*  31470 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  31473 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31475 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31477 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31486 */   GIR_RootConstrainSelectedInstOperands,
     /*  31487 */   // GIR_Coverage, 2855,
     /*  31487 */   GIR_EraseRootFromParent_Done,
     /*  31488 */ // Label 683: @31488
     /*  31488 */ GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(31525), // Rule ID 2856 //
     /*  31493 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  31496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31499 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  31507 */   // (bitconvert:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)  =>  (VREV32q8:{ *:[v4i32] } QPR:{ *:[v16i8] }:$src)
     /*  31507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  31510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  31512 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31514 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  31517 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31523 */   GIR_RootConstrainSelectedInstOperands,
     /*  31524 */   // GIR_Coverage, 2856,
     /*  31524 */   GIR_EraseRootFromParent_Done,
     /*  31525 */ // Label 684: @31525
     /*  31525 */ GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(31557), // Rule ID 5282 //
     /*  31530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31544 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31556 */   // GIR_Coverage, 5282,
     /*  31556 */   GIR_EraseRootFromParent_Done,
     /*  31557 */ // Label 685: @31557
     /*  31557 */ GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(31589), // Rule ID 5283 //
     /*  31562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  31565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  31568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31576 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31588 */   // GIR_Coverage, 5283,
     /*  31588 */   GIR_EraseRootFromParent_Done,
     /*  31589 */ // Label 686: @31589
     /*  31589 */ GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(31621), // Rule ID 5296 //
     /*  31594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31597 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31608 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31611 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31613 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31615 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31620 */   // GIR_Coverage, 5296,
     /*  31620 */   GIR_EraseRootFromParent_Done,
     /*  31621 */ // Label 687: @31621
     /*  31621 */ GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(31653), // Rule ID 5297 //
     /*  31626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31640 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31640 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31643 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31645 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31647 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31652 */   // GIR_Coverage, 5297,
     /*  31652 */   GIR_EraseRootFromParent_Done,
     /*  31653 */ // Label 688: @31653
     /*  31653 */ GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(31685), // Rule ID 5298 //
     /*  31658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31672 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31675 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31677 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31679 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31684 */   // GIR_Coverage, 5298,
     /*  31684 */   GIR_EraseRootFromParent_Done,
     /*  31685 */ // Label 689: @31685
     /*  31685 */ GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(31717), // Rule ID 5299 //
     /*  31690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31704 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31704 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31707 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31709 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31711 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31716 */   // GIR_Coverage, 5299,
     /*  31716 */   GIR_EraseRootFromParent_Done,
     /*  31717 */ // Label 690: @31717
     /*  31717 */ GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(31749), // Rule ID 5300 //
     /*  31722 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31736 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4f32] }:$src
     /*  31736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31739 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31741 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31748 */   // GIR_Coverage, 5300,
     /*  31748 */   GIR_EraseRootFromParent_Done,
     /*  31749 */ // Label 691: @31749
     /*  31749 */ GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(31781), // Rule ID 5301 //
     /*  31754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31768 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31768 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31771 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31773 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31775 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31780 */   // GIR_Coverage, 5301,
     /*  31780 */   GIR_EraseRootFromParent_Done,
     /*  31781 */ // Label 692: @31781
     /*  31781 */ GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(31813), // Rule ID 5302 //
     /*  31786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31800 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31800 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31803 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31805 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31807 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31812 */   // GIR_Coverage, 5302,
     /*  31812 */   GIR_EraseRootFromParent_Done,
     /*  31813 */ // Label 693: @31813
     /*  31813 */ GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(31845), // Rule ID 5303 //
     /*  31818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31824 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31828 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31832 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31835 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31837 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31839 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31844 */   // GIR_Coverage, 5303,
     /*  31844 */   GIR_EraseRootFromParent_Done,
     /*  31845 */ // Label 694: @31845
     /*  31845 */ GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(31877), // Rule ID 5304 //
     /*  31850 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31864 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31864 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31867 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31869 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31871 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31876 */   // GIR_Coverage, 5304,
     /*  31876 */   GIR_EraseRootFromParent_Done,
     /*  31877 */ // Label 695: @31877
     /*  31877 */ GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(31909), // Rule ID 5305 //
     /*  31882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  31885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31896 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v4i32] }:$src
     /*  31896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31899 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  31901 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31903 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31908 */   // GIR_Coverage, 5305,
     /*  31908 */   GIR_EraseRootFromParent_Done,
     /*  31909 */ // Label 696: @31909
     /*  31909 */ GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(31967), // Rule ID 5332 //
     /*  31914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31920 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31924 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31928 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2f64] }:$src)
     /*  31928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31940 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  31943 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  31945 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  31947 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  31950 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  31962 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  31965 */   GIR_RootConstrainSelectedInstOperands,
     /*  31966 */   // GIR_Coverage, 5332,
     /*  31966 */   GIR_EraseRootFromParent_Done,
     /*  31967 */ // Label 697: @31967
     /*  31967 */ GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(32025), // Rule ID 5333 //
     /*  31972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  31975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  31978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  31986 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4f32] } MQPR:{ *:[v2i64] }:$src)
     /*  31986 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  31989 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  31993 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32014 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32020 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32023 */   GIR_RootConstrainSelectedInstOperands,
     /*  32024 */   // GIR_Coverage, 5333,
     /*  32024 */   GIR_EraseRootFromParent_Done,
     /*  32025 */ // Label 698: @32025
     /*  32025 */ GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(32083), // Rule ID 5334 //
     /*  32030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32036 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32040 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32044 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$src)
     /*  32044 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32047 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32051 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32061 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32063 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32066 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32072 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32078 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32081 */   GIR_RootConstrainSelectedInstOperands,
     /*  32082 */   // GIR_Coverage, 5334,
     /*  32082 */   GIR_EraseRootFromParent_Done,
     /*  32083 */ // Label 699: @32083
     /*  32083 */ GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(32141), // Rule ID 5335 //
     /*  32088 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32091 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32098 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32102 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4f32] } MQPR:{ *:[v8i16] }:$src)
     /*  32102 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32105 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32109 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32119 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32121 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32124 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32139 */   GIR_RootConstrainSelectedInstOperands,
     /*  32140 */   // GIR_Coverage, 5335,
     /*  32140 */   GIR_EraseRootFromParent_Done,
     /*  32141 */ // Label 700: @32141
     /*  32141 */ GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(32199), // Rule ID 5336 //
     /*  32146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32160 */   // (bitconvert:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4f32] } MQPR:{ *:[v16i8] }:$src)
     /*  32160 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32163 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32167 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32172 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32175 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32177 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32179 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32182 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32188 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32194 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32197 */   GIR_RootConstrainSelectedInstOperands,
     /*  32198 */   // GIR_Coverage, 5336,
     /*  32198 */   GIR_EraseRootFromParent_Done,
     /*  32199 */ // Label 701: @32199
     /*  32199 */ GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(32257), // Rule ID 5337 //
     /*  32204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32218 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2f64] }:$src)
     /*  32218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32230 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32233 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32235 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32237 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32240 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32246 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32252 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32255 */   GIR_RootConstrainSelectedInstOperands,
     /*  32256 */   // GIR_Coverage, 5337,
     /*  32256 */   GIR_EraseRootFromParent_Done,
     /*  32257 */ // Label 702: @32257
     /*  32257 */ GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(32315), // Rule ID 5338 //
     /*  32262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32276 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_32:{ *:[v4i32] } MQPR:{ *:[v2i64] }:$src)
     /*  32276 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32279 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32283 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_32),
     /*  32291 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32295 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32298 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32304 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32313 */   GIR_RootConstrainSelectedInstOperands,
     /*  32314 */   // GIR_Coverage, 5338,
     /*  32314 */   GIR_EraseRootFromParent_Done,
     /*  32315 */ // Label 703: @32315
     /*  32315 */ GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(32373), // Rule ID 5339 //
     /*  32320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32334 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8f16] }:$src)
     /*  32334 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32337 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32341 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32351 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32353 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32356 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32362 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32368 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32371 */   GIR_RootConstrainSelectedInstOperands,
     /*  32372 */   // GIR_Coverage, 5339,
     /*  32372 */   GIR_EraseRootFromParent_Done,
     /*  32373 */ // Label 704: @32373
     /*  32373 */ GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(32431), // Rule ID 5340 //
     /*  32378 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32392 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV32_16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  32392 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32395 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32399 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  32407 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32409 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32411 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32414 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32420 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32426 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32429 */   GIR_RootConstrainSelectedInstOperands,
     /*  32430 */   // GIR_Coverage, 5340,
     /*  32430 */   GIR_EraseRootFromParent_Done,
     /*  32431 */ // Label 705: @32431
     /*  32431 */ GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(32489), // Rule ID 5341 //
     /*  32436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  32439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  32442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32446 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  32450 */   // (bitconvert:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v16i8] }:$src)
     /*  32450 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  32453 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  32457 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  32462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  32465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  32467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32469 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  32472 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32478 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32484 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  32487 */   GIR_RootConstrainSelectedInstOperands,
     /*  32488 */   // GIR_Coverage, 5341,
     /*  32488 */   GIR_EraseRootFromParent_Done,
     /*  32489 */ // Label 706: @32489
     /*  32489 */ GIM_Reject,
     /*  32490 */ // Label 545: @32490
     /*  32490 */ GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(32522), // Rule ID 2759 //
     /*  32495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32509 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32512 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32514 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32521 */   // GIR_Coverage, 2759,
     /*  32521 */   GIR_EraseRootFromParent_Done,
     /*  32522 */ // Label 707: @32522
     /*  32522 */ GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(32554), // Rule ID 2760 //
     /*  32527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32541 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32541 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32544 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32546 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32553 */   // GIR_Coverage, 2760,
     /*  32553 */   GIR_EraseRootFromParent_Done,
     /*  32554 */ // Label 708: @32554
     /*  32554 */ GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(32586), // Rule ID 2761 //
     /*  32559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32573 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32573 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32576 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32578 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32580 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32585 */   // GIR_Coverage, 2761,
     /*  32585 */   GIR_EraseRootFromParent_Done,
     /*  32586 */ // Label 709: @32586
     /*  32586 */ GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(32618), // Rule ID 2762 //
     /*  32591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32601 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32605 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32608 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32610 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32617 */   // GIR_Coverage, 2762,
     /*  32617 */   GIR_EraseRootFromParent_Done,
     /*  32618 */ // Label 710: @32618
     /*  32618 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(32650), // Rule ID 2763 //
     /*  32623 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32626 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32637 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32637 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32640 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32642 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32649 */   // GIR_Coverage, 2763,
     /*  32649 */   GIR_EraseRootFromParent_Done,
     /*  32650 */ // Label 711: @32650
     /*  32650 */ GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(32682), // Rule ID 2764 //
     /*  32655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32669 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  DPR:{ *:[v8i8] }:$src
     /*  32669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32672 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32674 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32676 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::DPRRegClassID),
     /*  32681 */   // GIR_Coverage, 2764,
     /*  32681 */   GIR_EraseRootFromParent_Done,
     /*  32682 */ // Label 712: @32682
     /*  32682 */ GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(32719), // Rule ID 2831 //
     /*  32687 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32701 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[f64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[f64] }:$src)
     /*  32701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32704 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32708 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32711 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32717 */   GIR_RootConstrainSelectedInstOperands,
     /*  32718 */   // GIR_Coverage, 2831,
     /*  32718 */   GIR_EraseRootFromParent_Done,
     /*  32719 */ // Label 713: @32719
     /*  32719 */ GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(32756), // Rule ID 2832 //
     /*  32724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  32730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32738 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)  =>  (VREV64d8:{ *:[v8i8] } DPR:{ *:[v1i64] }:$src)
     /*  32738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64d8),
     /*  32741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32743 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32754 */   GIR_RootConstrainSelectedInstOperands,
     /*  32755 */   // GIR_Coverage, 2832,
     /*  32755 */   GIR_EraseRootFromParent_Done,
     /*  32756 */ // Label 714: @32756
     /*  32756 */ GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(32793), // Rule ID 2833 //
     /*  32761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32775 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2f32] }:$src)
     /*  32775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32778 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32782 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32785 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32791 */   GIR_RootConstrainSelectedInstOperands,
     /*  32792 */   // GIR_Coverage, 2833,
     /*  32792 */   GIR_EraseRootFromParent_Done,
     /*  32793 */ // Label 715: @32793
     /*  32793 */ GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(32830), // Rule ID 2834 //
     /*  32798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  32804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32812 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)  =>  (VREV32d8:{ *:[v8i8] } DPR:{ *:[v2i32] }:$src)
     /*  32812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32d8),
     /*  32815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32817 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32819 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32822 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32828 */   GIR_RootConstrainSelectedInstOperands,
     /*  32829 */   // GIR_Coverage, 2834,
     /*  32829 */   GIR_EraseRootFromParent_Done,
     /*  32830 */ // Label 716: @32830
     /*  32830 */ GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(32867), // Rule ID 2835 //
     /*  32835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32849 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4f16] }:$src)
     /*  32849 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32852 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32854 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32865 */   GIR_RootConstrainSelectedInstOperands,
     /*  32866 */   // GIR_Coverage, 2835,
     /*  32866 */   GIR_EraseRootFromParent_Done,
     /*  32867 */ // Label 717: @32867
     /*  32867 */ GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(32904), // Rule ID 2836 //
     /*  32872 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  32875 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  32878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  32886 */   // (bitconvert:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)  =>  (VREV16d8:{ *:[v8i8] } DPR:{ *:[v4i16] }:$src)
     /*  32886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16d8),
     /*  32889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  32891 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32893 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  32896 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  32902 */   GIR_RootConstrainSelectedInstOperands,
     /*  32903 */   // GIR_Coverage, 2836,
     /*  32903 */   GIR_EraseRootFromParent_Done,
     /*  32904 */ // Label 718: @32904
     /*  32904 */ GIM_Reject,
     /*  32905 */ // Label 546: @32905
     /*  32905 */ GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(32937), // Rule ID 2727 //
     /*  32910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32924 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  32924 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32927 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32929 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32931 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32936 */   // GIR_Coverage, 2727,
     /*  32936 */   GIR_EraseRootFromParent_Done,
     /*  32937 */ // Label 719: @32937
     /*  32937 */ GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(32969), // Rule ID 2728 //
     /*  32942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32956 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32959 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32961 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32963 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  32968 */   // GIR_Coverage, 2728,
     /*  32968 */   GIR_EraseRootFromParent_Done,
     /*  32969 */ // Label 720: @32969
     /*  32969 */ GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(33001), // Rule ID 2785 //
     /*  32974 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  32977 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  32980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  32988 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  32988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  32991 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  32993 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  32995 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33000 */   // GIR_Coverage, 2785,
     /*  33000 */   GIR_EraseRootFromParent_Done,
     /*  33001 */ // Label 721: @33001
     /*  33001 */ GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(33033), // Rule ID 2786 //
     /*  33006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33020 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33023 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33027 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33032 */   // GIR_Coverage, 2786,
     /*  33032 */   GIR_EraseRootFromParent_Done,
     /*  33033 */ // Label 722: @33033
     /*  33033 */ GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(33065), // Rule ID 2787 //
     /*  33038 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33041 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33052 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33055 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33057 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33059 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33064 */   // GIR_Coverage, 2787,
     /*  33064 */   GIR_EraseRootFromParent_Done,
     /*  33065 */ // Label 723: @33065
     /*  33065 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(33097), // Rule ID 2788 //
     /*  33070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33084 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33087 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33089 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33091 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33096 */   // GIR_Coverage, 2788,
     /*  33096 */   GIR_EraseRootFromParent_Done,
     /*  33097 */ // Label 724: @33097
     /*  33097 */ GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(33129), // Rule ID 2789 //
     /*  33102 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33105 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33112 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33116 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8f16] }:$src
     /*  33116 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33119 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33121 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33123 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33128 */   // GIR_Coverage, 2789,
     /*  33128 */   GIR_EraseRootFromParent_Done,
     /*  33129 */ // Label 725: @33129
     /*  33129 */ GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(33161), // Rule ID 2790 //
     /*  33134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33148 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33148 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33151 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33153 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33155 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33160 */   // GIR_Coverage, 2790,
     /*  33160 */   GIR_EraseRootFromParent_Done,
     /*  33161 */ // Label 726: @33161
     /*  33161 */ GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(33193), // Rule ID 2791 //
     /*  33166 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33169 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33172 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33176 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33180 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33183 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33185 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33192 */   // GIR_Coverage, 2791,
     /*  33192 */   GIR_EraseRootFromParent_Done,
     /*  33193 */ // Label 727: @33193
     /*  33193 */ GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(33225), // Rule ID 2792 //
     /*  33198 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33212 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33215 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33217 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33224 */   // GIR_Coverage, 2792,
     /*  33224 */   GIR_EraseRootFromParent_Done,
     /*  33225 */ // Label 728: @33225
     /*  33225 */ GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(33257), // Rule ID 2793 //
     /*  33230 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33244 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33244 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33247 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33249 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33256 */   // GIR_Coverage, 2793,
     /*  33256 */   GIR_EraseRootFromParent_Done,
     /*  33257 */ // Label 729: @33257
     /*  33257 */ GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(33289), // Rule ID 2794 //
     /*  33262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  33265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33276 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  QPR:{ *:[v8i16] }:$src
     /*  33276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33279 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33281 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33283 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  33288 */   // GIR_Coverage, 2794,
     /*  33288 */   GIR_EraseRootFromParent_Done,
     /*  33289 */ // Label 730: @33289
     /*  33289 */ GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(33326), // Rule ID 2857 //
     /*  33294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33308 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2f64] }:$src)
     /*  33308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33313 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33315 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33318 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33324 */   GIR_RootConstrainSelectedInstOperands,
     /*  33325 */   // GIR_Coverage, 2857,
     /*  33325 */   GIR_EraseRootFromParent_Done,
     /*  33326 */ // Label 731: @33326
     /*  33326 */ GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(33363), // Rule ID 2858 //
     /*  33331 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33341 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33345 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8f16] } QPR:{ *:[v2i64] }:$src)
     /*  33345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33348 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33350 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33352 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33355 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33361 */   GIR_RootConstrainSelectedInstOperands,
     /*  33362 */   // GIR_Coverage, 2858,
     /*  33362 */   GIR_EraseRootFromParent_Done,
     /*  33363 */ // Label 732: @33363
     /*  33363 */ GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(33400), // Rule ID 2859 //
     /*  33368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33382 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4f32] }:$src)
     /*  33382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33398 */   GIR_RootConstrainSelectedInstOperands,
     /*  33399 */   // GIR_Coverage, 2859,
     /*  33399 */   GIR_EraseRootFromParent_Done,
     /*  33400 */ // Label 733: @33400
     /*  33400 */ GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(33437), // Rule ID 2860 //
     /*  33405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33419 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8f16] } QPR:{ *:[v4i32] }:$src)
     /*  33419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33422 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33435 */   GIR_RootConstrainSelectedInstOperands,
     /*  33436 */   // GIR_Coverage, 2860,
     /*  33436 */   GIR_EraseRootFromParent_Done,
     /*  33437 */ // Label 734: @33437
     /*  33437 */ GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(33474), // Rule ID 2861 //
     /*  33442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33456 */   // (bitconvert:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8f16] } QPR:{ *:[v16i8] }:$src)
     /*  33456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33461 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33466 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33472 */   GIR_RootConstrainSelectedInstOperands,
     /*  33473 */   // GIR_Coverage, 2861,
     /*  33473 */   GIR_EraseRootFromParent_Done,
     /*  33474 */ // Label 735: @33474
     /*  33474 */ GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(33511), // Rule ID 2862 //
     /*  33479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33493 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2f64] }:$src)
     /*  33493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33509 */   GIR_RootConstrainSelectedInstOperands,
     /*  33510 */   // GIR_Coverage, 2862,
     /*  33510 */   GIR_EraseRootFromParent_Done,
     /*  33511 */ // Label 736: @33511
     /*  33511 */ GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(33548), // Rule ID 2863 //
     /*  33516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33522 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33526 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33530 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q16:{ *:[v8i16] } QPR:{ *:[v2i64] }:$src)
     /*  33530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q16),
     /*  33533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33535 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33546 */   GIR_RootConstrainSelectedInstOperands,
     /*  33547 */   // GIR_Coverage, 2863,
     /*  33547 */   GIR_EraseRootFromParent_Done,
     /*  33548 */ // Label 737: @33548
     /*  33548 */ GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(33585), // Rule ID 2864 //
     /*  33553 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33556 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33559 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33567 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4f32] }:$src)
     /*  33567 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33570 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33572 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33574 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33577 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33583 */   GIR_RootConstrainSelectedInstOperands,
     /*  33584 */   // GIR_Coverage, 2864,
     /*  33584 */   GIR_EraseRootFromParent_Done,
     /*  33585 */ // Label 738: @33585
     /*  33585 */ GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(33622), // Rule ID 2865 //
     /*  33590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33604 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q16:{ *:[v8i16] } QPR:{ *:[v4i32] }:$src)
     /*  33604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q16),
     /*  33607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33620 */   GIR_RootConstrainSelectedInstOperands,
     /*  33621 */   // GIR_Coverage, 2865,
     /*  33621 */   GIR_EraseRootFromParent_Done,
     /*  33622 */ // Label 739: @33622
     /*  33622 */ GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(33659), // Rule ID 2866 //
     /*  33627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  33630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  33641 */   // (bitconvert:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)  =>  (VREV16q8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$src)
     /*  33641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  33644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  33646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33648 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  33651 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  33657 */   GIR_RootConstrainSelectedInstOperands,
     /*  33658 */   // GIR_Coverage, 2866,
     /*  33658 */   GIR_EraseRootFromParent_Done,
     /*  33659 */ // Label 740: @33659
     /*  33659 */ GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(33691), // Rule ID 5284 //
     /*  33664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33678 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33678 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33681 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33683 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33685 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33690 */   // GIR_Coverage, 5284,
     /*  33690 */   GIR_EraseRootFromParent_Done,
     /*  33691 */ // Label 741: @33691
     /*  33691 */ GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(33723), // Rule ID 5285 //
     /*  33696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  33699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  33702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33706 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33710 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33713 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33715 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33717 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33722 */   // GIR_Coverage, 5285,
     /*  33722 */   GIR_EraseRootFromParent_Done,
     /*  33723 */ // Label 742: @33723
     /*  33723 */ GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(33755), // Rule ID 5306 //
     /*  33728 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33731 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33738 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33742 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33742 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33745 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33747 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33749 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33754 */   // GIR_Coverage, 5306,
     /*  33754 */   GIR_EraseRootFromParent_Done,
     /*  33755 */ // Label 743: @33755
     /*  33755 */ GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(33787), // Rule ID 5307 //
     /*  33760 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33766 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33770 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33774 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33774 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33777 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33779 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33781 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33786 */   // GIR_Coverage, 5307,
     /*  33786 */   GIR_EraseRootFromParent_Done,
     /*  33787 */ // Label 744: @33787
     /*  33787 */ GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(33819), // Rule ID 5308 //
     /*  33792 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33798 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33802 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33806 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33809 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33811 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33813 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33818 */   // GIR_Coverage, 5308,
     /*  33818 */   GIR_EraseRootFromParent_Done,
     /*  33819 */ // Label 745: @33819
     /*  33819 */ GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(33851), // Rule ID 5309 //
     /*  33824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33838 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33841 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33843 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33845 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33850 */   // GIR_Coverage, 5309,
     /*  33850 */   GIR_EraseRootFromParent_Done,
     /*  33851 */ // Label 746: @33851
     /*  33851 */ GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(33883), // Rule ID 5310 //
     /*  33856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  33862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33870 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8f16] }:$src
     /*  33870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33873 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33875 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33877 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33882 */   // GIR_Coverage, 5310,
     /*  33882 */   GIR_EraseRootFromParent_Done,
     /*  33883 */ // Label 747: @33883
     /*  33883 */ GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(33915), // Rule ID 5311 //
     /*  33888 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33902 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33905 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33909 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33914 */   // GIR_Coverage, 5311,
     /*  33914 */   GIR_EraseRootFromParent_Done,
     /*  33915 */ // Label 748: @33915
     /*  33915 */ GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(33947), // Rule ID 5312 //
     /*  33920 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33923 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  33926 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33930 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33934 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33934 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33937 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33939 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33941 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33946 */   // GIR_Coverage, 5312,
     /*  33946 */   GIR_EraseRootFromParent_Done,
     /*  33947 */ // Label 749: @33947
     /*  33947 */ GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(33979), // Rule ID 5313 //
     /*  33952 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33966 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33966 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  33969 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  33971 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  33973 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33978 */   // GIR_Coverage, 5313,
     /*  33978 */   GIR_EraseRootFromParent_Done,
     /*  33979 */ // Label 750: @33979
     /*  33979 */ GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(34011), // Rule ID 5314 //
     /*  33984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  33987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  33990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  33998 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  33998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34001 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34003 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34005 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34010 */   // GIR_Coverage, 5314,
     /*  34010 */   GIR_EraseRootFromParent_Done,
     /*  34011 */ // Label 751: @34011
     /*  34011 */ GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(34043), // Rule ID 5315 //
     /*  34016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  34019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34030 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  MQPR:{ *:[v8i16] }:$src
     /*  34030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34033 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34035 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34037 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34042 */   // GIR_Coverage, 5315,
     /*  34042 */   GIR_EraseRootFromParent_Done,
     /*  34043 */ // Label 752: @34043
     /*  34043 */ GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(34101), // Rule ID 5342 //
     /*  34048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34062 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2f64] }:$src)
     /*  34062 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34065 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34069 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34077 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34081 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34084 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34090 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34096 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34099 */   GIR_RootConstrainSelectedInstOperands,
     /*  34100 */   // GIR_Coverage, 5342,
     /*  34100 */   GIR_EraseRootFromParent_Done,
     /*  34101 */ // Label 753: @34101
     /*  34101 */ GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(34159), // Rule ID 5343 //
     /*  34106 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34120 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8f16] } MQPR:{ *:[v2i64] }:$src)
     /*  34120 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34123 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34127 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34137 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34139 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34142 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34148 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34154 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34157 */   GIR_RootConstrainSelectedInstOperands,
     /*  34158 */   // GIR_Coverage, 5343,
     /*  34158 */   GIR_EraseRootFromParent_Done,
     /*  34159 */ // Label 754: @34159
     /*  34159 */ GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(34217), // Rule ID 5344 //
     /*  34164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34178 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4f32] }:$src)
     /*  34178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34195 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34197 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34200 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34206 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34212 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34215 */   GIR_RootConstrainSelectedInstOperands,
     /*  34216 */   // GIR_Coverage, 5344,
     /*  34216 */   GIR_EraseRootFromParent_Done,
     /*  34217 */ // Label 755: @34217
     /*  34217 */ GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(34275), // Rule ID 5345 //
     /*  34222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34225 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34232 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34236 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8f16] } MQPR:{ *:[v4i32] }:$src)
     /*  34236 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34239 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34243 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34248 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34251 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34253 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34255 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34258 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34264 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34270 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34273 */   GIR_RootConstrainSelectedInstOperands,
     /*  34274 */   // GIR_Coverage, 5345,
     /*  34274 */   GIR_EraseRootFromParent_Done,
     /*  34275 */ // Label 756: @34275
     /*  34275 */ GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(34333), // Rule ID 5346 //
     /*  34280 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34283 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34286 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34290 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34294 */   // (bitconvert:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8f16] } MQPR:{ *:[v16i8] }:$src)
     /*  34294 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34297 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34301 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34311 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34316 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34322 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34328 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34331 */   GIR_RootConstrainSelectedInstOperands,
     /*  34332 */   // GIR_Coverage, 5346,
     /*  34332 */   GIR_EraseRootFromParent_Done,
     /*  34333 */ // Label 757: @34333
     /*  34333 */ GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(34391), // Rule ID 5347 //
     /*  34338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34352 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2f64] }:$src)
     /*  34352 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34355 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34359 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34364 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34367 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34369 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34371 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34380 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34386 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34389 */   GIR_RootConstrainSelectedInstOperands,
     /*  34390 */   // GIR_Coverage, 5347,
     /*  34390 */   GIR_EraseRootFromParent_Done,
     /*  34391 */ // Label 758: @34391
     /*  34391 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(34449), // Rule ID 5348 //
     /*  34396 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34410 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_16:{ *:[v8i16] } MQPR:{ *:[v2i64] }:$src)
     /*  34410 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34413 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34417 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34422 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_16),
     /*  34425 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34427 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34429 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34432 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34438 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34444 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34447 */   GIR_RootConstrainSelectedInstOperands,
     /*  34448 */   // GIR_Coverage, 5348,
     /*  34448 */   GIR_EraseRootFromParent_Done,
     /*  34449 */ // Label 759: @34449
     /*  34449 */ GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(34507), // Rule ID 5349 //
     /*  34454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34460 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34464 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34468 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4f32] }:$src)
     /*  34468 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34471 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34475 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34483 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34496 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34502 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34505 */   GIR_RootConstrainSelectedInstOperands,
     /*  34506 */   // GIR_Coverage, 5349,
     /*  34506 */   GIR_EraseRootFromParent_Done,
     /*  34507 */ // Label 760: @34507
     /*  34507 */ GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(34565), // Rule ID 5350 //
     /*  34512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34526 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_16:{ *:[v8i16] } MQPR:{ *:[v4i32] }:$src)
     /*  34526 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34529 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34533 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34538 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_16),
     /*  34541 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34543 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34554 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34560 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34563 */   GIR_RootConstrainSelectedInstOperands,
     /*  34564 */   // GIR_Coverage, 5350,
     /*  34564 */   GIR_EraseRootFromParent_Done,
     /*  34565 */ // Label 761: @34565
     /*  34565 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(34623), // Rule ID 5351 //
     /*  34570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  34573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  34576 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  34584 */   // (bitconvert:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  34584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  34587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  34591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  34596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  34599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  34601 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34603 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  34606 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34612 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34618 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  34621 */   GIR_RootConstrainSelectedInstOperands,
     /*  34622 */   // GIR_Coverage, 5351,
     /*  34622 */   GIR_EraseRootFromParent_Done,
     /*  34623 */ // Label 762: @34623
     /*  34623 */ GIM_Reject,
     /*  34624 */ // Label 547: @34624
     /*  34624 */ GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(34656), // Rule ID 2795 //
     /*  34629 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34639 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34643 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34646 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34648 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34650 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34655 */   // GIR_Coverage, 2795,
     /*  34655 */   GIR_EraseRootFromParent_Done,
     /*  34656 */ // Label 763: @34656
     /*  34656 */ GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(34688), // Rule ID 2796 //
     /*  34661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34675 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34678 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34680 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34682 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34687 */   // GIR_Coverage, 2796,
     /*  34687 */   GIR_EraseRootFromParent_Done,
     /*  34688 */ // Label 764: @34688
     /*  34688 */ GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(34720), // Rule ID 2797 //
     /*  34693 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34707 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34710 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34712 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34719 */   // GIR_Coverage, 2797,
     /*  34719 */   GIR_EraseRootFromParent_Done,
     /*  34720 */ // Label 765: @34720
     /*  34720 */ GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(34752), // Rule ID 2798 //
     /*  34725 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34728 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34731 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34735 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34739 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34742 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34744 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34746 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34751 */   // GIR_Coverage, 2798,
     /*  34751 */   GIR_EraseRootFromParent_Done,
     /*  34752 */ // Label 766: @34752
     /*  34752 */ GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(34784), // Rule ID 2799 //
     /*  34757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34771 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34771 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34774 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34776 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34778 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34783 */   // GIR_Coverage, 2799,
     /*  34783 */   GIR_EraseRootFromParent_Done,
     /*  34784 */ // Label 767: @34784
     /*  34784 */ GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(34816), // Rule ID 2800 //
     /*  34789 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsLE),
     /*  34792 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34799 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34803 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  QPR:{ *:[v16i8] }:$src
     /*  34803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  34806 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  34808 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34810 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::QPRRegClassID),
     /*  34815 */   // GIR_Coverage, 2800,
     /*  34815 */   GIR_EraseRootFromParent_Done,
     /*  34816 */ // Label 768: @34816
     /*  34816 */ GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(34853), // Rule ID 2867 //
     /*  34821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34835 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2f64] }:$src)
     /*  34835 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34838 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34840 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34842 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34845 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34851 */   GIR_RootConstrainSelectedInstOperands,
     /*  34852 */   // GIR_Coverage, 2867,
     /*  34852 */   GIR_EraseRootFromParent_Done,
     /*  34853 */ // Label 769: @34853
     /*  34853 */ GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(34890), // Rule ID 2868 //
     /*  34858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  34864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34868 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34872 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)  =>  (VREV64q8:{ *:[v16i8] } QPR:{ *:[v2i64] }:$src)
     /*  34872 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV64q8),
     /*  34875 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34877 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34888 */   GIR_RootConstrainSelectedInstOperands,
     /*  34889 */   // GIR_Coverage, 2868,
     /*  34889 */   GIR_EraseRootFromParent_Done,
     /*  34890 */ // Label 770: @34890
     /*  34890 */ GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(34927), // Rule ID 2869 //
     /*  34895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34905 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34909 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4f32] }:$src)
     /*  34909 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34912 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34914 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34916 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34919 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34925 */   GIR_RootConstrainSelectedInstOperands,
     /*  34926 */   // GIR_Coverage, 2869,
     /*  34926 */   GIR_EraseRootFromParent_Done,
     /*  34927 */ // Label 771: @34927
     /*  34927 */ GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(34964), // Rule ID 2870 //
     /*  34932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  34938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34946 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)  =>  (VREV32q8:{ *:[v16i8] } QPR:{ *:[v4i32] }:$src)
     /*  34946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV32q8),
     /*  34949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34962 */   GIR_RootConstrainSelectedInstOperands,
     /*  34963 */   // GIR_Coverage, 2870,
     /*  34963 */   GIR_EraseRootFromParent_Done,
     /*  34964 */ // Label 772: @34964
     /*  34964 */ GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(35001), // Rule ID 2871 //
     /*  34969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  34972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  34983 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8f16] }:$src)
     /*  34983 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  34986 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  34988 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  34990 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  34993 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  34999 */   GIR_RootConstrainSelectedInstOperands,
     /*  35000 */   // GIR_Coverage, 2871,
     /*  35000 */   GIR_EraseRootFromParent_Done,
     /*  35001 */ // Label 773: @35001
     /*  35001 */ GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(35038), // Rule ID 2872 //
     /*  35006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_IsBE),
     /*  35009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  35020 */   // (bitconvert:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)  =>  (VREV16q8:{ *:[v16i8] } QPR:{ *:[v8i16] }:$src)
     /*  35020 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VREV16q8),
     /*  35023 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  35025 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35027 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35030 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35036 */   GIR_RootConstrainSelectedInstOperands,
     /*  35037 */   // GIR_Coverage, 2872,
     /*  35037 */   GIR_EraseRootFromParent_Done,
     /*  35038 */ // Label 774: @35038
     /*  35038 */ GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(35070), // Rule ID 5316 //
     /*  35043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35053 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35057 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35057 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35060 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35062 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35064 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35069 */   // GIR_Coverage, 5316,
     /*  35069 */   GIR_EraseRootFromParent_Done,
     /*  35070 */ // Label 775: @35070
     /*  35070 */ GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(35102), // Rule ID 5317 //
     /*  35075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35081 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35085 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35089 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35089 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35092 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35094 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35101 */   // GIR_Coverage, 5317,
     /*  35101 */   GIR_EraseRootFromParent_Done,
     /*  35102 */ // Label 776: @35102
     /*  35102 */ GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(35134), // Rule ID 5318 //
     /*  35107 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35121 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35124 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35126 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35133 */   // GIR_Coverage, 5318,
     /*  35133 */   GIR_EraseRootFromParent_Done,
     /*  35134 */ // Label 777: @35134
     /*  35134 */ GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(35166), // Rule ID 5319 //
     /*  35139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35153 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35153 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35156 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35158 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35160 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35165 */   // GIR_Coverage, 5319,
     /*  35165 */   GIR_EraseRootFromParent_Done,
     /*  35166 */ // Label 778: @35166
     /*  35166 */ GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(35198), // Rule ID 5320 //
     /*  35171 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35174 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35185 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35185 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35188 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35190 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35197 */   // GIR_Coverage, 5320,
     /*  35197 */   GIR_EraseRootFromParent_Done,
     /*  35198 */ // Label 779: @35198
     /*  35198 */ GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(35230), // Rule ID 5321 //
     /*  35203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsLE),
     /*  35206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35217 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  MQPR:{ *:[v16i8] }:$src
     /*  35217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  35220 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /*  35222 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35224 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35229 */   // GIR_Coverage, 5321,
     /*  35229 */   GIR_EraseRootFromParent_Done,
     /*  35230 */ // Label 780: @35230
     /*  35230 */ GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(35288), // Rule ID 5352 //
     /*  35235 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35241 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35245 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35249 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2f64] }:$src)
     /*  35249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35266 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35268 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35271 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35277 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35286 */   GIR_RootConstrainSelectedInstOperands,
     /*  35287 */   // GIR_Coverage, 5352,
     /*  35287 */   GIR_EraseRootFromParent_Done,
     /*  35288 */ // Label 781: @35288
     /*  35288 */ GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(35346), // Rule ID 5353 //
     /*  35293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  35299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35303 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35307 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)  =>  (MVE_VREV64_8:{ *:[v16i8] } MQPR:{ *:[v2i64] }:$src)
     /*  35307 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35310 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35314 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV64_8),
     /*  35322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35324 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35326 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35329 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35335 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35341 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35344 */   GIR_RootConstrainSelectedInstOperands,
     /*  35345 */   // GIR_Coverage, 5353,
     /*  35345 */   GIR_EraseRootFromParent_Done,
     /*  35346 */ // Label 782: @35346
     /*  35346 */ GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(35404), // Rule ID 5354 //
     /*  35351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35365 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4f32] }:$src)
     /*  35365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35382 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35393 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35399 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35402 */   GIR_RootConstrainSelectedInstOperands,
     /*  35403 */   // GIR_Coverage, 5354,
     /*  35403 */   GIR_EraseRootFromParent_Done,
     /*  35404 */ // Label 783: @35404
     /*  35404 */ GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(35462), // Rule ID 5355 //
     /*  35409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35419 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35423 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src)
     /*  35423 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35426 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35430 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35435 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /*  35438 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35440 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35442 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35445 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35451 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35457 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35460 */   GIR_RootConstrainSelectedInstOperands,
     /*  35461 */   // GIR_Coverage, 5355,
     /*  35461 */   GIR_EraseRootFromParent_Done,
     /*  35462 */ // Label 784: @35462
     /*  35462 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(35520), // Rule ID 5356 //
     /*  35467 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35470 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35477 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35481 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8f16] }:$src)
     /*  35481 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35484 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35488 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35493 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35496 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35498 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35500 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35503 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35518 */   GIR_RootConstrainSelectedInstOperands,
     /*  35519 */   // GIR_Coverage, 5356,
     /*  35519 */   GIR_EraseRootFromParent_Done,
     /*  35520 */ // Label 785: @35520
     /*  35520 */ GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(35578), // Rule ID 5357 //
     /*  35525 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_IsBE),
     /*  35528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35531 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35535 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35539 */   // (bitconvert:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v16i8] } MQPR:{ *:[v8i16] }:$src)
     /*  35539 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35542 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35546 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35551 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /*  35554 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35556 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /*  35558 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35561 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35573 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35576 */   GIR_RootConstrainSelectedInstOperands,
     /*  35577 */   // GIR_Coverage, 5357,
     /*  35577 */   GIR_EraseRootFromParent_Done,
     /*  35578 */ // Label 786: @35578
     /*  35578 */ GIM_Reject,
     /*  35579 */ // Label 548: @35579
     /*  35579 */ GIM_Reject,
     /*  35580 */ // Label 10: @35580
     /*  35580 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 792*/ GIMT_Encode4(35875),
     /*  35591 */ /*GILLT_s16*//*Label 787*/ GIMT_Encode4(35643),
     /*  35595 */ /*GILLT_s32*//*Label 788*/ GIMT_Encode4(35681),
     /*  35599 */ /*GILLT_s64*//*Label 789*/ GIMT_Encode4(35719), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35623 */ /*GILLT_v4s32*//*Label 790*/ GIMT_Encode4(35757), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35639 */ /*GILLT_v8s16*//*Label 791*/ GIMT_Encode4(35816),
     /*  35643 */ // Label 787: @35643
     /*  35643 */ GIM_Try, /*On fail goto*//*Label 793*/ GIMT_Encode4(35680), // Rule ID 665 //
     /*  35648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35662 */   // (ftrunc:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTZH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZH),
     /*  35665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35667 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35672 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35678 */   GIR_RootConstrainSelectedInstOperands,
     /*  35679 */   // GIR_Coverage, 665,
     /*  35679 */   GIR_EraseRootFromParent_Done,
     /*  35680 */ // Label 793: @35680
     /*  35680 */ GIM_Reject,
     /*  35681 */ // Label 788: @35681
     /*  35681 */ GIM_Try, /*On fail goto*//*Label 794*/ GIMT_Encode4(35718), // Rule ID 666 //
     /*  35686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35700 */   // (ftrunc:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTZS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZS),
     /*  35703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  35705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /*  35707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35716 */   GIR_RootConstrainSelectedInstOperands,
     /*  35717 */   // GIR_Coverage, 666,
     /*  35717 */   GIR_EraseRootFromParent_Done,
     /*  35718 */ // Label 794: @35718
     /*  35718 */ GIM_Reject,
     /*  35719 */ // Label 789: @35719
     /*  35719 */ GIM_Try, /*On fail goto*//*Label 795*/ GIMT_Encode4(35756), // Rule ID 667 //
     /*  35724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  35727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  35730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  35738 */   // (ftrunc:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTZD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  35738 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZD),
     /*  35741 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  35743 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /*  35745 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  35748 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35754 */   GIR_RootConstrainSelectedInstOperands,
     /*  35755 */   // GIR_Coverage, 667,
     /*  35755 */   GIR_EraseRootFromParent_Done,
     /*  35756 */ // Label 795: @35756
     /*  35756 */ GIM_Reject,
     /*  35757 */ // Label 790: @35757
     /*  35757 */ GIM_Try, /*On fail goto*//*Label 796*/ GIMT_Encode4(35815), // Rule ID 3979 //
     /*  35762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  35768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35776 */   // (ftrunc:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32Z:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  35776 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35779 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35783 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32Z),
     /*  35791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35793 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35795 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35798 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35804 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35810 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35813 */   GIR_RootConstrainSelectedInstOperands,
     /*  35814 */   // GIR_Coverage, 3979,
     /*  35814 */   GIR_EraseRootFromParent_Done,
     /*  35815 */ // Label 796: @35815
     /*  35815 */ GIM_Reject,
     /*  35816 */ // Label 791: @35816
     /*  35816 */ GIM_Try, /*On fail goto*//*Label 797*/ GIMT_Encode4(35874), // Rule ID 3967 //
     /*  35821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  35824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  35827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35831 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  35835 */   // (ftrunc:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16Z:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  35835 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  35838 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  35842 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  35847 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16Z),
     /*  35850 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  35852 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  35854 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  35857 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35863 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  35869 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  35872 */   GIR_RootConstrainSelectedInstOperands,
     /*  35873 */   // GIR_Coverage, 3967,
     /*  35873 */   GIR_EraseRootFromParent_Done,
     /*  35874 */ // Label 797: @35874
     /*  35874 */ GIM_Reject,
     /*  35875 */ // Label 792: @35875
     /*  35875 */ GIM_Reject,
     /*  35876 */ // Label 11: @35876
     /*  35876 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 803*/ GIMT_Encode4(36138),
     /*  35887 */ /*GILLT_s16*//*Label 798*/ GIMT_Encode4(35939),
     /*  35891 */ /*GILLT_s32*//*Label 799*/ GIMT_Encode4(35966),
     /*  35895 */ /*GILLT_s64*//*Label 800*/ GIMT_Encode4(35993), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35919 */ /*GILLT_v4s32*//*Label 801*/ GIMT_Encode4(36020), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  35935 */ /*GILLT_v8s16*//*Label 802*/ GIMT_Encode4(36079),
     /*  35939 */ // Label 798: @35939
     /*  35939 */ GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(35965), // Rule ID 674 //
     /*  35944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  35947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /*  35950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  35958 */   // (fround:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTAH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  35958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAH),
     /*  35963 */   GIR_RootConstrainSelectedInstOperands,
     /*  35964 */   // GIR_Coverage, 674,
     /*  35964 */   GIR_Done,
     /*  35965 */ // Label 804: @35965
     /*  35965 */ GIM_Reject,
     /*  35966 */ // Label 799: @35966
     /*  35966 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(35992), // Rule ID 675 //
     /*  35971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  35974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  35977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  35985 */   // (fround:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTAS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  35985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAS),
     /*  35990 */   GIR_RootConstrainSelectedInstOperands,
     /*  35991 */   // GIR_Coverage, 675,
     /*  35991 */   GIR_Done,
     /*  35992 */ // Label 805: @35992
     /*  35992 */ GIM_Reject,
     /*  35993 */ // Label 800: @35993
     /*  35993 */ GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(36019), // Rule ID 676 //
     /*  35998 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  36004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36008 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36012 */   // (fround:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTAD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36012 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTAD),
     /*  36017 */   GIR_RootConstrainSelectedInstOperands,
     /*  36018 */   // GIR_Coverage, 676,
     /*  36018 */   GIR_Done,
     /*  36019 */ // Label 806: @36019
     /*  36019 */ GIM_Reject,
     /*  36020 */ // Label 801: @36020
     /*  36020 */ GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(36078), // Rule ID 3977 //
     /*  36025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  36031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36039 */   // (fround:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32A:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  36039 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36042 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36046 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36051 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32A),
     /*  36054 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36056 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36058 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36061 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36067 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36073 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36076 */   GIR_RootConstrainSelectedInstOperands,
     /*  36077 */   // GIR_Coverage, 3977,
     /*  36077 */   GIR_EraseRootFromParent_Done,
     /*  36078 */ // Label 807: @36078
     /*  36078 */ GIM_Reject,
     /*  36079 */ // Label 802: @36079
     /*  36079 */ GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(36137), // Rule ID 3965 //
     /*  36084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  36087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  36090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  36098 */   // (fround:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16A:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  36098 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  36101 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  36105 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36110 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16A),
     /*  36113 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  36115 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /*  36117 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36120 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36126 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36135 */   GIR_RootConstrainSelectedInstOperands,
     /*  36136 */   // GIR_Coverage, 3965,
     /*  36136 */   GIR_EraseRootFromParent_Done,
     /*  36137 */ // Label 808: @36137
     /*  36137 */ GIM_Reject,
     /*  36138 */ // Label 803: @36138
     /*  36138 */ GIM_Reject,
     /*  36139 */ // Label 12: @36139
     /*  36139 */ GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(36301),
     /*  36144 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36147 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /*  36150 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(36225), // Rule ID 2050 //
     /*  36155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36158 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /*  36165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36169 */     // MIs[0] Rn
     /*  36169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36177 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (tLDRSB:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36189 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36195 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36198 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36201 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSB),
     /*  36212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36219 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36223 */     GIR_RootConstrainSelectedInstOperands,
     /*  36224 */     // GIR_Coverage, 2050,
     /*  36224 */     GIR_EraseRootFromParent_Done,
     /*  36225 */   // Label 810: @36225
     /*  36225 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(36300), // Rule ID 2051 //
     /*  36230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /*  36233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /*  36240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36244 */     // MIs[0] Rn
     /*  36244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  36248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  36252 */     // (ld:{ *:[i32] } tGPR:{ *:[i32] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (tLDRSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /*  36252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  36255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  36259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  36264 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  36270 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  36273 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /*  36276 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  36284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLDRSH),
     /*  36287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  36289 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  36291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  36294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  36298 */     GIR_RootConstrainSelectedInstOperands,
     /*  36299 */     // GIR_Coverage, 2051,
     /*  36299 */     GIR_EraseRootFromParent_Done,
     /*  36300 */   // Label 811: @36300
     /*  36300 */   GIM_Reject,
     /*  36301 */ // Label 809: @36301
     /*  36301 */ GIM_Reject,
     /*  36302 */ // Label 13: @36302
     /*  36302 */ GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(36322), // Rule ID 5418 //
     /*  36307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  36310 */   // MIs[0] Operand 0
     /*  36310 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /*  36313 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  36317 */   // (atomic_fence (timm:{ *:[i32] }), 0:{ *:[i32] })  =>  (MEMBARRIER)
     /*  36317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::MEMBARRIER),
     /*  36320 */   GIR_RootConstrainSelectedInstOperands,
     /*  36321 */   // GIR_Coverage, 5418,
     /*  36321 */   GIR_EraseRootFromParent_Done,
     /*  36322 */ // Label 812: @36322
     /*  36322 */ GIM_Reject,
     /*  36323 */ // Label 14: @36323
     /*  36323 */ GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(42138),
     /*  36328 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  36331 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(36379), // Rule ID 1853 //
     /*  36336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  36339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  36354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  36358 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (UXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  36358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTB16),
     /*  36361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  36365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36371 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36377 */     GIR_RootConstrainSelectedInstOperands,
     /*  36378 */     // GIR_Coverage, 1853,
     /*  36378 */     GIR_EraseRootFromParent_Done,
     /*  36379 */   // Label 814: @36379
     /*  36379 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(36427), // Rule ID 2107 //
     /*  36384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  36387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtb16),
     /*  36392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  36406 */     // (intrinsic_wo_chain:{ *:[i32] } 3918:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  36406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTB16),
     /*  36409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  36413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  36416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36425 */     GIR_RootConstrainSelectedInstOperands,
     /*  36426 */     // GIR_Coverage, 2107,
     /*  36426 */     GIR_EraseRootFromParent_Done,
     /*  36427 */   // Label 815: @36427
     /*  36427 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(36463), // Rule ID 677 //
     /*  36432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /*  36435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  36443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  36446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  36454 */     // (intrinsic_wo_chain:{ *:[f16] } 3804:{ *:[iPTR] }, HPR:{ *:[f16] }:$Sm)  =>  (VRINTNH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /*  36454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNH),
     /*  36457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36461 */     GIR_RootConstrainSelectedInstOperands,
     /*  36462 */     // GIR_Coverage, 677,
     /*  36462 */     GIR_EraseRootFromParent_Done,
     /*  36463 */   // Label 816: @36463
     /*  36463 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(36499), // Rule ID 678 //
     /*  36468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /*  36471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36490 */     // (intrinsic_wo_chain:{ *:[f32] } 3804:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VRINTNS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNS),
     /*  36493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36497 */     GIR_RootConstrainSelectedInstOperands,
     /*  36498 */     // GIR_Coverage, 678,
     /*  36498 */     GIR_EraseRootFromParent_Done,
     /*  36499 */   // Label 817: @36499
     /*  36499 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(36535), // Rule ID 679 //
     /*  36504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /*  36507 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  36512 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36515 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36526 */     // (intrinsic_wo_chain:{ *:[f64] } 3804:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VRINTND:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /*  36526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTND),
     /*  36529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  36531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36533 */     GIR_RootConstrainSelectedInstOperands,
     /*  36534 */     // GIR_Coverage, 679,
     /*  36534 */     GIR_EraseRootFromParent_Done,
     /*  36535 */   // Label 818: @36535
     /*  36535 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(36580), // Rule ID 693 //
     /*  36540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36558 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36562 */     // (intrinsic_wo_chain:{ *:[f32] } 3919:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOSIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRD),
     /*  36565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36578 */     GIR_RootConstrainSelectedInstOperands,
     /*  36579 */     // GIR_Coverage, 693,
     /*  36579 */     GIR_EraseRootFromParent_Done,
     /*  36580 */   // Label 819: @36580
     /*  36580 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(36625), // Rule ID 694 //
     /*  36585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtr),
     /*  36593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36607 */     // (intrinsic_wo_chain:{ *:[f32] } 3919:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOSIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOSIRS),
     /*  36610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36623 */     GIR_RootConstrainSelectedInstOperands,
     /*  36624 */     // GIR_Coverage, 694,
     /*  36624 */     GIR_EraseRootFromParent_Done,
     /*  36625 */   // Label 820: @36625
     /*  36625 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(36670), // Rule ID 695 //
     /*  36630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /*  36633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  36644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36652 */     // (intrinsic_wo_chain:{ *:[f32] } 3920:{ *:[iPTR] }, DPR:{ *:[f64] }:$Dm)  =>  (VTOUIRD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /*  36652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRD),
     /*  36655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /*  36659 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36662 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36668 */     GIR_RootConstrainSelectedInstOperands,
     /*  36669 */     // GIR_Coverage, 695,
     /*  36669 */     GIR_EraseRootFromParent_Done,
     /*  36670 */   // Label 821: @36670
     /*  36670 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(36715), // Rule ID 696 //
     /*  36675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /*  36678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_vcvtru),
     /*  36683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  36686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  36689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  36697 */     // (intrinsic_wo_chain:{ *:[f32] } 3920:{ *:[iPTR] }, SPR:{ *:[f32] }:$Sm)  =>  (VTOUIRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /*  36697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTOUIRS),
     /*  36700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  36702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /*  36704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36713 */     GIR_RootConstrainSelectedInstOperands,
     /*  36714 */     // GIR_Coverage, 696,
     /*  36714 */     GIR_EraseRootFromParent_Done,
     /*  36715 */   // Label 822: @36715
     /*  36715 */   GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(36760), // Rule ID 1239 //
     /*  36720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  36731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  36734 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36742 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3770:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLsv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  36742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i8),
     /*  36745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36758 */     GIR_RootConstrainSelectedInstOperands,
     /*  36759 */     // GIR_Coverage, 1239,
     /*  36759 */     GIR_EraseRootFromParent_Done,
     /*  36760 */   // Label 823: @36760
     /*  36760 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(36805), // Rule ID 1240 //
     /*  36765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  36776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  36779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36787 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3770:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLsv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  36787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i16),
     /*  36790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36803 */     GIR_RootConstrainSelectedInstOperands,
     /*  36804 */     // GIR_Coverage, 1240,
     /*  36804 */     GIR_EraseRootFromParent_Done,
     /*  36805 */   // Label 824: @36805
     /*  36805 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(36850), // Rule ID 1241 //
     /*  36810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  36821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  36824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  36832 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3770:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLsv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  36832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv2i32),
     /*  36835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36848 */     GIR_RootConstrainSelectedInstOperands,
     /*  36849 */     // GIR_Coverage, 1241,
     /*  36849 */     GIR_EraseRootFromParent_Done,
     /*  36850 */   // Label 825: @36850
     /*  36850 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(36895), // Rule ID 1242 //
     /*  36855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  36866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36877 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3770:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLsv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  36877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv16i8),
     /*  36880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36884 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36893 */     GIR_RootConstrainSelectedInstOperands,
     /*  36894 */     // GIR_Coverage, 1242,
     /*  36894 */     GIR_EraseRootFromParent_Done,
     /*  36895 */   // Label 826: @36895
     /*  36895 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(36940), // Rule ID 1243 //
     /*  36900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  36911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  36914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36922 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3770:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLsv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  36922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv8i16),
     /*  36925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36932 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36938 */     GIR_RootConstrainSelectedInstOperands,
     /*  36939 */     // GIR_Coverage, 1243,
     /*  36939 */     GIR_EraseRootFromParent_Done,
     /*  36940 */   // Label 827: @36940
     /*  36940 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(36985), // Rule ID 1244 //
     /*  36945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddls),
     /*  36953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  36956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  36959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  36967 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3770:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLsv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  36967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLsv4i32),
     /*  36970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  36972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  36974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  36977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  36983 */     GIR_RootConstrainSelectedInstOperands,
     /*  36984 */     // GIR_Coverage, 1244,
     /*  36984 */     GIR_EraseRootFromParent_Done,
     /*  36985 */   // Label 828: @36985
     /*  36985 */   GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(37030), // Rule ID 1245 //
     /*  36990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  36998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37012 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3771:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDLuv8i8:{ *:[v4i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  37012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i8),
     /*  37015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37028 */     GIR_RootConstrainSelectedInstOperands,
     /*  37029 */     // GIR_Coverage, 1245,
     /*  37029 */     GIR_EraseRootFromParent_Done,
     /*  37030 */   // Label 829: @37030
     /*  37030 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(37075), // Rule ID 1246 //
     /*  37035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37057 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3771:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDLuv4i16:{ *:[v2i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  37057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i16),
     /*  37060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37073 */     GIR_RootConstrainSelectedInstOperands,
     /*  37074 */     // GIR_Coverage, 1246,
     /*  37074 */     GIR_EraseRootFromParent_Done,
     /*  37075 */   // Label 830: @37075
     /*  37075 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(37120), // Rule ID 1247 //
     /*  37080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  37091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37102 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3771:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDLuv2i32:{ *:[v1i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  37102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv2i32),
     /*  37105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37118 */     GIR_RootConstrainSelectedInstOperands,
     /*  37119 */     // GIR_Coverage, 1247,
     /*  37119 */     GIR_EraseRootFromParent_Done,
     /*  37120 */   // Label 831: @37120
     /*  37120 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(37165), // Rule ID 1248 //
     /*  37125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37143 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37147 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3771:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADDLuv16i8:{ *:[v8i16] } QPR:{ *:[v16i8] }:$Vm)
     /*  37147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv16i8),
     /*  37150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37163 */     GIR_RootConstrainSelectedInstOperands,
     /*  37164 */     // GIR_Coverage, 1248,
     /*  37164 */     GIR_EraseRootFromParent_Done,
     /*  37165 */   // Label 832: @37165
     /*  37165 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(37210), // Rule ID 1249 //
     /*  37170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3771:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADDLuv8i16:{ *:[v4i32] } QPR:{ *:[v8i16] }:$Vm)
     /*  37192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv8i16),
     /*  37195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37208 */     GIR_RootConstrainSelectedInstOperands,
     /*  37209 */     // GIR_Coverage, 1249,
     /*  37209 */     GIR_EraseRootFromParent_Done,
     /*  37210 */   // Label 833: @37210
     /*  37210 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(37255), // Rule ID 1250 //
     /*  37215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpaddlu),
     /*  37223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  37226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37237 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3771:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADDLuv4i32:{ *:[v2i64] } QPR:{ *:[v4i32] }:$Vm)
     /*  37237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDLuv4i32),
     /*  37240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37253 */     GIR_RootConstrainSelectedInstOperands,
     /*  37254 */     // GIR_Coverage, 1250,
     /*  37254 */     GIR_EraseRootFromParent_Done,
     /*  37255 */   // Label 834: @37255
     /*  37255 */   GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(37300), // Rule ID 1279 //
     /*  37260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37282 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRECPEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEd),
     /*  37285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37298 */     GIR_RootConstrainSelectedInstOperands,
     /*  37299 */     // GIR_Coverage, 1279,
     /*  37299 */     GIR_EraseRootFromParent_Done,
     /*  37300 */   // Label 835: @37300
     /*  37300 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(37345), // Rule ID 1280 //
     /*  37305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37327 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRECPEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEq),
     /*  37330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37334 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37337 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37343 */     GIR_RootConstrainSelectedInstOperands,
     /*  37344 */     // GIR_Coverage, 1280,
     /*  37344 */     GIR_EraseRootFromParent_Done,
     /*  37345 */   // Label 836: @37345
     /*  37345 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(37390), // Rule ID 1281 //
     /*  37350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37372 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3798:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfd),
     /*  37375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37388 */     GIR_RootConstrainSelectedInstOperands,
     /*  37389 */     // GIR_Coverage, 1281,
     /*  37389 */     GIR_EraseRootFromParent_Done,
     /*  37390 */   // Label 837: @37390
     /*  37390 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(37435), // Rule ID 1282 //
     /*  37395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37417 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3798:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEfq),
     /*  37420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37433 */     GIR_RootConstrainSelectedInstOperands,
     /*  37434 */     // GIR_Coverage, 1282,
     /*  37434 */     GIR_EraseRootFromParent_Done,
     /*  37435 */   // Label 838: @37435
     /*  37435 */   GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(37480), // Rule ID 1283 //
     /*  37440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37462 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3798:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhd),
     /*  37465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37478 */     GIR_RootConstrainSelectedInstOperands,
     /*  37479 */     // GIR_Coverage, 1283,
     /*  37479 */     GIR_EraseRootFromParent_Done,
     /*  37480 */   // Label 839: @37480
     /*  37480 */   GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(37525), // Rule ID 1284 //
     /*  37485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecpe),
     /*  37493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37507 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3798:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPEhq),
     /*  37510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37523 */     GIR_RootConstrainSelectedInstOperands,
     /*  37524 */     // GIR_Coverage, 1284,
     /*  37524 */     GIR_EraseRootFromParent_Done,
     /*  37525 */   // Label 840: @37525
     /*  37525 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(37570), // Rule ID 1289 //
     /*  37530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VRSQRTEd:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEd),
     /*  37555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37568 */     GIR_RootConstrainSelectedInstOperands,
     /*  37569 */     // GIR_Coverage, 1289,
     /*  37569 */     GIR_EraseRootFromParent_Done,
     /*  37570 */   // Label 841: @37570
     /*  37570 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(37615), // Rule ID 1290 //
     /*  37575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37597 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSQRTEq:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  37597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEq),
     /*  37600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37613 */     GIR_RootConstrainSelectedInstOperands,
     /*  37614 */     // GIR_Coverage, 1290,
     /*  37614 */     GIR_EraseRootFromParent_Done,
     /*  37615 */   // Label 842: @37615
     /*  37615 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(37660), // Rule ID 1291 //
     /*  37620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37642 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3811:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTEfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  37642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfd),
     /*  37645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37658 */     GIR_RootConstrainSelectedInstOperands,
     /*  37659 */     // GIR_Coverage, 1291,
     /*  37659 */     GIR_EraseRootFromParent_Done,
     /*  37660 */   // Label 843: @37660
     /*  37660 */   GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(37705), // Rule ID 1292 //
     /*  37665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  37676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  37679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37687 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3811:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTEfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  37687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEfq),
     /*  37690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37703 */     GIR_RootConstrainSelectedInstOperands,
     /*  37704 */     // GIR_Coverage, 1292,
     /*  37704 */     GIR_EraseRootFromParent_Done,
     /*  37705 */   // Label 844: @37705
     /*  37705 */   GIM_Try, /*On fail goto*//*Label 845*/ GIMT_Encode4(37750), // Rule ID 1293 //
     /*  37710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37732 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3811:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTEhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  37732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhd),
     /*  37735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37748 */     GIR_RootConstrainSelectedInstOperands,
     /*  37749 */     // GIR_Coverage, 1293,
     /*  37749 */     GIR_EraseRootFromParent_Done,
     /*  37750 */   // Label 845: @37750
     /*  37750 */   GIM_Try, /*On fail goto*//*Label 846*/ GIMT_Encode4(37795), // Rule ID 1294 //
     /*  37755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  37758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrte),
     /*  37763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37777 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3811:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTEhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  37777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTEhq),
     /*  37780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37793 */     GIR_RootConstrainSelectedInstOperands,
     /*  37794 */     // GIR_Coverage, 1294,
     /*  37794 */     GIR_EraseRootFromParent_Done,
     /*  37795 */   // Label 846: @37795
     /*  37795 */   GIM_Try, /*On fail goto*//*Label 847*/ GIMT_Encode4(37840), // Rule ID 1515 //
     /*  37800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  37811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  37814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37822 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3776:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  37822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i8),
     /*  37825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37838 */     GIR_RootConstrainSelectedInstOperands,
     /*  37839 */     // GIR_Coverage, 1515,
     /*  37839 */     GIR_EraseRootFromParent_Done,
     /*  37840 */   // Label 847: @37840
     /*  37840 */   GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(37885), // Rule ID 1516 //
     /*  37845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  37856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  37859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37867 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3776:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  37867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i16),
     /*  37870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37883 */     GIR_RootConstrainSelectedInstOperands,
     /*  37884 */     // GIR_Coverage, 1516,
     /*  37884 */     GIR_EraseRootFromParent_Done,
     /*  37885 */   // Label 848: @37885
     /*  37885 */   GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(37930), // Rule ID 1517 //
     /*  37890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  37901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  37904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  37912 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3776:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  37912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv2i32),
     /*  37915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37928 */     GIR_RootConstrainSelectedInstOperands,
     /*  37929 */     // GIR_Coverage, 1517,
     /*  37929 */     GIR_EraseRootFromParent_Done,
     /*  37930 */   // Label 849: @37930
     /*  37930 */   GIM_Try, /*On fail goto*//*Label 850*/ GIMT_Encode4(37975), // Rule ID 1518 //
     /*  37935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  37946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  37949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37957 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3776:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  37957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv16i8),
     /*  37960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  37962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  37964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  37967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37973 */     GIR_RootConstrainSelectedInstOperands,
     /*  37974 */     // GIR_Coverage, 1518,
     /*  37974 */     GIR_EraseRootFromParent_Done,
     /*  37975 */   // Label 850: @37975
     /*  37975 */   GIM_Try, /*On fail goto*//*Label 851*/ GIMT_Encode4(38020), // Rule ID 1519 //
     /*  37980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  37983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  37988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  37991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  37994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  37998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38002 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3776:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv8i16),
     /*  38005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38009 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38018 */     GIR_RootConstrainSelectedInstOperands,
     /*  38019 */     // GIR_Coverage, 1519,
     /*  38019 */     GIR_EraseRootFromParent_Done,
     /*  38020 */   // Label 851: @38020
     /*  38020 */   GIM_Try, /*On fail goto*//*Label 852*/ GIMT_Encode4(38065), // Rule ID 1520 //
     /*  38025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqabs),
     /*  38033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38047 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3776:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQABSv4i32),
     /*  38050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38063 */     GIR_RootConstrainSelectedInstOperands,
     /*  38064 */     // GIR_Coverage, 1520,
     /*  38064 */     GIR_EraseRootFromParent_Done,
     /*  38065 */   // Label 852: @38065
     /*  38065 */   GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(38110), // Rule ID 1531 //
     /*  38070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38092 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3782:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VQNEGv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i8),
     /*  38095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38108 */     GIR_RootConstrainSelectedInstOperands,
     /*  38109 */     // GIR_Coverage, 1531,
     /*  38109 */     GIR_EraseRootFromParent_Done,
     /*  38110 */   // Label 853: @38110
     /*  38110 */   GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(38155), // Rule ID 1532 //
     /*  38115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38137 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3782:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VQNEGv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i16),
     /*  38140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38153 */     GIR_RootConstrainSelectedInstOperands,
     /*  38154 */     // GIR_Coverage, 1532,
     /*  38154 */     GIR_EraseRootFromParent_Done,
     /*  38155 */   // Label 854: @38155
     /*  38155 */   GIM_Try, /*On fail goto*//*Label 855*/ GIMT_Encode4(38200), // Rule ID 1533 //
     /*  38160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38182 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3782:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VQNEGv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv2i32),
     /*  38185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38198 */     GIR_RootConstrainSelectedInstOperands,
     /*  38199 */     // GIR_Coverage, 1533,
     /*  38199 */     GIR_EraseRootFromParent_Done,
     /*  38200 */   // Label 855: @38200
     /*  38200 */   GIM_Try, /*On fail goto*//*Label 856*/ GIMT_Encode4(38245), // Rule ID 1534 //
     /*  38205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38227 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3782:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VQNEGv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv16i8),
     /*  38230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38243 */     GIR_RootConstrainSelectedInstOperands,
     /*  38244 */     // GIR_Coverage, 1534,
     /*  38244 */     GIR_EraseRootFromParent_Done,
     /*  38245 */   // Label 856: @38245
     /*  38245 */   GIM_Try, /*On fail goto*//*Label 857*/ GIMT_Encode4(38290), // Rule ID 1535 //
     /*  38250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38272 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3782:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQNEGv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv8i16),
     /*  38275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38288 */     GIR_RootConstrainSelectedInstOperands,
     /*  38289 */     // GIR_Coverage, 1535,
     /*  38289 */     GIR_EraseRootFromParent_Done,
     /*  38290 */   // Label 857: @38290
     /*  38290 */   GIM_Try, /*On fail goto*//*Label 858*/ GIMT_Encode4(38335), // Rule ID 1536 //
     /*  38295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqneg),
     /*  38303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38317 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3782:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQNEGv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQNEGv4i32),
     /*  38320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38327 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38333 */     GIR_RootConstrainSelectedInstOperands,
     /*  38334 */     // GIR_Coverage, 1536,
     /*  38334 */     GIR_EraseRootFromParent_Done,
     /*  38335 */   // Label 858: @38335
     /*  38335 */   GIM_Try, /*On fail goto*//*Label 859*/ GIMT_Encode4(38380), // Rule ID 1537 //
     /*  38340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  38354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38362 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3723:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm)  =>  (VCLSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /*  38362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i8),
     /*  38365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38378 */     GIR_RootConstrainSelectedInstOperands,
     /*  38379 */     // GIR_Coverage, 1537,
     /*  38379 */     GIR_EraseRootFromParent_Done,
     /*  38380 */   // Label 859: @38380
     /*  38380 */   GIM_Try, /*On fail goto*//*Label 860*/ GIMT_Encode4(38425), // Rule ID 1538 //
     /*  38385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  38399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38407 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3723:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCLSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /*  38407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i16),
     /*  38410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38423 */     GIR_RootConstrainSelectedInstOperands,
     /*  38424 */     // GIR_Coverage, 1538,
     /*  38424 */     GIR_EraseRootFromParent_Done,
     /*  38425 */   // Label 860: @38425
     /*  38425 */   GIM_Try, /*On fail goto*//*Label 861*/ GIMT_Encode4(38470), // Rule ID 1539 //
     /*  38430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  38444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38452 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3723:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm)  =>  (VCLSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /*  38452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv2i32),
     /*  38455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38468 */     GIR_RootConstrainSelectedInstOperands,
     /*  38469 */     // GIR_Coverage, 1539,
     /*  38469 */     GIR_EraseRootFromParent_Done,
     /*  38470 */   // Label 861: @38470
     /*  38470 */   GIM_Try, /*On fail goto*//*Label 862*/ GIMT_Encode4(38515), // Rule ID 1540 //
     /*  38475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  38486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  38489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38497 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3723:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (VCLSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  38497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv16i8),
     /*  38500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38513 */     GIR_RootConstrainSelectedInstOperands,
     /*  38514 */     // GIR_Coverage, 1540,
     /*  38514 */     GIR_EraseRootFromParent_Done,
     /*  38515 */   // Label 862: @38515
     /*  38515 */   GIM_Try, /*On fail goto*//*Label 863*/ GIMT_Encode4(38560), // Rule ID 1541 //
     /*  38520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38523 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38528 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  38531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38542 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3723:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VCLSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /*  38542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv8i16),
     /*  38545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38558 */     GIR_RootConstrainSelectedInstOperands,
     /*  38559 */     // GIR_Coverage, 1541,
     /*  38559 */     GIR_EraseRootFromParent_Done,
     /*  38560 */   // Label 863: @38560
     /*  38560 */   GIM_Try, /*On fail goto*//*Label 864*/ GIMT_Encode4(38605), // Rule ID 1542 //
     /*  38565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcls),
     /*  38573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  38576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38587 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3723:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VCLSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /*  38587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLSv4i32),
     /*  38590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38603 */     GIR_RootConstrainSelectedInstOperands,
     /*  38604 */     // GIR_Coverage, 1542,
     /*  38604 */     GIR_EraseRootFromParent_Done,
     /*  38605 */   // Label 864: @38605
     /*  38605 */   GIM_Try, /*On fail goto*//*Label 865*/ GIMT_Encode4(38650), // Rule ID 1586 //
     /*  38610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38613 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38618 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38621 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38632 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3779:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv8i8),
     /*  38635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38642 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38648 */     GIR_RootConstrainSelectedInstOperands,
     /*  38649 */     // GIR_Coverage, 1586,
     /*  38649 */     GIR_EraseRootFromParent_Done,
     /*  38650 */   // Label 865: @38650
     /*  38650 */   GIM_Try, /*On fail goto*//*Label 866*/ GIMT_Encode4(38695), // Rule ID 1587 //
     /*  38655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38677 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3779:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv4i16),
     /*  38680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38693 */     GIR_RootConstrainSelectedInstOperands,
     /*  38694 */     // GIR_Coverage, 1587,
     /*  38694 */     GIR_EraseRootFromParent_Done,
     /*  38695 */   // Label 866: @38695
     /*  38695 */   GIM_Try, /*On fail goto*//*Label 867*/ GIMT_Encode4(38740), // Rule ID 1588 //
     /*  38700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovns),
     /*  38708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38722 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3779:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsv2i32),
     /*  38725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38738 */     GIR_RootConstrainSelectedInstOperands,
     /*  38739 */     // GIR_Coverage, 1588,
     /*  38739 */     GIR_EraseRootFromParent_Done,
     /*  38740 */   // Label 867: @38740
     /*  38740 */   GIM_Try, /*On fail goto*//*Label 868*/ GIMT_Encode4(38785), // Rule ID 1589 //
     /*  38745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38767 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3781:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv8i8),
     /*  38770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38783 */     GIR_RootConstrainSelectedInstOperands,
     /*  38784 */     // GIR_Coverage, 1589,
     /*  38784 */     GIR_EraseRootFromParent_Done,
     /*  38785 */   // Label 868: @38785
     /*  38785 */   GIM_Try, /*On fail goto*//*Label 869*/ GIMT_Encode4(38830), // Rule ID 1590 //
     /*  38790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38812 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3781:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv4i16),
     /*  38815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38828 */     GIR_RootConstrainSelectedInstOperands,
     /*  38829 */     // GIR_Coverage, 1590,
     /*  38829 */     GIR_EraseRootFromParent_Done,
     /*  38830 */   // Label 869: @38830
     /*  38830 */   GIM_Try, /*On fail goto*//*Label 870*/ GIMT_Encode4(38875), // Rule ID 1591 //
     /*  38835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnu),
     /*  38843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38857 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3781:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNuv2i32),
     /*  38860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38867 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38873 */     GIR_RootConstrainSelectedInstOperands,
     /*  38874 */     // GIR_Coverage, 1591,
     /*  38874 */     GIR_EraseRootFromParent_Done,
     /*  38875 */   // Label 870: @38875
     /*  38875 */   GIM_Try, /*On fail goto*//*Label 871*/ GIMT_Encode4(38920), // Rule ID 1592 //
     /*  38880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  38891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  38894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38902 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3780:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm)  =>  (VQMOVNsuv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  38902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv8i8),
     /*  38905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38918 */     GIR_RootConstrainSelectedInstOperands,
     /*  38919 */     // GIR_Coverage, 1592,
     /*  38919 */     GIR_EraseRootFromParent_Done,
     /*  38920 */   // Label 871: @38920
     /*  38920 */   GIM_Try, /*On fail goto*//*Label 872*/ GIMT_Encode4(38965), // Rule ID 1593 //
     /*  38925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  38936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  38939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38947 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3780:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm)  =>  (VQMOVNsuv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  38947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv4i16),
     /*  38950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  38957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  38963 */     GIR_RootConstrainSelectedInstOperands,
     /*  38964 */     // GIR_Coverage, 1593,
     /*  38964 */     GIR_EraseRootFromParent_Done,
     /*  38965 */   // Label 872: @38965
     /*  38965 */   GIM_Try, /*On fail goto*//*Label 873*/ GIMT_Encode4(39010), // Rule ID 1594 //
     /*  38970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  38973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqmovnsu),
     /*  38978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  38981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  38984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  38988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  38992 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3780:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm)  =>  (VQMOVNsuv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  38992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQMOVNsuv2i32),
     /*  38995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  38997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  38999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  39002 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39008 */     GIR_RootConstrainSelectedInstOperands,
     /*  39009 */     // GIR_Coverage, 1594,
     /*  39009 */     GIR_EraseRootFromParent_Done,
     /*  39010 */   // Label 873: @39010
     /*  39010 */   GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(39046), // Rule ID 1617 //
     /*  39015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39037 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3724:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDf),
     /*  39040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39044 */     GIR_RootConstrainSelectedInstOperands,
     /*  39045 */     // GIR_Coverage, 1617,
     /*  39045 */     GIR_EraseRootFromParent_Done,
     /*  39046 */   // Label 874: @39046
     /*  39046 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(39082), // Rule ID 1618 //
     /*  39051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39073 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3724:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQf),
     /*  39076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39080 */     GIR_RootConstrainSelectedInstOperands,
     /*  39081 */     // GIR_Coverage, 1618,
     /*  39081 */     GIR_EraseRootFromParent_Done,
     /*  39082 */   // Label 875: @39082
     /*  39082 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(39118), // Rule ID 1619 //
     /*  39087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39109 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3725:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTANUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDf),
     /*  39112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39116 */     GIR_RootConstrainSelectedInstOperands,
     /*  39117 */     // GIR_Coverage, 1619,
     /*  39117 */     GIR_EraseRootFromParent_Done,
     /*  39118 */   // Label 876: @39118
     /*  39118 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(39154), // Rule ID 1620 //
     /*  39123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39145 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3725:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTANUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQf),
     /*  39148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39152 */     GIR_RootConstrainSelectedInstOperands,
     /*  39153 */     // GIR_Coverage, 1620,
     /*  39153 */     GIR_EraseRootFromParent_Done,
     /*  39154 */   // Label 877: @39154
     /*  39154 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(39190), // Rule ID 1621 //
     /*  39159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39181 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3724:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSDh),
     /*  39184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39188 */     GIR_RootConstrainSelectedInstOperands,
     /*  39189 */     // GIR_Coverage, 1621,
     /*  39189 */     GIR_EraseRootFromParent_Done,
     /*  39190 */   // Label 878: @39190
     /*  39190 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(39226), // Rule ID 1622 //
     /*  39195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtas),
     /*  39203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39217 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3724:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANSQh),
     /*  39220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39224 */     GIR_RootConstrainSelectedInstOperands,
     /*  39225 */     // GIR_Coverage, 1622,
     /*  39225 */     GIR_EraseRootFromParent_Done,
     /*  39226 */   // Label 879: @39226
     /*  39226 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(39262), // Rule ID 1623 //
     /*  39231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39253 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3725:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTANUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUDh),
     /*  39256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39260 */     GIR_RootConstrainSelectedInstOperands,
     /*  39261 */     // GIR_Coverage, 1623,
     /*  39261 */     GIR_EraseRootFromParent_Done,
     /*  39262 */   // Label 880: @39262
     /*  39262 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(39298), // Rule ID 1624 //
     /*  39267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtau),
     /*  39275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39289 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3725:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTANUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTANUQh),
     /*  39292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39296 */     GIR_RootConstrainSelectedInstOperands,
     /*  39297 */     // GIR_Coverage, 1624,
     /*  39297 */     GIR_EraseRootFromParent_Done,
     /*  39298 */   // Label 881: @39298
     /*  39298 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(39334), // Rule ID 1625 //
     /*  39303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39325 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3736:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDf),
     /*  39328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39332 */     GIR_RootConstrainSelectedInstOperands,
     /*  39333 */     // GIR_Coverage, 1625,
     /*  39333 */     GIR_EraseRootFromParent_Done,
     /*  39334 */   // Label 882: @39334
     /*  39334 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(39370), // Rule ID 1626 //
     /*  39339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39357 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39361 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3736:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQf),
     /*  39364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39368 */     GIR_RootConstrainSelectedInstOperands,
     /*  39369 */     // GIR_Coverage, 1626,
     /*  39369 */     GIR_EraseRootFromParent_Done,
     /*  39370 */   // Label 883: @39370
     /*  39370 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(39406), // Rule ID 1627 //
     /*  39375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39397 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3737:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTNNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDf),
     /*  39400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39404 */     GIR_RootConstrainSelectedInstOperands,
     /*  39405 */     // GIR_Coverage, 1627,
     /*  39405 */     GIR_EraseRootFromParent_Done,
     /*  39406 */   // Label 884: @39406
     /*  39406 */   GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(39442), // Rule ID 1628 //
     /*  39411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39433 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3737:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTNNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQf),
     /*  39436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39440 */     GIR_RootConstrainSelectedInstOperands,
     /*  39441 */     // GIR_Coverage, 1628,
     /*  39441 */     GIR_EraseRootFromParent_Done,
     /*  39442 */   // Label 885: @39442
     /*  39442 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(39478), // Rule ID 1629 //
     /*  39447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39450 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39455 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39458 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39469 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3736:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSDh),
     /*  39472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39476 */     GIR_RootConstrainSelectedInstOperands,
     /*  39477 */     // GIR_Coverage, 1629,
     /*  39477 */     GIR_EraseRootFromParent_Done,
     /*  39478 */   // Label 886: @39478
     /*  39478 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(39514), // Rule ID 1630 //
     /*  39483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtns),
     /*  39491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39505 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3736:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNSQh),
     /*  39508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39512 */     GIR_RootConstrainSelectedInstOperands,
     /*  39513 */     // GIR_Coverage, 1630,
     /*  39513 */     GIR_EraseRootFromParent_Done,
     /*  39514 */   // Label 887: @39514
     /*  39514 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(39550), // Rule ID 1631 //
     /*  39519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39541 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3737:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTNNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUDh),
     /*  39544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39548 */     GIR_RootConstrainSelectedInstOperands,
     /*  39549 */     // GIR_Coverage, 1631,
     /*  39549 */     GIR_EraseRootFromParent_Done,
     /*  39550 */   // Label 888: @39550
     /*  39550 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(39586), // Rule ID 1632 //
     /*  39555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtnu),
     /*  39563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39577 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3737:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTNNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTNNUQh),
     /*  39580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39584 */     GIR_RootConstrainSelectedInstOperands,
     /*  39585 */     // GIR_Coverage, 1632,
     /*  39585 */     GIR_EraseRootFromParent_Done,
     /*  39586 */   // Label 889: @39586
     /*  39586 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(39622), // Rule ID 1633 //
     /*  39591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39613 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3738:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDf),
     /*  39616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39620 */     GIR_RootConstrainSelectedInstOperands,
     /*  39621 */     // GIR_Coverage, 1633,
     /*  39621 */     GIR_EraseRootFromParent_Done,
     /*  39622 */   // Label 890: @39622
     /*  39622 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(39658), // Rule ID 1634 //
     /*  39627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39649 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3738:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQf),
     /*  39652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39656 */     GIR_RootConstrainSelectedInstOperands,
     /*  39657 */     // GIR_Coverage, 1634,
     /*  39657 */     GIR_EraseRootFromParent_Done,
     /*  39658 */   // Label 891: @39658
     /*  39658 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(39694), // Rule ID 1635 //
     /*  39663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39685 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3739:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTPNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDf),
     /*  39688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39692 */     GIR_RootConstrainSelectedInstOperands,
     /*  39693 */     // GIR_Coverage, 1635,
     /*  39693 */     GIR_EraseRootFromParent_Done,
     /*  39694 */   // Label 892: @39694
     /*  39694 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(39730), // Rule ID 1636 //
     /*  39699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39721 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3739:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTPNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQf),
     /*  39724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39728 */     GIR_RootConstrainSelectedInstOperands,
     /*  39729 */     // GIR_Coverage, 1636,
     /*  39729 */     GIR_EraseRootFromParent_Done,
     /*  39730 */   // Label 893: @39730
     /*  39730 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(39766), // Rule ID 1637 //
     /*  39735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39757 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3738:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSDh),
     /*  39760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39764 */     GIR_RootConstrainSelectedInstOperands,
     /*  39765 */     // GIR_Coverage, 1637,
     /*  39765 */     GIR_EraseRootFromParent_Done,
     /*  39766 */   // Label 894: @39766
     /*  39766 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(39802), // Rule ID 1638 //
     /*  39771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtps),
     /*  39779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39793 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3738:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNSQh),
     /*  39796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39800 */     GIR_RootConstrainSelectedInstOperands,
     /*  39801 */     // GIR_Coverage, 1638,
     /*  39801 */     GIR_EraseRootFromParent_Done,
     /*  39802 */   // Label 895: @39802
     /*  39802 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(39838), // Rule ID 1639 //
     /*  39807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  39818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  39821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39829 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3739:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTPNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  39829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUDh),
     /*  39832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39836 */     GIR_RootConstrainSelectedInstOperands,
     /*  39837 */     // GIR_Coverage, 1639,
     /*  39837 */     GIR_EraseRootFromParent_Done,
     /*  39838 */   // Label 896: @39838
     /*  39838 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(39874), // Rule ID 1640 //
     /*  39843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  39846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtpu),
     /*  39851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  39854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  39857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39865 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3739:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTPNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  39865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTPNUQh),
     /*  39868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39872 */     GIR_RootConstrainSelectedInstOperands,
     /*  39873 */     // GIR_Coverage, 1640,
     /*  39873 */     GIR_EraseRootFromParent_Done,
     /*  39874 */   // Label 897: @39874
     /*  39874 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(39910), // Rule ID 1641 //
     /*  39879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39901 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3734:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNSDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDf),
     /*  39904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39908 */     GIR_RootConstrainSelectedInstOperands,
     /*  39909 */     // GIR_Coverage, 1641,
     /*  39909 */     GIR_EraseRootFromParent_Done,
     /*  39910 */   // Label 898: @39910
     /*  39910 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(39946), // Rule ID 1642 //
     /*  39915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  39923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  39929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  39937 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3734:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNSQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  39937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQf),
     /*  39940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39944 */     GIR_RootConstrainSelectedInstOperands,
     /*  39945 */     // GIR_Coverage, 1642,
     /*  39945 */     GIR_EraseRootFromParent_Done,
     /*  39946 */   // Label 899: @39946
     /*  39946 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(39982), // Rule ID 1643 //
     /*  39951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39954 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  39959 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  39962 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  39965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  39973 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3735:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTMNUDf:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /*  39973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDf),
     /*  39976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  39978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  39980 */     GIR_RootConstrainSelectedInstOperands,
     /*  39981 */     // GIR_Coverage, 1643,
     /*  39981 */     GIR_EraseRootFromParent_Done,
     /*  39982 */   // Label 900: @39982
     /*  39982 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(40018), // Rule ID 1644 //
     /*  39987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  39990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  39995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  39998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3735:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTMNUQf:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQf),
     /*  40012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40016 */     GIR_RootConstrainSelectedInstOperands,
     /*  40017 */     // GIR_Coverage, 1644,
     /*  40017 */     GIR_EraseRootFromParent_Done,
     /*  40018 */   // Label 901: @40018
     /*  40018 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(40054), // Rule ID 1645 //
     /*  40023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40045 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3734:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNSDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSDh),
     /*  40048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40052 */     GIR_RootConstrainSelectedInstOperands,
     /*  40053 */     // GIR_Coverage, 1645,
     /*  40053 */     GIR_EraseRootFromParent_Done,
     /*  40054 */   // Label 902: @40054
     /*  40054 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(40090), // Rule ID 1646 //
     /*  40059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtms),
     /*  40067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40081 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3734:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNSQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNSQh),
     /*  40084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40088 */     GIR_RootConstrainSelectedInstOperands,
     /*  40089 */     // GIR_Coverage, 1646,
     /*  40089 */     GIR_EraseRootFromParent_Done,
     /*  40090 */   // Label 903: @40090
     /*  40090 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(40126), // Rule ID 1647 //
     /*  40095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3735:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTMNUDh:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUDh),
     /*  40120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40124 */     GIR_RootConstrainSelectedInstOperands,
     /*  40125 */     // GIR_Coverage, 1647,
     /*  40125 */     GIR_EraseRootFromParent_Done,
     /*  40126 */   // Label 904: @40126
     /*  40126 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(40162), // Rule ID 1648 //
     /*  40131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtmu),
     /*  40139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40153 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3735:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTMNUQh:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTMNUQh),
     /*  40156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40160 */     GIR_RootConstrainSelectedInstOperands,
     /*  40161 */     // GIR_Coverage, 1648,
     /*  40161 */     GIR_EraseRootFromParent_Done,
     /*  40162 */   // Label 905: @40162
     /*  40162 */   GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(40207), // Rule ID 1665 //
     /*  40167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2hf),
     /*  40175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40189 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3730:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2h:{ *:[v4i16] } QPR:{ *:[v4f32] }:$Vm)
     /*  40189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /*  40192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40205 */     GIR_RootConstrainSelectedInstOperands,
     /*  40206 */     // GIR_Coverage, 1665,
     /*  40206 */     GIR_EraseRootFromParent_Done,
     /*  40207 */   // Label 906: @40207
     /*  40207 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(40252), // Rule ID 1666 //
     /*  40212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16_HasNEON),
     /*  40215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvthf2fp),
     /*  40220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40230 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40234 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3733:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4i16] }:$Vm)
     /*  40234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /*  40237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40241 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  40244 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40250 */     GIR_RootConstrainSelectedInstOperands,
     /*  40251 */     // GIR_Coverage, 1666,
     /*  40251 */     GIR_EraseRootFromParent_Done,
     /*  40252 */   // Label 907: @40252
     /*  40252 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(40288), // Rule ID 1688 //
     /*  40257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40279 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3804:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTNNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDf),
     /*  40282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40286 */     GIR_RootConstrainSelectedInstOperands,
     /*  40287 */     // GIR_Coverage, 1688,
     /*  40287 */     GIR_EraseRootFromParent_Done,
     /*  40288 */   // Label 908: @40288
     /*  40288 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(40324), // Rule ID 1689 //
     /*  40293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40315 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3804:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTNNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQf),
     /*  40318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40322 */     GIR_RootConstrainSelectedInstOperands,
     /*  40323 */     // GIR_Coverage, 1689,
     /*  40323 */     GIR_EraseRootFromParent_Done,
     /*  40324 */   // Label 909: @40324
     /*  40324 */   GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(40360), // Rule ID 1690 //
     /*  40329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40343 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40347 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40351 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3804:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTNNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNDh),
     /*  40354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40358 */     GIR_RootConstrainSelectedInstOperands,
     /*  40359 */     // GIR_Coverage, 1690,
     /*  40359 */     GIR_EraseRootFromParent_Done,
     /*  40360 */   // Label 910: @40360
     /*  40360 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(40396), // Rule ID 1691 //
     /*  40365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40368 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintn),
     /*  40373 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40376 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40387 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3804:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTNNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTNNQh),
     /*  40390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40394 */     GIR_RootConstrainSelectedInstOperands,
     /*  40395 */     // GIR_Coverage, 1691,
     /*  40395 */     GIR_EraseRootFromParent_Done,
     /*  40396 */   // Label 911: @40396
     /*  40396 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(40432), // Rule ID 1692 //
     /*  40401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40423 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3806:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTXNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDf),
     /*  40426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40428 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40430 */     GIR_RootConstrainSelectedInstOperands,
     /*  40431 */     // GIR_Coverage, 1692,
     /*  40431 */     GIR_EraseRootFromParent_Done,
     /*  40432 */   // Label 912: @40432
     /*  40432 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(40468), // Rule ID 1693 //
     /*  40437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40459 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3806:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTXNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQf),
     /*  40462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40466 */     GIR_RootConstrainSelectedInstOperands,
     /*  40467 */     // GIR_Coverage, 1693,
     /*  40467 */     GIR_EraseRootFromParent_Done,
     /*  40468 */   // Label 913: @40468
     /*  40468 */   GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(40504), // Rule ID 1694 //
     /*  40473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40495 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3806:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTXNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNDh),
     /*  40498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40502 */     GIR_RootConstrainSelectedInstOperands,
     /*  40503 */     // GIR_Coverage, 1694,
     /*  40503 */     GIR_EraseRootFromParent_Done,
     /*  40504 */   // Label 914: @40504
     /*  40504 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(40540), // Rule ID 1695 //
     /*  40509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintx),
     /*  40517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40531 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3806:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTXNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXNQh),
     /*  40534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40538 */     GIR_RootConstrainSelectedInstOperands,
     /*  40539 */     // GIR_Coverage, 1695,
     /*  40539 */     GIR_EraseRootFromParent_Done,
     /*  40540 */   // Label 915: @40540
     /*  40540 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(40576), // Rule ID 1696 //
     /*  40545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40567 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3802:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTANDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDf),
     /*  40570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40574 */     GIR_RootConstrainSelectedInstOperands,
     /*  40575 */     // GIR_Coverage, 1696,
     /*  40575 */     GIR_EraseRootFromParent_Done,
     /*  40576 */   // Label 916: @40576
     /*  40576 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(40612), // Rule ID 1697 //
     /*  40581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40603 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3802:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTANQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQf),
     /*  40606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40610 */     GIR_RootConstrainSelectedInstOperands,
     /*  40611 */     // GIR_Coverage, 1697,
     /*  40611 */     GIR_EraseRootFromParent_Done,
     /*  40612 */   // Label 917: @40612
     /*  40612 */   GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(40648), // Rule ID 1698 //
     /*  40617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40620 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40625 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40628 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40639 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3802:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTANDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANDh),
     /*  40642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40646 */     GIR_RootConstrainSelectedInstOperands,
     /*  40647 */     // GIR_Coverage, 1698,
     /*  40647 */     GIR_EraseRootFromParent_Done,
     /*  40648 */   // Label 918: @40648
     /*  40648 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(40684), // Rule ID 1699 //
     /*  40653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrinta),
     /*  40661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40675 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3802:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTANQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTANQh),
     /*  40678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40682 */     GIR_RootConstrainSelectedInstOperands,
     /*  40683 */     // GIR_Coverage, 1699,
     /*  40683 */     GIR_EraseRootFromParent_Done,
     /*  40684 */   // Label 919: @40684
     /*  40684 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(40720), // Rule ID 1700 //
     /*  40689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40711 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3807:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTZNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDf),
     /*  40714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40718 */     GIR_RootConstrainSelectedInstOperands,
     /*  40719 */     // GIR_Coverage, 1700,
     /*  40719 */     GIR_EraseRootFromParent_Done,
     /*  40720 */   // Label 920: @40720
     /*  40720 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(40756), // Rule ID 1701 //
     /*  40725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40747 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3807:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTZNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQf),
     /*  40750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40754 */     GIR_RootConstrainSelectedInstOperands,
     /*  40755 */     // GIR_Coverage, 1701,
     /*  40755 */     GIR_EraseRootFromParent_Done,
     /*  40756 */   // Label 921: @40756
     /*  40756 */   GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(40792), // Rule ID 1702 //
     /*  40761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40783 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3807:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTZNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNDh),
     /*  40786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40790 */     GIR_RootConstrainSelectedInstOperands,
     /*  40791 */     // GIR_Coverage, 1702,
     /*  40791 */     GIR_EraseRootFromParent_Done,
     /*  40792 */   // Label 922: @40792
     /*  40792 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(40828), // Rule ID 1703 //
     /*  40797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintz),
     /*  40805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40819 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3807:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTZNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTZNQh),
     /*  40822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40826 */     GIR_RootConstrainSelectedInstOperands,
     /*  40827 */     // GIR_Coverage, 1703,
     /*  40827 */     GIR_EraseRootFromParent_Done,
     /*  40828 */   // Label 923: @40828
     /*  40828 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(40864), // Rule ID 1704 //
     /*  40833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40855 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3803:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDf),
     /*  40858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40862 */     GIR_RootConstrainSelectedInstOperands,
     /*  40863 */     // GIR_Coverage, 1704,
     /*  40863 */     GIR_EraseRootFromParent_Done,
     /*  40864 */   // Label 924: @40864
     /*  40864 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(40900), // Rule ID 1705 //
     /*  40869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  40880 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  40883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40891 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3803:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  40891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQf),
     /*  40894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40898 */     GIR_RootConstrainSelectedInstOperands,
     /*  40899 */     // GIR_Coverage, 1705,
     /*  40899 */     GIR_EraseRootFromParent_Done,
     /*  40900 */   // Label 925: @40900
     /*  40900 */   GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(40936), // Rule ID 1706 //
     /*  40905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  40916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  40919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40927 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3803:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  40927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNDh),
     /*  40930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40934 */     GIR_RootConstrainSelectedInstOperands,
     /*  40935 */     // GIR_Coverage, 1706,
     /*  40935 */     GIR_EraseRootFromParent_Done,
     /*  40936 */   // Label 926: @40936
     /*  40936 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(40972), // Rule ID 1707 //
     /*  40941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  40944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintm),
     /*  40949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  40952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  40955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  40963 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3803:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  40963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTMNQh),
     /*  40966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  40968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  40970 */     GIR_RootConstrainSelectedInstOperands,
     /*  40971 */     // GIR_Coverage, 1707,
     /*  40971 */     GIR_EraseRootFromParent_Done,
     /*  40972 */   // Label 927: @40972
     /*  40972 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(41008), // Rule ID 1708 //
     /*  40977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  40980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  40985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  40988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  40991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  40999 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3805:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm)  =>  (VRINTPNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /*  40999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDf),
     /*  41002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41006 */     GIR_RootConstrainSelectedInstOperands,
     /*  41007 */     // GIR_Coverage, 1708,
     /*  41007 */     GIR_EraseRootFromParent_Done,
     /*  41008 */   // Label 928: @41008
     /*  41008 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(41044), // Rule ID 1709 //
     /*  41013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8),
     /*  41016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41035 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3805:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm)  =>  (VRINTPNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /*  41035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQf),
     /*  41038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41042 */     GIR_RootConstrainSelectedInstOperands,
     /*  41043 */     // GIR_Coverage, 1709,
     /*  41043 */     GIR_EraseRootFromParent_Done,
     /*  41044 */   // Label 929: @41044
     /*  41044 */   GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(41080), // Rule ID 1710 //
     /*  41049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  41060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  41063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  41071 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3805:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm)  =>  (VRINTPNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /*  41071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNDh),
     /*  41074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41078 */     GIR_RootConstrainSelectedInstOperands,
     /*  41079 */     // GIR_Coverage, 1710,
     /*  41079 */     GIR_EraseRootFromParent_Done,
     /*  41080 */   // Label 930: @41080
     /*  41080 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(41116), // Rule ID 1711 //
     /*  41085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8),
     /*  41088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrintp),
     /*  41093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41107 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3805:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm)  =>  (VRINTPNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /*  41107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTPNQh),
     /*  41110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41114 */     GIR_RootConstrainSelectedInstOperands,
     /*  41115 */     // GIR_Coverage, 1711,
     /*  41115 */     GIR_EraseRootFromParent_Done,
     /*  41116 */   // Label 931: @41116
     /*  41116 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(41152), // Rule ID 1714 //
     /*  41121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesimc),
     /*  41129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41143 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3693:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESIMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESIMC),
     /*  41146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41150 */     GIR_RootConstrainSelectedInstOperands,
     /*  41151 */     // GIR_Coverage, 1714,
     /*  41151 */     GIR_EraseRootFromParent_Done,
     /*  41152 */   // Label 932: @41152
     /*  41152 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(41188), // Rule ID 1715 //
     /*  41157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  41160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesmc),
     /*  41165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  41179 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3694:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm)  =>  (AESMC:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /*  41179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESMC),
     /*  41182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  41184 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  41186 */     GIR_RootConstrainSelectedInstOperands,
     /*  41187 */     // GIR_Coverage, 1715,
     /*  41187 */     GIR_EraseRootFromParent_Done,
     /*  41188 */   // Label 933: @41188
     /*  41188 */   GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(41236), // Rule ID 1848 //
     /*  41193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  41196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  41215 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, GPR:{ *:[i32] }:$Src)  =>  (SXTB16:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /*  41215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB16),
     /*  41218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Src
     /*  41222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41234 */     GIR_RootConstrainSelectedInstOperands,
     /*  41235 */     // GIR_Coverage, 1848,
     /*  41235 */     GIR_EraseRootFromParent_Done,
     /*  41236 */   // Label 934: @41236
     /*  41236 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(41284), // Rule ID 2096 //
     /*  41241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  41244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtb16),
     /*  41249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41263 */     // (intrinsic_wo_chain:{ *:[i32] } 3893:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (t2SXTB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, 0:{ *:[i32] })
     /*  41263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB16),
     /*  41266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41282 */     GIR_RootConstrainSelectedInstOperands,
     /*  41283 */     // GIR_Coverage, 2096,
     /*  41283 */     GIR_EraseRootFromParent_Done,
     /*  41284 */   // Label 935: @41284
     /*  41284 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(41350), // Rule ID 3645 //
     /*  41289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  41300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  41303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41311 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3575:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLSs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /*  41311 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41314 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41318 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs8),
     /*  41326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41328 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41345 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41348 */     GIR_RootConstrainSelectedInstOperands,
     /*  41349 */     // GIR_Coverage, 3645,
     /*  41349 */     GIR_EraseRootFromParent_Done,
     /*  41350 */   // Label 936: @41350
     /*  41350 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(41416), // Rule ID 3647 //
     /*  41355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41363 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41377 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3575:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLSs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /*  41377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs16),
     /*  41392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41394 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41414 */     GIR_RootConstrainSelectedInstOperands,
     /*  41415 */     // GIR_Coverage, 3647,
     /*  41415 */     GIR_EraseRootFromParent_Done,
     /*  41416 */   // Label 937: @41416
     /*  41416 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(41482), // Rule ID 3649 //
     /*  41421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcls),
     /*  41429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41443 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3575:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLSs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /*  41443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLSs32),
     /*  41458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41460 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41480 */     GIR_RootConstrainSelectedInstOperands,
     /*  41481 */     // GIR_Coverage, 3649,
     /*  41481 */     GIR_EraseRootFromParent_Done,
     /*  41482 */   // Label 938: @41482
     /*  41482 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(41548), // Rule ID 3961 //
     /*  41487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  41498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  41501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41509 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3657:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16N:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /*  41509 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41512 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41516 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16N),
     /*  41524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41526 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41543 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41546 */     GIR_RootConstrainSelectedInstOperands,
     /*  41547 */     // GIR_Coverage, 3961,
     /*  41547 */     GIR_EraseRootFromParent_Done,
     /*  41548 */   // Label 939: @41548
     /*  41548 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(41614), // Rule ID 3973 //
     /*  41553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  41556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrintn),
     /*  41561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  41564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  41567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  41575 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3657:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32N:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /*  41575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  41578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32N),
     /*  41590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  41592 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /*  41594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41612 */     GIR_RootConstrainSelectedInstOperands,
     /*  41613 */     // GIR_Coverage, 3973,
     /*  41613 */     GIR_EraseRootFromParent_Done,
     /*  41614 */   // Label 940: @41614
     /*  41614 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(41665), // Rule ID 4861 //
     /*  41619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp8),
     /*  41627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s1,
     /*  41630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41641 */     // (intrinsic_wo_chain:{ *:[v16i1] } 3583:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP8:{ *:[v16i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP8),
     /*  41644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41663 */     GIR_RootConstrainSelectedInstOperands,
     /*  41664 */     // GIR_Coverage, 4861,
     /*  41664 */     GIR_EraseRootFromParent_Done,
     /*  41665 */   // Label 941: @41665
     /*  41665 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(41716), // Rule ID 4863 //
     /*  41670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp16),
     /*  41678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s1,
     /*  41681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41692 */     // (intrinsic_wo_chain:{ *:[v8i1] } 3580:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP16:{ *:[v8i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP16),
     /*  41695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41714 */     GIR_RootConstrainSelectedInstOperands,
     /*  41715 */     // GIR_Coverage, 4863,
     /*  41715 */     GIR_EraseRootFromParent_Done,
     /*  41716 */   // Label 942: @41716
     /*  41716 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(41767), // Rule ID 4865 //
     /*  41721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp32),
     /*  41729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s1,
     /*  41732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41743 */     // (intrinsic_wo_chain:{ *:[v4i1] } 3581:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP32:{ *:[v4i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP32),
     /*  41746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41753 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41765 */     GIR_RootConstrainSelectedInstOperands,
     /*  41766 */     // GIR_Coverage, 4865,
     /*  41766 */     GIR_EraseRootFromParent_Done,
     /*  41767 */   // Label 943: @41767
     /*  41767 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(41818), // Rule ID 4867 //
     /*  41772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  41775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vctp64),
     /*  41780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s1,
     /*  41783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  41786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /*  41790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41794 */     // (intrinsic_wo_chain:{ *:[v2i1] } 3582:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn)  =>  (MVE_VCTP64:{ *:[v2i1] } rGPR:{ *:[i32] }:$Rn)
     /*  41794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCTP64),
     /*  41797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /*  41799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  41804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41816 */     GIR_RootConstrainSelectedInstOperands,
     /*  41817 */     // GIR_Coverage, 4867,
     /*  41817 */     GIR_EraseRootFromParent_Done,
     /*  41818 */   // Label 944: @41818
     /*  41818 */   GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(41864), // Rule ID 600 //
     /*  41823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tt),
     /*  41831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41838 */     // MIs[0] Rn
     /*  41838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41846 */     // (intrinsic_wo_chain:{ *:[i32] } 3465:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TT),
     /*  41849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41862 */     GIR_RootConstrainSelectedInstOperands,
     /*  41863 */     // GIR_Coverage, 600,
     /*  41863 */     GIR_EraseRootFromParent_Done,
     /*  41864 */   // Label 945: @41864
     /*  41864 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(41910), // Rule ID 601 //
     /*  41869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41872 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttt),
     /*  41877 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41884 */     // MIs[0] Rn
     /*  41884 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41888 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41892 */     // (intrinsic_wo_chain:{ *:[i32] } 3468:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTT),
     /*  41895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41902 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41908 */     GIR_RootConstrainSelectedInstOperands,
     /*  41909 */     // GIR_Coverage, 601,
     /*  41909 */     GIR_EraseRootFromParent_Done,
     /*  41910 */   // Label 946: @41910
     /*  41910 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(41956), // Rule ID 602 //
     /*  41915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_tta),
     /*  41923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41930 */     // MIs[0] Rn
     /*  41930 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41938 */     // (intrinsic_wo_chain:{ *:[i32] } 3466:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTA:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTA),
     /*  41941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  41954 */     GIR_RootConstrainSelectedInstOperands,
     /*  41955 */     // GIR_Coverage, 602,
     /*  41955 */     GIR_EraseRootFromParent_Done,
     /*  41956 */   // Label 947: @41956
     /*  41956 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(42002), // Rule ID 603 //
     /*  41961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_Has8MSecExt_IsThumb),
     /*  41964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_cmse_ttat),
     /*  41969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  41972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  41976 */     // MIs[0] Rn
     /*  41976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  41980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  41984 */     // (intrinsic_wo_chain:{ *:[i32] } 3467:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn)  =>  (t2TTAT:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn)
     /*  41984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2TTAT),
     /*  41987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  41989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  41991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  41994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42000 */     GIR_RootConstrainSelectedInstOperands,
     /*  42001 */     // GIR_Coverage, 603,
     /*  42001 */     GIR_EraseRootFromParent_Done,
     /*  42002 */   // Label 948: @42002
     /*  42002 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(42137), // Rule ID 2690 //
     /*  42007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1h),
     /*  42015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  42025 */     // (intrinsic_wo_chain:{ *:[i32] } 3701:{ *:[iPTR] }, i32:{ *:[i32] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[f32] } (SHA1H:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$Rn, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] }), GPR:{ *:[i32] })
     /*  42025 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /*  42028 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42032 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42037 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  42041 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42046 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /*  42049 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  42053 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42058 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  42061 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  42064 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /*  42067 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  42072 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /*  42080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::SHA1H),
     /*  42084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  42092 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  42094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42106 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /*  42113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  42118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42128 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42131 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /*  42136 */     // GIR_Coverage, 2690,
     /*  42136 */     GIR_EraseRootFromParent_Done,
     /*  42137 */   // Label 949: @42137
     /*  42137 */   GIM_Reject,
     /*  42138 */ // Label 813: @42138
     /*  42138 */ GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(62692),
     /*  42143 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  42146 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(42203), // Rule ID 2114 //
     /*  42151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  42159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42180 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  42180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UXTAB16),
     /*  42183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42201 */     GIR_RootConstrainSelectedInstOperands,
     /*  42202 */     // GIR_Coverage, 2114,
     /*  42202 */     GIR_EraseRootFromParent_Done,
     /*  42203 */   // Label 951: @42203
     /*  42203 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(42302), // Rule ID 1885 //
     /*  42208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  42211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42241 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42250 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42254 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42258 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42262 */     // MIs[2] Operand 1
     /*  42262 */     // No operand predicates
     /*  42262 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42266 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42270 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42274 */     // MIs[3] Operand 1
     /*  42274 */     // No operand predicates
     /*  42274 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42276 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  42279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42300 */     GIR_RootConstrainSelectedInstOperands,
     /*  42301 */     // GIR_Coverage, 1885,
     /*  42301 */     GIR_EraseRootFromParent_Done,
     /*  42302 */   // Label 952: @42302
     /*  42302 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(42401), // Rule ID 2151 //
     /*  42307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  42310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  42315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  42336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  42340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  42353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42357 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42361 */     // MIs[2] Operand 1
     /*  42361 */     // No operand predicates
     /*  42361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /*  42365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  42369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  42373 */     // MIs[3] Operand 1
     /*  42373 */     // No operand predicates
     /*  42373 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  42375 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, (shl:{ *:[i32] } GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft), (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$shft)
     /*  42375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  42378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // pos
     /*  42383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /*  42387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // shft
     /*  42390 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42399 */     GIR_RootConstrainSelectedInstOperands,
     /*  42400 */     // GIR_Coverage, 2151,
     /*  42400 */     GIR_EraseRootFromParent_Done,
     /*  42401 */   // Label 953: @42401
     /*  42401 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(42485), // Rule ID 5427 //
     /*  42406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42435 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42438 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42447 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42452 */     // MIs[1] Rn
     /*  42452 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42457 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42463 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn), GPRnopc:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42483 */     GIR_RootConstrainSelectedInstOperands,
     /*  42484 */     // GIR_Coverage, 5427,
     /*  42484 */     GIR_EraseRootFromParent_Done,
     /*  42485 */   // Label 954: @42485
     /*  42485 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(42569), // Rule ID 5684 //
     /*  42490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42519 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42522 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42536 */     // MIs[1] Rn
     /*  42536 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42545 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42547 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  42554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42558 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42561 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42567 */     GIR_RootConstrainSelectedInstOperands,
     /*  42568 */     // GIR_Coverage, 5684,
     /*  42568 */     GIR_EraseRootFromParent_Done,
     /*  42569 */   // Label 955: @42569
     /*  42569 */   GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(42653), // Rule ID 109 //
     /*  42574 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42577 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42582 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42585 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42588 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42607 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42610 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42624 */     // MIs[1] Rn
     /*  42624 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42631 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /*  42634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42651 */     GIR_RootConstrainSelectedInstOperands,
     /*  42652 */     // GIR_Coverage, 109,
     /*  42652 */     GIR_EraseRootFromParent_Done,
     /*  42653 */   // Label 956: @42653
     /*  42653 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(42737), // Rule ID 110 //
     /*  42658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  42661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42691 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42694 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  42708 */     // MIs[1] Rn
     /*  42708 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42715 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  42715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /*  42718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42735 */     GIR_RootConstrainSelectedInstOperands,
     /*  42736 */     // GIR_Coverage, 110,
     /*  42736 */     GIR_EraseRootFromParent_Done,
     /*  42737 */   // Label 957: @42737
     /*  42737 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(42821), // Rule ID 2129 //
     /*  42742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42775 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42778 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42783 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42792 */     // MIs[1] Rn
     /*  42792 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42799 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /*  42802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42819 */     GIR_RootConstrainSelectedInstOperands,
     /*  42820 */     // GIR_Coverage, 2129,
     /*  42820 */     GIR_EraseRootFromParent_Done,
     /*  42821 */   // Label 958: @42821
     /*  42821 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(42905), // Rule ID 2130 //
     /*  42826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  42829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  42834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  42837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  42843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  42855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42859 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42862 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  42867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  42871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  42876 */     // MIs[1] Rn
     /*  42876 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42883 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  42883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /*  42886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  42890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  42894 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  42897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42903 */     GIR_RootConstrainSelectedInstOperands,
     /*  42904 */     // GIR_Coverage, 2130,
     /*  42904 */     GIR_EraseRootFromParent_Done,
     /*  42905 */   // Label 959: @42905
     /*  42905 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(42978), // Rule ID 4055 //
     /*  42910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  42918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  42927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  42935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  42939 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3591:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  42939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  42946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16a),
     /*  42954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  42956 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  42958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  42961 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42967 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  42973 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42976 */     GIR_RootConstrainSelectedInstOperands,
     /*  42977 */     // GIR_Coverage, 4055,
     /*  42977 */     GIR_EraseRootFromParent_Done,
     /*  42978 */   // Label 960: @42978
     /*  42978 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(43051), // Rule ID 4057 //
     /*  42983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  42986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  42991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  42994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  42997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43004 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3595:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43012 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43015 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43019 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16n),
     /*  43027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43029 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43034 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43040 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43046 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43049 */     GIR_RootConstrainSelectedInstOperands,
     /*  43050 */     // GIR_Coverage, 4057,
     /*  43050 */     GIR_EraseRootFromParent_Done,
     /*  43051 */   // Label 961: @43051
     /*  43051 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(43124), // Rule ID 4059 //
     /*  43056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43077 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43085 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3597:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16p),
     /*  43100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43102 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43113 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43122 */     GIR_RootConstrainSelectedInstOperands,
     /*  43123 */     // GIR_Coverage, 4059,
     /*  43123 */     GIR_EraseRootFromParent_Done,
     /*  43124 */   // Label 962: @43124
     /*  43124 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(43197), // Rule ID 4061 //
     /*  43129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43154 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43158 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTs16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43158 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43161 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43165 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16m),
     /*  43173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43175 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43180 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43195 */     GIR_RootConstrainSelectedInstOperands,
     /*  43196 */     // GIR_Coverage, 4061,
     /*  43196 */     GIR_EraseRootFromParent_Done,
     /*  43197 */   // Label 963: @43197
     /*  43197 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(43270), // Rule ID 4063 //
     /*  43202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43231 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3591:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16a:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16a),
     /*  43246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43248 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43268 */     GIR_RootConstrainSelectedInstOperands,
     /*  43269 */     // GIR_Coverage, 4063,
     /*  43269 */     GIR_EraseRootFromParent_Done,
     /*  43270 */   // Label 964: @43270
     /*  43270 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(43343), // Rule ID 4065 //
     /*  43275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43296 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43300 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43304 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3595:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16n:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16n),
     /*  43319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43321 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43323 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43326 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43332 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43341 */     GIR_RootConstrainSelectedInstOperands,
     /*  43342 */     // GIR_Coverage, 4065,
     /*  43342 */     GIR_EraseRootFromParent_Done,
     /*  43343 */   // Label 965: @43343
     /*  43343 */   GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(43416), // Rule ID 4067 //
     /*  43348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43377 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3597:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16p:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16p),
     /*  43392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43394 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43396 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43399 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43405 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43414 */     GIR_RootConstrainSelectedInstOperands,
     /*  43415 */     // GIR_Coverage, 4067,
     /*  43415 */     GIR_EraseRootFromParent_Done,
     /*  43416 */   // Label 966: @43416
     /*  43416 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(43489), // Rule ID 4069 //
     /*  43421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  43432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  43438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43446 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43450 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$in)  =>  (MVE_VCVTu16f16m:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$in)
     /*  43450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16m),
     /*  43465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43467 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43472 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43478 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43484 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43487 */     GIR_RootConstrainSelectedInstOperands,
     /*  43488 */     // GIR_Coverage, 4069,
     /*  43488 */     GIR_EraseRootFromParent_Done,
     /*  43489 */   // Label 967: @43489
     /*  43489 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(43562), // Rule ID 4071 //
     /*  43494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43523 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3591:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43523 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43526 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43530 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32a),
     /*  43538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43540 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43560 */     GIR_RootConstrainSelectedInstOperands,
     /*  43561 */     // GIR_Coverage, 4071,
     /*  43561 */     GIR_EraseRootFromParent_Done,
     /*  43562 */   // Label 968: @43562
     /*  43562 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(43635), // Rule ID 4073 //
     /*  43567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43588 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43596 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3595:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32n),
     /*  43611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43613 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43633 */     GIR_RootConstrainSelectedInstOperands,
     /*  43634 */     // GIR_Coverage, 4073,
     /*  43634 */     GIR_EraseRootFromParent_Done,
     /*  43635 */   // Label 969: @43635
     /*  43635 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(43708), // Rule ID 4075 //
     /*  43640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43669 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3597:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32p),
     /*  43684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43686 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43691 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43703 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43706 */     GIR_RootConstrainSelectedInstOperands,
     /*  43707 */     // GIR_Coverage, 4075,
     /*  43707 */     GIR_EraseRootFromParent_Done,
     /*  43708 */   // Label 970: @43708
     /*  43708 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(43781), // Rule ID 4077 //
     /*  43713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  43721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  43738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43742 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3593:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTs32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43742 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43745 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43749 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32m),
     /*  43757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43759 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43764 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43770 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43779 */     GIR_RootConstrainSelectedInstOperands,
     /*  43780 */     // GIR_Coverage, 4077,
     /*  43780 */     GIR_EraseRootFromParent_Done,
     /*  43781 */   // Label 971: @43781
     /*  43781 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(43854), // Rule ID 4079 //
     /*  43786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvta),
     /*  43794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43800 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43807 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43815 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3591:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32a:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43815 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43818 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43822 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32a),
     /*  43830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43832 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43852 */     GIR_RootConstrainSelectedInstOperands,
     /*  43853 */     // GIR_Coverage, 4079,
     /*  43853 */     GIR_EraseRootFromParent_Done,
     /*  43854 */   // Label 972: @43854
     /*  43854 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(43927), // Rule ID 4081 //
     /*  43859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtn),
     /*  43867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43880 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43888 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3595:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32n:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43888 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43891 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43895 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32n),
     /*  43903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43905 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43907 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43910 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43922 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43925 */     GIR_RootConstrainSelectedInstOperands,
     /*  43926 */     // GIR_Coverage, 4081,
     /*  43926 */     GIR_EraseRootFromParent_Done,
     /*  43927 */   // Label 973: @43927
     /*  43927 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(44000), // Rule ID 4083 //
     /*  43932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  43935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtp),
     /*  43940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  43943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  43946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  43949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43953 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  43957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  43961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3597:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32p:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  43961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32p),
     /*  43976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  43978 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  43980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  43983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  43995 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  43998 */     GIR_RootConstrainSelectedInstOperands,
     /*  43999 */     // GIR_Coverage, 4083,
     /*  43999 */     GIR_EraseRootFromParent_Done,
     /*  44000 */   // Label 974: @44000
     /*  44000 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(44073), // Rule ID 4085 //
     /*  44005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvtm),
     /*  44013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  44022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  44030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44034 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3593:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$in)  =>  (MVE_VCVTu32f32m:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$in)
     /*  44034 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44037 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44041 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32m),
     /*  44049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44051 */     GIR_RootToRootCopy, /*OpIdx*/3, // in
     /*  44053 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44056 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44062 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44071 */     GIR_RootConstrainSelectedInstOperands,
     /*  44072 */     // GIR_Coverage, 4085,
     /*  44072 */     GIR_EraseRootFromParent_Done,
     /*  44073 */   // Label 975: @44073
     /*  44073 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(44146), // Rule ID 4529 //
     /*  44078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  44107 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf32f16bh:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16bh),
     /*  44122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44135 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44141 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44144 */     GIR_RootConstrainSelectedInstOperands,
     /*  44145 */     // GIR_Coverage, 4529,
     /*  44145 */     GIR_EraseRootFromParent_Done,
     /*  44146 */   // Label 976: @44146
     /*  44146 */   GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(44219), // Rule ID 4535 //
     /*  44151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  44154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_widen),
     /*  44159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44176 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  44180 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3589:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf32f16th:{ *:[v4f32] } MQPR:{ *:[v8f16] }:$Qm)
     /*  44180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32f16th),
     /*  44195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  44199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44202 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44214 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44217 */     GIR_RootConstrainSelectedInstOperands,
     /*  44218 */     // GIR_Coverage, 4535,
     /*  44218 */     GIR_EraseRootFromParent_Done,
     /*  44219 */   // Label 977: @44219
     /*  44219 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(44287), // Rule ID 1878 //
     /*  44224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44261 */     // MIs[1] Operand 1
     /*  44261 */     // No operand predicates
     /*  44261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44263 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPRnopc:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT),
     /*  44266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44268 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44271 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44285 */     GIR_RootConstrainSelectedInstOperands,
     /*  44286 */     // GIR_Coverage, 1878,
     /*  44286 */     GIR_EraseRootFromParent_Done,
     /*  44287 */   // Label 978: @44287
     /*  44287 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(44352), // Rule ID 1882 //
     /*  44292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  44295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  44317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44325 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44329 */     // MIs[1] Operand 1
     /*  44329 */     // No operand predicates
     /*  44329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44331 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPRnopc:{ *:[i32] }:$a)
     /*  44331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAT16),
     /*  44334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44339 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44341 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44344 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44350 */     GIR_RootConstrainSelectedInstOperands,
     /*  44351 */     // GIR_Coverage, 1882,
     /*  44351 */     GIR_EraseRootFromParent_Done,
     /*  44352 */   // Label 979: @44352
     /*  44352 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(44420), // Rule ID 2146 //
     /*  44357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat),
     /*  44365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44378 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44386 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44390 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44394 */     // MIs[1] Operand 1
     /*  44394 */     // No operand predicates
     /*  44394 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44396 */     // (intrinsic_wo_chain:{ *:[i32] } 3912:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos)  =>  (t2USAT:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$pos, GPR:{ *:[i32] }:$a, 0:{ *:[i32] })
     /*  44396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT),
     /*  44399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44401 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44404 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44409 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44418 */     GIR_RootConstrainSelectedInstOperands,
     /*  44419 */     // GIR_Coverage, 2146,
     /*  44419 */     GIR_EraseRootFromParent_Done,
     /*  44420 */   // Label 980: @44420
     /*  44420 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(44485), // Rule ID 2148 //
     /*  44425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  44428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usat16),
     /*  44433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  44436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  44439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  44446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  44450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44462 */     // MIs[1] Operand 1
     /*  44462 */     // No operand predicates
     /*  44462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44464 */     // (intrinsic_wo_chain:{ *:[i32] } 3913:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos)  =>  (t2USAT16:{ *:[i32] } (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$pos, GPR:{ *:[i32] }:$a)
     /*  44464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAT16),
     /*  44467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // pos
     /*  44472 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  44474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44483 */     GIR_RootConstrainSelectedInstOperands,
     /*  44484 */     // GIR_Coverage, 2148,
     /*  44484 */     GIR_EraseRootFromParent_Done,
     /*  44485 */   // Label 981: @44485
     /*  44485 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(44568), // Rule ID 3925 //
     /*  44490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  44498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  44501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44520 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  44524 */     // MIs[1] Operand 1
     /*  44524 */     // No operand predicates
     /*  44524 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44526 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3650:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VQSHLU_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  44526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms8),
     /*  44541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44543 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44545 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44557 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44563 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44566 */     GIR_RootConstrainSelectedInstOperands,
     /*  44567 */     // GIR_Coverage, 3925,
     /*  44567 */     GIR_EraseRootFromParent_Done,
     /*  44568 */   // Label 982: @44568
     /*  44568 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(44651), // Rule ID 3927 //
     /*  44573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  44581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  44584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44603 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  44607 */     // MIs[1] Operand 1
     /*  44607 */     // No operand predicates
     /*  44607 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44609 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3650:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VQSHLU_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  44609 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44612 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44616 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms16),
     /*  44624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44626 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44649 */     GIR_RootConstrainSelectedInstOperands,
     /*  44650 */     // GIR_Coverage, 3927,
     /*  44650 */     GIR_EraseRootFromParent_Done,
     /*  44651 */   // Label 983: @44651
     /*  44651 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(44734), // Rule ID 3929 //
     /*  44656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshlu_imm),
     /*  44661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  44664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  44667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  44678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44686 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  44690 */     // MIs[1] Operand 1
     /*  44690 */     // No operand predicates
     /*  44690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44692 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3650:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VQSHLU_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  44692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  44695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  44699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  44704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLU_imms32),
     /*  44707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  44709 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  44711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  44714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  44717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44729 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  44732 */     GIR_RootConstrainSelectedInstOperands,
     /*  44733 */     // GIR_Coverage, 3929,
     /*  44733 */     GIR_EraseRootFromParent_Done,
     /*  44734 */   // Label 984: @44734
     /*  44734 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(44795), // Rule ID 1649 //
     /*  44739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44772 */     // MIs[1] Operand 1
     /*  44772 */     // No operand predicates
     /*  44772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44774 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3728:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsd),
     /*  44777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44781 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44793 */     GIR_RootConstrainSelectedInstOperands,
     /*  44794 */     // GIR_Coverage, 1649,
     /*  44794 */     GIR_EraseRootFromParent_Done,
     /*  44795 */   // Label 985: @44795
     /*  44795 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(44856), // Rule ID 1650 //
     /*  44800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  44808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44833 */     // MIs[1] Operand 1
     /*  44833 */     // No operand predicates
     /*  44833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44835 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3729:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xud),
     /*  44838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44845 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44848 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44854 */     GIR_RootConstrainSelectedInstOperands,
     /*  44855 */     // GIR_Coverage, 1650,
     /*  44855 */     GIR_EraseRootFromParent_Done,
     /*  44856 */   // Label 986: @44856
     /*  44856 */   GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(44917), // Rule ID 1651 //
     /*  44861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  44869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44894 */     // MIs[1] Operand 1
     /*  44894 */     // No operand predicates
     /*  44894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44896 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3731:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fd),
     /*  44899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44903 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44906 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44915 */     GIR_RootConstrainSelectedInstOperands,
     /*  44916 */     // GIR_Coverage, 1651,
     /*  44916 */     GIR_EraseRootFromParent_Done,
     /*  44917 */   // Label 987: @44917
     /*  44917 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(44978), // Rule ID 1652 //
     /*  44922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  44930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  44933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  44939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  44951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44955 */     // MIs[1] Operand 1
     /*  44955 */     // No operand predicates
     /*  44955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  44957 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3732:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  44957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fd),
     /*  44960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  44962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  44964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  44967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  44970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  44976 */     GIR_RootConstrainSelectedInstOperands,
     /*  44977 */     // GIR_Coverage, 1652,
     /*  44977 */     GIR_EraseRootFromParent_Done,
     /*  44978 */   // Label 988: @44978
     /*  44978 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(45039), // Rule ID 1653 //
     /*  44983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  44986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  44991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  44994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  44997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45016 */     // MIs[1] Operand 1
     /*  45016 */     // No operand predicates
     /*  45016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45018 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3728:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsd),
     /*  45021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45025 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45028 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45031 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45037 */     GIR_RootConstrainSelectedInstOperands,
     /*  45038 */     // GIR_Coverage, 1653,
     /*  45038 */     GIR_EraseRootFromParent_Done,
     /*  45039 */   // Label 989: @45039
     /*  45039 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(45100), // Rule ID 1654 //
     /*  45044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45077 */     // MIs[1] Operand 1
     /*  45077 */     // No operand predicates
     /*  45077 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45079 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3729:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xud),
     /*  45082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45086 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45089 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45092 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45098 */     GIR_RootConstrainSelectedInstOperands,
     /*  45099 */     // GIR_Coverage, 1654,
     /*  45099 */     GIR_EraseRootFromParent_Done,
     /*  45100 */   // Label 990: @45100
     /*  45100 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(45161), // Rule ID 1655 //
     /*  45105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45138 */     // MIs[1] Operand 1
     /*  45138 */     // No operand predicates
     /*  45138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45140 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3731:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hd),
     /*  45143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45159 */     GIR_RootConstrainSelectedInstOperands,
     /*  45160 */     // GIR_Coverage, 1655,
     /*  45160 */     GIR_EraseRootFromParent_Done,
     /*  45161 */   // Label 991: @45161
     /*  45161 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(45222), // Rule ID 1656 //
     /*  45166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  45177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  45180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  45191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45199 */     // MIs[1] Operand 1
     /*  45199 */     // No operand predicates
     /*  45199 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45201 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3732:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hd),
     /*  45204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45208 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45220 */     GIR_RootConstrainSelectedInstOperands,
     /*  45221 */     // GIR_Coverage, 1656,
     /*  45221 */     GIR_EraseRootFromParent_Done,
     /*  45222 */   // Label 992: @45222
     /*  45222 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(45283), // Rule ID 1657 //
     /*  45227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45260 */     // MIs[1] Operand 1
     /*  45260 */     // No operand predicates
     /*  45260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45262 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3728:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xsq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xsq),
     /*  45265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45269 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45272 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45281 */     GIR_RootConstrainSelectedInstOperands,
     /*  45282 */     // GIR_Coverage, 1657,
     /*  45282 */     GIR_EraseRootFromParent_Done,
     /*  45283 */   // Label 993: @45283
     /*  45283 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(45344), // Rule ID 1658 //
     /*  45288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45321 */     // MIs[1] Operand 1
     /*  45321 */     // No operand predicates
     /*  45321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45323 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3729:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTf2xuq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2xuq),
     /*  45326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45336 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45342 */     GIR_RootConstrainSelectedInstOperands,
     /*  45343 */     // GIR_Coverage, 1658,
     /*  45343 */     GIR_EraseRootFromParent_Done,
     /*  45344 */   // Label 994: @45344
     /*  45344 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(45405), // Rule ID 1659 //
     /*  45349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45382 */     // MIs[1] Operand 1
     /*  45382 */     // No operand predicates
     /*  45382 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45384 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3731:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2fq),
     /*  45387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45391 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45403 */     GIR_RootConstrainSelectedInstOperands,
     /*  45404 */     // GIR_Coverage, 1659,
     /*  45404 */     GIR_EraseRootFromParent_Done,
     /*  45405 */   // Label 995: @45405
     /*  45405 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(45466), // Rule ID 1660 //
     /*  45410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  45421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  45424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45435 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45439 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45443 */     // MIs[1] Operand 1
     /*  45443 */     // No operand predicates
     /*  45443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45445 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3732:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2fq),
     /*  45448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45455 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45458 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45464 */     GIR_RootConstrainSelectedInstOperands,
     /*  45465 */     // GIR_Coverage, 1660,
     /*  45465 */     GIR_EraseRootFromParent_Done,
     /*  45466 */   // Label 996: @45466
     /*  45466 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(45527), // Rule ID 1661 //
     /*  45471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxs),
     /*  45479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45504 */     // MIs[1] Operand 1
     /*  45504 */     // No operand predicates
     /*  45504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45506 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3728:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xsq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xsq),
     /*  45509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45513 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45525 */     GIR_RootConstrainSelectedInstOperands,
     /*  45526 */     // GIR_Coverage, 1661,
     /*  45526 */     GIR_EraseRootFromParent_Done,
     /*  45527 */   // Label 997: @45527
     /*  45527 */   GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(45588), // Rule ID 1662 //
     /*  45532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfp2fxu),
     /*  45540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45565 */     // MIs[1] Operand 1
     /*  45565 */     // No operand predicates
     /*  45565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45567 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3729:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTh2xuq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2xuq),
     /*  45570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45586 */     GIR_RootConstrainSelectedInstOperands,
     /*  45587 */     // GIR_Coverage, 1662,
     /*  45587 */     GIR_EraseRootFromParent_Done,
     /*  45588 */   // Label 998: @45588
     /*  45588 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(45649), // Rule ID 1663 //
     /*  45593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxs2fp),
     /*  45601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45626 */     // MIs[1] Operand 1
     /*  45626 */     // No operand predicates
     /*  45626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45628 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3731:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxs2hq),
     /*  45631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45647 */     GIR_RootConstrainSelectedInstOperands,
     /*  45648 */     // GIR_Coverage, 1663,
     /*  45648 */     GIR_EraseRootFromParent_Done,
     /*  45649 */   // Label 999: @45649
     /*  45649 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(45710), // Rule ID 1664 //
     /*  45654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  45657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcvtfxu2fp),
     /*  45662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  45665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  45668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45675 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  45679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45687 */     // MIs[1] Operand 1
     /*  45687 */     // No operand predicates
     /*  45687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45689 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3732:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)  =>  (VCVTxu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm, (imm:{ *:[i32] }):$SIMM)
     /*  45689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTxu2hq),
     /*  45692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  45694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  45696 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // SIMM
     /*  45699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45708 */     GIR_RootConstrainSelectedInstOperands,
     /*  45709 */     // GIR_Coverage, 1664,
     /*  45709 */     GIR_EraseRootFromParent_Done,
     /*  45710 */   // Label 1000: @45710
     /*  45710 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(45771), // Rule ID 1722 //
     /*  45715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqshl),
     /*  45723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45748 */     // MIs[1] Operand 1
     /*  45748 */     // No operand predicates
     /*  45748 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45750 */     // (intrinsic_wo_chain:{ *:[i32] } 3555:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQSHL),
     /*  45753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45755 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45769 */     GIR_RootConstrainSelectedInstOperands,
     /*  45770 */     // GIR_Coverage, 1722,
     /*  45770 */     GIR_EraseRootFromParent_Done,
     /*  45771 */   // Label 1001: @45771
     /*  45771 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(45832), // Rule ID 1723 //
     /*  45776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_srshr),
     /*  45784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45809 */     // MIs[1] Operand 1
     /*  45809 */     // No operand predicates
     /*  45809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45811 */     // (intrinsic_wo_chain:{ *:[i32] } 3557:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_SRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SRSHR),
     /*  45814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45816 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45824 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45830 */     GIR_RootConstrainSelectedInstOperands,
     /*  45831 */     // GIR_Coverage, 1723,
     /*  45831 */     GIR_EraseRootFromParent_Done,
     /*  45832 */   // Label 1002: @45832
     /*  45832 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(45893), // Rule ID 1724 //
     /*  45837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqshl),
     /*  45845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45870 */     // MIs[1] Operand 1
     /*  45870 */     // No operand predicates
     /*  45870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45872 */     // (intrinsic_wo_chain:{ *:[i32] } 3562:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_UQSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQSHL),
     /*  45875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45877 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45891 */     GIR_RootConstrainSelectedInstOperands,
     /*  45892 */     // GIR_Coverage, 1724,
     /*  45892 */     GIR_EraseRootFromParent_Done,
     /*  45893 */   // Label 1003: @45893
     /*  45893 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(45954), // Rule ID 1725 //
     /*  45898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  45901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_urshr),
     /*  45906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  45923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  45927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45931 */     // MIs[1] Operand 1
     /*  45931 */     // No operand predicates
     /*  45931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45933 */     // (intrinsic_wo_chain:{ *:[i32] } 3564:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)  =>  (MVE_URSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, (imm:{ *:[i32] }):$imm)
     /*  45933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_URSHR),
     /*  45936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  45938 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  45940 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  45943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  45946 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  45952 */     GIR_RootConstrainSelectedInstOperands,
     /*  45953 */     // GIR_Coverage, 1725,
     /*  45953 */     GIR_EraseRootFromParent_Done,
     /*  45954 */   // Label 1004: @45954
     /*  45954 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(46008), // Rule ID 105 //
     /*  45959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  45962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  45967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  45970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  45973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  45976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  45988 */     // (intrinsic_wo_chain:{ *:[i32] } 3837:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  45988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD8),
     /*  45991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  45995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  45997 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46000 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46006 */     GIR_RootConstrainSelectedInstOperands,
     /*  46007 */     // GIR_Coverage, 105,
     /*  46007 */     GIR_EraseRootFromParent_Done,
     /*  46008 */   // Label 1005: @46008
     /*  46008 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(46062), // Rule ID 106 //
     /*  46013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  46021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46042 */     // (intrinsic_wo_chain:{ *:[i32] } 3836:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD16),
     /*  46045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46054 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46060 */     GIR_RootConstrainSelectedInstOperands,
     /*  46061 */     // GIR_Coverage, 106,
     /*  46061 */     GIR_EraseRootFromParent_Done,
     /*  46062 */   // Label 1006: @46062
     /*  46062 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(46116), // Rule ID 107 //
     /*  46067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  46075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46096 */     // (intrinsic_wo_chain:{ *:[i32] } 3841:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB16),
     /*  46099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46114 */     GIR_RootConstrainSelectedInstOperands,
     /*  46115 */     // GIR_Coverage, 107,
     /*  46115 */     GIR_EraseRootFromParent_Done,
     /*  46116 */   // Label 1007: @46116
     /*  46116 */   GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(46170), // Rule ID 108 //
     /*  46121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  46129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46138 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46142 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46146 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46150 */     // (intrinsic_wo_chain:{ *:[i32] } 3842:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB8),
     /*  46153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46155 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46157 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46168 */     GIR_RootConstrainSelectedInstOperands,
     /*  46169 */     // GIR_Coverage, 108,
     /*  46169 */     GIR_EraseRootFromParent_Done,
     /*  46170 */   // Label 1008: @46170
     /*  46170 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(46224), // Rule ID 111 //
     /*  46175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  46183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46200 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46204 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QSUB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /*  46207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46222 */     GIR_RootConstrainSelectedInstOperands,
     /*  46223 */     // GIR_Coverage, 111,
     /*  46223 */     GIR_EraseRootFromParent_Done,
     /*  46224 */   // Label 1009: @46224
     /*  46224 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(46278), // Rule ID 112 //
     /*  46229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  46237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46258 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)  =>  (QADD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Rn)
     /*  46258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /*  46261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  46265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  46267 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46270 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46276 */     GIR_RootConstrainSelectedInstOperands,
     /*  46277 */     // GIR_Coverage, 112,
     /*  46277 */     GIR_EraseRootFromParent_Done,
     /*  46278 */   // Label 1010: @46278
     /*  46278 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(46332), // Rule ID 113 //
     /*  46283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  46291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46312 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD16),
     /*  46315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46330 */     GIR_RootConstrainSelectedInstOperands,
     /*  46331 */     // GIR_Coverage, 113,
     /*  46331 */     GIR_EraseRootFromParent_Done,
     /*  46332 */   // Label 1011: @46332
     /*  46332 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(46386), // Rule ID 114 //
     /*  46337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  46345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46366 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQADD8),
     /*  46369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46384 */     GIR_RootConstrainSelectedInstOperands,
     /*  46385 */     // GIR_Coverage, 114,
     /*  46385 */     GIR_EraseRootFromParent_Done,
     /*  46386 */   // Label 1012: @46386
     /*  46386 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(46440), // Rule ID 115 //
     /*  46391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  46399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46420 */     // (intrinsic_wo_chain:{ *:[i32] } 3908:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB16),
     /*  46423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46438 */     GIR_RootConstrainSelectedInstOperands,
     /*  46439 */     // GIR_Coverage, 115,
     /*  46439 */     GIR_EraseRootFromParent_Done,
     /*  46440 */   // Label 1013: @46440
     /*  46440 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(46494), // Rule ID 116 //
     /*  46445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  46453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46466 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46470 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46474 */     // (intrinsic_wo_chain:{ *:[i32] } 3909:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSUB8),
     /*  46477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46481 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46492 */     GIR_RootConstrainSelectedInstOperands,
     /*  46493 */     // GIR_Coverage, 116,
     /*  46493 */     GIR_EraseRootFromParent_Done,
     /*  46494 */   // Label 1014: @46494
     /*  46494 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(46548), // Rule ID 117 //
     /*  46499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  46507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46524 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46528 */     // (intrinsic_wo_chain:{ *:[i32] } 3838:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QASX),
     /*  46531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46540 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46546 */     GIR_RootConstrainSelectedInstOperands,
     /*  46547 */     // GIR_Coverage, 117,
     /*  46547 */     GIR_EraseRootFromParent_Done,
     /*  46548 */   // Label 1015: @46548
     /*  46548 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(46602), // Rule ID 118 //
     /*  46553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  46561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46582 */     // (intrinsic_wo_chain:{ *:[i32] } 3839:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (QSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSAX),
     /*  46585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46591 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46594 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46600 */     GIR_RootConstrainSelectedInstOperands,
     /*  46601 */     // GIR_Coverage, 118,
     /*  46601 */     GIR_EraseRootFromParent_Done,
     /*  46602 */   // Label 1016: @46602
     /*  46602 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(46656), // Rule ID 119 //
     /*  46607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  46615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46632 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46636 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQASX),
     /*  46639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46648 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46654 */     GIR_RootConstrainSelectedInstOperands,
     /*  46655 */     // GIR_Coverage, 119,
     /*  46655 */     GIR_EraseRootFromParent_Done,
     /*  46656 */   // Label 1017: @46656
     /*  46656 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(46710), // Rule ID 120 //
     /*  46661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  46669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46690 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UQSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UQSAX),
     /*  46693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46708 */     GIR_RootConstrainSelectedInstOperands,
     /*  46709 */     // GIR_Coverage, 120,
     /*  46709 */     GIR_EraseRootFromParent_Done,
     /*  46710 */   // Label 1018: @46710
     /*  46710 */   GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(46764), // Rule ID 133 //
     /*  46715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  46723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46744 */     // (intrinsic_wo_chain:{ *:[i32] } 3850:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHASX),
     /*  46747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46753 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46756 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46762 */     GIR_RootConstrainSelectedInstOperands,
     /*  46763 */     // GIR_Coverage, 133,
     /*  46763 */     GIR_EraseRootFromParent_Done,
     /*  46764 */   // Label 1019: @46764
     /*  46764 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(46818), // Rule ID 134 //
     /*  46769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  46777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46794 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46798 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD16),
     /*  46801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46816 */     GIR_RootConstrainSelectedInstOperands,
     /*  46817 */     // GIR_Coverage, 134,
     /*  46817 */     GIR_EraseRootFromParent_Done,
     /*  46818 */   // Label 1020: @46818
     /*  46818 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(46872), // Rule ID 135 //
     /*  46823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  46831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46852 */     // (intrinsic_wo_chain:{ *:[i32] } 3849:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHADD8),
     /*  46855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46870 */     GIR_RootConstrainSelectedInstOperands,
     /*  46871 */     // GIR_Coverage, 135,
     /*  46871 */     GIR_EraseRootFromParent_Done,
     /*  46872 */   // Label 1021: @46872
     /*  46872 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(46926), // Rule ID 136 //
     /*  46877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  46885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46906 */     // (intrinsic_wo_chain:{ *:[i32] } 3851:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSAX),
     /*  46909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46924 */     GIR_RootConstrainSelectedInstOperands,
     /*  46925 */     // GIR_Coverage, 136,
     /*  46925 */     GIR_EraseRootFromParent_Done,
     /*  46926 */   // Label 1022: @46926
     /*  46926 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(46980), // Rule ID 137 //
     /*  46931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  46939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  46948 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46952 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46956 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  46960 */     // (intrinsic_wo_chain:{ *:[i32] } 3852:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  46960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB16),
     /*  46963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46967 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  46969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  46972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  46978 */     GIR_RootConstrainSelectedInstOperands,
     /*  46979 */     // GIR_Coverage, 137,
     /*  46979 */     GIR_EraseRootFromParent_Done,
     /*  46980 */   // Label 1023: @46980
     /*  46980 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(47034), // Rule ID 138 //
     /*  46985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  46988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  46993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  46996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  46999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47002 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47014 */     // (intrinsic_wo_chain:{ *:[i32] } 3853:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHSUB8),
     /*  47017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47032 */     GIR_RootConstrainSelectedInstOperands,
     /*  47033 */     // GIR_Coverage, 138,
     /*  47033 */     GIR_EraseRootFromParent_Done,
     /*  47034 */   // Label 1024: @47034
     /*  47034 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(47088), // Rule ID 139 //
     /*  47039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  47047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47064 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47068 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHASX),
     /*  47071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47086 */     GIR_RootConstrainSelectedInstOperands,
     /*  47087 */     // GIR_Coverage, 139,
     /*  47087 */     GIR_EraseRootFromParent_Done,
     /*  47088 */   // Label 1025: @47088
     /*  47088 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(47142), // Rule ID 140 //
     /*  47093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  47101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47122 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD16),
     /*  47125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47134 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47140 */     GIR_RootConstrainSelectedInstOperands,
     /*  47141 */     // GIR_Coverage, 140,
     /*  47141 */     GIR_EraseRootFromParent_Done,
     /*  47142 */   // Label 1026: @47142
     /*  47142 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(47196), // Rule ID 141 //
     /*  47147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  47155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47172 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47176 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHADD8),
     /*  47179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47194 */     GIR_RootConstrainSelectedInstOperands,
     /*  47195 */     // GIR_Coverage, 141,
     /*  47195 */     GIR_EraseRootFromParent_Done,
     /*  47196 */   // Label 1027: @47196
     /*  47196 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(47250), // Rule ID 142 //
     /*  47201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  47209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47230 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSAX),
     /*  47233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47242 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47248 */     GIR_RootConstrainSelectedInstOperands,
     /*  47249 */     // GIR_Coverage, 142,
     /*  47249 */     GIR_EraseRootFromParent_Done,
     /*  47250 */   // Label 1028: @47250
     /*  47250 */   GIM_Try, /*On fail goto*//*Label 1029*/ GIMT_Encode4(47304), // Rule ID 143 //
     /*  47255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  47263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47284 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB16),
     /*  47287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47302 */     GIR_RootConstrainSelectedInstOperands,
     /*  47303 */     // GIR_Coverage, 143,
     /*  47303 */     GIR_EraseRootFromParent_Done,
     /*  47304 */   // Label 1029: @47304
     /*  47304 */   GIM_Try, /*On fail goto*//*Label 1030*/ GIMT_Encode4(47358), // Rule ID 144 //
     /*  47309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  47312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  47317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47338 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UHSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UHSUB8),
     /*  47341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47356 */     GIR_RootConstrainSelectedInstOperands,
     /*  47357 */     // GIR_Coverage, 144,
     /*  47357 */     GIR_EraseRootFromParent_Done,
     /*  47358 */   // Label 1030: @47358
     /*  47358 */   GIM_Try, /*On fail goto*//*Label 1031*/ GIMT_Encode4(47412), // Rule ID 145 //
     /*  47363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  47366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  47371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  47392 */     // (intrinsic_wo_chain:{ *:[i32] } 3910:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (USAD8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  47392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAD8),
     /*  47395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47410 */     GIR_RootConstrainSelectedInstOperands,
     /*  47411 */     // GIR_Coverage, 145,
     /*  47411 */     GIR_EraseRootFromParent_Done,
     /*  47412 */   // Label 1031: @47412
     /*  47412 */   GIM_Try, /*On fail goto*//*Label 1032*/ GIMT_Encode4(47457), // Rule ID 204 //
     /*  47417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  47425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47438 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47442 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47446 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32B:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32B),
     /*  47449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47455 */     GIR_RootConstrainSelectedInstOperands,
     /*  47456 */     // GIR_Coverage, 204,
     /*  47456 */     GIR_EraseRootFromParent_Done,
     /*  47457 */   // Label 1032: @47457
     /*  47457 */   GIM_Try, /*On fail goto*//*Label 1033*/ GIMT_Encode4(47502), // Rule ID 205 //
     /*  47462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  47470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47491 */     // (intrinsic_wo_chain:{ *:[i32] } 3470:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CB:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CB),
     /*  47494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47500 */     GIR_RootConstrainSelectedInstOperands,
     /*  47501 */     // GIR_Coverage, 205,
     /*  47501 */     GIR_EraseRootFromParent_Done,
     /*  47502 */   // Label 1033: @47502
     /*  47502 */   GIM_Try, /*On fail goto*//*Label 1034*/ GIMT_Encode4(47547), // Rule ID 206 //
     /*  47507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  47515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47536 */     // (intrinsic_wo_chain:{ *:[i32] } 3473:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32H:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32H),
     /*  47539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47545 */     GIR_RootConstrainSelectedInstOperands,
     /*  47546 */     // GIR_Coverage, 206,
     /*  47546 */     GIR_EraseRootFromParent_Done,
     /*  47547 */   // Label 1034: @47547
     /*  47547 */   GIM_Try, /*On fail goto*//*Label 1035*/ GIMT_Encode4(47592), // Rule ID 207 //
     /*  47552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  47560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47577 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47581 */     // (intrinsic_wo_chain:{ *:[i32] } 3471:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CH:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CH),
     /*  47584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47590 */     GIR_RootConstrainSelectedInstOperands,
     /*  47591 */     // GIR_Coverage, 207,
     /*  47591 */     GIR_EraseRootFromParent_Done,
     /*  47592 */   // Label 1035: @47592
     /*  47592 */   GIM_Try, /*On fail goto*//*Label 1036*/ GIMT_Encode4(47637), // Rule ID 208 //
     /*  47597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  47605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47626 */     // (intrinsic_wo_chain:{ *:[i32] } 3474:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32W:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32W),
     /*  47629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47635 */     GIR_RootConstrainSelectedInstOperands,
     /*  47636 */     // GIR_Coverage, 208,
     /*  47636 */     GIR_EraseRootFromParent_Done,
     /*  47637 */   // Label 1036: @47637
     /*  47637 */   GIM_Try, /*On fail goto*//*Label 1037*/ GIMT_Encode4(47682), // Rule ID 209 //
     /*  47642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsARM),
     /*  47645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  47650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  47671 */     // (intrinsic_wo_chain:{ *:[i32] } 3472:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (CRC32CW:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  47671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CRC32CW),
     /*  47674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47680 */     GIR_RootConstrainSelectedInstOperands,
     /*  47681 */     // GIR_Coverage, 209,
     /*  47681 */     GIR_EraseRootFromParent_Done,
     /*  47682 */   // Label 1037: @47682
     /*  47682 */   GIM_Try, /*On fail goto*//*Label 1038*/ GIMT_Encode4(47736), // Rule ID 432 //
     /*  47687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd16),
     /*  47695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47716 */     // (intrinsic_wo_chain:{ *:[i32] } 3836:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD16),
     /*  47719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47734 */     GIR_RootConstrainSelectedInstOperands,
     /*  47735 */     // GIR_Coverage, 432,
     /*  47735 */     GIR_EraseRootFromParent_Done,
     /*  47736 */   // Label 1038: @47736
     /*  47736 */   GIM_Try, /*On fail goto*//*Label 1039*/ GIMT_Encode4(47790), // Rule ID 433 //
     /*  47741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd8),
     /*  47749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47770 */     // (intrinsic_wo_chain:{ *:[i32] } 3837:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD8),
     /*  47773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47782 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47788 */     GIR_RootConstrainSelectedInstOperands,
     /*  47789 */     // GIR_Coverage, 433,
     /*  47789 */     GIR_EraseRootFromParent_Done,
     /*  47790 */   // Label 1039: @47790
     /*  47790 */   GIM_Try, /*On fail goto*//*Label 1040*/ GIMT_Encode4(47844), // Rule ID 434 //
     /*  47795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qasx),
     /*  47803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47820 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47824 */     // (intrinsic_wo_chain:{ *:[i32] } 3838:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QASX),
     /*  47827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47831 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47842 */     GIR_RootConstrainSelectedInstOperands,
     /*  47843 */     // GIR_Coverage, 434,
     /*  47843 */     GIR_EraseRootFromParent_Done,
     /*  47844 */   // Label 1040: @47844
     /*  47844 */   GIM_Try, /*On fail goto*//*Label 1041*/ GIMT_Encode4(47898), // Rule ID 435 //
     /*  47849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub8),
     /*  47857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47878 */     // (intrinsic_wo_chain:{ *:[i32] } 3909:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB8),
     /*  47881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47883 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47887 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47890 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47896 */     GIR_RootConstrainSelectedInstOperands,
     /*  47897 */     // GIR_Coverage, 435,
     /*  47897 */     GIR_EraseRootFromParent_Done,
     /*  47898 */   // Label 1041: @47898
     /*  47898 */   GIM_Try, /*On fail goto*//*Label 1042*/ GIMT_Encode4(47952), // Rule ID 436 //
     /*  47903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsax),
     /*  47911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47932 */     // (intrinsic_wo_chain:{ *:[i32] } 3839:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSAX),
     /*  47935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  47950 */     GIR_RootConstrainSelectedInstOperands,
     /*  47951 */     // GIR_Coverage, 436,
     /*  47951 */     GIR_EraseRootFromParent_Done,
     /*  47952 */   // Label 1042: @47952
     /*  47952 */   GIM_Try, /*On fail goto*//*Label 1043*/ GIMT_Encode4(48006), // Rule ID 437 //
     /*  47957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  47960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub16),
     /*  47965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  47968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  47971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  47974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  47986 */     // (intrinsic_wo_chain:{ *:[i32] } 3841:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  47986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB16),
     /*  47989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  47995 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  47998 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48004 */     GIR_RootConstrainSelectedInstOperands,
     /*  48005 */     // GIR_Coverage, 437,
     /*  48005 */     GIR_EraseRootFromParent_Done,
     /*  48006 */   // Label 1043: @48006
     /*  48006 */   GIM_Try, /*On fail goto*//*Label 1044*/ GIMT_Encode4(48060), // Rule ID 438 //
     /*  48011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub8),
     /*  48019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48040 */     // (intrinsic_wo_chain:{ *:[i32] } 3842:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2QSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB8),
     /*  48043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48058 */     GIR_RootConstrainSelectedInstOperands,
     /*  48059 */     // GIR_Coverage, 438,
     /*  48059 */     GIR_EraseRootFromParent_Done,
     /*  48060 */   // Label 1044: @48060
     /*  48060 */   GIM_Try, /*On fail goto*//*Label 1045*/ GIMT_Encode4(48114), // Rule ID 439 //
     /*  48065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd16),
     /*  48073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48094 */     // (intrinsic_wo_chain:{ *:[i32] } 3904:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD16),
     /*  48097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48103 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48112 */     GIR_RootConstrainSelectedInstOperands,
     /*  48113 */     // GIR_Coverage, 439,
     /*  48113 */     GIR_EraseRootFromParent_Done,
     /*  48114 */   // Label 1045: @48114
     /*  48114 */   GIM_Try, /*On fail goto*//*Label 1046*/ GIMT_Encode4(48168), // Rule ID 440 //
     /*  48119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqadd8),
     /*  48127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48144 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48148 */     // (intrinsic_wo_chain:{ *:[i32] } 3905:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQADD8),
     /*  48151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48157 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48160 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48166 */     GIR_RootConstrainSelectedInstOperands,
     /*  48167 */     // GIR_Coverage, 440,
     /*  48167 */     GIR_EraseRootFromParent_Done,
     /*  48168 */   // Label 1046: @48168
     /*  48168 */   GIM_Try, /*On fail goto*//*Label 1047*/ GIMT_Encode4(48222), // Rule ID 441 //
     /*  48173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqasx),
     /*  48181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48202 */     // (intrinsic_wo_chain:{ *:[i32] } 3906:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQASX),
     /*  48205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48211 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48220 */     GIR_RootConstrainSelectedInstOperands,
     /*  48221 */     // GIR_Coverage, 441,
     /*  48221 */     GIR_EraseRootFromParent_Done,
     /*  48222 */   // Label 1047: @48222
     /*  48222 */   GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(48276), // Rule ID 442 //
     /*  48227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsax),
     /*  48235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48256 */     // (intrinsic_wo_chain:{ *:[i32] } 3907:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSAX),
     /*  48259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48268 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48274 */     GIR_RootConstrainSelectedInstOperands,
     /*  48275 */     // GIR_Coverage, 442,
     /*  48275 */     GIR_EraseRootFromParent_Done,
     /*  48276 */   // Label 1048: @48276
     /*  48276 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(48330), // Rule ID 443 //
     /*  48281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uqsub16),
     /*  48289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48302 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48310 */     // (intrinsic_wo_chain:{ *:[i32] } 3908:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UQSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UQSUB16),
     /*  48313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48322 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48328 */     GIR_RootConstrainSelectedInstOperands,
     /*  48329 */     // GIR_Coverage, 443,
     /*  48329 */     GIR_EraseRootFromParent_Done,
     /*  48330 */   // Label 1049: @48330
     /*  48330 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(48384), // Rule ID 456 //
     /*  48335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shasx),
     /*  48343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48364 */     // (intrinsic_wo_chain:{ *:[i32] } 3850:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHASX),
     /*  48367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48382 */     GIR_RootConstrainSelectedInstOperands,
     /*  48383 */     // GIR_Coverage, 456,
     /*  48383 */     GIR_EraseRootFromParent_Done,
     /*  48384 */   // Label 1050: @48384
     /*  48384 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(48438), // Rule ID 457 //
     /*  48389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd16),
     /*  48397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48418 */     // (intrinsic_wo_chain:{ *:[i32] } 3848:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD16),
     /*  48421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48425 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48436 */     GIR_RootConstrainSelectedInstOperands,
     /*  48437 */     // GIR_Coverage, 457,
     /*  48437 */     GIR_EraseRootFromParent_Done,
     /*  48438 */   // Label 1051: @48438
     /*  48438 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(48492), // Rule ID 458 //
     /*  48443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shadd8),
     /*  48451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48472 */     // (intrinsic_wo_chain:{ *:[i32] } 3849:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHADD8),
     /*  48475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48484 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48490 */     GIR_RootConstrainSelectedInstOperands,
     /*  48491 */     // GIR_Coverage, 458,
     /*  48491 */     GIR_EraseRootFromParent_Done,
     /*  48492 */   // Label 1052: @48492
     /*  48492 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(48546), // Rule ID 459 //
     /*  48497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsax),
     /*  48505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48518 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48522 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48526 */     // (intrinsic_wo_chain:{ *:[i32] } 3851:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSAX),
     /*  48529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48531 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48535 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48538 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48544 */     GIR_RootConstrainSelectedInstOperands,
     /*  48545 */     // GIR_Coverage, 459,
     /*  48545 */     GIR_EraseRootFromParent_Done,
     /*  48546 */   // Label 1053: @48546
     /*  48546 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(48600), // Rule ID 460 //
     /*  48551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub16),
     /*  48559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48572 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48576 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48580 */     // (intrinsic_wo_chain:{ *:[i32] } 3852:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB16),
     /*  48583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48592 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48598 */     GIR_RootConstrainSelectedInstOperands,
     /*  48599 */     // GIR_Coverage, 460,
     /*  48599 */     GIR_EraseRootFromParent_Done,
     /*  48600 */   // Label 1054: @48600
     /*  48600 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(48654), // Rule ID 461 //
     /*  48605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_shsub8),
     /*  48613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48634 */     // (intrinsic_wo_chain:{ *:[i32] } 3853:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SHSUB8),
     /*  48637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48652 */     GIR_RootConstrainSelectedInstOperands,
     /*  48653 */     // GIR_Coverage, 461,
     /*  48653 */     GIR_EraseRootFromParent_Done,
     /*  48654 */   // Label 1055: @48654
     /*  48654 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(48708), // Rule ID 462 //
     /*  48659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhasx),
     /*  48667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48688 */     // (intrinsic_wo_chain:{ *:[i32] } 3899:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHASX),
     /*  48691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48706 */     GIR_RootConstrainSelectedInstOperands,
     /*  48707 */     // GIR_Coverage, 462,
     /*  48707 */     GIR_EraseRootFromParent_Done,
     /*  48708 */   // Label 1056: @48708
     /*  48708 */   GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(48762), // Rule ID 463 //
     /*  48713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd16),
     /*  48721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48742 */     // (intrinsic_wo_chain:{ *:[i32] } 3897:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD16),
     /*  48745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48760 */     GIR_RootConstrainSelectedInstOperands,
     /*  48761 */     // GIR_Coverage, 463,
     /*  48761 */     GIR_EraseRootFromParent_Done,
     /*  48762 */   // Label 1057: @48762
     /*  48762 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(48816), // Rule ID 464 //
     /*  48767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhadd8),
     /*  48775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48796 */     // (intrinsic_wo_chain:{ *:[i32] } 3898:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHADD8),
     /*  48799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48805 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48808 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48814 */     GIR_RootConstrainSelectedInstOperands,
     /*  48815 */     // GIR_Coverage, 464,
     /*  48815 */     GIR_EraseRootFromParent_Done,
     /*  48816 */   // Label 1058: @48816
     /*  48816 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(48870), // Rule ID 465 //
     /*  48821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsax),
     /*  48829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48850 */     // (intrinsic_wo_chain:{ *:[i32] } 3900:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSAX),
     /*  48853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48868 */     GIR_RootConstrainSelectedInstOperands,
     /*  48869 */     // GIR_Coverage, 465,
     /*  48869 */     GIR_EraseRootFromParent_Done,
     /*  48870 */   // Label 1059: @48870
     /*  48870 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(48924), // Rule ID 466 //
     /*  48875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub16),
     /*  48883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48896 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48900 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48904 */     // (intrinsic_wo_chain:{ *:[i32] } 3901:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB16),
     /*  48907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48916 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48922 */     GIR_RootConstrainSelectedInstOperands,
     /*  48923 */     // GIR_Coverage, 466,
     /*  48923 */     GIR_EraseRootFromParent_Done,
     /*  48924 */   // Label 1060: @48924
     /*  48924 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(48978), // Rule ID 467 //
     /*  48929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uhsub8),
     /*  48937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  48946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  48958 */     // (intrinsic_wo_chain:{ *:[i32] } 3902:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UHSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  48958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UHSUB8),
     /*  48961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48963 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  48965 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  48967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  48970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  48976 */     GIR_RootConstrainSelectedInstOperands,
     /*  48977 */     // GIR_Coverage, 467,
     /*  48977 */     GIR_EraseRootFromParent_Done,
     /*  48978 */   // Label 1061: @48978
     /*  48978 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(49032), // Rule ID 468 //
     /*  48983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  48986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usad8),
     /*  48991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  48994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  48997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49012 */     // (intrinsic_wo_chain:{ *:[i32] } 3910:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAD8),
     /*  49015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49030 */     GIR_RootConstrainSelectedInstOperands,
     /*  49031 */     // GIR_Coverage, 468,
     /*  49031 */     GIR_EraseRootFromParent_Done,
     /*  49032 */   // Label 1062: @49032
     /*  49032 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(49086), // Rule ID 524 //
     /*  49037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  49045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49066 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUAD),
     /*  49069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49084 */     GIR_RootConstrainSelectedInstOperands,
     /*  49085 */     // GIR_Coverage, 524,
     /*  49085 */     GIR_EraseRootFromParent_Done,
     /*  49086 */   // Label 1063: @49086
     /*  49086 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(49140), // Rule ID 525 //
     /*  49091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  49099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49120 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUADX),
     /*  49123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49129 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49138 */     GIR_RootConstrainSelectedInstOperands,
     /*  49139 */     // GIR_Coverage, 525,
     /*  49139 */     GIR_EraseRootFromParent_Done,
     /*  49140 */   // Label 1064: @49140
     /*  49140 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(49194), // Rule ID 526 //
     /*  49145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  49153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49170 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49174 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSD),
     /*  49177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49183 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49186 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49192 */     GIR_RootConstrainSelectedInstOperands,
     /*  49193 */     // GIR_Coverage, 526,
     /*  49193 */     GIR_EraseRootFromParent_Done,
     /*  49194 */   // Label 1065: @49194
     /*  49194 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(49248), // Rule ID 527 //
     /*  49199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  49202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  49207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49228 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMUSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMUSDX),
     /*  49231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49240 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49246 */     GIR_RootConstrainSelectedInstOperands,
     /*  49247 */     // GIR_Coverage, 527,
     /*  49247 */     GIR_EraseRootFromParent_Done,
     /*  49248 */   // Label 1066: @49248
     /*  49248 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(49293), // Rule ID 541 //
     /*  49253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32b),
     /*  49261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49282 */     // (intrinsic_wo_chain:{ *:[i32] } 3469:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32B:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32B),
     /*  49285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49291 */     GIR_RootConstrainSelectedInstOperands,
     /*  49292 */     // GIR_Coverage, 541,
     /*  49292 */     GIR_EraseRootFromParent_Done,
     /*  49293 */   // Label 1067: @49293
     /*  49293 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(49338), // Rule ID 542 //
     /*  49298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cb),
     /*  49306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49327 */     // (intrinsic_wo_chain:{ *:[i32] } 3470:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CB),
     /*  49330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49336 */     GIR_RootConstrainSelectedInstOperands,
     /*  49337 */     // GIR_Coverage, 542,
     /*  49337 */     GIR_EraseRootFromParent_Done,
     /*  49338 */   // Label 1068: @49338
     /*  49338 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(49383), // Rule ID 543 //
     /*  49343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32h),
     /*  49351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49372 */     // (intrinsic_wo_chain:{ *:[i32] } 3473:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32H:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32H),
     /*  49375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49381 */     GIR_RootConstrainSelectedInstOperands,
     /*  49382 */     // GIR_Coverage, 543,
     /*  49382 */     GIR_EraseRootFromParent_Done,
     /*  49383 */   // Label 1069: @49383
     /*  49383 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(49428), // Rule ID 544 //
     /*  49388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32ch),
     /*  49396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49417 */     // (intrinsic_wo_chain:{ *:[i32] } 3471:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CH:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CH),
     /*  49420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49426 */     GIR_RootConstrainSelectedInstOperands,
     /*  49427 */     // GIR_Coverage, 544,
     /*  49427 */     GIR_EraseRootFromParent_Done,
     /*  49428 */   // Label 1070: @49428
     /*  49428 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(49473), // Rule ID 545 //
     /*  49433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32w),
     /*  49441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49462 */     // (intrinsic_wo_chain:{ *:[i32] } 3474:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32W:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32W),
     /*  49465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49471 */     GIR_RootConstrainSelectedInstOperands,
     /*  49472 */     // GIR_Coverage, 545,
     /*  49472 */     GIR_EraseRootFromParent_Done,
     /*  49473 */   // Label 1071: @49473
     /*  49473 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(49518), // Rule ID 546 //
     /*  49478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC_IsThumb2),
     /*  49481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_crc32cw),
     /*  49486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  49489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  49492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  49495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  49507 */     // (intrinsic_wo_chain:{ *:[i32] } 3472:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2CRC32CW:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  49507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CRC32CW),
     /*  49510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  49514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  49516 */     GIR_RootConstrainSelectedInstOperands,
     /*  49517 */     // GIR_Coverage, 546,
     /*  49517 */     GIR_EraseRootFromParent_Done,
     /*  49518 */   // Label 1072: @49518
     /*  49518 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(49572), // Rule ID 789 //
     /*  49523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49552 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3740:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i16),
     /*  49555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49561 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49564 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49570 */     GIR_RootConstrainSelectedInstOperands,
     /*  49571 */     // GIR_Coverage, 789,
     /*  49571 */     GIR_EraseRootFromParent_Done,
     /*  49572 */   // Label 1073: @49572
     /*  49572 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(49626), // Rule ID 790 //
     /*  49577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49606 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3740:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv2i32),
     /*  49609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49624 */     GIR_RootConstrainSelectedInstOperands,
     /*  49625 */     // GIR_Coverage, 790,
     /*  49625 */     GIR_EraseRootFromParent_Done,
     /*  49626 */   // Label 1074: @49626
     /*  49626 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(49680), // Rule ID 791 //
     /*  49631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49660 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3740:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i16),
     /*  49663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49678 */     GIR_RootConstrainSelectedInstOperands,
     /*  49679 */     // GIR_Coverage, 791,
     /*  49679 */     GIR_EraseRootFromParent_Done,
     /*  49680 */   // Label 1075: @49680
     /*  49680 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(49734), // Rule ID 792 //
     /*  49685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  49696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  49699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  49702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49706 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49710 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49714 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3740:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  49714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv4i32),
     /*  49717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49726 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49732 */     GIR_RootConstrainSelectedInstOperands,
     /*  49733 */     // GIR_Coverage, 792,
     /*  49733 */     GIR_EraseRootFromParent_Done,
     /*  49734 */   // Label 1076: @49734
     /*  49734 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(49788), // Rule ID 793 //
     /*  49739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  49750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  49753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  49756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49768 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3740:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  49768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv8i8),
     /*  49771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49786 */     GIR_RootConstrainSelectedInstOperands,
     /*  49787 */     // GIR_Coverage, 793,
     /*  49787 */     GIR_EraseRootFromParent_Done,
     /*  49788 */   // Label 1077: @49788
     /*  49788 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(49842), // Rule ID 794 //
     /*  49793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhadds),
     /*  49801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  49804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  49807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  49810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3740:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  49822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDsv16i8),
     /*  49825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49831 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49834 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49840 */     GIR_RootConstrainSelectedInstOperands,
     /*  49841 */     // GIR_Coverage, 794,
     /*  49841 */     GIR_EraseRootFromParent_Done,
     /*  49842 */   // Label 1078: @49842
     /*  49842 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(49896), // Rule ID 795 //
     /*  49847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  49858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  49864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49876 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3741:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  49876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i16),
     /*  49879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49888 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49894 */     GIR_RootConstrainSelectedInstOperands,
     /*  49895 */     // GIR_Coverage, 795,
     /*  49895 */     GIR_EraseRootFromParent_Done,
     /*  49896 */   // Label 1079: @49896
     /*  49896 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(49950), // Rule ID 796 //
     /*  49901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  49912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  49915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  49918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  49930 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3741:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  49930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv2i32),
     /*  49933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  49948 */     GIR_RootConstrainSelectedInstOperands,
     /*  49949 */     // GIR_Coverage, 796,
     /*  49949 */     GIR_EraseRootFromParent_Done,
     /*  49950 */   // Label 1080: @49950
     /*  49950 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(50004), // Rule ID 797 //
     /*  49955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  49963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  49966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  49969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  49972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  49984 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3741:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  49984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i16),
     /*  49987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  49989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  49991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  49993 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  49996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50002 */     GIR_RootConstrainSelectedInstOperands,
     /*  50003 */     // GIR_Coverage, 797,
     /*  50003 */     GIR_EraseRootFromParent_Done,
     /*  50004 */   // Label 1081: @50004
     /*  50004 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(50058), // Rule ID 798 //
     /*  50009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50038 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3741:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv4i32),
     /*  50041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50047 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50050 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50056 */     GIR_RootConstrainSelectedInstOperands,
     /*  50057 */     // GIR_Coverage, 798,
     /*  50057 */     GIR_EraseRootFromParent_Done,
     /*  50058 */   // Label 1082: @50058
     /*  50058 */   GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(50112), // Rule ID 799 //
     /*  50063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50092 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3741:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv8i8),
     /*  50095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50104 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50110 */     GIR_RootConstrainSelectedInstOperands,
     /*  50111 */     // GIR_Coverage, 799,
     /*  50111 */     GIR_EraseRootFromParent_Done,
     /*  50112 */   // Label 1083: @50112
     /*  50112 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(50166), // Rule ID 800 //
     /*  50117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhaddu),
     /*  50125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50146 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3741:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHADDuv16i8),
     /*  50149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50153 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50164 */     GIR_RootConstrainSelectedInstOperands,
     /*  50165 */     // GIR_Coverage, 800,
     /*  50165 */     GIR_EraseRootFromParent_Done,
     /*  50166 */   // Label 1084: @50166
     /*  50166 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(50220), // Rule ID 801 //
     /*  50171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50200 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3800:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i16),
     /*  50203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50207 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50209 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50212 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50218 */     GIR_RootConstrainSelectedInstOperands,
     /*  50219 */     // GIR_Coverage, 801,
     /*  50219 */     GIR_EraseRootFromParent_Done,
     /*  50220 */   // Label 1085: @50220
     /*  50220 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(50274), // Rule ID 802 //
     /*  50225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50254 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3800:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv2i32),
     /*  50257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50272 */     GIR_RootConstrainSelectedInstOperands,
     /*  50273 */     // GIR_Coverage, 802,
     /*  50273 */     GIR_EraseRootFromParent_Done,
     /*  50274 */   // Label 1086: @50274
     /*  50274 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(50328), // Rule ID 803 //
     /*  50279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50308 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3800:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i16),
     /*  50311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50320 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50326 */     GIR_RootConstrainSelectedInstOperands,
     /*  50327 */     // GIR_Coverage, 803,
     /*  50327 */     GIR_EraseRootFromParent_Done,
     /*  50328 */   // Label 1087: @50328
     /*  50328 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(50382), // Rule ID 804 //
     /*  50333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50362 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3800:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv4i32),
     /*  50365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50380 */     GIR_RootConstrainSelectedInstOperands,
     /*  50381 */     // GIR_Coverage, 804,
     /*  50381 */     GIR_EraseRootFromParent_Done,
     /*  50382 */   // Label 1088: @50382
     /*  50382 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(50436), // Rule ID 805 //
     /*  50387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50416 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3800:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv8i8),
     /*  50419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50434 */     GIR_RootConstrainSelectedInstOperands,
     /*  50435 */     // GIR_Coverage, 805,
     /*  50435 */     GIR_EraseRootFromParent_Done,
     /*  50436 */   // Label 1089: @50436
     /*  50436 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(50490), // Rule ID 806 //
     /*  50441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhadds),
     /*  50449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50466 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50470 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3800:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDsv16i8),
     /*  50473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50475 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50477 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50479 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50482 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50488 */     GIR_RootConstrainSelectedInstOperands,
     /*  50489 */     // GIR_Coverage, 806,
     /*  50489 */     GIR_EraseRootFromParent_Done,
     /*  50490 */   // Label 1090: @50490
     /*  50490 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(50544), // Rule ID 807 //
     /*  50495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  50512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50524 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3801:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VRHADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  50524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i16),
     /*  50527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50536 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50542 */     GIR_RootConstrainSelectedInstOperands,
     /*  50543 */     // GIR_Coverage, 807,
     /*  50543 */     GIR_EraseRootFromParent_Done,
     /*  50544 */   // Label 1091: @50544
     /*  50544 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(50598), // Rule ID 808 //
     /*  50549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  50563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  50566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50578 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3801:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VRHADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  50578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv2i32),
     /*  50581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50596 */     GIR_RootConstrainSelectedInstOperands,
     /*  50597 */     // GIR_Coverage, 808,
     /*  50597 */     GIR_EraseRootFromParent_Done,
     /*  50598 */   // Label 1092: @50598
     /*  50598 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(50652), // Rule ID 809 //
     /*  50603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  50614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50632 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3801:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRHADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i16),
     /*  50635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50644 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50650 */     GIR_RootConstrainSelectedInstOperands,
     /*  50651 */     // GIR_Coverage, 809,
     /*  50651 */     GIR_EraseRootFromParent_Done,
     /*  50652 */   // Label 1093: @50652
     /*  50652 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(50706), // Rule ID 810 //
     /*  50657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  50668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50686 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3801:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRHADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv4i32),
     /*  50689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50695 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50698 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50704 */     GIR_RootConstrainSelectedInstOperands,
     /*  50705 */     // GIR_Coverage, 810,
     /*  50705 */     GIR_EraseRootFromParent_Done,
     /*  50706 */   // Label 1094: @50706
     /*  50706 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(50760), // Rule ID 811 //
     /*  50711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50740 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3801:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VRHADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  50740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv8i8),
     /*  50743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50749 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50758 */     GIR_RootConstrainSelectedInstOperands,
     /*  50759 */     // GIR_Coverage, 811,
     /*  50759 */     GIR_EraseRootFromParent_Done,
     /*  50760 */   // Label 1095: @50760
     /*  50760 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(50814), // Rule ID 812 //
     /*  50765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrhaddu),
     /*  50773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  50776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  50779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  50782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50794 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3801:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VRHADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  50794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRHADDuv16i8),
     /*  50797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50803 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50812 */     GIR_RootConstrainSelectedInstOperands,
     /*  50813 */     // GIR_Coverage, 812,
     /*  50813 */     GIR_EraseRootFromParent_Done,
     /*  50814 */   // Label 1096: @50814
     /*  50814 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(50868), // Rule ID 829 //
     /*  50819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  50836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50848 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3797:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRADDHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  50848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv8i8),
     /*  50851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50866 */     GIR_RootConstrainSelectedInstOperands,
     /*  50867 */     // GIR_Coverage, 829,
     /*  50867 */     GIR_EraseRootFromParent_Done,
     /*  50868 */   // Label 1097: @50868
     /*  50868 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(50922), // Rule ID 830 //
     /*  50873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  50884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  50887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  50890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50902 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3797:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRADDHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  50902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv4i16),
     /*  50905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50914 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50920 */     GIR_RootConstrainSelectedInstOperands,
     /*  50921 */     // GIR_Coverage, 830,
     /*  50921 */     GIR_EraseRootFromParent_Done,
     /*  50922 */   // Label 1098: @50922
     /*  50922 */   GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(50976), // Rule ID 831 //
     /*  50927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vraddhn),
     /*  50935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  50938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  50941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  50944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  50948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  50956 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3797:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRADDHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  50956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRADDHNv2i32),
     /*  50959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  50961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  50963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  50965 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  50968 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  50974 */     GIR_RootConstrainSelectedInstOperands,
     /*  50975 */     // GIR_Coverage, 831,
     /*  50975 */     GIR_EraseRootFromParent_Done,
     /*  50976 */   // Label 1099: @50976
     /*  50976 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(51030), // Rule ID 838 //
     /*  50981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  50989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  50992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  50998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51006 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51010 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3766:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULpd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpd),
     /*  51013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51022 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51028 */     GIR_RootConstrainSelectedInstOperands,
     /*  51029 */     // GIR_Coverage, 838,
     /*  51029 */     GIR_EraseRootFromParent_Done,
     /*  51030 */   // Label 1100: @51030
     /*  51030 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(51084), // Rule ID 839 //
     /*  51035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmulp),
     /*  51043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  51046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  51052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51064 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3766:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMULpq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  51064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULpq),
     /*  51067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51076 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51082 */     GIR_RootConstrainSelectedInstOperands,
     /*  51083 */     // GIR_Coverage, 839,
     /*  51083 */     GIR_EraseRootFromParent_Done,
     /*  51084 */   // Label 1101: @51084
     /*  51084 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(51138), // Rule ID 852 //
     /*  51089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51118 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3777:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i16),
     /*  51121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51136 */     GIR_RootConstrainSelectedInstOperands,
     /*  51137 */     // GIR_Coverage, 852,
     /*  51137 */     GIR_EraseRootFromParent_Done,
     /*  51138 */   // Label 1102: @51138
     /*  51138 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(51192), // Rule ID 853 //
     /*  51143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51172 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3777:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv2i32),
     /*  51175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51190 */     GIR_RootConstrainSelectedInstOperands,
     /*  51191 */     // GIR_Coverage, 853,
     /*  51191 */     GIR_EraseRootFromParent_Done,
     /*  51192 */   // Label 1103: @51192
     /*  51192 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(51246), // Rule ID 854 //
     /*  51197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51222 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51226 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3777:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv8i16),
     /*  51229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51231 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51233 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51235 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51244 */     GIR_RootConstrainSelectedInstOperands,
     /*  51245 */     // GIR_Coverage, 854,
     /*  51245 */     GIR_EraseRootFromParent_Done,
     /*  51246 */   // Label 1104: @51246
     /*  51246 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(51300), // Rule ID 855 //
     /*  51251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmulh),
     /*  51259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51276 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51280 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3777:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULHv4i32),
     /*  51283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51292 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51298 */     GIR_RootConstrainSelectedInstOperands,
     /*  51299 */     // GIR_Coverage, 855,
     /*  51299 */     GIR_EraseRootFromParent_Done,
     /*  51300 */   // Label 1105: @51300
     /*  51300 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(51354), // Rule ID 860 //
     /*  51305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51334 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3785:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMULHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i16),
     /*  51337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51352 */     GIR_RootConstrainSelectedInstOperands,
     /*  51353 */     // GIR_Coverage, 860,
     /*  51353 */     GIR_EraseRootFromParent_Done,
     /*  51354 */   // Label 1106: @51354
     /*  51354 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(51408), // Rule ID 861 //
     /*  51359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51388 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3785:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMULHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv2i32),
     /*  51391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51400 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51406 */     GIR_RootConstrainSelectedInstOperands,
     /*  51407 */     // GIR_Coverage, 861,
     /*  51407 */     GIR_EraseRootFromParent_Done,
     /*  51408 */   // Label 1107: @51408
     /*  51408 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(51462), // Rule ID 862 //
     /*  51413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51442 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3785:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMULHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv8i16),
     /*  51445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51454 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51460 */     GIR_RootConstrainSelectedInstOperands,
     /*  51461 */     // GIR_Coverage, 862,
     /*  51461 */     GIR_EraseRootFromParent_Done,
     /*  51462 */   // Label 1108: @51462
     /*  51462 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(51516), // Rule ID 863 //
     /*  51467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmulh),
     /*  51475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51492 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51496 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3785:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMULHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMULHv4i32),
     /*  51499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51514 */     GIR_RootConstrainSelectedInstOperands,
     /*  51515 */     // GIR_Coverage, 863,
     /*  51515 */     GIR_EraseRootFromParent_Done,
     /*  51516 */   // Label 1109: @51516
     /*  51516 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(51570), // Rule ID 874 //
     /*  51521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51550 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3763:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMULLp8:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp8),
     /*  51553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51557 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51559 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51568 */     GIR_RootConstrainSelectedInstOperands,
     /*  51569 */     // GIR_Coverage, 874,
     /*  51569 */     GIR_EraseRootFromParent_Done,
     /*  51570 */   // Label 1110: @51570
     /*  51570 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(51615), // Rule ID 875 //
     /*  51575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  51578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vmullp),
     /*  51583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  51589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  51592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51604 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3763:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VMULLp64:{ *:[v2i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /*  51604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULLp64),
     /*  51607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51613 */     GIR_RootConstrainSelectedInstOperands,
     /*  51614 */     // GIR_Coverage, 875,
     /*  51614 */     GIR_EraseRootFromParent_Done,
     /*  51615 */   // Label 1111: @51615
     /*  51615 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(51669), // Rule ID 880 //
     /*  51620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51641 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51645 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51649 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQDMULLv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv4i32),
     /*  51652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51658 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51667 */     GIR_RootConstrainSelectedInstOperands,
     /*  51668 */     // GIR_Coverage, 880,
     /*  51668 */     GIR_EraseRootFromParent_Done,
     /*  51669 */   // Label 1112: @51669
     /*  51669 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(51723), // Rule ID 881 //
     /*  51674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /*  51682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  51685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51688 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51699 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51703 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQDMULLv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMULLv2i64),
     /*  51706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51712 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51721 */     GIR_RootConstrainSelectedInstOperands,
     /*  51722 */     // GIR_Coverage, 881,
     /*  51722 */     GIR_EraseRootFromParent_Done,
     /*  51723 */   // Label 1113: @51723
     /*  51723 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(51777), // Rule ID 993 //
     /*  51728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  51739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  51742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  51745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51757 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3742:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  51757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i16),
     /*  51760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51775 */     GIR_RootConstrainSelectedInstOperands,
     /*  51776 */     // GIR_Coverage, 993,
     /*  51776 */     GIR_EraseRootFromParent_Done,
     /*  51777 */   // Label 1114: @51777
     /*  51777 */   GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(51831), // Rule ID 994 //
     /*  51782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  51793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  51796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  51799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51811 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3742:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  51811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv2i32),
     /*  51814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51829 */     GIR_RootConstrainSelectedInstOperands,
     /*  51830 */     // GIR_Coverage, 994,
     /*  51830 */     GIR_EraseRootFromParent_Done,
     /*  51831 */   // Label 1115: @51831
     /*  51831 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(51885), // Rule ID 995 //
     /*  51836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  51847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  51850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  51853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51865 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3742:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  51865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i16),
     /*  51868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51877 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51883 */     GIR_RootConstrainSelectedInstOperands,
     /*  51884 */     // GIR_Coverage, 995,
     /*  51884 */     GIR_EraseRootFromParent_Done,
     /*  51885 */   // Label 1116: @51885
     /*  51885 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(51939), // Rule ID 996 //
     /*  51890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  51901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  51904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  51907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  51919 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3742:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  51919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv4i32),
     /*  51922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51926 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51928 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51931 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51937 */     GIR_RootConstrainSelectedInstOperands,
     /*  51938 */     // GIR_Coverage, 996,
     /*  51938 */     GIR_EraseRootFromParent_Done,
     /*  51939 */   // Label 1117: @51939
     /*  51939 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(51993), // Rule ID 997 //
     /*  51944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  51952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  51955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  51961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  51973 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3742:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  51973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv8i8),
     /*  51976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  51978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  51980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  51982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  51985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51991 */     GIR_RootConstrainSelectedInstOperands,
     /*  51992 */     // GIR_Coverage, 997,
     /*  51992 */     GIR_EraseRootFromParent_Done,
     /*  51993 */   // Label 1118: @51993
     /*  51993 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(52047), // Rule ID 998 //
     /*  51998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubs),
     /*  52006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52027 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3742:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBsv16i8),
     /*  52030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52045 */     GIR_RootConstrainSelectedInstOperands,
     /*  52046 */     // GIR_Coverage, 998,
     /*  52046 */     GIR_EraseRootFromParent_Done,
     /*  52047 */   // Label 1119: @52047
     /*  52047 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(52101), // Rule ID 999 //
     /*  52052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52073 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52081 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3743:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VHSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  52081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i16),
     /*  52084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52099 */     GIR_RootConstrainSelectedInstOperands,
     /*  52100 */     // GIR_Coverage, 999,
     /*  52100 */     GIR_EraseRootFromParent_Done,
     /*  52101 */   // Label 1120: @52101
     /*  52101 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(52155), // Rule ID 1000 //
     /*  52106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52120 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52135 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3743:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VHSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  52135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv2i32),
     /*  52138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52147 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52153 */     GIR_RootConstrainSelectedInstOperands,
     /*  52154 */     // GIR_Coverage, 1000,
     /*  52154 */     GIR_EraseRootFromParent_Done,
     /*  52155 */   // Label 1121: @52155
     /*  52155 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(52209), // Rule ID 1001 //
     /*  52160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52189 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3743:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VHSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i16),
     /*  52192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52207 */     GIR_RootConstrainSelectedInstOperands,
     /*  52208 */     // GIR_Coverage, 1001,
     /*  52208 */     GIR_EraseRootFromParent_Done,
     /*  52209 */   // Label 1122: @52209
     /*  52209 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(52263), // Rule ID 1002 //
     /*  52214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52243 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3743:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VHSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv4i32),
     /*  52246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52261 */     GIR_RootConstrainSelectedInstOperands,
     /*  52262 */     // GIR_Coverage, 1002,
     /*  52262 */     GIR_EraseRootFromParent_Done,
     /*  52263 */   // Label 1123: @52263
     /*  52263 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(52317), // Rule ID 1003 //
     /*  52268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  52282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  52285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52297 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3743:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VHSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  52297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv8i8),
     /*  52300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52306 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52309 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52315 */     GIR_RootConstrainSelectedInstOperands,
     /*  52316 */     // GIR_Coverage, 1003,
     /*  52316 */     GIR_EraseRootFromParent_Done,
     /*  52317 */   // Label 1124: @52317
     /*  52317 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(52371), // Rule ID 1004 //
     /*  52322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vhsubu),
     /*  52330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  52333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  52336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  52339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52351 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3743:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VHSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  52351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VHSUBuv16i8),
     /*  52354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52369 */     GIR_RootConstrainSelectedInstOperands,
     /*  52370 */     // GIR_Coverage, 1004,
     /*  52370 */     GIR_EraseRootFromParent_Done,
     /*  52371 */   // Label 1125: @52371
     /*  52371 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(52425), // Rule ID 1021 //
     /*  52376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  52387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52397 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52405 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3813:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VRSUBHNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  52405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv8i8),
     /*  52408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52423 */     GIR_RootConstrainSelectedInstOperands,
     /*  52424 */     // GIR_Coverage, 1021,
     /*  52424 */     GIR_EraseRootFromParent_Done,
     /*  52425 */   // Label 1126: @52425
     /*  52425 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(52479), // Rule ID 1022 //
     /*  52430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52455 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52459 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3813:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VRSUBHNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  52459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv4i16),
     /*  52462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52477 */     GIR_RootConstrainSelectedInstOperands,
     /*  52478 */     // GIR_Coverage, 1022,
     /*  52478 */     GIR_EraseRootFromParent_Done,
     /*  52479 */   // Label 1127: @52479
     /*  52479 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(52533), // Rule ID 1023 //
     /*  52484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsubhn),
     /*  52492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  52498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  52501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52513 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3813:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VRSUBHNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /*  52513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSUBHNv2i32),
     /*  52516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52531 */     GIR_RootConstrainSelectedInstOperands,
     /*  52532 */     // GIR_Coverage, 1023,
     /*  52532 */     GIR_EraseRootFromParent_Done,
     /*  52533 */   // Label 1128: @52533
     /*  52533 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(52587), // Rule ID 1116 //
     /*  52538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52567 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3718:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGEfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfd),
     /*  52570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52576 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52585 */     GIR_RootConstrainSelectedInstOperands,
     /*  52586 */     // GIR_Coverage, 1116,
     /*  52586 */     GIR_EraseRootFromParent_Done,
     /*  52587 */   // Label 1129: @52587
     /*  52587 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(52641), // Rule ID 1117 //
     /*  52592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52621 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3718:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGEfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEfq),
     /*  52624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52630 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52639 */     GIR_RootConstrainSelectedInstOperands,
     /*  52640 */     // GIR_Coverage, 1117,
     /*  52640 */     GIR_EraseRootFromParent_Done,
     /*  52641 */   // Label 1130: @52641
     /*  52641 */   GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(52695), // Rule ID 1118 //
     /*  52646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52675 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3718:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGEhd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhd),
     /*  52678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52682 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52693 */     GIR_RootConstrainSelectedInstOperands,
     /*  52694 */     // GIR_Coverage, 1118,
     /*  52694 */     GIR_EraseRootFromParent_Done,
     /*  52695 */   // Label 1131: @52695
     /*  52695 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(52749), // Rule ID 1119 //
     /*  52700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacge),
     /*  52708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52725 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52729 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3718:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGEhq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGEhq),
     /*  52732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52747 */     GIR_RootConstrainSelectedInstOperands,
     /*  52748 */     // GIR_Coverage, 1119,
     /*  52748 */     GIR_EraseRootFromParent_Done,
     /*  52749 */   // Label 1132: @52749
     /*  52749 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(52803), // Rule ID 1120 //
     /*  52754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52783 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3719:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VACGTfd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfd),
     /*  52786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52801 */     GIR_RootConstrainSelectedInstOperands,
     /*  52802 */     // GIR_Coverage, 1120,
     /*  52802 */     GIR_EraseRootFromParent_Done,
     /*  52803 */   // Label 1133: @52803
     /*  52803 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(52857), // Rule ID 1121 //
     /*  52808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  52819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  52822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  52825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52837 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3719:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VACGTfq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  52837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGTfq),
     /*  52840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52849 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52855 */     GIR_RootConstrainSelectedInstOperands,
     /*  52856 */     // GIR_Coverage, 1121,
     /*  52856 */     GIR_EraseRootFromParent_Done,
     /*  52857 */   // Label 1134: @52857
     /*  52857 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(52911), // Rule ID 1122 //
     /*  52862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52865 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52870 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  52873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  52876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  52879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52891 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3719:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VACGThd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  52891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThd),
     /*  52894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52909 */     GIR_RootConstrainSelectedInstOperands,
     /*  52910 */     // GIR_Coverage, 1122,
     /*  52910 */     GIR_EraseRootFromParent_Done,
     /*  52911 */   // Label 1135: @52911
     /*  52911 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(52965), // Rule ID 1123 //
     /*  52916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  52919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vacgt),
     /*  52924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  52927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  52930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  52933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  52945 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3719:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VACGThq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  52945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VACGThq),
     /*  52948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  52950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  52952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  52954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  52957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52963 */     GIR_RootConstrainSelectedInstOperands,
     /*  52964 */     // GIR_Coverage, 1123,
     /*  52964 */     GIR_EraseRootFromParent_Done,
     /*  52965 */   // Label 1136: @52965
     /*  52965 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(53019), // Rule ID 1166 //
     /*  52970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  52973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  52978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  52981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  52984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  52987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  52999 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3715:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VABDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  52999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfd),
     /*  53002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53017 */     GIR_RootConstrainSelectedInstOperands,
     /*  53018 */     // GIR_Coverage, 1166,
     /*  53018 */     GIR_EraseRootFromParent_Done,
     /*  53019 */   // Label 1137: @53019
     /*  53019 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(53073), // Rule ID 1167 //
     /*  53024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53041 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53053 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3715:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VABDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  53053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDfq),
     /*  53056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53058 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53071 */     GIR_RootConstrainSelectedInstOperands,
     /*  53072 */     // GIR_Coverage, 1167,
     /*  53072 */     GIR_EraseRootFromParent_Done,
     /*  53073 */   // Label 1138: @53073
     /*  53073 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(53127), // Rule ID 1168 //
     /*  53078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53107 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3715:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VABDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhd),
     /*  53110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53125 */     GIR_RootConstrainSelectedInstOperands,
     /*  53126 */     // GIR_Coverage, 1168,
     /*  53126 */     GIR_EraseRootFromParent_Done,
     /*  53127 */   // Label 1139: @53127
     /*  53127 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(53181), // Rule ID 1169 //
     /*  53132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vabds),
     /*  53140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53161 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3715:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VABDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  53161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABDhq),
     /*  53164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53179 */     GIR_RootConstrainSelectedInstOperands,
     /*  53180 */     // GIR_Coverage, 1169,
     /*  53180 */     GIR_EraseRootFromParent_Done,
     /*  53181 */   // Label 1140: @53181
     /*  53181 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(53235), // Rule ID 1234 //
     /*  53186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  53197 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  53200 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53215 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3769:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADDi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  53215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi8),
     /*  53218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53227 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53233 */     GIR_RootConstrainSelectedInstOperands,
     /*  53234 */     // GIR_Coverage, 1234,
     /*  53234 */     GIR_EraseRootFromParent_Done,
     /*  53235 */   // Label 1141: @53235
     /*  53235 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(53289), // Rule ID 1235 //
     /*  53240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53269 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADDi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  53269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi16),
     /*  53272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53278 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53281 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53287 */     GIR_RootConstrainSelectedInstOperands,
     /*  53288 */     // GIR_Coverage, 1235,
     /*  53288 */     GIR_EraseRootFromParent_Done,
     /*  53289 */   // Label 1142: @53289
     /*  53289 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(53343), // Rule ID 1236 //
     /*  53294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53323 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADDi32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  53323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDi32),
     /*  53326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53332 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53341 */     GIR_RootConstrainSelectedInstOperands,
     /*  53342 */     // GIR_Coverage, 1236,
     /*  53342 */     GIR_EraseRootFromParent_Done,
     /*  53343 */   // Label 1143: @53343
     /*  53343 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(53397), // Rule ID 1237 //
     /*  53348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53377 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3769:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPADDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  53377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDf),
     /*  53380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53395 */     GIR_RootConstrainSelectedInstOperands,
     /*  53396 */     // GIR_Coverage, 1237,
     /*  53396 */     GIR_EraseRootFromParent_Done,
     /*  53397 */   // Label 1144: @53397
     /*  53397 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(53451), // Rule ID 1238 //
     /*  53402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  53405 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadd),
     /*  53410 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53413 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53416 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53431 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3769:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPADDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  53431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADDh),
     /*  53434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  53438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53449 */     GIR_RootConstrainSelectedInstOperands,
     /*  53450 */     // GIR_Coverage, 1238,
     /*  53450 */     GIR_EraseRootFromParent_Done,
     /*  53451 */   // Label 1145: @53451
     /*  53451 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(53505), // Rule ID 1251 //
     /*  53456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53481 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53485 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3767:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALsv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i8),
     /*  53488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53490 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53497 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53503 */     GIR_RootConstrainSelectedInstOperands,
     /*  53504 */     // GIR_Coverage, 1251,
     /*  53504 */     GIR_EraseRootFromParent_Done,
     /*  53505 */   // Label 1146: @53505
     /*  53505 */   GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(53559), // Rule ID 1252 //
     /*  53510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53535 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53539 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3767:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALsv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i16),
     /*  53542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53544 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53548 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53557 */     GIR_RootConstrainSelectedInstOperands,
     /*  53558 */     // GIR_Coverage, 1252,
     /*  53558 */     GIR_EraseRootFromParent_Done,
     /*  53559 */   // Label 1147: @53559
     /*  53559 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(53613), // Rule ID 1253 //
     /*  53564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53593 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3767:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALsv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv2i32),
     /*  53596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53598 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53611 */     GIR_RootConstrainSelectedInstOperands,
     /*  53612 */     // GIR_Coverage, 1253,
     /*  53612 */     GIR_EraseRootFromParent_Done,
     /*  53613 */   // Label 1148: @53613
     /*  53613 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(53667), // Rule ID 1254 //
     /*  53618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3767:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALsv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv16i8),
     /*  53650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53652 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53665 */     GIR_RootConstrainSelectedInstOperands,
     /*  53666 */     // GIR_Coverage, 1254,
     /*  53666 */     GIR_EraseRootFromParent_Done,
     /*  53667 */   // Label 1149: @53667
     /*  53667 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(53721), // Rule ID 1255 //
     /*  53672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  53683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  53686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  53689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53701 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3767:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALsv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  53701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv8i16),
     /*  53704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53706 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53719 */     GIR_RootConstrainSelectedInstOperands,
     /*  53720 */     // GIR_Coverage, 1255,
     /*  53720 */     GIR_EraseRootFromParent_Done,
     /*  53721 */   // Label 1150: @53721
     /*  53721 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(53775), // Rule ID 1256 //
     /*  53726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadals),
     /*  53734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  53737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  53740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  53743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53755 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3767:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALsv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  53755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALsv4i32),
     /*  53758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53760 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53773 */     GIR_RootConstrainSelectedInstOperands,
     /*  53774 */     // GIR_Coverage, 1256,
     /*  53774 */     GIR_EraseRootFromParent_Done,
     /*  53775 */   // Label 1151: @53775
     /*  53775 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(53829), // Rule ID 1257 //
     /*  53780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  53791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  53797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53809 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3768:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)  =>  (VPADALuv8i8:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v8i8] }:$Vm)
     /*  53809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i8),
     /*  53812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53814 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53827 */     GIR_RootConstrainSelectedInstOperands,
     /*  53828 */     // GIR_Coverage, 1257,
     /*  53828 */     GIR_EraseRootFromParent_Done,
     /*  53829 */   // Label 1152: @53829
     /*  53829 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(53883), // Rule ID 1258 //
     /*  53834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  53845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  53851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53863 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3768:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)  =>  (VPADALuv4i16:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v4i16] }:$Vm)
     /*  53863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i16),
     /*  53866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53868 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53881 */     GIR_RootConstrainSelectedInstOperands,
     /*  53882 */     // GIR_Coverage, 1258,
     /*  53882 */     GIR_EraseRootFromParent_Done,
     /*  53883 */   // Label 1153: @53883
     /*  53883 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(53937), // Rule ID 1259 //
     /*  53888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  53899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  53902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  53905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  53917 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3768:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)  =>  (VPADALuv2i32:{ *:[v1i64] } DPR:{ *:[v1i64] }:$src1, DPR:{ *:[v2i32] }:$Vm)
     /*  53917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv2i32),
     /*  53920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53922 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53935 */     GIR_RootConstrainSelectedInstOperands,
     /*  53936 */     // GIR_Coverage, 1259,
     /*  53936 */     GIR_EraseRootFromParent_Done,
     /*  53937 */   // Label 1154: @53937
     /*  53937 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(53991), // Rule ID 1260 //
     /*  53942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  53950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  53953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  53956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  53959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  53971 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3768:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)  =>  (VPADALuv16i8:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v16i8] }:$Vm)
     /*  53971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv16i8),
     /*  53974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  53976 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  53978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  53980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  53983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53989 */     GIR_RootConstrainSelectedInstOperands,
     /*  53990 */     // GIR_Coverage, 1260,
     /*  53990 */     GIR_EraseRootFromParent_Done,
     /*  53991 */   // Label 1155: @53991
     /*  53991 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(54045), // Rule ID 1261 //
     /*  53996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  54007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  54013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54017 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54021 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54025 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3768:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)  =>  (VPADALuv8i16:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v8i16] }:$Vm)
     /*  54025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv8i16),
     /*  54028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54030 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54034 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54043 */     GIR_RootConstrainSelectedInstOperands,
     /*  54044 */     // GIR_Coverage, 1261,
     /*  54044 */     GIR_EraseRootFromParent_Done,
     /*  54045 */   // Label 1156: @54045
     /*  54045 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(54099), // Rule ID 1262 //
     /*  54050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpadalu),
     /*  54058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  54061 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  54064 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  54067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54071 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  54079 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3768:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)  =>  (VPADALuv4i32:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, QPR:{ *:[v4i32] }:$Vm)
     /*  54079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPADALuv4i32),
     /*  54082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54084 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  54086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54097 */     GIR_RootConstrainSelectedInstOperands,
     /*  54098 */     // GIR_Coverage, 1262,
     /*  54098 */     GIR_EraseRootFromParent_Done,
     /*  54099 */   // Label 1157: @54099
     /*  54099 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(54153), // Rule ID 1263 //
     /*  54104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54133 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3772:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs8),
     /*  54136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54151 */     GIR_RootConstrainSelectedInstOperands,
     /*  54152 */     // GIR_Coverage, 1263,
     /*  54152 */     GIR_EraseRootFromParent_Done,
     /*  54153 */   // Label 1158: @54153
     /*  54153 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(54207), // Rule ID 1264 //
     /*  54158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54187 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs16),
     /*  54190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54205 */     GIR_RootConstrainSelectedInstOperands,
     /*  54206 */     // GIR_Coverage, 1264,
     /*  54206 */     GIR_EraseRootFromParent_Done,
     /*  54207 */   // Label 1159: @54207
     /*  54207 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(54261), // Rule ID 1265 //
     /*  54212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54241 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXs32),
     /*  54244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54259 */     GIR_RootConstrainSelectedInstOperands,
     /*  54260 */     // GIR_Coverage, 1265,
     /*  54260 */     GIR_EraseRootFromParent_Done,
     /*  54261 */   // Label 1160: @54261
     /*  54261 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(54315), // Rule ID 1266 //
     /*  54266 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54269 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54274 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54277 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54280 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54295 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3773:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMAXu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu8),
     /*  54298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54304 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54307 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54313 */     GIR_RootConstrainSelectedInstOperands,
     /*  54314 */     // GIR_Coverage, 1266,
     /*  54314 */     GIR_EraseRootFromParent_Done,
     /*  54315 */   // Label 1161: @54315
     /*  54315 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(54369), // Rule ID 1267 //
     /*  54320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54349 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3773:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMAXu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu16),
     /*  54352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54367 */     GIR_RootConstrainSelectedInstOperands,
     /*  54368 */     // GIR_Coverage, 1267,
     /*  54368 */     GIR_EraseRootFromParent_Done,
     /*  54369 */   // Label 1162: @54369
     /*  54369 */   GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(54423), // Rule ID 1268 //
     /*  54374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54377 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxu),
     /*  54382 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54385 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54388 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54399 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54403 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3773:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMAXu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXu32),
     /*  54406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54421 */     GIR_RootConstrainSelectedInstOperands,
     /*  54422 */     // GIR_Coverage, 1268,
     /*  54422 */     GIR_EraseRootFromParent_Done,
     /*  54423 */   // Label 1163: @54423
     /*  54423 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(54477), // Rule ID 1269 //
     /*  54428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54457 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3772:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMAXf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXf),
     /*  54460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54475 */     GIR_RootConstrainSelectedInstOperands,
     /*  54476 */     // GIR_Coverage, 1269,
     /*  54476 */     GIR_EraseRootFromParent_Done,
     /*  54477 */   // Label 1164: @54477
     /*  54477 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(54531), // Rule ID 1270 //
     /*  54482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmaxs),
     /*  54490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54507 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54511 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3772:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMAXh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMAXh),
     /*  54514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54523 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54529 */     GIR_RootConstrainSelectedInstOperands,
     /*  54530 */     // GIR_Coverage, 1270,
     /*  54530 */     GIR_EraseRootFromParent_Done,
     /*  54531 */   // Label 1165: @54531
     /*  54531 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(54585), // Rule ID 1271 //
     /*  54536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54565 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3774:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINs8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs8),
     /*  54568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54577 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54583 */     GIR_RootConstrainSelectedInstOperands,
     /*  54584 */     // GIR_Coverage, 1271,
     /*  54584 */     GIR_EraseRootFromParent_Done,
     /*  54585 */   // Label 1166: @54585
     /*  54585 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(54639), // Rule ID 1272 //
     /*  54590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54615 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54619 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINs16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs16),
     /*  54622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54637 */     GIR_RootConstrainSelectedInstOperands,
     /*  54638 */     // GIR_Coverage, 1272,
     /*  54638 */     GIR_EraseRootFromParent_Done,
     /*  54639 */   // Label 1167: @54639
     /*  54639 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(54693), // Rule ID 1273 //
     /*  54644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54673 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINs32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINs32),
     /*  54676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54691 */     GIR_RootConstrainSelectedInstOperands,
     /*  54692 */     // GIR_Coverage, 1273,
     /*  54692 */     GIR_EraseRootFromParent_Done,
     /*  54693 */   // Label 1168: @54693
     /*  54693 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(54747), // Rule ID 1274 //
     /*  54698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  54709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  54715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54727 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3775:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VPMINu8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  54727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu8),
     /*  54730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54745 */     GIR_RootConstrainSelectedInstOperands,
     /*  54746 */     // GIR_Coverage, 1274,
     /*  54746 */     GIR_EraseRootFromParent_Done,
     /*  54747 */   // Label 1169: @54747
     /*  54747 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(54801), // Rule ID 1275 //
     /*  54752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54755 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54760 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54763 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54766 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54781 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3775:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VPMINu16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  54781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu16),
     /*  54784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54799 */     GIR_RootConstrainSelectedInstOperands,
     /*  54800 */     // GIR_Coverage, 1275,
     /*  54800 */     GIR_EraseRootFromParent_Done,
     /*  54801 */   // Label 1170: @54801
     /*  54801 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(54855), // Rule ID 1276 //
     /*  54806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpminu),
     /*  54814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54831 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54835 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3775:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VPMINu32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  54835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINu32),
     /*  54838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54844 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54853 */     GIR_RootConstrainSelectedInstOperands,
     /*  54854 */     // GIR_Coverage, 1276,
     /*  54854 */     GIR_EraseRootFromParent_Done,
     /*  54855 */   // Label 1171: @54855
     /*  54855 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(54909), // Rule ID 1277 //
     /*  54860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54889 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3774:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VPMINf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINf),
     /*  54892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54907 */     GIR_RootConstrainSelectedInstOperands,
     /*  54908 */     // GIR_Coverage, 1277,
     /*  54908 */     GIR_EraseRootFromParent_Done,
     /*  54909 */   // Label 1172: @54909
     /*  54909 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(54963), // Rule ID 1278 //
     /*  54914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  54917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vpmins),
     /*  54922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  54925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  54928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  54931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54939 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54943 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3774:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VPMINh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  54943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VPMINh),
     /*  54946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  54948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  54950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  54952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  54955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  54961 */     GIR_RootConstrainSelectedInstOperands,
     /*  54962 */     // GIR_Coverage, 1278,
     /*  54962 */     GIR_EraseRootFromParent_Done,
     /*  54963 */   // Label 1173: @54963
     /*  54963 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(55017), // Rule ID 1285 //
     /*  54968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  54976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  54979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  54982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  54985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  54997 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3799:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRECPSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  54997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfd),
     /*  55000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55009 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55015 */     GIR_RootConstrainSelectedInstOperands,
     /*  55016 */     // GIR_Coverage, 1285,
     /*  55016 */     GIR_EraseRootFromParent_Done,
     /*  55017 */   // Label 1174: @55017
     /*  55017 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(55071), // Rule ID 1286 //
     /*  55022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55036 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55051 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3799:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRECPSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPSfq),
     /*  55054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55063 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55069 */     GIR_RootConstrainSelectedInstOperands,
     /*  55070 */     // GIR_Coverage, 1286,
     /*  55070 */     GIR_EraseRootFromParent_Done,
     /*  55071 */   // Label 1175: @55071
     /*  55071 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(55125), // Rule ID 1287 //
     /*  55076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55105 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3799:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRECPShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShd),
     /*  55108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55117 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55123 */     GIR_RootConstrainSelectedInstOperands,
     /*  55124 */     // GIR_Coverage, 1287,
     /*  55124 */     GIR_EraseRootFromParent_Done,
     /*  55125 */   // Label 1176: @55125
     /*  55125 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(55179), // Rule ID 1288 //
     /*  55130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrecps),
     /*  55138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55159 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3799:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRECPShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRECPShq),
     /*  55162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55168 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55177 */     GIR_RootConstrainSelectedInstOperands,
     /*  55178 */     // GIR_Coverage, 1288,
     /*  55178 */     GIR_EraseRootFromParent_Done,
     /*  55179 */   // Label 1177: @55179
     /*  55179 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(55233), // Rule ID 1295 //
     /*  55184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55209 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55213 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3812:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VRSQRTSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /*  55213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfd),
     /*  55216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55220 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55231 */     GIR_RootConstrainSelectedInstOperands,
     /*  55232 */     // GIR_Coverage, 1295,
     /*  55232 */     GIR_EraseRootFromParent_Done,
     /*  55233 */   // Label 1178: @55233
     /*  55233 */   GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(55287), // Rule ID 1296 //
     /*  55238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55267 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3812:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VRSQRTSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /*  55267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTSfq),
     /*  55270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55276 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55279 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55285 */     GIR_RootConstrainSelectedInstOperands,
     /*  55286 */     // GIR_Coverage, 1296,
     /*  55286 */     GIR_EraseRootFromParent_Done,
     /*  55287 */   // Label 1179: @55287
     /*  55287 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(55341), // Rule ID 1297 //
     /*  55292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55321 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3812:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VRSQRTShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /*  55321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShd),
     /*  55324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55339 */     GIR_RootConstrainSelectedInstOperands,
     /*  55340 */     // GIR_Coverage, 1297,
     /*  55340 */     GIR_EraseRootFromParent_Done,
     /*  55341 */   // Label 1180: @55341
     /*  55341 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(55395), // Rule ID 1298 //
     /*  55346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /*  55349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrsqrts),
     /*  55354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55360 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55371 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55375 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3812:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VRSQRTShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /*  55375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSQRTShq),
     /*  55378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  55382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  55384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55393 */     GIR_RootConstrainSelectedInstOperands,
     /*  55394 */     // GIR_Coverage, 1298,
     /*  55394 */     GIR_EraseRootFromParent_Done,
     /*  55395 */   // Label 1181: @55395
     /*  55395 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(55449), // Rule ID 1299 //
     /*  55400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55429 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3815:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i16),
     /*  55432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55447 */     GIR_RootConstrainSelectedInstOperands,
     /*  55448 */     // GIR_Coverage, 1299,
     /*  55448 */     GIR_EraseRootFromParent_Done,
     /*  55449 */   // Label 1182: @55449
     /*  55449 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(55503), // Rule ID 1300 //
     /*  55454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55468 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55483 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3815:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i32),
     /*  55486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55501 */     GIR_RootConstrainSelectedInstOperands,
     /*  55502 */     // GIR_Coverage, 1300,
     /*  55502 */     GIR_EraseRootFromParent_Done,
     /*  55503 */   // Label 1183: @55503
     /*  55503 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(55557), // Rule ID 1301 //
     /*  55508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55537 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3815:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i16),
     /*  55540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55555 */     GIR_RootConstrainSelectedInstOperands,
     /*  55556 */     // GIR_Coverage, 1301,
     /*  55556 */     GIR_EraseRootFromParent_Done,
     /*  55557 */   // Label 1184: @55557
     /*  55557 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(55611), // Rule ID 1302 //
     /*  55562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  55573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  55576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  55579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55587 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55591 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3815:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  55591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv4i32),
     /*  55594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55603 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55609 */     GIR_RootConstrainSelectedInstOperands,
     /*  55610 */     // GIR_Coverage, 1302,
     /*  55610 */     GIR_EraseRootFromParent_Done,
     /*  55611 */   // Label 1185: @55611
     /*  55611 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(55665), // Rule ID 1303 //
     /*  55616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  55627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  55630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  55633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55645 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3815:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  55645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv8i8),
     /*  55648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55663 */     GIR_RootConstrainSelectedInstOperands,
     /*  55664 */     // GIR_Coverage, 1303,
     /*  55664 */     GIR_EraseRootFromParent_Done,
     /*  55665 */   // Label 1186: @55665
     /*  55665 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(55719), // Rule ID 1304 //
     /*  55670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  55681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  55684 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  55687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55699 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3815:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  55699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv16i8),
     /*  55702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55717 */     GIR_RootConstrainSelectedInstOperands,
     /*  55718 */     // GIR_Coverage, 1304,
     /*  55718 */     GIR_EraseRootFromParent_Done,
     /*  55719 */   // Label 1187: @55719
     /*  55719 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(55773), // Rule ID 1305 //
     /*  55724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55727 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55732 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  55735 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55738 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  55741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55749 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55753 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3815:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  55753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv1i64),
     /*  55756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55771 */     GIR_RootConstrainSelectedInstOperands,
     /*  55772 */     // GIR_Coverage, 1305,
     /*  55772 */     GIR_EraseRootFromParent_Done,
     /*  55773 */   // Label 1188: @55773
     /*  55773 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(55827), // Rule ID 1306 //
     /*  55778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshifts),
     /*  55786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  55789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  55792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  55795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55807 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3815:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  55807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLsv2i64),
     /*  55810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55816 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55825 */     GIR_RootConstrainSelectedInstOperands,
     /*  55826 */     // GIR_Coverage, 1306,
     /*  55826 */     GIR_EraseRootFromParent_Done,
     /*  55827 */   // Label 1189: @55827
     /*  55827 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(55881), // Rule ID 1307 //
     /*  55832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  55843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  55846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  55849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55861 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3816:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  55861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i16),
     /*  55864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55873 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55879 */     GIR_RootConstrainSelectedInstOperands,
     /*  55880 */     // GIR_Coverage, 1307,
     /*  55880 */     GIR_EraseRootFromParent_Done,
     /*  55881 */   // Label 1190: @55881
     /*  55881 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(55935), // Rule ID 1308 //
     /*  55886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  55897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  55900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  55903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55911 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  55915 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3816:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  55915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i32),
     /*  55918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55933 */     GIR_RootConstrainSelectedInstOperands,
     /*  55934 */     // GIR_Coverage, 1308,
     /*  55934 */     GIR_EraseRootFromParent_Done,
     /*  55935 */   // Label 1191: @55935
     /*  55935 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(55989), // Rule ID 1309 //
     /*  55940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  55948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  55951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  55954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  55957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  55969 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3816:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  55969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i16),
     /*  55972 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  55974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  55976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  55978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  55981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  55987 */     GIR_RootConstrainSelectedInstOperands,
     /*  55988 */     // GIR_Coverage, 1309,
     /*  55988 */     GIR_EraseRootFromParent_Done,
     /*  55989 */   // Label 1192: @55989
     /*  55989 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(56043), // Rule ID 1310 //
     /*  55994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  55997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56019 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56023 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3816:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv4i32),
     /*  56026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56041 */     GIR_RootConstrainSelectedInstOperands,
     /*  56042 */     // GIR_Coverage, 1310,
     /*  56042 */     GIR_EraseRootFromParent_Done,
     /*  56043 */   // Label 1193: @56043
     /*  56043 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(56097), // Rule ID 1311 //
     /*  56048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56077 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3816:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv8i8),
     /*  56080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56095 */     GIR_RootConstrainSelectedInstOperands,
     /*  56096 */     // GIR_Coverage, 1311,
     /*  56096 */     GIR_EraseRootFromParent_Done,
     /*  56097 */   // Label 1194: @56097
     /*  56097 */   GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(56151), // Rule ID 1312 //
     /*  56102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56131 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3816:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv16i8),
     /*  56134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56149 */     GIR_RootConstrainSelectedInstOperands,
     /*  56150 */     // GIR_Coverage, 1312,
     /*  56150 */     GIR_EraseRootFromParent_Done,
     /*  56151 */   // Label 1195: @56151
     /*  56151 */   GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(56205), // Rule ID 1313 //
     /*  56156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56185 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3816:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv1i64),
     /*  56188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56203 */     GIR_RootConstrainSelectedInstOperands,
     /*  56204 */     // GIR_Coverage, 1313,
     /*  56204 */     GIR_EraseRootFromParent_Done,
     /*  56205 */   // Label 1196: @56205
     /*  56205 */   GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(56259), // Rule ID 1314 //
     /*  56210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vshiftu),
     /*  56218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56239 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3816:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSHLuv2i64),
     /*  56242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56257 */     GIR_RootConstrainSelectedInstOperands,
     /*  56258 */     // GIR_Coverage, 1314,
     /*  56258 */     GIR_EraseRootFromParent_Done,
     /*  56259 */   // Label 1197: @56259
     /*  56259 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(56313), // Rule ID 1348 //
     /*  56264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56293 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3809:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i16),
     /*  56296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56311 */     GIR_RootConstrainSelectedInstOperands,
     /*  56312 */     // GIR_Coverage, 1348,
     /*  56312 */     GIR_EraseRootFromParent_Done,
     /*  56313 */   // Label 1198: @56313
     /*  56313 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(56367), // Rule ID 1349 //
     /*  56318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56347 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3809:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i32),
     /*  56350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56365 */     GIR_RootConstrainSelectedInstOperands,
     /*  56366 */     // GIR_Coverage, 1349,
     /*  56366 */     GIR_EraseRootFromParent_Done,
     /*  56367 */   // Label 1199: @56367
     /*  56367 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(56421), // Rule ID 1350 //
     /*  56372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56401 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3809:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i16),
     /*  56404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56419 */     GIR_RootConstrainSelectedInstOperands,
     /*  56420 */     // GIR_Coverage, 1350,
     /*  56420 */     GIR_EraseRootFromParent_Done,
     /*  56421 */   // Label 1200: @56421
     /*  56421 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(56475), // Rule ID 1351 //
     /*  56426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56451 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56455 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3809:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv4i32),
     /*  56458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56464 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56473 */     GIR_RootConstrainSelectedInstOperands,
     /*  56474 */     // GIR_Coverage, 1351,
     /*  56474 */     GIR_EraseRootFromParent_Done,
     /*  56475 */   // Label 1201: @56475
     /*  56475 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(56529), // Rule ID 1352 //
     /*  56480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56505 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56509 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3809:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv8i8),
     /*  56512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56527 */     GIR_RootConstrainSelectedInstOperands,
     /*  56528 */     // GIR_Coverage, 1352,
     /*  56528 */     GIR_EraseRootFromParent_Done,
     /*  56529 */   // Label 1202: @56529
     /*  56529 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(56583), // Rule ID 1353 //
     /*  56534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56563 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3809:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv16i8),
     /*  56566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56581 */     GIR_RootConstrainSelectedInstOperands,
     /*  56582 */     // GIR_Coverage, 1353,
     /*  56582 */     GIR_EraseRootFromParent_Done,
     /*  56583 */   // Label 1203: @56583
     /*  56583 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(56637), // Rule ID 1354 //
     /*  56588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  56599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  56602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  56605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56617 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3809:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  56617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv1i64),
     /*  56620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56626 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56635 */     GIR_RootConstrainSelectedInstOperands,
     /*  56636 */     // GIR_Coverage, 1354,
     /*  56636 */     GIR_EraseRootFromParent_Done,
     /*  56637 */   // Label 1204: @56637
     /*  56637 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(56691), // Rule ID 1355 //
     /*  56642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshifts),
     /*  56650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  56653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  56656 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  56659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56671 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3809:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  56671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLsv2i64),
     /*  56674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56683 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56689 */     GIR_RootConstrainSelectedInstOperands,
     /*  56690 */     // GIR_Coverage, 1355,
     /*  56690 */     GIR_EraseRootFromParent_Done,
     /*  56691 */   // Label 1205: @56691
     /*  56691 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(56745), // Rule ID 1356 //
     /*  56696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  56707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  56710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  56713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56725 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3810:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  56725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i16),
     /*  56728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56743 */     GIR_RootConstrainSelectedInstOperands,
     /*  56744 */     // GIR_Coverage, 1356,
     /*  56744 */     GIR_EraseRootFromParent_Done,
     /*  56745 */   // Label 1206: @56745
     /*  56745 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(56799), // Rule ID 1357 //
     /*  56750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  56761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  56767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56775 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56779 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3810:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  56779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i32),
     /*  56782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56797 */     GIR_RootConstrainSelectedInstOperands,
     /*  56798 */     // GIR_Coverage, 1357,
     /*  56798 */     GIR_EraseRootFromParent_Done,
     /*  56799 */   // Label 1207: @56799
     /*  56799 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(56853), // Rule ID 1358 //
     /*  56804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56807 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56812 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  56815 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  56818 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  56821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56833 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3810:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  56833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i16),
     /*  56836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56845 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56851 */     GIR_RootConstrainSelectedInstOperands,
     /*  56852 */     // GIR_Coverage, 1358,
     /*  56852 */     GIR_EraseRootFromParent_Done,
     /*  56853 */   // Label 1208: @56853
     /*  56853 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(56907), // Rule ID 1359 //
     /*  56858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  56869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  56872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  56875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3810:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  56887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv4i32),
     /*  56890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56905 */     GIR_RootConstrainSelectedInstOperands,
     /*  56906 */     // GIR_Coverage, 1359,
     /*  56906 */     GIR_EraseRootFromParent_Done,
     /*  56907 */   // Label 1209: @56907
     /*  56907 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(56961), // Rule ID 1360 //
     /*  56912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  56923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  56926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  56929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  56941 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3810:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  56941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv8i8),
     /*  56944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  56946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  56948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  56950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  56953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56959 */     GIR_RootConstrainSelectedInstOperands,
     /*  56960 */     // GIR_Coverage, 1360,
     /*  56960 */     GIR_EraseRootFromParent_Done,
     /*  56961 */   // Label 1210: @56961
     /*  56961 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(57015), // Rule ID 1361 //
     /*  56966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  56974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  56977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  56980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  56983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  56995 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3810:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  56995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv16i8),
     /*  56998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57013 */     GIR_RootConstrainSelectedInstOperands,
     /*  57014 */     // GIR_Coverage, 1361,
     /*  57014 */     GIR_EraseRootFromParent_Done,
     /*  57015 */   // Label 1211: @57015
     /*  57015 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(57069), // Rule ID 1362 //
     /*  57020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57023 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57028 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57031 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57034 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57049 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3810:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv1i64),
     /*  57052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57067 */     GIR_RootConstrainSelectedInstOperands,
     /*  57068 */     // GIR_Coverage, 1362,
     /*  57068 */     GIR_EraseRootFromParent_Done,
     /*  57069 */   // Label 1212: @57069
     /*  57069 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(57123), // Rule ID 1363 //
     /*  57074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vrshiftu),
     /*  57082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57095 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57099 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57103 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3810:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRSHLuv2i64),
     /*  57106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57110 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57121 */     GIR_RootConstrainSelectedInstOperands,
     /*  57122 */     // GIR_Coverage, 1363,
     /*  57122 */     GIR_EraseRootFromParent_Done,
     /*  57123 */   // Label 1213: @57123
     /*  57123 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(57177), // Rule ID 1383 //
     /*  57128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57157 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3794:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i16),
     /*  57160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57166 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57175 */     GIR_RootConstrainSelectedInstOperands,
     /*  57176 */     // GIR_Coverage, 1383,
     /*  57176 */     GIR_EraseRootFromParent_Done,
     /*  57177 */   // Label 1214: @57177
     /*  57177 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(57231), // Rule ID 1384 //
     /*  57182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57207 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57211 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3794:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i32),
     /*  57214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57229 */     GIR_RootConstrainSelectedInstOperands,
     /*  57230 */     // GIR_Coverage, 1384,
     /*  57230 */     GIR_EraseRootFromParent_Done,
     /*  57231 */   // Label 1215: @57231
     /*  57231 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(57285), // Rule ID 1385 //
     /*  57236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57265 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3794:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i16),
     /*  57268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57274 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57283 */     GIR_RootConstrainSelectedInstOperands,
     /*  57284 */     // GIR_Coverage, 1385,
     /*  57284 */     GIR_EraseRootFromParent_Done,
     /*  57285 */   // Label 1216: @57285
     /*  57285 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(57339), // Rule ID 1386 //
     /*  57290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57319 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3794:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv4i32),
     /*  57322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57337 */     GIR_RootConstrainSelectedInstOperands,
     /*  57338 */     // GIR_Coverage, 1386,
     /*  57338 */     GIR_EraseRootFromParent_Done,
     /*  57339 */   // Label 1217: @57339
     /*  57339 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(57393), // Rule ID 1387 //
     /*  57344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57373 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3794:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv8i8),
     /*  57376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57385 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57391 */     GIR_RootConstrainSelectedInstOperands,
     /*  57392 */     // GIR_Coverage, 1387,
     /*  57392 */     GIR_EraseRootFromParent_Done,
     /*  57393 */   // Label 1218: @57393
     /*  57393 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(57447), // Rule ID 1388 //
     /*  57398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57427 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3794:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv16i8),
     /*  57430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57436 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57439 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57445 */     GIR_RootConstrainSelectedInstOperands,
     /*  57446 */     // GIR_Coverage, 1388,
     /*  57446 */     GIR_EraseRootFromParent_Done,
     /*  57447 */   // Label 1219: @57447
     /*  57447 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(57501), // Rule ID 1389 //
     /*  57452 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57481 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3794:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv1i64),
     /*  57484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57499 */     GIR_RootConstrainSelectedInstOperands,
     /*  57500 */     // GIR_Coverage, 1389,
     /*  57500 */     GIR_EraseRootFromParent_Done,
     /*  57501 */   // Label 1220: @57501
     /*  57501 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(57555), // Rule ID 1390 //
     /*  57506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshifts),
     /*  57514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57527 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57531 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57535 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3794:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLsv2i64),
     /*  57538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57553 */     GIR_RootConstrainSelectedInstOperands,
     /*  57554 */     // GIR_Coverage, 1390,
     /*  57554 */     GIR_EraseRootFromParent_Done,
     /*  57555 */   // Label 1221: @57555
     /*  57555 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(57609), // Rule ID 1391 //
     /*  57560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  57571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  57577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57589 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3796:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  57589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i16),
     /*  57592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57601 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57607 */     GIR_RootConstrainSelectedInstOperands,
     /*  57608 */     // GIR_Coverage, 1391,
     /*  57608 */     GIR_EraseRootFromParent_Done,
     /*  57609 */   // Label 1222: @57609
     /*  57609 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(57663), // Rule ID 1392 //
     /*  57614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  57625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  57628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  57631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57639 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57643 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3796:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  57643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i32),
     /*  57646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57661 */     GIR_RootConstrainSelectedInstOperands,
     /*  57662 */     // GIR_Coverage, 1392,
     /*  57662 */     GIR_EraseRootFromParent_Done,
     /*  57663 */   // Label 1223: @57663
     /*  57663 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(57717), // Rule ID 1393 //
     /*  57668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  57679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  57685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3796:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  57697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i16),
     /*  57700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57715 */     GIR_RootConstrainSelectedInstOperands,
     /*  57716 */     // GIR_Coverage, 1393,
     /*  57716 */     GIR_EraseRootFromParent_Done,
     /*  57717 */   // Label 1224: @57717
     /*  57717 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(57771), // Rule ID 1394 //
     /*  57722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  57733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  57739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57751 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3796:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  57751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv4i32),
     /*  57754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57769 */     GIR_RootConstrainSelectedInstOperands,
     /*  57770 */     // GIR_Coverage, 1394,
     /*  57770 */     GIR_EraseRootFromParent_Done,
     /*  57771 */   // Label 1225: @57771
     /*  57771 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(57825), // Rule ID 1395 //
     /*  57776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  57787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  57793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57805 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3796:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  57805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv8i8),
     /*  57808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57823 */     GIR_RootConstrainSelectedInstOperands,
     /*  57824 */     // GIR_Coverage, 1395,
     /*  57824 */     GIR_EraseRootFromParent_Done,
     /*  57825 */   // Label 1226: @57825
     /*  57825 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(57879), // Rule ID 1396 //
     /*  57830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  57841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  57847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57859 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3796:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  57859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv16i8),
     /*  57862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57868 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57877 */     GIR_RootConstrainSelectedInstOperands,
     /*  57878 */     // GIR_Coverage, 1396,
     /*  57878 */     GIR_EraseRootFromParent_Done,
     /*  57879 */   // Label 1227: @57879
     /*  57879 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(57933), // Rule ID 1397 //
     /*  57884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  57895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  57898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  57901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  57913 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3796:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  57913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv1i64),
     /*  57916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57931 */     GIR_RootConstrainSelectedInstOperands,
     /*  57932 */     // GIR_Coverage, 1397,
     /*  57932 */     GIR_EraseRootFromParent_Done,
     /*  57933 */   // Label 1228: @57933
     /*  57933 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(57987), // Rule ID 1398 //
     /*  57938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqshiftu),
     /*  57946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  57949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  57955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  57967 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3796:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  57967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSHLuv2i64),
     /*  57970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  57972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  57974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  57976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  57979 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  57985 */     GIR_RootConstrainSelectedInstOperands,
     /*  57986 */     // GIR_Coverage, 1398,
     /*  57986 */     GIR_EraseRootFromParent_Done,
     /*  57987 */   // Label 1229: @57987
     /*  57987 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(58041), // Rule ID 1432 //
     /*  57992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58021 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3789:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i16),
     /*  58024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58033 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58039 */     GIR_RootConstrainSelectedInstOperands,
     /*  58040 */     // GIR_Coverage, 1432,
     /*  58040 */     GIR_EraseRootFromParent_Done,
     /*  58041 */   // Label 1230: @58041
     /*  58041 */   GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(58095), // Rule ID 1433 //
     /*  58046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58060 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58075 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3789:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i32),
     /*  58078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58084 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58093 */     GIR_RootConstrainSelectedInstOperands,
     /*  58094 */     // GIR_Coverage, 1433,
     /*  58094 */     GIR_EraseRootFromParent_Done,
     /*  58095 */   // Label 1231: @58095
     /*  58095 */   GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(58149), // Rule ID 1434 //
     /*  58100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58129 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3789:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i16),
     /*  58132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58138 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58141 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58147 */     GIR_RootConstrainSelectedInstOperands,
     /*  58148 */     // GIR_Coverage, 1434,
     /*  58148 */     GIR_EraseRootFromParent_Done,
     /*  58149 */   // Label 1232: @58149
     /*  58149 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(58203), // Rule ID 1435 //
     /*  58154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58183 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3789:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv4i32),
     /*  58186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58201 */     GIR_RootConstrainSelectedInstOperands,
     /*  58202 */     // GIR_Coverage, 1435,
     /*  58202 */     GIR_EraseRootFromParent_Done,
     /*  58203 */   // Label 1233: @58203
     /*  58203 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(58257), // Rule ID 1436 //
     /*  58208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58237 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3789:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv8i8),
     /*  58240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58246 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58249 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58255 */     GIR_RootConstrainSelectedInstOperands,
     /*  58256 */     // GIR_Coverage, 1436,
     /*  58256 */     GIR_EraseRootFromParent_Done,
     /*  58257 */   // Label 1234: @58257
     /*  58257 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(58311), // Rule ID 1437 //
     /*  58262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58291 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3789:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv16i8),
     /*  58294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58300 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58309 */     GIR_RootConstrainSelectedInstOperands,
     /*  58310 */     // GIR_Coverage, 1437,
     /*  58310 */     GIR_EraseRootFromParent_Done,
     /*  58311 */   // Label 1235: @58311
     /*  58311 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(58365), // Rule ID 1438 //
     /*  58316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58345 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3789:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv1i64),
     /*  58348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58363 */     GIR_RootConstrainSelectedInstOperands,
     /*  58364 */     // GIR_Coverage, 1438,
     /*  58364 */     GIR_EraseRootFromParent_Done,
     /*  58365 */   // Label 1236: @58365
     /*  58365 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(58419), // Rule ID 1439 //
     /*  58370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshifts),
     /*  58378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58399 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3789:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLsv2i64),
     /*  58402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58417 */     GIR_RootConstrainSelectedInstOperands,
     /*  58418 */     // GIR_Coverage, 1439,
     /*  58418 */     GIR_EraseRootFromParent_Done,
     /*  58419 */   // Label 1237: @58419
     /*  58419 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(58473), // Rule ID 1440 //
     /*  58424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  58435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  58438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  58441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58449 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58453 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3790:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)  =>  (VQRSHLuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm, DPR:{ *:[v4i16] }:$Vn)
     /*  58453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i16),
     /*  58456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58465 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58471 */     GIR_RootConstrainSelectedInstOperands,
     /*  58472 */     // GIR_Coverage, 1440,
     /*  58472 */     GIR_EraseRootFromParent_Done,
     /*  58473 */   // Label 1238: @58473
     /*  58473 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(58527), // Rule ID 1441 //
     /*  58478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  58489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  58492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  58495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58507 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3790:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)  =>  (VQRSHLuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm, DPR:{ *:[v2i32] }:$Vn)
     /*  58507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i32),
     /*  58510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58516 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58525 */     GIR_RootConstrainSelectedInstOperands,
     /*  58526 */     // GIR_Coverage, 1441,
     /*  58526 */     GIR_EraseRootFromParent_Done,
     /*  58527 */   // Label 1239: @58527
     /*  58527 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(58581), // Rule ID 1442 //
     /*  58532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  58543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  58546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  58549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58561 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3790:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)  =>  (VQRSHLuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm, QPR:{ *:[v8i16] }:$Vn)
     /*  58561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i16),
     /*  58564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58579 */     GIR_RootConstrainSelectedInstOperands,
     /*  58580 */     // GIR_Coverage, 1442,
     /*  58580 */     GIR_EraseRootFromParent_Done,
     /*  58581 */   // Label 1240: @58581
     /*  58581 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(58635), // Rule ID 1443 //
     /*  58586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58603 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58615 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3790:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)  =>  (VQRSHLuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm, QPR:{ *:[v4i32] }:$Vn)
     /*  58615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv4i32),
     /*  58618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58633 */     GIR_RootConstrainSelectedInstOperands,
     /*  58634 */     // GIR_Coverage, 1443,
     /*  58634 */     GIR_EraseRootFromParent_Done,
     /*  58635 */   // Label 1241: @58635
     /*  58635 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(58689), // Rule ID 1444 //
     /*  58640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  58651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  58654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  58657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58669 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3790:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)  =>  (VQRSHLuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm, DPR:{ *:[v8i8] }:$Vn)
     /*  58669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv8i8),
     /*  58672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58678 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58681 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58687 */     GIR_RootConstrainSelectedInstOperands,
     /*  58688 */     // GIR_Coverage, 1444,
     /*  58688 */     GIR_EraseRootFromParent_Done,
     /*  58689 */   // Label 1242: @58689
     /*  58689 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(58743), // Rule ID 1445 //
     /*  58694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58723 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3790:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)  =>  (VQRSHLuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm, QPR:{ *:[v16i8] }:$Vn)
     /*  58723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv16i8),
     /*  58726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58741 */     GIR_RootConstrainSelectedInstOperands,
     /*  58742 */     // GIR_Coverage, 1445,
     /*  58742 */     GIR_EraseRootFromParent_Done,
     /*  58743 */   // Label 1243: @58743
     /*  58743 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(58797), // Rule ID 1446 //
     /*  58748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /*  58759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  58762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /*  58765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  58777 */     // (intrinsic_wo_chain:{ *:[v1i64] } 3790:{ *:[iPTR] }, DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)  =>  (VQRSHLuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vm, DPR:{ *:[v1i64] }:$Vn)
     /*  58777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv1i64),
     /*  58780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58786 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58795 */     GIR_RootConstrainSelectedInstOperands,
     /*  58796 */     // GIR_Coverage, 1446,
     /*  58796 */     GIR_EraseRootFromParent_Done,
     /*  58797 */   // Label 1244: @58797
     /*  58797 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(58851), // Rule ID 1447 //
     /*  58802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  58805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrshiftu),
     /*  58810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  58813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  58816 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  58819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58831 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3790:{ *:[iPTR] }, QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)  =>  (VQRSHLuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vm, QPR:{ *:[v2i64] }:$Vn)
     /*  58831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRSHLuv2i64),
     /*  58834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /*  58838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  58840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  58843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  58849 */     GIR_RootConstrainSelectedInstOperands,
     /*  58850 */     // GIR_Coverage, 1447,
     /*  58850 */     GIR_EraseRootFromParent_Done,
     /*  58851 */   // Label 1245: @58851
     /*  58851 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(58896), // Rule ID 1712 //
     /*  58856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aesd),
     /*  58864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58877 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58881 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58885 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3691:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESD:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESD),
     /*  58888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58890 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58894 */     GIR_RootConstrainSelectedInstOperands,
     /*  58895 */     // GIR_Coverage, 1712,
     /*  58895 */     GIR_EraseRootFromParent_Done,
     /*  58896 */   // Label 1246: @58896
     /*  58896 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(58941), // Rule ID 1713 //
     /*  58901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES_HasV8),
     /*  58904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_aese),
     /*  58909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  58912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  58915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  58918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58930 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3692:{ *:[iPTR] }, QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)  =>  (AESE:{ *:[v16i8] } QPR:{ *:[v16i8] }:$src, QPR:{ *:[v16i8] }:$Vm)
     /*  58930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::AESE),
     /*  58933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58935 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58937 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58939 */     GIR_RootConstrainSelectedInstOperands,
     /*  58940 */     // GIR_Coverage, 1713,
     /*  58940 */     GIR_EraseRootFromParent_Done,
     /*  58941 */   // Label 1247: @58941
     /*  58941 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(58986), // Rule ID 1716 //
     /*  58946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su1),
     /*  58954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  58957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  58960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  58963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  58975 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3705:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  58975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU1),
     /*  58978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  58980 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  58982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  58984 */     GIR_RootConstrainSelectedInstOperands,
     /*  58985 */     // GIR_Coverage, 1716,
     /*  58985 */     GIR_EraseRootFromParent_Done,
     /*  58986 */   // Label 1248: @58986
     /*  58986 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(59031), // Rule ID 1717 //
     /*  58991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  58994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su0),
     /*  58999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  59002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  59005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  59008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  59020 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3708:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vm)
     /*  59020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU0),
     /*  59023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  59025 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  59027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /*  59029 */     GIR_RootConstrainSelectedInstOperands,
     /*  59030 */     // GIR_Coverage, 1717,
     /*  59030 */     GIR_EraseRootFromParent_Done,
     /*  59031 */   // Label 1249: @59031
     /*  59031 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(59085), // Rule ID 1726 //
     /*  59036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_sqrshr),
     /*  59044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59065 */     // (intrinsic_wo_chain:{ *:[i32] } 3553:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_SQRSHR:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_SQRSHR),
     /*  59068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59070 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59083 */     GIR_RootConstrainSelectedInstOperands,
     /*  59084 */     // GIR_Coverage, 1726,
     /*  59084 */     GIR_EraseRootFromParent_Done,
     /*  59085 */   // Label 1250: @59085
     /*  59085 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(59139), // Rule ID 1727 //
     /*  59090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt_HasV8_1MMainline),
     /*  59093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_uqrshl),
     /*  59098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59119 */     // (intrinsic_wo_chain:{ *:[i32] } 3560:{ *:[iPTR] }, rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_UQRSHL:{ *:[i32] } rGPR:{ *:[i32] }:$RdaSrc, rGPR:{ *:[i32] }:$Rm)
     /*  59119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_UQRSHL),
     /*  59122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  59124 */     GIR_RootToRootCopy, /*OpIdx*/2, // RdaSrc
     /*  59126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59137 */     GIR_RootConstrainSelectedInstOperands,
     /*  59138 */     // GIR_Coverage, 1727,
     /*  59138 */     GIR_EraseRootFromParent_Done,
     /*  59139 */   // Label 1251: @59139
     /*  59139 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(59196), // Rule ID 1850 //
     /*  59144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59173 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (SXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTAB16),
     /*  59176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59178 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59180 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59185 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59188 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59194 */     GIR_RootConstrainSelectedInstOperands,
     /*  59195 */     // GIR_Coverage, 1850,
     /*  59195 */     GIR_EraseRootFromParent_Done,
     /*  59196 */   // Label 1252: @59196
     /*  59196 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(59253), // Rule ID 1857 //
     /*  59201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uxtab16),
     /*  59209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59230 */     // (intrinsic_wo_chain:{ *:[i32] } 3917:{ *:[iPTR] }, GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS)  =>  (UXTAB16:{ *:[i32] } GPR:{ *:[i32] }:$LHS, GPR:{ *:[i32] }:$RHS, 0:{ *:[i32] })
     /*  59230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UXTAB16),
     /*  59233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59235 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  59237 */     GIR_RootToRootCopy, /*OpIdx*/3, // RHS
     /*  59239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59251 */     GIR_RootConstrainSelectedInstOperands,
     /*  59252 */     // GIR_Coverage, 1857,
     /*  59252 */     GIR_EraseRootFromParent_Done,
     /*  59253 */   // Label 1253: @59253
     /*  59253 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(59307), // Rule ID 1904 //
     /*  59258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuad),
     /*  59266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59287 */     // (intrinsic_wo_chain:{ *:[i32] } 3868:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUAD),
     /*  59290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59305 */     GIR_RootConstrainSelectedInstOperands,
     /*  59306 */     // GIR_Coverage, 1904,
     /*  59306 */     GIR_EraseRootFromParent_Done,
     /*  59307 */   // Label 1254: @59307
     /*  59307 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(59361), // Rule ID 1905 //
     /*  59312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smuadx),
     /*  59320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59341 */     // (intrinsic_wo_chain:{ *:[i32] } 3869:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUADX),
     /*  59344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59350 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59353 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59359 */     GIR_RootConstrainSelectedInstOperands,
     /*  59360 */     // GIR_Coverage, 1905,
     /*  59360 */     GIR_EraseRootFromParent_Done,
     /*  59361 */   // Label 1255: @59361
     /*  59361 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(59415), // Rule ID 1906 //
     /*  59366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusd),
     /*  59374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59395 */     // (intrinsic_wo_chain:{ *:[i32] } 3876:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSD),
     /*  59398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59407 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59413 */     GIR_RootConstrainSelectedInstOperands,
     /*  59414 */     // GIR_Coverage, 1906,
     /*  59414 */     GIR_EraseRootFromParent_Done,
     /*  59415 */   // Label 1256: @59415
     /*  59415 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(59469), // Rule ID 1907 //
     /*  59420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  59423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smusdx),
     /*  59428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  59449 */     // (intrinsic_wo_chain:{ *:[i32] } 3877:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SMUSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  59449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMUSDX),
     /*  59452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59467 */     GIR_RootConstrainSelectedInstOperands,
     /*  59468 */     // GIR_Coverage, 1907,
     /*  59468 */     GIR_EraseRootFromParent_Done,
     /*  59469 */   // Label 1257: @59469
     /*  59469 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(59523), // Rule ID 1981 //
     /*  59474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59503 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBB),
     /*  59506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59508 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59510 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59512 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59521 */     GIR_RootConstrainSelectedInstOperands,
     /*  59522 */     // GIR_Coverage, 1981,
     /*  59522 */     GIR_EraseRootFromParent_Done,
     /*  59523 */   // Label 1258: @59523
     /*  59523 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(59577), // Rule ID 1982 //
     /*  59528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  59536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59557 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULBT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULBT),
     /*  59560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59562 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59564 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59566 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59575 */     GIR_RootConstrainSelectedInstOperands,
     /*  59576 */     // GIR_Coverage, 1982,
     /*  59576 */     GIR_EraseRootFromParent_Done,
     /*  59577 */   // Label 1259: @59577
     /*  59577 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(59631), // Rule ID 1983 //
     /*  59582 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  59590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59611 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTB),
     /*  59614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59616 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59618 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59629 */     GIR_RootConstrainSelectedInstOperands,
     /*  59630 */     // GIR_Coverage, 1983,
     /*  59630 */     GIR_EraseRootFromParent_Done,
     /*  59631 */   // Label 1260: @59631
     /*  59631 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(59685), // Rule ID 1984 //
     /*  59636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  59644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59661 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59665 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULTT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULTT),
     /*  59668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59670 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59672 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59677 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59683 */     GIR_RootConstrainSelectedInstOperands,
     /*  59684 */     // GIR_Coverage, 1984,
     /*  59684 */     GIR_EraseRootFromParent_Done,
     /*  59685 */   // Label 1261: @59685
     /*  59685 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(59739), // Rule ID 1985 //
     /*  59690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  59698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59719 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWB),
     /*  59722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59724 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59726 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59731 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59737 */     GIR_RootConstrainSelectedInstOperands,
     /*  59738 */     // GIR_Coverage, 1985,
     /*  59738 */     GIR_EraseRootFromParent_Done,
     /*  59739 */   // Label 1262: @59739
     /*  59739 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(59793), // Rule ID 1986 //
     /*  59744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  59747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  59752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59769 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  59773 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (SMULWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /*  59773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMULWT),
     /*  59776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59778 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  59780 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  59782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59785 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59791 */     GIR_RootConstrainSelectedInstOperands,
     /*  59792 */     // GIR_Coverage, 1986,
     /*  59792 */     GIR_EraseRootFromParent_Done,
     /*  59793 */   // Label 1263: @59793
     /*  59793 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(59850), // Rule ID 2097 //
     /*  59798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sxtab16),
     /*  59806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59827 */     // (intrinsic_wo_chain:{ *:[i32] } 3892:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SXTAB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, 0:{ *:[i32] })
     /*  59827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTAB16),
     /*  59830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  59836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  59839 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59848 */     GIR_RootConstrainSelectedInstOperands,
     /*  59849 */     // GIR_Coverage, 2097,
     /*  59849 */     GIR_EraseRootFromParent_Done,
     /*  59850 */   // Label 1264: @59850
     /*  59850 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(59904), // Rule ID 2127 //
     /*  59855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qadd),
     /*  59863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59880 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59884 */     // (intrinsic_wo_chain:{ *:[i32] } 3835:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /*  59887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59896 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59902 */     GIR_RootConstrainSelectedInstOperands,
     /*  59903 */     // GIR_Coverage, 2127,
     /*  59903 */     GIR_EraseRootFromParent_Done,
     /*  59904 */   // Label 1265: @59904
     /*  59904 */   GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(59958), // Rule ID 2128 //
     /*  59909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_qsub),
     /*  59917 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59920 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59923 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59938 */     // (intrinsic_wo_chain:{ *:[i32] } 3840:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /*  59938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /*  59941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  59945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  59947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  59950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  59956 */     GIR_RootConstrainSelectedInstOperands,
     /*  59957 */     // GIR_Coverage, 2128,
     /*  59957 */     GIR_EraseRootFromParent_Done,
     /*  59958 */   // Label 1266: @59958
     /*  59958 */   GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(60012), // Rule ID 2168 //
     /*  59963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  59966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbb),
     /*  59971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  59974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  59977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  59980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  59992 */     // (intrinsic_wo_chain:{ *:[i32] } 3870:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  59992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBB),
     /*  59995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  59997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  59999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60001 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60004 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60010 */     GIR_RootConstrainSelectedInstOperands,
     /*  60011 */     // GIR_Coverage, 2168,
     /*  60011 */     GIR_EraseRootFromParent_Done,
     /*  60012 */   // Label 1267: @60012
     /*  60012 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(60066), // Rule ID 2169 //
     /*  60017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulbt),
     /*  60025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60046 */     // (intrinsic_wo_chain:{ *:[i32] } 3871:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULBT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULBT),
     /*  60049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60053 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60064 */     GIR_RootConstrainSelectedInstOperands,
     /*  60065 */     // GIR_Coverage, 2169,
     /*  60065 */     GIR_EraseRootFromParent_Done,
     /*  60066 */   // Label 1268: @60066
     /*  60066 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(60120), // Rule ID 2170 //
     /*  60071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultb),
     /*  60079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60096 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60100 */     // (intrinsic_wo_chain:{ *:[i32] } 3872:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTB),
     /*  60103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60109 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60112 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60118 */     GIR_RootConstrainSelectedInstOperands,
     /*  60119 */     // GIR_Coverage, 2170,
     /*  60119 */     GIR_EraseRootFromParent_Done,
     /*  60120 */   // Label 1269: @60120
     /*  60120 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(60174), // Rule ID 2171 //
     /*  60125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smultt),
     /*  60133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60154 */     // (intrinsic_wo_chain:{ *:[i32] } 3873:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULTT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULTT),
     /*  60157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60163 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60166 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60172 */     GIR_RootConstrainSelectedInstOperands,
     /*  60173 */     // GIR_Coverage, 2171,
     /*  60173 */     GIR_EraseRootFromParent_Done,
     /*  60174 */   // Label 1270: @60174
     /*  60174 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(60228), // Rule ID 2172 //
     /*  60179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwb),
     /*  60187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60208 */     // (intrinsic_wo_chain:{ *:[i32] } 3874:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWB:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWB),
     /*  60211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60213 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60226 */     GIR_RootConstrainSelectedInstOperands,
     /*  60227 */     // GIR_Coverage, 2172,
     /*  60227 */     GIR_EraseRootFromParent_Done,
     /*  60228 */   // Label 1271: @60228
     /*  60228 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(60282), // Rule ID 2173 //
     /*  60233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  60236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smulwt),
     /*  60241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  60250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60262 */     // (intrinsic_wo_chain:{ *:[i32] } 3875:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMULWT:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  60262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMULWT),
     /*  60265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  60267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  60274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60280 */     GIR_RootConstrainSelectedInstOperands,
     /*  60281 */     // GIR_Coverage, 2173,
     /*  60281 */     GIR_EraseRootFromParent_Done,
     /*  60282 */   // Label 1272: @60282
     /*  60282 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(60330), // Rule ID 2510 //
     /*  60287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60312 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60316 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3722:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /*  60316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60328 */     GIR_RootConstrainSelectedInstOperands,
     /*  60329 */     // GIR_Coverage, 2510,
     /*  60329 */     GIR_EraseRootFromParent_Done,
     /*  60330 */   // Label 1273: @60330
     /*  60330 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(60378), // Rule ID 2511 //
     /*  60335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  60346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  60349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  60352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60364 */     // (intrinsic_wo_chain:{ *:[v4f16] } 3721:{ *:[iPTR] }, DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm)  =>  (VCADDv4f16:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Rn, DPR:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /*  60364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f16),
     /*  60367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60376 */     GIR_RootConstrainSelectedInstOperands,
     /*  60377 */     // GIR_Coverage, 2511,
     /*  60377 */     GIR_EraseRootFromParent_Done,
     /*  60378 */   // Label 1274: @60378
     /*  60378 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(60426), // Rule ID 2512 //
     /*  60383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60412 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3722:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /*  60412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60421 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60424 */     GIR_RootConstrainSelectedInstOperands,
     /*  60425 */     // GIR_Coverage, 2512,
     /*  60425 */     GIR_EraseRootFromParent_Done,
     /*  60426 */   // Label 1275: @60426
     /*  60426 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(60474), // Rule ID 2513 //
     /*  60431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_HasV8_3a),
     /*  60434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  60442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  60445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60456 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60460 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3721:{ *:[iPTR] }, QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm)  =>  (VCADDv8f16:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Rn, QPR:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /*  60460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv8f16),
     /*  60463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60469 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60472 */     GIR_RootConstrainSelectedInstOperands,
     /*  60473 */     // GIR_Coverage, 2513,
     /*  60473 */     GIR_EraseRootFromParent_Done,
     /*  60474 */   // Label 1276: @60474
     /*  60474 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(60522), // Rule ID 2514 //
     /*  60479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60504 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60508 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3722:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /*  60508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60520 */     GIR_RootConstrainSelectedInstOperands,
     /*  60521 */     // GIR_Coverage, 2514,
     /*  60521 */     GIR_EraseRootFromParent_Done,
     /*  60522 */   // Label 1277: @60522
     /*  60522 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(60570), // Rule ID 2515 //
     /*  60527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  60538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  60541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  60544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60552 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  60556 */     // (intrinsic_wo_chain:{ *:[v2f32] } 3721:{ *:[iPTR] }, DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm)  =>  (VCADDv2f32:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Rn, DPR:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /*  60556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv2f32),
     /*  60559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60568 */     GIR_RootConstrainSelectedInstOperands,
     /*  60569 */     // GIR_Coverage, 2515,
     /*  60569 */     GIR_EraseRootFromParent_Done,
     /*  60570 */   // Label 1278: @60570
     /*  60570 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(60618), // Rule ID 2516 //
     /*  60575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot90),
     /*  60583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60600 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60604 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3722:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /*  60604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  60616 */     GIR_RootConstrainSelectedInstOperands,
     /*  60617 */     // GIR_Coverage, 2516,
     /*  60617 */     GIR_EraseRootFromParent_Done,
     /*  60618 */   // Label 1279: @60618
     /*  60618 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(60666), // Rule ID 2517 //
     /*  60623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_3a),
     /*  60626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vcadd_rot270),
     /*  60631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  60634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  60637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  60652 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3721:{ *:[iPTR] }, QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm)  =>  (VCADDv4f32:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Rn, QPR:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /*  60652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCADDv4f32),
     /*  60655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  60657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  60659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  60661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  60664 */     GIR_RootConstrainSelectedInstOperands,
     /*  60665 */     // GIR_Coverage, 2517,
     /*  60665 */     GIR_EraseRootFromParent_Done,
     /*  60666 */   // Label 1280: @60666
     /*  60666 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(60771), // Rule ID 3102 //
     /*  60671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60700 */     // (intrinsic_wo_chain:{ *:[f32] } 3529:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60700 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60703 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60707 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60712 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60716 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf32),
     /*  60728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60733 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60736 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60740 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60743 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60749 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60770 */     // GIR_Coverage, 3102,
     /*  60770 */     GIR_EraseRootFromParent_Done,
     /*  60771 */   // Label 1281: @60771
     /*  60771 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(60876), // Rule ID 3104 //
     /*  60776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmv),
     /*  60784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  60790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  60793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60797 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  60801 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60805 */     // (intrinsic_wo_chain:{ *:[f16] } 3529:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  60805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60817 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60821 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMVf16),
     /*  60833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60838 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60841 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60848 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60854 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  60875 */     // GIR_Coverage, 3104,
     /*  60875 */     GIR_EraseRootFromParent_Done,
     /*  60876 */   // Label 1282: @60876
     /*  60876 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(60981), // Rule ID 3106 //
     /*  60881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  60892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  60895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  60898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  60906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  60910 */     // (intrinsic_wo_chain:{ *:[f32] } 3520:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  60910 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  60913 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60917 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60922 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  60926 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  60931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  60934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf32),
     /*  60938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60943 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  60946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  60950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  60953 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60959 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  60965 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  60970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  60972 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60975 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  60980 */     // GIR_Coverage, 3106,
     /*  60980 */     GIR_EraseRootFromParent_Done,
     /*  60981 */   // Label 1283: @60981
     /*  60981 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(61086), // Rule ID 3108 //
     /*  60986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  60989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmv),
     /*  60994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  60997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61015 */     // (intrinsic_wo_chain:{ *:[f16] } 3520:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61015 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61018 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61022 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61027 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61031 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMVf16),
     /*  61043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61048 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61051 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61055 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61058 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61085 */     // GIR_Coverage, 3108,
     /*  61085 */     GIR_EraseRootFromParent_Done,
     /*  61086 */   // Label 1284: @61086
     /*  61086 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(61191), // Rule ID 3110 //
     /*  61091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61120 */     // (intrinsic_wo_chain:{ *:[f32] } 3527:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMINNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61120 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61123 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61127 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61132 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61136 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf32),
     /*  61148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61153 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61160 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61163 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61169 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61175 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61190 */     // GIR_Coverage, 3110,
     /*  61190 */     GIR_EraseRootFromParent_Done,
     /*  61191 */   // Label 1285: @61191
     /*  61191 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(61296), // Rule ID 3112 //
     /*  61196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minnmav),
     /*  61204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61225 */     // (intrinsic_wo_chain:{ *:[f16] } 3527:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMINNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61225 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61228 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61232 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61237 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAVf16),
     /*  61253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61258 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61261 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61265 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61268 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61274 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61295 */     // GIR_Coverage, 3112,
     /*  61295 */     GIR_EraseRootFromParent_Done,
     /*  61296 */   // Label 1286: @61296
     /*  61296 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(61401), // Rule ID 3114 //
     /*  61301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61322 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  61326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61330 */     // (intrinsic_wo_chain:{ *:[f32] } 3518:{ *:[iPTR] }, SPR:{ *:[f32] }:$prev, MQPR:{ *:[v4f32] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f32] } (MVE_VMAXNMAVf32:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } SPR:{ *:[f32] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v4f32] }:$vec), SPR:{ *:[i32] })
     /*  61330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61342 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61346 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61351 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61354 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf32),
     /*  61358 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61363 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61370 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61373 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61379 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61385 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61392 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61395 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  61400 */     // GIR_Coverage, 3114,
     /*  61400 */     GIR_EraseRootFromParent_Done,
     /*  61401 */   // Label 1287: @61401
     /*  61401 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(61506), // Rule ID 3116 //
     /*  61406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  61409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxnmav),
     /*  61414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /*  61417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /*  61420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /*  61431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61435 */     // (intrinsic_wo_chain:{ *:[f16] } 3518:{ *:[iPTR] }, HPR:{ *:[f16] }:$prev, MQPR:{ *:[v8f16] }:$vec)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (MVE_VMAXNMAVf16:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } HPR:{ *:[f16] }:$prev, rGPR:{ *:[i32] }), MQPR:{ *:[v8f16] }:$vec), HPR:{ *:[i32] })
     /*  61435 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  61438 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61442 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61447 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // prev
     /*  61451 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  61459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAVf16),
     /*  61463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61468 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  61471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // vec
     /*  61475 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  61478 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61484 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61490 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  61495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  61497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /*  61505 */     // GIR_Coverage, 3116,
     /*  61505 */     GIR_EraseRootFromParent_Done,
     /*  61506 */   // Label 1288: @61506
     /*  61506 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(61566), // Rule ID 3166 //
     /*  61511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61540 */     // (intrinsic_wo_chain:{ *:[i32] } 3525:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMINAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs8),
     /*  61543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61545 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61547 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61552 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61558 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61564 */     GIR_RootConstrainSelectedInstOperands,
     /*  61565 */     // GIR_Coverage, 3166,
     /*  61565 */     GIR_EraseRootFromParent_Done,
     /*  61566 */   // Label 1289: @61566
     /*  61566 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(61626), // Rule ID 3168 //
     /*  61571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61596 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61600 */     // (intrinsic_wo_chain:{ *:[i32] } 3525:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMINAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs16),
     /*  61603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61605 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61607 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61624 */     GIR_RootConstrainSelectedInstOperands,
     /*  61625 */     // GIR_Coverage, 3168,
     /*  61625 */     GIR_EraseRootFromParent_Done,
     /*  61626 */   // Label 1290: @61626
     /*  61626 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(61686), // Rule ID 3170 //
     /*  61631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minav),
     /*  61639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61656 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61660 */     // (intrinsic_wo_chain:{ *:[i32] } 3525:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMINAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAVs32),
     /*  61663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61665 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61667 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61684 */     GIR_RootConstrainSelectedInstOperands,
     /*  61685 */     // GIR_Coverage, 3170,
     /*  61685 */     GIR_EraseRootFromParent_Done,
     /*  61686 */   // Label 1291: @61686
     /*  61686 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(61746), // Rule ID 3172 //
     /*  61691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61716 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61720 */     // (intrinsic_wo_chain:{ *:[i32] } 3516:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VMAXAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  61720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs8),
     /*  61723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61725 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61727 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61729 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61732 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61744 */     GIR_RootConstrainSelectedInstOperands,
     /*  61745 */     // GIR_Coverage, 3172,
     /*  61745 */     GIR_EraseRootFromParent_Done,
     /*  61746 */   // Label 1292: @61746
     /*  61746 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(61806), // Rule ID 3174 //
     /*  61751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61759 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61762 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61765 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61780 */     // (intrinsic_wo_chain:{ *:[i32] } 3516:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VMAXAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  61780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs16),
     /*  61783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61785 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61787 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61804 */     GIR_RootConstrainSelectedInstOperands,
     /*  61805 */     // GIR_Coverage, 3174,
     /*  61805 */     GIR_EraseRootFromParent_Done,
     /*  61806 */   // Label 1293: @61806
     /*  61806 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(61866), // Rule ID 3176 //
     /*  61811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxav),
     /*  61819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  61822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  61825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  61828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  61836 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61840 */     // (intrinsic_wo_chain:{ *:[i32] } 3516:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VMAXAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  61840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAVs32),
     /*  61843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  61845 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  61847 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  61849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61864 */     GIR_RootConstrainSelectedInstOperands,
     /*  61865 */     // GIR_Coverage, 3176,
     /*  61865 */     GIR_EraseRootFromParent_Done,
     /*  61866 */   // Label 1294: @61866
     /*  61866 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(61941), // Rule ID 3467 //
     /*  61871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  61882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  61885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  61888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61896 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61900 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3638:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  61900 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61903 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61907 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi8),
     /*  61915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61921 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61924 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  61936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61939 */     GIR_RootConstrainSelectedInstOperands,
     /*  61940 */     // GIR_Coverage, 3467,
     /*  61940 */     GIR_EraseRootFromParent_Done,
     /*  61941 */   // Label 1295: @61941
     /*  61941 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(62016), // Rule ID 3474 //
     /*  61946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  61949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  61954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  61957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  61960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  61963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  61975 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3638:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  61975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  61978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  61982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi16),
     /*  61990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  61992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  61994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  61996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  61999 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62011 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62014 */     GIR_RootConstrainSelectedInstOperands,
     /*  62015 */     // GIR_Coverage, 3474,
     /*  62015 */     GIR_EraseRootFromParent_Done,
     /*  62016 */   // Label 1296: @62016
     /*  62016 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(62091), // Rule ID 3478 //
     /*  62021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmulh),
     /*  62029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62050 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3638:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULHi32),
     /*  62065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62074 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62089 */     GIR_RootConstrainSelectedInstOperands,
     /*  62090 */     // GIR_Coverage, 3478,
     /*  62090 */     GIR_EraseRootFromParent_Done,
     /*  62091 */   // Label 1297: @62091
     /*  62091 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(62166), // Rule ID 3480 //
     /*  62096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  62113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62121 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62125 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3647:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQRDMULHi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  62125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi8),
     /*  62140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62164 */     GIR_RootConstrainSelectedInstOperands,
     /*  62165 */     // GIR_Coverage, 3480,
     /*  62165 */     GIR_EraseRootFromParent_Done,
     /*  62166 */   // Label 1298: @62166
     /*  62166 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(62241), // Rule ID 3482 //
     /*  62171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  62188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62196 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62200 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3647:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQRDMULHi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  62200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi16),
     /*  62215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62239 */     GIR_RootConstrainSelectedInstOperands,
     /*  62240 */     // GIR_Coverage, 3482,
     /*  62240 */     GIR_EraseRootFromParent_Done,
     /*  62241 */   // Label 1299: @62241
     /*  62241 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(62316), // Rule ID 3484 //
     /*  62246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmulh),
     /*  62254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  62263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62275 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3647:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQRDMULHi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  62275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMULHi32),
     /*  62290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  62294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  62296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62299 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62314 */     GIR_RootConstrainSelectedInstOperands,
     /*  62315 */     // GIR_Coverage, 3484,
     /*  62315 */     GIR_EraseRootFromParent_Done,
     /*  62316 */   // Label 1300: @62316
     /*  62316 */   GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(62391), // Rule ID 4752 //
     /*  62321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62342 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62346 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62350 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3571:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /*  62365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62374 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62389 */     GIR_RootConstrainSelectedInstOperands,
     /*  62390 */     // GIR_Coverage, 4752,
     /*  62390 */     GIR_EraseRootFromParent_Done,
     /*  62391 */   // Label 1301: @62391
     /*  62391 */   GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(62466), // Rule ID 4757 //
     /*  62396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62421 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62425 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3571:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62446 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62455 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62464 */     GIR_RootConstrainSelectedInstOperands,
     /*  62465 */     // GIR_Coverage, 4757,
     /*  62465 */     GIR_EraseRootFromParent_Done,
     /*  62466 */   // Label 1302: @62466
     /*  62466 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(62541), // Rule ID 4759 //
     /*  62471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  62474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62496 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62500 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3571:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62500 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62503 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62507 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62530 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62536 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62539 */     GIR_RootConstrainSelectedInstOperands,
     /*  62540 */     // GIR_Coverage, 4759,
     /*  62540 */     GIR_EraseRootFromParent_Done,
     /*  62541 */   // Label 1303: @62541
     /*  62541 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(62616), // Rule ID 4761 //
     /*  62546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62571 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62575 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3571:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62575 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62578 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62582 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /*  62590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62605 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62614 */     GIR_RootConstrainSelectedInstOperands,
     /*  62615 */     // GIR_Coverage, 4761,
     /*  62615 */     GIR_EraseRootFromParent_Done,
     /*  62616 */   // Label 1304: @62616
     /*  62616 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(62691), // Rule ID 4763 //
     /*  62621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  62624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vbrsr),
     /*  62629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  62632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  62635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62642 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  62650 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3571:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)  =>  (MVE_VBRSR32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, rGPR:{ *:[i32] }:$Rm)
     /*  62650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /*  62665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /*  62669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  62671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62686 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62689 */     GIR_RootConstrainSelectedInstOperands,
     /*  62690 */     // GIR_Coverage, 4763,
     /*  62690 */     GIR_EraseRootFromParent_Done,
     /*  62691 */   // Label 1305: @62691
     /*  62691 */   GIM_Reject,
     /*  62692 */ // Label 950: @62692
     /*  62692 */ GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(73615),
     /*  62697 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  62700 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(62790), // Rule ID 3913 //
     /*  62705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62722 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62738 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62742 */     // MIs[1] Operand 1
     /*  62742 */     // No operand predicates
     /*  62742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62748 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3648:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62748 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62751 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62755 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms8),
     /*  62763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62765 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62788 */     GIR_RootConstrainSelectedInstOperands,
     /*  62789 */     // GIR_Coverage, 3913,
     /*  62789 */     GIR_EraseRootFromParent_Done,
     /*  62790 */   // Label 1307: @62790
     /*  62790 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(62880), // Rule ID 3915 //
     /*  62795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  62803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  62806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62809 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62828 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  62832 */     // MIs[1] Operand 1
     /*  62832 */     // No operand predicates
     /*  62832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  62836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62838 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3648:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  62838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu8),
     /*  62853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62855 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62869 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62878 */     GIR_RootConstrainSelectedInstOperands,
     /*  62879 */     // GIR_Coverage, 3915,
     /*  62879 */     GIR_EraseRootFromParent_Done,
     /*  62880 */   // Label 1308: @62880
     /*  62880 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(62970), // Rule ID 3917 //
     /*  62885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62896 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62899 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  62914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62918 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  62922 */     // MIs[1] Operand 1
     /*  62922 */     // No operand predicates
     /*  62922 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  62926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62928 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3648:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  62928 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  62931 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  62935 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms16),
     /*  62943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  62945 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  62947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  62950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  62953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62959 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  62965 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62968 */     GIR_RootConstrainSelectedInstOperands,
     /*  62969 */     // GIR_Coverage, 3917,
     /*  62969 */     GIR_EraseRootFromParent_Done,
     /*  62970 */   // Label 1309: @62970
     /*  62970 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(63060), // Rule ID 3919 //
     /*  62975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  62980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  62983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  62986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  62989 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  62992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  62996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63008 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  63012 */     // MIs[1] Operand 1
     /*  63012 */     // No operand predicates
     /*  63012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63018 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3648:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  63018 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63021 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63025 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu16),
     /*  63033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63035 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63043 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63058 */     GIR_RootConstrainSelectedInstOperands,
     /*  63059 */     // GIR_Coverage, 3919,
     /*  63059 */     GIR_EraseRootFromParent_Done,
     /*  63060 */   // Label 1310: @63060
     /*  63060 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(63150), // Rule ID 3921 //
     /*  63065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63098 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63102 */     // MIs[1] Operand 1
     /*  63102 */     // No operand predicates
     /*  63102 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63106 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63108 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3648:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 0:{ *:[i32] })  =>  (MVE_VQSHLimms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimms32),
     /*  63123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63133 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63139 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63148 */     GIR_RootConstrainSelectedInstOperands,
     /*  63149 */     // GIR_Coverage, 3921,
     /*  63149 */     GIR_EraseRootFromParent_Done,
     /*  63150 */   // Label 1311: @63150
     /*  63150 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(63240), // Rule ID 3923 //
     /*  63155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqshl_imm),
     /*  63160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63188 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  63192 */     // MIs[1] Operand 1
     /*  63192 */     // No operand predicates
     /*  63192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63198 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3648:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm, 1:{ *:[i32] })  =>  (MVE_VQSHLimmu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  63198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHLimmu32),
     /*  63213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63215 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63217 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63223 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63229 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63238 */     GIR_RootConstrainSelectedInstOperands,
     /*  63239 */     // GIR_Coverage, 3923,
     /*  63239 */     GIR_EraseRootFromParent_Done,
     /*  63240 */   // Label 1312: @63240
     /*  63240 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(63330), // Rule ID 3931 //
     /*  63245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63259 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63278 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63282 */     // MIs[1] Operand 1
     /*  63282 */     // No operand predicates
     /*  63282 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63288 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms8),
     /*  63303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63305 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63307 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63328 */     GIR_RootConstrainSelectedInstOperands,
     /*  63329 */     // GIR_Coverage, 3931,
     /*  63329 */     GIR_EraseRootFromParent_Done,
     /*  63330 */   // Label 1313: @63330
     /*  63330 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(63420), // Rule ID 3933 //
     /*  63335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  63343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  63346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63349 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  63372 */     // MIs[1] Operand 1
     /*  63372 */     // No operand predicates
     /*  63372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63378 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3665:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  63378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu8),
     /*  63393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63395 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63418 */     GIR_RootConstrainSelectedInstOperands,
     /*  63419 */     // GIR_Coverage, 3933,
     /*  63419 */     GIR_EraseRootFromParent_Done,
     /*  63420 */   // Label 1314: @63420
     /*  63420 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(63510), // Rule ID 3935 //
     /*  63425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63458 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63462 */     // MIs[1] Operand 1
     /*  63462 */     // No operand predicates
     /*  63462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63468 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63468 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63471 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63475 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms16),
     /*  63483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63485 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63508 */     GIR_RootConstrainSelectedInstOperands,
     /*  63509 */     // GIR_Coverage, 3935,
     /*  63509 */     GIR_EraseRootFromParent_Done,
     /*  63510 */   // Label 1315: @63510
     /*  63510 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(63600), // Rule ID 3937 //
     /*  63515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  63526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63548 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  63552 */     // MIs[1] Operand 1
     /*  63552 */     // No operand predicates
     /*  63552 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63558 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3665:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  63558 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63561 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63565 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu16),
     /*  63573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63575 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63577 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63580 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63583 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63598 */     GIR_RootConstrainSelectedInstOperands,
     /*  63599 */     // GIR_Coverage, 3937,
     /*  63599 */     GIR_EraseRootFromParent_Done,
     /*  63600 */   // Label 1316: @63600
     /*  63600 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(63690), // Rule ID 3939 //
     /*  63605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63619 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63638 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63642 */     // MIs[1] Operand 1
     /*  63642 */     // No operand predicates
     /*  63642 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  63646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63648 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 0:{ *:[i32] })  =>  (MVE_VRSHR_imms32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_imms32),
     /*  63663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63665 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63688 */     GIR_RootConstrainSelectedInstOperands,
     /*  63689 */     // GIR_Coverage, 3939,
     /*  63689 */     GIR_EraseRootFromParent_Done,
     /*  63690 */   // Label 1317: @63690
     /*  63690 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(63780), // Rule ID 3941 //
     /*  63695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrshr_imm),
     /*  63700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  63703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  63706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  63709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  63724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63728 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  63732 */     // MIs[1] Operand 1
     /*  63732 */     // No operand predicates
     /*  63732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  63736 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63738 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3665:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm, 1:{ *:[i32] })  =>  (MVE_VRSHR_immu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  63738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHR_immu32),
     /*  63753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63755 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  63757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  63760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63778 */     GIR_RootConstrainSelectedInstOperands,
     /*  63779 */     // GIR_Coverage, 3941,
     /*  63779 */     GIR_EraseRootFromParent_Done,
     /*  63780 */   // Label 1318: @63780
     /*  63780 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(63869), // Rule ID 4039 //
     /*  63785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63825 */     // MIs[1] Operand 1
     /*  63825 */     // No operand predicates
     /*  63825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63827 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16s16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16_fix),
     /*  63842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63867 */     GIR_RootConstrainSelectedInstOperands,
     /*  63868 */     // GIR_Coverage, 4039,
     /*  63868 */     GIR_EraseRootFromParent_Done,
     /*  63869 */   // Label 1319: @63869
     /*  63869 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(63958), // Rule ID 4041 //
     /*  63874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63898 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  63902 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  63914 */     // MIs[1] Operand 1
     /*  63914 */     // No operand predicates
     /*  63914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63916 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  63916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  63919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  63923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  63928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16_fix),
     /*  63931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  63933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  63935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  63938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  63941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  63953 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  63956 */     GIR_RootConstrainSelectedInstOperands,
     /*  63957 */     // GIR_Coverage, 4041,
     /*  63957 */     GIR_EraseRootFromParent_Done,
     /*  63958 */   // Label 1320: @63958
     /*  63958 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(64047), // Rule ID 4043 //
     /*  63963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  63966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  63971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  63974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  63977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  63980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  63983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  63991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  63995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  63999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64003 */     // MIs[1] Operand 1
     /*  64003 */     // No operand predicates
     /*  64003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64005 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf16u16_fix:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16_fix),
     /*  64020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64024 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64030 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64045 */     GIR_RootConstrainSelectedInstOperands,
     /*  64046 */     // GIR_Coverage, 4043,
     /*  64046 */     GIR_EraseRootFromParent_Done,
     /*  64047 */   // Label 1321: @64047
     /*  64047 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(64136), // Rule ID 4045 //
     /*  64052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  64063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64069 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64080 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64092 */     // MIs[1] Operand 1
     /*  64092 */     // No operand predicates
     /*  64092 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64094 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu16f16_fix:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64094 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64097 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64101 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16_fix),
     /*  64109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64113 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64131 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64134 */     GIR_RootConstrainSelectedInstOperands,
     /*  64135 */     // GIR_Coverage, 4045,
     /*  64135 */     GIR_EraseRootFromParent_Done,
     /*  64136 */   // Label 1322: @64136
     /*  64136 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(64225), // Rule ID 4047 //
     /*  64141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64181 */     // MIs[1] Operand 1
     /*  64181 */     // No operand predicates
     /*  64181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64183 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32s32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64183 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64186 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64190 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32_fix),
     /*  64198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64202 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64214 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64223 */     GIR_RootConstrainSelectedInstOperands,
     /*  64224 */     // GIR_Coverage, 4047,
     /*  64224 */     GIR_EraseRootFromParent_Done,
     /*  64225 */   // Label 1323: @64225
     /*  64225 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(64314), // Rule ID 4049 //
     /*  64230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  64258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64270 */     // MIs[1] Operand 1
     /*  64270 */     // No operand predicates
     /*  64270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64272 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3584:{ *:[iPTR] }, 0:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTs32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32_fix),
     /*  64287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64291 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64294 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64297 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64309 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64312 */     GIR_RootConstrainSelectedInstOperands,
     /*  64313 */     // GIR_Coverage, 4049,
     /*  64313 */     GIR_EraseRootFromParent_Done,
     /*  64314 */   // Label 1324: @64314
     /*  64314 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(64403), // Rule ID 4051 //
     /*  64319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64359 */     // MIs[1] Operand 1
     /*  64359 */     // No operand predicates
     /*  64359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64361 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTf32u32_fix:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32_fix),
     /*  64376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64380 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64398 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64401 */     GIR_RootConstrainSelectedInstOperands,
     /*  64402 */     // GIR_Coverage, 4051,
     /*  64402 */     GIR_EraseRootFromParent_Done,
     /*  64403 */   // Label 1325: @64403
     /*  64403 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(64492), // Rule ID 4053 //
     /*  64408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  64411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_fix),
     /*  64416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  64419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  64436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  64444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64448 */     // MIs[1] Operand 1
     /*  64448 */     // No operand predicates
     /*  64448 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64450 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3584:{ *:[iPTR] }, 1:{ *:[i32] }, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)  =>  (MVE_VCVTu32f32_fix:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$scale)
     /*  64450 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  64453 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  64457 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  64462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32_fix),
     /*  64465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  64467 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  64469 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // scale
     /*  64472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  64490 */     GIR_RootConstrainSelectedInstOperands,
     /*  64491 */     // GIR_Coverage, 4053,
     /*  64491 */     GIR_EraseRootFromParent_Done,
     /*  64492 */   // Label 1326: @64492
     /*  64492 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(64559), // Rule ID 3118 //
     /*  64497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64533 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /*  64536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64538 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64540 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64557 */     GIR_RootConstrainSelectedInstOperands,
     /*  64558 */     // GIR_Coverage, 3118,
     /*  64558 */     GIR_EraseRootFromParent_Done,
     /*  64559 */   // Label 1327: @64559
     /*  64559 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(64626), // Rule ID 3120 //
     /*  64564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64592 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64596 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64600 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /*  64603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64605 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64607 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64612 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64624 */     GIR_RootConstrainSelectedInstOperands,
     /*  64625 */     // GIR_Coverage, 3120,
     /*  64625 */     GIR_EraseRootFromParent_Done,
     /*  64626 */   // Label 1328: @64626
     /*  64626 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(64693), // Rule ID 3122 //
     /*  64631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64667 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMINVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /*  64670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64672 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64674 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64685 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64691 */     GIR_RootConstrainSelectedInstOperands,
     /*  64692 */     // GIR_Coverage, 3122,
     /*  64692 */     GIR_EraseRootFromParent_Done,
     /*  64693 */   // Label 1329: @64693
     /*  64693 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(64760), // Rule ID 3124 //
     /*  64698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64715 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64734 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /*  64737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64739 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64741 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64743 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64746 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64752 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64758 */     GIR_RootConstrainSelectedInstOperands,
     /*  64759 */     // GIR_Coverage, 3124,
     /*  64759 */     GIR_EraseRootFromParent_Done,
     /*  64760 */   // Label 1330: @64760
     /*  64760 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(64827), // Rule ID 3126 //
     /*  64765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64801 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  64801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /*  64804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64806 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64808 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64825 */     GIR_RootConstrainSelectedInstOperands,
     /*  64826 */     // GIR_Coverage, 3126,
     /*  64826 */     GIR_EraseRootFromParent_Done,
     /*  64827 */   // Label 1331: @64827
     /*  64827 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(64894), // Rule ID 3128 //
     /*  64832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_minv),
     /*  64840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  64849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64864 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  64868 */     // (intrinsic_wo_chain:{ *:[i32] } 3531:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMINVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  64868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /*  64871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64873 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64875 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64877 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64886 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64892 */     GIR_RootConstrainSelectedInstOperands,
     /*  64893 */     // GIR_Coverage, 3128,
     /*  64893 */     GIR_EraseRootFromParent_Done,
     /*  64894 */   // Label 1332: @64894
     /*  64894 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(64961), // Rule ID 3130 //
     /*  64899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  64916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64931 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  64935 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  64935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /*  64938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  64940 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  64942 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  64944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  64947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  64959 */     GIR_RootConstrainSelectedInstOperands,
     /*  64960 */     // GIR_Coverage, 3130,
     /*  64960 */     GIR_EraseRootFromParent_Done,
     /*  64961 */   // Label 1333: @64961
     /*  64961 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(65028), // Rule ID 3132 //
     /*  64966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  64969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  64974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  64977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  64980 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  64983 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  64986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  64994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  64998 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65002 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /*  65005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65007 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65009 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65014 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65020 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65026 */     GIR_RootConstrainSelectedInstOperands,
     /*  65027 */     // GIR_Coverage, 3132,
     /*  65027 */     GIR_EraseRootFromParent_Done,
     /*  65028 */   // Label 1334: @65028
     /*  65028 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(65095), // Rule ID 3134 //
     /*  65033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65061 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65069 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 0:{ *:[i32] })  =>  (MVE_VMAXVs32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /*  65072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65074 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65076 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65081 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65087 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65093 */     GIR_RootConstrainSelectedInstOperands,
     /*  65094 */     // GIR_Coverage, 3134,
     /*  65094 */     GIR_EraseRootFromParent_Done,
     /*  65095 */   // Label 1335: @65095
     /*  65095 */   GIM_Try, /*On fail goto*//*Label 1336*/ GIMT_Encode4(65162), // Rule ID 3136 //
     /*  65100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65136 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu8:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v16i8] }:$vec)
     /*  65136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /*  65139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65141 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65143 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65145 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65148 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65154 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65160 */     GIR_RootConstrainSelectedInstOperands,
     /*  65161 */     // GIR_Coverage, 3136,
     /*  65161 */     GIR_EraseRootFromParent_Done,
     /*  65162 */   // Label 1336: @65162
     /*  65162 */   GIM_Try, /*On fail goto*//*Label 1337*/ GIMT_Encode4(65229), // Rule ID 3138 //
     /*  65167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65203 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu16:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v8i16] }:$vec)
     /*  65203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /*  65206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65208 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65210 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65221 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65227 */     GIR_RootConstrainSelectedInstOperands,
     /*  65228 */     // GIR_Coverage, 3138,
     /*  65228 */     GIR_EraseRootFromParent_Done,
     /*  65229 */   // Label 1337: @65229
     /*  65229 */   GIM_Try, /*On fail goto*//*Label 1338*/ GIMT_Encode4(65296), // Rule ID 3140 //
     /*  65234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_maxv),
     /*  65242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  65245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  65248 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65251 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  65262 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65270 */     // (intrinsic_wo_chain:{ *:[i32] } 3522:{ *:[iPTR] }, rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec, 1:{ *:[i32] })  =>  (MVE_VMAXVu32:{ *:[i32] } rGPR:{ *:[i32] }:$prev, MQPR:{ *:[v4i32] }:$vec)
     /*  65270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /*  65273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  65275 */     GIR_RootToRootCopy, /*OpIdx*/2, // prev
     /*  65277 */     GIR_RootToRootCopy, /*OpIdx*/3, // vec
     /*  65279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65294 */     GIR_RootConstrainSelectedInstOperands,
     /*  65295 */     // GIR_Coverage, 3140,
     /*  65295 */     GIR_EraseRootFromParent_Done,
     /*  65296 */   // Label 1338: @65296
     /*  65296 */   GIM_Try, /*On fail goto*//*Label 1339*/ GIMT_Encode4(65378), // Rule ID 3545 //
     /*  65301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65337 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3568:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65337 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65340 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65344 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs8),
     /*  65352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65373 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65376 */     GIR_RootConstrainSelectedInstOperands,
     /*  65377 */     // GIR_Coverage, 3545,
     /*  65377 */     GIR_EraseRootFromParent_Done,
     /*  65378 */   // Label 1339: @65378
     /*  65378 */   GIM_Try, /*On fail goto*//*Label 1340*/ GIMT_Encode4(65460), // Rule ID 3552 //
     /*  65383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65419 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs16),
     /*  65434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65440 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65449 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65458 */     GIR_RootConstrainSelectedInstOperands,
     /*  65459 */     // GIR_Coverage, 3552,
     /*  65459 */     GIR_EraseRootFromParent_Done,
     /*  65460 */   // Label 1340: @65460
     /*  65460 */   GIM_Try, /*On fail goto*//*Label 1341*/ GIMT_Encode4(65542), // Rule ID 3556 //
     /*  65465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65501 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65501 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65504 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65508 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDs32),
     /*  65516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65518 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65520 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65525 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65531 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65540 */     GIR_RootConstrainSelectedInstOperands,
     /*  65541 */     // GIR_Coverage, 3556,
     /*  65541 */     GIR_EraseRootFromParent_Done,
     /*  65542 */   // Label 1341: @65542
     /*  65542 */   GIM_Try, /*On fail goto*//*Label 1342*/ GIMT_Encode4(65624), // Rule ID 3560 //
     /*  65547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65583 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3568:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu8),
     /*  65598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65607 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65613 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65622 */     GIR_RootConstrainSelectedInstOperands,
     /*  65623 */     // GIR_Coverage, 3560,
     /*  65623 */     GIR_EraseRootFromParent_Done,
     /*  65624 */   // Label 1342: @65624
     /*  65624 */   GIM_Try, /*On fail goto*//*Label 1343*/ GIMT_Encode4(65706), // Rule ID 3564 //
     /*  65629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65665 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65665 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65668 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65672 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu16),
     /*  65680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65689 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65701 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65704 */     GIR_RootConstrainSelectedInstOperands,
     /*  65705 */     // GIR_Coverage, 3564,
     /*  65705 */     GIR_EraseRootFromParent_Done,
     /*  65706 */   // Label 1343: @65706
     /*  65706 */   GIM_Try, /*On fail goto*//*Label 1344*/ GIMT_Encode4(65788), // Rule ID 3568 //
     /*  65711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  65719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65743 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  65747 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VABDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDu32),
     /*  65762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65777 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65786 */     GIR_RootConstrainSelectedInstOperands,
     /*  65787 */     // GIR_Coverage, 3568,
     /*  65787 */     GIR_EraseRootFromParent_Done,
     /*  65788 */   // Label 1344: @65788
     /*  65788 */   GIM_Try, /*On fail goto*//*Label 1345*/ GIMT_Encode4(65870), // Rule ID 3569 //
     /*  65793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  65804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  65807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  65810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65825 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65829 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3654:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  65829 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65832 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65836 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs8),
     /*  65844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65859 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65868 */     GIR_RootConstrainSelectedInstOperands,
     /*  65869 */     // GIR_Coverage, 3569,
     /*  65869 */     GIR_EraseRootFromParent_Done,
     /*  65870 */   // Label 1345: @65870
     /*  65870 */   GIM_Try, /*On fail goto*//*Label 1346*/ GIMT_Encode4(65952), // Rule ID 3576 //
     /*  65875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  65886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  65889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  65892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65911 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3654:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  65911 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65914 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  65918 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  65923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs16),
     /*  65926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  65928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  65930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  65932 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  65935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  65947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  65950 */     GIR_RootConstrainSelectedInstOperands,
     /*  65951 */     // GIR_Coverage, 3576,
     /*  65951 */     GIR_EraseRootFromParent_Done,
     /*  65952 */   // Label 1346: @65952
     /*  65952 */   GIM_Try, /*On fail goto*//*Label 1347*/ GIMT_Encode4(66034), // Rule ID 3580 //
     /*  65957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  65960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  65965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  65968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  65971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  65974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  65977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65985 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  65989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  65993 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3654:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  65993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  65996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDs32),
     /*  66008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66014 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66023 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66029 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66032 */     GIR_RootConstrainSelectedInstOperands,
     /*  66033 */     // GIR_Coverage, 3580,
     /*  66033 */     GIR_EraseRootFromParent_Done,
     /*  66034 */   // Label 1347: @66034
     /*  66034 */   GIM_Try, /*On fail goto*//*Label 1348*/ GIMT_Encode4(66116), // Rule ID 3584 //
     /*  66039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66075 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3654:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu8),
     /*  66090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66111 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66114 */     GIR_RootConstrainSelectedInstOperands,
     /*  66115 */     // GIR_Coverage, 3584,
     /*  66115 */     GIR_EraseRootFromParent_Done,
     /*  66116 */   // Label 1348: @66116
     /*  66116 */   GIM_Try, /*On fail goto*//*Label 1349*/ GIMT_Encode4(66198), // Rule ID 3588 //
     /*  66121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66124 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66129 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66132 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66135 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66138 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66157 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3654:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66157 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66160 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66164 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu16),
     /*  66172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66193 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66196 */     GIR_RootConstrainSelectedInstOperands,
     /*  66197 */     // GIR_Coverage, 3588,
     /*  66197 */     GIR_EraseRootFromParent_Done,
     /*  66198 */   // Label 1349: @66198
     /*  66198 */   GIM_Try, /*On fail goto*//*Label 1350*/ GIMT_Encode4(66280), // Rule ID 3592 //
     /*  66203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrhadd),
     /*  66211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66239 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3654:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRHADDu32),
     /*  66254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66275 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66278 */     GIR_RootConstrainSelectedInstOperands,
     /*  66279 */     // GIR_Coverage, 3592,
     /*  66279 */     GIR_EraseRootFromParent_Done,
     /*  66280 */   // Label 1350: @66280
     /*  66280 */   GIM_Try, /*On fail goto*//*Label 1351*/ GIMT_Encode4(66362), // Rule ID 3593 //
     /*  66285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66321 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66321 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66324 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66328 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs8),
     /*  66336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66351 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66357 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66360 */     GIR_RootConstrainSelectedInstOperands,
     /*  66361 */     // GIR_Coverage, 3593,
     /*  66361 */     GIR_EraseRootFromParent_Done,
     /*  66362 */   // Label 1351: @66362
     /*  66362 */   GIM_Try, /*On fail goto*//*Label 1352*/ GIMT_Encode4(66444), // Rule ID 3600 //
     /*  66367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66399 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66403 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs16),
     /*  66418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66420 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66422 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66442 */     GIR_RootConstrainSelectedInstOperands,
     /*  66443 */     // GIR_Coverage, 3600,
     /*  66443 */     GIR_EraseRootFromParent_Done,
     /*  66444 */   // Label 1352: @66444
     /*  66444 */   GIM_Try, /*On fail goto*//*Label 1353*/ GIMT_Encode4(66526), // Rule ID 3604 //
     /*  66449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66481 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66485 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDs32),
     /*  66500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66506 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66509 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66515 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66524 */     GIR_RootConstrainSelectedInstOperands,
     /*  66525 */     // GIR_Coverage, 3604,
     /*  66525 */     GIR_EraseRootFromParent_Done,
     /*  66526 */   // Label 1353: @66526
     /*  66526 */   GIM_Try, /*On fail goto*//*Label 1354*/ GIMT_Encode4(66608), // Rule ID 3608 //
     /*  66531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66559 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66563 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66567 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3603:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66567 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66570 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66574 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu8),
     /*  66582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66591 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66597 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66606 */     GIR_RootConstrainSelectedInstOperands,
     /*  66607 */     // GIR_Coverage, 3608,
     /*  66607 */     GIR_EraseRootFromParent_Done,
     /*  66608 */   // Label 1354: @66608
     /*  66608 */   GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(66690), // Rule ID 3612 //
     /*  66613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66649 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3603:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66649 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66652 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66656 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu16),
     /*  66664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66670 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66685 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66688 */     GIR_RootConstrainSelectedInstOperands,
     /*  66689 */     // GIR_Coverage, 3612,
     /*  66689 */     GIR_EraseRootFromParent_Done,
     /*  66690 */   // Label 1355: @66690
     /*  66690 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(66772), // Rule ID 3616 //
     /*  66695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhadd),
     /*  66703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  66731 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3603:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66731 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66734 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66738 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHADDu32),
     /*  66746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66752 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66755 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66767 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66770 */     GIR_RootConstrainSelectedInstOperands,
     /*  66771 */     // GIR_Coverage, 3616,
     /*  66771 */     GIR_EraseRootFromParent_Done,
     /*  66772 */   // Label 1356: @66772
     /*  66772 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(66854), // Rule ID 3617 //
     /*  66777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  66788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  66791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  66794 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66813 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3604:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  66813 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66816 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66820 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs8),
     /*  66828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66852 */     GIR_RootConstrainSelectedInstOperands,
     /*  66853 */     // GIR_Coverage, 3617,
     /*  66853 */     GIR_EraseRootFromParent_Done,
     /*  66854 */   // Label 1357: @66854
     /*  66854 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(66936), // Rule ID 3620 //
     /*  66859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66867 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  66870 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  66873 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  66876 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66887 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66895 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  66895 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66898 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66902 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs16),
     /*  66910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  66919 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  66931 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  66934 */     GIR_RootConstrainSelectedInstOperands,
     /*  66935 */     // GIR_Coverage, 3620,
     /*  66935 */     GIR_EraseRootFromParent_Done,
     /*  66936 */   // Label 1358: @66936
     /*  66936 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(67018), // Rule ID 3623 //
     /*  66941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  66944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  66949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  66952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  66955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  66958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  66961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  66973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  66977 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VHSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  66977 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  66980 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  66984 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  66989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBs32),
     /*  66992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  66994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  66996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  66998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67016 */     GIR_RootConstrainSelectedInstOperands,
     /*  67017 */     // GIR_Coverage, 3623,
     /*  67017 */     GIR_EraseRootFromParent_Done,
     /*  67018 */   // Label 1359: @67018
     /*  67018 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(67100), // Rule ID 3626 //
     /*  67023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67047 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67051 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67059 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3604:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu8),
     /*  67074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67089 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67098 */     GIR_RootConstrainSelectedInstOperands,
     /*  67099 */     // GIR_Coverage, 3626,
     /*  67099 */     GIR_EraseRootFromParent_Done,
     /*  67100 */   // Label 1360: @67100
     /*  67100 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(67182), // Rule ID 3629 //
     /*  67105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67108 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67113 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67122 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67141 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3604:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu16),
     /*  67156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67162 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67165 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67171 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67180 */     GIR_RootConstrainSelectedInstOperands,
     /*  67181 */     // GIR_Coverage, 3629,
     /*  67181 */     GIR_EraseRootFromParent_Done,
     /*  67182 */   // Label 1361: @67182
     /*  67182 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(67264), // Rule ID 3632 //
     /*  67187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vhsub),
     /*  67195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67219 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67223 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3604:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VHSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHSUBu32),
     /*  67238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67244 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67253 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67259 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67262 */     GIR_RootConstrainSelectedInstOperands,
     /*  67263 */     // GIR_Coverage, 3632,
     /*  67263 */     GIR_EraseRootFromParent_Done,
     /*  67264 */   // Label 1362: @67264
     /*  67264 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(67346), // Rule ID 4033 //
     /*  67269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67305 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3568:{ *:[iPTR] }, MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /*  67305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /*  67320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67344 */     GIR_RootConstrainSelectedInstOperands,
     /*  67345 */     // GIR_Coverage, 4033,
     /*  67345 */     GIR_EraseRootFromParent_Done,
     /*  67346 */   // Label 1363: @67346
     /*  67346 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(67428), // Rule ID 4035 //
     /*  67351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  67354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabd),
     /*  67359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67387 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3568:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /*  67387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /*  67402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67423 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67426 */     GIR_RootConstrainSelectedInstOperands,
     /*  67427 */     // GIR_Coverage, 4035,
     /*  67427 */     GIR_EraseRootFromParent_Done,
     /*  67428 */   // Label 1364: @67428
     /*  67428 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(67510), // Rule ID 4408 //
     /*  67433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67469 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp8),
     /*  67484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67505 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67508 */     GIR_RootConstrainSelectedInstOperands,
     /*  67509 */     // GIR_Coverage, 4408,
     /*  67509 */     GIR_EraseRootFromParent_Done,
     /*  67510 */   // Label 1365: @67510
     /*  67510 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(67592), // Rule ID 4410 //
     /*  67515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67551 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3631:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp8),
     /*  67566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67572 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67575 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67581 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67590 */     GIR_RootConstrainSelectedInstOperands,
     /*  67591 */     // GIR_Coverage, 4410,
     /*  67591 */     GIR_EraseRootFromParent_Done,
     /*  67592 */   // Label 1366: @67592
     /*  67592 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(67674), // Rule ID 4412 //
     /*  67597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67633 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULLBp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBp16),
     /*  67648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67669 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67672 */     GIR_RootConstrainSelectedInstOperands,
     /*  67673 */     // GIR_Coverage, 4412,
     /*  67673 */     GIR_EraseRootFromParent_Done,
     /*  67674 */   // Label 1367: @67674
     /*  67674 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(67756), // Rule ID 4414 //
     /*  67679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull_poly),
     /*  67687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67703 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67707 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67711 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  67715 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3631:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULLTp16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67715 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67718 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67722 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTp16),
     /*  67730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67739 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67754 */     GIR_RootConstrainSelectedInstOperands,
     /*  67755 */     // GIR_Coverage, 4414,
     /*  67755 */     GIR_EraseRootFromParent_Done,
     /*  67756 */   // Label 1368: @67756
     /*  67756 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(67838), // Rule ID 4441 //
     /*  67761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  67772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  67775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  67778 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67797 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3629:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  67797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /*  67812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67821 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67827 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67833 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67836 */     GIR_RootConstrainSelectedInstOperands,
     /*  67837 */     // GIR_Coverage, 4441,
     /*  67837 */     GIR_EraseRootFromParent_Done,
     /*  67838 */   // Label 1369: @67838
     /*  67838 */   GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(67920), // Rule ID 4448 //
     /*  67843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  67854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  67857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  67860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67871 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67875 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67879 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  67879 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67882 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67886 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /*  67894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67900 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67903 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67909 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67915 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  67918 */     GIR_RootConstrainSelectedInstOperands,
     /*  67919 */     // GIR_Coverage, 4448,
     /*  67919 */     GIR_EraseRootFromParent_Done,
     /*  67920 */   // Label 1370: @67920
     /*  67920 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(68002), // Rule ID 4452 //
     /*  67925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  67928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  67933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  67936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  67939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  67942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  67945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  67957 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  67961 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  67961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  67964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  67968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  67973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /*  67976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  67978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  67980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  67982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  67985 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67991 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  67997 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68000 */     GIR_RootConstrainSelectedInstOperands,
     /*  68001 */     // GIR_Coverage, 4452,
     /*  68001 */     GIR_EraseRootFromParent_Done,
     /*  68002 */   // Label 1371: @68002
     /*  68002 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(68084), // Rule ID 4456 //
     /*  68007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68039 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68043 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3629:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68073 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68082 */     GIR_RootConstrainSelectedInstOperands,
     /*  68083 */     // GIR_Coverage, 4456,
     /*  68083 */     GIR_EraseRootFromParent_Done,
     /*  68084 */   // Label 1372: @68084
     /*  68084 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(68166), // Rule ID 4460 //
     /*  68089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68125 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3629:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68125 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68128 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68132 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /*  68140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68146 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68155 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68161 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68164 */     GIR_RootConstrainSelectedInstOperands,
     /*  68165 */     // GIR_Coverage, 4460,
     /*  68165 */     GIR_EraseRootFromParent_Done,
     /*  68166 */   // Label 1373: @68166
     /*  68166 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(68248), // Rule ID 4464 //
     /*  68171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmulh),
     /*  68179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68207 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3629:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /*  68222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68228 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68246 */     GIR_RootConstrainSelectedInstOperands,
     /*  68247 */     // GIR_Coverage, 4464,
     /*  68247 */     GIR_EraseRootFromParent_Done,
     /*  68248 */   // Label 1374: @68248
     /*  68248 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(68330), // Rule ID 4465 //
     /*  68253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68289 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs8),
     /*  68304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68328 */     GIR_RootConstrainSelectedInstOperands,
     /*  68329 */     // GIR_Coverage, 4465,
     /*  68329 */     GIR_EraseRootFromParent_Done,
     /*  68330 */   // Label 1375: @68330
     /*  68330 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(68412), // Rule ID 4467 //
     /*  68335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68371 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68371 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68374 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68378 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs16),
     /*  68386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68392 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68401 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68407 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68410 */     GIR_RootConstrainSelectedInstOperands,
     /*  68411 */     // GIR_Coverage, 4467,
     /*  68411 */     GIR_EraseRootFromParent_Done,
     /*  68412 */   // Label 1376: @68412
     /*  68412 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(68494), // Rule ID 4469 //
     /*  68417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68453 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VRMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68453 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68456 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68460 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHs32),
     /*  68468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68492 */     GIR_RootConstrainSelectedInstOperands,
     /*  68493 */     // GIR_Coverage, 4469,
     /*  68493 */     GIR_EraseRootFromParent_Done,
     /*  68494 */   // Label 1377: @68494
     /*  68494 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(68576), // Rule ID 4471 //
     /*  68499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  68510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  68513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  68516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68531 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68535 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3664:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  68535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu8),
     /*  68550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68556 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68571 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68574 */     GIR_RootConstrainSelectedInstOperands,
     /*  68575 */     // GIR_Coverage, 4471,
     /*  68575 */     GIR_EraseRootFromParent_Done,
     /*  68576 */   // Label 1378: @68576
     /*  68576 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(68658), // Rule ID 4473 //
     /*  68581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68609 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68617 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3664:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu16),
     /*  68632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68641 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68647 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68656 */     GIR_RootConstrainSelectedInstOperands,
     /*  68657 */     // GIR_Coverage, 4473,
     /*  68657 */     GIR_EraseRootFromParent_Done,
     /*  68658 */   // Label 1379: @68658
     /*  68658 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(68740), // Rule ID 4475 //
     /*  68663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vrmulh),
     /*  68671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68687 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68699 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3664:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VRMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  68699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRMULHu32),
     /*  68714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68738 */     GIR_RootConstrainSelectedInstOperands,
     /*  68739 */     // GIR_Coverage, 4475,
     /*  68739 */     GIR_EraseRootFromParent_Done,
     /*  68740 */   // Label 1380: @68740
     /*  68740 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(68807), // Rule ID 4526 //
     /*  68745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68781 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3587:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 0:{ *:[i32] })  =>  (MVE_VCVTf16f32bh:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32bh),
     /*  68784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68805 */     GIR_RootConstrainSelectedInstOperands,
     /*  68806 */     // GIR_Coverage, 4526,
     /*  68806 */     GIR_EraseRootFromParent_Done,
     /*  68807 */   // Label 1381: @68807
     /*  68807 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(68874), // Rule ID 4532 //
     /*  68812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  68815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcvt_narrow),
     /*  68820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  68823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  68829 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68840 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68848 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3587:{ *:[iPTR] }, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm, 1:{ *:[i32] })  =>  (MVE_VCVTf16f32th:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qm)
     /*  68848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16f32th),
     /*  68851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  68855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  68857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68860 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68866 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68872 */     GIR_RootConstrainSelectedInstOperands,
     /*  68873 */     // GIR_Coverage, 4532,
     /*  68873 */     GIR_EraseRootFromParent_Done,
     /*  68874 */   // Label 1382: @68874
     /*  68874 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(68956), // Rule ID 4550 //
     /*  68879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  68915 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  68918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  68922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  68927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16bh),
     /*  68930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  68932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  68934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  68936 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  68939 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  68951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  68954 */     GIR_RootConstrainSelectedInstOperands,
     /*  68955 */     // GIR_Coverage, 4550,
     /*  68955 */     GIR_EraseRootFromParent_Done,
     /*  68956 */   // Label 1383: @68956
     /*  68956 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(69038), // Rule ID 4552 //
     /*  68961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  68964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  68969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  68972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  68975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  68978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  68981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  68993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  68997 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3639:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  68997 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69000 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69004 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs16th),
     /*  69012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69036 */     GIR_RootConstrainSelectedInstOperands,
     /*  69037 */     // GIR_Coverage, 4552,
     /*  69037 */     GIR_EraseRootFromParent_Done,
     /*  69038 */   // Label 1384: @69038
     /*  69038 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(69120), // Rule ID 4554 //
     /*  69043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  69079 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3639:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] })  =>  (MVE_VQDMULLs32bh:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69079 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69082 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69086 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32bh),
     /*  69094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69100 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69103 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69109 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69115 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69118 */     GIR_RootConstrainSelectedInstOperands,
     /*  69119 */     // GIR_Coverage, 4554,
     /*  69119 */     GIR_EraseRootFromParent_Done,
     /*  69120 */   // Label 1385: @69120
     /*  69120 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(69202), // Rule ID 4556 //
     /*  69125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  69128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmull),
     /*  69133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  69136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  69161 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3639:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] })  =>  (MVE_VQDMULLs32th:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  69161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMULLs32th),
     /*  69176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  69180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69200 */     GIR_RootConstrainSelectedInstOperands,
     /*  69201 */     // GIR_Coverage, 4556,
     /*  69201 */     GIR_EraseRootFromParent_Done,
     /*  69202 */   // Label 1386: @69202
     /*  69202 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(69279), // Rule ID 3901 //
     /*  69207 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69212 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69215 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69218 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69221 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69244 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /*  69248 */     // MIs[1] Operand 1
     /*  69248 */     // No operand predicates
     /*  69248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69250 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3679:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)  =>  (MVE_VSLIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_7>>:$imm)
     /*  69250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm8),
     /*  69253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69255 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69277 */     GIR_RootConstrainSelectedInstOperands,
     /*  69278 */     // GIR_Coverage, 3901,
     /*  69278 */     GIR_EraseRootFromParent_Done,
     /*  69279 */   // Label 1387: @69279
     /*  69279 */   GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(69356), // Rule ID 3903 //
     /*  69284 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69289 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69292 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69295 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69298 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69301 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69321 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  69325 */     // MIs[1] Operand 1
     /*  69325 */     // No operand predicates
     /*  69325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69327 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3679:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (MVE_VSLIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)
     /*  69327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm16),
     /*  69330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69332 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69336 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69348 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69354 */     GIR_RootConstrainSelectedInstOperands,
     /*  69355 */     // GIR_Coverage, 3903,
     /*  69355 */     GIR_EraseRootFromParent_Done,
     /*  69356 */   // Label 1388: @69356
     /*  69356 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(69433), // Rule ID 3905 //
     /*  69361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsli),
     /*  69366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69375 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69386 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69398 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /*  69402 */     // MIs[1] Operand 1
     /*  69402 */     // No operand predicates
     /*  69402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69404 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3679:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)  =>  (MVE_VSLIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_imm0_31>>:$imm)
     /*  69404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSLIimm32),
     /*  69407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69409 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69425 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69431 */     GIR_RootConstrainSelectedInstOperands,
     /*  69432 */     // GIR_Coverage, 3905,
     /*  69432 */     GIR_EraseRootFromParent_Done,
     /*  69433 */   // Label 1389: @69433
     /*  69433 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(69510), // Rule ID 3907 //
     /*  69438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  69446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  69449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  69452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  69479 */     // MIs[1] Operand 1
     /*  69479 */     // No operand predicates
     /*  69479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69481 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3681:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)  =>  (MVE_VSRIimm8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm)
     /*  69481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm8),
     /*  69484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69486 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69493 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69502 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69508 */     GIR_RootConstrainSelectedInstOperands,
     /*  69509 */     // GIR_Coverage, 3907,
     /*  69509 */     GIR_EraseRootFromParent_Done,
     /*  69510 */   // Label 1390: @69510
     /*  69510 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(69587), // Rule ID 3909 //
     /*  69515 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69520 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69523 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  69526 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69529 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69540 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69552 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  69556 */     // MIs[1] Operand 1
     /*  69556 */     // No operand predicates
     /*  69556 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69558 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3681:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)  =>  (MVE_VSRIimm16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm)
     /*  69558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm16),
     /*  69561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69563 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69585 */     GIR_RootConstrainSelectedInstOperands,
     /*  69586 */     // GIR_Coverage, 3909,
     /*  69586 */     GIR_EraseRootFromParent_Done,
     /*  69587 */   // Label 1391: @69587
     /*  69587 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(69664), // Rule ID 3911 //
     /*  69592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vsri),
     /*  69597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  69625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69629 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm32),
     /*  69633 */     // MIs[1] Operand 1
     /*  69633 */     // No operand predicates
     /*  69633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69635 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3681:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)  =>  (MVE_VSRIimm32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm32>>:$imm)
     /*  69635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSRIimm32),
     /*  69638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69640 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  69642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  69644 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  69647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69650 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69656 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69662 */     GIR_RootConstrainSelectedInstOperands,
     /*  69663 */     // GIR_Coverage, 3911,
     /*  69663 */     GIR_EraseRootFromParent_Done,
     /*  69664 */   // Label 1392: @69664
     /*  69664 */   GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(69755), // Rule ID 4380 //
     /*  69669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  69680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  69686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  69689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69701 */     // MIs[1] Operand 1
     /*  69701 */     // No operand predicates
     /*  69701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69711 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3578:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf16),
     /*  69726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69753 */     GIR_RootConstrainSelectedInstOperands,
     /*  69754 */     // GIR_Coverage, 4380,
     /*  69754 */     GIR_EraseRootFromParent_Done,
     /*  69755 */   // Label 1393: @69755
     /*  69755 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(69846), // Rule ID 4382 //
     /*  69760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  69763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmulq),
     /*  69768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  69771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  69777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  69780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69792 */     // MIs[1] Operand 1
     /*  69792 */     // No operand predicates
     /*  69792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69796 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  69800 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  69802 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3578:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  69802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  69805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  69809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  69814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMULf32),
     /*  69817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  69819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  69821 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qm
     /*  69823 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  69826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  69829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  69844 */     GIR_RootConstrainSelectedInstOperands,
     /*  69845 */     // GIR_Coverage, 4382,
     /*  69845 */     GIR_EraseRootFromParent_Done,
     /*  69846 */   // Label 1394: @69846
     /*  69846 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(69909), // Rule ID 146 //
     /*  69851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  69854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  69887 */     // (intrinsic_wo_chain:{ *:[i32] } 3911:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (USADA8:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)
     /*  69887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USADA8),
     /*  69890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69907 */     GIR_RootConstrainSelectedInstOperands,
     /*  69908 */     // GIR_Coverage, 146,
     /*  69908 */     GIR_EraseRootFromParent_Done,
     /*  69909 */   // Label 1395: @69909
     /*  69909 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(69972), // Rule ID 469 //
     /*  69914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usada8),
     /*  69922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69928 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69931 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69946 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  69950 */     // (intrinsic_wo_chain:{ *:[i32] } 3911:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2USADA8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  69950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USADA8),
     /*  69953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  69955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  69957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  69959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  69961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  69964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  69970 */     GIR_RootConstrainSelectedInstOperands,
     /*  69971 */     // GIR_Coverage, 469,
     /*  69971 */     GIR_EraseRootFromParent_Done,
     /*  69972 */   // Label 1396: @69972
     /*  69972 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(70035), // Rule ID 528 //
     /*  69977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  69980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  69985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  69988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  69991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  69994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  69997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70009 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70013 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLAD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAD),
     /*  70016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70033 */     GIR_RootConstrainSelectedInstOperands,
     /*  70034 */     // GIR_Coverage, 528,
     /*  70034 */     GIR_EraseRootFromParent_Done,
     /*  70035 */   // Label 1397: @70035
     /*  70035 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(70098), // Rule ID 529 //
     /*  70040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  70048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70076 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLADX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLADX),
     /*  70079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70087 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70090 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70096 */     GIR_RootConstrainSelectedInstOperands,
     /*  70097 */     // GIR_Coverage, 529,
     /*  70097 */     GIR_EraseRootFromParent_Done,
     /*  70098 */   // Label 1398: @70098
     /*  70098 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(70161), // Rule ID 530 //
     /*  70103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  70111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70135 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70139 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSD:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSD),
     /*  70142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70159 */     GIR_RootConstrainSelectedInstOperands,
     /*  70160 */     // GIR_Coverage, 530,
     /*  70160 */     GIR_EraseRootFromParent_Done,
     /*  70161 */   // Label 1399: @70161
     /*  70161 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(70224), // Rule ID 531 //
     /*  70166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  70169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  70174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  70177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  70180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  70183 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  70186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70198 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  70202 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)  =>  (t2SMLSDX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Ra)
     /*  70202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLSDX),
     /*  70205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  70209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  70211 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  70213 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70216 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70222 */     GIR_RootConstrainSelectedInstOperands,
     /*  70223 */     // GIR_Coverage, 531,
     /*  70223 */     GIR_EraseRootFromParent_Done,
     /*  70224 */   // Label 1400: @70224
     /*  70224 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(70278), // Rule ID 948 //
     /*  70229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70261 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70265 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3711:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTD),
     /*  70268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70276 */     GIR_RootConstrainSelectedInstOperands,
     /*  70277 */     // GIR_Coverage, 948,
     /*  70277 */     GIR_EraseRootFromParent_Done,
     /*  70278 */   // Label 1401: @70278
     /*  70278 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(70332), // Rule ID 949 //
     /*  70283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70319 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3699:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTD),
     /*  70322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70330 */     GIR_RootConstrainSelectedInstOperands,
     /*  70331 */     // GIR_Coverage, 949,
     /*  70331 */     GIR_EraseRootFromParent_Done,
     /*  70332 */   // Label 1402: @70332
     /*  70332 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(70386), // Rule ID 950 //
     /*  70337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_udot),
     /*  70345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70369 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70373 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3711:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUDOTQ),
     /*  70376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70384 */     GIR_RootConstrainSelectedInstOperands,
     /*  70385 */     // GIR_Coverage, 950,
     /*  70385 */     GIR_EraseRootFromParent_Done,
     /*  70386 */   // Label 1403: @70386
     /*  70386 */   GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(70440), // Rule ID 951 //
     /*  70391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /*  70394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sdot),
     /*  70399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70419 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70423 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70427 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3699:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSDOTQ),
     /*  70430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70438 */     GIR_RootConstrainSelectedInstOperands,
     /*  70439 */     // GIR_Coverage, 951,
     /*  70439 */     GIR_EraseRootFromParent_Done,
     /*  70440 */   // Label 1404: @70440
     /*  70440 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(70494), // Rule ID 952 //
     /*  70445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_smmla),
     /*  70453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70477 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70481 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3710:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSMMLA),
     /*  70484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70490 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70492 */     GIR_RootConstrainSelectedInstOperands,
     /*  70493 */     // GIR_Coverage, 952,
     /*  70493 */     GIR_EraseRootFromParent_Done,
     /*  70494 */   // Label 1405: @70494
     /*  70494 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(70548), // Rule ID 953 //
     /*  70499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_ummla),
     /*  70507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70531 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70535 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3712:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUMMLA),
     /*  70538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70546 */     GIR_RootConstrainSelectedInstOperands,
     /*  70547 */     // GIR_Coverage, 953,
     /*  70547 */     GIR_EraseRootFromParent_Done,
     /*  70548 */   // Label 1406: @70548
     /*  70548 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(70602), // Rule ID 954 //
     /*  70553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usmmla),
     /*  70561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70585 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70589 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3714:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSMMLA:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSMMLA),
     /*  70592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70598 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70600 */     GIR_RootConstrainSelectedInstOperands,
     /*  70601 */     // GIR_Coverage, 954,
     /*  70601 */     GIR_EraseRootFromParent_Done,
     /*  70602 */   // Label 1407: @70602
     /*  70602 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(70656), // Rule ID 955 //
     /*  70607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  70618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  70621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70624 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70639 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70643 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3713:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VUSDOTD:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vd, DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTD),
     /*  70646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70654 */     GIR_RootConstrainSelectedInstOperands,
     /*  70655 */     // GIR_Coverage, 955,
     /*  70655 */     GIR_EraseRootFromParent_Done,
     /*  70656 */   // Label 1408: @70656
     /*  70656 */   GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(70710), // Rule ID 956 //
     /*  70661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /*  70664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_usdot),
     /*  70669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  70678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  70681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70689 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70693 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70697 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3713:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VUSDOTQ:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vd, QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /*  70697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUSDOTQ),
     /*  70700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /*  70704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70708 */     GIR_RootConstrainSelectedInstOperands,
     /*  70709 */     // GIR_Coverage, 956,
     /*  70709 */     GIR_EraseRootFromParent_Done,
     /*  70710 */   // Label 1409: @70710
     /*  70710 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(70773), // Rule ID 1687 //
     /*  70715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx1),
     /*  70723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  70726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  70732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  70735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70747 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  70751 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3831:{ *:[iPTR] }, DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VTBX1:{ *:[v8i8] } DPR:{ *:[v8i8] }:$orig, VecListOneD:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /*  70751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX1),
     /*  70754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70756 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  70758 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70760 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  70765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  70771 */     GIR_RootConstrainSelectedInstOperands,
     /*  70772 */     // GIR_Coverage, 1687,
     /*  70772 */     GIR_EraseRootFromParent_Done,
     /*  70773 */   // Label 1410: @70773
     /*  70773 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(70827), // Rule ID 1718 //
     /*  70778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1su0),
     /*  70786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70802 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70806 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70810 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3704:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA1SU0:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1SU0),
     /*  70817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70819 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70823 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70825 */     GIR_RootConstrainSelectedInstOperands,
     /*  70826 */     // GIR_Coverage, 1718,
     /*  70826 */     GIR_EraseRootFromParent_Done,
     /*  70827 */   // Label 1411: @70827
     /*  70827 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(70881), // Rule ID 1719 //
     /*  70832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70835 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h),
     /*  70840 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70849 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70860 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70864 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70868 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3706:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H),
     /*  70871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70873 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70879 */     GIR_RootConstrainSelectedInstOperands,
     /*  70880 */     // GIR_Coverage, 1719,
     /*  70880 */     GIR_EraseRootFromParent_Done,
     /*  70881 */   // Label 1412: @70881
     /*  70881 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(70935), // Rule ID 1720 //
     /*  70886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256h2),
     /*  70894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70903 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70918 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70922 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3707:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256H2:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256H2),
     /*  70925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70927 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70931 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70933 */     GIR_RootConstrainSelectedInstOperands,
     /*  70934 */     // GIR_Coverage, 1720,
     /*  70934 */     GIR_EraseRootFromParent_Done,
     /*  70935 */   // Label 1413: @70935
     /*  70935 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(70989), // Rule ID 1721 //
     /*  70940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2_HasV8),
     /*  70943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha256su1),
     /*  70948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  70951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  70957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  70960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70972 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  70976 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3709:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (SHA256SU1:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  70976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA256SU1),
     /*  70979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  70981 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  70983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  70985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  70987 */     GIR_RootConstrainSelectedInstOperands,
     /*  70988 */     // GIR_Coverage, 1721,
     /*  70988 */     GIR_EraseRootFromParent_Done,
     /*  70989 */   // Label 1414: @70989
     /*  70989 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(71052), // Rule ID 1896 //
     /*  70994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  70997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlad),
     /*  71002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71022 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71026 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71030 */     // (intrinsic_wo_chain:{ *:[i32] } 3856:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLAD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAD),
     /*  71033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71039 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71041 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71050 */     GIR_RootConstrainSelectedInstOperands,
     /*  71051 */     // GIR_Coverage, 1896,
     /*  71051 */     GIR_EraseRootFromParent_Done,
     /*  71052 */   // Label 1415: @71052
     /*  71052 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(71115), // Rule ID 1897 //
     /*  71057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smladx),
     /*  71065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71089 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71093 */     // (intrinsic_wo_chain:{ *:[i32] } 3857:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLADX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLADX),
     /*  71096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71102 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71107 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71113 */     GIR_RootConstrainSelectedInstOperands,
     /*  71114 */     // GIR_Coverage, 1897,
     /*  71114 */     GIR_EraseRootFromParent_Done,
     /*  71115 */   // Label 1416: @71115
     /*  71115 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(71178), // Rule ID 1898 //
     /*  71120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsd),
     /*  71128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71152 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71156 */     // (intrinsic_wo_chain:{ *:[i32] } 3864:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSD:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSD),
     /*  71159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71167 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71170 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71176 */     GIR_RootConstrainSelectedInstOperands,
     /*  71177 */     // GIR_Coverage, 1898,
     /*  71177 */     GIR_EraseRootFromParent_Done,
     /*  71178 */   // Label 1417: @71178
     /*  71178 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(71241), // Rule ID 1899 //
     /*  71183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  71186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlsdx),
     /*  71191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71211 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71215 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71219 */     // (intrinsic_wo_chain:{ *:[i32] } 3865:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPR:{ *:[i32] }:$Ra)  =>  (SMLSDX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm, GPRnopc:{ *:[i32] }:$Ra)
     /*  71219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLSDX),
     /*  71222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71226 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  71228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ra
     /*  71230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71239 */     GIR_RootConstrainSelectedInstOperands,
     /*  71240 */     // GIR_Coverage, 1899,
     /*  71240 */     GIR_EraseRootFromParent_Done,
     /*  71241 */   // Label 1418: @71241
     /*  71241 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(71304), // Rule ID 1987 //
     /*  71246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71282 */     // (intrinsic_wo_chain:{ *:[i32] } 3854:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABB),
     /*  71285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71287 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71289 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71291 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71293 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71296 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71302 */     GIR_RootConstrainSelectedInstOperands,
     /*  71303 */     // GIR_Coverage, 1987,
     /*  71303 */     GIR_EraseRootFromParent_Done,
     /*  71304 */   // Label 1419: @71304
     /*  71304 */   GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(71367), // Rule ID 1988 //
     /*  71309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71341 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71345 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLABT),
     /*  71348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71350 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71352 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71354 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71356 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71359 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71365 */     GIR_RootConstrainSelectedInstOperands,
     /*  71366 */     // GIR_Coverage, 1988,
     /*  71366 */     GIR_EraseRootFromParent_Done,
     /*  71367 */   // Label 1420: @71367
     /*  71367 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(71430), // Rule ID 1989 //
     /*  71372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71375 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71380 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71389 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71404 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71408 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATB),
     /*  71411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71413 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71415 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71417 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71422 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71428 */     GIR_RootConstrainSelectedInstOperands,
     /*  71429 */     // GIR_Coverage, 1989,
     /*  71429 */     GIR_EraseRootFromParent_Done,
     /*  71430 */   // Label 1421: @71430
     /*  71430 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(71493), // Rule ID 1990 //
     /*  71435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71467 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71471 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLATT),
     /*  71474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71476 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71478 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71480 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71482 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71491 */     GIR_RootConstrainSelectedInstOperands,
     /*  71492 */     // GIR_Coverage, 1990,
     /*  71492 */     GIR_EraseRootFromParent_Done,
     /*  71493 */   // Label 1422: @71493
     /*  71493 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(71556), // Rule ID 1991 //
     /*  71498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71515 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71530 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71534 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWB),
     /*  71537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71539 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71541 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71543 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71545 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71554 */     GIR_RootConstrainSelectedInstOperands,
     /*  71555 */     // GIR_Coverage, 1991,
     /*  71555 */     GIR_EraseRootFromParent_Done,
     /*  71556 */   // Label 1423: @71556
     /*  71556 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(71619), // Rule ID 1992 //
     /*  71561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /*  71564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  71585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71593 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71597 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMLAWT),
     /*  71600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71602 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71604 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71606 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71617 */     GIR_RootConstrainSelectedInstOperands,
     /*  71618 */     // GIR_Coverage, 1992,
     /*  71618 */     GIR_EraseRootFromParent_Done,
     /*  71619 */   // Label 1424: @71619
     /*  71619 */   GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(71682), // Rule ID 2178 //
     /*  71624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabb),
     /*  71632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71641 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71656 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71660 */     // (intrinsic_wo_chain:{ *:[i32] } 3854:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABB),
     /*  71663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71665 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71667 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71669 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71680 */     GIR_RootConstrainSelectedInstOperands,
     /*  71681 */     // GIR_Coverage, 2178,
     /*  71681 */     GIR_EraseRootFromParent_Done,
     /*  71682 */   // Label 1425: @71682
     /*  71682 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(71745), // Rule ID 2179 //
     /*  71687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlabt),
     /*  71695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71715 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71723 */     // (intrinsic_wo_chain:{ *:[i32] } 3855:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLABT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLABT),
     /*  71726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71728 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71730 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71732 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71743 */     GIR_RootConstrainSelectedInstOperands,
     /*  71744 */     // GIR_Coverage, 2179,
     /*  71744 */     GIR_EraseRootFromParent_Done,
     /*  71745 */   // Label 1426: @71745
     /*  71745 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(71808), // Rule ID 2180 //
     /*  71750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatb),
     /*  71758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71764 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71767 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71782 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71786 */     // (intrinsic_wo_chain:{ *:[i32] } 3860:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATB),
     /*  71789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71791 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71793 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71795 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71806 */     GIR_RootConstrainSelectedInstOperands,
     /*  71807 */     // GIR_Coverage, 2180,
     /*  71807 */     GIR_EraseRootFromParent_Done,
     /*  71808 */   // Label 1427: @71808
     /*  71808 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(71871), // Rule ID 2181 //
     /*  71813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlatt),
     /*  71821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71837 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71841 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71845 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71849 */     // (intrinsic_wo_chain:{ *:[i32] } 3861:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLATT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLATT),
     /*  71852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71854 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71856 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71858 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71863 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71869 */     GIR_RootConstrainSelectedInstOperands,
     /*  71870 */     // GIR_Coverage, 2181,
     /*  71870 */     GIR_EraseRootFromParent_Done,
     /*  71871 */   // Label 1428: @71871
     /*  71871 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(71934), // Rule ID 2182 //
     /*  71876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawb),
     /*  71884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71890 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71893 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71908 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71912 */     // (intrinsic_wo_chain:{ *:[i32] } 3862:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWB),
     /*  71915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71917 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71919 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71921 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71923 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71926 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71932 */     GIR_RootConstrainSelectedInstOperands,
     /*  71933 */     // GIR_Coverage, 2182,
     /*  71933 */     GIR_EraseRootFromParent_Done,
     /*  71934 */   // Label 1429: @71934
     /*  71934 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(71997), // Rule ID 2183 //
     /*  71939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  71942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_smlawt),
     /*  71947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  71950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  71953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  71956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  71959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  71963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71971 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  71975 */     // (intrinsic_wo_chain:{ *:[i32] } 3863:{ *:[iPTR] }, GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)  =>  (t2SMLAWT:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b, GPR:{ *:[i32] }:$acc)
     /*  71975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMLAWT),
     /*  71978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71980 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  71984 */     GIR_RootToRootCopy, /*OpIdx*/4, // acc
     /*  71986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  71989 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  71995 */     GIR_RootConstrainSelectedInstOperands,
     /*  71996 */     // GIR_Coverage, 2183,
     /*  71996 */     GIR_EraseRootFromParent_Done,
     /*  71997 */   // Label 1430: @71997
     /*  71997 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(72060), // Rule ID 2469 //
     /*  72002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72019 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72034 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72038 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3783:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLAHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i16),
     /*  72041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72043 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72045 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72047 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72058 */     GIR_RootConstrainSelectedInstOperands,
     /*  72059 */     // GIR_Coverage, 2469,
     /*  72059 */     GIR_EraseRootFromParent_Done,
     /*  72060 */   // Label 1431: @72060
     /*  72060 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(72123), // Rule ID 2470 //
     /*  72065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72097 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72101 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3783:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLAHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv2i32),
     /*  72104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72106 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72112 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72115 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72121 */     GIR_RootConstrainSelectedInstOperands,
     /*  72122 */     // GIR_Coverage, 2470,
     /*  72122 */     GIR_EraseRootFromParent_Done,
     /*  72123 */   // Label 1432: @72123
     /*  72123 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(72186), // Rule ID 2471 //
     /*  72128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72160 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72164 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3783:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLAHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv8i16),
     /*  72167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72169 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72184 */     GIR_RootConstrainSelectedInstOperands,
     /*  72185 */     // GIR_Coverage, 2471,
     /*  72185 */     GIR_EraseRootFromParent_Done,
     /*  72186 */   // Label 1433: @72186
     /*  72186 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(72249), // Rule ID 2472 //
     /*  72191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlah),
     /*  72199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72223 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72227 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3783:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLAHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLAHv4i32),
     /*  72230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72232 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72247 */     GIR_RootConstrainSelectedInstOperands,
     /*  72248 */     // GIR_Coverage, 2472,
     /*  72248 */     GIR_EraseRootFromParent_Done,
     /*  72249 */   // Label 1434: @72249
     /*  72249 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(72312), // Rule ID 2477 //
     /*  72254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /*  72265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  72268 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  72271 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /*  72274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72278 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72282 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72286 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72290 */     // (intrinsic_wo_chain:{ *:[v4i16] } 3784:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQRDMLSHv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /*  72290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i16),
     /*  72293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72295 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72301 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72304 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72310 */     GIR_RootConstrainSelectedInstOperands,
     /*  72311 */     // GIR_Coverage, 2477,
     /*  72311 */     GIR_EraseRootFromParent_Done,
     /*  72312 */   // Label 1435: @72312
     /*  72312 */   GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(72375), // Rule ID 2478 //
     /*  72317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /*  72328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  72331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  72334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /*  72337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72345 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72349 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  72353 */     // (intrinsic_wo_chain:{ *:[v2i32] } 3784:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQRDMLSHv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /*  72353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv2i32),
     /*  72356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72358 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72373 */     GIR_RootConstrainSelectedInstOperands,
     /*  72374 */     // GIR_Coverage, 2478,
     /*  72374 */     GIR_EraseRootFromParent_Done,
     /*  72375 */   // Label 1436: @72375
     /*  72375 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(72438), // Rule ID 2479 //
     /*  72380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  72400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72412 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72416 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3784:{ *:[iPTR] }, QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQRDMLSHv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$src1, QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /*  72416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv8i16),
     /*  72419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72421 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72423 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72425 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72430 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72436 */     GIR_RootConstrainSelectedInstOperands,
     /*  72437 */     // GIR_Coverage, 2479,
     /*  72437 */     GIR_EraseRootFromParent_Done,
     /*  72438 */   // Label 1437: @72438
     /*  72438 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(72501), // Rule ID 2480 //
     /*  72443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasV8_1a),
     /*  72446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqrdmlsh),
     /*  72451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  72463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72471 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72475 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  72479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3784:{ *:[iPTR] }, QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQRDMLSHv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /*  72479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQRDMLSHv4i32),
     /*  72482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  72484 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /*  72486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /*  72488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /*  72490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  72493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72499 */     GIR_RootConstrainSelectedInstOperands,
     /*  72500 */     // GIR_Coverage, 2480,
     /*  72500 */     GIR_EraseRootFromParent_Done,
     /*  72501 */   // Label 1438: @72501
     /*  72501 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(72570), // Rule ID 4837 //
     /*  72506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72523 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72534 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72538 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72542 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3634:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs8),
     /*  72545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72547 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72549 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72551 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72562 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72568 */     GIR_RootConstrainSelectedInstOperands,
     /*  72569 */     // GIR_Coverage, 4837,
     /*  72569 */     GIR_EraseRootFromParent_Done,
     /*  72570 */   // Label 1439: @72570
     /*  72570 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(72639), // Rule ID 4839 //
     /*  72575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72578 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72583 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72607 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72611 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3634:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs16),
     /*  72614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72616 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72618 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72620 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72622 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72625 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72637 */     GIR_RootConstrainSelectedInstOperands,
     /*  72638 */     // GIR_Coverage, 4839,
     /*  72638 */     GIR_EraseRootFromParent_Done,
     /*  72639 */   // Label 1440: @72639
     /*  72639 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(72708), // Rule ID 4841 //
     /*  72644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlah),
     /*  72652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72661 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72676 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72680 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3634:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLAH_qrs32),
     /*  72683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72685 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72687 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72689 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72694 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72706 */     GIR_RootConstrainSelectedInstOperands,
     /*  72707 */     // GIR_Coverage, 4841,
     /*  72707 */     GIR_EraseRootFromParent_Done,
     /*  72708 */   // Label 1441: @72708
     /*  72708 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(72777), // Rule ID 4843 //
     /*  72713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72749 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3643:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs8),
     /*  72752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72754 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72756 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72758 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72775 */     GIR_RootConstrainSelectedInstOperands,
     /*  72776 */     // GIR_Coverage, 4843,
     /*  72776 */     GIR_EraseRootFromParent_Done,
     /*  72777 */   // Label 1442: @72777
     /*  72777 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(72846), // Rule ID 4845 //
     /*  72782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  72793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72796 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  72799 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72814 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72818 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3643:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs16),
     /*  72821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72823 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72825 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72827 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72832 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72844 */     GIR_RootConstrainSelectedInstOperands,
     /*  72845 */     // GIR_Coverage, 4845,
     /*  72845 */     GIR_EraseRootFromParent_Done,
     /*  72846 */   // Label 1443: @72846
     /*  72846 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(72915), // Rule ID 4847 //
     /*  72851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlah),
     /*  72859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  72862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  72865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  72868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72879 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72883 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72887 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3643:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLAH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLAH_qrs32),
     /*  72890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72892 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72894 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72896 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72913 */     GIR_RootConstrainSelectedInstOperands,
     /*  72914 */     // GIR_Coverage, 4847,
     /*  72914 */     GIR_EraseRootFromParent_Done,
     /*  72915 */   // Label 1444: @72915
     /*  72915 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(72984), // Rule ID 4849 //
     /*  72920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  72931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  72937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  72940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  72952 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  72956 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3636:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  72956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs8),
     /*  72959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  72961 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  72965 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  72967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  72970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  72982 */     GIR_RootConstrainSelectedInstOperands,
     /*  72983 */     // GIR_Coverage, 4849,
     /*  72983 */     GIR_EraseRootFromParent_Done,
     /*  72984 */   // Label 1445: @72984
     /*  72984 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(73053), // Rule ID 4851 //
     /*  72989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  72992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  72997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73021 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73025 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3636:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs16),
     /*  73028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73030 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73032 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73034 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73051 */     GIR_RootConstrainSelectedInstOperands,
     /*  73052 */     // GIR_Coverage, 4851,
     /*  73052 */     GIR_EraseRootFromParent_Done,
     /*  73053 */   // Label 1446: @73053
     /*  73053 */   GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(73122), // Rule ID 4853 //
     /*  73058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlash),
     /*  73066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73075 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73082 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73090 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73094 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3636:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLASH_qrs32),
     /*  73097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73099 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73101 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73103 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73120 */     GIR_RootConstrainSelectedInstOperands,
     /*  73121 */     // GIR_Coverage, 4853,
     /*  73121 */     GIR_EraseRootFromParent_Done,
     /*  73122 */   // Label 1447: @73122
     /*  73122 */   GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(73191), // Rule ID 4855 //
     /*  73127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  73138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  73144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73163 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3645:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v1, MQPR:{ *:[v16i8] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs8),
     /*  73166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73168 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73170 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73172 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73189 */     GIR_RootConstrainSelectedInstOperands,
     /*  73190 */     // GIR_Coverage, 4855,
     /*  73190 */     GIR_EraseRootFromParent_Done,
     /*  73191 */   // Label 1448: @73191
     /*  73191 */   GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(73260), // Rule ID 4857 //
     /*  73196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73199 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73204 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73207 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73210 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  73213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73228 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73232 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3645:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v1, MQPR:{ *:[v8i16] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs16),
     /*  73235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73237 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73239 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73241 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73243 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73246 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73258 */     GIR_RootConstrainSelectedInstOperands,
     /*  73259 */     // GIR_Coverage, 4857,
     /*  73259 */     GIR_EraseRootFromParent_Done,
     /*  73260 */   // Label 1449: @73260
     /*  73260 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(73329), // Rule ID 4859 //
     /*  73265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  73268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqrdmlash),
     /*  73273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  73282 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73297 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  73301 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3645:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)  =>  (MVE_VQRDMLASH_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v1, MQPR:{ *:[v4i32] }:$v2, rGPR:{ *:[i32] }:$s)
     /*  73301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLASH_qrs32),
     /*  73304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73306 */     GIR_RootToRootCopy, /*OpIdx*/2, // v1
     /*  73308 */     GIR_RootToRootCopy, /*OpIdx*/3, // v2
     /*  73310 */     GIR_RootToRootCopy, /*OpIdx*/4, // s
     /*  73312 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73315 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73321 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73327 */     GIR_RootConstrainSelectedInstOperands,
     /*  73328 */     // GIR_Coverage, 4859,
     /*  73328 */     GIR_EraseRootFromParent_Done,
     /*  73329 */   // Label 1450: @73329
     /*  73329 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(73424), // Rule ID 2691 //
     /*  73334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1c),
     /*  73342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73351 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73358 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3700:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1C:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73358 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73361 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73365 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73370 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73391 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73394 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73397 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73400 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1C),
     /*  73413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73415 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73417 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73420 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73422 */     GIR_RootConstrainSelectedInstOperands,
     /*  73423 */     // GIR_Coverage, 2691,
     /*  73423 */     GIR_EraseRootFromParent_Done,
     /*  73424 */   // Label 1451: @73424
     /*  73424 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(73519), // Rule ID 2692 //
     /*  73429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1m),
     /*  73437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73453 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3702:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1M:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73453 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73456 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73460 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73465 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73469 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73474 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73477 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73481 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73486 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73489 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73492 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1M),
     /*  73508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73510 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73512 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73515 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73517 */     GIR_RootConstrainSelectedInstOperands,
     /*  73518 */     // GIR_Coverage, 2692,
     /*  73518 */     GIR_EraseRootFromParent_Done,
     /*  73519 */   // Label 1452: @73519
     /*  73519 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(73614), // Rule ID 2693 //
     /*  73524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_sha1p),
     /*  73532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  73538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  73544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  73548 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3703:{ *:[iPTR] }, v4i32:{ *:[v4i32] }:$hash_abcd, i32:{ *:[i32] }:$hash_e, v4i32:{ *:[v4i32] }:$wk)  =>  (SHA1P:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$hash_abcd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (COPY_TO_REGCLASS:{ *:[f32] } i32:{ *:[i32] }:$hash_e, SPR:{ *:[i32] }), ssub_0:{ *:[i32] }), v4i32:{ *:[v4i32] }:$wk)
     /*  73548 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  73551 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  73555 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73560 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // hash_e
     /*  73564 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  73572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  73576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73581 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  73584 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  73587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/17,
     /*  73590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPair_with_ssub_0RegClassID),
     /*  73595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /*  73600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SHA1P),
     /*  73603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  73605 */     GIR_RootToRootCopy, /*OpIdx*/2, // hash_abcd
     /*  73607 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73610 */     GIR_RootToRootCopy, /*OpIdx*/4, // wk
     /*  73612 */     GIR_RootConstrainSelectedInstOperands,
     /*  73613 */     // GIR_Coverage, 2693,
     /*  73613 */     GIR_EraseRootFromParent_Done,
     /*  73614 */   // Label 1453: @73614
     /*  73614 */   GIM_Reject,
     /*  73615 */ // Label 1306: @73615
     /*  73615 */ GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(77001),
     /*  73620 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  73623 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(73707), // Rule ID 3724 //
     /*  73628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73668 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8bh),
     /*  73683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73685 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73690 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73696 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73702 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73705 */     GIR_RootConstrainSelectedInstOperands,
     /*  73706 */     // GIR_Coverage, 3724,
     /*  73706 */     GIR_EraseRootFromParent_Done,
     /*  73707 */   // Label 1455: @73707
     /*  73707 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(73791), // Rule ID 3728 //
     /*  73712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73726 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73729 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73736 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73740 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73752 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  73752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws8th),
     /*  73767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73769 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73774 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73780 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73789 */     GIR_RootConstrainSelectedInstOperands,
     /*  73790 */     // GIR_Coverage, 3728,
     /*  73790 */     GIR_EraseRootFromParent_Done,
     /*  73791 */   // Label 1456: @73791
     /*  73791 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(73875), // Rule ID 3732 //
     /*  73796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73813 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73828 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73832 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  73836 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lws16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16bh),
     /*  73851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73853 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73855 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73864 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73870 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73873 */     GIR_RootConstrainSelectedInstOperands,
     /*  73874 */     // GIR_Coverage, 3732,
     /*  73874 */     GIR_EraseRootFromParent_Done,
     /*  73875 */   // Label 1457: @73875
     /*  73875 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(73959), // Rule ID 3736 //
     /*  73880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  73888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  73891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73894 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73897 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73908 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  73912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  73916 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  73920 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lws16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  73920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  73923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  73927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  73932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lws16th),
     /*  73935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  73937 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  73939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  73942 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  73954 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  73957 */     GIR_RootConstrainSelectedInstOperands,
     /*  73958 */     // GIR_Coverage, 3736,
     /*  73958 */     GIR_EraseRootFromParent_Done,
     /*  73959 */   // Label 1458: @73959
     /*  73959 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(74043), // Rule ID 3740 //
     /*  73964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  73969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  73972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  73978 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  73981 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  73984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  73992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  73996 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74000 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74004 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu8bh:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8bh),
     /*  74019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74021 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74023 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74026 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74041 */     GIR_RootConstrainSelectedInstOperands,
     /*  74042 */     // GIR_Coverage, 3740,
     /*  74042 */     GIR_EraseRootFromParent_Done,
     /*  74043 */   // Label 1459: @74043
     /*  74043 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(74127), // Rule ID 3744 //
     /*  74048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74065 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /*  74080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74088 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3675:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$src, 8:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu8th:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$src)
     /*  74088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu8th),
     /*  74103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74105 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74107 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74110 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74125 */     GIR_RootConstrainSelectedInstOperands,
     /*  74126 */     // GIR_Coverage, 3744,
     /*  74126 */     GIR_EraseRootFromParent_Done,
     /*  74127 */   // Label 1460: @74127
     /*  74127 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(74211), // Rule ID 3748 //
     /*  74132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74164 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74172 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHLL_lwu16bh:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74172 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74175 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74179 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16bh),
     /*  74187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74189 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74194 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74209 */     GIR_RootConstrainSelectedInstOperands,
     /*  74210 */     // GIR_Coverage, 3748,
     /*  74210 */     GIR_EraseRootFromParent_Done,
     /*  74211 */   // Label 1461: @74211
     /*  74211 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(74295), // Rule ID 3752 //
     /*  74216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshll_imm),
     /*  74221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  74230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74233 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /*  74248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74252 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74256 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3675:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$src, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHLL_lwu16th:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$src)
     /*  74256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHLL_lwu16th),
     /*  74271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74273 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /*  74275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74278 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74284 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74293 */     GIR_RootConstrainSelectedInstOperands,
     /*  74294 */     // GIR_Coverage, 3752,
     /*  74294 */     GIR_EraseRootFromParent_Done,
     /*  74295 */   // Label 1462: @74295
     /*  74295 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(74384), // Rule ID 4384 //
     /*  74300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74303 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74308 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74317 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74320 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74343 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs8),
     /*  74358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74373 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74382 */     GIR_RootConstrainSelectedInstOperands,
     /*  74383 */     // GIR_Coverage, 4384,
     /*  74383 */     GIR_EraseRootFromParent_Done,
     /*  74384 */   // Label 1463: @74384
     /*  74384 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(74473), // Rule ID 4386 //
     /*  74389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74409 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74432 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74435 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74439 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs8),
     /*  74447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74471 */     GIR_RootConstrainSelectedInstOperands,
     /*  74472 */     // GIR_Coverage, 4386,
     /*  74472 */     GIR_EraseRootFromParent_Done,
     /*  74473 */   // Label 1464: @74473
     /*  74473 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(74562), // Rule ID 4388 //
     /*  74478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74495 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74498 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74509 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74513 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74521 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs16),
     /*  74536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74551 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74560 */     GIR_RootConstrainSelectedInstOperands,
     /*  74561 */     // GIR_Coverage, 4388,
     /*  74561 */     GIR_EraseRootFromParent_Done,
     /*  74562 */   // Label 1465: @74562
     /*  74562 */   GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(74651), // Rule ID 4390 //
     /*  74567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  74578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  74581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  74584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74587 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  74610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74613 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74617 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs16),
     /*  74625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74649 */     GIR_RootConstrainSelectedInstOperands,
     /*  74650 */     // GIR_Coverage, 4390,
     /*  74650 */     GIR_EraseRootFromParent_Done,
     /*  74651 */   // Label 1466: @74651
     /*  74651 */   GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(74740), // Rule ID 4392 //
     /*  74656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74664 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74667 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74670 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74673 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74676 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74691 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74699 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBs32),
     /*  74714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74738 */     GIR_RootConstrainSelectedInstOperands,
     /*  74739 */     // GIR_Coverage, 4392,
     /*  74739 */     GIR_EraseRootFromParent_Done,
     /*  74740 */   // Label 1467: @74740
     /*  74740 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(74829), // Rule ID 4394 //
     /*  74745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  74756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  74759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  74762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  74784 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74788 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTs32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  74788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTs32),
     /*  74803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74807 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74827 */     GIR_RootConstrainSelectedInstOperands,
     /*  74828 */     // GIR_Coverage, 4394,
     /*  74828 */     GIR_EraseRootFromParent_Done,
     /*  74829 */   // Label 1468: @74829
     /*  74829 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(74918), // Rule ID 4396 //
     /*  74834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74842 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74845 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74848 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74851 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74854 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74869 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74873 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  74877 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu8),
     /*  74892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74907 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  74916 */     GIR_RootConstrainSelectedInstOperands,
     /*  74917 */     // GIR_Coverage, 4396,
     /*  74917 */     GIR_EraseRootFromParent_Done,
     /*  74918 */   // Label 1469: @74918
     /*  74918 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(75007), // Rule ID 4398 //
     /*  74923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  74926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  74931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  74934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  74937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  74940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  74943 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  74946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74954 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  74958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  74962 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  74966 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3630:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu8:{ *:[v8i16] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /*  74966 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  74969 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  74973 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  74978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu8),
     /*  74981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  74983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  74985 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  74987 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  74990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  74996 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75002 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75005 */     GIR_RootConstrainSelectedInstOperands,
     /*  75006 */     // GIR_Coverage, 4398,
     /*  75006 */     GIR_EraseRootFromParent_Done,
     /*  75007 */   // Label 1470: @75007
     /*  75007 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(75096), // Rule ID 4400 //
     /*  75012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75015 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75020 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75023 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75026 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75029 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75032 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75055 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75055 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75058 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75062 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu16),
     /*  75070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75094 */     GIR_RootConstrainSelectedInstOperands,
     /*  75095 */     // GIR_Coverage, 4400,
     /*  75095 */     GIR_EraseRootFromParent_Done,
     /*  75096 */   // Label 1471: @75096
     /*  75096 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(75185), // Rule ID 4402 //
     /*  75101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  75115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  75118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75136 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75140 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75144 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3630:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu16:{ *:[v4i32] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /*  75144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu16),
     /*  75159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75183 */     GIR_RootConstrainSelectedInstOperands,
     /*  75184 */     // GIR_Coverage, 4402,
     /*  75184 */     GIR_EraseRootFromParent_Done,
     /*  75185 */   // Label 1472: @75185
     /*  75185 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(75274), // Rule ID 4404 //
     /*  75190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  75233 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VMULLBu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLBu32),
     /*  75248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75263 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75269 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75272 */     GIR_RootConstrainSelectedInstOperands,
     /*  75273 */     // GIR_Coverage, 4404,
     /*  75273 */     GIR_EraseRootFromParent_Done,
     /*  75274 */   // Label 1473: @75274
     /*  75274 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(75363), // Rule ID 4406 //
     /*  75279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75282 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmull),
     /*  75287 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  75290 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  75293 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  75296 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  75299 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  75302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  75318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  75322 */     // (intrinsic_wo_chain:{ *:[v2i64] } 3630:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VMULLTu32:{ *:[v2i64] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /*  75322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULLTu32),
     /*  75337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qm
     /*  75341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qn
     /*  75343 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75346 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75361 */     GIR_RootConstrainSelectedInstOperands,
     /*  75362 */     // GIR_Coverage, 4406,
     /*  75362 */     GIR_EraseRootFromParent_Done,
     /*  75363 */   // Label 1474: @75363
     /*  75363 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(75461), // Rule ID 4029 //
     /*  75368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75388 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75407 */     // MIs[1] Operand 1
     /*  75407 */     // No operand predicates
     /*  75407 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75411 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75417 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75417 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75420 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75424 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf16),
     /*  75432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75436 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75444 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75456 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75459 */     GIR_RootConstrainSelectedInstOperands,
     /*  75460 */     // GIR_Coverage, 4029,
     /*  75460 */     GIR_EraseRootFromParent_Done,
     /*  75461 */   // Label 1475: @75461
     /*  75461 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(75559), // Rule ID 4031 //
     /*  75466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  75469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75493 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75505 */     // MIs[1] Operand 1
     /*  75505 */     // No operand predicates
     /*  75505 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75509 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75515 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDf32),
     /*  75530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75532 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75534 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75539 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75542 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75554 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75557 */     GIR_RootConstrainSelectedInstOperands,
     /*  75558 */     // GIR_Coverage, 4031,
     /*  75558 */     GIR_EraseRootFromParent_Done,
     /*  75559 */   // Label 1476: @75559
     /*  75559 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(75657), // Rule ID 4538 //
     /*  75564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75567 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75591 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75603 */     // MIs[1] Operand 1
     /*  75603 */     // No operand predicates
     /*  75603 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75607 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75611 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75613 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VCADDi8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi8),
     /*  75628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75632 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75634 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75640 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75652 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75655 */     GIR_RootConstrainSelectedInstOperands,
     /*  75656 */     // GIR_Coverage, 4538,
     /*  75656 */     GIR_EraseRootFromParent_Done,
     /*  75657 */   // Label 1477: @75657
     /*  75657 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(75755), // Rule ID 4540 //
     /*  75662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75701 */     // MIs[1] Operand 1
     /*  75701 */     // No operand predicates
     /*  75701 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75705 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75709 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75711 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VCADDi16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75711 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75714 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75718 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi16),
     /*  75726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75730 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75735 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75738 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75744 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75750 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75753 */     GIR_RootConstrainSelectedInstOperands,
     /*  75754 */     // GIR_Coverage, 4540,
     /*  75754 */     GIR_EraseRootFromParent_Done,
     /*  75755 */   // Label 1478: @75755
     /*  75755 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(75853), // Rule ID 4542 //
     /*  75760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  75771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  75780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  75783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75787 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  75791 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75795 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75799 */     // MIs[1] Operand 1
     /*  75799 */     // No operand predicates
     /*  75799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75803 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75809 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3573:{ *:[iPTR] }, 1:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VCADDi32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCADDi32),
     /*  75824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75826 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75828 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75830 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75833 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75836 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75842 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75848 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75851 */     GIR_RootConstrainSelectedInstOperands,
     /*  75852 */     // GIR_Coverage, 4542,
     /*  75852 */     GIR_EraseRootFromParent_Done,
     /*  75853 */   // Label 1479: @75853
     /*  75853 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(75951), // Rule ID 4544 //
     /*  75858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  75869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  75878 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  75881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75897 */     // MIs[1] Operand 1
     /*  75897 */     // No operand predicates
     /*  75897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75901 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  75907 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3573:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VHCADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  75907 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  75910 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  75914 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  75919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs8),
     /*  75922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  75924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  75926 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  75928 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  75931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  75934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75940 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  75946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  75949 */     GIR_RootConstrainSelectedInstOperands,
     /*  75950 */     // GIR_Coverage, 4544,
     /*  75950 */     GIR_EraseRootFromParent_Done,
     /*  75951 */   // Label 1480: @75951
     /*  75951 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(76049), // Rule ID 4546 //
     /*  75956 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  75959 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  75964 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  75967 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  75970 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  75973 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  75976 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  75979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  75987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  75991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  75995 */     // MIs[1] Operand 1
     /*  75995 */     // No operand predicates
     /*  75995 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  75999 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76005 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3573:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VHCADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs16),
     /*  76020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76024 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76044 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76047 */     GIR_RootConstrainSelectedInstOperands,
     /*  76048 */     // GIR_Coverage, 4546,
     /*  76048 */     GIR_EraseRootFromParent_Done,
     /*  76049 */   // Label 1481: @76049
     /*  76049 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(76147), // Rule ID 4548 //
     /*  76054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcaddq),
     /*  76062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76081 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  76089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76093 */     // MIs[1] Operand 1
     /*  76093 */     // No operand predicates
     /*  76093 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76097 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76103 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3573:{ *:[iPTR] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VHCADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76103 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  76106 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76110 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VHCADDs32),
     /*  76118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76122 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76124 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76127 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76136 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76145 */     GIR_RootConstrainSelectedInstOperands,
     /*  76146 */     // GIR_Coverage, 4548,
     /*  76146 */     GIR_EraseRootFromParent_Done,
     /*  76147 */   // Label 1482: @76147
     /*  76147 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(76223), // Rule ID 3034 //
     /*  76152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76172 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76187 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76191 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76195 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVs8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs8),
     /*  76198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76204 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76221 */     GIR_RootConstrainSelectedInstOperands,
     /*  76222 */     // GIR_Coverage, 3034,
     /*  76222 */     GIR_EraseRootFromParent_Done,
     /*  76223 */   // Label 1483: @76223
     /*  76223 */   GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(76299), // Rule ID 3036 //
     /*  76228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76248 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76263 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76267 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76271 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVs16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs16),
     /*  76274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76280 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76297 */     GIR_RootConstrainSelectedInstOperands,
     /*  76298 */     // GIR_Coverage, 3036,
     /*  76298 */     GIR_EraseRootFromParent_Done,
     /*  76299 */   // Label 1484: @76299
     /*  76299 */   GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(76375), // Rule ID 3038 //
     /*  76304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76324 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76331 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  76335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76343 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76347 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 0:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVs32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVs32),
     /*  76350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76354 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76356 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76361 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76367 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76373 */     GIR_RootConstrainSelectedInstOperands,
     /*  76374 */     // GIR_Coverage, 3038,
     /*  76374 */     GIR_EraseRootFromParent_Done,
     /*  76375 */   // Label 1485: @76375
     /*  76375 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(76451), // Rule ID 3040 //
     /*  76380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  76400 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v16s8,
     /*  76403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76407 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76419 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76423 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VABAVu8:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  76423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu8),
     /*  76426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76430 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76432 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76443 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76449 */     GIR_RootConstrainSelectedInstOperands,
     /*  76450 */     // GIR_Coverage, 3040,
     /*  76450 */     GIR_EraseRootFromParent_Done,
     /*  76451 */   // Label 1486: @76451
     /*  76451 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(76527), // Rule ID 3042 //
     /*  76456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76476 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76499 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VABAVu16:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  76499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu16),
     /*  76502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76508 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76513 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76519 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76525 */     GIR_RootConstrainSelectedInstOperands,
     /*  76526 */     // GIR_Coverage, 3042,
     /*  76526 */     GIR_EraseRootFromParent_Done,
     /*  76527 */   // Label 1487: @76527
     /*  76527 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(76603), // Rule ID 3044 //
     /*  76532 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  76535 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vabav),
     /*  76540 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  76543 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76546 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  76549 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76552 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76559 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  76563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  76567 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76571 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76575 */     // (intrinsic_wo_chain:{ *:[i32] } 3566:{ *:[iPTR] }, 1:{ *:[i32] }, rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VABAVu32:{ *:[i32] } rGPR:{ *:[i32] }:$Rda_src, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  76575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABAVu32),
     /*  76578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /*  76580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rda_src
     /*  76582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76584 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76595 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76601 */     GIR_RootConstrainSelectedInstOperands,
     /*  76602 */     // GIR_Coverage, 3044,
     /*  76602 */     GIR_EraseRootFromParent_Done,
     /*  76603 */   // Label 1488: @76603
     /*  76603 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(76688), // Rule ID 3993 //
     /*  76608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  76619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  76625 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  76628 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s16,
     /*  76631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76643 */     // MIs[1] Operand 1
     /*  76643 */     // No operand predicates
     /*  76643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76647 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76651 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76655 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76657 */     // (intrinsic_wo_chain:{ *:[v8f16] } 3576:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm)  =>  (MVE_VCMLAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd_src, MQPR:{ *:[v8f16] }:$Qn, MQPR:{ *:[v8f16] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf16),
     /*  76660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76666 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76671 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76674 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76680 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76686 */     GIR_RootConstrainSelectedInstOperands,
     /*  76687 */     // GIR_Coverage, 3993,
     /*  76687 */     GIR_EraseRootFromParent_Done,
     /*  76688 */   // Label 1489: @76688
     /*  76688 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(76773), // Rule ID 3996 //
     /*  76693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /*  76696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vcmlaq),
     /*  76701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  76704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  76707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  76710 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  76713 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v4s32,
     /*  76716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  76724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  76728 */     // MIs[1] Operand 1
     /*  76728 */     // No operand predicates
     /*  76728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76732 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76736 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  76740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  76742 */     // (intrinsic_wo_chain:{ *:[v4f32] } 3576:{ *:[iPTR] }, (imm:{ *:[i32] }):$rot, MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm)  =>  (MVE_VCMLAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd_src, MQPR:{ *:[v4f32] }:$Qn, MQPR:{ *:[v4f32] }:$Qm, (imm:{ *:[i32] }):$rot)
     /*  76742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMLAf32),
     /*  76745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  76747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qd_src
     /*  76749 */     GIR_RootToRootCopy, /*OpIdx*/4, // Qn
     /*  76751 */     GIR_RootToRootCopy, /*OpIdx*/5, // Qm
     /*  76753 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // rot
     /*  76756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  76759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76771 */     GIR_RootConstrainSelectedInstOperands,
     /*  76772 */     // GIR_Coverage, 3996,
     /*  76772 */     GIR_EraseRootFromParent_Done,
     /*  76773 */   // Label 1490: @76773
     /*  76773 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(76869), // Rule ID 2685 //
     /*  76778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx2),
     /*  76786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76805 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3832:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX2:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v16i8] } DPair:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /*  76808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76817 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  76821 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  76828 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPairRegClassID),
     /*  76836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX2),
     /*  76849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  76851 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  76853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76856 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76858 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76861 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76867 */     GIR_RootConstrainSelectedInstOperands,
     /*  76868 */     // GIR_Coverage, 2685,
     /*  76868 */     GIR_EraseRootFromParent_Done,
     /*  76869 */   // Label 1491: @76869
     /*  76869 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(77000), // Rule ID 2686 //
     /*  76874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  76877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl3),
     /*  76882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  76885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  76888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  76891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  76894 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  76897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  76901 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3829:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL3Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  76901 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  76904 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  76908 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  76915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  76918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  76922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  76927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  76931 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  76934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  76938 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  76941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  76945 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  76948 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  76951 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  76954 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  76959 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76974 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  76979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL3Pseudo),
     /*  76982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  76984 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  76987 */     GIR_RootToRootCopy, /*OpIdx*/5, // Vm
     /*  76989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  76992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  76998 */     GIR_RootConstrainSelectedInstOperands,
     /*  76999 */     // GIR_Coverage, 2686,
     /*  76999 */     GIR_EraseRootFromParent_Done,
     /*  77000 */   // Label 1492: @77000
     /*  77000 */   GIM_Reject,
     /*  77001 */ // Label 1454: @77001
     /*  77001 */ GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(82307),
     /*  77006 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  77009 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(77102), // Rule ID 3835 //
     /*  77014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77031 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77034 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77053 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77061 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs8),
     /*  77076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77078 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77080 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77100 */     GIR_RootConstrainSelectedInstOperands,
     /*  77101 */     // GIR_Coverage, 3835,
     /*  77101 */     GIR_EraseRootFromParent_Done,
     /*  77102 */   // Label 1494: @77102
     /*  77102 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(77195), // Rule ID 3837 //
     /*  77107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77121 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77124 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77127 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77142 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77150 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77154 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77154 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77157 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77161 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs16),
     /*  77169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77171 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77173 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77175 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77178 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77193 */     GIR_RootConstrainSelectedInstOperands,
     /*  77194 */     // GIR_Coverage, 3837,
     /*  77194 */     GIR_EraseRootFromParent_Done,
     /*  77195 */   // Label 1495: @77195
     /*  77195 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(77288), // Rule ID 3839 //
     /*  77200 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77205 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77208 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77211 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77214 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77217 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77220 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77231 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77243 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77247 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77247 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77250 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77254 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecs32),
     /*  77262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77264 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77266 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77277 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77286 */     GIR_RootConstrainSelectedInstOperands,
     /*  77287 */     // GIR_Coverage, 3839,
     /*  77287 */     GIR_EraseRootFromParent_Done,
     /*  77288 */   // Label 1496: @77288
     /*  77288 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(77381), // Rule ID 3841 //
     /*  77293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77307 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77310 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77313 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77324 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77328 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77332 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77336 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77340 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu8),
     /*  77355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77357 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77359 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77379 */     GIR_RootConstrainSelectedInstOperands,
     /*  77380 */     // GIR_Coverage, 3841,
     /*  77380 */     GIR_EraseRootFromParent_Done,
     /*  77381 */   // Label 1497: @77381
     /*  77381 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(77474), // Rule ID 3843 //
     /*  77386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77433 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu16),
     /*  77448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77450 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77452 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77472 */     GIR_RootConstrainSelectedInstOperands,
     /*  77473 */     // GIR_Coverage, 3843,
     /*  77473 */     GIR_EraseRootFromParent_Done,
     /*  77474 */   // Label 1498: @77474
     /*  77474 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(77567), // Rule ID 3845 //
     /*  77479 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77484 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77487 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77490 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77493 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77496 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77499 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77502 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  77518 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77522 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77526 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_by_vecu32),
     /*  77541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77543 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77545 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77550 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77565 */     GIR_RootConstrainSelectedInstOperands,
     /*  77566 */     // GIR_Coverage, 3845,
     /*  77566 */     GIR_EraseRootFromParent_Done,
     /*  77567 */   // Label 1499: @77567
     /*  77567 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(77660), // Rule ID 3847 //
     /*  77572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77619 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77619 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77622 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77626 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs8),
     /*  77634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77636 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77638 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77649 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77658 */     GIR_RootConstrainSelectedInstOperands,
     /*  77659 */     // GIR_Coverage, 3847,
     /*  77659 */     GIR_EraseRootFromParent_Done,
     /*  77660 */   // Label 1500: @77660
     /*  77660 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(77753), // Rule ID 3849 //
     /*  77665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77679 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77682 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77685 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77696 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77700 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77704 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77712 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77712 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77715 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77719 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs16),
     /*  77727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77729 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77731 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77742 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77751 */     GIR_RootConstrainSelectedInstOperands,
     /*  77752 */     // GIR_Coverage, 3849,
     /*  77752 */     GIR_EraseRootFromParent_Done,
     /*  77753 */   // Label 1501: @77753
     /*  77753 */   GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(77846), // Rule ID 3851 //
     /*  77758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  77766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  77769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  77772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77778 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77781 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  77805 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  77805 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77808 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77812 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecs32),
     /*  77820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77822 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77824 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77844 */     GIR_RootConstrainSelectedInstOperands,
     /*  77845 */     // GIR_Coverage, 3851,
     /*  77845 */     GIR_EraseRootFromParent_Done,
     /*  77846 */   // Label 1502: @77846
     /*  77846 */   GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(77939), // Rule ID 3853 //
     /*  77851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  77859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  77862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  77865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77894 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77898 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  77898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  77910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu8),
     /*  77913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  77915 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  77917 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  77919 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  77922 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  77934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  77937 */     GIR_RootConstrainSelectedInstOperands,
     /*  77938 */     // GIR_Coverage, 3853,
     /*  77938 */     GIR_EraseRootFromParent_Done,
     /*  77939 */   // Label 1503: @77939
     /*  77939 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(78032), // Rule ID 3855 //
     /*  77944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  77949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  77952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  77955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  77958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  77961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  77964 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  77967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77971 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77975 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  77979 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  77983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  77987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  77991 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  77991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  77994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  77998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu16),
     /*  78006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78008 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78010 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78027 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78030 */     GIR_RootConstrainSelectedInstOperands,
     /*  78031 */     // GIR_Coverage, 3855,
     /*  78031 */     GIR_EraseRootFromParent_Done,
     /*  78032 */   // Label 1504: @78032
     /*  78032 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(78125), // Rule ID 3857 //
     /*  78037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78051 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78054 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78057 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78072 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  78080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78084 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_by_vecu32),
     /*  78099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78101 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78103 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78105 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78114 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78123 */     GIR_RootConstrainSelectedInstOperands,
     /*  78124 */     // GIR_Coverage, 3857,
     /*  78124 */     GIR_EraseRootFromParent_Done,
     /*  78125 */   // Label 1505: @78125
     /*  78125 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(78218), // Rule ID 3859 //
     /*  78130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78147 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78150 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78161 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78169 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78177 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs8),
     /*  78192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78194 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78196 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78207 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78216 */     GIR_RootConstrainSelectedInstOperands,
     /*  78217 */     // GIR_Coverage, 3859,
     /*  78217 */     GIR_EraseRootFromParent_Done,
     /*  78218 */   // Label 1506: @78218
     /*  78218 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(78311), // Rule ID 3861 //
     /*  78223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78237 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78240 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78243 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78250 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78254 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78262 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78266 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78270 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78270 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78273 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78277 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs16),
     /*  78285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78287 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78289 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78294 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78306 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78309 */     GIR_RootConstrainSelectedInstOperands,
     /*  78310 */     // GIR_Coverage, 3861,
     /*  78310 */     GIR_EraseRootFromParent_Done,
     /*  78311 */   // Label 1507: @78311
     /*  78311 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(78404), // Rule ID 3863 //
     /*  78316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78363 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecs32),
     /*  78378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78380 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78382 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78384 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78387 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78393 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78402 */     GIR_RootConstrainSelectedInstOperands,
     /*  78403 */     // GIR_Coverage, 3863,
     /*  78403 */     GIR_EraseRootFromParent_Done,
     /*  78404 */   // Label 1508: @78404
     /*  78404 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(78497), // Rule ID 3865 //
     /*  78409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78423 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78426 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78429 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78440 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78448 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78452 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78456 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu8),
     /*  78471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78473 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78475 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78486 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78495 */     GIR_RootConstrainSelectedInstOperands,
     /*  78496 */     // GIR_Coverage, 3865,
     /*  78496 */     GIR_EraseRootFromParent_Done,
     /*  78497 */   // Label 1509: @78497
     /*  78497 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(78590), // Rule ID 3867 //
     /*  78502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78516 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78519 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78522 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78549 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu16),
     /*  78564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78566 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78568 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78588 */     GIR_RootConstrainSelectedInstOperands,
     /*  78589 */     // GIR_Coverage, 3867,
     /*  78589 */     GIR_EraseRootFromParent_Done,
     /*  78590 */   // Label 1510: @78590
     /*  78590 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(78683), // Rule ID 3869 //
     /*  78595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78612 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78615 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78626 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78630 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  78634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78638 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  78642 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78642 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78645 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78649 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_by_vecu32),
     /*  78657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78659 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78661 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78678 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78681 */     GIR_RootConstrainSelectedInstOperands,
     /*  78682 */     // GIR_Coverage, 3869,
     /*  78682 */     GIR_EraseRootFromParent_Done,
     /*  78683 */   // Label 1511: @78683
     /*  78683 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(78776), // Rule ID 3871 //
     /*  78688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78708 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78727 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78731 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78735 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  78735 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78738 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78742 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs8),
     /*  78750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78752 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78754 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78771 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78774 */     GIR_RootConstrainSelectedInstOperands,
     /*  78775 */     // GIR_Coverage, 3871,
     /*  78775 */     GIR_EraseRootFromParent_Done,
     /*  78776 */   // Label 1512: @78776
     /*  78776 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(78869), // Rule ID 3873 //
     /*  78781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  78789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  78792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  78795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78812 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78824 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78828 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  78828 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78831 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78835 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs16),
     /*  78843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78845 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78847 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78849 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78852 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78858 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78867 */     GIR_RootConstrainSelectedInstOperands,
     /*  78868 */     // GIR_Coverage, 3873,
     /*  78868 */     GIR_EraseRootFromParent_Done,
     /*  78869 */   // Label 1513: @78869
     /*  78869 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(78962), // Rule ID 3875 //
     /*  78874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  78882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  78885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  78888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78891 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78894 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  78913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  78917 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  78921 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_by_vecs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  78921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  78924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  78928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  78933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecs32),
     /*  78936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  78938 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  78940 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  78942 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  78945 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  78957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  78960 */     GIR_RootConstrainSelectedInstOperands,
     /*  78961 */     // GIR_Coverage, 3875,
     /*  78961 */     GIR_EraseRootFromParent_Done,
     /*  78962 */   // Label 1514: @78962
     /*  78962 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(79055), // Rule ID 3877 //
     /*  78967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  78972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  78975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  78978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  78981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  78984 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  78987 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  78990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  78998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79010 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79014 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3671:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, MQPR:{ *:[v16i8] }:$sh)
     /*  79014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu8),
     /*  79029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79031 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79033 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79053 */     GIR_RootConstrainSelectedInstOperands,
     /*  79054 */     // GIR_Coverage, 3877,
     /*  79054 */     GIR_EraseRootFromParent_Done,
     /*  79055 */   // Label 1515: @79055
     /*  79055 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(79148), // Rule ID 3879 //
     /*  79060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79077 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79080 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79087 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79091 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79095 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79099 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79103 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79107 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3671:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, MQPR:{ *:[v8i16] }:$sh)
     /*  79107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu16),
     /*  79122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79124 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79126 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79128 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79137 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79143 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79146 */     GIR_RootConstrainSelectedInstOperands,
     /*  79147 */     // GIR_Coverage, 3879,
     /*  79147 */     GIR_EraseRootFromParent_Done,
     /*  79148 */   // Label 1516: @79148
     /*  79148 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(79241), // Rule ID 3881 //
     /*  79153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_vector),
     /*  79158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  79161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  79164 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79167 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79170 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79173 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79184 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79188 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79192 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79196 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79200 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3671:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_by_vecu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, MQPR:{ *:[v4i32] }:$sh)
     /*  79200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  79203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  79207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  79212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_by_vecu32),
     /*  79215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79217 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  79219 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  79221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79224 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79236 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  79239 */     GIR_RootConstrainSelectedInstOperands,
     /*  79240 */     // GIR_Coverage, 3881,
     /*  79240 */     GIR_EraseRootFromParent_Done,
     /*  79241 */   // Label 1517: @79241
     /*  79241 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(79319), // Rule ID 4486 //
     /*  79246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79277 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79293 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32bh),
     /*  79296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79305 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79311 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79317 */     GIR_RootConstrainSelectedInstOperands,
     /*  79318 */     // GIR_Coverage, 4486,
     /*  79318 */     GIR_EraseRootFromParent_Done,
     /*  79319 */   // Label 1518: @79319
     /*  79319 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(79397), // Rule ID 4488 //
     /*  79324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79338 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79341 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79344 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79351 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79355 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79363 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79367 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79371 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs32th),
     /*  79374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79383 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79395 */     GIR_RootConstrainSelectedInstOperands,
     /*  79396 */     // GIR_Coverage, 4488,
     /*  79396 */     GIR_EraseRootFromParent_Done,
     /*  79397 */   // Label 1519: @79397
     /*  79397 */   GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(79475), // Rule ID 4490 //
     /*  79402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79419 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79422 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79449 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16bh),
     /*  79452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79458 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79461 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79467 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79473 */     GIR_RootConstrainSelectedInstOperands,
     /*  79474 */     // GIR_Coverage, 4490,
     /*  79474 */     GIR_EraseRootFromParent_Done,
     /*  79475 */   // Label 1520: @79475
     /*  79475 */   GIM_Try, /*On fail goto*//*Label 1521*/ GIMT_Encode4(79553), // Rule ID 4492 //
     /*  79480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79497 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79500 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  79519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNs16th),
     /*  79530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79545 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79551 */     GIR_RootConstrainSelectedInstOperands,
     /*  79552 */     // GIR_Coverage, 4492,
     /*  79552 */     GIR_EraseRootFromParent_Done,
     /*  79553 */   // Label 1521: @79553
     /*  79553 */   GIM_Try, /*On fail goto*//*Label 1522*/ GIMT_Encode4(79631), // Rule ID 4494 //
     /*  79558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79575 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79578 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79589 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79601 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79605 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32bh),
     /*  79608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79629 */     GIR_RootConstrainSelectedInstOperands,
     /*  79630 */     // GIR_Coverage, 4494,
     /*  79630 */     GIR_EraseRootFromParent_Done,
     /*  79631 */   // Label 1522: @79631
     /*  79631 */   GIM_Try, /*On fail goto*//*Label 1523*/ GIMT_Encode4(79709), // Rule ID 4496 //
     /*  79636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79653 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79656 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79667 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79675 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79683 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu32th),
     /*  79686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79688 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79690 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79707 */     GIR_RootConstrainSelectedInstOperands,
     /*  79708 */     // GIR_Coverage, 4496,
     /*  79708 */     GIR_EraseRootFromParent_Done,
     /*  79709 */   // Label 1523: @79709
     /*  79709 */   GIM_Try, /*On fail goto*//*Label 1524*/ GIMT_Encode4(79787), // Rule ID 4498 //
     /*  79714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79731 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79734 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79761 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVNu16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16bh),
     /*  79764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79770 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79779 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79785 */     GIR_RootConstrainSelectedInstOperands,
     /*  79786 */     // GIR_Coverage, 4498,
     /*  79786 */     GIR_EraseRootFromParent_Done,
     /*  79787 */   // Label 1524: @79787
     /*  79787 */   GIM_Try, /*On fail goto*//*Label 1525*/ GIMT_Encode4(79865), // Rule ID 4500 //
     /*  79792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  79800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  79803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  79806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79809 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79812 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79831 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  79835 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79839 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVNu16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  79839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVNu16th),
     /*  79842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79848 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79851 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79857 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79863 */     GIR_RootConstrainSelectedInstOperands,
     /*  79864 */     // GIR_Coverage, 4500,
     /*  79864 */     GIR_EraseRootFromParent_Done,
     /*  79865 */   // Label 1525: @79865
     /*  79865 */   GIM_Try, /*On fail goto*//*Label 1526*/ GIMT_Encode4(79943), // Rule ID 4502 //
     /*  79870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79884 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79887 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79890 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  79917 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32bh),
     /*  79920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  79922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  79924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  79926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  79929 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79935 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  79941 */     GIR_RootConstrainSelectedInstOperands,
     /*  79942 */     // GIR_Coverage, 4502,
     /*  79942 */     GIR_EraseRootFromParent_Done,
     /*  79943 */   // Label 1526: @79943
     /*  79943 */   GIM_Try, /*On fail goto*//*Label 1527*/ GIMT_Encode4(80021), // Rule ID 4504 //
     /*  79948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  79953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  79956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  79959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  79962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  79965 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  79968 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  79971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79975 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79979 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  79983 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  79987 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  79991 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  79995 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3641:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd_src, MQPR:{ *:[v4i32] }:$Qm)
     /*  79995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs32th),
     /*  79998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80019 */     GIR_RootConstrainSelectedInstOperands,
     /*  80020 */     // GIR_Coverage, 4504,
     /*  80020 */     GIR_EraseRootFromParent_Done,
     /*  80021 */   // Label 1527: @80021
     /*  80021 */   GIM_Try, /*On fail goto*//*Label 1528*/ GIMT_Encode4(80099), // Rule ID 4506 //
     /*  80026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80043 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80046 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80073 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQMOVUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16bh),
     /*  80076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80097 */     GIR_RootConstrainSelectedInstOperands,
     /*  80098 */     // GIR_Coverage, 4506,
     /*  80098 */     GIR_EraseRootFromParent_Done,
     /*  80099 */   // Label 1528: @80099
     /*  80099 */   GIM_Try, /*On fail goto*//*Label 1529*/ GIMT_Encode4(80177), // Rule ID 4508 //
     /*  80104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqmovn),
     /*  80109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  80118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80121 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80124 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80139 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  80143 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80147 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80151 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3641:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQMOVUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd_src, MQPR:{ *:[v8i16] }:$Qm)
     /*  80151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQMOVUNs16th),
     /*  80154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd_src
     /*  80158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  80160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80163 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80169 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80175 */     GIR_RootConstrainSelectedInstOperands,
     /*  80176 */     // GIR_Coverage, 4508,
     /*  80176 */     GIR_EraseRootFromParent_Done,
     /*  80177 */   // Label 1529: @80177
     /*  80177 */   GIM_Try, /*On fail goto*//*Label 1530*/ GIMT_Encode4(80255), // Rule ID 4698 //
     /*  80182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80199 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80202 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80229 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs8),
     /*  80232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80234 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80236 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80241 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80247 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80253 */     GIR_RootConstrainSelectedInstOperands,
     /*  80254 */     // GIR_Coverage, 4698,
     /*  80254 */     GIR_EraseRootFromParent_Done,
     /*  80255 */   // Label 1530: @80255
     /*  80255 */   GIM_Try, /*On fail goto*//*Label 1531*/ GIMT_Encode4(80333), // Rule ID 4700 //
     /*  80260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80277 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80280 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80291 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80295 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80307 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs16),
     /*  80310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80312 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80314 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80331 */     GIR_RootConstrainSelectedInstOperands,
     /*  80332 */     // GIR_Coverage, 4700,
     /*  80332 */     GIR_EraseRootFromParent_Done,
     /*  80333 */   // Label 1531: @80333
     /*  80333 */   GIM_Try, /*On fail goto*//*Label 1532*/ GIMT_Encode4(80411), // Rule ID 4702 //
     /*  80338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80373 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80377 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80385 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qrs32),
     /*  80388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80390 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80392 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80397 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80403 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80409 */     GIR_RootConstrainSelectedInstOperands,
     /*  80410 */     // GIR_Coverage, 4702,
     /*  80410 */     GIR_EraseRootFromParent_Done,
     /*  80411 */   // Label 1532: @80411
     /*  80411 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(80489), // Rule ID 4704 //
     /*  80416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80433 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80436 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80447 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80455 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80463 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru8),
     /*  80466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80468 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80470 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80475 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80481 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80487 */     GIR_RootConstrainSelectedInstOperands,
     /*  80488 */     // GIR_Coverage, 4704,
     /*  80488 */     GIR_EraseRootFromParent_Done,
     /*  80489 */   // Label 1533: @80489
     /*  80489 */   GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(80567), // Rule ID 4706 //
     /*  80494 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80499 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80502 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80505 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80508 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80511 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80514 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80541 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru16),
     /*  80544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80546 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80548 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80565 */     GIR_RootConstrainSelectedInstOperands,
     /*  80566 */     // GIR_Coverage, 4706,
     /*  80566 */     GIR_EraseRootFromParent_Done,
     /*  80567 */   // Label 1534: @80567
     /*  80567 */   GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(80645), // Rule ID 4708 //
     /*  80572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80589 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80592 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80611 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  80615 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80619 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHL_qru32),
     /*  80622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80624 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80626 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80628 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80631 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80637 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80643 */     GIR_RootConstrainSelectedInstOperands,
     /*  80644 */     // GIR_Coverage, 4708,
     /*  80644 */     GIR_EraseRootFromParent_Done,
     /*  80645 */   // Label 1535: @80645
     /*  80645 */   GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(80723), // Rule ID 4710 //
     /*  80650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80667 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80670 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80697 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs8),
     /*  80700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80702 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80704 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80706 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80709 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80715 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80721 */     GIR_RootConstrainSelectedInstOperands,
     /*  80722 */     // GIR_Coverage, 4710,
     /*  80722 */     GIR_EraseRootFromParent_Done,
     /*  80723 */   // Label 1536: @80723
     /*  80723 */   GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(80801), // Rule ID 4712 //
     /*  80728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80745 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80748 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80755 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80759 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80775 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs16),
     /*  80778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80780 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80782 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80784 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80787 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80799 */     GIR_RootConstrainSelectedInstOperands,
     /*  80800 */     // GIR_Coverage, 4712,
     /*  80800 */     GIR_EraseRootFromParent_Done,
     /*  80801 */   // Label 1537: @80801
     /*  80801 */   GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(80879), // Rule ID 4714 //
     /*  80806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  80814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  80817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80820 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80823 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80826 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  80853 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qrs32),
     /*  80856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80858 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80860 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80862 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80865 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80871 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80877 */     GIR_RootConstrainSelectedInstOperands,
     /*  80878 */     // GIR_Coverage, 4714,
     /*  80878 */     GIR_EraseRootFromParent_Done,
     /*  80879 */   // Label 1538: @80879
     /*  80879 */   GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(80957), // Rule ID 4716 //
     /*  80884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  80892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  80895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80901 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80904 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  80923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  80927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  80931 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  80931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru8),
     /*  80934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  80936 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  80938 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  80940 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  80943 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  80955 */     GIR_RootConstrainSelectedInstOperands,
     /*  80956 */     // GIR_Coverage, 4716,
     /*  80956 */     GIR_EraseRootFromParent_Done,
     /*  80957 */   // Label 1539: @80957
     /*  80957 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(81035), // Rule ID 4718 //
     /*  80962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  80967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  80970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  80973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  80976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  80979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  80982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  80985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  80993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  80997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81005 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81009 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru16),
     /*  81012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81014 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81016 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81033 */     GIR_RootConstrainSelectedInstOperands,
     /*  81034 */     // GIR_Coverage, 4718,
     /*  81034 */     GIR_EraseRootFromParent_Done,
     /*  81035 */   // Label 1540: @81035
     /*  81035 */   GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(81113), // Rule ID 4720 //
     /*  81040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81057 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81060 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81071 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81075 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  81079 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81083 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81087 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHL_qru32),
     /*  81090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81092 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81094 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81105 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81111 */     GIR_RootConstrainSelectedInstOperands,
     /*  81112 */     // GIR_Coverage, 4720,
     /*  81112 */     GIR_EraseRootFromParent_Done,
     /*  81113 */   // Label 1541: @81113
     /*  81113 */   GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(81191), // Rule ID 4722 //
     /*  81118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81165 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs8),
     /*  81168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81170 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81172 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81183 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81189 */     GIR_RootConstrainSelectedInstOperands,
     /*  81190 */     // GIR_Coverage, 4722,
     /*  81190 */     GIR_EraseRootFromParent_Done,
     /*  81191 */   // Label 1542: @81191
     /*  81191 */   GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(81269), // Rule ID 4724 //
     /*  81196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81213 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81216 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81231 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81239 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81243 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs16),
     /*  81246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81248 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81250 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81252 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81255 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81267 */     GIR_RootConstrainSelectedInstOperands,
     /*  81268 */     // GIR_Coverage, 4724,
     /*  81268 */     GIR_EraseRootFromParent_Done,
     /*  81269 */   // Label 1543: @81269
     /*  81269 */   GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(81347), // Rule ID 4726 //
     /*  81274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81309 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81321 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qrs32),
     /*  81324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81326 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81328 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81333 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81345 */     GIR_RootConstrainSelectedInstOperands,
     /*  81346 */     // GIR_Coverage, 4726,
     /*  81346 */     GIR_EraseRootFromParent_Done,
     /*  81347 */   // Label 1544: @81347
     /*  81347 */   GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(81425), // Rule ID 4728 //
     /*  81352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81366 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81369 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81372 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81387 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81391 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81395 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81399 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru8),
     /*  81402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81404 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81406 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81423 */     GIR_RootConstrainSelectedInstOperands,
     /*  81424 */     // GIR_Coverage, 4728,
     /*  81424 */     GIR_EraseRootFromParent_Done,
     /*  81425 */   // Label 1545: @81425
     /*  81425 */   GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(81503), // Rule ID 4730 //
     /*  81430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81465 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81477 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru16),
     /*  81480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81482 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81484 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81486 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81501 */     GIR_RootConstrainSelectedInstOperands,
     /*  81502 */     // GIR_Coverage, 4730,
     /*  81502 */     GIR_EraseRootFromParent_Done,
     /*  81503 */   // Label 1546: @81503
     /*  81503 */   GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(81581), // Rule ID 4732 //
     /*  81508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81528 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81535 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81539 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  81551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81555 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHL_qru32),
     /*  81558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81560 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81562 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81564 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81567 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81579 */     GIR_RootConstrainSelectedInstOperands,
     /*  81580 */     // GIR_Coverage, 4732,
     /*  81580 */     GIR_EraseRootFromParent_Done,
     /*  81581 */   // Label 1547: @81581
     /*  81581 */   GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(81659), // Rule ID 4734 //
     /*  81586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81600 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81603 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81606 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81633 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs8),
     /*  81636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81638 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81640 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81657 */     GIR_RootConstrainSelectedInstOperands,
     /*  81658 */     // GIR_Coverage, 4734,
     /*  81658 */     GIR_EraseRootFromParent_Done,
     /*  81659 */   // Label 1548: @81659
     /*  81659 */   GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(81737), // Rule ID 4736 //
     /*  81664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81681 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81684 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81699 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81703 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81707 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81711 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs16),
     /*  81714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81716 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81718 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81735 */     GIR_RootConstrainSelectedInstOperands,
     /*  81736 */     // GIR_Coverage, 4736,
     /*  81736 */     GIR_EraseRootFromParent_Done,
     /*  81737 */   // Label 1549: @81737
     /*  81737 */   GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(81815), // Rule ID 4738 //
     /*  81742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81759 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81762 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81781 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81785 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  81789 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHL_qrs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qrs32),
     /*  81792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81794 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81796 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81813 */     GIR_RootConstrainSelectedInstOperands,
     /*  81814 */     // GIR_Coverage, 4738,
     /*  81814 */     GIR_EraseRootFromParent_Done,
     /*  81815 */   // Label 1550: @81815
     /*  81815 */   GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(81893), // Rule ID 4740 //
     /*  81820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  81828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  81831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81837 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81840 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81855 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3669:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru8),
     /*  81870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81872 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81874 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81876 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81879 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81891 */     GIR_RootConstrainSelectedInstOperands,
     /*  81892 */     // GIR_Coverage, 4740,
     /*  81892 */     GIR_EraseRootFromParent_Done,
     /*  81893 */   // Label 1551: @81893
     /*  81893 */   GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(81971), // Rule ID 4742 //
     /*  81898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  81906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  81909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81912 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81915 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81918 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  81929 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  81933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  81937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  81941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  81945 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3669:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  81945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru16),
     /*  81948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  81950 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  81952 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  81954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  81957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  81969 */     GIR_RootConstrainSelectedInstOperands,
     /*  81970 */     // GIR_Coverage, 4742,
     /*  81970 */     GIR_EraseRootFromParent_Done,
     /*  81971 */   // Label 1552: @81971
     /*  81971 */   GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(82049), // Rule ID 4744 //
     /*  81976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshl_scalar),
     /*  81981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  81984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  81987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  81990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  81993 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  81996 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  81999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82007 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  82011 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82015 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  82019 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  82023 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3669:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHL_qru32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$in, rGPR:{ *:[i32] }:$sh)
     /*  82023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHL_qru32),
     /*  82026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  82028 */     GIR_RootToRootCopy, /*OpIdx*/2, // in
     /*  82030 */     GIR_RootToRootCopy, /*OpIdx*/3, // sh
     /*  82032 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82035 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82047 */     GIR_RootConstrainSelectedInstOperands,
     /*  82048 */     // GIR_Coverage, 4744,
     /*  82048 */     GIR_EraseRootFromParent_Done,
     /*  82049 */   // Label 1553: @82049
     /*  82049 */   GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(82185), // Rule ID 2687 //
     /*  82054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx3),
     /*  82062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82071 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82074 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82077 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82084 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3833:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX3Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, (IMPLICIT_DEF:{ *:[v8i8] }), dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82084 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s8,
     /*  82087 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  82091 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  82098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82110 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  82114 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82117 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  82121 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  82128 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82131 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  82134 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82152 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX3Pseudo),
     /*  82165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82167 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  82169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82172 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82177 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82183 */     GIR_RootConstrainSelectedInstOperands,
     /*  82184 */     // GIR_Coverage, 2687,
     /*  82184 */     GIR_EraseRootFromParent_Done,
     /*  82185 */   // Label 1554: @82185
     /*  82185 */   GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(82306), // Rule ID 2688 //
     /*  82190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  82193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbl4),
     /*  82198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  82201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  82204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  82207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  82210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  82213 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  82216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  82220 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3830:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBL4Pseudo:{ *:[v8i8] } (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  82220 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  82223 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  82227 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  82232 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Vn0
     /*  82236 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  82239 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn1
     /*  82243 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  82246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn2
     /*  82250 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  82253 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn3
     /*  82257 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  82260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  82265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82270 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82275 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82280 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  82285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBL4Pseudo),
     /*  82288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  82290 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  82293 */     GIR_RootToRootCopy, /*OpIdx*/6, // Vm
     /*  82295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  82298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82304 */     GIR_RootConstrainSelectedInstOperands,
     /*  82305 */     // GIR_Coverage, 2688,
     /*  82305 */     GIR_EraseRootFromParent_Done,
     /*  82306 */   // Label 1555: @82306
     /*  82306 */   GIM_Reject,
     /*  82307 */ // Label 1493: @82307
     /*  82307 */ GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(87200),
     /*  82312 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/8,
     /*  82315 */   GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(82403), // Rule ID 3178 //
     /*  82320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82323 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82328 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82331 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82334 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82337 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82340 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82343 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82346 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82353 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82357 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82369 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82373 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82377 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs8),
     /*  82380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82382 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82384 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82395 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82401 */     GIR_RootConstrainSelectedInstOperands,
     /*  82402 */     // GIR_Coverage, 3178,
     /*  82402 */     GIR_EraseRootFromParent_Done,
     /*  82403 */   // Label 1557: @82403
     /*  82403 */   GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(82491), // Rule ID 3182 //
     /*  82408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82425 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82428 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82431 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82434 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82445 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82457 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82461 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82465 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs8),
     /*  82468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82470 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82472 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82477 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82489 */     GIR_RootConstrainSelectedInstOperands,
     /*  82490 */     // GIR_Coverage, 3182,
     /*  82490 */     GIR_EraseRootFromParent_Done,
     /*  82491 */   // Label 1558: @82491
     /*  82491 */   GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(82579), // Rule ID 3186 //
     /*  82496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82516 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82519 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  82522 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  82525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82533 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82545 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82549 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82553 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVu8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  82553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /*  82556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82558 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82560 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82565 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82571 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82577 */     GIR_RootConstrainSelectedInstOperands,
     /*  82578 */     // GIR_Coverage, 3186,
     /*  82578 */     GIR_EraseRootFromParent_Done,
     /*  82579 */   // Label 1559: @82579
     /*  82579 */   GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(82667), // Rule ID 3190 //
     /*  82584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82601 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82604 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82607 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82610 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82617 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82621 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82625 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82629 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82633 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82637 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82641 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs16),
     /*  82644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82646 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82648 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82653 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82659 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82665 */     GIR_RootConstrainSelectedInstOperands,
     /*  82666 */     // GIR_Coverage, 3190,
     /*  82666 */     GIR_EraseRootFromParent_Done,
     /*  82667 */   // Label 1560: @82667
     /*  82667 */   GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(82755), // Rule ID 3194 //
     /*  82672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82695 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82698 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82721 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82725 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82729 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs16),
     /*  82732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82734 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82736 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82741 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82747 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82753 */     GIR_RootConstrainSelectedInstOperands,
     /*  82754 */     // GIR_Coverage, 3194,
     /*  82754 */     GIR_EraseRootFromParent_Done,
     /*  82755 */   // Label 1561: @82755
     /*  82755 */   GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(82843), // Rule ID 3198 //
     /*  82760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82763 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82768 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82771 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82774 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82777 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82780 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82783 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  82786 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  82789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  82797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82809 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82813 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82817 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVu16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  82817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /*  82820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82822 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82824 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82829 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82835 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82841 */     GIR_RootConstrainSelectedInstOperands,
     /*  82842 */     // GIR_Coverage, 3198,
     /*  82842 */     GIR_EraseRootFromParent_Done,
     /*  82843 */   // Label 1562: @82843
     /*  82843 */   GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(82931), // Rule ID 3202 //
     /*  82848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82889 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  82893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82897 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82901 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82905 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVs32),
     /*  82908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82910 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  82912 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  82914 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  82917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82923 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  82929 */     GIR_RootConstrainSelectedInstOperands,
     /*  82930 */     // GIR_Coverage, 3202,
     /*  82930 */     GIR_EraseRootFromParent_Done,
     /*  82931 */   // Label 1563: @82931
     /*  82931 */   GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(83019), // Rule ID 3206 //
     /*  82936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  82939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  82944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  82947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  82950 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  82953 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  82956 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  82959 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  82962 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  82965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  82969 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  82973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  82977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  82981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  82985 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82989 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  82993 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  82993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVxs32),
     /*  82996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  82998 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83000 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83005 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83017 */     GIR_RootConstrainSelectedInstOperands,
     /*  83018 */     // GIR_Coverage, 3206,
     /*  83018 */     GIR_EraseRootFromParent_Done,
     /*  83019 */   // Label 1564: @83019
     /*  83019 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(83107), // Rule ID 3210 //
     /*  83024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83027 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83032 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83035 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83041 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83044 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83047 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83050 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83057 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83073 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83077 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83081 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVu32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /*  83084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83086 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83088 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83090 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83093 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83105 */     GIR_RootConstrainSelectedInstOperands,
     /*  83106 */     // GIR_Coverage, 3210,
     /*  83106 */     GIR_EraseRootFromParent_Done,
     /*  83107 */   // Label 1565: @83107
     /*  83107 */   GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(83195), // Rule ID 3214 //
     /*  83112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83115 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83120 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83123 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83126 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83129 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83132 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83135 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83138 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83145 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83149 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83161 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83165 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83169 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs8),
     /*  83172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83174 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83176 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83193 */     GIR_RootConstrainSelectedInstOperands,
     /*  83194 */     // GIR_Coverage, 3214,
     /*  83194 */     GIR_EraseRootFromParent_Done,
     /*  83195 */   // Label 1566: @83195
     /*  83195 */   GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(83283), // Rule ID 3218 //
     /*  83200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83220 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83223 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83226 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83237 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83241 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83249 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83253 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83257 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVxs8:{ *:[i32] } MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs8),
     /*  83260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83262 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83264 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83281 */     GIR_RootConstrainSelectedInstOperands,
     /*  83282 */     // GIR_Coverage, 3218,
     /*  83282 */     GIR_EraseRootFromParent_Done,
     /*  83283 */   // Label 1567: @83283
     /*  83283 */   GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(83371), // Rule ID 3222 //
     /*  83288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83305 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83308 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83311 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83314 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83325 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83337 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83341 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83345 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs16),
     /*  83348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83350 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83352 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83354 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83357 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83369 */     GIR_RootConstrainSelectedInstOperands,
     /*  83370 */     // GIR_Coverage, 3222,
     /*  83370 */     GIR_EraseRootFromParent_Done,
     /*  83371 */   // Label 1568: @83371
     /*  83371 */   GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(83459), // Rule ID 3226 //
     /*  83376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83393 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83396 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83399 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83402 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83425 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83429 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83433 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVxs16:{ *:[i32] } MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs16),
     /*  83436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83438 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83440 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83442 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83445 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83451 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83457 */     GIR_RootConstrainSelectedInstOperands,
     /*  83458 */     // GIR_Coverage, 3226,
     /*  83458 */     GIR_EraseRootFromParent_Done,
     /*  83459 */   // Label 1569: @83459
     /*  83459 */   GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(83547), // Rule ID 3230 //
     /*  83464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83481 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83484 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83487 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83490 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83509 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83513 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83517 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83521 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVs32),
     /*  83524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83526 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83528 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83545 */     GIR_RootConstrainSelectedInstOperands,
     /*  83546 */     // GIR_Coverage, 3230,
     /*  83546 */     GIR_EraseRootFromParent_Done,
     /*  83547 */   // Label 1570: @83547
     /*  83547 */   GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(83635), // Rule ID 3234 //
     /*  83552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83575 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  83578 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  83581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  83593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83597 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  83601 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83605 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83609 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVxs32:{ *:[i32] } MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  83609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVxs32),
     /*  83612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83614 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83616 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83633 */     GIR_RootConstrainSelectedInstOperands,
     /*  83634 */     // GIR_Coverage, 3234,
     /*  83634 */     GIR_EraseRootFromParent_Done,
     /*  83635 */   // Label 1571: @83635
     /*  83635 */   GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(83725), // Rule ID 3180 //
     /*  83640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83685 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83689 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83693 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83697 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas8),
     /*  83700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83702 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83704 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83706 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83723 */     GIR_RootConstrainSelectedInstOperands,
     /*  83724 */     // GIR_Coverage, 3180,
     /*  83724 */     GIR_EraseRootFromParent_Done,
     /*  83725 */   // Label 1572: @83725
     /*  83725 */   GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(83815), // Rule ID 3184 //
     /*  83730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83750 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83753 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83756 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83763 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  83775 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83779 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83783 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83787 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs8),
     /*  83790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83792 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83794 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83796 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83801 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83807 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83813 */     GIR_RootConstrainSelectedInstOperands,
     /*  83814 */     // GIR_Coverage, 3184,
     /*  83814 */     GIR_EraseRootFromParent_Done,
     /*  83815 */   // Label 1573: @83815
     /*  83815 */   GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(83905), // Rule ID 3188 //
     /*  83820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83837 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83840 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83843 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  83846 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  83849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  83857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83865 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83869 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83873 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83877 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLADAVau8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  83877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau8),
     /*  83880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83882 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83884 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83886 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83903 */     GIR_RootConstrainSelectedInstOperands,
     /*  83904 */     // GIR_Coverage, 3188,
     /*  83904 */     GIR_EraseRootFromParent_Done,
     /*  83905 */   // Label 1574: @83905
     /*  83905 */   GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(83995), // Rule ID 3192 //
     /*  83910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  83913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  83918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  83921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  83924 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  83927 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  83930 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  83933 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  83936 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  83939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83943 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  83947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  83951 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  83955 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  83959 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83963 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  83967 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  83967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas16),
     /*  83970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  83972 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  83974 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  83976 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  83978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  83981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  83993 */     GIR_RootConstrainSelectedInstOperands,
     /*  83994 */     // GIR_Coverage, 3192,
     /*  83994 */     GIR_EraseRootFromParent_Done,
     /*  83995 */   // Label 1575: @83995
     /*  83995 */   GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(84085), // Rule ID 3196 //
     /*  84000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84020 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84023 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84026 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84045 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84049 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84053 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84057 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs16),
     /*  84060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84062 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84064 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84066 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84068 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84071 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84077 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84083 */     GIR_RootConstrainSelectedInstOperands,
     /*  84084 */     // GIR_Coverage, 3196,
     /*  84084 */     GIR_EraseRootFromParent_Done,
     /*  84085 */   // Label 1576: @84085
     /*  84085 */   GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(84175), // Rule ID 3200 //
     /*  84090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84107 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84110 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84113 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84116 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84131 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84135 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84139 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84143 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84147 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLADAVau16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau16),
     /*  84150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84152 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84154 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84156 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84161 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84173 */     GIR_RootConstrainSelectedInstOperands,
     /*  84174 */     // GIR_Coverage, 3200,
     /*  84174 */     GIR_EraseRootFromParent_Done,
     /*  84175 */   // Label 1577: @84175
     /*  84175 */   GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(84265), // Rule ID 3204 //
     /*  84180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84183 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84188 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84191 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84194 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84197 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84200 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84203 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84206 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84213 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84217 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84221 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84225 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84229 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84233 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84237 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVas32),
     /*  84240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84242 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84244 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84246 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84263 */     GIR_RootConstrainSelectedInstOperands,
     /*  84264 */     // GIR_Coverage, 3204,
     /*  84264 */     GIR_EraseRootFromParent_Done,
     /*  84265 */   // Label 1578: @84265
     /*  84265 */   GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(84355), // Rule ID 3208 //
     /*  84270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84293 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84296 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84299 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84303 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84307 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84311 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84315 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84319 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84323 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84327 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVaxs32),
     /*  84330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84332 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84334 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84336 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84347 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84353 */     GIR_RootConstrainSelectedInstOperands,
     /*  84354 */     // GIR_Coverage, 3208,
     /*  84354 */     GIR_EraseRootFromParent_Done,
     /*  84355 */   // Label 1579: @84355
     /*  84355 */   GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(84445), // Rule ID 3212 //
     /*  84360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84363 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84368 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84377 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84380 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84383 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84386 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 1,
     /*  84397 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /*  84401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84405 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84409 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84413 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84417 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLADAVau32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVau32),
     /*  84420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84422 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84424 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84426 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84431 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84437 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84443 */     GIR_RootConstrainSelectedInstOperands,
     /*  84444 */     // GIR_Coverage, 3212,
     /*  84444 */     GIR_EraseRootFromParent_Done,
     /*  84445 */   // Label 1580: @84445
     /*  84445 */   GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(84535), // Rule ID 3216 //
     /*  84450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84473 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84476 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84495 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84499 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84503 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84507 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVas8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas8),
     /*  84510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84512 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84514 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84516 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84518 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84521 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84533 */     GIR_RootConstrainSelectedInstOperands,
     /*  84534 */     // GIR_Coverage, 3216,
     /*  84534 */     GIR_EraseRootFromParent_Done,
     /*  84535 */   // Label 1581: @84535
     /*  84535 */   GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(84625), // Rule ID 3220 //
     /*  84540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84560 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84563 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v16s8,
     /*  84566 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v16s8,
     /*  84569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84577 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84581 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84585 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84589 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84593 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84597 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)  =>  (MVE_VMLSDAVaxs8:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v16i8] }:$Qn, MQPR:{ *:[v16i8] }:$Qm)
     /*  84597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs8),
     /*  84600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84602 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84604 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84606 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84611 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84623 */     GIR_RootConstrainSelectedInstOperands,
     /*  84624 */     // GIR_Coverage, 3220,
     /*  84624 */     GIR_EraseRootFromParent_Done,
     /*  84625 */   // Label 1582: @84625
     /*  84625 */   GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(84715), // Rule ID 3224 //
     /*  84630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84647 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84650 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84653 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84656 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84663 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84667 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84675 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84679 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84683 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84687 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVas16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas16),
     /*  84690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84692 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84694 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84696 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84713 */     GIR_RootConstrainSelectedInstOperands,
     /*  84714 */     // GIR_Coverage, 3224,
     /*  84714 */     GIR_EraseRootFromParent_Done,
     /*  84715 */   // Label 1583: @84715
     /*  84715 */   GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(84805), // Rule ID 3228 //
     /*  84720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84737 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84740 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84743 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s16,
     /*  84746 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s16,
     /*  84749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84757 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84761 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84765 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84769 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84773 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84777 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)  =>  (MVE_VMLSDAVaxs16:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v8i16] }:$Qn, MQPR:{ *:[v8i16] }:$Qm)
     /*  84777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs16),
     /*  84780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84782 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84784 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84786 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84791 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84803 */     GIR_RootConstrainSelectedInstOperands,
     /*  84804 */     // GIR_Coverage, 3228,
     /*  84804 */     GIR_EraseRootFromParent_Done,
     /*  84805 */   // Label 1584: @84805
     /*  84805 */   GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(84895), // Rule ID 3232 //
     /*  84810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84827 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84830 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84833 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84836 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84843 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84847 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84851 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /*  84855 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84859 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84863 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84867 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVas32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVas32),
     /*  84870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84872 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84874 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84876 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84881 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84887 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84893 */     GIR_RootConstrainSelectedInstOperands,
     /*  84894 */     // GIR_Coverage, 3232,
     /*  84894 */     GIR_EraseRootFromParent_Done,
     /*  84895 */   // Label 1585: @84895
     /*  84895 */   GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(84985), // Rule ID 3236 //
     /*  84900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /*  84903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vmldava),
     /*  84908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  84911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  84914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  84917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  84920 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  84923 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v4s32,
     /*  84926 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v4s32,
     /*  84929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /*  84937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 1,
     /*  84941 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 1,
     /*  84945 */     GIM_RootCheckRegBankForClass, /*Op*/5, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /*  84949 */     GIM_RootCheckRegBankForClass, /*Op*/6, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84953 */     GIM_RootCheckRegBankForClass, /*Op*/7, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  84957 */     // (intrinsic_wo_chain:{ *:[i32] } 3623:{ *:[iPTR] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)  =>  (MVE_VMLSDAVaxs32:{ *:[i32] } tGPREven:{ *:[i32] }:$RdaSrc, MQPR:{ *:[v4i32] }:$Qn, MQPR:{ *:[v4i32] }:$Qm)
     /*  84957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLSDAVaxs32),
     /*  84960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /*  84962 */     GIR_RootToRootCopy, /*OpIdx*/5, // RdaSrc
     /*  84964 */     GIR_RootToRootCopy, /*OpIdx*/6, // Qn
     /*  84966 */     GIR_RootToRootCopy, /*OpIdx*/7, // Qm
     /*  84968 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  84971 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  84983 */     GIR_RootConstrainSelectedInstOperands,
     /*  84984 */     // GIR_Coverage, 3236,
     /*  84984 */     GIR_EraseRootFromParent_Done,
     /*  84985 */   // Label 1586: @84985
     /*  84985 */   GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(85072), // Rule ID 4332 //
     /*  84990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  84995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  84998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85004 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85007 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85010 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85013 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85024 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85028 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85032 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85036 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85040 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85044 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs8),
     /*  85047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85049 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85051 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85053 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85064 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85070 */     GIR_RootConstrainSelectedInstOperands,
     /*  85071 */     // GIR_Coverage, 4332,
     /*  85071 */     GIR_EraseRootFromParent_Done,
     /*  85072 */   // Label 1587: @85072
     /*  85072 */   GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(85159), // Rule ID 4334 //
     /*  85077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85094 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85097 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85100 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85111 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85115 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85119 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85127 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85131 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs16),
     /*  85134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85136 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85138 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85140 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85151 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85157 */     GIR_RootConstrainSelectedInstOperands,
     /*  85158 */     // GIR_Coverage, 4334,
     /*  85158 */     GIR_EraseRootFromParent_Done,
     /*  85159 */   // Label 1588: @85159
     /*  85159 */   GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(85246), // Rule ID 4336 //
     /*  85164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85181 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85184 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85187 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85202 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85206 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85214 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85218 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHs32),
     /*  85221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85223 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85225 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85227 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85244 */     GIR_RootConstrainSelectedInstOperands,
     /*  85245 */     // GIR_Coverage, 4336,
     /*  85245 */     GIR_EraseRootFromParent_Done,
     /*  85246 */   // Label 1589: @85246
     /*  85246 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(85333), // Rule ID 4338 //
     /*  85251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85265 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85268 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85271 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85274 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85289 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85305 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs8),
     /*  85308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85310 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85312 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85314 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85325 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85331 */     GIR_RootConstrainSelectedInstOperands,
     /*  85332 */     // GIR_Coverage, 4338,
     /*  85332 */     GIR_EraseRootFromParent_Done,
     /*  85333 */   // Label 1590: @85333
     /*  85333 */   GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(85420), // Rule ID 4340 //
     /*  85338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85358 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85361 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85372 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85376 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85392 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs16),
     /*  85395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85397 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85399 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85401 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85406 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85412 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85418 */     GIR_RootConstrainSelectedInstOperands,
     /*  85419 */     // GIR_Coverage, 4340,
     /*  85419 */     GIR_EraseRootFromParent_Done,
     /*  85420 */   // Label 1591: @85420
     /*  85420 */   GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(85507), // Rule ID 4342 //
     /*  85425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85439 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85442 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85445 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85448 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85459 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85463 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85467 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85471 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  85475 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85479 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLADHXs32),
     /*  85482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85484 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85486 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85488 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85499 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85505 */     GIR_RootConstrainSelectedInstOperands,
     /*  85506 */     // GIR_Coverage, 4342,
     /*  85506 */     GIR_EraseRootFromParent_Done,
     /*  85507 */   // Label 1592: @85507
     /*  85507 */   GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(85594), // Rule ID 4344 //
     /*  85512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85526 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85529 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85532 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85535 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85554 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85562 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85566 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs8),
     /*  85569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85571 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85573 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85575 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85592 */     GIR_RootConstrainSelectedInstOperands,
     /*  85593 */     // GIR_Coverage, 4344,
     /*  85593 */     GIR_EraseRootFromParent_Done,
     /*  85594 */   // Label 1593: @85594
     /*  85594 */   GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(85681), // Rule ID 4346 //
     /*  85599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85613 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85616 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85619 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85622 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85645 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85649 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85653 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs16),
     /*  85656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85658 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85660 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85662 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85664 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85667 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85673 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85679 */     GIR_RootConstrainSelectedInstOperands,
     /*  85680 */     // GIR_Coverage, 4346,
     /*  85680 */     GIR_EraseRootFromParent_Done,
     /*  85681 */   // Label 1594: @85681
     /*  85681 */   GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(85768), // Rule ID 4348 //
     /*  85686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85703 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85706 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85709 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85724 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85728 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  85732 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85736 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85740 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  85740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHs32),
     /*  85743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85745 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85747 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85749 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85766 */     GIR_RootConstrainSelectedInstOperands,
     /*  85767 */     // GIR_Coverage, 4348,
     /*  85767 */     GIR_EraseRootFromParent_Done,
     /*  85768 */   // Label 1595: @85768
     /*  85768 */   GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(85855), // Rule ID 4350 //
     /*  85773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  85781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  85784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  85787 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  85790 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85793 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85796 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85803 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85807 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85811 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85815 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85819 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85823 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85827 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  85827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs8),
     /*  85830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85832 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85834 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85836 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85853 */     GIR_RootConstrainSelectedInstOperands,
     /*  85854 */     // GIR_Coverage, 4350,
     /*  85854 */     GIR_EraseRootFromParent_Done,
     /*  85855 */   // Label 1596: @85855
     /*  85855 */   GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(85942), // Rule ID 4352 //
     /*  85860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  85868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  85871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  85874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  85877 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85880 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85883 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85898 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85910 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  85914 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  85914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs16),
     /*  85917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  85919 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  85921 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  85923 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  85925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  85928 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85934 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  85940 */     GIR_RootConstrainSelectedInstOperands,
     /*  85941 */     // GIR_Coverage, 4352,
     /*  85941 */     GIR_EraseRootFromParent_Done,
     /*  85942 */   // Label 1597: @85942
     /*  85942 */   GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(86029), // Rule ID 4354 //
     /*  85947 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  85952 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  85955 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  85958 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  85961 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  85964 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  85967 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  85970 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  85973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85985 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  85989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  85993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  85997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  86001 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRDMLADHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLADHXs32),
     /*  86004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86006 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86008 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86010 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86012 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86015 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86021 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86027 */     GIR_RootConstrainSelectedInstOperands,
     /*  86028 */     // GIR_Coverage, 4354,
     /*  86028 */     GIR_EraseRootFromParent_Done,
     /*  86029 */   // Label 1598: @86029
     /*  86029 */   GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(86116), // Rule ID 4356 //
     /*  86034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86051 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86054 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86057 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86072 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86076 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86080 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86084 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86088 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs8),
     /*  86091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86093 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86095 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86097 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86108 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86114 */     GIR_RootConstrainSelectedInstOperands,
     /*  86115 */     // GIR_Coverage, 4356,
     /*  86115 */     GIR_EraseRootFromParent_Done,
     /*  86116 */   // Label 1599: @86116
     /*  86116 */   GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(86203), // Rule ID 4358 //
     /*  86121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86135 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86138 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86141 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86144 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86159 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86163 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86171 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86175 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs16),
     /*  86178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86180 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86182 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86184 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86189 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86201 */     GIR_RootConstrainSelectedInstOperands,
     /*  86202 */     // GIR_Coverage, 4358,
     /*  86202 */     GIR_EraseRootFromParent_Done,
     /*  86203 */   // Label 1600: @86203
     /*  86203 */   GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(86290), // Rule ID 4360 //
     /*  86208 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86213 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86216 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86219 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86222 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86225 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86228 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86231 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86246 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86250 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86254 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86258 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86262 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHs32),
     /*  86265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86267 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86269 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86271 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86276 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86288 */     GIR_RootConstrainSelectedInstOperands,
     /*  86289 */     // GIR_Coverage, 4360,
     /*  86289 */     GIR_EraseRootFromParent_Done,
     /*  86290 */   // Label 1601: @86290
     /*  86290 */   GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(86377), // Rule ID 4362 //
     /*  86295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86300 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86303 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86306 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86309 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86312 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86315 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86318 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86333 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86345 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86349 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs8),
     /*  86352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86354 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86356 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86358 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86360 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86363 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86369 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86375 */     GIR_RootConstrainSelectedInstOperands,
     /*  86376 */     // GIR_Coverage, 4362,
     /*  86376 */     GIR_EraseRootFromParent_Done,
     /*  86377 */   // Label 1602: @86377
     /*  86377 */   GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(86464), // Rule ID 4364 //
     /*  86382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86399 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86402 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86405 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86416 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86420 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86428 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86432 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86436 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs16),
     /*  86439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86441 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86443 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86445 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86462 */     GIR_RootConstrainSelectedInstOperands,
     /*  86463 */     // GIR_Coverage, 4364,
     /*  86463 */     GIR_EraseRootFromParent_Done,
     /*  86464 */   // Label 1603: @86464
     /*  86464 */   GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(86551), // Rule ID 4366 //
     /*  86469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86480 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86483 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86486 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86489 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86492 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86507 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86511 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86515 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  86519 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86523 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQDMLSDHXs32),
     /*  86526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86528 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86530 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86532 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86537 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86543 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86549 */     GIR_RootConstrainSelectedInstOperands,
     /*  86550 */     // GIR_Coverage, 4366,
     /*  86550 */     GIR_EraseRootFromParent_Done,
     /*  86551 */   // Label 1604: @86551
     /*  86551 */   GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(86638), // Rule ID 4368 //
     /*  86556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86573 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86576 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86579 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86594 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86610 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs8),
     /*  86613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86615 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86617 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86619 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86621 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86624 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86630 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86636 */     GIR_RootConstrainSelectedInstOperands,
     /*  86637 */     // GIR_Coverage, 4368,
     /*  86637 */     GIR_EraseRootFromParent_Done,
     /*  86638 */   // Label 1605: @86638
     /*  86638 */   GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(86725), // Rule ID 4370 //
     /*  86643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86660 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86663 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86666 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86681 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86685 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs16),
     /*  86700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86702 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86704 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86706 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86711 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86717 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86723 */     GIR_RootConstrainSelectedInstOperands,
     /*  86724 */     // GIR_Coverage, 4370,
     /*  86724 */     GIR_EraseRootFromParent_Done,
     /*  86725 */   // Label 1606: @86725
     /*  86725 */   GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(86812), // Rule ID 4372 //
     /*  86730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  86741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  86744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  86747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86753 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86764 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86768 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86772 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  86776 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86780 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86784 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  86784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHs32),
     /*  86787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86789 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86791 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86793 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86798 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86810 */     GIR_RootConstrainSelectedInstOperands,
     /*  86811 */     // GIR_Coverage, 4372,
     /*  86811 */     GIR_EraseRootFromParent_Done,
     /*  86812 */   // Label 1607: @86812
     /*  86812 */   GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(86899), // Rule ID 4374 //
     /*  86817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  86825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  86828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  86831 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /*  86834 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86837 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86840 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86847 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86851 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86855 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86859 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86871 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3632:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$a, MQPR:{ *:[v16i8] }:$b, MQPR:{ *:[v16i8] }:$c)
     /*  86871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs8),
     /*  86874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86876 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86878 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86880 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86897 */     GIR_RootConstrainSelectedInstOperands,
     /*  86898 */     // GIR_Coverage, 4374,
     /*  86898 */     GIR_EraseRootFromParent_Done,
     /*  86899 */   // Label 1608: @86899
     /*  86899 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(86986), // Rule ID 4376 //
     /*  86904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  86912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  86915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  86918 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /*  86921 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  86924 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  86927 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  86930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86942 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  86946 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  86950 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  86954 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  86958 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3632:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$a, MQPR:{ *:[v8i16] }:$b, MQPR:{ *:[v8i16] }:$c)
     /*  86958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs16),
     /*  86961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  86963 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  86965 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  86967 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  86969 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  86972 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86978 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  86984 */     GIR_RootConstrainSelectedInstOperands,
     /*  86985 */     // GIR_Coverage, 4376,
     /*  86985 */     GIR_EraseRootFromParent_Done,
     /*  86986 */   // Label 1609: @86986
     /*  86986 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(87073), // Rule ID 4378 //
     /*  86991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vqdmlad),
     /*  86996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  86999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  87002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  87008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87011 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87014 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87029 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87033 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  87037 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  87041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87045 */     // (intrinsic_wo_chain:{ *:[v4i32] } 3632:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRDMLSDHXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$a, MQPR:{ *:[v4i32] }:$b, MQPR:{ *:[v4i32] }:$c)
     /*  87045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRDMLSDHXs32),
     /*  87048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87050 */     GIR_RootToRootCopy, /*OpIdx*/2, // a
     /*  87052 */     GIR_RootToRootCopy, /*OpIdx*/3, // b
     /*  87054 */     GIR_RootToRootCopy, /*OpIdx*/4, // c
     /*  87056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87059 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87065 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87071 */     GIR_RootConstrainSelectedInstOperands,
     /*  87072 */     // GIR_Coverage, 4378,
     /*  87072 */     GIR_EraseRootFromParent_Done,
     /*  87073 */   // Label 1610: @87073
     /*  87073 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(87199), // Rule ID 2689 //
     /*  87078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  87081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vtbx4),
     /*  87086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /*  87089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  87092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  87095 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /*  87098 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_v8s8,
     /*  87101 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_v8s8,
     /*  87104 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_v8s8,
     /*  87107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  87111 */     // (intrinsic_wo_chain:{ *:[v8i8] } 3834:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$orig, v8i8:{ *:[v8i8] }:$Vn0, v8i8:{ *:[v8i8] }:$Vn1, v8i8:{ *:[v8i8] }:$Vn2, v8i8:{ *:[v8i8] }:$Vn3, v8i8:{ *:[v8i8] }:$Vm)  =>  (VTBX4Pseudo:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$orig, (REG_SEQUENCE:{ *:[v4i64] } QQPR:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn0, dsub_0:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn1, dsub_1:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn2, dsub_2:{ *:[i32] }, v8i8:{ *:[v8i8] }:$Vn3, dsub_3:{ *:[i32] }), v8i8:{ *:[v8i8] }:$Vm)
     /*  87111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s64,
     /*  87114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::REG_SEQUENCE),
     /*  87118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  87123 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Vn0
     /*  87127 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/1,
     /*  87130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/4, // Vn1
     /*  87134 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/2,
     /*  87137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/5, // Vn2
     /*  87141 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/3,
     /*  87144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/6, // Vn3
     /*  87148 */     GIR_AddImm8, /*InsnID*/1, /*SubRegIndex*/4,
     /*  87151 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::QQPRRegClassID),
     /*  87156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/3, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87166 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/5, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87171 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/7, GIMT_Encode2(ARM::DPRRegClassID),
     /*  87176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VTBX4Pseudo),
     /*  87179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  87181 */     GIR_RootToRootCopy, /*OpIdx*/2, // orig
     /*  87183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  87186 */     GIR_RootToRootCopy, /*OpIdx*/7, // Vm
     /*  87188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  87191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87197 */     GIR_RootConstrainSelectedInstOperands,
     /*  87198 */     // GIR_Coverage, 2689,
     /*  87198 */     GIR_EraseRootFromParent_Done,
     /*  87199 */   // Label 1611: @87199
     /*  87199 */   GIM_Reject,
     /*  87200 */ // Label 1556: @87200
     /*  87200 */ GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(91494),
     /*  87205 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/10,
     /*  87208 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vshrn),
     /*  87213 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(87320), // Rule ID 3755 //
     /*  87218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87224 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87227 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87230 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87233 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87236 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87239 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87242 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87265 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87269 */     // MIs[1] Operand 1
     /*  87269 */     // No operand predicates
     /*  87269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87285 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87291 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87296 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87318 */     GIR_RootConstrainSelectedInstOperands,
     /*  87319 */     // GIR_Coverage, 3755,
     /*  87319 */     GIR_EraseRootFromParent_Done,
     /*  87320 */   // Label 1613: @87320
     /*  87320 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(87427), // Rule ID 3757 //
     /*  87325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87340 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87343 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87346 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87349 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87356 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87360 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87372 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87376 */     // MIs[1] Operand 1
     /*  87376 */     // No operand predicates
     /*  87376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87392 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87398 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87403 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87407 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87410 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87413 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87419 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87425 */     GIR_RootConstrainSelectedInstOperands,
     /*  87426 */     // GIR_Coverage, 3757,
     /*  87426 */     GIR_EraseRootFromParent_Done,
     /*  87427 */   // Label 1614: @87427
     /*  87427 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(87534), // Rule ID 3759 //
     /*  87432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87447 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87450 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87453 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87456 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87479 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87483 */     // MIs[1] Operand 1
     /*  87483 */     // No operand predicates
     /*  87483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87499 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87505 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87510 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87514 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87526 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87532 */     GIR_RootConstrainSelectedInstOperands,
     /*  87533 */     // GIR_Coverage, 3759,
     /*  87533 */     GIR_EraseRootFromParent_Done,
     /*  87534 */   // Label 1615: @87534
     /*  87534 */   GIM_Try, /*On fail goto*//*Label 1616*/ GIMT_Encode4(87641), // Rule ID 3761 //
     /*  87539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87554 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87557 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87560 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87563 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87586 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87590 */     // MIs[1] Operand 1
     /*  87590 */     // No operand predicates
     /*  87590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  87602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  87606 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87610 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87612 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  87615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87617 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87639 */     GIR_RootConstrainSelectedInstOperands,
     /*  87640 */     // GIR_Coverage, 3761,
     /*  87640 */     GIR_EraseRootFromParent_Done,
     /*  87641 */   // Label 1616: @87641
     /*  87641 */   GIM_Try, /*On fail goto*//*Label 1617*/ GIMT_Encode4(87748), // Rule ID 3763 //
     /*  87646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87661 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87664 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87667 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87670 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87677 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87681 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87693 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87697 */     // MIs[1] Operand 1
     /*  87697 */     // No operand predicates
     /*  87697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87713 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87717 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87719 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16bh),
     /*  87722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87724 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87728 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87740 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87746 */     GIR_RootConstrainSelectedInstOperands,
     /*  87747 */     // GIR_Coverage, 3763,
     /*  87747 */     GIR_EraseRootFromParent_Done,
     /*  87748 */   // Label 1617: @87748
     /*  87748 */   GIM_Try, /*On fail goto*//*Label 1618*/ GIMT_Encode4(87855), // Rule ID 3765 //
     /*  87753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  87756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  87759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  87762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87765 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87768 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87771 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87774 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87777 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87800 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  87804 */     // MIs[1] Operand 1
     /*  87804 */     // No operand predicates
     /*  87804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87820 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  87824 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87826 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi16th),
     /*  87829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87831 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87835 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87838 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87841 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87847 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87853 */     GIR_RootConstrainSelectedInstOperands,
     /*  87854 */     // GIR_Coverage, 3765,
     /*  87854 */     GIR_EraseRootFromParent_Done,
     /*  87855 */   // Label 1618: @87855
     /*  87855 */   GIM_Try, /*On fail goto*//*Label 1619*/ GIMT_Encode4(87962), // Rule ID 3767 //
     /*  87860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87869 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87872 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87875 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87878 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87881 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87884 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  87903 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  87907 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  87911 */     // MIs[1] Operand 1
     /*  87911 */     // No operand predicates
     /*  87911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  87915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  87919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  87923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  87927 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  87931 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87933 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  87933 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32bh),
     /*  87936 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  87938 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  87940 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  87942 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  87945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  87948 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  87960 */     GIR_RootConstrainSelectedInstOperands,
     /*  87961 */     // GIR_Coverage, 3767,
     /*  87961 */     GIR_EraseRootFromParent_Done,
     /*  87962 */   // Label 1619: @87962
     /*  87962 */   GIM_Try, /*On fail goto*//*Label 1620*/ GIMT_Encode4(88069), // Rule ID 3769 //
     /*  87967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  87970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  87973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  87976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  87979 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  87982 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  87985 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  87988 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  87991 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  87994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  87998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88002 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88014 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88018 */     // MIs[1] Operand 1
     /*  88018 */     // No operand predicates
     /*  88018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88034 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88040 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSHRNi32th),
     /*  88043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88045 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88047 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88049 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88052 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88055 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88061 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88067 */     GIR_RootConstrainSelectedInstOperands,
     /*  88068 */     // GIR_Coverage, 3769,
     /*  88068 */     GIR_EraseRootFromParent_Done,
     /*  88069 */   // Label 1620: @88069
     /*  88069 */   GIM_Try, /*On fail goto*//*Label 1621*/ GIMT_Encode4(88176), // Rule ID 3771 //
     /*  88074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88086 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88089 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88092 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88095 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88098 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88121 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88125 */     // MIs[1] Operand 1
     /*  88125 */     // No operand predicates
     /*  88125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88141 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88147 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88152 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88159 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88162 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88174 */     GIR_RootConstrainSelectedInstOperands,
     /*  88175 */     // GIR_Coverage, 3771,
     /*  88175 */     GIR_EraseRootFromParent_Done,
     /*  88176 */   // Label 1621: @88176
     /*  88176 */   GIM_Try, /*On fail goto*//*Label 1622*/ GIMT_Encode4(88283), // Rule ID 3773 //
     /*  88181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88193 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88196 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88199 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88202 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88205 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88228 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88232 */     // MIs[1] Operand 1
     /*  88232 */     // No operand predicates
     /*  88232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88248 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88252 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88254 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88259 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88263 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88269 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88275 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88281 */     GIR_RootConstrainSelectedInstOperands,
     /*  88282 */     // GIR_Coverage, 3773,
     /*  88282 */     GIR_EraseRootFromParent_Done,
     /*  88283 */   // Label 1622: @88283
     /*  88283 */   GIM_Try, /*On fail goto*//*Label 1623*/ GIMT_Encode4(88390), // Rule ID 3775 //
     /*  88288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88300 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88303 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88306 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88309 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88312 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88335 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88339 */     // MIs[1] Operand 1
     /*  88339 */     // No operand predicates
     /*  88339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88361 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88366 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88370 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88382 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88388 */     GIR_RootConstrainSelectedInstOperands,
     /*  88389 */     // GIR_Coverage, 3775,
     /*  88389 */     GIR_EraseRootFromParent_Done,
     /*  88390 */   // Label 1623: @88390
     /*  88390 */   GIM_Try, /*On fail goto*//*Label 1624*/ GIMT_Encode4(88497), // Rule ID 3777 //
     /*  88395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88413 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88416 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88419 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88446 */     // MIs[1] Operand 1
     /*  88446 */     // No operand predicates
     /*  88446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88462 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88468 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88473 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88475 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88483 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88489 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88495 */     GIR_RootConstrainSelectedInstOperands,
     /*  88496 */     // GIR_Coverage, 3777,
     /*  88496 */     GIR_EraseRootFromParent_Done,
     /*  88497 */   // Label 1624: @88497
     /*  88497 */   GIM_Try, /*On fail goto*//*Label 1625*/ GIMT_Encode4(88604), // Rule ID 3779 //
     /*  88502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88514 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88517 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88520 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88523 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88526 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88529 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88549 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88553 */     // MIs[1] Operand 1
     /*  88553 */     // No operand predicates
     /*  88553 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88557 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88561 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88575 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16bh),
     /*  88578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88580 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88596 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88602 */     GIR_RootConstrainSelectedInstOperands,
     /*  88603 */     // GIR_Coverage, 3779,
     /*  88603 */     GIR_EraseRootFromParent_Done,
     /*  88604 */   // Label 1625: @88604
     /*  88604 */   GIM_Try, /*On fail goto*//*Label 1626*/ GIMT_Encode4(88711), // Rule ID 3781 //
     /*  88609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88618 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88621 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88624 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88627 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88630 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88633 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88656 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88660 */     // MIs[1] Operand 1
     /*  88660 */     // No operand predicates
     /*  88660 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88664 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88668 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88676 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88682 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi16th),
     /*  88685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88687 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88691 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88694 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88697 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88703 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88709 */     GIR_RootConstrainSelectedInstOperands,
     /*  88710 */     // GIR_Coverage, 3781,
     /*  88710 */     GIR_EraseRootFromParent_Done,
     /*  88711 */   // Label 1626: @88711
     /*  88711 */   GIM_Try, /*On fail goto*//*Label 1627*/ GIMT_Encode4(88818), // Rule ID 3783 //
     /*  88716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88725 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88728 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88731 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88734 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88737 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88740 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88751 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88767 */     // MIs[1] Operand 1
     /*  88767 */     // No operand predicates
     /*  88767 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88771 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88779 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  88787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88789 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VRSHRNi32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32bh),
     /*  88792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88794 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88810 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88816 */     GIR_RootConstrainSelectedInstOperands,
     /*  88817 */     // GIR_Coverage, 3783,
     /*  88817 */     GIR_EraseRootFromParent_Done,
     /*  88818 */   // Label 1627: @88818
     /*  88818 */   GIM_Try, /*On fail goto*//*Label 1628*/ GIMT_Encode4(88925), // Rule ID 3785 //
     /*  88823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  88826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  88829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  88832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88841 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88844 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88847 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88870 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  88874 */     // MIs[1] Operand 1
     /*  88874 */     // No operand predicates
     /*  88874 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  88878 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  88882 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  88886 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  88890 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  88894 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88896 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VRSHRNi32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  88896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRSHRNi32th),
     /*  88899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  88901 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  88903 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  88905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  88908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  88911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88917 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88923 */     GIR_RootConstrainSelectedInstOperands,
     /*  88924 */     // GIR_Coverage, 3785,
     /*  88924 */     GIR_EraseRootFromParent_Done,
     /*  88925 */   // Label 1628: @88925
     /*  88925 */   GIM_Try, /*On fail goto*//*Label 1629*/ GIMT_Encode4(89032), // Rule ID 3787 //
     /*  88930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  88933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  88936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  88939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  88942 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  88945 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  88948 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  88951 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  88954 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  88957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  88969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  88973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  88981 */     // MIs[1] Operand 1
     /*  88981 */     // No operand predicates
     /*  88981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  88985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  88989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  88993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  88997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89003 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs16),
     /*  89006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89008 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89018 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89024 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89030 */     GIR_RootConstrainSelectedInstOperands,
     /*  89031 */     // GIR_Coverage, 3787,
     /*  89031 */     GIR_EraseRootFromParent_Done,
     /*  89032 */   // Label 1629: @89032
     /*  89032 */   GIM_Try, /*On fail goto*//*Label 1630*/ GIMT_Encode4(89139), // Rule ID 3789 //
     /*  89037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89046 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89049 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89052 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89055 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89058 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89061 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89072 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89076 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89080 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89084 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89088 */     // MIs[1] Operand 1
     /*  89088 */     // No operand predicates
     /*  89088 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89092 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89096 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89100 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89110 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths16),
     /*  89113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89115 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89131 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89137 */     GIR_RootConstrainSelectedInstOperands,
     /*  89138 */     // GIR_Coverage, 3789,
     /*  89138 */     GIR_EraseRootFromParent_Done,
     /*  89139 */   // Label 1630: @89139
     /*  89139 */   GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(89246), // Rule ID 3791 //
     /*  89144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89153 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89156 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89159 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89162 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89165 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89168 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89191 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89195 */     // MIs[1] Operand 1
     /*  89195 */     // No operand predicates
     /*  89195 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89203 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89207 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89211 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89215 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89217 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhs32),
     /*  89220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89222 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89238 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89244 */     GIR_RootConstrainSelectedInstOperands,
     /*  89245 */     // GIR_Coverage, 3791,
     /*  89245 */     GIR_EraseRootFromParent_Done,
     /*  89246 */   // Label 1631: @89246
     /*  89246 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(89353), // Rule ID 3793 //
     /*  89251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89263 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89266 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89269 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89272 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89275 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89298 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89302 */     // MIs[1] Operand 1
     /*  89302 */     // No operand predicates
     /*  89302 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89310 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89318 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89324 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNths32),
     /*  89327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89329 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89336 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89345 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89351 */     GIR_RootConstrainSelectedInstOperands,
     /*  89352 */     // GIR_Coverage, 3793,
     /*  89352 */     GIR_EraseRootFromParent_Done,
     /*  89353 */   // Label 1632: @89353
     /*  89353 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(89460), // Rule ID 3795 //
     /*  89358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89364 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89367 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89370 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89373 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89376 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89379 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89382 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89405 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89409 */     // MIs[1] Operand 1
     /*  89409 */     // No operand predicates
     /*  89409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89413 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89417 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89425 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89431 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu16),
     /*  89434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89436 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89440 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89443 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89446 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89452 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89458 */     GIR_RootConstrainSelectedInstOperands,
     /*  89459 */     // GIR_Coverage, 3795,
     /*  89459 */     GIR_EraseRootFromParent_Done,
     /*  89460 */   // Label 1633: @89460
     /*  89460 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(89567), // Rule ID 3797 //
     /*  89465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89477 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89480 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89483 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89486 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89489 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89500 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89512 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89516 */     // MIs[1] Operand 1
     /*  89516 */     // No operand predicates
     /*  89516 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89520 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89524 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89528 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89532 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89536 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89538 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu16),
     /*  89541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89543 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89565 */     GIR_RootConstrainSelectedInstOperands,
     /*  89566 */     // GIR_Coverage, 3797,
     /*  89566 */     GIR_EraseRootFromParent_Done,
     /*  89567 */   // Label 1634: @89567
     /*  89567 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(89674), // Rule ID 3799 //
     /*  89572 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89575 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89578 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89581 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89584 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89587 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89590 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89593 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89596 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89619 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89623 */     // MIs[1] Operand 1
     /*  89623 */     // No operand predicates
     /*  89623 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89627 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89631 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89635 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89639 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89645 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNbhu32),
     /*  89648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89650 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89654 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89660 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89666 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89672 */     GIR_RootConstrainSelectedInstOperands,
     /*  89673 */     // GIR_Coverage, 3799,
     /*  89673 */     GIR_EraseRootFromParent_Done,
     /*  89674 */   // Label 1635: @89674
     /*  89674 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(89781), // Rule ID 3801 //
     /*  89679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  89682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  89685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  89688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89691 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89694 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89697 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89700 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89703 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89714 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89726 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  89730 */     // MIs[1] Operand 1
     /*  89730 */     // No operand predicates
     /*  89730 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89734 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  89738 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  89742 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  89746 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89752 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRNthu32),
     /*  89755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89757 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89767 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89773 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89779 */     GIR_RootConstrainSelectedInstOperands,
     /*  89780 */     // GIR_Coverage, 3801,
     /*  89780 */     GIR_EraseRootFromParent_Done,
     /*  89781 */   // Label 1636: @89781
     /*  89781 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(89888), // Rule ID 3803 //
     /*  89786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89798 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89801 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89804 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89807 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89810 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89837 */     // MIs[1] Operand 1
     /*  89837 */     // No operand predicates
     /*  89837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89853 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  89857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89859 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs16),
     /*  89862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89864 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89871 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89880 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89886 */     GIR_RootConstrainSelectedInstOperands,
     /*  89887 */     // GIR_Coverage, 3803,
     /*  89887 */     GIR_EraseRootFromParent_Done,
     /*  89888 */   // Label 1637: @89888
     /*  89888 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(89995), // Rule ID 3805 //
     /*  89893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  89896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  89899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  89902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  89905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  89908 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  89911 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  89914 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  89917 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  89920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  89932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  89936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  89940 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  89944 */     // MIs[1] Operand 1
     /*  89944 */     // No operand predicates
     /*  89944 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  89948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  89952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  89956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  89960 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  89964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89966 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  89966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths16),
     /*  89969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  89971 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  89973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  89975 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  89978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  89981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89987 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89993 */     GIR_RootConstrainSelectedInstOperands,
     /*  89994 */     // GIR_Coverage, 3805,
     /*  89994 */     GIR_EraseRootFromParent_Done,
     /*  89995 */   // Label 1638: @89995
     /*  89995 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(90102), // Rule ID 3807 //
     /*  90000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90012 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90015 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90018 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90021 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90024 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90047 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90051 */     // MIs[1] Operand 1
     /*  90051 */     // No operand predicates
     /*  90051 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90059 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90067 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90071 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90073 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhs32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhs32),
     /*  90076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90078 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90088 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90094 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90100 */     GIR_RootConstrainSelectedInstOperands,
     /*  90101 */     // GIR_Coverage, 3807,
     /*  90101 */     GIR_EraseRootFromParent_Done,
     /*  90102 */   // Label 1639: @90102
     /*  90102 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(90209), // Rule ID 3809 //
     /*  90107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90119 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90122 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90125 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90128 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90131 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90142 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90154 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90158 */     // MIs[1] Operand 1
     /*  90158 */     // No operand predicates
     /*  90158 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90162 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90166 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 0,
     /*  90170 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90174 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90180 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNths32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNths32),
     /*  90183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90185 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90195 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90207 */     GIR_RootConstrainSelectedInstOperands,
     /*  90208 */     // GIR_Coverage, 3809,
     /*  90208 */     GIR_EraseRootFromParent_Done,
     /*  90209 */   // Label 1640: @90209
     /*  90209 */   GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(90316), // Rule ID 3811 //
     /*  90214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90220 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90223 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90226 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90229 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90232 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90235 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90238 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90261 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90265 */     // MIs[1] Operand 1
     /*  90265 */     // No operand predicates
     /*  90265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90277 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90281 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90285 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90287 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu16),
     /*  90290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90292 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90299 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90302 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90308 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90314 */     GIR_RootConstrainSelectedInstOperands,
     /*  90315 */     // GIR_Coverage, 3811,
     /*  90315 */     GIR_EraseRootFromParent_Done,
     /*  90316 */   // Label 1641: @90316
     /*  90316 */   GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(90423), // Rule ID 3813 //
     /*  90321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90330 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90333 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90336 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90339 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90342 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90345 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90356 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90368 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90372 */     // MIs[1] Operand 1
     /*  90372 */     // No operand predicates
     /*  90372 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90376 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90384 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90388 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90394 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu16:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu16),
     /*  90397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90399 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90403 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90406 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90409 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90415 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90421 */     GIR_RootConstrainSelectedInstOperands,
     /*  90422 */     // GIR_Coverage, 3813,
     /*  90422 */     GIR_EraseRootFromParent_Done,
     /*  90423 */   // Label 1642: @90423
     /*  90423 */   GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(90530), // Rule ID 3815 //
     /*  90428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90440 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90443 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90446 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90449 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90452 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90475 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90479 */     // MIs[1] Operand 1
     /*  90479 */     // No operand predicates
     /*  90479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90483 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90491 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90495 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90501 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRNbhu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNbhu32),
     /*  90504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90506 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90510 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90513 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90516 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90522 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90528 */     GIR_RootConstrainSelectedInstOperands,
     /*  90529 */     // GIR_Coverage, 3815,
     /*  90529 */     GIR_EraseRootFromParent_Done,
     /*  90530 */   // Label 1643: @90530
     /*  90530 */   GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(90637), // Rule ID 3817 //
     /*  90535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90547 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90550 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90553 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90556 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90559 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90582 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90586 */     // MIs[1] Operand 1
     /*  90586 */     // No operand predicates
     /*  90586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90590 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  90594 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90598 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 1,
     /*  90602 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90608 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRNthu32:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRNthu32),
     /*  90611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90613 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90620 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90623 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90629 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90635 */     GIR_RootConstrainSelectedInstOperands,
     /*  90636 */     // GIR_Coverage, 3817,
     /*  90636 */     GIR_EraseRootFromParent_Done,
     /*  90637 */   // Label 1644: @90637
     /*  90637 */   GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(90744), // Rule ID 3819 //
     /*  90642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90648 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90651 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90654 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90657 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90660 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90663 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90666 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90673 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90677 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90689 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90693 */     // MIs[1] Operand 1
     /*  90693 */     // No operand predicates
     /*  90693 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90697 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90713 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90715 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16bh),
     /*  90718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90720 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90742 */     GIR_RootConstrainSelectedInstOperands,
     /*  90743 */     // GIR_Coverage, 3819,
     /*  90743 */     GIR_EraseRootFromParent_Done,
     /*  90744 */   // Label 1645: @90744
     /*  90744 */   GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(90851), // Rule ID 3821 //
     /*  90749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  90752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  90755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  90758 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90761 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90764 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90767 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90770 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90773 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90796 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  90800 */     // MIs[1] Operand 1
     /*  90800 */     // No operand predicates
     /*  90800 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90804 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90808 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90812 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90816 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  90820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs16th),
     /*  90825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90827 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90831 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90843 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90849 */     GIR_RootConstrainSelectedInstOperands,
     /*  90850 */     // GIR_Coverage, 3821,
     /*  90850 */     GIR_EraseRootFromParent_Done,
     /*  90851 */   // Label 1646: @90851
     /*  90851 */   GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(90958), // Rule ID 3823 //
     /*  90856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90868 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90871 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90874 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90877 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90880 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90887 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90891 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  90899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  90903 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  90907 */     // MIs[1] Operand 1
     /*  90907 */     // No operand predicates
     /*  90907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  90911 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  90915 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  90919 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  90923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  90927 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90929 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  90929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32bh),
     /*  90932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  90934 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  90936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  90938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  90941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  90944 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90950 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  90956 */     GIR_RootConstrainSelectedInstOperands,
     /*  90957 */     // GIR_Coverage, 3823,
     /*  90957 */     GIR_EraseRootFromParent_Done,
     /*  90958 */   // Label 1647: @90958
     /*  90958 */   GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(91065), // Rule ID 3825 //
     /*  90963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  90966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  90969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  90975 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  90978 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  90981 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  90984 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  90987 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  90990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  90998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91010 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91014 */     // MIs[1] Operand 1
     /*  91014 */     // No operand predicates
     /*  91014 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91018 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  91022 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91026 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91030 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91034 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91036 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSHRUNs32th),
     /*  91039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91041 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91048 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91051 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91057 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91063 */     GIR_RootConstrainSelectedInstOperands,
     /*  91064 */     // GIR_Coverage, 3825,
     /*  91064 */     GIR_EraseRootFromParent_Done,
     /*  91065 */   // Label 1648: @91065
     /*  91065 */   GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(91172), // Rule ID 3827 //
     /*  91070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91079 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91082 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91085 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91088 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91091 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91094 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91117 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91121 */     // MIs[1] Operand 1
     /*  91121 */     // No operand predicates
     /*  91121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91125 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91143 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs16bh:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16bh),
     /*  91146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91148 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91152 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91155 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91164 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91170 */     GIR_RootConstrainSelectedInstOperands,
     /*  91171 */     // GIR_Coverage, 3827,
     /*  91171 */     GIR_EraseRootFromParent_Done,
     /*  91172 */   // Label 1649: @91172
     /*  91172 */   GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(91279), // Rule ID 3829 //
     /*  91177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  91180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  91183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91189 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91192 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91195 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91198 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91201 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91224 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm8),
     /*  91228 */     // MIs[1] Operand 1
     /*  91228 */     // No operand predicates
     /*  91228 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91240 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91248 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91250 */     // (intrinsic_wo_chain:{ *:[v16i8] } 3677:{ *:[iPTR] }, MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm8>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs16th:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$QdSrc, MQPR:{ *:[v8i16] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs16th),
     /*  91253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91255 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91262 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91265 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91277 */     GIR_RootConstrainSelectedInstOperands,
     /*  91278 */     // GIR_Coverage, 3829,
     /*  91278 */     GIR_EraseRootFromParent_Done,
     /*  91279 */   // Label 1650: @91279
     /*  91279 */   GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(91386), // Rule ID 3831 //
     /*  91284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91296 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91299 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91302 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91305 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91308 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91315 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91331 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91335 */     // MIs[1] Operand 1
     /*  91335 */     // No operand predicates
     /*  91335 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91339 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91347 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 0,
     /*  91355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91357 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VQRSHRUNs32bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32bh),
     /*  91360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91362 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91378 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91384 */     GIR_RootConstrainSelectedInstOperands,
     /*  91385 */     // GIR_Coverage, 3831,
     /*  91385 */     GIR_EraseRootFromParent_Done,
     /*  91386 */   // Label 1651: @91386
     /*  91386 */   GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(91493), // Rule ID 3833 //
     /*  91391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  91394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  91400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  91403 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  91406 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  91409 */     GIM_RootCheckType, /*Op*/7, /*Type*/GILLT_s32,
     /*  91412 */     GIM_RootCheckType, /*Op*/8, /*Type*/GILLT_s32,
     /*  91415 */     GIM_RootCheckType, /*Op*/9, /*Type*/GILLT_s32,
     /*  91418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91426 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  91430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /*  91434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91438 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_shr_imm16),
     /*  91442 */     // MIs[1] Operand 1
     /*  91442 */     // No operand predicates
     /*  91442 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  91446 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  91450 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/7, 1,
     /*  91454 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/8, 0,
     /*  91458 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/9, 1,
     /*  91462 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91464 */     // (intrinsic_wo_chain:{ *:[v8i16] } 3677:{ *:[iPTR] }, MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] })<<P:Predicate_shr_imm16>>:$imm, 1:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VQRSHRUNs32th:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$QdSrc, MQPR:{ *:[v4i32] }:$Qm, (imm:{ *:[i32] }):$imm)
     /*  91464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQRSHRUNs32th),
     /*  91467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  91469 */     GIR_RootToRootCopy, /*OpIdx*/2, // QdSrc
     /*  91471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Qm
     /*  91473 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91476 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  91479 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91485 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91491 */     GIR_RootConstrainSelectedInstOperands,
     /*  91492 */     // GIR_Coverage, 3833,
     /*  91492 */     GIR_EraseRootFromParent_Done,
     /*  91493 */   // Label 1652: @91493
     /*  91493 */   GIM_Reject,
     /*  91494 */ // Label 1612: @91494
     /*  91494 */ GIM_Reject,
     /*  91495 */ // Label 15: @91495
     /*  91495 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(91552),
     /*  91500 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /*  91503 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_clrex),
     /*  91508 */   GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(91525), // Rule ID 245 //
     /*  91513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6K_IsARM),
     /*  91516 */     // (intrinsic_void 3462:{ *:[iPTR] })  =>  (CLREX)
     /*  91516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLREX),
     /*  91519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91523 */     GIR_RootConstrainSelectedInstOperands,
     /*  91524 */     // GIR_Coverage, 245,
     /*  91524 */     GIR_EraseRootFromParent_Done,
     /*  91525 */   // Label 1654: @91525
     /*  91525 */   GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(91551), // Rule ID 574 //
     /*  91530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7Clrex_IsThumb),
     /*  91533 */     // (intrinsic_void 3462:{ *:[iPTR] })  =>  (t2CLREX)
     /*  91533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLREX),
     /*  91536 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91549 */     GIR_RootConstrainSelectedInstOperands,
     /*  91550 */     // GIR_Coverage, 574,
     /*  91550 */     GIR_EraseRootFromParent_Done,
     /*  91551 */   // Label 1655: @91551
     /*  91551 */   GIM_Reject,
     /*  91552 */ // Label 1653: @91552
     /*  91552 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(92354),
     /*  91557 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /*  91560 */   GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(91596), // Rule ID 344 //
     /*  91565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsWindows),
     /*  91568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91573 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91576 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/1, GIMT_Encode8(249),
     /*  91587 */     // (intrinsic_void 3903:{ *:[iPTR] }, 249:{ *:[i32] })  =>  (t__brkdiv0)
     /*  91587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t__brkdiv0),
     /*  91590 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  91594 */     GIR_RootConstrainSelectedInstOperands,
     /*  91595 */     // GIR_Coverage, 344,
     /*  91595 */     GIR_EraseRootFromParent_Done,
     /*  91596 */   // Label 1657: @91596
     /*  91596 */   GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(91648), // Rule ID 2 //
     /*  91601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  91604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91609 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91620 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  91624 */     // MIs[1] Operand 1
     /*  91624 */     // No operand predicates
     /*  91624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91626 */     // (intrinsic_void 3480:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /*  91626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::HINT),
     /*  91629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91632 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91635 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91641 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91646 */     GIR_RootConstrainSelectedInstOperands,
     /*  91647 */     // GIR_Coverage, 2,
     /*  91647 */     GIR_EraseRootFromParent_Done,
     /*  91648 */   // Label 1658: @91648
     /*  91648 */   GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(91700), // Rule ID 10 //
     /*  91653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV7_IsARM),
     /*  91656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  91661 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91672 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91676 */     // MIs[1] Operand 1
     /*  91676 */     // No operand predicates
     /*  91676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91678 */     // (intrinsic_void 3475:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DBG (imm:{ *:[i32] }):$opt)
     /*  91678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DBG),
     /*  91681 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91684 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91687 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91693 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91698 */     GIR_RootConstrainSelectedInstOperands,
     /*  91699 */     // GIR_Coverage, 10,
     /*  91699 */     GIR_EraseRootFromParent_Done,
     /*  91700 */   // Label 1659: @91700
     /*  91700 */   GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(91743), // Rule ID 11 //
     /*  91705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  91708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91713 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91724 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91728 */     // MIs[1] Operand 1
     /*  91728 */     // No operand predicates
     /*  91728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91730 */     // (intrinsic_void 3903:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (UDF (imm:{ *:[i32] }):$imm16)
     /*  91730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /*  91733 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  91736 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91741 */     GIR_RootConstrainSelectedInstOperands,
     /*  91742 */     // GIR_Coverage, 11,
     /*  91742 */     GIR_EraseRootFromParent_Done,
     /*  91743 */   // Label 1660: @91743
     /*  91743 */   GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(91786), // Rule ID 228 //
     /*  91748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  91756 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91767 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91771 */     // MIs[1] Operand 1
     /*  91771 */     // No operand predicates
     /*  91771 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91773 */     // (intrinsic_void 3476:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DMB (imm:{ *:[i32] }):$opt)
     /*  91773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DMB),
     /*  91776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91784 */     GIR_RootConstrainSelectedInstOperands,
     /*  91785 */     // GIR_Coverage, 228,
     /*  91785 */     GIR_EraseRootFromParent_Done,
     /*  91786 */   // Label 1661: @91786
     /*  91786 */   GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(91829), // Rule ID 229 //
     /*  91791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  91799 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91810 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91814 */     // MIs[1] Operand 1
     /*  91814 */     // No operand predicates
     /*  91814 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91816 */     // (intrinsic_void 3477:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (DSB (imm:{ *:[i32] }):$opt)
     /*  91816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::DSB),
     /*  91819 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91827 */     GIR_RootConstrainSelectedInstOperands,
     /*  91828 */     // GIR_Coverage, 229,
     /*  91828 */     GIR_EraseRootFromParent_Done,
     /*  91829 */   // Label 1662: @91829
     /*  91829 */   GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(91872), // Rule ID 230 //
     /*  91834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsARM),
     /*  91837 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  91842 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91853 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91857 */     // MIs[1] Operand 1
     /*  91857 */     // No operand predicates
     /*  91857 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91859 */     // (intrinsic_void 3481:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (ISB (imm:{ *:[i32] }):$opt)
     /*  91859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::ISB),
     /*  91862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  91865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91870 */     GIR_RootConstrainSelectedInstOperands,
     /*  91871 */     // GIR_Coverage, 230,
     /*  91871 */     GIR_EraseRootFromParent_Done,
     /*  91872 */   // Label 1663: @91872
     /*  91872 */   GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(91924), // Rule ID 276 //
     /*  91877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6M_IsThumb),
     /*  91880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  91885 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91888 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91892 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91896 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  91900 */     // MIs[1] Operand 1
     /*  91900 */     // No operand predicates
     /*  91900 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91902 */     // (intrinsic_void 3480:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$imm)  =>  (tHINT (imm:{ *:[i32] }):$imm)
     /*  91902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tHINT),
     /*  91905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  91908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  91911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  91917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91922 */     GIR_RootConstrainSelectedInstOperands,
     /*  91923 */     // GIR_Coverage, 276,
     /*  91923 */     GIR_EraseRootFromParent_Done,
     /*  91924 */   // Label 1664: @91924
     /*  91924 */   GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(91967), // Rule ID 343 //
     /*  91929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /*  91932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91937 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91948 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /*  91952 */     // MIs[1] Operand 1
     /*  91952 */     // No operand predicates
     /*  91952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91954 */     // (intrinsic_void 3903:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$imm8)  =>  (tUDF (imm:{ *:[i32] }):$imm8)
     /*  91954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /*  91957 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm8
     /*  91960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  91965 */     GIR_RootConstrainSelectedInstOperands,
     /*  91966 */     // GIR_Coverage, 343,
     /*  91966 */     GIR_EraseRootFromParent_Done,
     /*  91967 */   // Label 1665: @91967
     /*  91967 */   GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(92010), // Rule ID 494 //
     /*  91972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  91975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_undefined),
     /*  91980 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  91983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  91991 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  91995 */     // MIs[1] Operand 1
     /*  91995 */     // No operand predicates
     /*  91995 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91997 */     // (intrinsic_void 3903:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm16)  =>  (t2UDF (imm:{ *:[i32] }):$imm16)
     /*  91997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UDF),
     /*  92000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm16
     /*  92003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92008 */     GIR_RootConstrainSelectedInstOperands,
     /*  92009 */     // GIR_Coverage, 494,
     /*  92009 */     GIR_EraseRootFromParent_Done,
     /*  92010 */   // Label 1666: @92010
     /*  92010 */   GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(92062), // Rule ID 559 //
     /*  92015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dmb),
     /*  92023 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92034 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92038 */     // MIs[1] Operand 1
     /*  92038 */     // No operand predicates
     /*  92038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92040 */     // (intrinsic_void 3476:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DMB (imm:{ *:[i32] }):$opt)
     /*  92040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DMB),
     /*  92043 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92046 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92060 */     GIR_RootConstrainSelectedInstOperands,
     /*  92061 */     // GIR_Coverage, 559,
     /*  92061 */     GIR_EraseRootFromParent_Done,
     /*  92062 */   // Label 1667: @92062
     /*  92062 */   GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(92114), // Rule ID 560 //
     /*  92067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dsb),
     /*  92075 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92086 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92090 */     // MIs[1] Operand 1
     /*  92090 */     // No operand predicates
     /*  92090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92092 */     // (intrinsic_void 3477:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DSB (imm:{ *:[i32] }):$opt)
     /*  92092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DSB),
     /*  92095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92101 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92112 */     GIR_RootConstrainSelectedInstOperands,
     /*  92113 */     // GIR_Coverage, 560,
     /*  92113 */     GIR_EraseRootFromParent_Done,
     /*  92114 */   // Label 1668: @92114
     /*  92114 */   GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(92166), // Rule ID 561 //
     /*  92119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDB_IsThumb),
     /*  92122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_isb),
     /*  92127 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92138 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92142 */     // MIs[1] Operand 1
     /*  92142 */     // No operand predicates
     /*  92142 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92144 */     // (intrinsic_void 3481:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2ISB (imm:{ *:[i32] }):$opt)
     /*  92144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ISB),
     /*  92147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92150 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92153 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92159 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92164 */     GIR_RootConstrainSelectedInstOperands,
     /*  92165 */     // GIR_Coverage, 561,
     /*  92165 */     GIR_EraseRootFromParent_Done,
     /*  92166 */   // Label 1669: @92166
     /*  92166 */   GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(92218), // Rule ID 579 //
     /*  92171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_hint),
     /*  92179 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92182 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92186 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92190 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_239),
     /*  92194 */     // MIs[1] Operand 1
     /*  92194 */     // No operand predicates
     /*  92194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92196 */     // (intrinsic_void 3480:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_239>>:$imm)  =>  (t2HINT (imm:{ *:[i32] }):$imm)
     /*  92196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2HINT),
     /*  92199 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /*  92202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92205 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92216 */     GIR_RootConstrainSelectedInstOperands,
     /*  92217 */     // GIR_Coverage, 579,
     /*  92217 */     GIR_EraseRootFromParent_Done,
     /*  92218 */   // Label 1670: @92218
     /*  92218 */   GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(92270), // Rule ID 580 //
     /*  92223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  92226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_dbg),
     /*  92231 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92242 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /*  92246 */     // MIs[1] Operand 1
     /*  92246 */     // No operand predicates
     /*  92246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92248 */     // (intrinsic_void 3475:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_15>>:$opt)  =>  (t2DBG (imm:{ *:[i32] }):$opt)
     /*  92248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DBG),
     /*  92251 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // opt
     /*  92254 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92257 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92263 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92268 */     GIR_RootConstrainSelectedInstOperands,
     /*  92269 */     // GIR_Coverage, 580,
     /*  92269 */     GIR_EraseRootFromParent_Done,
     /*  92270 */   // Label 1671: @92270
     /*  92270 */   GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(92310), // Rule ID 722 //
     /*  92275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_get_fpscr),
     /*  92283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92290 */     // (intrinsic_w_chain:{ *:[i32] } 3478:{ *:[iPTR] })  =>  (VMRS:{ *:[i32] })
     /*  92290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /*  92293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /*  92295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92298 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92304 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92308 */     GIR_RootConstrainSelectedInstOperands,
     /*  92309 */     // GIR_Coverage, 722,
     /*  92309 */     GIR_EraseRootFromParent_Done,
     /*  92310 */   // Label 1672: @92310
     /*  92310 */   GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(92353), // Rule ID 723 //
     /*  92315 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs),
     /*  92318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_set_fpscr),
     /*  92323 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  92326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92330 */     // (intrinsic_void 3847:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /*  92330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /*  92333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rt
     /*  92335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92338 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92344 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /*  92347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92351 */     GIR_RootConstrainSelectedInstOperands,
     /*  92352 */     // GIR_Coverage, 723,
     /*  92352 */     GIR_EraseRootFromParent_Done,
     /*  92353 */   // Label 1673: @92353
     /*  92353 */   GIM_Reject,
     /*  92354 */ // Label 1656: @92354
     /*  92354 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(92397), // Rule ID 604 //
     /*  92359 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLOB_HasV8_1MMainline_IsThumb2),
     /*  92362 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  92365 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::start_loop_iterations),
     /*  92370 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRlrRegClassID),
     /*  92380 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  92384 */   // (intrinsic_w_chain:{ *:[i32] } 344:{ *:[iPTR] }, rGPR:{ *:[i32] }:$tc)  =>  (t2DoLoopStart:{ *:[i32] } rGPR:{ *:[i32] }:$tc)
     /*  92384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2DoLoopStart),
     /*  92387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[X]
     /*  92389 */   GIR_RootToRootCopy, /*OpIdx*/2, // tc
     /*  92391 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92395 */   GIR_RootConstrainSelectedInstOperands,
     /*  92396 */   // GIR_Coverage, 604,
     /*  92396 */   GIR_EraseRootFromParent_Done,
     /*  92397 */ // Label 1674: @92397
     /*  92397 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(94388),
     /*  92402 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /*  92405 */   GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(92459), // Rule ID 5048 //
     /*  92410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92428 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92440 */     // MIs[1] Operand 1
     /*  92440 */     // No operand predicates
     /*  92440 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92442 */     // (intrinsic_w_chain:{ *:[v4i32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92447 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92457 */     GIR_RootConstrainSelectedInstOperands,
     /*  92458 */     // GIR_Coverage, 5048,
     /*  92458 */     GIR_EraseRootFromParent_Done,
     /*  92459 */   // Label 1676: @92459
     /*  92459 */   GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(92513), // Rule ID 5054 //
     /*  92464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  92472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  92475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92494 */     // MIs[1] Operand 1
     /*  92494 */     // No operand predicates
     /*  92494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92496 */     // (intrinsic_w_chain:{ *:[v4f32] } 3611:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRWU32_qi:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_qi),
     /*  92499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92501 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92506 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92511 */     GIR_RootConstrainSelectedInstOperands,
     /*  92512 */     // GIR_Coverage, 5054,
     /*  92512 */     GIR_EraseRootFromParent_Done,
     /*  92513 */   // Label 1677: @92513
     /*  92513 */   GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(92567), // Rule ID 5056 //
     /*  92518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92548 */     // MIs[1] Operand 1
     /*  92548 */     // No operand predicates
     /*  92548 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92550 */     // (intrinsic_w_chain:{ *:[v2i64] } 3611:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92555 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92557 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92565 */     GIR_RootConstrainSelectedInstOperands,
     /*  92566 */     // GIR_Coverage, 5056,
     /*  92566 */     GIR_EraseRootFromParent_Done,
     /*  92567 */   // Label 1678: @92567
     /*  92567 */   GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(92621), // Rule ID 5058 //
     /*  92572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_base),
     /*  92577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  92580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  92583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92594 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  92598 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92602 */     // MIs[1] Operand 1
     /*  92602 */     // No operand predicates
     /*  92602 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92604 */     // (intrinsic_w_chain:{ *:[v2f64] } 3611:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)  =>  (MVE_VLDRDU64_qi:{ *:[v2f64] } MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_qi),
     /*  92607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  92609 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  92611 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92614 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92619 */     GIR_RootConstrainSelectedInstOperands,
     /*  92620 */     // GIR_Coverage, 5058,
     /*  92620 */     GIR_EraseRootFromParent_Done,
     /*  92621 */   // Label 1679: @92621
     /*  92621 */   GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(92663), // Rule ID 1738 //
     /*  92626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_space),
     /*  92631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92641 */     // MIs[0] size
     /*  92641 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  92644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92648 */     // (intrinsic_w_chain:{ *:[i32] } 3878:{ *:[iPTR] }, (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)  =>  (SPACE:{ *:[i32] } (timm:{ *:[i32] }):$size, GPR:{ *:[i32] }:$Rn)
     /*  92648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SPACE),
     /*  92651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92653 */     GIR_RootToRootCopy, /*OpIdx*/2, // size
     /*  92655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /*  92657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92661 */     GIR_RootConstrainSelectedInstOperands,
     /*  92662 */     // GIR_Coverage, 1738,
     /*  92662 */     GIR_EraseRootFromParent_Done,
     /*  92663 */   // Label 1680: @92663
     /*  92663 */   GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(92717), // Rule ID 5050 //
     /*  92668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92673 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92694 */     // MIs[1] Operand 1
     /*  92694 */     // No operand predicates
     /*  92694 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92700 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92703 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92705 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92710 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92715 */     GIR_RootConstrainSelectedInstOperands,
     /*  92716 */     // GIR_Coverage, 5050,
     /*  92716 */     GIR_EraseRootFromParent_Done,
     /*  92717 */   // Label 1681: @92717
     /*  92717 */   GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(92771), // Rule ID 5060 //
     /*  92722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92727 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  92730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  92736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92748 */     // MIs[1] Operand 1
     /*  92748 */     // No operand predicates
     /*  92748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92754 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi),
     /*  92757 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92759 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92761 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92769 */     GIR_RootConstrainSelectedInstOperands,
     /*  92770 */     // GIR_Coverage, 5060,
     /*  92770 */     GIR_EraseRootFromParent_Done,
     /*  92771 */   // Label 1682: @92771
     /*  92771 */   GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(92825), // Rule ID 5064 //
     /*  92776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92781 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92802 */     // MIs[1] Operand 1
     /*  92802 */     // No operand predicates
     /*  92802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92808 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92811 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92813 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92818 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92823 */     GIR_RootConstrainSelectedInstOperands,
     /*  92824 */     // GIR_Coverage, 5064,
     /*  92824 */     GIR_EraseRootFromParent_Done,
     /*  92825 */   // Label 1683: @92825
     /*  92825 */   GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(92879), // Rule ID 5068 //
     /*  92830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base),
     /*  92835 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  92838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  92844 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92848 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92852 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  92856 */     // MIs[1] Operand 1
     /*  92856 */     // No operand predicates
     /*  92856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  92860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92862 */     // (intrinsic_void 3685:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  92862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi),
     /*  92865 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  92867 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /*  92869 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  92872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  92877 */     GIR_RootConstrainSelectedInstOperands,
     /*  92878 */     // GIR_Coverage, 5068,
     /*  92878 */     GIR_EraseRootFromParent_Done,
     /*  92879 */   // Label 1684: @92879
     /*  92879 */   GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(92937), // Rule ID 3 //
     /*  92884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /*  92887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  92892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  92913 */     // (intrinsic_w_chain:{ *:[i32] } 3846:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  92913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SEL),
     /*  92916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92931 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92935 */     GIR_RootConstrainSelectedInstOperands,
     /*  92936 */     // GIR_Coverage, 3,
     /*  92936 */     GIR_EraseRootFromParent_Done,
     /*  92937 */   // Label 1685: @92937
     /*  92937 */   GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(92995), // Rule ID 121 //
     /*  92942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  92945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  92950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  92953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  92956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  92959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92967 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  92971 */     // (intrinsic_w_chain:{ *:[i32] } 3845:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  92971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SASX),
     /*  92974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  92978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  92980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  92983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  92989 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  92993 */     GIR_RootConstrainSelectedInstOperands,
     /*  92994 */     // GIR_Coverage, 121,
     /*  92994 */     GIR_EraseRootFromParent_Done,
     /*  92995 */   // Label 1686: @92995
     /*  92995 */   GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(93053), // Rule ID 122 //
     /*  93000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93029 */     // (intrinsic_w_chain:{ *:[i32] } 3843:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD16),
     /*  93032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93038 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93041 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93051 */     GIR_RootConstrainSelectedInstOperands,
     /*  93052 */     // GIR_Coverage, 122,
     /*  93052 */     GIR_EraseRootFromParent_Done,
     /*  93053 */   // Label 1687: @93053
     /*  93053 */   GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(93111), // Rule ID 123 //
     /*  93058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93087 */     // (intrinsic_w_chain:{ *:[i32] } 3844:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SADD8),
     /*  93090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93099 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93105 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93109 */     GIR_RootConstrainSelectedInstOperands,
     /*  93110 */     // GIR_Coverage, 123,
     /*  93110 */     GIR_EraseRootFromParent_Done,
     /*  93111 */   // Label 1688: @93111
     /*  93111 */   GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(93169), // Rule ID 124 //
     /*  93116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93119 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93124 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93127 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93130 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93145 */     // (intrinsic_w_chain:{ *:[i32] } 3881:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSAX),
     /*  93148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93157 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93167 */     GIR_RootConstrainSelectedInstOperands,
     /*  93168 */     // GIR_Coverage, 124,
     /*  93168 */     GIR_EraseRootFromParent_Done,
     /*  93169 */   // Label 1689: @93169
     /*  93169 */   GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(93227), // Rule ID 125 //
     /*  93174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93203 */     // (intrinsic_w_chain:{ *:[i32] } 3882:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB16),
     /*  93206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93215 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93221 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93225 */     GIR_RootConstrainSelectedInstOperands,
     /*  93226 */     // GIR_Coverage, 125,
     /*  93226 */     GIR_EraseRootFromParent_Done,
     /*  93227 */   // Label 1690: @93227
     /*  93227 */   GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(93285), // Rule ID 126 //
     /*  93232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93235 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93240 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93261 */     // (intrinsic_w_chain:{ *:[i32] } 3883:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (SSUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SSUB8),
     /*  93264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93270 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93279 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93283 */     GIR_RootConstrainSelectedInstOperands,
     /*  93284 */     // GIR_Coverage, 126,
     /*  93284 */     GIR_EraseRootFromParent_Done,
     /*  93285 */   // Label 1691: @93285
     /*  93285 */   GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(93343), // Rule ID 127 //
     /*  93290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  93298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93304 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93311 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93319 */     // (intrinsic_w_chain:{ *:[i32] } 3896:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UASX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UASX),
     /*  93322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93328 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93331 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93341 */     GIR_RootConstrainSelectedInstOperands,
     /*  93342 */     // GIR_Coverage, 127,
     /*  93342 */     GIR_EraseRootFromParent_Done,
     /*  93343 */   // Label 1692: @93343
     /*  93343 */   GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(93401), // Rule ID 128 //
     /*  93348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  93356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93377 */     // (intrinsic_w_chain:{ *:[i32] } 3894:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD16),
     /*  93380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93399 */     GIR_RootConstrainSelectedInstOperands,
     /*  93400 */     // GIR_Coverage, 128,
     /*  93400 */     GIR_EraseRootFromParent_Done,
     /*  93401 */   // Label 1693: @93401
     /*  93401 */   GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(93459), // Rule ID 129 //
     /*  93406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  93414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93435 */     // (intrinsic_w_chain:{ *:[i32] } 3895:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (UADD8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UADD8),
     /*  93438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93447 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93457 */     GIR_RootConstrainSelectedInstOperands,
     /*  93458 */     // GIR_Coverage, 129,
     /*  93458 */     GIR_EraseRootFromParent_Done,
     /*  93459 */   // Label 1694: @93459
     /*  93459 */   GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(93517), // Rule ID 130 //
     /*  93464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  93472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93493 */     // (intrinsic_w_chain:{ *:[i32] } 3914:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USAX:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USAX),
     /*  93496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93505 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93515 */     GIR_RootConstrainSelectedInstOperands,
     /*  93516 */     // GIR_Coverage, 130,
     /*  93516 */     GIR_EraseRootFromParent_Done,
     /*  93517 */   // Label 1695: @93517
     /*  93517 */   GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(93575), // Rule ID 131 //
     /*  93522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  93530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93551 */     // (intrinsic_w_chain:{ *:[i32] } 3915:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB16:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB16),
     /*  93554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93573 */     GIR_RootConstrainSelectedInstOperands,
     /*  93574 */     // GIR_Coverage, 131,
     /*  93574 */     GIR_EraseRootFromParent_Done,
     /*  93575 */   // Label 1696: @93575
     /*  93575 */   GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(93633), // Rule ID 132 //
     /*  93580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  93583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  93588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  93609 */     // (intrinsic_w_chain:{ *:[i32] } 3916:{ *:[iPTR] }, GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)  =>  (USUB8:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rn, GPRnopc:{ *:[i32] }:$Rm)
     /*  93609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::USUB8),
     /*  93612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93618 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93621 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93631 */     GIR_RootConstrainSelectedInstOperands,
     /*  93632 */     // GIR_Coverage, 132,
     /*  93632 */     GIR_EraseRootFromParent_Done,
     /*  93633 */   // Label 1697: @93633
     /*  93633 */   GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(93691), // Rule ID 431 //
     /*  93638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sel),
     /*  93646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  93667 */     // (intrinsic_w_chain:{ *:[i32] } 3846:{ *:[iPTR] }, GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (t2SEL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /*  93667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SEL),
     /*  93670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93679 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93685 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93689 */     GIR_RootConstrainSelectedInstOperands,
     /*  93690 */     // GIR_Coverage, 431,
     /*  93690 */     GIR_EraseRootFromParent_Done,
     /*  93691 */   // Label 1698: @93691
     /*  93691 */   GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(93749), // Rule ID 444 //
     /*  93696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sasx),
     /*  93704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93725 */     // (intrinsic_w_chain:{ *:[i32] } 3845:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SASX),
     /*  93728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93734 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93737 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93747 */     GIR_RootConstrainSelectedInstOperands,
     /*  93748 */     // GIR_Coverage, 444,
     /*  93748 */     GIR_EraseRootFromParent_Done,
     /*  93749 */   // Label 1699: @93749
     /*  93749 */   GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(93807), // Rule ID 445 //
     /*  93754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93757 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd16),
     /*  93762 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93765 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93768 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93771 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93783 */     // (intrinsic_w_chain:{ *:[i32] } 3843:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD16),
     /*  93786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93795 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93801 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93805 */     GIR_RootConstrainSelectedInstOperands,
     /*  93806 */     // GIR_Coverage, 445,
     /*  93806 */     GIR_EraseRootFromParent_Done,
     /*  93807 */   // Label 1700: @93807
     /*  93807 */   GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(93865), // Rule ID 446 //
     /*  93812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_sadd8),
     /*  93820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93841 */     // (intrinsic_w_chain:{ *:[i32] } 3844:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SADD8),
     /*  93844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93850 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93853 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93859 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93863 */     GIR_RootConstrainSelectedInstOperands,
     /*  93864 */     // GIR_Coverage, 446,
     /*  93864 */     GIR_EraseRootFromParent_Done,
     /*  93865 */   // Label 1701: @93865
     /*  93865 */   GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(93923), // Rule ID 447 //
     /*  93870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93873 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssax),
     /*  93878 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93881 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93884 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93899 */     // (intrinsic_w_chain:{ *:[i32] } 3881:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSAX),
     /*  93902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93908 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93917 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93921 */     GIR_RootConstrainSelectedInstOperands,
     /*  93922 */     // GIR_Coverage, 447,
     /*  93922 */     GIR_EraseRootFromParent_Done,
     /*  93923 */   // Label 1702: @93923
     /*  93923 */   GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(93981), // Rule ID 448 //
     /*  93928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub16),
     /*  93936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  93942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  93945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  93957 */     // (intrinsic_w_chain:{ *:[i32] } 3882:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  93957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB16),
     /*  93960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  93962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  93964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  93966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  93969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  93975 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  93979 */     GIR_RootConstrainSelectedInstOperands,
     /*  93980 */     // GIR_Coverage, 448,
     /*  93980 */     GIR_EraseRootFromParent_Done,
     /*  93981 */   // Label 1703: @93981
     /*  93981 */   GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(94039), // Rule ID 449 //
     /*  93986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  93989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_ssub8),
     /*  93994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  93997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94000 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94015 */     // (intrinsic_w_chain:{ *:[i32] } 3883:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SSUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SSUB8),
     /*  94018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94024 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94027 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94033 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94037 */     GIR_RootConstrainSelectedInstOperands,
     /*  94038 */     // GIR_Coverage, 449,
     /*  94038 */     GIR_EraseRootFromParent_Done,
     /*  94039 */   // Label 1704: @94039
     /*  94039 */   GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(94097), // Rule ID 450 //
     /*  94044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uasx),
     /*  94052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94073 */     // (intrinsic_w_chain:{ *:[i32] } 3896:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UASX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UASX),
     /*  94076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94085 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94091 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94095 */     GIR_RootConstrainSelectedInstOperands,
     /*  94096 */     // GIR_Coverage, 450,
     /*  94096 */     GIR_EraseRootFromParent_Done,
     /*  94097 */   // Label 1705: @94097
     /*  94097 */   GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(94155), // Rule ID 451 //
     /*  94102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd16),
     /*  94110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94127 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94131 */     // (intrinsic_w_chain:{ *:[i32] } 3894:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD16),
     /*  94134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94153 */     GIR_RootConstrainSelectedInstOperands,
     /*  94154 */     // GIR_Coverage, 451,
     /*  94154 */     GIR_EraseRootFromParent_Done,
     /*  94155 */   // Label 1706: @94155
     /*  94155 */   GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(94213), // Rule ID 452 //
     /*  94160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_uadd8),
     /*  94168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94181 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94185 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94189 */     // (intrinsic_w_chain:{ *:[i32] } 3895:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2UADD8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2UADD8),
     /*  94192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94198 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94201 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94211 */     GIR_RootConstrainSelectedInstOperands,
     /*  94212 */     // GIR_Coverage, 452,
     /*  94212 */     GIR_EraseRootFromParent_Done,
     /*  94213 */   // Label 1707: @94213
     /*  94213 */   GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(94271), // Rule ID 453 //
     /*  94218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usax),
     /*  94226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94247 */     // (intrinsic_w_chain:{ *:[i32] } 3914:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USAX:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USAX),
     /*  94250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94259 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94269 */     GIR_RootConstrainSelectedInstOperands,
     /*  94270 */     // GIR_Coverage, 453,
     /*  94270 */     GIR_EraseRootFromParent_Done,
     /*  94271 */   // Label 1708: @94271
     /*  94271 */   GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(94329), // Rule ID 454 //
     /*  94276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub16),
     /*  94284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94301 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94305 */     // (intrinsic_w_chain:{ *:[i32] } 3915:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB16:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB16),
     /*  94308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94323 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94327 */     GIR_RootConstrainSelectedInstOperands,
     /*  94328 */     // GIR_Coverage, 454,
     /*  94328 */     GIR_EraseRootFromParent_Done,
     /*  94329 */   // Label 1709: @94329
     /*  94329 */   GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(94387), // Rule ID 455 //
     /*  94334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /*  94337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_usub8),
     /*  94342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  94345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  94348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94359 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  94363 */     // (intrinsic_w_chain:{ *:[i32] } 3916:{ *:[iPTR] }, rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2USUB8:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /*  94363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2USUB8),
     /*  94366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  94368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  94370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /*  94372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  94375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  94381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94385 */     GIR_RootConstrainSelectedInstOperands,
     /*  94386 */     // GIR_Coverage, 455,
     /*  94386 */     GIR_EraseRootFromParent_Done,
     /*  94387 */   // Label 1710: @94387
     /*  94387 */   GIM_Reject,
     /*  94388 */ // Label 1675: @94388
     /*  94388 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(94634),
     /*  94393 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /*  94396 */   GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_base_wb),
     /*  94401 */   GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(94459), // Rule ID 5052 //
     /*  94406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94415 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94434 */     // MIs[1] Operand 1
     /*  94434 */     // No operand predicates
     /*  94434 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94438 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94440 */     // (intrinsic_w_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4i32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94445 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94447 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94457 */     GIR_RootConstrainSelectedInstOperands,
     /*  94458 */     // GIR_Coverage, 5052,
     /*  94458 */     GIR_EraseRootFromParent_Done,
     /*  94459 */   // Label 1712: @94459
     /*  94459 */   GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(94517), // Rule ID 5062 //
     /*  94464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  94467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94473 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /*  94476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94492 */     // MIs[1] Operand 1
     /*  94492 */     // No operand predicates
     /*  94492 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94496 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94498 */     // (intrinsic_w_chain:{ *:[v4i32] } 3687:{ *:[iPTR] }, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v4f32] }:$data)  =>  (MVE_VSTRW32_qi_pre:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$data, MQPR:{ *:[v4i32] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_qi_pre),
     /*  94501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94503 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94505 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94515 */     GIR_RootConstrainSelectedInstOperands,
     /*  94516 */     // GIR_Coverage, 5062,
     /*  94516 */     GIR_EraseRootFromParent_Done,
     /*  94517 */   // Label 1713: @94517
     /*  94517 */   GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(94575), // Rule ID 5066 //
     /*  94522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94528 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94531 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94550 */     // MIs[1] Operand 1
     /*  94550 */     // No operand predicates
     /*  94550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94556 */     // (intrinsic_w_chain:{ *:[v2i64] } 3687:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2i64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2i64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94561 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94563 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94565 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94568 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94573 */     GIR_RootConstrainSelectedInstOperands,
     /*  94574 */     // GIR_Coverage, 5066,
     /*  94574 */     GIR_EraseRootFromParent_Done,
     /*  94575 */   // Label 1714: @94575
     /*  94575 */   GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(94633), // Rule ID 5070 //
     /*  94580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  94583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  94586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  94589 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /*  94592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /*  94604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  94608 */     // MIs[1] Operand 1
     /*  94608 */     // No operand predicates
     /*  94608 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94612 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94614 */     // (intrinsic_w_chain:{ *:[v2i64] } 3687:{ *:[iPTR] }, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset, MQPR:{ *:[v2f64] }:$data)  =>  (MVE_VSTRD64_qi_pre:{ *:[v2i64] } MQPR:{ *:[v2f64] }:$data, MQPR:{ *:[v2i64] }:$addr, (imm:{ *:[i32] }):$offset)
     /*  94614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_qi_pre),
     /*  94617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[wb]
     /*  94619 */     GIR_RootToRootCopy, /*OpIdx*/4, // data
     /*  94621 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /*  94623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // offset
     /*  94626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  94631 */     GIR_RootConstrainSelectedInstOperands,
     /*  94632 */     // GIR_Coverage, 5070,
     /*  94632 */     GIR_EraseRootFromParent_Done,
     /*  94633 */   // Label 1715: @94633
     /*  94633 */   GIM_Reject,
     /*  94634 */ // Label 1711: @94634
     /*  94634 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(95805),
     /*  94639 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /*  94642 */   GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(94703), // Rule ID 4940 //
     /*  94647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94661 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94664 */     // MIs[0] base
     /*  94664 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94668 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94680 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94684 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94688 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94691 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94693 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94695 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94701 */     GIR_RootConstrainSelectedInstOperands,
     /*  94702 */     // GIR_Coverage, 4940,
     /*  94702 */     GIR_EraseRootFromParent_Done,
     /*  94703 */   // Label 1717: @94703
     /*  94703 */   GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(94764), // Rule ID 4941 //
     /*  94708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94719 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94722 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94725 */     // MIs[0] base
     /*  94725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  94749 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  94752 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94754 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94756 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94758 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94762 */     GIR_RootConstrainSelectedInstOperands,
     /*  94763 */     // GIR_Coverage, 4941,
     /*  94763 */     GIR_EraseRootFromParent_Done,
     /*  94764 */   // Label 1718: @94764
     /*  94764 */   GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(94825), // Rule ID 4944 //
     /*  94769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  94777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  94780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94783 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94786 */     // MIs[0] base
     /*  94786 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94802 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94806 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94810 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, MQPR:{ *:[v16i8] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB8_rq MQPR:{ *:[v16i8] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  94810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB8_rq),
     /*  94813 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94815 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94817 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94823 */     GIR_RootConstrainSelectedInstOperands,
     /*  94824 */     // GIR_Coverage, 4944,
     /*  94824 */     GIR_EraseRootFromParent_Done,
     /*  94825 */   // Label 1719: @94825
     /*  94825 */   GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(94886), // Rule ID 5024 //
     /*  94830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94835 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94838 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94841 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94844 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94847 */     // MIs[0] base
     /*  94847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94851 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94855 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94859 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94863 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94867 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94871 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8i16] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB16_rq MQPR:{ *:[v8i16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB16_rq),
     /*  94874 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94876 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94878 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94884 */     GIR_RootConstrainSelectedInstOperands,
     /*  94885 */     // GIR_Coverage, 5024,
     /*  94885 */     GIR_EraseRootFromParent_Done,
     /*  94886 */   // Label 1720: @94886
     /*  94886 */   GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(94947), // Rule ID 5026 //
     /*  94891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  94899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  94902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94905 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94908 */     // MIs[0] base
     /*  94908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94920 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94924 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  94928 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94932 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 8:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRB32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  94932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRB32_rq),
     /*  94935 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94937 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  94939 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  94941 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  94945 */     GIR_RootConstrainSelectedInstOperands,
     /*  94946 */     // GIR_Coverage, 5026,
     /*  94946 */     GIR_EraseRootFromParent_Done,
     /*  94947 */   // Label 1721: @94947
     /*  94947 */   GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(95008), // Rule ID 5028 //
     /*  94952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  94957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  94960 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  94963 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  94966 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  94969 */     // MIs[0] base
     /*  94969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  94973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  94977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  94985 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  94989 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  94993 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH16_rq_u MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  94993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq_u),
     /*  94996 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  94998 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95000 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95006 */     GIR_RootConstrainSelectedInstOperands,
     /*  95007 */     // GIR_Coverage, 5028,
     /*  95007 */     GIR_EraseRootFromParent_Done,
     /*  95008 */   // Label 1722: @95008
     /*  95008 */   GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(95069), // Rule ID 5029 //
     /*  95013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  95021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  95024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95027 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95030 */     // MIs[0] base
     /*  95030 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95046 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95050 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95054 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, MQPR:{ *:[v8f16] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH16_rq MQPR:{ *:[v8f16] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  95054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH16_rq),
     /*  95057 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95059 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95061 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95067 */     GIR_RootConstrainSelectedInstOperands,
     /*  95068 */     // GIR_Coverage, 5029,
     /*  95068 */     GIR_EraseRootFromParent_Done,
     /*  95069 */   // Label 1723: @95069
     /*  95069 */   GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(95130), // Rule ID 5032 //
     /*  95074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95088 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95091 */     // MIs[0] base
     /*  95091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95107 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95115 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRH32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq_u),
     /*  95118 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95120 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95122 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95124 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95128 */     GIR_RootConstrainSelectedInstOperands,
     /*  95129 */     // GIR_Coverage, 5032,
     /*  95129 */     GIR_EraseRootFromParent_Done,
     /*  95130 */   // Label 1724: @95130
     /*  95130 */   GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(95191), // Rule ID 5033 //
     /*  95135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95152 */     // MIs[0] base
     /*  95152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95156 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95168 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  95172 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  95176 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 16:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VSTRH32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRH32_rq),
     /*  95179 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95181 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95183 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95185 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95189 */     GIR_RootConstrainSelectedInstOperands,
     /*  95190 */     // GIR_Coverage, 5033,
     /*  95190 */     GIR_EraseRootFromParent_Done,
     /*  95191 */   // Label 1725: @95191
     /*  95191 */   GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(95252), // Rule ID 5036 //
     /*  95196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95210 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95213 */     // MIs[0] base
     /*  95213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95237 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95240 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95242 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95244 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95250 */     GIR_RootConstrainSelectedInstOperands,
     /*  95251 */     // GIR_Coverage, 5036,
     /*  95251 */     GIR_EraseRootFromParent_Done,
     /*  95252 */   // Label 1726: @95252
     /*  95252 */   GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(95313), // Rule ID 5037 //
     /*  95257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95274 */     // MIs[0] base
     /*  95274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95282 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95286 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95294 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95298 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4i32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4i32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95301 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95303 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95305 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95307 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95311 */     GIR_RootConstrainSelectedInstOperands,
     /*  95312 */     // GIR_Coverage, 5037,
     /*  95312 */     GIR_EraseRootFromParent_Done,
     /*  95313 */   // Label 1727: @95313
     /*  95313 */   GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(95374), // Rule ID 5040 //
     /*  95318 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95332 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95335 */     // MIs[0] base
     /*  95335 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95351 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95355 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95359 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRW32_rq_u MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq_u),
     /*  95362 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95364 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95366 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95368 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95372 */     GIR_RootConstrainSelectedInstOperands,
     /*  95373 */     // GIR_Coverage, 5040,
     /*  95373 */     GIR_EraseRootFromParent_Done,
     /*  95374 */   // Label 1728: @95374
     /*  95374 */   GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(95435), // Rule ID 5041 //
     /*  95379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  95387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  95390 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95393 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95396 */     // MIs[0] base
     /*  95396 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95412 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  95416 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  95420 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, MQPR:{ *:[v4f32] }:$data, 32:{ *:[i32] }, 2:{ *:[i32] })  =>  (MVE_VSTRW32_rq MQPR:{ *:[v4f32] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  95420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRW32_rq),
     /*  95423 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95425 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95427 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95429 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95433 */     GIR_RootConstrainSelectedInstOperands,
     /*  95434 */     // GIR_Coverage, 5041,
     /*  95434 */     GIR_EraseRootFromParent_Done,
     /*  95435 */   // Label 1729: @95435
     /*  95435 */   GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(95496), // Rule ID 5044 //
     /*  95440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95448 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95451 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95454 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95457 */     // MIs[0] base
     /*  95457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95469 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  95481 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VSTRD64_rq_u MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq_u),
     /*  95484 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95486 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95488 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95494 */     GIR_RootConstrainSelectedInstOperands,
     /*  95495 */     // GIR_Coverage, 5044,
     /*  95495 */     GIR_EraseRootFromParent_Done,
     /*  95496 */   // Label 1730: @95496
     /*  95496 */   GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(95557), // Rule ID 5045 //
     /*  95501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mve_vstr_scatter_offset),
     /*  95506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  95509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  95512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  95518 */     // MIs[0] base
     /*  95518 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/32,
     /*  95522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95530 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  95534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  95538 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  95542 */     // (intrinsic_void 3689:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, MQPR:{ *:[v2i64] }:$data, 64:{ *:[i32] }, 3:{ *:[i32] })  =>  (MVE_VSTRD64_rq MQPR:{ *:[v2i64] }:$data, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  95542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSTRD64_rq),
     /*  95545 */     GIR_RootToRootCopy, /*OpIdx*/3, // data
     /*  95547 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /*  95549 */     GIR_RootToRootCopy, /*OpIdx*/2, // offsets
     /*  95551 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95555 */     GIR_RootConstrainSelectedInstOperands,
     /*  95556 */     // GIR_Coverage, 5045,
     /*  95556 */     GIR_EraseRootFromParent_Done,
     /*  95557 */   // Label 1731: @95557
     /*  95557 */   GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(95621), // Rule ID 258 //
     /*  95562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  95565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95573 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95576 */     // MIs[0] cop
     /*  95576 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95579 */     // MIs[0] opc1
     /*  95579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95582 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95586 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95590 */     // MIs[0] CRm
     /*  95590 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95593 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR),
     /*  95596 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95598 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95604 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95615 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95619 */     GIR_RootConstrainSelectedInstOperands,
     /*  95620 */     // GIR_Coverage, 258,
     /*  95620 */     GIR_EraseRootFromParent_Done,
     /*  95621 */   // Label 1732: @95621
     /*  95621 */   GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(95676), // Rule ID 259 //
     /*  95626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95640 */     // MIs[0] cop
     /*  95640 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95643 */     // MIs[0] opc1
     /*  95643 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95646 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95650 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /*  95654 */     // MIs[0] CRm
     /*  95654 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95657 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPRnopc:{ *:[i32] }:$Rt, GPRnopc:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCRR2),
     /*  95660 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95662 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95668 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95670 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95674 */     GIR_RootConstrainSelectedInstOperands,
     /*  95675 */     // GIR_Coverage, 259,
     /*  95675 */     GIR_EraseRootFromParent_Done,
     /*  95676 */   // Label 1733: @95676
     /*  95676 */   GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(95740), // Rule ID 596 //
     /*  95681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  95684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr),
     /*  95689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95695 */     // MIs[0] cop
     /*  95695 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95698 */     // MIs[0] opc1
     /*  95698 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95701 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95705 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95709 */     // MIs[0] CRm
     /*  95709 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95712 */     // (intrinsic_void 3492:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR),
     /*  95715 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95717 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95723 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95738 */     GIR_RootConstrainSelectedInstOperands,
     /*  95739 */     // GIR_Coverage, 596,
     /*  95739 */     GIR_EraseRootFromParent_Done,
     /*  95740 */   // Label 1734: @95740
     /*  95740 */   GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(95804), // Rule ID 597 //
     /*  95745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcrr2),
     /*  95753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  95756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  95759 */     // MIs[0] cop
     /*  95759 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95762 */     // MIs[0] opc1
     /*  95762 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95769 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  95773 */     // MIs[0] CRm
     /*  95773 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95776 */     // (intrinsic_void 3493:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)  =>  (t2MCRR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, GPR:{ *:[i32] }:$Rt2, (timm:{ *:[i32] }):$CRm)
     /*  95776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCRR2),
     /*  95779 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95781 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  95785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rt2
     /*  95787 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95802 */     GIR_RootConstrainSelectedInstOperands,
     /*  95803 */     // GIR_Coverage, 597,
     /*  95803 */     GIR_EraseRootFromParent_Done,
     /*  95804 */   // Label 1735: @95804
     /*  95804 */   GIM_Reject,
     /*  95805 */ // Label 1716: @95805
     /*  95805 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(99156),
     /*  95810 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/7,
     /*  95813 */   GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(95874), // Rule ID 246 //
     /*  95818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95826 */     // MIs[0] cop
     /*  95826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95829 */     // MIs[0] opc1
     /*  95829 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95832 */     // MIs[0] CRd
     /*  95832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95835 */     // MIs[0] CRn
     /*  95835 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95838 */     // MIs[0] CRm
     /*  95838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95841 */     // MIs[0] opc2
     /*  95841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95844 */     // (intrinsic_void 3460:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP),
     /*  95847 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95849 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95851 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95853 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95855 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95857 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95868 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95872 */     GIR_RootConstrainSelectedInstOperands,
     /*  95873 */     // GIR_Coverage, 246,
     /*  95873 */     GIR_EraseRootFromParent_Done,
     /*  95874 */   // Label 1737: @95874
     /*  95874 */   GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(95926), // Rule ID 247 //
     /*  95879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  95882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  95887 */     // MIs[0] cop
     /*  95887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95890 */     // MIs[0] opc1
     /*  95890 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95893 */     // MIs[0] CRd
     /*  95893 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95896 */     // MIs[0] CRn
     /*  95896 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95899 */     // MIs[0] CRm
     /*  95899 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95902 */     // MIs[0] opc2
     /*  95902 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95905 */     // (intrinsic_void 3461:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CDP2),
     /*  95908 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95910 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95912 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95914 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95916 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95918 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95924 */     GIR_RootConstrainSelectedInstOperands,
     /*  95925 */     // GIR_Coverage, 247,
     /*  95925 */     GIR_EraseRootFromParent_Done,
     /*  95926 */   // Label 1738: @95926
     /*  95926 */   GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(95987), // Rule ID 598 //
     /*  95931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp),
     /*  95939 */     // MIs[0] cop
     /*  95939 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  95942 */     // MIs[0] opc1
     /*  95942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  95945 */     // MIs[0] CRd
     /*  95945 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  95948 */     // MIs[0] CRn
     /*  95948 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  95951 */     // MIs[0] CRm
     /*  95951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  95954 */     // MIs[0] opc2
     /*  95954 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  95957 */     // (intrinsic_void 3460:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  95957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP),
     /*  95960 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  95962 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  95964 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  95966 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  95968 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  95970 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  95972 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  95975 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  95981 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  95985 */     GIR_RootConstrainSelectedInstOperands,
     /*  95986 */     // GIR_Coverage, 598,
     /*  95986 */     GIR_EraseRootFromParent_Done,
     /*  95987 */   // Label 1739: @95987
     /*  95987 */   GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(96048), // Rule ID 599 //
     /*  95992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  95995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_cdp2),
     /*  96000 */     // MIs[0] cop
     /*  96000 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  96003 */     // MIs[0] opc1
     /*  96003 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  96006 */     // MIs[0] CRd
     /*  96006 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /*  96009 */     // MIs[0] CRn
     /*  96009 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  96012 */     // MIs[0] CRm
     /*  96012 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  96015 */     // MIs[0] opc2
     /*  96015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  96018 */     // (intrinsic_void 3461:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2CDP2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, (timm:{ *:[i32] }):$CRd, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  96018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CDP2),
     /*  96021 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  96023 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  96025 */     GIR_RootToRootCopy, /*OpIdx*/3, // CRd
     /*  96027 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  96029 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  96031 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  96033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  96036 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  96042 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96046 */     GIR_RootConstrainSelectedInstOperands,
     /*  96047 */     // GIR_Coverage, 599,
     /*  96047 */     GIR_EraseRootFromParent_Done,
     /*  96048 */   // Label 1740: @96048
     /*  96048 */   GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(96116), // Rule ID 4934 //
     /*  96053 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96058 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96067 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96070 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96077 */     // MIs[0] base
     /*  96077 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96081 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96089 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96093 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96097 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96101 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96106 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96108 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96110 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96114 */     GIR_RootConstrainSelectedInstOperands,
     /*  96115 */     // GIR_Coverage, 4934,
     /*  96115 */     GIR_EraseRootFromParent_Done,
     /*  96116 */   // Label 1741: @96116
     /*  96116 */   GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(96184), // Rule ID 4935 //
     /*  96121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96138 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96145 */     // MIs[0] base
     /*  96145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96157 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96161 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96165 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96169 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96174 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96176 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96178 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96182 */     GIR_RootConstrainSelectedInstOperands,
     /*  96183 */     // GIR_Coverage, 4935,
     /*  96183 */     GIR_EraseRootFromParent_Done,
     /*  96184 */   // Label 1742: @96184
     /*  96184 */   GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(96252), // Rule ID 4938 //
     /*  96189 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96194 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96203 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96206 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96213 */     // MIs[0] base
     /*  96213 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96221 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96225 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96229 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96237 */     // (intrinsic_w_chain:{ *:[v16i8] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96242 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96244 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96246 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96250 */     GIR_RootConstrainSelectedInstOperands,
     /*  96251 */     // GIR_Coverage, 4938,
     /*  96251 */     GIR_EraseRootFromParent_Done,
     /*  96252 */   // Label 1743: @96252
     /*  96252 */   GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(96320), // Rule ID 4946 //
     /*  96257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /*  96265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  96268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96271 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96274 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96281 */     // MIs[0] base
     /*  96281 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96297 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96301 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96305 */     // (intrinsic_w_chain:{ *:[v16i8] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBU8_rq:{ *:[v16i8] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v16i8] }:$offsets)
     /*  96305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU8_rq),
     /*  96308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96310 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96312 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96318 */     GIR_RootConstrainSelectedInstOperands,
     /*  96319 */     // GIR_Coverage, 4946,
     /*  96319 */     GIR_EraseRootFromParent_Done,
     /*  96320 */   // Label 1744: @96320
     /*  96320 */   GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(96388), // Rule ID 4948 //
     /*  96325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96339 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96342 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96349 */     // MIs[0] base
     /*  96349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96361 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96369 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96373 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU16_rq),
     /*  96376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96378 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96380 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96386 */     GIR_RootConstrainSelectedInstOperands,
     /*  96387 */     // GIR_Coverage, 4948,
     /*  96387 */     GIR_EraseRootFromParent_Done,
     /*  96388 */   // Label 1745: @96388
     /*  96388 */   GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(96456), // Rule ID 4950 //
     /*  96393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96407 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96410 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96417 */     // MIs[0] base
     /*  96417 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96425 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96429 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96437 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96441 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS16_rq),
     /*  96444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96446 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96448 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96454 */     GIR_RootConstrainSelectedInstOperands,
     /*  96455 */     // GIR_Coverage, 4950,
     /*  96455 */     GIR_EraseRootFromParent_Done,
     /*  96456 */   // Label 1746: @96456
     /*  96456 */   GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(96524), // Rule ID 4952 //
     /*  96461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96478 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96485 */     // MIs[0] base
     /*  96485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96497 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96501 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96509 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRBU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBU32_rq),
     /*  96512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96514 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96516 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96522 */     GIR_RootConstrainSelectedInstOperands,
     /*  96523 */     // GIR_Coverage, 4952,
     /*  96523 */     GIR_EraseRootFromParent_Done,
     /*  96524 */   // Label 1747: @96524
     /*  96524 */   GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(96592), // Rule ID 4954 //
     /*  96529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  96537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  96540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96543 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96546 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96553 */     // MIs[0] base
     /*  96553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96565 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 8,
     /*  96569 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96573 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96577 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 8:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRBS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  96577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRBS32_rq),
     /*  96580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96582 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96584 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96590 */     GIR_RootConstrainSelectedInstOperands,
     /*  96591 */     // GIR_Coverage, 4954,
     /*  96591 */     GIR_EraseRootFromParent_Done,
     /*  96592 */   // Label 1748: @96592
     /*  96592 */   GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(96660), // Rule ID 4956 //
     /*  96597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96614 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96621 */     // MIs[0] base
     /*  96621 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96625 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96629 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96637 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96641 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96645 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96650 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96652 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96654 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96658 */     GIR_RootConstrainSelectedInstOperands,
     /*  96659 */     // GIR_Coverage, 4956,
     /*  96659 */     GIR_EraseRootFromParent_Done,
     /*  96660 */   // Label 1749: @96660
     /*  96660 */   GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(96728), // Rule ID 4957 //
     /*  96665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96682 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96689 */     // MIs[0] base
     /*  96689 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96701 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96705 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96713 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96718 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96720 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96726 */     GIR_RootConstrainSelectedInstOperands,
     /*  96727 */     // GIR_Coverage, 4957,
     /*  96727 */     GIR_EraseRootFromParent_Done,
     /*  96728 */   // Label 1750: @96728
     /*  96728 */   GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(96796), // Rule ID 4960 //
     /*  96733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96747 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96750 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96757 */     // MIs[0] base
     /*  96757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96769 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96773 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96777 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96781 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96786 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96788 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96794 */     GIR_RootConstrainSelectedInstOperands,
     /*  96795 */     // GIR_Coverage, 4960,
     /*  96795 */     GIR_EraseRootFromParent_Done,
     /*  96796 */   // Label 1751: @96796
     /*  96796 */   GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(96864), // Rule ID 4961 //
     /*  96801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96815 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96818 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96825 */     // MIs[0] base
     /*  96825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96837 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96841 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  96849 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96854 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96856 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96858 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96862 */     GIR_RootConstrainSelectedInstOperands,
     /*  96863 */     // GIR_Coverage, 4961,
     /*  96863 */     GIR_EraseRootFromParent_Done,
     /*  96864 */   // Label 1752: @96864
     /*  96864 */   GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(96932), // Rule ID 4964 //
     /*  96869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96883 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96886 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96893 */     // MIs[0] base
     /*  96893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96901 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96909 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  96913 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96917 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96922 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96924 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96926 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96930 */     GIR_RootConstrainSelectedInstOperands,
     /*  96931 */     // GIR_Coverage, 4964,
     /*  96931 */     GIR_EraseRootFromParent_Done,
     /*  96932 */   // Label 1753: @96932
     /*  96932 */   GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(97000), // Rule ID 4965 //
     /*  96937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  96942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  96945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  96948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  96951 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  96954 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  96957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96961 */     // MIs[0] base
     /*  96961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  96965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  96969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  96973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  96977 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  96981 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  96985 */     // (intrinsic_w_chain:{ *:[v8i16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8i16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  96985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  96988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  96990 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  96992 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  96994 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  96998 */     GIR_RootConstrainSelectedInstOperands,
     /*  96999 */     // GIR_Coverage, 4965,
     /*  96999 */     GIR_EraseRootFromParent_Done,
     /*  97000 */   // Label 1754: @97000
     /*  97000 */   GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(97068), // Rule ID 4968 //
     /*  97005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97019 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97022 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97029 */     // MIs[0] base
     /*  97029 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97037 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97041 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97045 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97049 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97053 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97058 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97060 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97066 */     GIR_RootConstrainSelectedInstOperands,
     /*  97067 */     // GIR_Coverage, 4968,
     /*  97067 */     GIR_EraseRootFromParent_Done,
     /*  97068 */   // Label 1755: @97068
     /*  97068 */   GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(97136), // Rule ID 4969 //
     /*  97073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97087 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97090 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97097 */     // MIs[0] base
     /*  97097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97109 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97113 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97121 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97126 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97128 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97134 */     GIR_RootConstrainSelectedInstOperands,
     /*  97135 */     // GIR_Coverage, 4969,
     /*  97135 */     GIR_EraseRootFromParent_Done,
     /*  97136 */   // Label 1756: @97136
     /*  97136 */   GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(97204), // Rule ID 4972 //
     /*  97141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97155 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97158 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97165 */     // MIs[0] base
     /*  97165 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97185 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97189 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq_u:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq_u),
     /*  97192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97194 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97196 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97198 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97202 */     GIR_RootConstrainSelectedInstOperands,
     /*  97203 */     // GIR_Coverage, 4972,
     /*  97203 */     GIR_EraseRootFromParent_Done,
     /*  97204 */   // Label 1757: @97204
     /*  97204 */   GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(97272), // Rule ID 4973 //
     /*  97209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /*  97217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  97220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97223 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97226 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97233 */     // MIs[0] base
     /*  97233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97237 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97245 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97253 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97257 */     // (intrinsic_w_chain:{ *:[v8f16] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU16_rq:{ *:[v8f16] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v8i16] }:$offsets)
     /*  97257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU16_rq),
     /*  97260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97262 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97264 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97270 */     GIR_RootConstrainSelectedInstOperands,
     /*  97271 */     // GIR_Coverage, 4973,
     /*  97271 */     GIR_EraseRootFromParent_Done,
     /*  97272 */   // Label 1758: @97272
     /*  97272 */   GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(97340), // Rule ID 4976 //
     /*  97277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97291 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97294 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97301 */     // MIs[0] base
     /*  97301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97309 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97313 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97317 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97321 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97325 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq_u),
     /*  97328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97330 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97332 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97338 */     GIR_RootConstrainSelectedInstOperands,
     /*  97339 */     // GIR_Coverage, 4976,
     /*  97339 */     GIR_EraseRootFromParent_Done,
     /*  97340 */   // Label 1759: @97340
     /*  97340 */   GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(97408), // Rule ID 4977 //
     /*  97345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97359 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97362 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97369 */     // MIs[0] base
     /*  97369 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97381 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97389 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97393 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRHU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHU32_rq),
     /*  97396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97398 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97400 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97402 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97406 */     GIR_RootConstrainSelectedInstOperands,
     /*  97407 */     // GIR_Coverage, 4977,
     /*  97407 */     GIR_EraseRootFromParent_Done,
     /*  97408 */   // Label 1760: @97408
     /*  97408 */   GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(97476), // Rule ID 4980 //
     /*  97413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97424 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97427 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97430 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97437 */     // MIs[0] base
     /*  97437 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97449 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97453 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97461 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq_u),
     /*  97464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97466 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97468 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97474 */     GIR_RootConstrainSelectedInstOperands,
     /*  97475 */     // GIR_Coverage, 4980,
     /*  97475 */     GIR_EraseRootFromParent_Done,
     /*  97476 */   // Label 1761: @97476
     /*  97476 */   GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(97544), // Rule ID 4981 //
     /*  97481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97498 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97505 */     // MIs[0] base
     /*  97505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97517 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 16,
     /*  97521 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 1,
     /*  97525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97529 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 16:{ *:[i32] }, 1:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRHS32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRHS32_rq),
     /*  97532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97534 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97536 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97542 */     GIR_RootConstrainSelectedInstOperands,
     /*  97543 */     // GIR_Coverage, 4981,
     /*  97543 */     GIR_EraseRootFromParent_Done,
     /*  97544 */   // Label 1762: @97544
     /*  97544 */   GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(97612), // Rule ID 4984 //
     /*  97549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97563 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97566 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97573 */     // MIs[0] base
     /*  97573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97577 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97585 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97589 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97597 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97602 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97604 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97606 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97610 */     GIR_RootConstrainSelectedInstOperands,
     /*  97611 */     // GIR_Coverage, 4984,
     /*  97611 */     GIR_EraseRootFromParent_Done,
     /*  97612 */   // Label 1763: @97612
     /*  97612 */   GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(97680), // Rule ID 4985 //
     /*  97617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97631 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97634 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97641 */     // MIs[0] base
     /*  97641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97653 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97657 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97665 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97670 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97672 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97674 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97678 */     GIR_RootConstrainSelectedInstOperands,
     /*  97679 */     // GIR_Coverage, 4985,
     /*  97679 */     GIR_EraseRootFromParent_Done,
     /*  97680 */   // Label 1764: @97680
     /*  97680 */   GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(97748), // Rule ID 4988 //
     /*  97685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97699 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97702 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97709 */     // MIs[0] base
     /*  97709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97721 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97729 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97733 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97738 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97740 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97746 */     GIR_RootConstrainSelectedInstOperands,
     /*  97747 */     // GIR_Coverage, 4988,
     /*  97747 */     GIR_EraseRootFromParent_Done,
     /*  97748 */   // Label 1765: @97748
     /*  97748 */   GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(97816), // Rule ID 4989 //
     /*  97753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97767 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97770 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97777 */     // MIs[0] base
     /*  97777 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97781 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97785 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97793 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97797 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  97801 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97806 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97808 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97810 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97814 */     GIR_RootConstrainSelectedInstOperands,
     /*  97815 */     // GIR_Coverage, 4989,
     /*  97815 */     GIR_EraseRootFromParent_Done,
     /*  97816 */   // Label 1766: @97816
     /*  97816 */   GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(97884), // Rule ID 4992 //
     /*  97821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97838 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97845 */     // MIs[0] base
     /*  97845 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97857 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97861 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  97865 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97869 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  97872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97874 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97876 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97882 */     GIR_RootConstrainSelectedInstOperands,
     /*  97883 */     // GIR_Coverage, 4992,
     /*  97883 */     GIR_EraseRootFromParent_Done,
     /*  97884 */   // Label 1767: @97884
     /*  97884 */   GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(97952), // Rule ID 4993 //
     /*  97889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97903 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97906 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97913 */     // MIs[0] base
     /*  97913 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97925 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97929 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  97933 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  97937 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  97937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  97940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  97942 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  97944 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  97946 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  97950 */     GIR_RootConstrainSelectedInstOperands,
     /*  97951 */     // GIR_Coverage, 4993,
     /*  97951 */     GIR_EraseRootFromParent_Done,
     /*  97952 */   // Label 1768: @97952
     /*  97952 */   GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(98020), // Rule ID 4996 //
     /*  97957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  97962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  97965 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  97968 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  97971 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  97974 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  97977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97981 */     // MIs[0] base
     /*  97981 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  97985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  97989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  97993 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  97997 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98001 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98005 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98010 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98012 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98018 */     GIR_RootConstrainSelectedInstOperands,
     /*  98019 */     // GIR_Coverage, 4996,
     /*  98019 */     GIR_EraseRootFromParent_Done,
     /*  98020 */   // Label 1769: @98020
     /*  98020 */   GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(98088), // Rule ID 4997 //
     /*  98025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98039 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98042 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98049 */     // MIs[0] base
     /*  98049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98061 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98065 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98069 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98073 */     // (intrinsic_w_chain:{ *:[v4i32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4i32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98078 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98080 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98082 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98086 */     GIR_RootConstrainSelectedInstOperands,
     /*  98087 */     // GIR_Coverage, 4997,
     /*  98087 */     GIR_EraseRootFromParent_Done,
     /*  98088 */   // Label 1770: @98088
     /*  98088 */   GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(98156), // Rule ID 5000 //
     /*  98093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98107 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98110 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98117 */     // MIs[0] base
     /*  98117 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98129 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98133 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98137 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98141 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98146 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98148 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98154 */     GIR_RootConstrainSelectedInstOperands,
     /*  98155 */     // GIR_Coverage, 5000,
     /*  98155 */     GIR_EraseRootFromParent_Done,
     /*  98156 */   // Label 1771: @98156
     /*  98156 */   GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(98224), // Rule ID 5001 //
     /*  98161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98178 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98185 */     // MIs[0] base
     /*  98185 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98201 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98205 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98209 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98214 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98216 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98222 */     GIR_RootConstrainSelectedInstOperands,
     /*  98223 */     // GIR_Coverage, 5001,
     /*  98223 */     GIR_EraseRootFromParent_Done,
     /*  98224 */   // Label 1772: @98224
     /*  98224 */   GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(98292), // Rule ID 5004 //
     /*  98229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98246 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98253 */     // MIs[0] base
     /*  98253 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98261 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98265 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98269 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98273 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98277 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq_u:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq_u),
     /*  98280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98282 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98284 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98286 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98290 */     GIR_RootConstrainSelectedInstOperands,
     /*  98291 */     // GIR_Coverage, 5004,
     /*  98291 */     GIR_EraseRootFromParent_Done,
     /*  98292 */   // Label 1773: @98292
     /*  98292 */   GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(98360), // Rule ID 5005 //
     /*  98297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /*  98305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  98308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98311 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98314 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98321 */     // MIs[0] base
     /*  98321 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98329 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98333 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 32,
     /*  98337 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 2,
     /*  98341 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98345 */     // (intrinsic_w_chain:{ *:[v4f32] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets, 32:{ *:[i32] }, 2:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRWU32_rq:{ *:[v4f32] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v4i32] }:$offsets)
     /*  98345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRWU32_rq),
     /*  98348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98350 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98352 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98358 */     GIR_RootConstrainSelectedInstOperands,
     /*  98359 */     // GIR_Coverage, 5005,
     /*  98359 */     GIR_EraseRootFromParent_Done,
     /*  98360 */   // Label 1774: @98360
     /*  98360 */   GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(98428), // Rule ID 5008 //
     /*  98365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98379 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98382 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98389 */     // MIs[0] base
     /*  98389 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98401 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98405 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98409 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98413 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98418 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98420 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98422 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98426 */     GIR_RootConstrainSelectedInstOperands,
     /*  98427 */     // GIR_Coverage, 5008,
     /*  98427 */     GIR_EraseRootFromParent_Done,
     /*  98428 */   // Label 1775: @98428
     /*  98428 */   GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(98496), // Rule ID 5009 //
     /*  98433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98447 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98450 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98457 */     // MIs[0] base
     /*  98457 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98477 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98481 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98486 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98488 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98490 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98494 */     GIR_RootConstrainSelectedInstOperands,
     /*  98495 */     // GIR_Coverage, 5009,
     /*  98495 */     GIR_EraseRootFromParent_Done,
     /*  98496 */   // Label 1776: @98496
     /*  98496 */   GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(98564), // Rule ID 5012 //
     /*  98501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98515 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98518 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98525 */     // MIs[0] base
     /*  98525 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98541 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98545 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98549 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98554 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98556 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98558 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98562 */     GIR_RootConstrainSelectedInstOperands,
     /*  98563 */     // GIR_Coverage, 5012,
     /*  98563 */     GIR_EraseRootFromParent_Done,
     /*  98564 */   // Label 1777: @98564
     /*  98564 */   GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(98632), // Rule ID 5013 //
     /*  98569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98583 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98586 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98593 */     // MIs[0] base
     /*  98593 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98605 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98609 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98613 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98617 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98622 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98624 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98626 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98630 */     GIR_RootConstrainSelectedInstOperands,
     /*  98631 */     // GIR_Coverage, 5013,
     /*  98631 */     GIR_EraseRootFromParent_Done,
     /*  98632 */   // Label 1778: @98632
     /*  98632 */   GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(98700), // Rule ID 5016 //
     /*  98637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98651 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98654 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98661 */     // MIs[0] base
     /*  98661 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98673 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98677 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98681 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98685 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98690 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98692 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98698 */     GIR_RootConstrainSelectedInstOperands,
     /*  98699 */     // GIR_Coverage, 5016,
     /*  98699 */     GIR_EraseRootFromParent_Done,
     /*  98700 */   // Label 1779: @98700
     /*  98700 */   GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(98768), // Rule ID 5017 //
     /*  98705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98716 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98719 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98722 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98729 */     // MIs[0] base
     /*  98729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98737 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98741 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98749 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 0,
     /*  98753 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 0:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98758 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98760 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98766 */     GIR_RootConstrainSelectedInstOperands,
     /*  98767 */     // GIR_Coverage, 5017,
     /*  98767 */     GIR_EraseRootFromParent_Done,
     /*  98768 */   // Label 1780: @98768
     /*  98768 */   GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(98836), // Rule ID 5020 //
     /*  98773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98787 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98790 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98797 */     // MIs[0] base
     /*  98797 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98805 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98809 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 0,
     /*  98817 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98821 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 0:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq_u:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq_u),
     /*  98824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98826 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98828 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98834 */     GIR_RootConstrainSelectedInstOperands,
     /*  98835 */     // GIR_Coverage, 5020,
     /*  98835 */     GIR_EraseRootFromParent_Done,
     /*  98836 */   // Label 1781: @98836
     /*  98836 */   GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(98904), // Rule ID 5021 //
     /*  98841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::arm_mve_vldr_gather_offset),
     /*  98846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /*  98849 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  98852 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /*  98855 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s32,
     /*  98858 */     GIM_RootCheckType, /*Op*/6, /*Type*/GILLT_s32,
     /*  98861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98865 */     // MIs[0] base
     /*  98865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/32,
     /*  98869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /*  98877 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 64,
     /*  98881 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/5, 3,
     /*  98885 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/6, 1,
     /*  98889 */     // (intrinsic_w_chain:{ *:[v2i64] } 3615:{ *:[iPTR] }, GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets, 64:{ *:[i32] }, 3:{ *:[i32] }, 1:{ *:[i32] })  =>  (MVE_VLDRDU64_rq:{ *:[v2i64] } GPR:{ *:[i32] }:$base, MQPR:{ *:[v2i64] }:$offsets)
     /*  98889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VLDRDU64_rq),
     /*  98892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /*  98894 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /*  98896 */     GIR_RootToRootCopy, /*OpIdx*/3, // offsets
     /*  98898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98902 */     GIR_RootConstrainSelectedInstOperands,
     /*  98903 */     // GIR_Coverage, 5021,
     /*  98903 */     GIR_EraseRootFromParent_Done,
     /*  98904 */   // Label 1782: @98904
     /*  98904 */   GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(98969), // Rule ID 256 //
     /*  98909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  98912 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  98917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98920 */     // MIs[0] cop
     /*  98920 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98923 */     // MIs[0] opc1
     /*  98923 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98926 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98930 */     // MIs[0] CRn
     /*  98930 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98933 */     // MIs[0] CRm
     /*  98933 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  98936 */     // MIs[0] opc2
     /*  98936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  98939 */     // (intrinsic_void 3490:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  98939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR),
     /*  98942 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  98944 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  98946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  98948 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  98950 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  98952 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  98954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  98957 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  98963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  98967 */     GIR_RootConstrainSelectedInstOperands,
     /*  98968 */     // GIR_Coverage, 256,
     /*  98968 */     GIR_EraseRootFromParent_Done,
     /*  98969 */   // Label 1783: @98969
     /*  98969 */   GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(99025), // Rule ID 257 //
     /*  98974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_PreV8),
     /*  98977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  98982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  98985 */     // MIs[0] cop
     /*  98985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  98988 */     // MIs[0] opc1
     /*  98988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  98991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  98995 */     // MIs[0] CRn
     /*  98995 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  98998 */     // MIs[0] CRm
     /*  98998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99001 */     // MIs[0] opc2
     /*  99001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99004 */     // (intrinsic_void 3491:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MCR2),
     /*  99007 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99009 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99013 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99015 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99017 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99023 */     GIR_RootConstrainSelectedInstOperands,
     /*  99024 */     // GIR_Coverage, 257,
     /*  99024 */     GIR_EraseRootFromParent_Done,
     /*  99025 */   // Label 1784: @99025
     /*  99025 */   GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(99090), // Rule ID 594 //
     /*  99030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr),
     /*  99038 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99041 */     // MIs[0] cop
     /*  99041 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99044 */     // MIs[0] opc1
     /*  99044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99047 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99051 */     // MIs[0] CRn
     /*  99051 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99054 */     // MIs[0] CRm
     /*  99054 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99057 */     // MIs[0] opc2
     /*  99057 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99060 */     // (intrinsic_void 3490:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR),
     /*  99063 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99065 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99067 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99069 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99071 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99073 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99078 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99084 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99088 */     GIR_RootConstrainSelectedInstOperands,
     /*  99089 */     // GIR_Coverage, 594,
     /*  99089 */     GIR_EraseRootFromParent_Done,
     /*  99090 */   // Label 1785: @99090
     /*  99090 */   GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(99155), // Rule ID 595 //
     /*  99095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2_PreV8),
     /*  99098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::arm_mcr2),
     /*  99103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /*  99106 */     // MIs[0] cop
     /*  99106 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /*  99109 */     // MIs[0] opc1
     /*  99109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /*  99112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99116 */     // MIs[0] CRn
     /*  99116 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /*  99119 */     // MIs[0] CRm
     /*  99119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /*  99122 */     // MIs[0] opc2
     /*  99122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/6,
     /*  99125 */     // (intrinsic_void 3491:{ *:[iPTR] }, (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)  =>  (t2MCR2 (timm:{ *:[i32] }):$cop, (timm:{ *:[i32] }):$opc1, GPR:{ *:[i32] }:$Rt, (timm:{ *:[i32] }):$CRn, (timm:{ *:[i32] }):$CRm, (timm:{ *:[i32] }):$opc2)
     /*  99125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MCR2),
     /*  99128 */     GIR_RootToRootCopy, /*OpIdx*/1, // cop
     /*  99130 */     GIR_RootToRootCopy, /*OpIdx*/2, // opc1
     /*  99132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rt
     /*  99134 */     GIR_RootToRootCopy, /*OpIdx*/4, // CRn
     /*  99136 */     GIR_RootToRootCopy, /*OpIdx*/5, // CRm
     /*  99138 */     GIR_RootToRootCopy, /*OpIdx*/6, // opc2
     /*  99140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99143 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /*  99153 */     GIR_RootConstrainSelectedInstOperands,
     /*  99154 */     // GIR_Coverage, 595,
     /*  99154 */     GIR_EraseRootFromParent_Done,
     /*  99155 */   // Label 1786: @99155
     /*  99155 */   GIM_Reject,
     /*  99156 */ // Label 1736: @99156
     /*  99156 */ GIM_Reject,
     /*  99157 */ // Label 16: @99157
     /*  99157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1790*/ GIMT_Encode4(99314),
     /*  99168 */ /*GILLT_v2s64*//*Label 1787*/ GIMT_Encode4(99200), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99180 */ /*GILLT_v4s32*//*Label 1788*/ GIMT_Encode4(99238), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99196 */ /*GILLT_v8s16*//*Label 1789*/ GIMT_Encode4(99276),
     /*  99200 */ // Label 1787: @99200
     /*  99200 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(99237), // Rule ID 2665 //
     /*  99205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99215 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99219 */   // (anyext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /*  99222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99224 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99226 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99229 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99235 */   GIR_RootConstrainSelectedInstOperands,
     /*  99236 */   // GIR_Coverage, 2665,
     /*  99236 */   GIR_EraseRootFromParent_Done,
     /*  99237 */ // Label 1791: @99237
     /*  99237 */ GIM_Reject,
     /*  99238 */ // Label 1788: @99238
     /*  99238 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(99275), // Rule ID 2664 //
     /*  99243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99257 */   // (anyext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99257 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /*  99260 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99262 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99264 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99267 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99273 */   GIR_RootConstrainSelectedInstOperands,
     /*  99274 */   // GIR_Coverage, 2664,
     /*  99274 */   GIR_EraseRootFromParent_Done,
     /*  99275 */ // Label 1792: @99275
     /*  99275 */ GIM_Reject,
     /*  99276 */ // Label 1789: @99276
     /*  99276 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(99313), // Rule ID 2663 //
     /*  99281 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  99287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99291 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99295 */   // (anyext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /*  99295 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /*  99298 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99300 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99302 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99305 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99311 */   GIR_RootConstrainSelectedInstOperands,
     /*  99312 */   // GIR_Coverage, 2663,
     /*  99312 */   GIR_EraseRootFromParent_Done,
     /*  99313 */ // Label 1793: @99313
     /*  99313 */ GIM_Reject,
     /*  99314 */ // Label 1790: @99314
     /*  99314 */ GIM_Reject,
     /*  99315 */ // Label 17: @99315
     /*  99315 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(12), /*)*//*default:*//*Label 1797*/ GIMT_Encode4(99472),
     /*  99326 */ /*GILLT_v2s32*//*Label 1794*/ GIMT_Encode4(99358), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99338 */ /*GILLT_v4s16*//*Label 1795*/ GIMT_Encode4(99396), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99354 */ /*GILLT_v8s8*//*Label 1796*/ GIMT_Encode4(99434),
     /*  99358 */ // Label 1794: @99358
     /*  99358 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(99395), // Rule ID 1585 //
     /*  99363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99377 */   // (trunc:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)  =>  (VMOVNv2i32:{ *:[v2i32] } QPR:{ *:[v2i64] }:$Vm)
     /*  99377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv2i32),
     /*  99380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99382 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99387 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99393 */   GIR_RootConstrainSelectedInstOperands,
     /*  99394 */   // GIR_Coverage, 1585,
     /*  99394 */   GIR_EraseRootFromParent_Done,
     /*  99395 */ // Label 1798: @99395
     /*  99395 */ GIM_Reject,
     /*  99396 */ // Label 1795: @99396
     /*  99396 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(99433), // Rule ID 1584 //
     /*  99401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  99407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99415 */   // (trunc:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)  =>  (VMOVNv4i16:{ *:[v4i16] } QPR:{ *:[v4i32] }:$Vm)
     /*  99415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv4i16),
     /*  99418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99420 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99422 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99425 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99431 */   GIR_RootConstrainSelectedInstOperands,
     /*  99432 */   // GIR_Coverage, 1584,
     /*  99432 */   GIR_EraseRootFromParent_Done,
     /*  99433 */ // Label 1799: @99433
     /*  99433 */ GIM_Reject,
     /*  99434 */ // Label 1796: @99434
     /*  99434 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(99471), // Rule ID 1583 //
     /*  99439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  99445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99453 */   // (trunc:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)  =>  (VMOVNv8i8:{ *:[v8i8] } QPR:{ *:[v8i16] }:$Vm)
     /*  99453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVNv8i8),
     /*  99456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99458 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99463 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99469 */   GIR_RootConstrainSelectedInstOperands,
     /*  99470 */   // GIR_Coverage, 1583,
     /*  99470 */   GIR_EraseRootFromParent_Done,
     /*  99471 */ // Label 1800: @99471
     /*  99471 */ GIM_Reject,
     /*  99472 */ // Label 1797: @99472
     /*  99472 */ GIM_Reject,
     /*  99473 */ // Label 18: @99473
     /*  99473 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(99793),
     /*  99478 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /*  99481 */   GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(99522), // Rule ID 404 //
     /*  99486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /*  99489 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_t2_so_imm),
     /*  99493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99497 */     // MIs[0] Operand 1
     /*  99497 */     // No operand predicates
     /*  99497 */     // (imm:{ *:[i32] })<<P:Predicate_t2_so_imm>>:$imm  =>  (t2MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /*  99500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99520 */     GIR_RootConstrainSelectedInstOperands,
     /*  99521 */     // GIR_Coverage, 404,
     /*  99521 */     GIR_EraseRootFromParent_Done,
     /*  99522 */   // Label 1802: @99522
     /*  99522 */   GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(99563), // Rule ID 57 //
     /*  99527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99530 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm),
     /*  99534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99538 */     // MIs[0] Operand 1
     /*  99538 */     // No operand predicates
     /*  99538 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm>>:$imm  =>  (MOVi:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /*  99541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99546 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99549 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99555 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99561 */     GIR_RootConstrainSelectedInstOperands,
     /*  99562 */     // GIR_Coverage, 57,
     /*  99562 */     GIR_EraseRootFromParent_Done,
     /*  99563 */   // Label 1803: @99563
     /*  99563 */   GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(99598), // Rule ID 58 //
     /*  99568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /*  99571 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99579 */     // MIs[0] Operand 1
     /*  99579 */     // No operand predicates
     /*  99579 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi16),
     /*  99582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99590 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99596 */     GIR_RootConstrainSelectedInstOperands,
     /*  99597 */     // GIR_Coverage, 58,
     /*  99597 */     GIR_EraseRootFromParent_Done,
     /*  99598 */   // Label 1804: @99598
     /*  99598 */   GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(99641), // Rule ID 168 //
     /*  99603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99606 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_mod_imm_not),
     /*  99610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99614 */     // MIs[0] Operand 1
     /*  99614 */     // No operand predicates
     /*  99614 */     // (imm:{ *:[i32] })<<P:Predicate_mod_imm_not>><<X:imm_not_XFORM>>:$imm  =>  (MVNi:{ *:[i32] } (imm_not_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  99614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVNi),
     /*  99617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99619 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderInvertedImm), // imm
     /*  99624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99627 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99633 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99639 */     GIR_RootConstrainSelectedInstOperands,
     /*  99640 */     // GIR_Coverage, 168,
     /*  99640 */     GIR_EraseRootFromParent_Done,
     /*  99641 */   // Label 1805: @99641
     /*  99641 */   GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(99667), // Rule ID 268 //
     /*  99646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /*  99649 */     GIM_CheckAPIntImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_arm_i32imm),
     /*  99653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /*  99657 */     // MIs[0] Operand 1
     /*  99657 */     // No operand predicates
     /*  99657 */     // (imm:{ *:[i32] })<<P:Predicate_arm_i32imm>>:$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MOVi32imm),
     /*  99660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99662 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99665 */     GIR_RootConstrainSelectedInstOperands,
     /*  99666 */     // GIR_Coverage, 268,
     /*  99666 */     GIR_EraseRootFromParent_Done,
     /*  99667 */   // Label 1806: @99667
     /*  99667 */   GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(99708), // Rule ID 322 //
     /*  99672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /*  99675 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255_expr),
     /*  99679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /*  99683 */     // MIs[0] Operand 1
     /*  99683 */     // No operand predicates
     /*  99683 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_255_expr>>:$imm8  =>  (tMOVi8:{ *:[i32] } (imm:{ *:[i32] }):$imm8)
     /*  99683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /*  99686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99688 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /*  99694 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm8
     /*  99697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99700 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99706 */     GIR_RootConstrainSelectedInstOperands,
     /*  99707 */     // GIR_Coverage, 322,
     /*  99707 */     GIR_EraseRootFromParent_Done,
     /*  99708 */   // Label 1807: @99708
     /*  99708 */   GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(99743), // Rule ID 405 //
     /*  99713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /*  99716 */     GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_65535),
     /*  99720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99724 */     // MIs[0] Operand 1
     /*  99724 */     // No operand predicates
     /*  99724 */     // (imm:{ *:[i32] })<<P:Predicate_imm0_65535>>:$imm  =>  (t2MOVi16:{ *:[i32] } (imm:{ *:[i32] }):$imm)
     /*  99724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /*  99727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // imm
     /*  99732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99735 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99741 */     GIR_RootConstrainSelectedInstOperands,
     /*  99742 */     // GIR_Coverage, 405,
     /*  99742 */     GIR_EraseRootFromParent_Done,
     /*  99743 */   // Label 1808: @99743
     /*  99743 */   GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(99792),
     /*  99748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /*  99752 */     GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(99773), // Rule ID 353 //
     /*  99757 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseMovt_GenExecuteOnly_IsThumb1Only),
     /*  99760 */       // MIs[0] Operand 1
     /*  99760 */       // No operand predicates
     /*  99760 */       // (imm:{ *:[i32] }):$src  =>  (tMOVi32imm:{ *:[i32] }:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99760 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tMOVi32imm),
     /*  99763 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99765 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99768 */       GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::CPSR*/0,
     /*  99771 */       GIR_RootConstrainSelectedInstOperands,
     /*  99772 */       // GIR_Coverage, 353,
     /*  99772 */       GIR_EraseRootFromParent_Done,
     /*  99773 */     // Label 1810: @99773
     /*  99773 */     GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(99791), // Rule ID 582 //
     /*  99778 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_UseMovt),
     /*  99781 */       // MIs[0] Operand 1
     /*  99781 */       // No operand predicates
     /*  99781 */       // (imm:{ *:[i32] }):$src  =>  (t2MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /*  99781 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /*  99784 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99786 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /*  99789 */       GIR_RootConstrainSelectedInstOperands,
     /*  99790 */       // GIR_Coverage, 582,
     /*  99790 */       GIR_EraseRootFromParent_Done,
     /*  99791 */     // Label 1811: @99791
     /*  99791 */     GIM_Reject,
     /*  99792 */   // Label 1809: @99792
     /*  99792 */   GIM_Reject,
     /*  99793 */ // Label 1801: @99793
     /*  99793 */ GIM_Reject,
     /*  99794 */ // Label 19: @99794
     /*  99794 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(3), /*)*//*default:*//*Label 1814*/ GIMT_Encode4(99889),
     /*  99805 */ /*GILLT_s32*//*Label 1812*/ GIMT_Encode4(99813),
     /*  99809 */ /*GILLT_s64*//*Label 1813*/ GIMT_Encode4(99851),
     /*  99813 */ // Label 1812: @99813
     /*  99813 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(99850), // Rule ID 725 //
     /*  99818 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP3),
     /*  99821 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /*  99825 */   // MIs[0] Operand 1
     /*  99825 */   // No operand predicates
     /*  99825 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f32imm),
     /*  99829 */   // (fpimm:{ *:[f32] })<<P:Predicate_vfp_f32imm>><<X:vfp_f32imm_xform>>:$imm  =>  (FCONSTS:{ *:[f32] } (vfp_f32imm_xform:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /*  99829 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTS),
     /*  99832 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /*  99834 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF32Imm), // imm
     /*  99839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99842 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99848 */   GIR_RootConstrainSelectedInstOperands,
     /*  99849 */   // GIR_Coverage, 725,
     /*  99849 */   GIR_EraseRootFromParent_Done,
     /*  99850 */ // Label 1815: @99850
     /*  99850 */ GIM_Reject,
     /*  99851 */ // Label 1813: @99851
     /*  99851 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(99888), // Rule ID 724 //
     /*  99856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP3),
     /*  99859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99863 */   // MIs[0] Operand 1
     /*  99863 */   // No operand predicates
     /*  99863 */   GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_vfp_f64imm),
     /*  99867 */   // (fpimm:{ *:[f64] })<<P:Predicate_vfp_f64imm>><<X:vfp_f64imm_xform>>:$imm  =>  (FCONSTD:{ *:[f64] } (vfp_f64imm_xform:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /*  99867 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::FCONSTD),
     /*  99870 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /*  99872 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderVFPF64Imm), // imm
     /*  99877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99880 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99886 */   GIR_RootConstrainSelectedInstOperands,
     /*  99887 */   // GIR_Coverage, 724,
     /*  99887 */   GIR_EraseRootFromParent_Done,
     /*  99888 */ // Label 1816: @99888
     /*  99888 */ GIM_Reject,
     /*  99889 */ // Label 1814: @99889
     /*  99889 */ GIM_Reject,
     /*  99890 */ // Label 20: @99890
     /*  99890 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1820*/ GIMT_Encode4(100047),
     /*  99901 */ /*GILLT_v2s64*//*Label 1817*/ GIMT_Encode4(99933), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99913 */ /*GILLT_v4s32*//*Label 1818*/ GIMT_Encode4(99971), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  99929 */ /*GILLT_v8s16*//*Label 1819*/ GIMT_Encode4(100009),
     /*  99933 */ // Label 1817: @99933
     /*  99933 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(99970), // Rule ID 1597 //
     /*  99938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99952 */   // (sext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLsv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /*  99952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv2i64),
     /*  99955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99957 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99959 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /*  99962 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  99968 */   GIR_RootConstrainSelectedInstOperands,
     /*  99969 */   // GIR_Coverage, 1597,
     /*  99969 */   GIR_EraseRootFromParent_Done,
     /*  99970 */ // Label 1821: @99970
     /*  99970 */ GIM_Reject,
     /*  99971 */ // Label 1818: @99971
     /*  99971 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(100008), // Rule ID 1596 //
     /*  99976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  99982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /*  99986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /*  99990 */   // (sext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLsv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /*  99990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv4i32),
     /*  99993 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  99995 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /*  99997 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100000 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100006 */   GIR_RootConstrainSelectedInstOperands,
     /* 100007 */   // GIR_Coverage, 1596,
     /* 100007 */   GIR_EraseRootFromParent_Done,
     /* 100008 */ // Label 1822: @100008
     /* 100008 */ GIM_Reject,
     /* 100009 */ // Label 1819: @100009
     /* 100009 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(100046), // Rule ID 1595 //
     /* 100014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100028 */   // (sext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLsv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100028 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLsv8i16),
     /* 100031 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100033 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100035 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100038 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100044 */   GIR_RootConstrainSelectedInstOperands,
     /* 100045 */   // GIR_Coverage, 1595,
     /* 100045 */   GIR_EraseRootFromParent_Done,
     /* 100046 */ // Label 1823: @100046
     /* 100046 */ GIM_Reject,
     /* 100047 */ // Label 1820: @100047
     /* 100047 */ GIM_Reject,
     /* 100048 */ // Label 21: @100048
     /* 100048 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 1827*/ GIMT_Encode4(100652),
     /* 100059 */ /*GILLT_s32*//*Label 1824*/ GIMT_Encode4(100107), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100087 */ /*GILLT_v4s32*//*Label 1825*/ GIMT_Encode4(100399), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100103 */ /*GILLT_v8s16*//*Label 1826*/ GIMT_Encode4(100582),
     /* 100107 */ // Label 1824: @100107
     /* 100107 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(100398),
     /* 100112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100115 */   GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(100160), // Rule ID 340 //
     /* 100120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100127 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100131 */     // MIs[0] Operand 2
     /* 100131 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100142 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i8:{ *:[Other] })  =>  (tSXTB:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTB),
     /* 100145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100158 */     GIR_RootConstrainSelectedInstOperands,
     /* 100159 */     // GIR_Coverage, 340,
     /* 100159 */     GIR_EraseRootFromParent_Done,
     /* 100160 */   // Label 1829: @100160
     /* 100160 */   GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(100205), // Rule ID 341 //
     /* 100165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 100168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100172 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100176 */     // MIs[0] Operand 2
     /* 100176 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100187 */     // (sext_inreg:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, i16:{ *:[Other] })  =>  (tSXTH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 100187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tSXTH),
     /* 100190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100194 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100197 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100203 */     GIR_RootConstrainSelectedInstOperands,
     /* 100204 */     // GIR_Coverage, 341,
     /* 100204 */     GIR_EraseRootFromParent_Done,
     /* 100205 */   // Label 1830: @100205
     /* 100205 */   GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(100253), // Rule ID 1999 //
     /* 100210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100217 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100221 */     // MIs[0] Operand 2
     /* 100221 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100232 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (SXTB:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTB),
     /* 100235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100242 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100245 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100251 */     GIR_RootConstrainSelectedInstOperands,
     /* 100252 */     // GIR_Coverage, 1999,
     /* 100252 */     GIR_EraseRootFromParent_Done,
     /* 100253 */   // Label 1831: @100253
     /* 100253 */   GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(100301), // Rule ID 2000 //
     /* 100258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 100261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 100265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 100269 */     // MIs[0] Operand 2
     /* 100269 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100280 */     // (sext_inreg:{ *:[i32] } GPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (SXTH:{ *:[i32] } GPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SXTH),
     /* 100283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100293 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100299 */     GIR_RootConstrainSelectedInstOperands,
     /* 100300 */     // GIR_Coverage, 2000,
     /* 100300 */     GIR_EraseRootFromParent_Done,
     /* 100301 */   // Label 1832: @100301
     /* 100301 */   GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(100349), // Rule ID 2238 //
     /* 100306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100317 */     // MIs[0] Operand 2
     /* 100317 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100328 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i8:{ *:[Other] })  =>  (t2SXTB:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTB),
     /* 100331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100333 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100338 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100341 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100347 */     GIR_RootConstrainSelectedInstOperands,
     /* 100348 */     // GIR_Coverage, 2238,
     /* 100348 */     GIR_EraseRootFromParent_Done,
     /* 100349 */   // Label 1833: @100349
     /* 100349 */   GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(100397), // Rule ID 2239 //
     /* 100354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100365 */     // MIs[0] Operand 2
     /* 100365 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100376 */     // (sext_inreg:{ *:[i32] } rGPR:{ *:[i32] }:$Src, i16:{ *:[Other] })  =>  (t2SXTH:{ *:[i32] } rGPR:{ *:[i32] }:$Src, 0:{ *:[i32] })
     /* 100376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SXTH),
     /* 100379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100381 */     GIR_RootToRootCopy, /*OpIdx*/1, // Src
     /* 100383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100395 */     GIR_RootConstrainSelectedInstOperands,
     /* 100396 */     // GIR_Coverage, 2239,
     /* 100396 */     GIR_EraseRootFromParent_Done,
     /* 100397 */   // Label 1834: @100397
     /* 100397 */   GIM_Reject,
     /* 100398 */ // Label 1828: @100398
     /* 100398 */ GIM_Reject,
     /* 100399 */ // Label 1825: @100399
     /* 100399 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(100581),
     /* 100404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 100407 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100411 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100415 */   GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(100473), // Rule ID 3710 //
     /* 100420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100423 */     // MIs[0] Operand 2
     /* 100423 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 100434 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i16:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 100434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100451 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100453 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100456 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100471 */     GIR_RootConstrainSelectedInstOperands,
     /* 100472 */     // GIR_Coverage, 3710,
     /* 100472 */     GIR_EraseRootFromParent_Done,
     /* 100473 */   // Label 1836: @100473
     /* 100473 */   GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(100580), // Rule ID 3712 //
     /* 100478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100481 */     // MIs[0] Operand 2
     /* 100481 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100492 */     // (sext_inreg:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src, v4i8:{ *:[Other] })  =>  (MVE_VMOVLs16bh:{ *:[v4i32] } (MVE_VMOVLs8bh:{ *:[v16i8] } MQPR:{ *:[v4i32] }:$src))
     /* 100492 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 100495 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100499 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100504 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 100507 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100511 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 100519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100528 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 100532 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 100535 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100541 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100547 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs16bh),
     /* 100555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100557 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100569 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 100578 */     GIR_RootConstrainSelectedInstOperands,
     /* 100579 */     // GIR_Coverage, 3712,
     /* 100579 */     GIR_EraseRootFromParent_Done,
     /* 100580 */   // Label 1837: @100580
     /* 100580 */   GIM_Reject,
     /* 100581 */ // Label 1835: @100581
     /* 100581 */ GIM_Reject,
     /* 100582 */ // Label 1826: @100582
     /* 100582 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(100651), // Rule ID 3711 //
     /* 100587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 100590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 100593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 100601 */   // MIs[0] Operand 2
     /* 100601 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 100612 */   // (sext_inreg:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src, v8i8:{ *:[Other] })  =>  (MVE_VMOVLs8bh:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 100612 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 100615 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100619 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100624 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOVLs8bh),
     /* 100627 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 100629 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 100631 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100634 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100640 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100649 */   GIR_RootConstrainSelectedInstOperands,
     /* 100650 */   // GIR_Coverage, 3711,
     /* 100650 */   GIR_EraseRootFromParent_Done,
     /* 100651 */ // Label 1838: @100651
     /* 100651 */ GIM_Reject,
     /* 100652 */ // Label 1827: @100652
     /* 100652 */ GIM_Reject,
     /* 100653 */ // Label 22: @100653
     /* 100653 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(13), /*)*//*default:*//*Label 1842*/ GIMT_Encode4(100810),
     /* 100664 */ /*GILLT_v2s64*//*Label 1839*/ GIMT_Encode4(100696), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100676 */ /*GILLT_v4s32*//*Label 1840*/ GIMT_Encode4(100734), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 100692 */ /*GILLT_v8s16*//*Label 1841*/ GIMT_Encode4(100772),
     /* 100696 */ // Label 1839: @100696
     /* 100696 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(100733), // Rule ID 1600 //
     /* 100701 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100704 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 100707 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100715 */   // (zext:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)  =>  (VMOVLuv2i64:{ *:[v2i64] } DPR:{ *:[v2i32] }:$Vm)
     /* 100715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv2i64),
     /* 100718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100722 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100725 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100731 */   GIR_RootConstrainSelectedInstOperands,
     /* 100732 */   // GIR_Coverage, 1600,
     /* 100732 */   GIR_EraseRootFromParent_Done,
     /* 100733 */ // Label 1843: @100733
     /* 100733 */ GIM_Reject,
     /* 100734 */ // Label 1840: @100734
     /* 100734 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(100771), // Rule ID 1599 //
     /* 100739 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100742 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 100745 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100749 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100753 */   // (zext:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)  =>  (VMOVLuv4i32:{ *:[v4i32] } DPR:{ *:[v4i16] }:$Vm)
     /* 100753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv4i32),
     /* 100756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100758 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100760 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100763 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100769 */   GIR_RootConstrainSelectedInstOperands,
     /* 100770 */   // GIR_Coverage, 1599,
     /* 100770 */   GIR_EraseRootFromParent_Done,
     /* 100771 */ // Label 1844: @100771
     /* 100771 */ GIM_Reject,
     /* 100772 */ // Label 1841: @100772
     /* 100772 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(100809), // Rule ID 1598 //
     /* 100777 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100780 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 100783 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 100787 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 100791 */   // (zext:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)  =>  (VMOVLuv8i16:{ *:[v8i16] } DPR:{ *:[v8i8] }:$Vm)
     /* 100791 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMOVLuv8i16),
     /* 100794 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 100796 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 100798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100801 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100807 */   GIR_RootConstrainSelectedInstOperands,
     /* 100808 */   // GIR_Coverage, 1598,
     /* 100808 */   GIR_EraseRootFromParent_Done,
     /* 100809 */ // Label 1845: @100809
     /* 100809 */ GIM_Reject,
     /* 100810 */ // Label 1842: @100810
     /* 100810 */ GIM_Reject,
     /* 100811 */ // Label 23: @100811
     /* 100811 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(101026),
     /* 100816 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 100819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 100822 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 100825 */   GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(100882), // Rule ID 470 //
     /* 100830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100849 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 100853 */     // MIs[1] Operand 1
     /* 100853 */     // No operand predicates
     /* 100853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100855 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2LSLri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 100855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLri),
     /* 100858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 100865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100880 */     GIR_RootConstrainSelectedInstOperands,
     /* 100881 */     // GIR_Coverage, 470,
     /* 100881 */     GIR_EraseRootFromParent_Done,
     /* 100882 */   // Label 1847: @100882
     /* 100882 */   GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(100979),
     /* 100887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100891 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100895 */     GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(100940), // Rule ID 318 //
     /* 100900 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100903 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100907 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100911 */       // MIs[1] Operand 1
     /* 100911 */       // No operand predicates
     /* 100911 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100913 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)  =>  (tLSLri:{ *:[i32] } tGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm5)
     /* 100913 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLri),
     /* 100916 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100918 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100924 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 100926 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm5
     /* 100929 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100932 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100938 */       GIR_RootConstrainSelectedInstOperands,
     /* 100939 */       // GIR_Coverage, 318,
     /* 100939 */       GIR_EraseRootFromParent_Done,
     /* 100940 */     // Label 1849: @100940
     /* 100940 */     GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(100978), // Rule ID 319 //
     /* 100945 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 100948 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 100952 */       // (shl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSLrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 100952 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSLrr),
     /* 100955 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 100957 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 100963 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 100965 */       GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 100967 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 100970 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 100976 */       GIR_RootConstrainSelectedInstOperands,
     /* 100977 */       // GIR_Coverage, 319,
     /* 100977 */       GIR_EraseRootFromParent_Done,
     /* 100978 */     // Label 1850: @100978
     /* 100978 */     GIM_Reject,
     /* 100979 */   // Label 1848: @100979
     /* 100979 */   GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(101025), // Rule ID 471 //
     /* 100984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 100987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100991 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 100999 */     // (shl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSLrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 100999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSLrr),
     /* 101002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101008 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101011 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101017 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101023 */     GIR_RootConstrainSelectedInstOperands,
     /* 101024 */     // GIR_Coverage, 471,
     /* 101024 */     GIR_EraseRootFromParent_Done,
     /* 101025 */   // Label 1851: @101025
     /* 101025 */   GIM_Reject,
     /* 101026 */ // Label 1846: @101026
     /* 101026 */ GIM_Reject,
     /* 101027 */ // Label 24: @101027
     /* 101027 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(101134),
     /* 101032 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101041 */   GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(101087), // Rule ID 321 //
     /* 101046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101061 */     // (srl:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tLSRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tLSRrr),
     /* 101064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101066 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101079 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101085 */     GIR_RootConstrainSelectedInstOperands,
     /* 101086 */     // GIR_Coverage, 321,
     /* 101086 */     GIR_EraseRootFromParent_Done,
     /* 101087 */   // Label 1853: @101087
     /* 101087 */   GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(101133), // Rule ID 473 //
     /* 101092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101107 */     // (srl:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2LSRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2LSRrr),
     /* 101110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101119 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101131 */     GIR_RootConstrainSelectedInstOperands,
     /* 101132 */     // GIR_Coverage, 473,
     /* 101132 */     GIR_EraseRootFromParent_Done,
     /* 101133 */   // Label 1854: @101133
     /* 101133 */   GIM_Reject,
     /* 101134 */ // Label 1852: @101134
     /* 101134 */ GIM_Reject,
     /* 101135 */ // Label 25: @101135
     /* 101135 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(101407),
     /* 101140 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101146 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101149 */   GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(101204), // Rule ID 201 //
     /* 101154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101182 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101184 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REVSH:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REVSH),
     /* 101187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101196 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101202 */     GIR_RootConstrainSelectedInstOperands,
     /* 101203 */     // GIR_Coverage, 201,
     /* 101203 */     GIR_EraseRootFromParent_Done,
     /* 101204 */   // Label 1856: @101204
     /* 101204 */   GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(101259), // Rule ID 328 //
     /* 101209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101228 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101237 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101239 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREVSH:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREVSH),
     /* 101242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101248 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101251 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101257 */     GIR_RootConstrainSelectedInstOperands,
     /* 101258 */     // GIR_Coverage, 328,
     /* 101258 */     GIR_EraseRootFromParent_Done,
     /* 101259 */   // Label 1857: @101259
     /* 101259 */   GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(101314), // Rule ID 538 //
     /* 101264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101288 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101294 */     // (sra:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REVSH:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REVSH),
     /* 101297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101312 */     GIR_RootConstrainSelectedInstOperands,
     /* 101313 */     // GIR_Coverage, 538,
     /* 101313 */     GIR_EraseRootFromParent_Done,
     /* 101314 */   // Label 1858: @101314
     /* 101314 */   GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(101360), // Rule ID 312 //
     /* 101319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101334 */     // (sra:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tASRrr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tASRrr),
     /* 101337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101339 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101345 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101349 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101352 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101358 */     GIR_RootConstrainSelectedInstOperands,
     /* 101359 */     // GIR_Coverage, 312,
     /* 101359 */     GIR_EraseRootFromParent_Done,
     /* 101360 */   // Label 1859: @101360
     /* 101360 */   GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(101406), // Rule ID 475 //
     /* 101365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101380 */     // (sra:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2ASRrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2ASRrr),
     /* 101383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101392 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101398 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101404 */     GIR_RootConstrainSelectedInstOperands,
     /* 101405 */     // GIR_Coverage, 475,
     /* 101405 */     GIR_EraseRootFromParent_Done,
     /* 101406 */   // Label 1860: @101406
     /* 101406 */   GIM_Reject,
     /* 101407 */ // Label 1855: @101407
     /* 101407 */ GIM_Reject,
     /* 101408 */ // Label 26: @101408
     /* 101408 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(101739),
     /* 101413 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 101416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 101419 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 101422 */   GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(101477), // Rule ID 200 //
     /* 101427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 101430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 101451 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101455 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101457 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (REV16:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 101457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV16),
     /* 101460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101469 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101475 */     GIR_RootConstrainSelectedInstOperands,
     /* 101476 */     // GIR_Coverage, 200,
     /* 101476 */     GIR_EraseRootFromParent_Done,
     /* 101477 */   // Label 1862: @101477
     /* 101477 */   GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(101532), // Rule ID 327 //
     /* 101482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 101485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101506 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101512 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (tREV16:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 101512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV16),
     /* 101515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101530 */     GIR_RootConstrainSelectedInstOperands,
     /* 101531 */     // GIR_Coverage, 327,
     /* 101531 */     GIR_EraseRootFromParent_Done,
     /* 101532 */   // Label 1863: @101532
     /* 101532 */   GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(101646),
     /* 101537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101541 */     GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(101592), // Rule ID 537 //
     /* 101546 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101549 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 101553 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 101557 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 101561 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101566 */       GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 101570 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101572 */       // (rotr:{ *:[i32] } (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm), 16:{ *:[i32] })  =>  (t2REV16:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 101572 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV16),
     /* 101575 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101577 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 101581 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101584 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101590 */       GIR_RootConstrainSelectedInstOperands,
     /* 101591 */       // GIR_Coverage, 537,
     /* 101591 */       GIR_EraseRootFromParent_Done,
     /* 101592 */     // Label 1865: @101592
     /* 101592 */     GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(101645), // Rule ID 476 //
     /* 101597 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101600 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101604 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101608 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 101612 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm1_31),
     /* 101616 */       // MIs[1] Operand 1
     /* 101616 */       // No operand predicates
     /* 101616 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101618 */       // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm1_31>>:$imm)  =>  (t2RORri:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 101618 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORri),
     /* 101621 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101623 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 101625 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 101628 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101631 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101637 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101643 */       GIR_RootConstrainSelectedInstOperands,
     /* 101644 */       // GIR_Coverage, 476,
     /* 101644 */       GIR_EraseRootFromParent_Done,
     /* 101645 */     // Label 1866: @101645
     /* 101645 */     GIM_Reject,
     /* 101646 */   // Label 1864: @101646
     /* 101646 */   GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(101692), // Rule ID 329 //
     /* 101651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 101654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 101666 */     // (rotr:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)  =>  (tROR:{ *:[i32] } tGPR:{ *:[i32] }:$Rn, tGPR:{ *:[i32] }:$Rm)
     /* 101666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tROR),
     /* 101669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 101671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 101677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101684 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101690 */     GIR_RootConstrainSelectedInstOperands,
     /* 101691 */     // GIR_Coverage, 329,
     /* 101691 */     GIR_EraseRootFromParent_Done,
     /* 101692 */   // Label 1867: @101692
     /* 101692 */   GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(101738), // Rule ID 477 //
     /* 101697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 101700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 101712 */     // (rotr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2RORrr:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 101712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RORrr),
     /* 101715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 101717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 101721 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 101724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101736 */     GIR_RootConstrainSelectedInstOperands,
     /* 101737 */     // GIR_Coverage, 477,
     /* 101737 */     GIR_EraseRootFromParent_Done,
     /* 101738 */   // Label 1868: @101738
     /* 101738 */   GIM_Reject,
     /* 101739 */ // Label 1861: @101739
     /* 101739 */ GIM_Reject,
     /* 101740 */ // Label 27: @101740
     /* 101740 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 1872*/ GIMT_Encode4(101987),
     /* 101751 */ /*GILLT_v4s32*//*Label 1869*/ GIMT_Encode4(101783), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101767 */ /*GILLT_v8s16*//*Label 1870*/ GIMT_Encode4(101851), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 101779 */ /*GILLT_v16s8*//*Label 1871*/ GIMT_Encode4(101919),
     /* 101783 */ // Label 1869: @101783
     /* 101783 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(101850), // Rule ID 4461 //
     /* 101788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101809 */   // (mulhu:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 101809 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101812 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101816 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu32),
     /* 101824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101826 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101828 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101830 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101833 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101839 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101845 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101848 */   GIR_RootConstrainSelectedInstOperands,
     /* 101849 */   // GIR_Coverage, 4461,
     /* 101849 */   GIR_EraseRootFromParent_Done,
     /* 101850 */ // Label 1873: @101850
     /* 101850 */ GIM_Reject,
     /* 101851 */ // Label 1870: @101851
     /* 101851 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(101918), // Rule ID 4457 //
     /* 101856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 101862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 101865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101873 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101877 */   // (mulhu:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 101877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu16),
     /* 101892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101894 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101896 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101898 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101901 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101907 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101913 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101916 */   GIR_RootConstrainSelectedInstOperands,
     /* 101917 */   // GIR_Coverage, 4457,
     /* 101917 */   GIR_EraseRootFromParent_Done,
     /* 101918 */ // Label 1874: @101918
     /* 101918 */ GIM_Reject,
     /* 101919 */ // Label 1871: @101919
     /* 101919 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(101986), // Rule ID 4453 //
     /* 101924 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 101927 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 101930 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 101933 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101937 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101941 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 101945 */   // (mulhu:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 101945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHu8),
     /* 101960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 101962 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 101964 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 101966 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101969 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101975 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 101981 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101984 */   GIR_RootConstrainSelectedInstOperands,
     /* 101985 */   // GIR_Coverage, 4453,
     /* 101985 */   GIR_EraseRootFromParent_Done,
     /* 101986 */ // Label 1875: @101986
     /* 101986 */ GIM_Reject,
     /* 101987 */ // Label 1872: @101987
     /* 101987 */ GIM_Reject,
     /* 101988 */ // Label 28: @101988
     /* 101988 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1880*/ GIMT_Encode4(102356),
     /* 101999 */ /*GILLT_s32*//*Label 1876*/ GIMT_Encode4(102059), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102027 */ /*GILLT_v4s32*//*Label 1877*/ GIMT_Encode4(102152), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102043 */ /*GILLT_v8s16*//*Label 1878*/ GIMT_Encode4(102220), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102055 */ /*GILLT_v16s8*//*Label 1879*/ GIMT_Encode4(102288),
     /* 102059 */ // Label 1876: @102059
     /* 102059 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(102151),
     /* 102064 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 102067 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 102070 */   GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(102110), // Rule ID 178 //
     /* 102075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 102078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 102090 */     // (mulhs:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)  =>  (SMMUL:{ *:[i32] } GPR:{ *:[i32] }:$Rn, GPR:{ *:[i32] }:$Rm)
     /* 102090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::SMMUL),
     /* 102093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102099 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102102 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102108 */     GIR_RootConstrainSelectedInstOperands,
     /* 102109 */     // GIR_Coverage, 178,
     /* 102109 */     GIR_EraseRootFromParent_Done,
     /* 102110 */   // Label 1882: @102110
     /* 102110 */   GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(102150), // Rule ID 507 //
     /* 102115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 102118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102122 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 102130 */     // (mulhs:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)  =>  (t2SMMUL:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rm)
     /* 102130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2SMMUL),
     /* 102133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 102137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 102139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102142 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102148 */     GIR_RootConstrainSelectedInstOperands,
     /* 102149 */     // GIR_Coverage, 507,
     /* 102149 */     GIR_EraseRootFromParent_Done,
     /* 102150 */   // Label 1883: @102150
     /* 102150 */   GIM_Reject,
     /* 102151 */ // Label 1881: @102151
     /* 102151 */ GIM_Reject,
     /* 102152 */ // Label 1877: @102152
     /* 102152 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(102219), // Rule ID 4449 //
     /* 102157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102178 */   // (mulhs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMULHs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102178 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102181 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102185 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs32),
     /* 102193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102195 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102197 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102199 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102202 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102208 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102217 */   GIR_RootConstrainSelectedInstOperands,
     /* 102218 */   // GIR_Coverage, 4449,
     /* 102218 */   GIR_EraseRootFromParent_Done,
     /* 102219 */ // Label 1884: @102219
     /* 102219 */ GIM_Reject,
     /* 102220 */ // Label 1878: @102220
     /* 102220 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(102287), // Rule ID 4445 //
     /* 102225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102246 */   // (mulhs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMULHs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102246 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102249 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102253 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102258 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs16),
     /* 102261 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102263 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102265 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102267 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102270 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102276 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102282 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102285 */   GIR_RootConstrainSelectedInstOperands,
     /* 102286 */   // GIR_Coverage, 4445,
     /* 102286 */   GIR_EraseRootFromParent_Done,
     /* 102287 */ // Label 1885: @102287
     /* 102287 */ GIM_Reject,
     /* 102288 */ // Label 1879: @102288
     /* 102288 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(102355), // Rule ID 4442 //
     /* 102293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102299 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102310 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102314 */   // (mulhs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMULHs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102314 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102317 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102321 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102326 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULHs8),
     /* 102329 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102331 */   GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102333 */   GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102335 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102338 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102344 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102350 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102353 */   GIR_RootConstrainSelectedInstOperands,
     /* 102354 */   // GIR_Coverage, 4442,
     /* 102354 */   GIR_EraseRootFromParent_Done,
     /* 102355 */ // Label 1886: @102355
     /* 102355 */ GIM_Reject,
     /* 102356 */ // Label 1880: @102356
     /* 102356 */ GIM_Reject,
     /* 102357 */ // Label 29: @102357
     /* 102357 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1895*/ GIMT_Encode4(103001),
     /* 102368 */ /*GILLT_s64*//*Label 1887*/ GIMT_Encode4(102424), GIMT_Encode4(0),
     /* 102376 */ /*GILLT_v2s32*//*Label 1888*/ GIMT_Encode4(102471),
     /* 102380 */ /*GILLT_v2s64*//*Label 1889*/ GIMT_Encode4(102518), GIMT_Encode4(0),
     /* 102388 */ /*GILLT_v4s16*//*Label 1890*/ GIMT_Encode4(102565),
     /* 102392 */ /*GILLT_v4s32*//*Label 1891*/ GIMT_Encode4(102612), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102404 */ /*GILLT_v8s8*//*Label 1892*/ GIMT_Encode4(102726),
     /* 102408 */ /*GILLT_v8s16*//*Label 1893*/ GIMT_Encode4(102773), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 102420 */ /*GILLT_v16s8*//*Label 1894*/ GIMT_Encode4(102887),
     /* 102424 */ // Label 1887: @102424
     /* 102424 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(102470), // Rule ID 827 //
     /* 102429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 102435 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 102438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102446 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102450 */   // (uaddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 102450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv1i64),
     /* 102453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102455 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102457 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102459 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102462 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102468 */   GIR_RootConstrainSelectedInstOperands,
     /* 102469 */   // GIR_Coverage, 827,
     /* 102469 */   GIR_EraseRootFromParent_Done,
     /* 102470 */ // Label 1896: @102470
     /* 102470 */ GIM_Reject,
     /* 102471 */ // Label 1888: @102471
     /* 102471 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(102517), // Rule ID 822 //
     /* 102476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 102482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 102485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102489 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102493 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102497 */   // (uaddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 102497 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i32),
     /* 102500 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102502 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102504 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102506 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102509 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102515 */   GIR_RootConstrainSelectedInstOperands,
     /* 102516 */   // GIR_Coverage, 822,
     /* 102516 */   GIR_EraseRootFromParent_Done,
     /* 102517 */ // Label 1897: @102517
     /* 102517 */ GIM_Reject,
     /* 102518 */ // Label 1889: @102518
     /* 102518 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(102564), // Rule ID 828 //
     /* 102523 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 102529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 102532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102536 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102540 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102544 */   // (uaddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 102544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv2i64),
     /* 102547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102549 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102551 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102553 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102556 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102562 */   GIR_RootConstrainSelectedInstOperands,
     /* 102563 */   // GIR_Coverage, 828,
     /* 102563 */   GIR_EraseRootFromParent_Done,
     /* 102564 */ // Label 1898: @102564
     /* 102564 */ GIM_Reject,
     /* 102565 */ // Label 1890: @102565
     /* 102565 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(102611), // Rule ID 821 //
     /* 102570 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102573 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 102576 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 102579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102583 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102587 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102591 */   // (uaddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 102591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i16),
     /* 102594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102596 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102598 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102603 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102609 */   GIR_RootConstrainSelectedInstOperands,
     /* 102610 */   // GIR_Coverage, 821,
     /* 102610 */   GIR_EraseRootFromParent_Done,
     /* 102611 */ // Label 1899: @102611
     /* 102611 */ GIM_Reject,
     /* 102612 */ // Label 1891: @102612
     /* 102612 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(102725),
     /* 102617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102620 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102623 */   GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(102663), // Rule ID 824 //
     /* 102628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102635 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102643 */     // (uaddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 102643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv4i32),
     /* 102646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102648 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102652 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102661 */     GIR_RootConstrainSelectedInstOperands,
     /* 102662 */     // GIR_Coverage, 824,
     /* 102662 */     GIR_EraseRootFromParent_Done,
     /* 102663 */   // Label 1901: @102663
     /* 102663 */   GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(102724), // Rule ID 3524 //
     /* 102668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102683 */     // (uaddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 102683 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102686 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102690 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu32),
     /* 102698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102707 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102713 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102722 */     GIR_RootConstrainSelectedInstOperands,
     /* 102723 */     // GIR_Coverage, 3524,
     /* 102723 */     GIR_EraseRootFromParent_Done,
     /* 102724 */   // Label 1902: @102724
     /* 102724 */   GIM_Reject,
     /* 102725 */ // Label 1900: @102725
     /* 102725 */ GIM_Reject,
     /* 102726 */ // Label 1892: @102726
     /* 102726 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(102772), // Rule ID 825 //
     /* 102731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 102737 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 102740 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102744 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102748 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 102752 */   // (uaddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 102752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i8),
     /* 102755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102757 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102759 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102761 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102764 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102770 */   GIR_RootConstrainSelectedInstOperands,
     /* 102771 */   // GIR_Coverage, 825,
     /* 102771 */   GIR_EraseRootFromParent_Done,
     /* 102772 */ // Label 1903: @102772
     /* 102772 */ GIM_Reject,
     /* 102773 */ // Label 1893: @102773
     /* 102773 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(102886),
     /* 102778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 102781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 102784 */   GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(102824), // Rule ID 823 //
     /* 102789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102804 */     // (uaddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 102804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv8i16),
     /* 102807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102816 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102822 */     GIR_RootConstrainSelectedInstOperands,
     /* 102823 */     // GIR_Coverage, 823,
     /* 102823 */     GIR_EraseRootFromParent_Done,
     /* 102824 */   // Label 1905: @102824
     /* 102824 */   GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(102885), // Rule ID 3521 //
     /* 102829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102836 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102844 */     // (uaddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 102844 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102847 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102851 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu16),
     /* 102859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102865 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102868 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102874 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102883 */     GIR_RootConstrainSelectedInstOperands,
     /* 102884 */     // GIR_Coverage, 3521,
     /* 102884 */     GIR_EraseRootFromParent_Done,
     /* 102885 */   // Label 1906: @102885
     /* 102885 */   GIM_Reject,
     /* 102886 */ // Label 1904: @102886
     /* 102886 */ GIM_Reject,
     /* 102887 */ // Label 1894: @102887
     /* 102887 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(103000),
     /* 102892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 102895 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 102898 */   GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(102938), // Rule ID 826 //
     /* 102903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 102918 */     // (uaddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 102918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDuv16i8),
     /* 102921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 102923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 102925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 102927 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 102930 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102936 */     GIR_RootConstrainSelectedInstOperands,
     /* 102937 */     // GIR_Coverage, 826,
     /* 102937 */     GIR_EraseRootFromParent_Done,
     /* 102938 */   // Label 1908: @102938
     /* 102938 */   GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(102999), // Rule ID 3518 //
     /* 102943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 102946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 102958 */     // (uaddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 102958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 102961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDu8),
     /* 102973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 102975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 102977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 102979 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102988 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 102994 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102997 */     GIR_RootConstrainSelectedInstOperands,
     /* 102998 */     // GIR_Coverage, 3518,
     /* 102998 */     GIR_EraseRootFromParent_Done,
     /* 102999 */   // Label 1909: @102999
     /* 102999 */   GIM_Reject,
     /* 103000 */ // Label 1907: @103000
     /* 103000 */ GIM_Reject,
     /* 103001 */ // Label 1895: @103001
     /* 103001 */ GIM_Reject,
     /* 103002 */ // Label 30: @103002
     /* 103002 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1919*/ GIMT_Encode4(104301),
     /* 103013 */ /*GILLT_s32*//*Label 1910*/ GIMT_Encode4(103073),
     /* 103017 */ /*GILLT_s64*//*Label 1911*/ GIMT_Encode4(103414), GIMT_Encode4(0),
     /* 103025 */ /*GILLT_v2s32*//*Label 1912*/ GIMT_Encode4(103461),
     /* 103029 */ /*GILLT_v2s64*//*Label 1913*/ GIMT_Encode4(103508), GIMT_Encode4(0),
     /* 103037 */ /*GILLT_v4s16*//*Label 1914*/ GIMT_Encode4(103709),
     /* 103041 */ /*GILLT_v4s32*//*Label 1915*/ GIMT_Encode4(103756), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103053 */ /*GILLT_v8s8*//*Label 1916*/ GIMT_Encode4(104026),
     /* 103057 */ /*GILLT_v8s16*//*Label 1917*/ GIMT_Encode4(104073), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 103069 */ /*GILLT_v16s8*//*Label 1918*/ GIMT_Encode4(104187),
     /* 103073 */ // Label 1910: @103073
     /* 103073 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(103413),
     /* 103078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 103081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 103084 */   GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(103146), // Rule ID 5651 //
     /* 103089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103113 */     // MIs[1] Rn
     /* 103113 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103124 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103144 */     GIR_RootConstrainSelectedInstOperands,
     /* 103145 */     // GIR_Coverage, 5651,
     /* 103145 */     GIR_EraseRootFromParent_Done,
     /* 103146 */   // Label 1921: @103146
     /* 103146 */   GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(103208), // Rule ID 5685 //
     /* 103151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103175 */     // MIs[1] Rn
     /* 103175 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103186 */     // (saddsat:{ *:[i32] } (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn), rGPR:{ *:[i32] }:$Rm)  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 103193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103197 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103200 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103206 */     GIR_RootConstrainSelectedInstOperands,
     /* 103207 */     // GIR_Coverage, 5685,
     /* 103207 */     GIR_EraseRootFromParent_Done,
     /* 103208 */   // Label 1922: @103208
     /* 103208 */   GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(103270), // Rule ID 1867 //
     /* 103213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103241 */     // MIs[1] Rn
     /* 103241 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103248 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDADD),
     /* 103251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103259 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103262 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103268 */     GIR_RootConstrainSelectedInstOperands,
     /* 103269 */     // GIR_Coverage, 1867,
     /* 103269 */     GIR_EraseRootFromParent_Done,
     /* 103270 */   // Label 1923: @103270
     /* 103270 */   GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(103332), // Rule ID 2133 //
     /* 103275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 103294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 103298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103303 */     // MIs[1] Rn
     /* 103303 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 103308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103310 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDADD),
     /* 103313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103321 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103324 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103330 */     GIR_RootConstrainSelectedInstOperands,
     /* 103331 */     // GIR_Coverage, 2133,
     /* 103331 */     GIR_EraseRootFromParent_Done,
     /* 103332 */   // Label 1924: @103332
     /* 103332 */   GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(103372), // Rule ID 1865 //
     /* 103337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 103340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 103344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 103352 */     // (saddsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QADD:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 103352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QADD),
     /* 103355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103357 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 103359 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 103361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103370 */     GIR_RootConstrainSelectedInstOperands,
     /* 103371 */     // GIR_Coverage, 1865,
     /* 103371 */     GIR_EraseRootFromParent_Done,
     /* 103372 */   // Label 1925: @103372
     /* 103372 */   GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(103412), // Rule ID 2131 //
     /* 103377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 103380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103384 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 103392 */     // (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QADD:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 103392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QADD),
     /* 103395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103397 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 103399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 103401 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103404 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103410 */     GIR_RootConstrainSelectedInstOperands,
     /* 103411 */     // GIR_Coverage, 2131,
     /* 103411 */     GIR_EraseRootFromParent_Done,
     /* 103412 */   // Label 1926: @103412
     /* 103412 */   GIM_Reject,
     /* 103413 */ // Label 1920: @103413
     /* 103413 */ GIM_Reject,
     /* 103414 */ // Label 1911: @103414
     /* 103414 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(103460), // Rule ID 819 //
     /* 103419 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103422 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 103425 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 103428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103436 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103440 */   // (saddsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQADDsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 103440 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv1i64),
     /* 103443 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103445 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103447 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103449 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103452 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103458 */   GIR_RootConstrainSelectedInstOperands,
     /* 103459 */   // GIR_Coverage, 819,
     /* 103459 */   GIR_EraseRootFromParent_Done,
     /* 103460 */ // Label 1927: @103460
     /* 103460 */ GIM_Reject,
     /* 103461 */ // Label 1912: @103461
     /* 103461 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(103507), // Rule ID 814 //
     /* 103466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 103472 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103483 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103487 */   // (saddsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQADDsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103487 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i32),
     /* 103490 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103492 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103494 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103496 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103499 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103505 */   GIR_RootConstrainSelectedInstOperands,
     /* 103506 */   // GIR_Coverage, 814,
     /* 103506 */   GIR_EraseRootFromParent_Done,
     /* 103507 */ // Label 1928: @103507
     /* 103507 */ GIM_Reject,
     /* 103508 */ // Label 1913: @103508
     /* 103508 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(103708),
     /* 103513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 103516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 103519 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103523 */   GIM_Try, /*On fail goto*//*Label 1930*/ GIMT_Encode4(103597), // Rule ID 5742 //
     /* 103528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103539 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103542 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103569 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103571 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm), QPR:{ *:[v2i64] }:$src1)  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103576 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103589 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103595 */     GIR_RootConstrainSelectedInstOperands,
     /* 103596 */     // GIR_Coverage, 5742,
     /* 103596 */     GIR_EraseRootFromParent_Done,
     /* 103597 */   // Label 1930: @103597
     /* 103597 */   GIM_Try, /*On fail goto*//*Label 1931*/ GIMT_Encode4(103671), // Rule ID 2486 //
     /* 103602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103605 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103617 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103620 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 103629 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 103633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103643 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103645 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLALv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 103645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv2i64),
     /* 103648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103650 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103656 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103660 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103663 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103669 */     GIR_RootConstrainSelectedInstOperands,
     /* 103670 */     // GIR_Coverage, 2486,
     /* 103670 */     GIR_EraseRootFromParent_Done,
     /* 103671 */   // Label 1931: @103671
     /* 103671 */   GIM_Try, /*On fail goto*//*Label 1932*/ GIMT_Encode4(103707), // Rule ID 820 //
     /* 103676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103679 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103687 */     // (saddsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQADDsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 103687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv2i64),
     /* 103690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103692 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103705 */     GIR_RootConstrainSelectedInstOperands,
     /* 103706 */     // GIR_Coverage, 820,
     /* 103706 */     GIR_EraseRootFromParent_Done,
     /* 103707 */   // Label 1932: @103707
     /* 103707 */   GIM_Reject,
     /* 103708 */ // Label 1929: @103708
     /* 103708 */ GIM_Reject,
     /* 103709 */ // Label 1914: @103709
     /* 103709 */ GIM_Try, /*On fail goto*//*Label 1933*/ GIMT_Encode4(103755), // Rule ID 813 //
     /* 103714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 103720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103731 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103735 */   // (saddsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQADDsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i16),
     /* 103738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103740 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103742 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103744 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103747 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103753 */   GIR_RootConstrainSelectedInstOperands,
     /* 103754 */   // GIR_Coverage, 813,
     /* 103754 */   GIR_EraseRootFromParent_Done,
     /* 103755 */ // Label 1933: @103755
     /* 103755 */ GIM_Reject,
     /* 103756 */ // Label 1915: @103756
     /* 103756 */ GIM_Try, /*On fail goto*//*Label 1934*/ GIMT_Encode4(104025),
     /* 103761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103764 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103767 */   GIM_Try, /*On fail goto*//*Label 1935*/ GIMT_Encode4(103845), // Rule ID 5741 //
     /* 103772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103787 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103790 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103795 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103799 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103817 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103819 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm), QPR:{ *:[v4i32] }:$src1)  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103824 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 103826 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103830 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103837 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103843 */     GIR_RootConstrainSelectedInstOperands,
     /* 103844 */     // GIR_Coverage, 5741,
     /* 103844 */     GIR_EraseRootFromParent_Done,
     /* 103845 */   // Label 1935: @103845
     /* 103845 */   GIM_Try, /*On fail goto*//*Label 1936*/ GIMT_Encode4(103923), // Rule ID 2485 //
     /* 103850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103869 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103872 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 103877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 103881 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 103885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103890 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 103895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103897 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLALv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 103897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLALv4i32),
     /* 103900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103902 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 103904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 103908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 103912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103915 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103921 */     GIR_RootConstrainSelectedInstOperands,
     /* 103922 */     // GIR_Coverage, 2485,
     /* 103922 */     GIR_EraseRootFromParent_Done,
     /* 103923 */   // Label 1936: @103923
     /* 103923 */   GIM_Try, /*On fail goto*//*Label 1937*/ GIMT_Encode4(103963), // Rule ID 816 //
     /* 103928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 103943 */     // (saddsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQADDsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 103943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv4i32),
     /* 103946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 103948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 103950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 103952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 103955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 103961 */     GIR_RootConstrainSelectedInstOperands,
     /* 103962 */     // GIR_Coverage, 816,
     /* 103962 */     GIR_EraseRootFromParent_Done,
     /* 103963 */   // Label 1937: @103963
     /* 103963 */   GIM_Try, /*On fail goto*//*Label 1938*/ GIMT_Encode4(104024), // Rule ID 3515 //
     /* 103968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 103971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 103983 */     // (saddsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQADDs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 103983 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 103986 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103990 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs32),
     /* 103998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104000 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104004 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104013 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104022 */     GIR_RootConstrainSelectedInstOperands,
     /* 104023 */     // GIR_Coverage, 3515,
     /* 104023 */     GIR_EraseRootFromParent_Done,
     /* 104024 */   // Label 1938: @104024
     /* 104024 */   GIM_Reject,
     /* 104025 */ // Label 1934: @104025
     /* 104025 */ GIM_Reject,
     /* 104026 */ // Label 1916: @104026
     /* 104026 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(104072), // Rule ID 817 //
     /* 104031 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104034 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104037 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104048 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104052 */   // (saddsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQADDsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104052 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i8),
     /* 104055 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104057 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104059 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104061 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104064 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104070 */   GIR_RootConstrainSelectedInstOperands,
     /* 104071 */   // GIR_Coverage, 817,
     /* 104071 */   GIR_EraseRootFromParent_Done,
     /* 104072 */ // Label 1939: @104072
     /* 104072 */ GIM_Reject,
     /* 104073 */ // Label 1917: @104073
     /* 104073 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(104186),
     /* 104078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104084 */   GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(104124), // Rule ID 815 //
     /* 104089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104104 */     // (saddsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQADDsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv8i16),
     /* 104107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104111 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104116 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104122 */     GIR_RootConstrainSelectedInstOperands,
     /* 104123 */     // GIR_Coverage, 815,
     /* 104123 */     GIR_EraseRootFromParent_Done,
     /* 104124 */   // Label 1941: @104124
     /* 104124 */   GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(104185), // Rule ID 3512 //
     /* 104129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104140 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104144 */     // (saddsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQADDs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs16),
     /* 104159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104161 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104165 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104168 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104174 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104180 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104183 */     GIR_RootConstrainSelectedInstOperands,
     /* 104184 */     // GIR_Coverage, 3512,
     /* 104184 */     GIR_EraseRootFromParent_Done,
     /* 104185 */   // Label 1942: @104185
     /* 104185 */   GIM_Reject,
     /* 104186 */ // Label 1940: @104186
     /* 104186 */ GIM_Reject,
     /* 104187 */ // Label 1918: @104187
     /* 104187 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(104300),
     /* 104192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104198 */   GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(104238), // Rule ID 818 //
     /* 104203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104210 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104218 */     // (saddsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQADDsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQADDsv16i8),
     /* 104221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104227 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104236 */     GIR_RootConstrainSelectedInstOperands,
     /* 104237 */     // GIR_Coverage, 818,
     /* 104237 */     GIR_EraseRootFromParent_Done,
     /* 104238 */   // Label 1944: @104238
     /* 104238 */   GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(104299), // Rule ID 3509 //
     /* 104243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104250 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104258 */     // (saddsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQADDs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104258 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104261 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104265 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQADDs8),
     /* 104273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104282 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104288 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104297 */     GIR_RootConstrainSelectedInstOperands,
     /* 104298 */     // GIR_Coverage, 3509,
     /* 104298 */     GIR_EraseRootFromParent_Done,
     /* 104299 */   // Label 1945: @104299
     /* 104299 */   GIM_Reject,
     /* 104300 */ // Label 1943: @104300
     /* 104300 */ GIM_Reject,
     /* 104301 */ // Label 1919: @104301
     /* 104301 */ GIM_Reject,
     /* 104302 */ // Label 31: @104302
     /* 104302 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(16), /*)*//*default:*//*Label 1954*/ GIMT_Encode4(104946),
     /* 104313 */ /*GILLT_s64*//*Label 1946*/ GIMT_Encode4(104369), GIMT_Encode4(0),
     /* 104321 */ /*GILLT_v2s32*//*Label 1947*/ GIMT_Encode4(104416),
     /* 104325 */ /*GILLT_v2s64*//*Label 1948*/ GIMT_Encode4(104463), GIMT_Encode4(0),
     /* 104333 */ /*GILLT_v4s16*//*Label 1949*/ GIMT_Encode4(104510),
     /* 104337 */ /*GILLT_v4s32*//*Label 1950*/ GIMT_Encode4(104557), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104349 */ /*GILLT_v8s8*//*Label 1951*/ GIMT_Encode4(104671),
     /* 104353 */ /*GILLT_v8s16*//*Label 1952*/ GIMT_Encode4(104718), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104365 */ /*GILLT_v16s8*//*Label 1953*/ GIMT_Encode4(104832),
     /* 104369 */ // Label 1946: @104369
     /* 104369 */ GIM_Try, /*On fail goto*//*Label 1955*/ GIMT_Encode4(104415), // Rule ID 1019 //
     /* 104374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 104380 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 104383 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104387 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104391 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104395 */   // (usubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBuv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 104395 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv1i64),
     /* 104398 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104400 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104402 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104404 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104407 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104413 */   GIR_RootConstrainSelectedInstOperands,
     /* 104414 */   // GIR_Coverage, 1019,
     /* 104414 */   GIR_EraseRootFromParent_Done,
     /* 104415 */ // Label 1955: @104415
     /* 104415 */ GIM_Reject,
     /* 104416 */ // Label 1947: @104416
     /* 104416 */ GIM_Try, /*On fail goto*//*Label 1956*/ GIMT_Encode4(104462), // Rule ID 1014 //
     /* 104421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 104427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 104430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104442 */   // (usubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 104442 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i32),
     /* 104445 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104447 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104449 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104451 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104454 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104460 */   GIR_RootConstrainSelectedInstOperands,
     /* 104461 */   // GIR_Coverage, 1014,
     /* 104461 */   GIR_EraseRootFromParent_Done,
     /* 104462 */ // Label 1956: @104462
     /* 104462 */ GIM_Reject,
     /* 104463 */ // Label 1948: @104463
     /* 104463 */ GIM_Try, /*On fail goto*//*Label 1957*/ GIMT_Encode4(104509), // Rule ID 1020 //
     /* 104468 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104471 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 104474 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 104477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104481 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104485 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104489 */   // (usubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBuv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 104489 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv2i64),
     /* 104492 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104494 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104496 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104498 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104501 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104507 */   GIR_RootConstrainSelectedInstOperands,
     /* 104508 */   // GIR_Coverage, 1020,
     /* 104508 */   GIR_EraseRootFromParent_Done,
     /* 104509 */ // Label 1957: @104509
     /* 104509 */ GIM_Reject,
     /* 104510 */ // Label 1949: @104510
     /* 104510 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(104556), // Rule ID 1013 //
     /* 104515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 104521 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 104524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104528 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104532 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104536 */   // (usubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 104536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i16),
     /* 104539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104541 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104543 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104545 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104548 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104554 */   GIR_RootConstrainSelectedInstOperands,
     /* 104555 */   // GIR_Coverage, 1013,
     /* 104555 */   GIR_EraseRootFromParent_Done,
     /* 104556 */ // Label 1958: @104556
     /* 104556 */ GIM_Reject,
     /* 104557 */ // Label 1950: @104557
     /* 104557 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(104670),
     /* 104562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 104565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 104568 */   GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(104608), // Rule ID 1016 //
     /* 104573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104580 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104588 */     // (usubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 104588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv4i32),
     /* 104591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104593 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104606 */     GIR_RootConstrainSelectedInstOperands,
     /* 104607 */     // GIR_Coverage, 1016,
     /* 104607 */     GIR_EraseRootFromParent_Done,
     /* 104608 */   // Label 1960: @104608
     /* 104608 */   GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(104669), // Rule ID 3542 //
     /* 104613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104628 */     // (usubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 104628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu32),
     /* 104643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104645 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104649 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104658 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104664 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104667 */     GIR_RootConstrainSelectedInstOperands,
     /* 104668 */     // GIR_Coverage, 3542,
     /* 104668 */     GIR_EraseRootFromParent_Done,
     /* 104669 */   // Label 1961: @104669
     /* 104669 */   GIM_Reject,
     /* 104670 */ // Label 1959: @104670
     /* 104670 */ GIM_Reject,
     /* 104671 */ // Label 1951: @104671
     /* 104671 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(104717), // Rule ID 1017 //
     /* 104676 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104679 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104682 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104693 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 104697 */   // (usubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 104697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i8),
     /* 104700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104702 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104704 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104709 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104715 */   GIR_RootConstrainSelectedInstOperands,
     /* 104716 */   // GIR_Coverage, 1017,
     /* 104716 */   GIR_EraseRootFromParent_Done,
     /* 104717 */ // Label 1962: @104717
     /* 104717 */ GIM_Reject,
     /* 104718 */ // Label 1952: @104718
     /* 104718 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(104831),
     /* 104723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104729 */   GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(104769), // Rule ID 1015 //
     /* 104734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104745 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104749 */     // (usubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 104749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv8i16),
     /* 104752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104754 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104761 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104767 */     GIR_RootConstrainSelectedInstOperands,
     /* 104768 */     // GIR_Coverage, 1015,
     /* 104768 */     GIR_EraseRootFromParent_Done,
     /* 104769 */   // Label 1964: @104769
     /* 104769 */   GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(104830), // Rule ID 3539 //
     /* 104774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104789 */     // (usubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 104789 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104792 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104796 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu16),
     /* 104804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104813 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104819 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104825 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104828 */     GIR_RootConstrainSelectedInstOperands,
     /* 104829 */     // GIR_Coverage, 3539,
     /* 104829 */     GIR_EraseRootFromParent_Done,
     /* 104830 */   // Label 1965: @104830
     /* 104830 */   GIM_Reject,
     /* 104831 */ // Label 1963: @104831
     /* 104831 */ GIM_Reject,
     /* 104832 */ // Label 1953: @104832
     /* 104832 */ GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(104945),
     /* 104837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 104840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 104843 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(104883), // Rule ID 1018 //
     /* 104848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 104863 */     // (usubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 104863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBuv16i8),
     /* 104866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 104868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 104870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 104872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 104875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104881 */     GIR_RootConstrainSelectedInstOperands,
     /* 104882 */     // GIR_Coverage, 1018,
     /* 104882 */     GIR_EraseRootFromParent_Done,
     /* 104883 */   // Label 1967: @104883
     /* 104883 */   GIM_Try, /*On fail goto*//*Label 1968*/ GIMT_Encode4(104944), // Rule ID 3536 //
     /* 104888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 104891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 104903 */     // (usubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 104903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 104906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBu8),
     /* 104918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 104920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 104922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 104924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104933 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 104939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104942 */     GIR_RootConstrainSelectedInstOperands,
     /* 104943 */     // GIR_Coverage, 3536,
     /* 104943 */     GIR_EraseRootFromParent_Done,
     /* 104944 */   // Label 1968: @104944
     /* 104944 */   GIM_Reject,
     /* 104945 */ // Label 1966: @104945
     /* 104945 */ GIM_Reject,
     /* 104946 */ // Label 1954: @104946
     /* 104946 */ GIM_Reject,
     /* 104947 */ // Label 32: @104947
     /* 104947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 1978*/ GIMT_Encode4(105966),
     /* 104958 */ /*GILLT_s32*//*Label 1969*/ GIMT_Encode4(105018),
     /* 104962 */ /*GILLT_s64*//*Label 1970*/ GIMT_Encode4(105235), GIMT_Encode4(0),
     /* 104970 */ /*GILLT_v2s32*//*Label 1971*/ GIMT_Encode4(105282),
     /* 104974 */ /*GILLT_v2s64*//*Label 1972*/ GIMT_Encode4(105329), GIMT_Encode4(0),
     /* 104982 */ /*GILLT_v4s16*//*Label 1973*/ GIMT_Encode4(105452),
     /* 104986 */ /*GILLT_v4s32*//*Label 1974*/ GIMT_Encode4(105499), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 104998 */ /*GILLT_v8s8*//*Label 1975*/ GIMT_Encode4(105691),
     /* 105002 */ /*GILLT_v8s16*//*Label 1976*/ GIMT_Encode4(105738), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 105014 */ /*GILLT_v16s8*//*Label 1977*/ GIMT_Encode4(105852),
     /* 105018 */ // Label 1969: @105018
     /* 105018 */ GIM_Try, /*On fail goto*//*Label 1979*/ GIMT_Encode4(105234),
     /* 105023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 105026 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 105029 */   GIM_Try, /*On fail goto*//*Label 1980*/ GIMT_Encode4(105091), // Rule ID 1868 //
     /* 105034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105045 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105049 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105053 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105062 */     // MIs[1] Rn
     /* 105062 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105069 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QDSUB),
     /* 105072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105080 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105083 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105089 */     GIR_RootConstrainSelectedInstOperands,
     /* 105090 */     // GIR_Coverage, 1868,
     /* 105090 */     GIR_EraseRootFromParent_Done,
     /* 105091 */   // Label 1980: @105091
     /* 105091 */   GIM_Try, /*On fail goto*//*Label 1981*/ GIMT_Encode4(105153), // Rule ID 2134 //
     /* 105096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105103 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SADDSAT),
     /* 105115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 105119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105124 */     // MIs[1] Rn
     /* 105124 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 105129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105131 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, (saddsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rn, rGPR:{ *:[i32] }:$Rn))  =>  (t2QDSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QDSUB),
     /* 105134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105136 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105145 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105151 */     GIR_RootConstrainSelectedInstOperands,
     /* 105152 */     // GIR_Coverage, 2134,
     /* 105152 */     GIR_EraseRootFromParent_Done,
     /* 105153 */   // Label 1981: @105153
     /* 105153 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(105193), // Rule ID 1866 //
     /* 105158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5TE_IsARM),
     /* 105161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 105165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 105173 */     // (ssubsat:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)  =>  (QSUB:{ *:[i32] } GPR:{ *:[i32] }:$a, GPR:{ *:[i32] }:$b)
     /* 105173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::QSUB),
     /* 105176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105178 */     GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 105180 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 105182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105191 */     GIR_RootConstrainSelectedInstOperands,
     /* 105192 */     // GIR_Coverage, 1866,
     /* 105192 */     GIR_EraseRootFromParent_Done,
     /* 105193 */   // Label 1982: @105193
     /* 105193 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(105233), // Rule ID 2132 //
     /* 105198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDSP_IsThumb2),
     /* 105201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 105213 */     // (ssubsat:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)  =>  (t2QSUB:{ *:[i32] } rGPR:{ *:[i32] }:$Rm, rGPR:{ *:[i32] }:$Rn)
     /* 105213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2QSUB),
     /* 105216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 105220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 105222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105231 */     GIR_RootConstrainSelectedInstOperands,
     /* 105232 */     // GIR_Coverage, 2132,
     /* 105232 */     GIR_EraseRootFromParent_Done,
     /* 105233 */   // Label 1983: @105233
     /* 105233 */   GIM_Reject,
     /* 105234 */ // Label 1979: @105234
     /* 105234 */ GIM_Reject,
     /* 105235 */ // Label 1970: @105235
     /* 105235 */ GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(105281), // Rule ID 1011 //
     /* 105240 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105243 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 105246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 105249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105257 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105261 */   // (ssubsat:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)  =>  (VQSUBsv1i64:{ *:[v1i64] } DPR:{ *:[v1i64] }:$Vn, DPR:{ *:[v1i64] }:$Vm)
     /* 105261 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv1i64),
     /* 105264 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105266 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105268 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105270 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105273 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105279 */   GIR_RootConstrainSelectedInstOperands,
     /* 105280 */   // GIR_Coverage, 1011,
     /* 105280 */   GIR_EraseRootFromParent_Done,
     /* 105281 */ // Label 1984: @105281
     /* 105281 */ GIM_Reject,
     /* 105282 */ // Label 1971: @105282
     /* 105282 */ GIM_Try, /*On fail goto*//*Label 1985*/ GIMT_Encode4(105328), // Rule ID 1006 //
     /* 105287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 105293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105308 */   // (ssubsat:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VQSUBsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i32),
     /* 105311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105313 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105315 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105317 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105320 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105326 */   GIR_RootConstrainSelectedInstOperands,
     /* 105327 */   // GIR_Coverage, 1006,
     /* 105327 */   GIR_EraseRootFromParent_Done,
     /* 105328 */ // Label 1985: @105328
     /* 105328 */ GIM_Reject,
     /* 105329 */ // Label 1972: @105329
     /* 105329 */ GIM_Try, /*On fail goto*//*Label 1986*/ GIMT_Encode4(105451),
     /* 105334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 105337 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 105340 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105344 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105348 */   GIM_Try, /*On fail goto*//*Label 1987*/ GIMT_Encode4(105418), // Rule ID 2493 //
     /* 105353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 105376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 105380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105392 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, (intrinsic_wo_chain:{ *:[v2i64] } 3778:{ *:[iPTR] }, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm))  =>  (VQDMLSLv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$src1, DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 105392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv2i64),
     /* 105395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105397 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105407 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105410 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105416 */     GIR_RootConstrainSelectedInstOperands,
     /* 105417 */     // GIR_Coverage, 2493,
     /* 105417 */     GIR_EraseRootFromParent_Done,
     /* 105418 */   // Label 1987: @105418
     /* 105418 */   GIM_Try, /*On fail goto*//*Label 1988*/ GIMT_Encode4(105450), // Rule ID 1012 //
     /* 105423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105430 */     // (ssubsat:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)  =>  (VQSUBsv2i64:{ *:[v2i64] } QPR:{ *:[v2i64] }:$Vn, QPR:{ *:[v2i64] }:$Vm)
     /* 105430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv2i64),
     /* 105433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105439 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105442 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105448 */     GIR_RootConstrainSelectedInstOperands,
     /* 105449 */     // GIR_Coverage, 1012,
     /* 105449 */     GIR_EraseRootFromParent_Done,
     /* 105450 */   // Label 1988: @105450
     /* 105450 */   GIM_Reject,
     /* 105451 */ // Label 1986: @105451
     /* 105451 */ GIM_Reject,
     /* 105452 */ // Label 1973: @105452
     /* 105452 */ GIM_Try, /*On fail goto*//*Label 1989*/ GIMT_Encode4(105498), // Rule ID 1005 //
     /* 105457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 105463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105474 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105478 */   // (ssubsat:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VQSUBsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i16),
     /* 105481 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105483 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105485 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105487 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105490 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105496 */   GIR_RootConstrainSelectedInstOperands,
     /* 105497 */   // GIR_Coverage, 1005,
     /* 105497 */   GIR_EraseRootFromParent_Done,
     /* 105498 */ // Label 1989: @105498
     /* 105498 */ GIM_Reject,
     /* 105499 */ // Label 1974: @105499
     /* 105499 */ GIM_Try, /*On fail goto*//*Label 1990*/ GIMT_Encode4(105690),
     /* 105504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 105507 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 105510 */   GIM_Try, /*On fail goto*//*Label 1991*/ GIMT_Encode4(105588), // Rule ID 2492 //
     /* 105515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105522 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105534 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105537 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::arm_neon_vqdmull),
     /* 105542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 105546 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 105550 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105560 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105562 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, (intrinsic_wo_chain:{ *:[v4i32] } 3778:{ *:[iPTR] }, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm))  =>  (VQDMLSLv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$src1, DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 105562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQDMLSLv4i32),
     /* 105565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105567 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 105569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 105573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Vm
     /* 105577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105580 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105586 */     GIR_RootConstrainSelectedInstOperands,
     /* 105587 */     // GIR_Coverage, 2492,
     /* 105587 */     GIR_EraseRootFromParent_Done,
     /* 105588 */   // Label 1991: @105588
     /* 105588 */   GIM_Try, /*On fail goto*//*Label 1992*/ GIMT_Encode4(105628), // Rule ID 1008 //
     /* 105593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105608 */     // (ssubsat:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VQSUBsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 105608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv4i32),
     /* 105611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105620 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105626 */     GIR_RootConstrainSelectedInstOperands,
     /* 105627 */     // GIR_Coverage, 1008,
     /* 105627 */     GIR_EraseRootFromParent_Done,
     /* 105628 */   // Label 1992: @105628
     /* 105628 */   GIM_Try, /*On fail goto*//*Label 1993*/ GIMT_Encode4(105689), // Rule ID 3533 //
     /* 105633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105648 */     // (ssubsat:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VQSUBs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 105648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs32),
     /* 105663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105665 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105669 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105672 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105678 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105684 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105687 */     GIR_RootConstrainSelectedInstOperands,
     /* 105688 */     // GIR_Coverage, 3533,
     /* 105688 */     GIR_EraseRootFromParent_Done,
     /* 105689 */   // Label 1993: @105689
     /* 105689 */   GIM_Reject,
     /* 105690 */ // Label 1990: @105690
     /* 105690 */ GIM_Reject,
     /* 105691 */ // Label 1975: @105691
     /* 105691 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(105737), // Rule ID 1009 //
     /* 105696 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105699 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 105702 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 105705 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105709 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105713 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 105717 */   // (ssubsat:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VQSUBsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 105717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i8),
     /* 105720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105722 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105724 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105726 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105729 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105735 */   GIR_RootConstrainSelectedInstOperands,
     /* 105736 */   // GIR_Coverage, 1009,
     /* 105736 */   GIR_EraseRootFromParent_Done,
     /* 105737 */ // Label 1994: @105737
     /* 105737 */ GIM_Reject,
     /* 105738 */ // Label 1976: @105738
     /* 105738 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(105851),
     /* 105743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105749 */   GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(105789), // Rule ID 1007 //
     /* 105754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105769 */     // (ssubsat:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VQSUBsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 105769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv8i16),
     /* 105772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105774 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105781 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105787 */     GIR_RootConstrainSelectedInstOperands,
     /* 105788 */     // GIR_Coverage, 1007,
     /* 105788 */     GIR_EraseRootFromParent_Done,
     /* 105789 */   // Label 1996: @105789
     /* 105789 */   GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(105850), // Rule ID 3530 //
     /* 105794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105801 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105805 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105809 */     // (ssubsat:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VQSUBs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 105809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs16),
     /* 105824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105830 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105833 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105848 */     GIR_RootConstrainSelectedInstOperands,
     /* 105849 */     // GIR_Coverage, 3530,
     /* 105849 */     GIR_EraseRootFromParent_Done,
     /* 105850 */   // Label 1997: @105850
     /* 105850 */   GIM_Reject,
     /* 105851 */ // Label 1995: @105851
     /* 105851 */ GIM_Reject,
     /* 105852 */ // Label 1977: @105852
     /* 105852 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(105965),
     /* 105857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 105860 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 105863 */   GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(105903), // Rule ID 1010 //
     /* 105868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105875 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 105883 */     // (ssubsat:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VQSUBsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 105883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VQSUBsv16i8),
     /* 105886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 105888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 105890 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 105892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 105895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105901 */     GIR_RootConstrainSelectedInstOperands,
     /* 105902 */     // GIR_Coverage, 1010,
     /* 105902 */     GIR_EraseRootFromParent_Done,
     /* 105903 */   // Label 1999: @105903
     /* 105903 */   GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(105964), // Rule ID 3527 //
     /* 105908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 105911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 105923 */     // (ssubsat:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VQSUBs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 105923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 105926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VQSUBs8),
     /* 105938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 105940 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 105942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 105944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105947 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105953 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 105959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105962 */     GIR_RootConstrainSelectedInstOperands,
     /* 105963 */     // GIR_Coverage, 3527,
     /* 105963 */     GIR_EraseRootFromParent_Done,
     /* 105964 */   // Label 2000: @105964
     /* 105964 */   GIM_Reject,
     /* 105965 */ // Label 1998: @105965
     /* 105965 */ GIM_Reject,
     /* 105966 */ // Label 1978: @105966
     /* 105966 */ GIM_Reject,
     /* 105967 */ // Label 33: @105967
     /* 105967 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2008*/ GIMT_Encode4(108319),
     /* 105978 */ /*GILLT_s16*//*Label 2001*/ GIMT_Encode4(106030),
     /* 105982 */ /*GILLT_s32*//*Label 2002*/ GIMT_Encode4(106077),
     /* 105986 */ /*GILLT_s64*//*Label 2003*/ GIMT_Encode4(107672), GIMT_Encode4(0),
     /* 105994 */ /*GILLT_v2s32*//*Label 2004*/ GIMT_Encode4(107719), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106006 */ /*GILLT_v4s16*//*Label 2005*/ GIMT_Encode4(107766),
     /* 106010 */ /*GILLT_v4s32*//*Label 2006*/ GIMT_Encode4(107951), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106026 */ /*GILLT_v8s16*//*Label 2007*/ GIMT_Encode4(108065),
     /* 106030 */ // Label 2001: @106030
     /* 106030 */ GIM_Try, /*On fail goto*//*Label 2009*/ GIMT_Encode4(106076), // Rule ID 614 //
     /* 106035 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 106038 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 106041 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 106044 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106048 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106052 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 106056 */   // (fadd:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VADDH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 106056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDH),
     /* 106059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 106061 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 106063 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 106065 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 106068 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106074 */   GIR_RootConstrainSelectedInstOperands,
     /* 106075 */   // GIR_Coverage, 614,
     /* 106075 */   GIR_EraseRootFromParent_Done,
     /* 106076 */ // Label 2009: @106076
     /* 106076 */ GIM_Reject,
     /* 106077 */ // Label 2002: @106077
     /* 106077 */ GIM_Try, /*On fail goto*//*Label 2010*/ GIMT_Encode4(107671),
     /* 106082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 106088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106092 */   GIM_Try, /*On fail goto*//*Label 2011*/ GIMT_Encode4(106420), // Rule ID 5918 //
     /* 106097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106132 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106132 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106135 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106139 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106146 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106149 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106153 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106158 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106161 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106166 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106169 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106173 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106178 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106181 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106185 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106188 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106193 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106198 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106203 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106206 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106210 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106215 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106217 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106220 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106224 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106229 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106232 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106237 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106240 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106244 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106249 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106252 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106256 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106259 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106264 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106269 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106274 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106277 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106281 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106288 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106291 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106295 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106300 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106303 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106308 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106311 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106315 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106320 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106323 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106327 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106330 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106335 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106340 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106345 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106348 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 106352 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106357 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106360 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106363 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106369 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106389 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106392 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106402 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106419 */     // GIR_Coverage, 5918,
     /* 106419 */     GIR_EraseRootFromParent_Done,
     /* 106420 */   // Label 2011: @106420
     /* 106420 */   GIM_Try, /*On fail goto*//*Label 2012*/ GIMT_Encode4(106748), // Rule ID 5919 //
     /* 106425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 106428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106460 */     // (fadd:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b), SPR:{ *:[f32] }:$acc)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106460 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106463 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106467 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106474 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106477 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106481 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106486 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106489 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106494 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106497 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106501 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106506 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106509 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106513 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106516 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106521 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106526 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106531 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106534 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106538 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106543 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106545 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106548 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106552 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106557 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106560 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106565 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106568 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106572 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106577 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106580 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106584 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106587 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106592 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106597 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106602 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106605 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106609 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106616 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106619 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106623 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106628 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106631 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106636 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106639 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106643 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106648 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106651 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // acc
     /* 106655 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106658 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106663 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106668 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106673 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 106676 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 106680 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106685 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 106688 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 106691 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 106694 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 106697 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 106703 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 106705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 106708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106717 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 106720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106730 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 106737 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106742 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106747 */     // GIR_Coverage, 5919,
     /* 106747 */     GIR_EraseRootFromParent_Done,
     /* 106748 */   // Label 2012: @106748
     /* 106748 */   GIM_Try, /*On fail goto*//*Label 2013*/ GIMT_Encode4(107076), // Rule ID 2697 //
     /* 106753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 106756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 106764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 106768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 106772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 106776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 106786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106788 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 106788 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 106791 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106795 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 106802 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 106805 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106809 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106814 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 106817 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106822 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 106825 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106829 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106834 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 106837 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 106841 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 106844 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106849 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106854 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106859 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 106862 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106866 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 106873 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 106876 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106880 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106885 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 106888 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106893 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 106896 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106900 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106905 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 106908 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 106912 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 106915 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106920 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106925 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 106930 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 106933 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 106937 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106942 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 106944 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 106947 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106951 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106956 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 106959 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106964 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 106967 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 106971 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 106976 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 106979 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 106983 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 106986 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106991 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 106996 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107001 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107004 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLAfd),
     /* 107008 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107013 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107016 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107019 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107022 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107025 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107031 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107033 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107036 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107040 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107045 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107048 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107058 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107075 */     // GIR_Coverage, 2697,
     /* 107075 */     GIR_EraseRootFromParent_Done,
     /* 107076 */   // Label 2013: @107076
     /* 107076 */   GIM_Try, /*On fail goto*//*Label 2014*/ GIMT_Encode4(107404), // Rule ID 2699 //
     /* 107081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 107084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 107100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 107104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107114 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107116 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMAfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107116 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 107119 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107123 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 107130 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 107133 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107137 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107142 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 107145 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107150 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 107153 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107157 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107162 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 107165 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 107169 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 107172 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107177 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107182 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107187 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107190 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107194 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107201 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107204 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107208 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107213 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107216 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107221 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107224 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107228 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107233 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107236 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 107240 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107243 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107248 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107253 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107258 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107261 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107265 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107272 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107275 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107279 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107284 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107287 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107292 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107295 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107299 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107304 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107307 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 107311 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107314 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107319 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107324 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107329 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107332 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 107336 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107341 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107344 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107347 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 107350 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107353 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107359 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107373 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107386 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107393 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107403 */     // GIR_Coverage, 2699,
     /* 107403 */     GIR_EraseRootFromParent_Done,
     /* 107404 */   // Label 2014: @107404
     /* 107404 */   GIM_Try, /*On fail goto*//*Label 2015*/ GIMT_Encode4(107440), // Rule ID 613 //
     /* 107409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 107412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107420 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VADDS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 107420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDS),
     /* 107423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 107425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 107427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 107429 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107432 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107438 */     GIR_RootConstrainSelectedInstOperands,
     /* 107439 */     // GIR_Coverage, 613,
     /* 107439 */     GIR_EraseRootFromParent_Done,
     /* 107440 */   // Label 2015: @107440
     /* 107440 */   GIM_Try, /*On fail goto*//*Label 2016*/ GIMT_Encode4(107670), // Rule ID 2694 //
     /* 107445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 107448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 107456 */     // (fadd:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VADDfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 107456 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 107459 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107463 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107468 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 107470 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 107473 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107477 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107482 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 107485 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107490 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 107493 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107497 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107502 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 107505 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 107509 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 107512 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107517 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107522 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107527 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 107530 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 107534 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107539 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 107541 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 107544 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107548 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107553 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 107556 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107561 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 107564 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 107568 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107573 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 107576 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 107580 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 107583 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107588 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107593 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 107601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107610 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 107613 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 107616 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 107619 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 107627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 107630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 107642 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107652 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 107659 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 107664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 107669 */     // GIR_Coverage, 2694,
     /* 107669 */     GIR_EraseRootFromParent_Done,
     /* 107670 */   // Label 2016: @107670
     /* 107670 */   GIM_Reject,
     /* 107671 */ // Label 2010: @107671
     /* 107671 */ GIM_Reject,
     /* 107672 */ // Label 2003: @107672
     /* 107672 */ GIM_Try, /*On fail goto*//*Label 2017*/ GIMT_Encode4(107718), // Rule ID 612 //
     /* 107677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 107680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107683 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 107686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107694 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107698 */   // (fadd:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VADDD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 107698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDD),
     /* 107701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 107703 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 107705 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 107707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107716 */   GIR_RootConstrainSelectedInstOperands,
     /* 107717 */   // GIR_Coverage, 612,
     /* 107717 */   GIR_EraseRootFromParent_Done,
     /* 107718 */ // Label 2017: @107718
     /* 107718 */ GIM_Reject,
     /* 107719 */ // Label 2004: @107719
     /* 107719 */ GIM_Try, /*On fail goto*//*Label 2018*/ GIMT_Encode4(107765), // Rule ID 761 //
     /* 107724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107727 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107730 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 107733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107737 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107741 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107745 */   // (fadd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VADDfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 107745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfd),
     /* 107748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107750 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107752 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107754 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107757 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107763 */   GIR_RootConstrainSelectedInstOperands,
     /* 107764 */   // GIR_Coverage, 761,
     /* 107764 */   GIR_EraseRootFromParent_Done,
     /* 107765 */ // Label 2018: @107765
     /* 107765 */ GIM_Reject,
     /* 107766 */ // Label 2005: @107766
     /* 107766 */ GIM_Try, /*On fail goto*//*Label 2019*/ GIMT_Encode4(107950),
     /* 107771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107781 */   GIM_Try, /*On fail goto*//*Label 2020*/ GIMT_Encode4(107847), // Rule ID 5581 //
     /* 107786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107821 */     // (fadd:{ *:[v4f16] } (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm), DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107826 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 107828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107832 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107845 */     GIR_RootConstrainSelectedInstOperands,
     /* 107846 */     // GIR_Coverage, 5581,
     /* 107846 */     GIR_EraseRootFromParent_Done,
     /* 107847 */   // Label 2020: @107847
     /* 107847 */   GIM_Try, /*On fail goto*//*Label 2021*/ GIMT_Encode4(107913), // Rule ID 942 //
     /* 107852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 107855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 107863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 107867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 107875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107885 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107887 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 107890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107892 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 107894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 107898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 107902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107911 */     GIR_RootConstrainSelectedInstOperands,
     /* 107912 */     // GIR_Coverage, 942,
     /* 107912 */     GIR_EraseRootFromParent_Done,
     /* 107913 */   // Label 2021: @107913
     /* 107913 */   GIM_Try, /*On fail goto*//*Label 2022*/ GIMT_Encode4(107949), // Rule ID 763 //
     /* 107918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 107921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 107929 */     // (fadd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VADDhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 107929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhd),
     /* 107932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107938 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107941 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 107947 */     GIR_RootConstrainSelectedInstOperands,
     /* 107948 */     // GIR_Coverage, 763,
     /* 107948 */     GIR_EraseRootFromParent_Done,
     /* 107949 */   // Label 2022: @107949
     /* 107949 */   GIM_Reject,
     /* 107950 */ // Label 2019: @107950
     /* 107950 */ GIM_Reject,
     /* 107951 */ // Label 2006: @107951
     /* 107951 */ GIM_Try, /*On fail goto*//*Label 2023*/ GIMT_Encode4(108064),
     /* 107956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 107959 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 107962 */   GIM_Try, /*On fail goto*//*Label 2024*/ GIMT_Encode4(108002), // Rule ID 762 //
     /* 107967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 107970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 107982 */     // (fadd:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VADDfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 107982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDfq),
     /* 107985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 107987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 107989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 107991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 107994 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108000 */     GIR_RootConstrainSelectedInstOperands,
     /* 108001 */     // GIR_Coverage, 762,
     /* 108001 */     GIR_EraseRootFromParent_Done,
     /* 108002 */   // Label 2024: @108002
     /* 108002 */   GIM_Try, /*On fail goto*//*Label 2025*/ GIMT_Encode4(108063), // Rule ID 4013 //
     /* 108007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108018 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108022 */     // (fadd:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VADDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 108022 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108025 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108029 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf32),
     /* 108037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108043 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108046 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108061 */     GIR_RootConstrainSelectedInstOperands,
     /* 108062 */     // GIR_Coverage, 4013,
     /* 108062 */     GIR_EraseRootFromParent_Done,
     /* 108063 */   // Label 2025: @108063
     /* 108063 */   GIM_Reject,
     /* 108064 */ // Label 2023: @108064
     /* 108064 */ GIM_Reject,
     /* 108065 */ // Label 2007: @108065
     /* 108065 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(108318),
     /* 108070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108076 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(108146), // Rule ID 5582 //
     /* 108081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 108092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108120 */     // (fadd:{ *:[v8f16] } (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm), QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108125 */     GIR_RootToRootCopy, /*OpIdx*/2, // src1
     /* 108127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108144 */     GIR_RootConstrainSelectedInstOperands,
     /* 108145 */     // GIR_Coverage, 5582,
     /* 108145 */     GIR_EraseRootFromParent_Done,
     /* 108146 */   // Label 2027: @108146
     /* 108146 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(108216), // Rule ID 943 //
     /* 108151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 108154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 108178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108190 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 108193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108195 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 108197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 108201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 108205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108208 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108214 */     GIR_RootConstrainSelectedInstOperands,
     /* 108215 */     // GIR_Coverage, 943,
     /* 108215 */     GIR_EraseRootFromParent_Done,
     /* 108216 */   // Label 2028: @108216
     /* 108216 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(108256), // Rule ID 764 //
     /* 108221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 108224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 108236 */     // (fadd:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VADDhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 108236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VADDhq),
     /* 108239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 108241 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 108243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 108245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108248 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108254 */     GIR_RootConstrainSelectedInstOperands,
     /* 108255 */     // GIR_Coverage, 764,
     /* 108255 */     GIR_EraseRootFromParent_Done,
     /* 108256 */   // Label 2029: @108256
     /* 108256 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(108317), // Rule ID 4017 //
     /* 108261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 108264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 108276 */     // (fadd:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VADDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 108276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 108279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDf16),
     /* 108291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 108293 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 108295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 108297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 108300 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108306 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 108315 */     GIR_RootConstrainSelectedInstOperands,
     /* 108316 */     // GIR_Coverage, 4017,
     /* 108316 */     GIR_EraseRootFromParent_Done,
     /* 108317 */   // Label 2030: @108317
     /* 108317 */   GIM_Reject,
     /* 108318 */ // Label 2026: @108318
     /* 108318 */ GIM_Reject,
     /* 108319 */ // Label 2008: @108319
     /* 108319 */ GIM_Reject,
     /* 108320 */ // Label 34: @108320
     /* 108320 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2038*/ GIMT_Encode4(109996),
     /* 108331 */ /*GILLT_s16*//*Label 2031*/ GIMT_Encode4(108383),
     /* 108335 */ /*GILLT_s32*//*Label 2032*/ GIMT_Encode4(108430),
     /* 108339 */ /*GILLT_s64*//*Label 2033*/ GIMT_Encode4(109357), GIMT_Encode4(0),
     /* 108347 */ /*GILLT_v2s32*//*Label 2034*/ GIMT_Encode4(109404), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108359 */ /*GILLT_v4s16*//*Label 2035*/ GIMT_Encode4(109451),
     /* 108363 */ /*GILLT_v4s32*//*Label 2036*/ GIMT_Encode4(109628), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 108379 */ /*GILLT_v8s16*//*Label 2037*/ GIMT_Encode4(109742),
     /* 108383 */ // Label 2031: @108383
     /* 108383 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(108429), // Rule ID 617 //
     /* 108388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 108391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 108394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 108397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 108409 */   // (fsub:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VSUBH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 108409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBH),
     /* 108412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 108414 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 108416 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 108418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 108421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108427 */   GIR_RootConstrainSelectedInstOperands,
     /* 108428 */   // GIR_Coverage, 617,
     /* 108428 */   GIR_EraseRootFromParent_Done,
     /* 108429 */ // Label 2039: @108429
     /* 108429 */ GIM_Reject,
     /* 108430 */ // Label 2032: @108430
     /* 108430 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(109356),
     /* 108435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 108438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 108441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108449 */   GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(108773), // Rule ID 2698 //
     /* 108454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseFPVMLx_UseNEONForFP),
     /* 108457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108485 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMLSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108485 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108488 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108492 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108499 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108502 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108506 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108511 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108514 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108519 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108522 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108526 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108531 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108534 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108538 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108541 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108546 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108551 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108556 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108559 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108563 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108568 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108570 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108573 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108577 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108582 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108585 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108590 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108593 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108597 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108602 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108605 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108609 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108612 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108617 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108622 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108627 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108630 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108634 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108641 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108644 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108648 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108653 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108656 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108661 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108664 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108668 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108673 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 108676 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 108680 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 108683 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108688 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108693 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108698 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 108701 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMLSfd),
     /* 108705 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108710 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 108713 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 108716 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 108719 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 108722 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 108728 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 108730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 108733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108742 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 108745 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 108755 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 108762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108772 */     // GIR_Coverage, 2698,
     /* 108772 */     GIR_EraseRootFromParent_Done,
     /* 108773 */   // Label 2041: @108773
     /* 108773 */   GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(109097), // Rule ID 2700 //
     /* 108778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4_UseFusedMAC_UseNEONForFP),
     /* 108781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 108785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 108789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 108793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 108797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108802 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 108807 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 108809 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$acc, (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b))  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VFMSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$acc, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 108809 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v2s32,
     /* 108812 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108816 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 108823 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v2s32,
     /* 108826 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108830 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108835 */     GIR_AddSimpleTempRegister, /*InsnID*/10, /*TempRegID*/10,
     /* 108838 */     GIR_ConstrainOperandRC, /*InsnID*/10, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108843 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v2s32,
     /* 108846 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108850 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108855 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 108858 */     GIR_Copy, /*NewInsnID*/9, /*OldInsnID*/1, /*OpIdx*/2, // b
     /* 108862 */     GIR_AddImm8, /*InsnID*/9, /*Imm*/17,
     /* 108865 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108870 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108875 */     GIR_ConstrainOperandRC, /*InsnID*/9, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108880 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 108883 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108887 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108892 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 108894 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 108897 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108901 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108906 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 108909 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108914 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 108917 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108921 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108926 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 108929 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 108933 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 108936 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108941 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108946 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 108951 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 108954 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 108958 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108963 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 108965 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 108968 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108972 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108977 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 108980 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 108985 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 108988 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 108992 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 108997 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109000 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // acc
     /* 109004 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109007 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109012 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109017 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 109029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109034 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109037 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109040 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/8,
     /* 109043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109046 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109066 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109079 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109096 */     // GIR_Coverage, 2700,
     /* 109096 */     GIR_EraseRootFromParent_Done,
     /* 109097 */   // Label 2042: @109097
     /* 109097 */   GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(109129), // Rule ID 616 //
     /* 109102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 109105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109109 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VSUBS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 109109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBS),
     /* 109112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 109114 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 109116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 109118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109121 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109127 */     GIR_RootConstrainSelectedInstOperands,
     /* 109128 */     // GIR_Coverage, 616,
     /* 109128 */     GIR_EraseRootFromParent_Done,
     /* 109129 */   // Label 2043: @109129
     /* 109129 */   GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(109355), // Rule ID 2695 //
     /* 109134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 109137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 109141 */     // (fsub:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VSUBfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 109141 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 109144 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109148 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109153 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 109155 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 109158 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109162 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109167 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 109170 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109175 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 109178 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109182 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109187 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 109190 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 109194 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 109197 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109202 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109207 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109212 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 109215 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109219 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 109226 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 109229 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109233 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109238 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 109241 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109246 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 109249 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 109253 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109258 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 109261 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 109265 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 109268 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109273 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109278 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109283 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 109286 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109290 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109295 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 109298 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 109301 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 109304 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 109315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109324 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 109327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 109337 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 109344 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 109349 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 109354 */     // GIR_Coverage, 2695,
     /* 109354 */     GIR_EraseRootFromParent_Done,
     /* 109355 */   // Label 2044: @109355
     /* 109355 */   GIM_Reject,
     /* 109356 */ // Label 2040: @109356
     /* 109356 */ GIM_Reject,
     /* 109357 */ // Label 2033: @109357
     /* 109357 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(109403), // Rule ID 615 //
     /* 109362 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 109365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 109371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109379 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109383 */   // (fsub:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VSUBD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 109383 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBD),
     /* 109386 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 109388 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 109390 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 109392 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109395 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109401 */   GIR_RootConstrainSelectedInstOperands,
     /* 109402 */   // GIR_Coverage, 615,
     /* 109402 */   GIR_EraseRootFromParent_Done,
     /* 109403 */ // Label 2045: @109403
     /* 109403 */ GIM_Reject,
     /* 109404 */ // Label 2034: @109404
     /* 109404 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(109450), // Rule ID 965 //
     /* 109409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 109418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109422 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109426 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109430 */   // (fsub:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VSUBfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 109430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfd),
     /* 109433 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109435 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109437 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109439 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109442 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109448 */   GIR_RootConstrainSelectedInstOperands,
     /* 109449 */   // GIR_Coverage, 965,
     /* 109449 */   GIR_EraseRootFromParent_Done,
     /* 109450 */ // Label 2046: @109450
     /* 109450 */ GIM_Reject,
     /* 109451 */ // Label 2035: @109451
     /* 109451 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(109627),
     /* 109456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109459 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109466 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109470 */   GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(109532), // Rule ID 920 //
     /* 109475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109504 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109506 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VMLShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShd),
     /* 109509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109511 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109521 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109524 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109530 */     GIR_RootConstrainSelectedInstOperands,
     /* 109531 */     // GIR_Coverage, 920,
     /* 109531 */     GIR_EraseRootFromParent_Done,
     /* 109532 */   // Label 2048: @109532
     /* 109532 */   GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(109594), // Rule ID 946 //
     /* 109537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 109556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109561 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109566 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109568 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm))  =>  (VFMShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShd),
     /* 109571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109573 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109579 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109592 */     GIR_RootConstrainSelectedInstOperands,
     /* 109593 */     // GIR_Coverage, 946,
     /* 109593 */     GIR_EraseRootFromParent_Done,
     /* 109594 */   // Label 2049: @109594
     /* 109594 */   GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(109626), // Rule ID 967 //
     /* 109599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 109606 */     // (fsub:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VSUBhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 109606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhd),
     /* 109609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109611 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109618 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109624 */     GIR_RootConstrainSelectedInstOperands,
     /* 109625 */     // GIR_Coverage, 967,
     /* 109625 */     GIR_EraseRootFromParent_Done,
     /* 109626 */   // Label 2050: @109626
     /* 109626 */   GIM_Reject,
     /* 109627 */ // Label 2047: @109627
     /* 109627 */ GIM_Reject,
     /* 109628 */ // Label 2036: @109628
     /* 109628 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(109741),
     /* 109633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 109639 */   GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(109679), // Rule ID 966 //
     /* 109644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 109647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109659 */     // (fsub:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VSUBfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 109659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBfq),
     /* 109662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109664 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109671 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109677 */     GIR_RootConstrainSelectedInstOperands,
     /* 109678 */     // GIR_Coverage, 966,
     /* 109678 */     GIR_EraseRootFromParent_Done,
     /* 109679 */   // Label 2052: @109679
     /* 109679 */   GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(109740), // Rule ID 4021 //
     /* 109684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109687 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109691 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109699 */     // (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VSUBf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 109699 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109702 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109706 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf32),
     /* 109714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109729 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109738 */     GIR_RootConstrainSelectedInstOperands,
     /* 109739 */     // GIR_Coverage, 4021,
     /* 109739 */     GIR_EraseRootFromParent_Done,
     /* 109740 */   // Label 2053: @109740
     /* 109740 */   GIM_Reject,
     /* 109741 */ // Label 2051: @109741
     /* 109741 */ GIM_Reject,
     /* 109742 */ // Label 2037: @109742
     /* 109742 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(109995),
     /* 109747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109750 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109753 */   GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(109823), // Rule ID 921 //
     /* 109758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFPVMLx),
     /* 109761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109797 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VMLShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMLShq),
     /* 109800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109802 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109808 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109815 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109821 */     GIR_RootConstrainSelectedInstOperands,
     /* 109822 */     // GIR_Coverage, 921,
     /* 109822 */     GIR_EraseRootFromParent_Done,
     /* 109823 */   // Label 2055: @109823
     /* 109823 */   GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(109893), // Rule ID 947 //
     /* 109828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON_UseFusedMAC),
     /* 109831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109835 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 109843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 109847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 109855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109865 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 109867 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm))  =>  (VFMShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMShq),
     /* 109870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109872 */     GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 109874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 109878 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 109882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109891 */     GIR_RootConstrainSelectedInstOperands,
     /* 109892 */     // GIR_Coverage, 947,
     /* 109892 */     GIR_EraseRootFromParent_Done,
     /* 109893 */   // Label 2056: @109893
     /* 109893 */   GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(109933), // Rule ID 968 //
     /* 109898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 109901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 109913 */     // (fsub:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VSUBhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 109913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSUBhq),
     /* 109916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 109918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 109920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 109922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 109925 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109931 */     GIR_RootConstrainSelectedInstOperands,
     /* 109932 */     // GIR_Coverage, 968,
     /* 109932 */     GIR_EraseRootFromParent_Done,
     /* 109933 */   // Label 2057: @109933
     /* 109933 */   GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(109994), // Rule ID 4025 //
     /* 109938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 109941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 109953 */     // (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VSUBf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 109953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 109956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 109960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VSUBf16),
     /* 109968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 109970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 109972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 109974 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 109977 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109983 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 109989 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109992 */     GIR_RootConstrainSelectedInstOperands,
     /* 109993 */     // GIR_Coverage, 4025,
     /* 109993 */     GIR_EraseRootFromParent_Done,
     /* 109994 */   // Label 2058: @109994
     /* 109994 */   GIM_Reject,
     /* 109995 */ // Label 2054: @109995
     /* 109995 */ GIM_Reject,
     /* 109996 */ // Label 2038: @109996
     /* 109996 */ GIM_Reject,
     /* 109997 */ // Label 35: @109997
     /* 109997 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2066*/ GIMT_Encode4(110977),
     /* 110008 */ /*GILLT_s16*//*Label 2059*/ GIMT_Encode4(110060),
     /* 110012 */ /*GILLT_s32*//*Label 2060*/ GIMT_Encode4(110107),
     /* 110016 */ /*GILLT_s64*//*Label 2061*/ GIMT_Encode4(110496), GIMT_Encode4(0),
     /* 110024 */ /*GILLT_v2s32*//*Label 2062*/ GIMT_Encode4(110655), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110036 */ /*GILLT_v4s16*//*Label 2063*/ GIMT_Encode4(110702),
     /* 110040 */ /*GILLT_v4s32*//*Label 2064*/ GIMT_Encode4(110749), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 110056 */ /*GILLT_v8s16*//*Label 2065*/ GIMT_Encode4(110863),
     /* 110060 */ // Label 2059: @110060
     /* 110060 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(110106), // Rule ID 623 //
     /* 110065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 110068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 110071 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 110074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110082 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 110086 */   // (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 110086 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULH),
     /* 110089 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110091 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110093 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110095 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110098 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110104 */   GIR_RootConstrainSelectedInstOperands,
     /* 110105 */   // GIR_Coverage, 623,
     /* 110105 */   GIR_EraseRootFromParent_Done,
     /* 110106 */ // Label 2067: @110106
     /* 110106 */ GIM_Reject,
     /* 110107 */ // Label 2060: @110107
     /* 110107 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(110495),
     /* 110112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 110115 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 110118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110122 */   GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(110175), // Rule ID 2299 //
     /* 110127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110138 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110142 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110147 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110151 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110153 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a), SPR:{ *:[f32] }:$b)  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110162 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110167 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110173 */     GIR_RootConstrainSelectedInstOperands,
     /* 110174 */     // GIR_Coverage, 2299,
     /* 110174 */     GIR_EraseRootFromParent_Done,
     /* 110175 */   // Label 2069: @110175
     /* 110175 */   GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(110228), // Rule ID 5708 //
     /* 110180 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_NoHonorSignDependentRounding),
     /* 110183 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110195 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 110199 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110206 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$b, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)
     /* 110206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 110209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110215 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110220 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110226 */     GIR_RootConstrainSelectedInstOperands,
     /* 110227 */     // GIR_Coverage, 5708,
     /* 110227 */     GIR_EraseRootFromParent_Done,
     /* 110228 */   // Label 2070: @110228
     /* 110228 */   GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(110264), // Rule ID 622 //
     /* 110233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 110236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110244 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 110244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULS),
     /* 110247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 110249 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 110251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 110253 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110256 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110262 */     GIR_RootConstrainSelectedInstOperands,
     /* 110263 */     // GIR_Coverage, 622,
     /* 110263 */     GIR_EraseRootFromParent_Done,
     /* 110264 */   // Label 2071: @110264
     /* 110264 */   GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(110494), // Rule ID 2696 //
     /* 110269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 110272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 110280 */     // (fmul:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMULfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 110280 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 110283 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110287 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110292 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 110294 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 110297 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110301 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110306 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 110309 */     GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110314 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 110317 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110321 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110326 */     GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 110329 */     GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 110333 */     GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 110336 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110341 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110346 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110351 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 110354 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110358 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110363 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 110365 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 110368 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110372 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110377 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 110380 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110385 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 110388 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 110392 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110397 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 110400 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 110404 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 110407 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110412 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110417 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110422 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 110425 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110429 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110434 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 110437 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 110440 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 110443 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 110451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 110454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 110466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 110476 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 110483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 110488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 110493 */     // GIR_Coverage, 2696,
     /* 110493 */     GIR_EraseRootFromParent_Done,
     /* 110494 */   // Label 2072: @110494
     /* 110494 */   GIM_Reject,
     /* 110495 */ // Label 2068: @110495
     /* 110495 */ GIM_Reject,
     /* 110496 */ // Label 2061: @110496
     /* 110496 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(110654),
     /* 110501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 110507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110511 */   GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(110564), // Rule ID 2298 //
     /* 110516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 110523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110531 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110542 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a), DPR:{ *:[f64] }:$b)  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110551 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 110553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110556 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110562 */     GIR_RootConstrainSelectedInstOperands,
     /* 110563 */     // GIR_Coverage, 2298,
     /* 110563 */     GIR_EraseRootFromParent_Done,
     /* 110564 */   // Label 2074: @110564
     /* 110564 */   GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(110617), // Rule ID 5707 //
     /* 110569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_NoHonorSignDependentRounding),
     /* 110572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 110580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 110584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 110588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110593 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 110595 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$b, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$a, DPR:{ *:[f64] }:$b)
     /* 110595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 110598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110600 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 110604 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 110606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110615 */     GIR_RootConstrainSelectedInstOperands,
     /* 110616 */     // GIR_Coverage, 5707,
     /* 110616 */     GIR_EraseRootFromParent_Done,
     /* 110617 */   // Label 2075: @110617
     /* 110617 */   GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(110653), // Rule ID 621 //
     /* 110622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 110625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110633 */     // (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 110633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULD),
     /* 110636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 110638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 110640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 110642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110651 */     GIR_RootConstrainSelectedInstOperands,
     /* 110652 */     // GIR_Coverage, 621,
     /* 110652 */     GIR_EraseRootFromParent_Done,
     /* 110653 */   // Label 2076: @110653
     /* 110653 */   GIM_Reject,
     /* 110654 */ // Label 2073: @110654
     /* 110654 */ GIM_Reject,
     /* 110655 */ // Label 2062: @110655
     /* 110655 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(110701), // Rule ID 840 //
     /* 110660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 110669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110677 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110681 */   // (fmul:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMULfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 110681 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfd),
     /* 110684 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110686 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110688 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110693 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110699 */   GIR_RootConstrainSelectedInstOperands,
     /* 110700 */   // GIR_Coverage, 840,
     /* 110700 */   GIR_EraseRootFromParent_Done,
     /* 110701 */ // Label 2077: @110701
     /* 110701 */ GIM_Reject,
     /* 110702 */ // Label 2063: @110702
     /* 110702 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(110748), // Rule ID 842 //
     /* 110707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110713 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 110716 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110720 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110724 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 110728 */   // (fmul:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMULhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 110728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhd),
     /* 110731 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110733 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110735 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110737 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110740 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110746 */   GIR_RootConstrainSelectedInstOperands,
     /* 110747 */   // GIR_Coverage, 842,
     /* 110747 */   GIR_EraseRootFromParent_Done,
     /* 110748 */ // Label 2078: @110748
     /* 110748 */ GIM_Reject,
     /* 110749 */ // Label 2064: @110749
     /* 110749 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(110862),
     /* 110754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 110760 */   GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(110800), // Rule ID 841 //
     /* 110765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 110768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110780 */     // (fmul:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMULfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 110780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULfq),
     /* 110783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110792 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110798 */     GIR_RootConstrainSelectedInstOperands,
     /* 110799 */     // GIR_Coverage, 841,
     /* 110799 */     GIR_EraseRootFromParent_Done,
     /* 110800 */   // Label 2080: @110800
     /* 110800 */   GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(110861), // Rule ID 3985 //
     /* 110805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110816 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110820 */     // (fmul:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMULf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 110820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf32),
     /* 110835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110844 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110850 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110859 */     GIR_RootConstrainSelectedInstOperands,
     /* 110860 */     // GIR_Coverage, 3985,
     /* 110860 */     GIR_EraseRootFromParent_Done,
     /* 110861 */   // Label 2081: @110861
     /* 110861 */   GIM_Reject,
     /* 110862 */ // Label 2079: @110862
     /* 110862 */ GIM_Reject,
     /* 110863 */ // Label 2065: @110863
     /* 110863 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(110976),
     /* 110868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110871 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 110874 */   GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(110914), // Rule ID 843 //
     /* 110879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 110882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 110894 */     // (fmul:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMULhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 110894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMULhq),
     /* 110897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 110899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 110901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 110903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 110906 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110912 */     GIR_RootConstrainSelectedInstOperands,
     /* 110913 */     // GIR_Coverage, 843,
     /* 110913 */     GIR_EraseRootFromParent_Done,
     /* 110914 */   // Label 2083: @110914
     /* 110914 */   GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(110975), // Rule ID 3989 //
     /* 110919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 110922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 110934 */     // (fmul:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMULf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 110934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 110937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 110941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 110946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMULf16),
     /* 110949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 110951 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 110953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 110955 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 110958 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110964 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 110970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 110973 */     GIR_RootConstrainSelectedInstOperands,
     /* 110974 */     // GIR_Coverage, 3989,
     /* 110974 */     GIR_EraseRootFromParent_Done,
     /* 110975 */   // Label 2084: @110975
     /* 110975 */   GIM_Reject,
     /* 110976 */ // Label 2082: @110976
     /* 110976 */ GIM_Reject,
     /* 110977 */ // Label 2066: @110977
     /* 110977 */ GIM_Reject,
     /* 110978 */ // Label 36: @110978
     /* 110978 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2092*/ GIMT_Encode4(113068),
     /* 110989 */ /*GILLT_s16*//*Label 2085*/ GIMT_Encode4(111041),
     /* 110993 */ /*GILLT_s32*//*Label 2086*/ GIMT_Encode4(111428),
     /* 110997 */ /*GILLT_s64*//*Label 2087*/ GIMT_Encode4(111815), GIMT_Encode4(0),
     /* 111005 */ /*GILLT_v2s32*//*Label 2088*/ GIMT_Encode4(112202), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111017 */ /*GILLT_v4s16*//*Label 2089*/ GIMT_Encode4(112382),
     /* 111021 */ /*GILLT_v4s32*//*Label 2090*/ GIMT_Encode4(112438), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 111037 */ /*GILLT_v8s16*//*Label 2091*/ GIMT_Encode4(112816),
     /* 111041 */ // Label 2085: @111041
     /* 111041 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(111427),
     /* 111046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 111049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 111052 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 111055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111059 */   GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(111133), // Rule ID 2403 //
     /* 111064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111107 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111112 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111125 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111131 */     GIR_RootConstrainSelectedInstOperands,
     /* 111132 */     // GIR_Coverage, 2403,
     /* 111132 */     GIR_EraseRootFromParent_Done,
     /* 111133 */   // Label 2094: @111133
     /* 111133 */   GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(111207), // Rule ID 5716 //
     /* 111138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111157 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111166 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111170 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 111174 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111181 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 111184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111199 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111205 */     GIR_RootConstrainSelectedInstOperands,
     /* 111206 */     // GIR_Coverage, 5716,
     /* 111206 */     GIR_EraseRootFromParent_Done,
     /* 111207 */   // Label 2095: @111207
     /* 111207 */   GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(111266), // Rule ID 2395 //
     /* 111212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111240 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111242 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111255 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111264 */     GIR_RootConstrainSelectedInstOperands,
     /* 111265 */     // GIR_Coverage, 2395,
     /* 111265 */     GIR_EraseRootFromParent_Done,
     /* 111266 */   // Label 2096: @111266
     /* 111266 */   GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(111325), // Rule ID 5713 //
     /* 111271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111274 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111299 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111301 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin)  =>  (VFMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSH),
     /* 111304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111323 */     GIR_RootConstrainSelectedInstOperands,
     /* 111324 */     // GIR_Coverage, 5713,
     /* 111324 */     GIR_EraseRootFromParent_Done,
     /* 111325 */   // Label 2097: @111325
     /* 111325 */   GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(111384), // Rule ID 2408 //
     /* 111330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 111353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111358 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111360 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 111363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111376 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111382 */     GIR_RootConstrainSelectedInstOperands,
     /* 111383 */     // GIR_Coverage, 2408,
     /* 111383 */     GIR_EraseRootFromParent_Done,
     /* 111384 */   // Label 2098: @111384
     /* 111384 */   GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(111426), // Rule ID 2389 //
     /* 111389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 111392 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 111404 */     // (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin)  =>  (VFMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 111404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAH),
     /* 111407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111415 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111424 */     GIR_RootConstrainSelectedInstOperands,
     /* 111425 */     // GIR_Coverage, 2389,
     /* 111425 */     GIR_EraseRootFromParent_Done,
     /* 111426 */   // Label 2099: @111426
     /* 111426 */   GIM_Reject,
     /* 111427 */ // Label 2093: @111427
     /* 111427 */ GIM_Reject,
     /* 111428 */ // Label 2086: @111428
     /* 111428 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(111814),
     /* 111433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 111436 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 111439 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 111442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111446 */   GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(111520), // Rule ID 2402 //
     /* 111451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111483 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111487 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111492 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111494 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111512 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111518 */     GIR_RootConstrainSelectedInstOperands,
     /* 111519 */     // GIR_Coverage, 2402,
     /* 111519 */     GIR_EraseRootFromParent_Done,
     /* 111520 */   // Label 2101: @111520
     /* 111520 */   GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(111594), // Rule ID 5715 //
     /* 111525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111557 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 111561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111568 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 111571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sdin
     /* 111577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111586 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111592 */     GIR_RootConstrainSelectedInstOperands,
     /* 111593 */     // GIR_Coverage, 5715,
     /* 111593 */     GIR_EraseRootFromParent_Done,
     /* 111594 */   // Label 2102: @111594
     /* 111594 */   GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(111653), // Rule ID 2394 //
     /* 111599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111629 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111636 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111642 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111645 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111651 */     GIR_RootConstrainSelectedInstOperands,
     /* 111652 */     // GIR_Coverage, 2394,
     /* 111652 */     GIR_EraseRootFromParent_Done,
     /* 111653 */   // Label 2103: @111653
     /* 111653 */   GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(111712), // Rule ID 5712 //
     /* 111658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111661 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111665 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111669 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111673 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111686 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111688 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin)  =>  (VFMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSS),
     /* 111691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 111699 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 111701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111704 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111710 */     GIR_RootConstrainSelectedInstOperands,
     /* 111711 */     // GIR_Coverage, 5712,
     /* 111711 */     GIR_EraseRootFromParent_Done,
     /* 111712 */   // Label 2104: @111712
     /* 111712 */   GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(111771), // Rule ID 2407 //
     /* 111717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 111732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 111740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111745 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 111747 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 111750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sdin
     /* 111756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111760 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111763 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111769 */     GIR_RootConstrainSelectedInstOperands,
     /* 111770 */     // GIR_Coverage, 2407,
     /* 111770 */     GIR_EraseRootFromParent_Done,
     /* 111771 */   // Label 2105: @111771
     /* 111771 */   GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(111813), // Rule ID 2388 //
     /* 111776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 111779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111787 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 111791 */     // (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin)  =>  (VFMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 111791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAS),
     /* 111794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 111796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Sdin
     /* 111798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 111800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 111802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111805 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111811 */     GIR_RootConstrainSelectedInstOperands,
     /* 111812 */     // GIR_Coverage, 2388,
     /* 111812 */     GIR_EraseRootFromParent_Done,
     /* 111813 */   // Label 2106: @111813
     /* 111813 */   GIM_Reject,
     /* 111814 */ // Label 2100: @111814
     /* 111814 */ GIM_Reject,
     /* 111815 */ // Label 2087: @111815
     /* 111815 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(112201),
     /* 111820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 111826 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 111829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111833 */   GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(111907), // Rule ID 2401 //
     /* 111838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111870 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111874 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111879 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111881 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 111896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111899 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111905 */     GIR_RootConstrainSelectedInstOperands,
     /* 111906 */     // GIR_Coverage, 2401,
     /* 111906 */     GIR_EraseRootFromParent_Done,
     /* 111907 */   // Label 2108: @111907
     /* 111907 */   GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(111981), // Rule ID 5714 //
     /* 111912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111915 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111919 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 111923 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111927 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 111931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 111940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 111948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 111953 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 111955 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 111955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 111958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 111960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ddin
     /* 111964 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 111968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 111970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 111973 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 111979 */     GIR_RootConstrainSelectedInstOperands,
     /* 111980 */     // GIR_Coverage, 5714,
     /* 111980 */     GIR_EraseRootFromParent_Done,
     /* 111981 */   // Label 2109: @111981
     /* 111981 */   GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(112040), // Rule ID 2393 //
     /* 111986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 111989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 111993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 111997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112016 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112029 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112032 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112038 */     GIR_RootConstrainSelectedInstOperands,
     /* 112039 */     // GIR_Coverage, 2393,
     /* 112039 */     GIR_EraseRootFromParent_Done,
     /* 112040 */   // Label 2110: @112040
     /* 112040 */   GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(112099), // Rule ID 5711 //
     /* 112045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112064 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112069 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112073 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112075 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin)  =>  (VFMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSD),
     /* 112078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 112086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 112088 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112091 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112097 */     GIR_RootConstrainSelectedInstOperands,
     /* 112098 */     // GIR_Coverage, 5711,
     /* 112098 */     GIR_EraseRootFromParent_Done,
     /* 112099 */   // Label 2111: @112099
     /* 112099 */   GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(112158), // Rule ID 2406 //
     /* 112104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112107 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 112119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 112127 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112134 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 112137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ddin
     /* 112143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112147 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112150 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112156 */     GIR_RootConstrainSelectedInstOperands,
     /* 112157 */     // GIR_Coverage, 2406,
     /* 112157 */     GIR_EraseRootFromParent_Done,
     /* 112158 */   // Label 2112: @112158
     /* 112158 */   GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(112200), // Rule ID 2387 //
     /* 112163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 112166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112178 */     // (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin)  =>  (VFMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 112178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAD),
     /* 112181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 112183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ddin
     /* 112185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 112187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 112189 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112192 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112198 */     GIR_RootConstrainSelectedInstOperands,
     /* 112199 */     // GIR_Coverage, 2387,
     /* 112199 */     GIR_EraseRootFromParent_Done,
     /* 112200 */   // Label 2113: @112200
     /* 112200 */   GIM_Reject,
     /* 112201 */ // Label 2107: @112201
     /* 112201 */ GIM_Reject,
     /* 112202 */ // Label 2088: @112202
     /* 112202 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(112381),
     /* 112207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112210 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 112213 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 112216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112220 */   GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(112279), // Rule ID 2500 //
     /* 112225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112240 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112249 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112255 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112260 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112268 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112271 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112277 */     GIR_RootConstrainSelectedInstOperands,
     /* 112278 */     // GIR_Coverage, 2500,
     /* 112278 */     GIR_EraseRootFromParent_Done,
     /* 112279 */   // Label 2115: @112279
     /* 112279 */   GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(112338), // Rule ID 5754 //
     /* 112284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 112303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112314 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm, (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn), DPR:{ *:[v2f32] }:$src1)  =>  (VFMSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfd),
     /* 112317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112319 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112325 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112330 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112336 */     GIR_RootConstrainSelectedInstOperands,
     /* 112337 */     // GIR_Coverage, 5754,
     /* 112337 */     GIR_EraseRootFromParent_Done,
     /* 112338 */   // Label 2116: @112338
     /* 112338 */   GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(112380), // Rule ID 2498 //
     /* 112343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112358 */     // (fma:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm, DPR:{ *:[v2f32] }:$src1)  =>  (VFMAfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$src1, DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 112358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfd),
     /* 112361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112363 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112369 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112372 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112378 */     GIR_RootConstrainSelectedInstOperands,
     /* 112379 */     // GIR_Coverage, 2498,
     /* 112379 */     GIR_EraseRootFromParent_Done,
     /* 112380 */   // Label 2117: @112380
     /* 112380 */   GIM_Reject,
     /* 112381 */ // Label 2114: @112381
     /* 112381 */ GIM_Reject,
     /* 112382 */ // Label 2089: @112382
     /* 112382 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(112437), // Rule ID 2496 //
     /* 112387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 112393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 112396 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 112399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112403 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112407 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112411 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 112415 */   // (fma:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm, DPR:{ *:[v4f16] }:$src1)  =>  (VFMAhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$src1, DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 112415 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhd),
     /* 112418 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112420 */   GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112422 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112424 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112426 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112429 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112435 */   GIR_RootConstrainSelectedInstOperands,
     /* 112436 */   // GIR_Coverage, 2496,
     /* 112436 */   GIR_EraseRootFromParent_Done,
     /* 112437 */ // Label 2118: @112437
     /* 112437 */ GIM_Reject,
     /* 112438 */ // Label 2090: @112438
     /* 112438 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(112815),
     /* 112443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 112449 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 112452 */   GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(112515), // Rule ID 2501 //
     /* 112457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112489 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112491 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112496 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112504 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112507 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112513 */     GIR_RootConstrainSelectedInstOperands,
     /* 112514 */     // GIR_Coverage, 2501,
     /* 112514 */     GIR_EraseRootFromParent_Done,
     /* 112515 */   // Label 2120: @112515
     /* 112515 */   GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(112584), // Rule ID 3999 //
     /* 112520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112552 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112554 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112559 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112565 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112570 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112576 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112582 */     GIR_RootConstrainSelectedInstOperands,
     /* 112583 */     // GIR_Coverage, 3999,
     /* 112583 */     GIR_EraseRootFromParent_Done,
     /* 112584 */   // Label 2121: @112584
     /* 112584 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(112647), // Rule ID 5755 //
     /* 112589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112596 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112617 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112623 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm, (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn), QPR:{ *:[v4f32] }:$src1)  =>  (VFMSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMSfq),
     /* 112626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112628 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 112634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 112636 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112639 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112645 */     GIR_RootConstrainSelectedInstOperands,
     /* 112646 */     // GIR_Coverage, 5755,
     /* 112646 */     GIR_EraseRootFromParent_Done,
     /* 112647 */   // Label 2122: @112647
     /* 112647 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(112716), // Rule ID 6035 //
     /* 112652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112680 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112684 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112686 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m2, (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1), MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf32),
     /* 112689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112691 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112697 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112699 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112708 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112714 */     GIR_RootConstrainSelectedInstOperands,
     /* 112715 */     // GIR_Coverage, 6035,
     /* 112715 */     GIR_EraseRootFromParent_Done,
     /* 112716 */   // Label 2123: @112716
     /* 112716 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(112762), // Rule ID 2499 //
     /* 112721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasVFP4),
     /* 112724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112736 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112740 */     // (fma:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm, QPR:{ *:[v4f32] }:$src1)  =>  (VFMAfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$src1, QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 112740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAfq),
     /* 112743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112745 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 112749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 112751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 112754 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112760 */     GIR_RootConstrainSelectedInstOperands,
     /* 112761 */     // GIR_Coverage, 2499,
     /* 112761 */     GIR_EraseRootFromParent_Done,
     /* 112762 */   // Label 2124: @112762
     /* 112762 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(112814), // Rule ID 4003 //
     /* 112767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112786 */     // (fma:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$m1, MQPR:{ *:[v4f32] }:$m2, MQPR:{ *:[v4f32] }:$add)  =>  (MVE_VFMAf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$add, ?:{ *:[v4f32] }:$m1, ?:{ *:[v4f32] }:$m2)
     /* 112786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf32),
     /* 112789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112791 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112793 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 112795 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112797 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112800 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112806 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112812 */     GIR_RootConstrainSelectedInstOperands,
     /* 112813 */     // GIR_Coverage, 4003,
     /* 112813 */     GIR_EraseRootFromParent_Done,
     /* 112814 */   // Label 2125: @112814
     /* 112814 */   GIM_Reject,
     /* 112815 */ // Label 2119: @112815
     /* 112815 */ GIM_Reject,
     /* 112816 */ // Label 2091: @112816
     /* 112816 */ GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(113067),
     /* 112821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 112827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 112830 */   GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(112899), // Rule ID 4009 //
     /* 112835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112867 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112869 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112874 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112880 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 112882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112885 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112897 */     GIR_RootConstrainSelectedInstOperands,
     /* 112898 */     // GIR_Coverage, 4009,
     /* 112898 */     GIR_EraseRootFromParent_Done,
     /* 112899 */   // Label 2127: @112899
     /* 112899 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(112968), // Rule ID 6037 //
     /* 112904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 112907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 112919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 112923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112927 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112932 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 112936 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112938 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m2, (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1), MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 112938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMSf16),
     /* 112941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 112943 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 112945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // m1
     /* 112949 */     GIR_RootToRootCopy, /*OpIdx*/1, // m2
     /* 112951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112954 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112960 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 112966 */     GIR_RootConstrainSelectedInstOperands,
     /* 112967 */     // GIR_Coverage, 6037,
     /* 112967 */     GIR_EraseRootFromParent_Done,
     /* 112968 */   // Label 2128: @112968
     /* 112968 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(113014), // Rule ID 2497 //
     /* 112973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 112976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 112992 */     // (fma:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm, QPR:{ *:[v8f16] }:$src1)  =>  (VFMAhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$src1, QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 112992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFMAhq),
     /* 112995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 112997 */     GIR_RootToRootCopy, /*OpIdx*/3, // src1
     /* 112999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 113001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 113003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113012 */     GIR_RootConstrainSelectedInstOperands,
     /* 113013 */     // GIR_Coverage, 2497,
     /* 113013 */     GIR_EraseRootFromParent_Done,
     /* 113014 */   // Label 2129: @113014
     /* 113014 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(113066), // Rule ID 4006 //
     /* 113019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 113022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113026 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113030 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113034 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 113038 */     // (fma:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$m1, MQPR:{ *:[v8f16] }:$m2, MQPR:{ *:[v8f16] }:$add)  =>  (MVE_VFMAf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$add, ?:{ *:[v8f16] }:$m1, ?:{ *:[v8f16] }:$m2)
     /* 113038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VFMAf16),
     /* 113041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 113043 */     GIR_RootToRootCopy, /*OpIdx*/3, // add
     /* 113045 */     GIR_RootToRootCopy, /*OpIdx*/1, // m1
     /* 113047 */     GIR_RootToRootCopy, /*OpIdx*/2, // m2
     /* 113049 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 113052 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113058 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113064 */     GIR_RootConstrainSelectedInstOperands,
     /* 113065 */     // GIR_Coverage, 4006,
     /* 113065 */     GIR_EraseRootFromParent_Done,
     /* 113066 */   // Label 2130: @113066
     /* 113066 */   GIM_Reject,
     /* 113067 */ // Label 2126: @113067
     /* 113067 */ GIM_Reject,
     /* 113068 */ // Label 2092: @113068
     /* 113068 */ GIM_Reject,
     /* 113069 */ // Label 37: @113069
     /* 113069 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2134*/ GIMT_Encode4(113233),
     /* 113080 */ /*GILLT_s16*//*Label 2131*/ GIMT_Encode4(113092),
     /* 113084 */ /*GILLT_s32*//*Label 2132*/ GIMT_Encode4(113139),
     /* 113088 */ /*GILLT_s64*//*Label 2133*/ GIMT_Encode4(113186),
     /* 113092 */ // Label 2131: @113092
     /* 113092 */ GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(113138), // Rule ID 620 //
     /* 113097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 113106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113118 */   // (fdiv:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VDIVH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVH),
     /* 113121 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113123 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113125 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113127 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113130 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113136 */   GIR_RootConstrainSelectedInstOperands,
     /* 113137 */   // GIR_Coverage, 620,
     /* 113137 */   GIR_EraseRootFromParent_Done,
     /* 113138 */ // Label 2135: @113138
     /* 113138 */ GIM_Reject,
     /* 113139 */ // Label 2132: @113139
     /* 113139 */ GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(113185), // Rule ID 619 //
     /* 113144 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113150 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 113153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113157 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113161 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113165 */   // (fdiv:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VDIVS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVS),
     /* 113168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113170 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sn
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/2, // Sm
     /* 113174 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113177 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113183 */   GIR_RootConstrainSelectedInstOperands,
     /* 113184 */   // GIR_Coverage, 619,
     /* 113184 */   GIR_EraseRootFromParent_Done,
     /* 113185 */ // Label 2136: @113185
     /* 113185 */ GIM_Reject,
     /* 113186 */ // Label 2133: @113186
     /* 113186 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(113232), // Rule ID 618 //
     /* 113191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 113194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 113200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 113212 */   // (fdiv:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VDIVD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 113212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VDIVD),
     /* 113215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 113217 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dn
     /* 113219 */   GIR_RootToRootCopy, /*OpIdx*/2, // Dm
     /* 113221 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113224 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113230 */   GIR_RootConstrainSelectedInstOperands,
     /* 113231 */   // GIR_Coverage, 618,
     /* 113231 */   GIR_EraseRootFromParent_Done,
     /* 113232 */ // Label 2137: @113232
     /* 113232 */ GIM_Reject,
     /* 113233 */ // Label 2134: @113233
     /* 113233 */ GIM_Reject,
     /* 113234 */ // Label 38: @113234
     /* 113234 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2145*/ GIMT_Encode4(114764),
     /* 113245 */ /*GILLT_s16*//*Label 2138*/ GIMT_Encode4(113297),
     /* 113249 */ /*GILLT_s32*//*Label 2139*/ GIMT_Encode4(113644),
     /* 113253 */ /*GILLT_s64*//*Label 2140*/ GIMT_Encode4(114143), GIMT_Encode4(0),
     /* 113261 */ /*GILLT_v2s32*//*Label 2141*/ GIMT_Encode4(114490), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113273 */ /*GILLT_v4s16*//*Label 2142*/ GIMT_Encode4(114528),
     /* 113277 */ /*GILLT_v4s32*//*Label 2143*/ GIMT_Encode4(114566), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 113293 */ /*GILLT_v8s16*//*Label 2144*/ GIMT_Encode4(114665),
     /* 113297 */ // Label 2138: @113297
     /* 113297 */ GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(113643),
     /* 113302 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 113305 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113309 */   GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(113394), // Rule ID 2411 //
     /* 113314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113321 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113325 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113349 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113354 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113366 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113386 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113392 */     GIR_RootConstrainSelectedInstOperands,
     /* 113393 */     // GIR_Coverage, 2411,
     /* 113393 */     GIR_EraseRootFromParent_Done,
     /* 113394 */   // Label 2147: @113394
     /* 113394 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(113479), // Rule ID 5719 //
     /* 113399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113418 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 113439 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113451 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sm, (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sn), HPR:{ *:[f16] }:$Sdin))  =>  (VFNMSH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSH),
     /* 113454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113471 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113477 */     GIR_RootConstrainSelectedInstOperands,
     /* 113478 */     // GIR_Coverage, 5719,
     /* 113478 */     GIR_EraseRootFromParent_Done,
     /* 113479 */   // Label 2148: @113479
     /* 113479 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(113552), // Rule ID 2400 //
     /* 113484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113503 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 113507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113524 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm, HPR:{ *:[f16] }:$Sdin))  =>  (VFNMAH:{ *:[f16] } HPR:{ *:[f16] }:$Sdin, HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAH),
     /* 113527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113541 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113544 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113550 */     GIR_RootConstrainSelectedInstOperands,
     /* 113551 */     // GIR_Coverage, 2400,
     /* 113551 */     GIR_EraseRootFromParent_Done,
     /* 113552 */   // Label 2149: @113552
     /* 113552 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(113612), // Rule ID 626 //
     /* 113557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 113572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 113576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113588 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm))  =>  (VNMULH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 113588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULH),
     /* 113591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113601 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113604 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113610 */     GIR_RootConstrainSelectedInstOperands,
     /* 113611 */     // GIR_Coverage, 626,
     /* 113611 */     GIR_EraseRootFromParent_Done,
     /* 113612 */   // Label 2150: @113612
     /* 113612 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(113642), // Rule ID 664 //
     /* 113617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 113620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 113624 */     // (fneg:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VNEGH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 113624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGH),
     /* 113627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113634 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113640 */     GIR_RootConstrainSelectedInstOperands,
     /* 113641 */     // GIR_Coverage, 664,
     /* 113641 */     GIR_EraseRootFromParent_Done,
     /* 113642 */   // Label 2151: @113642
     /* 113642 */   GIM_Reject,
     /* 113643 */ // Label 2146: @113643
     /* 113643 */ GIM_Reject,
     /* 113644 */ // Label 2139: @113644
     /* 113644 */ GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(114142),
     /* 113649 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 113652 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113656 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(113741), // Rule ID 2410 //
     /* 113661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113680 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 113688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113706 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113713 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113733 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113739 */     GIR_RootConstrainSelectedInstOperands,
     /* 113740 */     // GIR_Coverage, 2410,
     /* 113740 */     GIR_EraseRootFromParent_Done,
     /* 113741 */   // Label 2153: @113741
     /* 113741 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(113826), // Rule ID 5718 //
     /* 113746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113765 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 113778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 113782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 113786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113791 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113796 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 113798 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sm, (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sn), SPR:{ *:[f32] }:$Sdin))  =>  (VFNMSS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSS),
     /* 113801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Sn
     /* 113811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sm
     /* 113815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113824 */     GIR_RootConstrainSelectedInstOperands,
     /* 113825 */     // GIR_Coverage, 5718,
     /* 113825 */     GIR_EraseRootFromParent_Done,
     /* 113826 */   // Label 2154: @113826
     /* 113826 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(113899), // Rule ID 2399 //
     /* 113831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP4),
     /* 113834 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113838 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 113842 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113846 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113850 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 113854 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113864 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113871 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm, SPR:{ *:[f32] }:$Sdin))  =>  (VFNMAS:{ *:[f32] } SPR:{ *:[f32] }:$Sdin, SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAS),
     /* 113874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113876 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Sdin
     /* 113880 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113884 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113897 */     GIR_RootConstrainSelectedInstOperands,
     /* 113898 */     // GIR_Coverage, 2399,
     /* 113898 */     GIR_EraseRootFromParent_Done,
     /* 113899 */   // Label 2155: @113899
     /* 113899 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(113959), // Rule ID 625 //
     /* 113904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 113907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 113911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 113915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 113919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 113923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113928 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 113935 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm))  =>  (VNMULS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 113935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULS),
     /* 113938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 113944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Sm
     /* 113948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113951 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113957 */     GIR_RootConstrainSelectedInstOperands,
     /* 113958 */     // GIR_Coverage, 625,
     /* 113958 */     GIR_EraseRootFromParent_Done,
     /* 113959 */   // Label 2156: @113959
     /* 113959 */   GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(113989), // Rule ID 663 //
     /* 113964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 113967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 113971 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VNEGS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 113971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGS),
     /* 113974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 113976 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 113978 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 113981 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 113987 */     GIR_RootConstrainSelectedInstOperands,
     /* 113988 */     // GIR_Coverage, 663,
     /* 113988 */     GIR_EraseRootFromParent_Done,
     /* 113989 */   // Label 2157: @113989
     /* 113989 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(114141), // Rule ID 2702 //
     /* 113994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 113997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114001 */     // (fneg:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VNEGfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 114001 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 114004 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114008 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 114015 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 114018 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114022 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114027 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 114030 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114035 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 114038 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 114042 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114047 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 114050 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 114054 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 114057 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114062 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114067 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114072 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 114075 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114079 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114084 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 114087 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 114090 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114096 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114098 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 114101 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114105 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114110 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 114113 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 114123 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 114130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114135 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 114140 */     // GIR_Coverage, 2702,
     /* 114140 */     GIR_EraseRootFromParent_Done,
     /* 114141 */   // Label 2158: @114141
     /* 114141 */   GIM_Reject,
     /* 114142 */ // Label 2152: @114142
     /* 114142 */ GIM_Reject,
     /* 114143 */ // Label 2140: @114143
     /* 114143 */ GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(114489),
     /* 114148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 114151 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114155 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(114240), // Rule ID 2409 //
     /* 114160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114175 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114179 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 114187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114200 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114212 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114225 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114232 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114238 */     GIR_RootConstrainSelectedInstOperands,
     /* 114239 */     // GIR_Coverage, 2409,
     /* 114239 */     GIR_EraseRootFromParent_Done,
     /* 114240 */   // Label 2160: @114240
     /* 114240 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(114325), // Rule ID 5717 //
     /* 114245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114264 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 114277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 114281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 114285 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114295 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 114297 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dm, (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dn), DPR:{ *:[f64] }:$Ddin))  =>  (VFNMSD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMSD),
     /* 114300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Dn
     /* 114310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dm
     /* 114314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114317 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114323 */     GIR_RootConstrainSelectedInstOperands,
     /* 114324 */     // GIR_Coverage, 5717,
     /* 114324 */     GIR_EraseRootFromParent_Done,
     /* 114325 */   // Label 2161: @114325
     /* 114325 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(114398), // Rule ID 2398 //
     /* 114330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP4),
     /* 114333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 114341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114349 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 114353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114368 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114370 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm, DPR:{ *:[f64] }:$Ddin))  =>  (VFNMAD:{ *:[f64] } DPR:{ *:[f64] }:$Ddin, DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VFNMAD),
     /* 114373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ddin
     /* 114379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114387 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114390 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114396 */     GIR_RootConstrainSelectedInstOperands,
     /* 114397 */     // GIR_Coverage, 2398,
     /* 114397 */     GIR_EraseRootFromParent_Done,
     /* 114398 */   // Label 2162: @114398
     /* 114398 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(114458), // Rule ID 624 //
     /* 114403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 114410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 114414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 114418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 114422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114432 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 114434 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm))  =>  (VNMULD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 114434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNMULD),
     /* 114437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Dn
     /* 114443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Dm
     /* 114447 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114450 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114456 */     GIR_RootConstrainSelectedInstOperands,
     /* 114457 */     // GIR_Coverage, 624,
     /* 114457 */     GIR_EraseRootFromParent_Done,
     /* 114458 */   // Label 2163: @114458
     /* 114458 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(114488), // Rule ID 662 //
     /* 114463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114470 */     // (fneg:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VNEGD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 114470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGD),
     /* 114473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 114477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114486 */     GIR_RootConstrainSelectedInstOperands,
     /* 114487 */     // GIR_Coverage, 662,
     /* 114487 */     GIR_EraseRootFromParent_Done,
     /* 114488 */   // Label 2164: @114488
     /* 114488 */   GIM_Reject,
     /* 114489 */ // Label 2159: @114489
     /* 114489 */ GIM_Reject,
     /* 114490 */ // Label 2141: @114490
     /* 114490 */ GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(114527), // Rule ID 1527 //
     /* 114495 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 114501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114505 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114509 */   // (fneg:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VNEGfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 114509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGfd),
     /* 114512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114514 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114516 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114519 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114525 */   GIR_RootConstrainSelectedInstOperands,
     /* 114526 */   // GIR_Coverage, 1527,
     /* 114526 */   GIR_EraseRootFromParent_Done,
     /* 114527 */ // Label 2165: @114527
     /* 114527 */ GIM_Reject,
     /* 114528 */ // Label 2142: @114528
     /* 114528 */ GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(114565), // Rule ID 1529 //
     /* 114533 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114547 */   // (fneg:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VNEGhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 114547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhd),
     /* 114550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114552 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114554 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114557 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114563 */   GIR_RootConstrainSelectedInstOperands,
     /* 114564 */   // GIR_Coverage, 1529,
     /* 114564 */   GIR_EraseRootFromParent_Done,
     /* 114565 */ // Label 2166: @114565
     /* 114565 */ GIM_Reject,
     /* 114566 */ // Label 2143: @114566
     /* 114566 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(114664),
     /* 114571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114574 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(114608), // Rule ID 1528 //
     /* 114579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 114582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114590 */     // (fneg:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VNEGf32q:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 114590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGf32q),
     /* 114593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114597 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114600 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114606 */     GIR_RootConstrainSelectedInstOperands,
     /* 114607 */     // GIR_Coverage, 1528,
     /* 114607 */     GIR_EraseRootFromParent_Done,
     /* 114608 */   // Label 2168: @114608
     /* 114608 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(114663), // Rule ID 4113 //
     /* 114613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114620 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114624 */     // (fneg:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VNEGf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 114624 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114627 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114631 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf32),
     /* 114639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114641 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114643 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114646 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114652 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114661 */     GIR_RootConstrainSelectedInstOperands,
     /* 114662 */     // GIR_Coverage, 4113,
     /* 114662 */     GIR_EraseRootFromParent_Done,
     /* 114663 */   // Label 2169: @114663
     /* 114663 */   GIM_Reject,
     /* 114664 */ // Label 2167: @114664
     /* 114664 */ GIM_Reject,
     /* 114665 */ // Label 2144: @114665
     /* 114665 */ GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(114763),
     /* 114670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114673 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(114707), // Rule ID 1530 //
     /* 114678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 114681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114689 */     // (fneg:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VNEGhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 114689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VNEGhq),
     /* 114692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114694 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 114696 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114699 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114705 */     GIR_RootConstrainSelectedInstOperands,
     /* 114706 */     // GIR_Coverage, 1530,
     /* 114706 */     GIR_EraseRootFromParent_Done,
     /* 114707 */   // Label 2171: @114707
     /* 114707 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(114762), // Rule ID 4111 //
     /* 114712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 114715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 114723 */     // (fneg:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VNEGf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 114723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 114726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 114730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VNEGf16),
     /* 114738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 114740 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 114742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 114745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114760 */     GIR_RootConstrainSelectedInstOperands,
     /* 114761 */     // GIR_Coverage, 4111,
     /* 114761 */     GIR_EraseRootFromParent_Done,
     /* 114762 */   // Label 2172: @114762
     /* 114762 */   GIM_Reject,
     /* 114763 */ // Label 2170: @114763
     /* 114763 */ GIM_Reject,
     /* 114764 */ // Label 2145: @114764
     /* 114764 */ GIM_Reject,
     /* 114765 */ // Label 39: @114765
     /* 114765 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(9), /*)*//*default:*//*Label 2176*/ GIMT_Encode4(115000),
     /* 114776 */ /*GILLT_s32*//*Label 2173*/ GIMT_Encode4(114808),
     /* 114780 */ /*GILLT_s64*//*Label 2174*/ GIMT_Encode4(114868), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 114804 */ /*GILLT_v4s32*//*Label 2175*/ GIMT_Encode4(114965),
     /* 114808 */ // Label 2173: @114808
     /* 114808 */ GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(114867), // Rule ID 2300 //
     /* 114813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 114816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114827 */   // (fpextend:{ *:[f32] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114839 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114843 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114848 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHS),
     /* 114851 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 114853 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114856 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114859 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114865 */   GIR_RootConstrainSelectedInstOperands,
     /* 114866 */   // GIR_Coverage, 2300,
     /* 114866 */   GIR_EraseRootFromParent_Done,
     /* 114867 */ // Label 2177: @114867
     /* 114867 */ GIM_Reject,
     /* 114868 */ // Label 2174: @114868
     /* 114868 */ GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(114905), // Rule ID 660 //
     /* 114873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 114876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 114879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 114887 */   // (fpextend:{ *:[f64] } SPR:{ *:[f32] }:$Sm)  =>  (VCVTDS:{ *:[f64] } SPR:{ *:[f32] }:$Sm)
     /* 114887 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTDS),
     /* 114890 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114892 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 114894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114897 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114903 */   GIR_RootConstrainSelectedInstOperands,
     /* 114904 */   // GIR_Coverage, 660,
     /* 114904 */   GIR_EraseRootFromParent_Done,
     /* 114905 */ // Label 2178: @114905
     /* 114905 */ GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(114964), // Rule ID 2310 //
     /* 114910 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 114913 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 114916 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114920 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 114924 */   // (fpextend:{ *:[f64] } HPR:{ *:[f16] }:$Sm)  =>  (VCVTBHD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } HPR:{ *:[f16] }:$Sm, SPR:{ *:[i32] }))
     /* 114924 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 114927 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114931 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114936 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 114940 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 114945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTBHD),
     /* 114948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 114950 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114962 */   GIR_RootConstrainSelectedInstOperands,
     /* 114963 */   // GIR_Coverage, 2310,
     /* 114963 */   GIR_EraseRootFromParent_Done,
     /* 114964 */ // Label 2179: @114964
     /* 114964 */ GIM_Reject,
     /* 114965 */ // Label 2175: @114965
     /* 114965 */ GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(114999), // Rule ID 2667 //
     /* 114970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 114973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 114977 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 114981 */   // (fpextend:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)  =>  (VCVTh2f:{ *:[v4f32] } DPR:{ *:[v4f16] }:$src)
     /* 114981 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2f),
     /* 114984 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 114986 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114988 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 114991 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 114997 */   GIR_RootConstrainSelectedInstOperands,
     /* 114998 */   // GIR_Coverage, 2667,
     /* 114998 */   GIR_EraseRootFromParent_Done,
     /* 114999 */ // Label 2180: @114999
     /* 114999 */ GIM_Reject,
     /* 115000 */ // Label 2176: @115000
     /* 115000 */ GIM_Reject,
     /* 115001 */ // Label 40: @115001
     /* 115001 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(8), /*)*//*default:*//*Label 2184*/ GIMT_Encode4(115272),
     /* 115012 */ /*GILLT_s16*//*Label 2181*/ GIMT_Encode4(115044),
     /* 115016 */ /*GILLT_s32*//*Label 2182*/ GIMT_Encode4(115199), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115040 */ /*GILLT_v4s16*//*Label 2183*/ GIMT_Encode4(115237),
     /* 115044 */ // Label 2181: @115044
     /* 115044 */ GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(115121), // Rule ID 2302 //
     /* 115049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16),
     /* 115052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115063 */   // (fpround:{ *:[f16] } SPR:{ *:[f32] }:$Sm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBSH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), SPR:{ *:[f32] }:$Sm), HPR:{ *:[i32] })
     /* 115063 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115066 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115070 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBSH),
     /* 115084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115089 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115092 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Sm
     /* 115096 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115099 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115105 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115112 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115115 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115120 */   // GIR_Coverage, 2302,
     /* 115120 */   GIR_EraseRootFromParent_Done,
     /* 115121 */ // Label 2185: @115121
     /* 115121 */ GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(115198), // Rule ID 2312 //
     /* 115126 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115140 */   // (fpround:{ *:[f16] } DPR:{ *:[f64] }:$Dm)  =>  (COPY_TO_REGCLASS:{ *:[f16] } (VCVTBDH:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), DPR:{ *:[f64] }:$Dm), HPR:{ *:[i32] })
     /* 115140 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 115143 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 115147 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115152 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 115154 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115157 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTBDH),
     /* 115161 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115166 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 115169 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Dm
     /* 115173 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115176 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115182 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115184 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115187 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115189 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115192 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::HPRRegClassID),
     /* 115197 */   // GIR_Coverage, 2312,
     /* 115197 */   GIR_EraseRootFromParent_Done,
     /* 115198 */ // Label 2186: @115198
     /* 115198 */ GIM_Reject,
     /* 115199 */ // Label 2182: @115199
     /* 115199 */ GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(115236), // Rule ID 661 //
     /* 115204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115218 */   // (fpround:{ *:[f32] } DPR:{ *:[f64] }:$Dm)  =>  (VCVTSD:{ *:[f32] } DPR:{ *:[f64] }:$Dm)
     /* 115218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTSD),
     /* 115221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 115223 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 115225 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115228 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115234 */   GIR_RootConstrainSelectedInstOperands,
     /* 115235 */   // GIR_Coverage, 661,
     /* 115235 */   GIR_EraseRootFromParent_Done,
     /* 115236 */ // Label 2187: @115236
     /* 115236 */ GIM_Reject,
     /* 115237 */ // Label 2183: @115237
     /* 115237 */ GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(115271), // Rule ID 2666 //
     /* 115242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 115245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 115253 */   // (fpround:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)  =>  (VCVTf2h:{ *:[v4f16] } QPR:{ *:[v4f32] }:$src)
     /* 115253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2h),
     /* 115256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 115258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115260 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 115263 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115269 */   GIR_RootConstrainSelectedInstOperands,
     /* 115270 */   // GIR_Coverage, 2666,
     /* 115270 */   GIR_EraseRootFromParent_Done,
     /* 115271 */ // Label 2188: @115271
     /* 115271 */ GIM_Reject,
     /* 115272 */ // Label 2184: @115272
     /* 115272 */ GIM_Reject,
     /* 115273 */ // Label 41: @115273
     /* 115273 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2196*/ GIMT_Encode4(116606),
     /* 115284 */ /*GILLT_s32*//*Label 2189*/ GIMT_Encode4(115332), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 115296 */ /*GILLT_v2s32*//*Label 2190*/ GIMT_Encode4(116226), GIMT_Encode4(0),
     /* 115304 */ /*GILLT_v4s1*//*Label 2191*/ GIMT_Encode4(116264),
     /* 115308 */ /*GILLT_v4s16*//*Label 2192*/ GIMT_Encode4(116317),
     /* 115312 */ /*GILLT_v4s32*//*Label 2193*/ GIMT_Encode4(116355), GIMT_Encode4(0),
     /* 115320 */ /*GILLT_v8s1*//*Label 2194*/ GIMT_Encode4(116454), GIMT_Encode4(0),
     /* 115328 */ /*GILLT_v8s16*//*Label 2195*/ GIMT_Encode4(116507),
     /* 115332 */ // Label 2189: @115332
     /* 115332 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(115398), // Rule ID 2320 //
     /* 115337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115347 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115351 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115355 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115359 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115364 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115366 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115366 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115369 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSH),
     /* 115373 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115378 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115382 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115387 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115389 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115392 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115397 */   // GIR_Coverage, 2320,
     /* 115397 */   GIR_EraseRootFromParent_Done,
     /* 115398 */ // Label 2197: @115398
     /* 115398 */ GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(115464), // Rule ID 2322 //
     /* 115403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115413 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115417 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115421 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115425 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115430 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115432 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSS),
     /* 115439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115444 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115448 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115463 */   // GIR_Coverage, 2322,
     /* 115463 */   GIR_EraseRootFromParent_Done,
     /* 115464 */ // Label 2198: @115464
     /* 115464 */ GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(115530), // Rule ID 2324 //
     /* 115469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115479 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115483 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 115487 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115491 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115496 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115498 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115498 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115501 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPSD),
     /* 115505 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115510 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115514 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115529 */   // GIR_Coverage, 2324,
     /* 115529 */   GIR_EraseRootFromParent_Done,
     /* 115530 */ // Label 2199: @115530
     /* 115530 */ GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(115596), // Rule ID 2326 //
     /* 115535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115545 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115549 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115553 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115562 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115564 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115564 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115567 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSH),
     /* 115571 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115576 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115580 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115595 */   // GIR_Coverage, 2326,
     /* 115595 */   GIR_EraseRootFromParent_Done,
     /* 115596 */ // Label 2200: @115596
     /* 115596 */ GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(115662), // Rule ID 2328 //
     /* 115601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115623 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115628 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115630 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSS),
     /* 115637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115642 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115646 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115648 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115651 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115653 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115656 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115661 */   // GIR_Coverage, 2328,
     /* 115661 */   GIR_EraseRootFromParent_Done,
     /* 115662 */ // Label 2201: @115662
     /* 115662 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(115728), // Rule ID 2330 //
     /* 115667 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115670 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115677 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115681 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 115685 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115689 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115694 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115696 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMSD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115696 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115699 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMSD),
     /* 115703 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115708 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115712 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115714 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115717 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115719 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115722 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115727 */   // GIR_Coverage, 2330,
     /* 115727 */   GIR_EraseRootFromParent_Done,
     /* 115728 */ // Label 2202: @115728
     /* 115728 */ GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(115794), // Rule ID 2314 //
     /* 115733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 115736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 115739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115751 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 115755 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 115760 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115762 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 115762 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115765 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASH),
     /* 115769 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115774 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115778 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115780 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115783 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115793 */   // GIR_Coverage, 2314,
     /* 115793 */   GIR_EraseRootFromParent_Done,
     /* 115794 */ // Label 2203: @115794
     /* 115794 */ GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(115860), // Rule ID 2316 //
     /* 115799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 115802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115809 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115813 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115817 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 115821 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 115826 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115828 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 115828 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115831 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASS),
     /* 115835 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115840 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115849 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115851 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115854 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115859 */   // GIR_Coverage, 2316,
     /* 115859 */   GIR_EraseRootFromParent_Done,
     /* 115860 */ // Label 2204: @115860
     /* 115860 */ GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(115926), // Rule ID 2318 //
     /* 115865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 115868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 115879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 115883 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 115887 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115892 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 115894 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTASD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115894 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115897 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTASD),
     /* 115901 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115906 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 115910 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115912 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115915 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115917 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115925 */   // GIR_Coverage, 2318,
     /* 115925 */   GIR_EraseRootFromParent_Done,
     /* 115926 */ // Label 2205: @115926
     /* 115926 */ GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(115986), // Rule ID 2349 //
     /* 115931 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 115934 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 115937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 115941 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 115945 */   // (fp_to_sint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 115945 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 115948 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZD),
     /* 115952 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 115957 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 115961 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 115964 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 115970 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 115972 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115975 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 115977 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 115980 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 115985 */   // GIR_Coverage, 2349,
     /* 115985 */   GIR_EraseRootFromParent_Done,
     /* 115986 */ // Label 2206: @115986
     /* 115986 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(116046), // Rule ID 2353 //
     /* 115991 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 115994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 115997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116005 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116005 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116008 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZS),
     /* 116012 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116017 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116021 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116024 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116030 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116045 */   // GIR_Coverage, 2353,
     /* 116045 */   GIR_EraseRootFromParent_Done,
     /* 116046 */ // Label 2207: @116046
     /* 116046 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(116106), // Rule ID 2357 //
     /* 116051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 116054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116065 */   // (fp_to_sint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOSIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116065 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116068 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOSIZH),
     /* 116072 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116077 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116081 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116084 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116097 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116100 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116105 */   // GIR_Coverage, 2357,
     /* 116105 */   GIR_EraseRootFromParent_Done,
     /* 116106 */ // Label 2208: @116106
     /* 116106 */ GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(116225), // Rule ID 2707 //
     /* 116111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 116114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116125 */   // (fp_to_sint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2sd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 116125 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 116128 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116132 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116137 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116139 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 116142 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116146 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116151 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 116154 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 116158 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 116161 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116166 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116171 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116176 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 116179 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116183 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116188 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116191 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 116194 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116207 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 116214 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 116219 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 116224 */   // GIR_Coverage, 2707,
     /* 116224 */   GIR_EraseRootFromParent_Done,
     /* 116225 */ // Label 2209: @116225
     /* 116225 */ GIM_Reject,
     /* 116226 */ // Label 2190: @116226
     /* 116226 */ GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(116263), // Rule ID 1601 //
     /* 116231 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116245 */   // (fp_to_sint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2sd:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 116245 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sd),
     /* 116248 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116250 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116252 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116255 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116261 */   GIR_RootConstrainSelectedInstOperands,
     /* 116262 */   // GIR_Coverage, 1601,
     /* 116262 */   GIR_EraseRootFromParent_Done,
     /* 116263 */ // Label 2210: @116263
     /* 116263 */ GIM_Reject,
     /* 116264 */ // Label 2191: @116264
     /* 116264 */ GIM_Try, /*On fail goto*//*Label 2211*/ GIMT_Encode4(116316), // Rule ID 5102 //
     /* 116269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116283 */   // (fp_to_sint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 116286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116288 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116290 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116296 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116299 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116302 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116308 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116314 */   GIR_RootConstrainSelectedInstOperands,
     /* 116315 */   // GIR_Coverage, 5102,
     /* 116315 */   GIR_EraseRootFromParent_Done,
     /* 116316 */ // Label 2211: @116316
     /* 116316 */ GIM_Reject,
     /* 116317 */ // Label 2192: @116317
     /* 116317 */ GIM_Try, /*On fail goto*//*Label 2212*/ GIMT_Encode4(116354), // Rule ID 1609 //
     /* 116322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116332 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116336 */   // (fp_to_sint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2sd:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 116336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sd),
     /* 116339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116341 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116343 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116346 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116352 */   GIR_RootConstrainSelectedInstOperands,
     /* 116353 */   // GIR_Coverage, 1609,
     /* 116353 */   GIR_EraseRootFromParent_Done,
     /* 116354 */ // Label 2212: @116354
     /* 116354 */ GIM_Reject,
     /* 116355 */ // Label 2193: @116355
     /* 116355 */ GIM_Try, /*On fail goto*//*Label 2213*/ GIMT_Encode4(116453),
     /* 116360 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116363 */   GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(116397), // Rule ID 1605 //
     /* 116368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116379 */     // (fp_to_sint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2sq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 116379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2sq),
     /* 116382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116389 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116395 */     GIR_RootConstrainSelectedInstOperands,
     /* 116396 */     // GIR_Coverage, 1605,
     /* 116396 */     GIR_EraseRootFromParent_Done,
     /* 116397 */   // Label 2214: @116397
     /* 116397 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(116452), // Rule ID 4091 //
     /* 116402 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116413 */     // (fp_to_sint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTs32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 116413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs32f32z),
     /* 116428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116430 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116432 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116435 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116441 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116450 */     GIR_RootConstrainSelectedInstOperands,
     /* 116451 */     // GIR_Coverage, 4091,
     /* 116451 */     GIR_EraseRootFromParent_Done,
     /* 116452 */   // Label 2215: @116452
     /* 116452 */   GIM_Reject,
     /* 116453 */ // Label 2213: @116453
     /* 116453 */ GIM_Reject,
     /* 116454 */ // Label 2194: @116454
     /* 116454 */ GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(116506), // Rule ID 5103 //
     /* 116459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 116469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116473 */   // (fp_to_sint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 116473 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 116476 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 116478 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 116480 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116486 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 116489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116492 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116498 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116504 */   GIR_RootConstrainSelectedInstOperands,
     /* 116505 */   // GIR_Coverage, 5103,
     /* 116505 */   GIR_EraseRootFromParent_Done,
     /* 116506 */ // Label 2216: @116506
     /* 116506 */ GIM_Reject,
     /* 116507 */ // Label 2195: @116507
     /* 116507 */ GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(116605),
     /* 116512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116515 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(116549), // Rule ID 1613 //
     /* 116520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116527 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 116531 */     // (fp_to_sint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2sq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 116531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2sq),
     /* 116534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 116536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 116538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 116541 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116547 */     GIR_RootConstrainSelectedInstOperands,
     /* 116548 */     // GIR_Coverage, 1613,
     /* 116548 */     GIR_EraseRootFromParent_Done,
     /* 116549 */   // Label 2218: @116549
     /* 116549 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(116604), // Rule ID 4087 //
     /* 116554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 116557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 116565 */     // (fp_to_sint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTs16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 116565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 116568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTs16f16z),
     /* 116580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 116582 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 116587 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 116599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116602 */     GIR_RootConstrainSelectedInstOperands,
     /* 116603 */     // GIR_Coverage, 4087,
     /* 116603 */     GIR_EraseRootFromParent_Done,
     /* 116604 */   // Label 2219: @116604
     /* 116604 */   GIM_Reject,
     /* 116605 */ // Label 2217: @116605
     /* 116605 */ GIM_Reject,
     /* 116606 */ // Label 2196: @116606
     /* 116606 */ GIM_Reject,
     /* 116607 */ // Label 42: @116607
     /* 116607 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2227*/ GIMT_Encode4(117940),
     /* 116618 */ /*GILLT_s32*//*Label 2220*/ GIMT_Encode4(116666), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 116630 */ /*GILLT_v2s32*//*Label 2221*/ GIMT_Encode4(117560), GIMT_Encode4(0),
     /* 116638 */ /*GILLT_v4s1*//*Label 2222*/ GIMT_Encode4(117598),
     /* 116642 */ /*GILLT_v4s16*//*Label 2223*/ GIMT_Encode4(117651),
     /* 116646 */ /*GILLT_v4s32*//*Label 2224*/ GIMT_Encode4(117689), GIMT_Encode4(0),
     /* 116654 */ /*GILLT_v8s1*//*Label 2225*/ GIMT_Encode4(117788), GIMT_Encode4(0),
     /* 116662 */ /*GILLT_v8s16*//*Label 2226*/ GIMT_Encode4(117841),
     /* 116666 */ // Label 2220: @116666
     /* 116666 */ GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(116732), // Rule ID 2321 //
     /* 116671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116689 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116693 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116698 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116700 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116700 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116703 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUH),
     /* 116707 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116712 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116726 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116731 */   // GIR_Coverage, 2321,
     /* 116731 */   GIR_EraseRootFromParent_Done,
     /* 116732 */ // Label 2228: @116732
     /* 116732 */ GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(116798), // Rule ID 2323 //
     /* 116737 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116747 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116751 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116755 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116759 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116764 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116766 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUS),
     /* 116773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116778 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116784 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116787 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116789 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116797 */   // GIR_Coverage, 2323,
     /* 116797 */   GIR_EraseRootFromParent_Done,
     /* 116798 */ // Label 2229: @116798
     /* 116798 */ GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(116864), // Rule ID 2325 //
     /* 116803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 116806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 116821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 116825 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 116830 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116832 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTPUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 116832 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116835 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTPUD),
     /* 116839 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116844 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116848 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116858 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116863 */   // GIR_Coverage, 2325,
     /* 116863 */   GIR_EraseRootFromParent_Done,
     /* 116864 */ // Label 2230: @116864
     /* 116864 */ GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(116930), // Rule ID 2327 //
     /* 116869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116879 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116883 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116887 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 116891 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 116896 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116898 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 116898 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116901 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUH),
     /* 116905 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116910 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116914 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116921 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116924 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116929 */   // GIR_Coverage, 2327,
     /* 116929 */   GIR_EraseRootFromParent_Done,
     /* 116930 */ // Label 2231: @116930
     /* 116930 */ GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(116996), // Rule ID 2329 //
     /* 116935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 116945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 116949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 116953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 116957 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 116962 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 116964 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 116964 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 116967 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUS),
     /* 116971 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116976 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 116980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 116982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 116995 */   // GIR_Coverage, 2329,
     /* 116995 */   GIR_EraseRootFromParent_Done,
     /* 116996 */ // Label 2232: @116996
     /* 116996 */ GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(117062), // Rule ID 2331 //
     /* 117001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117011 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117015 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 117019 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117023 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117030 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTMUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117030 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117033 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTMUD),
     /* 117037 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117042 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117046 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117053 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117056 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117061 */   // GIR_Coverage, 2331,
     /* 117061 */   GIR_EraseRootFromParent_Done,
     /* 117062 */ // Label 2233: @117062
     /* 117062 */ GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(117128), // Rule ID 2315 //
     /* 117067 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117077 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117081 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117085 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 117089 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117094 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117096 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f16] } HPR:{ *:[f16] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117096 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117099 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUH),
     /* 117103 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117108 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117112 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117114 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117117 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117119 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117122 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117127 */   // GIR_Coverage, 2315,
     /* 117127 */   GIR_EraseRootFromParent_Done,
     /* 117128 */ // Label 2234: @117128
     /* 117128 */ GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(117194), // Rule ID 2317 //
     /* 117133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117139 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117143 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117147 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117151 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 117155 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117160 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117162 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } SPR:{ *:[f32] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117162 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117165 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUS),
     /* 117169 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117174 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117185 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117188 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117193 */   // GIR_Coverage, 2317,
     /* 117193 */   GIR_EraseRootFromParent_Done,
     /* 117194 */ // Label 2235: @117194
     /* 117194 */ GIM_Try, /*On fail goto*//*Label 2236*/ GIMT_Encode4(117260), // Rule ID 2319 //
     /* 117199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 117202 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117205 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117209 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 117213 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 117217 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 117221 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 117228 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } DPR:{ *:[f64] }:$a))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VCVTAUD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117228 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117231 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTAUD),
     /* 117235 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117240 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 117244 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117246 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117249 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117251 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117254 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117259 */   // GIR_Coverage, 2319,
     /* 117259 */   GIR_EraseRootFromParent_Done,
     /* 117260 */ // Label 2236: @117260
     /* 117260 */ GIM_Try, /*On fail goto*//*Label 2237*/ GIMT_Encode4(117320), // Rule ID 2359 //
     /* 117265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 117268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117279 */   // (fp_to_uint:{ *:[i32] } DPR:{ *:[f64] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZD:{ *:[f32] } DPR:{ *:[f64] }:$a), GPR:{ *:[i32] })
     /* 117279 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117282 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZD),
     /* 117286 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117291 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117295 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117298 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117304 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117314 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117319 */   // GIR_Coverage, 2359,
     /* 117319 */   GIR_EraseRootFromParent_Done,
     /* 117320 */ // Label 2237: @117320
     /* 117320 */ GIM_Try, /*On fail goto*//*Label 2238*/ GIMT_Encode4(117380), // Rule ID 2363 //
     /* 117325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117339 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZS:{ *:[f32] } SPR:{ *:[f32] }:$a), GPR:{ *:[i32] })
     /* 117339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZS),
     /* 117346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117351 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117355 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117358 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117374 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117379 */   // GIR_Coverage, 2363,
     /* 117379 */   GIR_EraseRootFromParent_Done,
     /* 117380 */ // Label 2238: @117380
     /* 117380 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(117440), // Rule ID 2367 //
     /* 117385 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 117388 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 117395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 117399 */   // (fp_to_uint:{ *:[i32] } HPR:{ *:[f16] }:$a)  =>  (COPY_TO_REGCLASS:{ *:[i32] } (VTOUIZH:{ *:[f32] } HPR:{ *:[f16] }:$a), GPR:{ *:[i32] })
     /* 117399 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117402 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VTOUIZH),
     /* 117406 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117411 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117415 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117418 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117424 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117429 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117431 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117434 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::GPRRegClassID),
     /* 117439 */   // GIR_Coverage, 2367,
     /* 117439 */   GIR_EraseRootFromParent_Done,
     /* 117440 */ // Label 2239: @117440
     /* 117440 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(117559), // Rule ID 2708 //
     /* 117445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 117448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117455 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 117459 */   // (fp_to_uint:{ *:[i32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[i32] } (VCVTf2ud:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 117459 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 117462 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117466 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117471 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117473 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 117476 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117480 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117485 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 117488 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 117492 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 117495 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117500 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117505 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117510 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 117513 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117517 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117522 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117525 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 117528 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117534 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117536 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117539 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117541 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 117548 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 117553 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 117558 */   // GIR_Coverage, 2708,
     /* 117558 */   GIR_EraseRootFromParent_Done,
     /* 117559 */ // Label 2240: @117559
     /* 117559 */ GIM_Reject,
     /* 117560 */ // Label 2221: @117560
     /* 117560 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(117597), // Rule ID 1602 //
     /* 117565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117579 */   // (fp_to_uint:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VCVTf2ud:{ *:[v2i32] } DPR:{ *:[v2f32] }:$Vm)
     /* 117579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2ud),
     /* 117582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117586 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117589 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117595 */   GIR_RootConstrainSelectedInstOperands,
     /* 117596 */   // GIR_Coverage, 1602,
     /* 117596 */   GIR_EraseRootFromParent_Done,
     /* 117597 */ // Label 2241: @117597
     /* 117597 */ GIM_Reject,
     /* 117598 */ // Label 2222: @117598
     /* 117598 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(117650), // Rule ID 5100 //
     /* 117603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117617 */   // (fp_to_uint:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1)  =>  (MVE_VCMPf32r:{ *:[v4i1] } MQPR:{ *:[v4f32] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117617 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf32r),
     /* 117620 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117622 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117624 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117630 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117633 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117636 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117642 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117648 */   GIR_RootConstrainSelectedInstOperands,
     /* 117649 */   // GIR_Coverage, 5100,
     /* 117649 */   GIR_EraseRootFromParent_Done,
     /* 117650 */ // Label 2242: @117650
     /* 117650 */ GIM_Reject,
     /* 117651 */ // Label 2223: @117651
     /* 117651 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(117688), // Rule ID 1610 //
     /* 117656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117666 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 117670 */   // (fp_to_uint:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VCVTh2ud:{ *:[v4i16] } DPR:{ *:[v4f16] }:$Vm)
     /* 117670 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2ud),
     /* 117673 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117675 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117677 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117680 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117686 */   GIR_RootConstrainSelectedInstOperands,
     /* 117687 */   // GIR_Coverage, 1610,
     /* 117687 */   GIR_EraseRootFromParent_Done,
     /* 117688 */ // Label 2243: @117688
     /* 117688 */ GIM_Reject,
     /* 117689 */ // Label 2224: @117689
     /* 117689 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(117787),
     /* 117694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117697 */   GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(117731), // Rule ID 1606 //
     /* 117702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117713 */     // (fp_to_uint:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VCVTf2uq:{ *:[v4i32] } QPR:{ *:[v4f32] }:$Vm)
     /* 117713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTf2uq),
     /* 117716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117718 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117723 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117729 */     GIR_RootConstrainSelectedInstOperands,
     /* 117730 */     // GIR_Coverage, 1606,
     /* 117730 */     GIR_EraseRootFromParent_Done,
     /* 117731 */   // Label 2245: @117731
     /* 117731 */   GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(117786), // Rule ID 4093 //
     /* 117736 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117747 */     // (fp_to_uint:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)  =>  (MVE_VCVTu32f32z:{ *:[v4i32] } MQPR:{ *:[v4f32] }:$src)
     /* 117747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu32f32z),
     /* 117762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117764 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117766 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117769 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117775 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117784 */     GIR_RootConstrainSelectedInstOperands,
     /* 117785 */     // GIR_Coverage, 4093,
     /* 117785 */     GIR_EraseRootFromParent_Done,
     /* 117786 */   // Label 2246: @117786
     /* 117786 */   GIM_Reject,
     /* 117787 */ // Label 2244: @117787
     /* 117787 */ GIM_Reject,
     /* 117788 */ // Label 2225: @117788
     /* 117788 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(117840), // Rule ID 5101 //
     /* 117793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::VCCRRegClassID),
     /* 117803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117807 */   // (fp_to_uint:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1)  =>  (MVE_VCMPf16r:{ *:[v8i1] } MQPR:{ *:[v8f16] }:$v1, ZR:{ *:[i32] }, 1:{ *:[i32] })
     /* 117807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCMPf16r),
     /* 117810 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[P0]
     /* 117812 */   GIR_RootToRootCopy, /*OpIdx*/1, // v1
     /* 117814 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::ZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117820 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 117823 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117826 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117832 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117838 */   GIR_RootConstrainSelectedInstOperands,
     /* 117839 */   // GIR_Coverage, 5101,
     /* 117839 */   GIR_EraseRootFromParent_Done,
     /* 117840 */ // Label 2247: @117840
     /* 117840 */ GIM_Reject,
     /* 117841 */ // Label 2226: @117841
     /* 117841 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(117939),
     /* 117846 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117849 */   GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(117883), // Rule ID 1614 //
     /* 117854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 117865 */     // (fp_to_uint:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VCVTh2uq:{ *:[v8i16] } QPR:{ *:[v8f16] }:$Vm)
     /* 117865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTh2uq),
     /* 117868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 117870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 117872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 117875 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117881 */     GIR_RootConstrainSelectedInstOperands,
     /* 117882 */     // GIR_Coverage, 1614,
     /* 117882 */     GIR_EraseRootFromParent_Done,
     /* 117883 */   // Label 2249: @117883
     /* 117883 */   GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(117938), // Rule ID 4089 //
     /* 117888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 117891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117895 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 117899 */     // (fp_to_uint:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)  =>  (MVE_VCVTu16f16z:{ *:[v8i16] } MQPR:{ *:[v8f16] }:$src)
     /* 117899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 117902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTu16f16z),
     /* 117914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 117916 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 117918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 117921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 117933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117936 */     GIR_RootConstrainSelectedInstOperands,
     /* 117937 */     // GIR_Coverage, 4089,
     /* 117937 */     GIR_EraseRootFromParent_Done,
     /* 117938 */   // Label 2250: @117938
     /* 117938 */   GIM_Reject,
     /* 117939 */ // Label 2248: @117939
     /* 117939 */ GIM_Reject,
     /* 117940 */ // Label 2227: @117940
     /* 117940 */ GIM_Reject,
     /* 117941 */ // Label 43: @117941
     /* 117941 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2258*/ GIMT_Encode4(118592),
     /* 117952 */ /*GILLT_s16*//*Label 2251*/ GIMT_Encode4(118004),
     /* 117956 */ /*GILLT_s32*//*Label 2252*/ GIMT_Encode4(118064),
     /* 117960 */ /*GILLT_s64*//*Label 2253*/ GIMT_Encode4(118258), GIMT_Encode4(0),
     /* 117968 */ /*GILLT_v2s32*//*Label 2254*/ GIMT_Encode4(118318), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 117980 */ /*GILLT_v4s16*//*Label 2255*/ GIMT_Encode4(118356),
     /* 117984 */ /*GILLT_v4s32*//*Label 2256*/ GIMT_Encode4(118394), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118000 */ /*GILLT_v8s16*//*Label 2257*/ GIMT_Encode4(118493),
     /* 118004 */ // Label 2251: @118004
     /* 118004 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(118063), // Rule ID 2343 //
     /* 118009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118015 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118019 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118023 */   // (sint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VSITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118023 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118026 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118030 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118035 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118039 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOH),
     /* 118047 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118049 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118061 */   GIR_RootConstrainSelectedInstOperands,
     /* 118062 */   // GIR_Coverage, 2343,
     /* 118062 */   GIR_EraseRootFromParent_Done,
     /* 118063 */ // Label 2259: @118063
     /* 118063 */ GIM_Reject,
     /* 118064 */ // Label 2252: @118064
     /* 118064 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(118257),
     /* 118069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118080 */   GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(118128), // Rule ID 2341 //
     /* 118085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118088 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VSITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118088 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118091 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118095 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118100 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118104 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOS),
     /* 118112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118117 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118120 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118126 */     GIR_RootConstrainSelectedInstOperands,
     /* 118127 */     // GIR_Coverage, 2341,
     /* 118127 */     GIR_EraseRootFromParent_Done,
     /* 118128 */   // Label 2261: @118128
     /* 118128 */   GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(118256), // Rule ID 2709 //
     /* 118133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118136 */     // (sint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTs2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118136 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118139 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118143 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118148 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118152 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118157 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118160 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118164 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118171 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118174 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118178 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118183 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118186 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118189 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118192 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118197 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118202 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118207 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118210 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118214 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118219 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118225 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118238 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118255 */     // GIR_Coverage, 2709,
     /* 118255 */     GIR_EraseRootFromParent_Done,
     /* 118256 */   // Label 2262: @118256
     /* 118256 */   GIM_Reject,
     /* 118257 */ // Label 2260: @118257
     /* 118257 */ GIM_Reject,
     /* 118258 */ // Label 2253: @118258
     /* 118258 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(118317), // Rule ID 2339 //
     /* 118263 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118273 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118277 */   // (sint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VSITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118277 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118280 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118284 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118289 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSITOD),
     /* 118301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118309 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118315 */   GIR_RootConstrainSelectedInstOperands,
     /* 118316 */   // GIR_Coverage, 2339,
     /* 118316 */   GIR_EraseRootFromParent_Done,
     /* 118317 */ // Label 2263: @118317
     /* 118317 */ GIM_Reject,
     /* 118318 */ // Label 2254: @118318
     /* 118318 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(118355), // Rule ID 1603 //
     /* 118323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118337 */   // (sint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTs2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fd),
     /* 118340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118342 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118344 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118347 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118353 */   GIR_RootConstrainSelectedInstOperands,
     /* 118354 */   // GIR_Coverage, 1603,
     /* 118354 */   GIR_EraseRootFromParent_Done,
     /* 118355 */ // Label 2264: @118355
     /* 118355 */ GIM_Reject,
     /* 118356 */ // Label 2255: @118356
     /* 118356 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(118393), // Rule ID 1611 //
     /* 118361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 118367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118375 */   // (sint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTs2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 118375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hd),
     /* 118378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118380 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118382 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118385 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118391 */   GIR_RootConstrainSelectedInstOperands,
     /* 118392 */   // GIR_Coverage, 1611,
     /* 118392 */   GIR_EraseRootFromParent_Done,
     /* 118393 */ // Label 2265: @118393
     /* 118393 */ GIM_Reject,
     /* 118394 */ // Label 2256: @118394
     /* 118394 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(118492),
     /* 118399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 118402 */   GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(118436), // Rule ID 1607 //
     /* 118407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118418 */     // (sint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTs2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 118418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2fq),
     /* 118421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118423 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118428 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118434 */     GIR_RootConstrainSelectedInstOperands,
     /* 118435 */     // GIR_Coverage, 1607,
     /* 118435 */     GIR_EraseRootFromParent_Done,
     /* 118436 */   // Label 2267: @118436
     /* 118436 */   GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(118491), // Rule ID 4099 //
     /* 118441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118452 */     // (sint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32s32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 118452 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118455 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118459 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32s32n),
     /* 118467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118469 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118486 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118489 */     GIR_RootConstrainSelectedInstOperands,
     /* 118490 */     // GIR_Coverage, 4099,
     /* 118490 */     GIR_EraseRootFromParent_Done,
     /* 118491 */   // Label 2268: @118491
     /* 118491 */   GIM_Reject,
     /* 118492 */ // Label 2266: @118492
     /* 118492 */ GIM_Reject,
     /* 118493 */ // Label 2257: @118493
     /* 118493 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(118591),
     /* 118498 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 118501 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(118535), // Rule ID 1615 //
     /* 118506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 118509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 118517 */     // (sint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTs2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 118517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTs2hq),
     /* 118520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118524 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118527 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118533 */     GIR_RootConstrainSelectedInstOperands,
     /* 118534 */     // GIR_Coverage, 1615,
     /* 118534 */     GIR_EraseRootFromParent_Done,
     /* 118535 */   // Label 2270: @118535
     /* 118535 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(118590), // Rule ID 4095 //
     /* 118540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 118543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 118551 */     // (sint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16s16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 118551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 118554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16s16n),
     /* 118566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 118568 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 118570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 118573 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118579 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118588 */     GIR_RootConstrainSelectedInstOperands,
     /* 118589 */     // GIR_Coverage, 4095,
     /* 118589 */     GIR_EraseRootFromParent_Done,
     /* 118590 */   // Label 2271: @118590
     /* 118590 */   GIM_Reject,
     /* 118591 */ // Label 2269: @118591
     /* 118591 */ GIM_Reject,
     /* 118592 */ // Label 2258: @118592
     /* 118592 */ GIM_Reject,
     /* 118593 */ // Label 44: @118593
     /* 118593 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2279*/ GIMT_Encode4(119244),
     /* 118604 */ /*GILLT_s16*//*Label 2272*/ GIMT_Encode4(118656),
     /* 118608 */ /*GILLT_s32*//*Label 2273*/ GIMT_Encode4(118716),
     /* 118612 */ /*GILLT_s64*//*Label 2274*/ GIMT_Encode4(118910), GIMT_Encode4(0),
     /* 118620 */ /*GILLT_v2s32*//*Label 2275*/ GIMT_Encode4(118970), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118632 */ /*GILLT_v4s16*//*Label 2276*/ GIMT_Encode4(119008),
     /* 118636 */ /*GILLT_v4s32*//*Label 2277*/ GIMT_Encode4(119046), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118652 */ /*GILLT_v8s16*//*Label 2278*/ GIMT_Encode4(119145),
     /* 118656 */ // Label 2272: @118656
     /* 118656 */ GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(118715), // Rule ID 2348 //
     /* 118661 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118664 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 118671 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118675 */   // (uint_to_fp:{ *:[f16] } GPR:{ *:[i32] }:$a)  =>  (VUITOH:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118675 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118678 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118682 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118687 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118691 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOH),
     /* 118699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118701 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118704 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118707 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118713 */   GIR_RootConstrainSelectedInstOperands,
     /* 118714 */   // GIR_Coverage, 2348,
     /* 118714 */   GIR_EraseRootFromParent_Done,
     /* 118715 */ // Label 2280: @118715
     /* 118715 */ GIM_Reject,
     /* 118716 */ // Label 2273: @118716
     /* 118716 */ GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(118909),
     /* 118721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 118728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118732 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(118780), // Rule ID 2346 //
     /* 118737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 118740 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (VUITOS:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118740 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118743 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118747 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118752 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118756 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOS),
     /* 118764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 118766 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118769 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118772 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118778 */     GIR_RootConstrainSelectedInstOperands,
     /* 118779 */     // GIR_Coverage, 2346,
     /* 118779 */     GIR_EraseRootFromParent_Done,
     /* 118780 */   // Label 2282: @118780
     /* 118780 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(118908), // Rule ID 2710 //
     /* 118785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 118788 */     // (uint_to_fp:{ *:[f32] } GPR:{ *:[i32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (VCVTu2fd:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), (COPY_TO_REGCLASS:{ *:[i32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }), ssub_0:{ *:[i32] })), ssub_0:{ *:[i32] })
     /* 118788 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 118791 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118795 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118800 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118804 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118809 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 118812 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118816 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118821 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118823 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s32,
     /* 118826 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118830 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118835 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 118838 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 118841 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/17,
     /* 118844 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118849 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118854 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118859 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 118862 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118866 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118871 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 118877 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118883 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 118885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118890 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 118897 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118902 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 118907 */     // GIR_Coverage, 2710,
     /* 118907 */     GIR_EraseRootFromParent_Done,
     /* 118908 */   // Label 2283: @118908
     /* 118908 */   GIM_Reject,
     /* 118909 */ // Label 2281: @118909
     /* 118909 */ GIM_Reject,
     /* 118910 */ // Label 2274: @118910
     /* 118910 */ GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(118969), // Rule ID 2344 //
     /* 118915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 118918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 118921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 118929 */   // (uint_to_fp:{ *:[f64] } GPR:{ *:[i32] }:$a)  =>  (VUITOD:{ *:[f64] } (COPY_TO_REGCLASS:{ *:[f32] } GPR:{ *:[i32] }:$a, SPR:{ *:[i32] }))
     /* 118929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 118932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 118936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 118945 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 118950 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VUITOD),
     /* 118953 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 118955 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118958 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118961 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 118967 */   GIR_RootConstrainSelectedInstOperands,
     /* 118968 */   // GIR_Coverage, 2344,
     /* 118968 */   GIR_EraseRootFromParent_Done,
     /* 118969 */ // Label 2284: @118969
     /* 118969 */ GIM_Reject,
     /* 118970 */ // Label 2275: @118970
     /* 118970 */ GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(119007), // Rule ID 1604 //
     /* 118975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 118978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 118981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 118989 */   // (uint_to_fp:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCVTu2fd:{ *:[v2f32] } DPR:{ *:[v2i32] }:$Vm)
     /* 118989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fd),
     /* 118992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 118994 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 118996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 118999 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119005 */   GIR_RootConstrainSelectedInstOperands,
     /* 119006 */   // GIR_Coverage, 1604,
     /* 119006 */   GIR_EraseRootFromParent_Done,
     /* 119007 */ // Label 2285: @119007
     /* 119007 */ GIM_Reject,
     /* 119008 */ // Label 2276: @119008
     /* 119008 */ GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(119045), // Rule ID 1612 //
     /* 119013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119016 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119027 */   // (uint_to_fp:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCVTu2hd:{ *:[v4f16] } DPR:{ *:[v4i16] }:$Vm)
     /* 119027 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hd),
     /* 119030 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119032 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119034 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119037 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119043 */   GIR_RootConstrainSelectedInstOperands,
     /* 119044 */   // GIR_Coverage, 1612,
     /* 119044 */   GIR_EraseRootFromParent_Done,
     /* 119045 */ // Label 2286: @119045
     /* 119045 */ GIM_Reject,
     /* 119046 */ // Label 2277: @119046
     /* 119046 */ GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(119144),
     /* 119051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119054 */   GIM_Try, /*On fail goto*//*Label 2288*/ GIMT_Encode4(119088), // Rule ID 1608 //
     /* 119059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119066 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119070 */     // (uint_to_fp:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCVTu2fq:{ *:[v4f32] } QPR:{ *:[v4i32] }:$Vm)
     /* 119070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2fq),
     /* 119073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119077 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119080 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119086 */     GIR_RootConstrainSelectedInstOperands,
     /* 119087 */     // GIR_Coverage, 1608,
     /* 119087 */     GIR_EraseRootFromParent_Done,
     /* 119088 */   // Label 2288: @119088
     /* 119088 */   GIM_Try, /*On fail goto*//*Label 2289*/ GIMT_Encode4(119143), // Rule ID 4101 //
     /* 119093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119100 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119104 */     // (uint_to_fp:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VCVTf32u32n:{ *:[v4f32] } MQPR:{ *:[v4i32] }:$src)
     /* 119104 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119107 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119111 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf32u32n),
     /* 119119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119121 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119123 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119126 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119132 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119141 */     GIR_RootConstrainSelectedInstOperands,
     /* 119142 */     // GIR_Coverage, 4101,
     /* 119142 */     GIR_EraseRootFromParent_Done,
     /* 119143 */   // Label 2289: @119143
     /* 119143 */   GIM_Reject,
     /* 119144 */ // Label 2287: @119144
     /* 119144 */ GIM_Reject,
     /* 119145 */ // Label 2278: @119145
     /* 119145 */ GIM_Try, /*On fail goto*//*Label 2290*/ GIMT_Encode4(119243),
     /* 119150 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119153 */   GIM_Try, /*On fail goto*//*Label 2291*/ GIMT_Encode4(119187), // Rule ID 1616 //
     /* 119158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119169 */     // (uint_to_fp:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCVTu2hq:{ *:[v8f16] } QPR:{ *:[v8i16] }:$Vm)
     /* 119169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCVTu2hq),
     /* 119172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119179 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119185 */     GIR_RootConstrainSelectedInstOperands,
     /* 119186 */     // GIR_Coverage, 1616,
     /* 119186 */     GIR_EraseRootFromParent_Done,
     /* 119187 */   // Label 2291: @119187
     /* 119187 */   GIM_Try, /*On fail goto*//*Label 2292*/ GIMT_Encode4(119242), // Rule ID 4097 //
     /* 119192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119203 */     // (uint_to_fp:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VCVTf16u16n:{ *:[v8f16] } MQPR:{ *:[v8i16] }:$src)
     /* 119203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCVTf16u16n),
     /* 119218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119220 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 119222 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119225 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119231 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119240 */     GIR_RootConstrainSelectedInstOperands,
     /* 119241 */     // GIR_Coverage, 4097,
     /* 119241 */     GIR_EraseRootFromParent_Done,
     /* 119242 */   // Label 2292: @119242
     /* 119242 */   GIM_Reject,
     /* 119243 */ // Label 2290: @119243
     /* 119243 */ GIM_Reject,
     /* 119244 */ // Label 2279: @119244
     /* 119244 */ GIM_Reject,
     /* 119245 */ // Label 45: @119245
     /* 119245 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2300*/ GIMT_Encode4(120020),
     /* 119256 */ /*GILLT_s16*//*Label 2293*/ GIMT_Encode4(119308),
     /* 119260 */ /*GILLT_s32*//*Label 2294*/ GIMT_Encode4(119346),
     /* 119264 */ /*GILLT_s64*//*Label 2295*/ GIMT_Encode4(119538), GIMT_Encode4(0),
     /* 119272 */ /*GILLT_v2s32*//*Label 2296*/ GIMT_Encode4(119576), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119284 */ /*GILLT_v4s16*//*Label 2297*/ GIMT_Encode4(119614),
     /* 119288 */ /*GILLT_v4s32*//*Label 2298*/ GIMT_Encode4(119652), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 119304 */ /*GILLT_v8s16*//*Label 2299*/ GIMT_Encode4(119836),
     /* 119308 */ // Label 2293: @119308
     /* 119308 */ GIM_Try, /*On fail goto*//*Label 2301*/ GIMT_Encode4(119345), // Rule ID 653 //
     /* 119313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 119316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 119319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119323 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 119327 */   // (fabs:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VABSH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 119327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSH),
     /* 119330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119332 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119334 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119337 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119343 */   GIR_RootConstrainSelectedInstOperands,
     /* 119344 */   // GIR_Coverage, 653,
     /* 119344 */   GIR_EraseRootFromParent_Done,
     /* 119345 */ // Label 2301: @119345
     /* 119345 */ GIM_Reject,
     /* 119346 */ // Label 2294: @119346
     /* 119346 */ GIM_Try, /*On fail goto*//*Label 2302*/ GIMT_Encode4(119537),
     /* 119351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 119354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 119362 */   GIM_Try, /*On fail goto*//*Label 2303*/ GIMT_Encode4(119388), // Rule ID 652 //
     /* 119367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNEONForFP_HasVFP2),
     /* 119370 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VABSS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 119370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSS),
     /* 119373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 119375 */     GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 119377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119380 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119386 */     GIR_RootConstrainSelectedInstOperands,
     /* 119387 */     // GIR_Coverage, 652,
     /* 119387 */     GIR_EraseRootFromParent_Done,
     /* 119388 */   // Label 2303: @119388
     /* 119388 */   GIM_Try, /*On fail goto*//*Label 2304*/ GIMT_Encode4(119536), // Rule ID 2701 //
     /* 119393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_UseNEONForFP),
     /* 119396 */     // (fabs:{ *:[f32] } SPR:{ *:[f32] }:$a)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VABSfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 119396 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 119399 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119403 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119408 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 119410 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 119413 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119417 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119422 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 119425 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119430 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 119433 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 119437 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119442 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 119445 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 119449 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 119452 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119457 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119462 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119467 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 119470 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119474 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119479 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 119482 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 119485 */     GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119491 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 119493 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 119496 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119500 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119505 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 119508 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 119516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 119518 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 119525 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 119530 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 119535 */     // GIR_Coverage, 2701,
     /* 119535 */     GIR_EraseRootFromParent_Done,
     /* 119536 */   // Label 2304: @119536
     /* 119536 */   GIM_Reject,
     /* 119537 */ // Label 2302: @119537
     /* 119537 */ GIM_Reject,
     /* 119538 */ // Label 2295: @119538
     /* 119538 */ GIM_Try, /*On fail goto*//*Label 2305*/ GIMT_Encode4(119575), // Rule ID 651 //
     /* 119543 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 119546 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 119549 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119553 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119557 */   // (fabs:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VABSD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 119557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSD),
     /* 119560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 119562 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 119564 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119567 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119573 */   GIR_RootConstrainSelectedInstOperands,
     /* 119574 */   // GIR_Coverage, 651,
     /* 119574 */   GIR_EraseRootFromParent_Done,
     /* 119575 */ // Label 2305: @119575
     /* 119575 */ GIM_Reject,
     /* 119576 */ // Label 2296: @119576
     /* 119576 */ GIM_Try, /*On fail goto*//*Label 2306*/ GIMT_Encode4(119613), // Rule ID 1511 //
     /* 119581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 119587 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119591 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119595 */   // (fabs:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)  =>  (VABSfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vm)
     /* 119595 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfd),
     /* 119598 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119600 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119602 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119605 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119611 */   GIR_RootConstrainSelectedInstOperands,
     /* 119612 */   // GIR_Coverage, 1511,
     /* 119612 */   GIR_EraseRootFromParent_Done,
     /* 119613 */ // Label 2306: @119613
     /* 119613 */ GIM_Reject,
     /* 119614 */ // Label 2297: @119614
     /* 119614 */ GIM_Try, /*On fail goto*//*Label 2307*/ GIMT_Encode4(119651), // Rule ID 1513 //
     /* 119619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 119625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 119633 */   // (fabs:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)  =>  (VABShd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vm)
     /* 119633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShd),
     /* 119636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119638 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119640 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119643 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119649 */   GIR_RootConstrainSelectedInstOperands,
     /* 119650 */   // GIR_Coverage, 1513,
     /* 119650 */   GIR_EraseRootFromParent_Done,
     /* 119651 */ // Label 2307: @119651
     /* 119651 */ GIM_Reject,
     /* 119652 */ // Label 2298: @119652
     /* 119652 */ GIM_Try, /*On fail goto*//*Label 2308*/ GIMT_Encode4(119835),
     /* 119657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119660 */   GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(119745), // Rule ID 4038 //
     /* 119665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 119684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 119688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119700 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn))  =>  (MVE_VABDf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 119700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf32),
     /* 119715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119725 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119728 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119734 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119740 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119743 */     GIR_RootConstrainSelectedInstOperands,
     /* 119744 */     // GIR_Coverage, 4038,
     /* 119744 */     GIR_EraseRootFromParent_Done,
     /* 119745 */   // Label 2309: @119745
     /* 119745 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(119779), // Rule ID 1512 //
     /* 119750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 119753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119761 */     // (fabs:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)  =>  (VABSfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vm)
     /* 119761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSfq),
     /* 119764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119766 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119771 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119777 */     GIR_RootConstrainSelectedInstOperands,
     /* 119778 */     // GIR_Coverage, 1512,
     /* 119778 */     GIR_EraseRootFromParent_Done,
     /* 119779 */   // Label 2310: @119779
     /* 119779 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(119834), // Rule ID 4109 //
     /* 119784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119795 */     // (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$v)  =>  (MVE_VABSf32:{ *:[v4f32] } ?:{ *:[v4f32] }:$v)
     /* 119795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf32),
     /* 119810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119812 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119814 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119817 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119823 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119832 */     GIR_RootConstrainSelectedInstOperands,
     /* 119833 */     // GIR_Coverage, 4109,
     /* 119833 */     GIR_EraseRootFromParent_Done,
     /* 119834 */   // Label 2311: @119834
     /* 119834 */   GIM_Reject,
     /* 119835 */ // Label 2308: @119835
     /* 119835 */ GIM_Reject,
     /* 119836 */ // Label 2299: @119836
     /* 119836 */ GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(120019),
     /* 119841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119844 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(119929), // Rule ID 4037 //
     /* 119849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 119852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 119860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 119864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 119868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 119872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119882 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 119884 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn))  =>  (MVE_VABDf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 119884 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119887 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119891 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABDf16),
     /* 119899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 119905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Qn
     /* 119909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 119912 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119924 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 119927 */     GIR_RootConstrainSelectedInstOperands,
     /* 119928 */     // GIR_Coverage, 4037,
     /* 119928 */     GIR_EraseRootFromParent_Done,
     /* 119929 */   // Label 2313: @119929
     /* 119929 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(119963), // Rule ID 1514 //
     /* 119934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 119937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 119945 */     // (fabs:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)  =>  (VABShq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vm)
     /* 119945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABShq),
     /* 119948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 119950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 119952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 119955 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 119961 */     GIR_RootConstrainSelectedInstOperands,
     /* 119962 */     // GIR_Coverage, 1514,
     /* 119962 */     GIR_EraseRootFromParent_Done,
     /* 119963 */   // Label 2314: @119963
     /* 119963 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(120018), // Rule ID 4107 //
     /* 119968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 119971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 119979 */     // (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$v)  =>  (MVE_VABSf16:{ *:[v8f16] } ?:{ *:[v8f16] }:$v)
     /* 119979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 119982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 119986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 119991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSf16),
     /* 119994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 119996 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 119998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120007 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120016 */     GIR_RootConstrainSelectedInstOperands,
     /* 120017 */     // GIR_Coverage, 4107,
     /* 120017 */     GIR_EraseRootFromParent_Done,
     /* 120018 */   // Label 2315: @120018
     /* 120018 */   GIM_Reject,
     /* 120019 */ // Label 2312: @120019
     /* 120019 */ GIM_Reject,
     /* 120020 */ // Label 2300: @120020
     /* 120020 */ GIM_Reject,
     /* 120021 */ // Label 46: @120021
     /* 120021 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2323*/ GIMT_Encode4(120612),
     /* 120032 */ /*GILLT_s16*//*Label 2316*/ GIMT_Encode4(120084),
     /* 120036 */ /*GILLT_s32*//*Label 2317*/ GIMT_Encode4(120118),
     /* 120040 */ /*GILLT_s64*//*Label 2318*/ GIMT_Encode4(120152), GIMT_Encode4(0),
     /* 120048 */ /*GILLT_v2s32*//*Label 2319*/ GIMT_Encode4(120186), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120060 */ /*GILLT_v4s16*//*Label 2320*/ GIMT_Encode4(120220),
     /* 120064 */ /*GILLT_v4s32*//*Label 2321*/ GIMT_Encode4(120254), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120080 */ /*GILLT_v8s16*//*Label 2322*/ GIMT_Encode4(120433),
     /* 120084 */ // Label 2316: @120084
     /* 120084 */ GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(120117), // Rule ID 642 //
     /* 120089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120106 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120110 */   // (fminnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMINNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120110 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMH),
     /* 120115 */   GIR_RootConstrainSelectedInstOperands,
     /* 120116 */   // GIR_Coverage, 642,
     /* 120116 */   GIR_Done,
     /* 120117 */ // Label 2324: @120117
     /* 120117 */ GIM_Reject,
     /* 120118 */ // Label 2317: @120118
     /* 120118 */ GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(120151), // Rule ID 643 //
     /* 120123 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120136 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120140 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120144 */   // (fminnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMINNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMS),
     /* 120149 */   GIR_RootConstrainSelectedInstOperands,
     /* 120150 */   // GIR_Coverage, 643,
     /* 120150 */   GIR_Done,
     /* 120151 */ // Label 2325: @120151
     /* 120151 */ GIM_Reject,
     /* 120152 */ // Label 2318: @120152
     /* 120152 */ GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(120185), // Rule ID 644 //
     /* 120157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120178 */   // (fminnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMINNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMINNMD),
     /* 120183 */   GIR_RootConstrainSelectedInstOperands,
     /* 120184 */   // GIR_Coverage, 644,
     /* 120184 */   GIR_Done,
     /* 120185 */ // Label 2326: @120185
     /* 120185 */ GIM_Reject,
     /* 120186 */ // Label 2319: @120186
     /* 120186 */ GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(120219), // Rule ID 1230 //
     /* 120191 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120197 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120200 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120204 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120208 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120212 */   // (fminnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMINNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120212 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDf),
     /* 120217 */   GIR_RootConstrainSelectedInstOperands,
     /* 120218 */   // GIR_Coverage, 1230,
     /* 120218 */   GIR_Done,
     /* 120219 */ // Label 2327: @120219
     /* 120219 */ GIM_Reject,
     /* 120220 */ // Label 2320: @120220
     /* 120220 */ GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(120253), // Rule ID 1232 //
     /* 120225 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120231 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120242 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120246 */   // (fminnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMINNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNDh),
     /* 120251 */   GIR_RootConstrainSelectedInstOperands,
     /* 120252 */   // GIR_Coverage, 1232,
     /* 120252 */   GIR_Done,
     /* 120253 */ // Label 2328: @120253
     /* 120253 */ GIM_Reject,
     /* 120254 */ // Label 2321: @120254
     /* 120254 */ GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(120432),
     /* 120259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120265 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(120343), // Rule ID 4119 //
     /* 120270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120289 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120313 */     // (fminnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMINNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf32),
     /* 120316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120322 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120326 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120329 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120335 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120341 */     GIR_RootConstrainSelectedInstOperands,
     /* 120342 */     // GIR_Coverage, 4119,
     /* 120342 */     GIR_EraseRootFromParent_Done,
     /* 120343 */   // Label 2330: @120343
     /* 120343 */   GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(120370), // Rule ID 1231 //
     /* 120348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120363 */     // (fminnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMINNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQf),
     /* 120368 */     GIR_RootConstrainSelectedInstOperands,
     /* 120369 */     // GIR_Coverage, 1231,
     /* 120369 */     GIR_Done,
     /* 120370 */   // Label 2331: @120370
     /* 120370 */   GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(120431), // Rule ID 3285 //
     /* 120375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120390 */     // (fminnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMINNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf32),
     /* 120405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120407 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120411 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120414 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120420 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120426 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120429 */     GIR_RootConstrainSelectedInstOperands,
     /* 120430 */     // GIR_Coverage, 3285,
     /* 120430 */     GIR_EraseRootFromParent_Done,
     /* 120431 */   // Label 2332: @120431
     /* 120431 */   GIM_Reject,
     /* 120432 */ // Label 2329: @120432
     /* 120432 */ GIM_Reject,
     /* 120433 */ // Label 2322: @120433
     /* 120433 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(120611),
     /* 120438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 120444 */   GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(120522), // Rule ID 4121 //
     /* 120449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120468 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 120485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120492 */     // (fminnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMINNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 120492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMAf16),
     /* 120495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120508 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120514 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120520 */     GIR_RootConstrainSelectedInstOperands,
     /* 120521 */     // GIR_Coverage, 4121,
     /* 120521 */     GIR_EraseRootFromParent_Done,
     /* 120522 */   // Label 2334: @120522
     /* 120522 */   GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(120549), // Rule ID 1233 //
     /* 120527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120534 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120542 */     // (fminnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMINNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 120542 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMINNMNQh),
     /* 120547 */     GIR_RootConstrainSelectedInstOperands,
     /* 120548 */     // GIR_Coverage, 1233,
     /* 120548 */     GIR_Done,
     /* 120549 */   // Label 2335: @120549
     /* 120549 */   GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(120610), // Rule ID 3288 //
     /* 120554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120569 */     // (fminnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMINNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 120569 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120572 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120576 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINNMf16),
     /* 120584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120586 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 120588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 120590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120593 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 120608 */     GIR_RootConstrainSelectedInstOperands,
     /* 120609 */     // GIR_Coverage, 3288,
     /* 120609 */     GIR_EraseRootFromParent_Done,
     /* 120610 */   // Label 2336: @120610
     /* 120610 */   GIM_Reject,
     /* 120611 */ // Label 2333: @120611
     /* 120611 */ GIM_Reject,
     /* 120612 */ // Label 2323: @120612
     /* 120612 */ GIM_Reject,
     /* 120613 */ // Label 47: @120613
     /* 120613 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2344*/ GIMT_Encode4(121204),
     /* 120624 */ /*GILLT_s16*//*Label 2337*/ GIMT_Encode4(120676),
     /* 120628 */ /*GILLT_s32*//*Label 2338*/ GIMT_Encode4(120710),
     /* 120632 */ /*GILLT_s64*//*Label 2339*/ GIMT_Encode4(120744), GIMT_Encode4(0),
     /* 120640 */ /*GILLT_v2s32*//*Label 2340*/ GIMT_Encode4(120778), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120652 */ /*GILLT_v4s16*//*Label 2341*/ GIMT_Encode4(120812),
     /* 120656 */ /*GILLT_v4s32*//*Label 2342*/ GIMT_Encode4(120846), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 120672 */ /*GILLT_v8s16*//*Label 2343*/ GIMT_Encode4(121025),
     /* 120676 */ // Label 2337: @120676
     /* 120676 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(120709), // Rule ID 639 //
     /* 120681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 120684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 120687 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 120690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120698 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 120702 */   // (fmaxnum:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)  =>  (VFP_VMAXNMH:{ *:[f16] } HPR:{ *:[f16] }:$Sn, HPR:{ *:[f16] }:$Sm)
     /* 120702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMH),
     /* 120707 */   GIR_RootConstrainSelectedInstOperands,
     /* 120708 */   // GIR_Coverage, 639,
     /* 120708 */   GIR_Done,
     /* 120709 */ // Label 2345: @120709
     /* 120709 */ GIM_Reject,
     /* 120710 */ // Label 2338: @120710
     /* 120710 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(120743), // Rule ID 640 //
     /* 120715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 120718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 120721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 120724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120728 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120732 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 120736 */   // (fmaxnum:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)  =>  (VFP_VMAXNMS:{ *:[f32] } SPR:{ *:[f32] }:$Sn, SPR:{ *:[f32] }:$Sm)
     /* 120736 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMS),
     /* 120741 */   GIR_RootConstrainSelectedInstOperands,
     /* 120742 */   // GIR_Coverage, 640,
     /* 120742 */   GIR_Done,
     /* 120743 */ // Label 2346: @120743
     /* 120743 */ GIM_Reject,
     /* 120744 */ // Label 2339: @120744
     /* 120744 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(120777), // Rule ID 641 //
     /* 120749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 120752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 120755 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 120758 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120762 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120766 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120770 */   // (fmaxnum:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)  =>  (VFP_VMAXNMD:{ *:[f64] } DPR:{ *:[f64] }:$Dn, DPR:{ *:[f64] }:$Dm)
     /* 120770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VFP_VMAXNMD),
     /* 120775 */   GIR_RootConstrainSelectedInstOperands,
     /* 120776 */   // GIR_Coverage, 641,
     /* 120776 */   GIR_Done,
     /* 120777 */ // Label 2347: @120777
     /* 120777 */ GIM_Reject,
     /* 120778 */ // Label 2340: @120778
     /* 120778 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(120811), // Rule ID 1210 //
     /* 120783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 120789 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 120792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120800 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120804 */   // (fmaxnum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (NEON_VMAXNMNDf:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 120804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDf),
     /* 120809 */   GIR_RootConstrainSelectedInstOperands,
     /* 120810 */   // GIR_Coverage, 1210,
     /* 120810 */   GIR_Done,
     /* 120811 */ // Label 2348: @120811
     /* 120811 */ GIM_Reject,
     /* 120812 */ // Label 2341: @120812
     /* 120812 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(120845), // Rule ID 1212 //
     /* 120817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 120820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 120823 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 120826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120830 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120834 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 120838 */   // (fmaxnum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (NEON_VMAXNMNDh:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 120838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNDh),
     /* 120843 */   GIR_RootConstrainSelectedInstOperands,
     /* 120844 */   // GIR_Coverage, 1212,
     /* 120844 */   GIR_Done,
     /* 120845 */ // Label 2349: @120845
     /* 120845 */ GIM_Reject,
     /* 120846 */ // Label 2342: @120846
     /* 120846 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(121024),
     /* 120851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 120857 */   GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(120935), // Rule ID 4115 //
     /* 120862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 120865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 120873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 120890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 120894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 120898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 120905 */     // (fmaxnum:{ *:[v4f32] } (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd), (fabs:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm))  =>  (MVE_VMAXNMAf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qd, MQPR:{ *:[v4f32] }:$Qm)
     /* 120905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf32),
     /* 120908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 120914 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 120918 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 120921 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120927 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 120933 */     GIR_RootConstrainSelectedInstOperands,
     /* 120934 */     // GIR_Coverage, 4115,
     /* 120934 */     GIR_EraseRootFromParent_Done,
     /* 120935 */   // Label 2351: @120935
     /* 120935 */   GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(120962), // Rule ID 1211 //
     /* 120940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasNEON),
     /* 120943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 120955 */     // (fmaxnum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (NEON_VMAXNMNQf:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 120955 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQf),
     /* 120960 */     GIR_RootConstrainSelectedInstOperands,
     /* 120961 */     // GIR_Coverage, 1211,
     /* 120961 */     GIR_Done,
     /* 120962 */   // Label 2352: @120962
     /* 120962 */   GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(121023), // Rule ID 3027 //
     /* 120967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 120970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 120982 */     // (fmaxnum:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)  =>  (MVE_VMAXNMf32:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$Qm, MQPR:{ *:[v4f32] }:$Qn)
     /* 120982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 120985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 120989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 120994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf32),
     /* 120997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 120999 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121003 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121006 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121012 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121021 */     GIR_RootConstrainSelectedInstOperands,
     /* 121022 */     // GIR_Coverage, 3027,
     /* 121022 */     GIR_EraseRootFromParent_Done,
     /* 121023 */   // Label 2353: @121023
     /* 121023 */   GIM_Reject,
     /* 121024 */ // Label 2350: @121024
     /* 121024 */ GIM_Reject,
     /* 121025 */ // Label 2343: @121025
     /* 121025 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(121203),
     /* 121030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121036 */   GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(121114), // Rule ID 4117 //
     /* 121041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 121044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 121052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121056 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 121069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 121073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121077 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 121084 */     // (fmaxnum:{ *:[v8f16] } (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd), (fabs:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm))  =>  (MVE_VMAXNMAf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qd, MQPR:{ *:[v8f16] }:$Qm)
     /* 121084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMAf16),
     /* 121087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qd
     /* 121093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Qm
     /* 121097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121112 */     GIR_RootConstrainSelectedInstOperands,
     /* 121113 */     // GIR_Coverage, 4117,
     /* 121113 */     GIR_EraseRootFromParent_Done,
     /* 121114 */   // Label 2355: @121114
     /* 121114 */   GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(121141), // Rule ID 1213 //
     /* 121119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasFullFP16_HasNEON),
     /* 121122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121134 */     // (fmaxnum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (NEON_VMAXNMNQh:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::NEON_VMAXNMNQh),
     /* 121139 */     GIR_RootConstrainSelectedInstOperands,
     /* 121140 */     // GIR_Coverage, 1213,
     /* 121140 */     GIR_Done,
     /* 121141 */   // Label 2356: @121141
     /* 121141 */   GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(121202), // Rule ID 3282 //
     /* 121146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 121149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 121161 */     // (fmaxnum:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)  =>  (MVE_VMAXNMf16:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$Qm, MQPR:{ *:[v8f16] }:$Qn)
     /* 121161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 121164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXNMf16),
     /* 121176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 121178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 121180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 121182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121185 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121191 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121197 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121200 */     GIR_RootConstrainSelectedInstOperands,
     /* 121201 */     // GIR_Coverage, 3282,
     /* 121201 */     GIR_EraseRootFromParent_Done,
     /* 121202 */   // Label 2357: @121202
     /* 121202 */   GIM_Reject,
     /* 121203 */ // Label 2354: @121203
     /* 121203 */ GIM_Reject,
     /* 121204 */ // Label 2344: @121204
     /* 121204 */ GIM_Reject,
     /* 121205 */ // Label 48: @121205
     /* 121205 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2364*/ GIMT_Encode4(121938),
     /* 121216 */ /*GILLT_s16*//*Label 2358*/ GIMT_Encode4(121268),
     /* 121220 */ /*GILLT_s32*//*Label 2359*/ GIMT_Encode4(121509), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121232 */ /*GILLT_v2s32*//*Label 2360*/ GIMT_Encode4(121750), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121244 */ /*GILLT_v4s16*//*Label 2361*/ GIMT_Encode4(121797),
     /* 121248 */ /*GILLT_v4s32*//*Label 2362*/ GIMT_Encode4(121844), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121264 */ /*GILLT_v8s16*//*Label 2363*/ GIMT_Encode4(121891),
     /* 121268 */ // Label 2358: @121268
     /* 121268 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(121508), // Rule ID 2704 //
     /* 121273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 121276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 121279 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 121282 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121286 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121290 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 121294 */   // (fminimum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMINhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121294 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 121297 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121301 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121306 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121308 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 121311 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121315 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121320 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121323 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121328 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 121331 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121335 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121340 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121343 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121347 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121350 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121355 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121360 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121365 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 121368 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121372 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121377 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121379 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 121382 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121386 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121391 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121394 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121399 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 121402 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121406 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121411 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121414 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121418 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121421 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121426 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121431 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 121436 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121439 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121443 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121448 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121451 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121454 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121457 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121465 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 121468 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121472 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121477 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121480 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121485 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121488 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121490 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121497 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121502 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121507 */   // GIR_Coverage, 2704,
     /* 121507 */   GIR_EraseRootFromParent_Done,
     /* 121508 */ // Label 2365: @121508
     /* 121508 */ GIM_Reject,
     /* 121509 */ // Label 2359: @121509
     /* 121509 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(121749), // Rule ID 2706 //
     /* 121514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 121520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 121523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 121535 */   // (fminimum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMINfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 121535 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 121538 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121542 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121547 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 121549 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 121552 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121556 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121561 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 121564 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121569 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 121572 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121576 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121581 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 121584 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 121588 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 121591 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121596 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121601 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121606 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 121609 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 121613 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121618 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 121620 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 121623 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121627 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121632 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 121635 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121640 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 121643 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 121647 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121652 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 121655 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 121659 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 121662 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121667 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121672 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 121680 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121684 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121689 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 121692 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 121695 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 121698 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 121706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 121709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121718 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 121721 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 121729 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121731 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 121738 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 121743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 121748 */   // GIR_Coverage, 2706,
     /* 121748 */   GIR_EraseRootFromParent_Done,
     /* 121749 */ // Label 2366: @121749
     /* 121749 */ GIM_Reject,
     /* 121750 */ // Label 2360: @121750
     /* 121750 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(121796), // Rule ID 1226 //
     /* 121755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 121761 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 121764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121772 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121776 */   // (fminimum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMINfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 121776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfd),
     /* 121779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121781 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121783 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121785 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121788 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121794 */   GIR_RootConstrainSelectedInstOperands,
     /* 121795 */   // GIR_Coverage, 1226,
     /* 121795 */   GIR_EraseRootFromParent_Done,
     /* 121796 */ // Label 2367: @121796
     /* 121796 */ GIM_Reject,
     /* 121797 */ // Label 2361: @121797
     /* 121797 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(121843), // Rule ID 1228 //
     /* 121802 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121805 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 121808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 121811 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121815 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121819 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 121823 */   // (fminimum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMINhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 121823 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhd),
     /* 121826 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121828 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121830 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121832 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121835 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121841 */   GIR_RootConstrainSelectedInstOperands,
     /* 121842 */   // GIR_Coverage, 1228,
     /* 121842 */   GIR_EraseRootFromParent_Done,
     /* 121843 */ // Label 2368: @121843
     /* 121843 */ GIM_Reject,
     /* 121844 */ // Label 2362: @121844
     /* 121844 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(121890), // Rule ID 1227 //
     /* 121849 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 121852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 121855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 121858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121862 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121866 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121870 */   // (fminimum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMINfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 121870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINfq),
     /* 121873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121875 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121877 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121879 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121882 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121888 */   GIR_RootConstrainSelectedInstOperands,
     /* 121889 */   // GIR_Coverage, 1227,
     /* 121889 */   GIR_EraseRootFromParent_Done,
     /* 121890 */ // Label 2369: @121890
     /* 121890 */ GIM_Reject,
     /* 121891 */ // Label 2363: @121891
     /* 121891 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(121937), // Rule ID 1229 //
     /* 121896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 121899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 121902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 121905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121909 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121913 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 121917 */   // (fminimum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMINhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 121917 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINhq),
     /* 121920 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 121922 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 121924 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 121926 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 121929 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 121935 */   GIR_RootConstrainSelectedInstOperands,
     /* 121936 */   // GIR_Coverage, 1229,
     /* 121936 */   GIR_EraseRootFromParent_Done,
     /* 121937 */ // Label 2370: @121937
     /* 121937 */ GIM_Reject,
     /* 121938 */ // Label 2364: @121938
     /* 121938 */ GIM_Reject,
     /* 121939 */ // Label 49: @121939
     /* 121939 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2377*/ GIMT_Encode4(122672),
     /* 121950 */ /*GILLT_s16*//*Label 2371*/ GIMT_Encode4(122002),
     /* 121954 */ /*GILLT_s32*//*Label 2372*/ GIMT_Encode4(122243), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121966 */ /*GILLT_v2s32*//*Label 2373*/ GIMT_Encode4(122484), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121978 */ /*GILLT_v4s16*//*Label 2374*/ GIMT_Encode4(122531),
     /* 121982 */ /*GILLT_v4s32*//*Label 2375*/ GIMT_Encode4(122578), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 121998 */ /*GILLT_v8s16*//*Label 2376*/ GIMT_Encode4(122625),
     /* 122002 */ // Label 2371: @122002
     /* 122002 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(122242), // Rule ID 2703 //
     /* 122007 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 122010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 122013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 122016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 122028 */   // (fmaximum:{ *:[f16] } HPR:{ *:[f16] }:$a, HPR:{ *:[f16] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (VMAXhd:{ *:[f64] } (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), DPR_VFP2:{ *:[i32] }), HPR:{ *:[f16] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122028 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 122031 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122035 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122040 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122042 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s16,
     /* 122045 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122049 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122054 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122057 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122062 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 122065 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122069 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122074 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122077 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122081 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122084 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122089 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122094 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122099 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s16,
     /* 122102 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122106 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122113 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s16,
     /* 122116 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122120 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122125 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122128 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122133 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 122136 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122140 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122145 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122148 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122152 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122155 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122160 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122165 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::HPRRegClassID),
     /* 122170 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122173 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122177 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122182 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122185 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122188 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122191 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122197 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 122202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122211 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122224 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122236 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122241 */   // GIR_Coverage, 2703,
     /* 122241 */   GIR_EraseRootFromParent_Done,
     /* 122242 */ // Label 2378: @122242
     /* 122242 */ GIM_Reject,
     /* 122243 */ // Label 2372: @122243
     /* 122243 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(122483), // Rule ID 2705 //
     /* 122248 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122251 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 122254 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 122257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122265 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 122269 */   // (fmaximum:{ *:[f32] } SPR:{ *:[f32] }:$a, SPR:{ *:[f32] }:$b)  =>  (EXTRACT_SUBREG:{ *:[f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (VMAXfd:{ *:[f64] } (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$a, ssub_0:{ *:[i32] }), (INSERT_SUBREG:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), DPR_VFP2:{ *:[i32] }), SPR:{ *:[f32] }:$b, ssub_0:{ *:[i32] })), DPR_VFP2:{ *:[i32] }), ssub_0:{ *:[i32] })
     /* 122269 */   GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v2s32,
     /* 122272 */   GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122276 */   GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122281 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 122283 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v2s32,
     /* 122286 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122290 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122295 */   GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 122298 */   GIR_ConstrainOperandRC, /*InsnID*/7, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122303 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v2s32,
     /* 122306 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122310 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122315 */   GIR_AddSimpleTempRegister, /*InsnID*/6, /*TempRegID*/6,
     /* 122318 */   GIR_Copy, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/2, // b
     /* 122322 */   GIR_AddImm8, /*InsnID*/6, /*Imm*/17,
     /* 122325 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122330 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122335 */   GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122340 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v2s32,
     /* 122343 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 122347 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122352 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 122354 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v2s32,
     /* 122357 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122361 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122366 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 122369 */   GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122374 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s32,
     /* 122377 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 122381 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122386 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 122389 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // a
     /* 122393 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/17,
     /* 122396 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122401 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122406 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122411 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 122414 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122418 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122423 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 122426 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/5,
     /* 122429 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/14,
     /* 122432 */   GIR_AddRegister, /*InsnID*/2, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122438 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 122440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 122443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122452 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 122455 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 122463 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122465 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(ARM::ssub_0),
     /* 122472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(ARM::SPRRegClassID),
     /* 122477 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(ARM::DPR_VFP2RegClassID),
     /* 122482 */   // GIR_Coverage, 2705,
     /* 122482 */   GIR_EraseRootFromParent_Done,
     /* 122483 */ // Label 2379: @122483
     /* 122483 */ GIM_Reject,
     /* 122484 */ // Label 2373: @122484
     /* 122484 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(122530), // Rule ID 1206 //
     /* 122489 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122492 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122495 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122506 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122510 */   // (fmaximum:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)  =>  (VMAXfd:{ *:[v2f32] } DPR:{ *:[v2f32] }:$Vn, DPR:{ *:[v2f32] }:$Vm)
     /* 122510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfd),
     /* 122513 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122515 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122517 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122519 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122522 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122528 */   GIR_RootConstrainSelectedInstOperands,
     /* 122529 */   // GIR_Coverage, 1206,
     /* 122529 */   GIR_EraseRootFromParent_Done,
     /* 122530 */ // Label 2380: @122530
     /* 122530 */ GIM_Reject,
     /* 122531 */ // Label 2374: @122531
     /* 122531 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(122577), // Rule ID 1208 //
     /* 122536 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 122542 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 122545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122553 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122557 */   // (fmaximum:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)  =>  (VMAXhd:{ *:[v4f16] } DPR:{ *:[v4f16] }:$Vn, DPR:{ *:[v4f16] }:$Vm)
     /* 122557 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhd),
     /* 122560 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122562 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122564 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122566 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122569 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122575 */   GIR_RootConstrainSelectedInstOperands,
     /* 122576 */   // GIR_Coverage, 1208,
     /* 122576 */   GIR_EraseRootFromParent_Done,
     /* 122577 */ // Label 2381: @122577
     /* 122577 */ GIM_Reject,
     /* 122578 */ // Label 2375: @122578
     /* 122578 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(122624), // Rule ID 1207 //
     /* 122583 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 122589 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 122592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122600 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122604 */   // (fmaximum:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)  =>  (VMAXfq:{ *:[v4f32] } QPR:{ *:[v4f32] }:$Vn, QPR:{ *:[v4f32] }:$Vm)
     /* 122604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXfq),
     /* 122607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122609 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122611 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122613 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122616 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122622 */   GIR_RootConstrainSelectedInstOperands,
     /* 122623 */   // GIR_Coverage, 1207,
     /* 122623 */   GIR_EraseRootFromParent_Done,
     /* 122624 */ // Label 2382: @122624
     /* 122624 */ GIM_Reject,
     /* 122625 */ // Label 2376: @122625
     /* 122625 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(122671), // Rule ID 1209 //
     /* 122630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 122633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 122636 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 122639 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122643 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122647 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 122651 */   // (fmaximum:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)  =>  (VMAXhq:{ *:[v8f16] } QPR:{ *:[v8f16] }:$Vn, QPR:{ *:[v8f16] }:$Vm)
     /* 122651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXhq),
     /* 122654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122656 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122658 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122660 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122663 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122669 */   GIR_RootConstrainSelectedInstOperands,
     /* 122670 */   // GIR_Coverage, 1209,
     /* 122670 */   GIR_EraseRootFromParent_Done,
     /* 122671 */ // Label 2383: @122671
     /* 122671 */ GIM_Reject,
     /* 122672 */ // Label 2377: @122672
     /* 122672 */ GIM_Reject,
     /* 122673 */ // Label 50: @122673
     /* 122673 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(122705), // Rule ID 2416 //
     /* 122678 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122685 */   // (get_fpenv:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122685 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122688 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122690 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122693 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122699 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122703 */   GIR_RootConstrainSelectedInstOperands,
     /* 122704 */   // GIR_Coverage, 2416,
     /* 122704 */   GIR_EraseRootFromParent_Done,
     /* 122705 */ // Label 2384: @122705
     /* 122705 */ GIM_Reject,
     /* 122706 */ // Label 51: @122706
     /* 122706 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(122741), // Rule ID 2417 //
     /* 122711 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122714 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122718 */   // (set_fpenv GPRnopc:{ *:[i32] }:$Rt)  =>  (VMSR:{ *:[i32] } GPRnopc:{ *:[i32] }:$Rt)
     /* 122718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122721 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 122723 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122726 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122732 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122735 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122739 */   GIR_RootConstrainSelectedInstOperands,
     /* 122740 */   // GIR_Coverage, 2417,
     /* 122740 */   GIR_EraseRootFromParent_Done,
     /* 122741 */ // Label 2385: @122741
     /* 122741 */ GIM_Reject,
     /* 122742 */ // Label 52: @122742
     /* 122742 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(122806), // Rule ID 2418 //
     /* 122747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 122750 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (MOVi:{ *:[i32] } 0:{ *:[i32] }))
     /* 122750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::MOVi),
     /* 122757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122762 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122765 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122768 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122774 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122785 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122791 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122797 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122800 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122804 */   GIR_RootConstrainSelectedInstOperands,
     /* 122805 */   // GIR_Coverage, 2418,
     /* 122805 */   GIR_EraseRootFromParent_Done,
     /* 122806 */ // Label 2386: @122806
     /* 122806 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(122870), // Rule ID 2419 //
     /* 122811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 122814 */   // (reset_fpenv)  =>  (VMSR:{ *:[i32] } (tMOVi8:{ *:[i32] } 0:{ *:[i32] }))
     /* 122814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::tMOVi8),
     /* 122821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122826 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::CPSR), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define | RegState::Dead),
     /* 122832 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 122835 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 122838 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMSR),
     /* 122849 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122852 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122855 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122861 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for ARM::FPSCR*/0,
     /* 122864 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122868 */   GIR_RootConstrainSelectedInstOperands,
     /* 122869 */   // GIR_Coverage, 2419,
     /* 122869 */   GIR_EraseRootFromParent_Done,
     /* 122870 */ // Label 2387: @122870
     /* 122870 */ GIM_Reject,
     /* 122871 */ // Label 53: @122871
     /* 122871 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(122903), // Rule ID 2420 //
     /* 122876 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 122879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRnopcRegClassID),
     /* 122883 */   // (get_fpmode:{ *:[i32] })  =>  (VMRS:{ *:[i32] })
     /* 122883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMRS),
     /* 122886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 122891 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 122897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122901 */   GIR_RootConstrainSelectedInstOperands,
     /* 122902 */   // GIR_Coverage, 2420,
     /* 122902 */   GIR_EraseRootFromParent_Done,
     /* 122903 */ // Label 2388: @122903
     /* 122903 */ GIM_Reject,
     /* 122904 */ // Label 54: @122904
     /* 122904 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2395*/ GIMT_Encode4(123446),
     /* 122915 */ /*GILLT_v2s32*//*Label 2389*/ GIMT_Encode4(122963), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122927 */ /*GILLT_v4s16*//*Label 2390*/ GIMT_Encode4(123010),
     /* 122931 */ /*GILLT_v4s32*//*Label 2391*/ GIMT_Encode4(123057), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122943 */ /*GILLT_v8s8*//*Label 2392*/ GIMT_Encode4(123171),
     /* 122947 */ /*GILLT_v8s16*//*Label 2393*/ GIMT_Encode4(123218), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 122959 */ /*GILLT_v16s8*//*Label 2394*/ GIMT_Encode4(123332),
     /* 122963 */ // Label 2389: @122963
     /* 122963 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(123009), // Rule ID 1215 //
     /* 122968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 122971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 122974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 122977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122985 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 122989 */   // (smin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 122989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv2i32),
     /* 122992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 122994 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 122996 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 122998 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123001 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123007 */   GIR_RootConstrainSelectedInstOperands,
     /* 123008 */   // GIR_Coverage, 1215,
     /* 123008 */   GIR_EraseRootFromParent_Done,
     /* 123009 */ // Label 2396: @123009
     /* 123009 */ GIM_Reject,
     /* 123010 */ // Label 2390: @123010
     /* 123010 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(123056), // Rule ID 1214 //
     /* 123015 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123018 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123021 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123024 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123028 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123032 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123036 */   // (smin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i16),
     /* 123039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123041 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123043 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123045 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123048 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123054 */   GIR_RootConstrainSelectedInstOperands,
     /* 123055 */   // GIR_Coverage, 1214,
     /* 123055 */   GIR_EraseRootFromParent_Done,
     /* 123056 */ // Label 2397: @123056
     /* 123056 */ GIM_Reject,
     /* 123057 */ // Label 2391: @123057
     /* 123057 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(123170),
     /* 123062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123068 */   GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(123108), // Rule ID 1217 //
     /* 123073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123088 */     // (smin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv4i32),
     /* 123091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123100 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123106 */     GIR_RootConstrainSelectedInstOperands,
     /* 123107 */     // GIR_Coverage, 1217,
     /* 123107 */     GIR_EraseRootFromParent_Done,
     /* 123108 */   // Label 2399: @123108
     /* 123108 */   GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(123169), // Rule ID 3297 //
     /* 123113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123128 */     // (smin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123128 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123131 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123135 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs32),
     /* 123143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123145 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123149 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123152 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123158 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123167 */     GIR_RootConstrainSelectedInstOperands,
     /* 123168 */     // GIR_Coverage, 3297,
     /* 123168 */     GIR_EraseRootFromParent_Done,
     /* 123169 */   // Label 2400: @123169
     /* 123169 */   GIM_Reject,
     /* 123170 */ // Label 2398: @123170
     /* 123170 */ GIM_Reject,
     /* 123171 */ // Label 2392: @123171
     /* 123171 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(123217), // Rule ID 1218 //
     /* 123176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123182 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123193 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123197 */   // (smin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123197 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i8),
     /* 123200 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123202 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123204 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123206 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123209 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123215 */   GIR_RootConstrainSelectedInstOperands,
     /* 123216 */   // GIR_Coverage, 1218,
     /* 123216 */   GIR_EraseRootFromParent_Done,
     /* 123217 */ // Label 2401: @123217
     /* 123217 */ GIM_Reject,
     /* 123218 */ // Label 2393: @123218
     /* 123218 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(123331),
     /* 123223 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123226 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123229 */   GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(123269), // Rule ID 1216 //
     /* 123234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123249 */     // (smin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv8i16),
     /* 123252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123261 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123267 */     GIR_RootConstrainSelectedInstOperands,
     /* 123268 */     // GIR_Coverage, 1216,
     /* 123268 */     GIR_EraseRootFromParent_Done,
     /* 123269 */   // Label 2403: @123269
     /* 123269 */   GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(123330), // Rule ID 3294 //
     /* 123274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123281 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123289 */     // (smin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs16),
     /* 123304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123310 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123313 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123319 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123325 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123328 */     GIR_RootConstrainSelectedInstOperands,
     /* 123329 */     // GIR_Coverage, 3294,
     /* 123329 */     GIR_EraseRootFromParent_Done,
     /* 123330 */   // Label 2404: @123330
     /* 123330 */   GIM_Reject,
     /* 123331 */ // Label 2402: @123331
     /* 123331 */ GIM_Reject,
     /* 123332 */ // Label 2394: @123332
     /* 123332 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(123445),
     /* 123337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123343 */   GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(123383), // Rule ID 1219 //
     /* 123348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123363 */     // (smin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINsv16i8),
     /* 123366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123368 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123375 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123381 */     GIR_RootConstrainSelectedInstOperands,
     /* 123382 */     // GIR_Coverage, 1219,
     /* 123382 */     GIR_EraseRootFromParent_Done,
     /* 123383 */   // Label 2406: @123383
     /* 123383 */   GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(123444), // Rule ID 3291 //
     /* 123388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123403 */     // (smin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINs8),
     /* 123418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123424 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123433 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123442 */     GIR_RootConstrainSelectedInstOperands,
     /* 123443 */     // GIR_Coverage, 3291,
     /* 123443 */     GIR_EraseRootFromParent_Done,
     /* 123444 */   // Label 2407: @123444
     /* 123444 */   GIM_Reject,
     /* 123445 */ // Label 2405: @123445
     /* 123445 */ GIM_Reject,
     /* 123446 */ // Label 2395: @123446
     /* 123446 */ GIM_Reject,
     /* 123447 */ // Label 55: @123447
     /* 123447 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2414*/ GIMT_Encode4(123989),
     /* 123458 */ /*GILLT_v2s32*//*Label 2408*/ GIMT_Encode4(123506), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123470 */ /*GILLT_v4s16*//*Label 2409*/ GIMT_Encode4(123553),
     /* 123474 */ /*GILLT_v4s32*//*Label 2410*/ GIMT_Encode4(123600), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123486 */ /*GILLT_v8s8*//*Label 2411*/ GIMT_Encode4(123714),
     /* 123490 */ /*GILLT_v8s16*//*Label 2412*/ GIMT_Encode4(123761), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 123502 */ /*GILLT_v16s8*//*Label 2413*/ GIMT_Encode4(123875),
     /* 123506 */ // Label 2408: @123506
     /* 123506 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(123552), // Rule ID 1195 //
     /* 123511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 123517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 123520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123524 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123528 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123532 */   // (smax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXsv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 123532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv2i32),
     /* 123535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123537 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123539 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123541 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123544 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123550 */   GIR_RootConstrainSelectedInstOperands,
     /* 123551 */   // GIR_Coverage, 1195,
     /* 123551 */   GIR_EraseRootFromParent_Done,
     /* 123552 */ // Label 2415: @123552
     /* 123552 */ GIM_Reject,
     /* 123553 */ // Label 2409: @123553
     /* 123553 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(123599), // Rule ID 1194 //
     /* 123558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 123564 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 123567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123579 */   // (smax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXsv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 123579 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i16),
     /* 123582 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123584 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123586 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123588 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123591 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123597 */   GIR_RootConstrainSelectedInstOperands,
     /* 123598 */   // GIR_Coverage, 1194,
     /* 123598 */   GIR_EraseRootFromParent_Done,
     /* 123599 */ // Label 2416: @123599
     /* 123599 */ GIM_Reject,
     /* 123600 */ // Label 2410: @123600
     /* 123600 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(123713),
     /* 123605 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 123608 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 123611 */   GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(123651), // Rule ID 1197 //
     /* 123616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123631 */     // (smax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXsv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 123631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv4i32),
     /* 123634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123636 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123640 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123643 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123649 */     GIR_RootConstrainSelectedInstOperands,
     /* 123650 */     // GIR_Coverage, 1197,
     /* 123650 */     GIR_EraseRootFromParent_Done,
     /* 123651 */   // Label 2418: @123651
     /* 123651 */   GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(123712), // Rule ID 3315 //
     /* 123656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123671 */     // (smax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 123671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs32),
     /* 123686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123695 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123701 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123710 */     GIR_RootConstrainSelectedInstOperands,
     /* 123711 */     // GIR_Coverage, 3315,
     /* 123711 */     GIR_EraseRootFromParent_Done,
     /* 123712 */   // Label 2419: @123712
     /* 123712 */   GIM_Reject,
     /* 123713 */ // Label 2417: @123713
     /* 123713 */ GIM_Reject,
     /* 123714 */ // Label 2411: @123714
     /* 123714 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(123760), // Rule ID 1198 //
     /* 123719 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 123725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 123728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123736 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 123740 */   // (smax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXsv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 123740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i8),
     /* 123743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123745 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123747 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123749 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123752 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123758 */   GIR_RootConstrainSelectedInstOperands,
     /* 123759 */   // GIR_Coverage, 1198,
     /* 123759 */   GIR_EraseRootFromParent_Done,
     /* 123760 */ // Label 2420: @123760
     /* 123760 */ GIM_Reject,
     /* 123761 */ // Label 2412: @123761
     /* 123761 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(123874),
     /* 123766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 123769 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 123772 */   GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(123812), // Rule ID 1196 //
     /* 123777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123784 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123792 */     // (smax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXsv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 123792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv8i16),
     /* 123795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123801 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123804 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123810 */     GIR_RootConstrainSelectedInstOperands,
     /* 123811 */     // GIR_Coverage, 1196,
     /* 123811 */     GIR_EraseRootFromParent_Done,
     /* 123812 */   // Label 2422: @123812
     /* 123812 */   GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(123873), // Rule ID 3312 //
     /* 123817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123832 */     // (smax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 123832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs16),
     /* 123847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123849 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123856 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123862 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123871 */     GIR_RootConstrainSelectedInstOperands,
     /* 123872 */     // GIR_Coverage, 3312,
     /* 123872 */     GIR_EraseRootFromParent_Done,
     /* 123873 */   // Label 2423: @123873
     /* 123873 */   GIM_Reject,
     /* 123874 */ // Label 2421: @123874
     /* 123874 */ GIM_Reject,
     /* 123875 */ // Label 2413: @123875
     /* 123875 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(123988),
     /* 123880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 123883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 123886 */   GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(123926), // Rule ID 1199 //
     /* 123891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 123894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 123906 */     // (smax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXsv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 123906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXsv16i8),
     /* 123909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 123911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 123913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 123915 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 123918 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123924 */     GIR_RootConstrainSelectedInstOperands,
     /* 123925 */     // GIR_Coverage, 1199,
     /* 123925 */     GIR_EraseRootFromParent_Done,
     /* 123926 */   // Label 2425: @123926
     /* 123926 */   GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(123987), // Rule ID 3309 //
     /* 123931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 123934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 123946 */     // (smax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 123946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 123949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 123953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXs8),
     /* 123961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 123963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 123965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 123967 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123970 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123976 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 123982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123985 */     GIR_RootConstrainSelectedInstOperands,
     /* 123986 */     // GIR_Coverage, 3309,
     /* 123986 */     GIR_EraseRootFromParent_Done,
     /* 123987 */   // Label 2426: @123987
     /* 123987 */   GIM_Reject,
     /* 123988 */ // Label 2424: @123988
     /* 123988 */ GIM_Reject,
     /* 123989 */ // Label 2414: @123989
     /* 123989 */ GIM_Reject,
     /* 123990 */ // Label 56: @123990
     /* 123990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2433*/ GIMT_Encode4(124910),
     /* 124001 */ /*GILLT_v2s32*//*Label 2427*/ GIMT_Encode4(124049), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124013 */ /*GILLT_v4s16*//*Label 2428*/ GIMT_Encode4(124096),
     /* 124017 */ /*GILLT_v4s32*//*Label 2429*/ GIMT_Encode4(124143), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124029 */ /*GILLT_v8s8*//*Label 2430*/ GIMT_Encode4(124383),
     /* 124033 */ /*GILLT_v8s16*//*Label 2431*/ GIMT_Encode4(124430), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124045 */ /*GILLT_v16s8*//*Label 2432*/ GIMT_Encode4(124670),
     /* 124049 */ // Label 2427: @124049
     /* 124049 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(124095), // Rule ID 1221 //
     /* 124054 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124057 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124060 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124071 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124075 */   // (umin:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMINuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124075 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv2i32),
     /* 124078 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124080 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124082 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124084 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124087 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124093 */   GIR_RootConstrainSelectedInstOperands,
     /* 124094 */   // GIR_Coverage, 1221,
     /* 124094 */   GIR_EraseRootFromParent_Done,
     /* 124095 */ // Label 2434: @124095
     /* 124095 */ GIM_Reject,
     /* 124096 */ // Label 2428: @124096
     /* 124096 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(124142), // Rule ID 1220 //
     /* 124101 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124104 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 124107 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 124110 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124114 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124118 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124122 */   // (umin:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMINuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 124122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i16),
     /* 124125 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124127 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124129 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124131 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124134 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124140 */   GIR_RootConstrainSelectedInstOperands,
     /* 124141 */   // GIR_Coverage, 1220,
     /* 124141 */   GIR_EraseRootFromParent_Done,
     /* 124142 */ // Label 2435: @124142
     /* 124142 */ GIM_Reject,
     /* 124143 */ // Label 2429: @124143
     /* 124143 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(124382),
     /* 124148 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124151 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 124154 */   GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(124217), // Rule ID 6024 //
     /* 124159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124189 */     // (umin:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124200 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124203 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124209 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124215 */     GIR_RootConstrainSelectedInstOperands,
     /* 124216 */     // GIR_Coverage, 6024,
     /* 124216 */     GIR_EraseRootFromParent_Done,
     /* 124217 */   // Label 2437: @124217
     /* 124217 */   GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(124280), // Rule ID 3694 //
     /* 124222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124229 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 124245 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124250 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124252 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMINAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 124252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs32),
     /* 124255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124257 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124266 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124272 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124278 */     GIR_RootConstrainSelectedInstOperands,
     /* 124279 */     // GIR_Coverage, 3694,
     /* 124279 */     GIR_EraseRootFromParent_Done,
     /* 124280 */   // Label 2438: @124280
     /* 124280 */   GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(124320), // Rule ID 1223 //
     /* 124285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124292 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124300 */     // (umin:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMINuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 124300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv4i32),
     /* 124303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124305 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124309 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124312 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124318 */     GIR_RootConstrainSelectedInstOperands,
     /* 124319 */     // GIR_Coverage, 1223,
     /* 124319 */     GIR_EraseRootFromParent_Done,
     /* 124320 */   // Label 2439: @124320
     /* 124320 */   GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(124381), // Rule ID 3306 //
     /* 124325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124332 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124340 */     // (umin:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMINu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 124340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu32),
     /* 124355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124364 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124370 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124379 */     GIR_RootConstrainSelectedInstOperands,
     /* 124380 */     // GIR_Coverage, 3306,
     /* 124380 */     GIR_EraseRootFromParent_Done,
     /* 124381 */   // Label 2440: @124381
     /* 124381 */   GIM_Reject,
     /* 124382 */ // Label 2436: @124382
     /* 124382 */ GIM_Reject,
     /* 124383 */ // Label 2430: @124383
     /* 124383 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(124429), // Rule ID 1224 //
     /* 124388 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 124394 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 124397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124405 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124409 */   // (umin:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMINuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 124409 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i8),
     /* 124412 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124414 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124416 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124418 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124421 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124427 */   GIR_RootConstrainSelectedInstOperands,
     /* 124428 */   // GIR_Coverage, 1224,
     /* 124428 */   GIR_EraseRootFromParent_Done,
     /* 124429 */ // Label 2441: @124429
     /* 124429 */ GIM_Reject,
     /* 124430 */ // Label 2431: @124430
     /* 124430 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(124669),
     /* 124435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 124441 */   GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(124504), // Rule ID 6023 //
     /* 124446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124476 */     // (umin:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124490 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124496 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124502 */     GIR_RootConstrainSelectedInstOperands,
     /* 124503 */     // GIR_Coverage, 6023,
     /* 124503 */     GIR_EraseRootFromParent_Done,
     /* 124504 */   // Label 2443: @124504
     /* 124504 */   GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(124567), // Rule ID 3692 //
     /* 124509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 124532 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124539 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMINAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 124539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs16),
     /* 124542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124544 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124550 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124553 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124559 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124565 */     GIR_RootConstrainSelectedInstOperands,
     /* 124566 */     // GIR_Coverage, 3692,
     /* 124566 */     GIR_EraseRootFromParent_Done,
     /* 124567 */   // Label 2444: @124567
     /* 124567 */   GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(124607), // Rule ID 1222 //
     /* 124572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124583 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124587 */     // (umin:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMINuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 124587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv8i16),
     /* 124590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124599 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124605 */     GIR_RootConstrainSelectedInstOperands,
     /* 124606 */     // GIR_Coverage, 1222,
     /* 124606 */     GIR_EraseRootFromParent_Done,
     /* 124607 */   // Label 2445: @124607
     /* 124607 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(124668), // Rule ID 3303 //
     /* 124612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124623 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124627 */     // (umin:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMINu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 124627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu16),
     /* 124642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124666 */     GIR_RootConstrainSelectedInstOperands,
     /* 124667 */     // GIR_Coverage, 3303,
     /* 124667 */     GIR_EraseRootFromParent_Done,
     /* 124668 */   // Label 2446: @124668
     /* 124668 */   GIM_Reject,
     /* 124669 */ // Label 2442: @124669
     /* 124669 */ GIM_Reject,
     /* 124670 */ // Label 2432: @124670
     /* 124670 */ GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(124909),
     /* 124675 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124678 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 124681 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(124744), // Rule ID 6022 //
     /* 124686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 124697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124716 */     // (umin:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 124723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124730 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124742 */     GIR_RootConstrainSelectedInstOperands,
     /* 124743 */     // GIR_Coverage, 6022,
     /* 124743 */     GIR_EraseRootFromParent_Done,
     /* 124744 */   // Label 2448: @124744
     /* 124744 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(124807), // Rule ID 3690 //
     /* 124749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 124764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 124768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 124772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 124779 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMINAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 124779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINAs8),
     /* 124782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 124786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 124790 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124793 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124799 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124805 */     GIR_RootConstrainSelectedInstOperands,
     /* 124806 */     // GIR_Coverage, 3690,
     /* 124806 */     GIR_EraseRootFromParent_Done,
     /* 124807 */   // Label 2449: @124807
     /* 124807 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(124847), // Rule ID 1225 //
     /* 124812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 124827 */     // (umin:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMINuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 124827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMINuv16i8),
     /* 124830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 124832 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 124834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 124836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 124839 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124845 */     GIR_RootConstrainSelectedInstOperands,
     /* 124846 */     // GIR_Coverage, 1225,
     /* 124846 */     GIR_EraseRootFromParent_Done,
     /* 124847 */   // Label 2450: @124847
     /* 124847 */   GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(124908), // Rule ID 3300 //
     /* 124852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 124855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124859 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 124867 */     // (umin:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMINu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 124867 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 124870 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 124874 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 124879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINu8),
     /* 124882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 124884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 124886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 124888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 124891 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124897 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 124903 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 124906 */     GIR_RootConstrainSelectedInstOperands,
     /* 124907 */     // GIR_Coverage, 3300,
     /* 124907 */     GIR_EraseRootFromParent_Done,
     /* 124908 */   // Label 2451: @124908
     /* 124908 */   GIM_Reject,
     /* 124909 */ // Label 2447: @124909
     /* 124909 */ GIM_Reject,
     /* 124910 */ // Label 2433: @124910
     /* 124910 */ GIM_Reject,
     /* 124911 */ // Label 57: @124911
     /* 124911 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2458*/ GIMT_Encode4(125831),
     /* 124922 */ /*GILLT_v2s32*//*Label 2452*/ GIMT_Encode4(124970), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124934 */ /*GILLT_v4s16*//*Label 2453*/ GIMT_Encode4(125017),
     /* 124938 */ /*GILLT_v4s32*//*Label 2454*/ GIMT_Encode4(125064), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124950 */ /*GILLT_v8s8*//*Label 2455*/ GIMT_Encode4(125304),
     /* 124954 */ /*GILLT_v8s16*//*Label 2456*/ GIMT_Encode4(125351), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 124966 */ /*GILLT_v16s8*//*Label 2457*/ GIMT_Encode4(125591),
     /* 124970 */ // Label 2452: @124970
     /* 124970 */ GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(125016), // Rule ID 1201 //
     /* 124975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 124978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 124981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 124984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124992 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 124996 */   // (umax:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)  =>  (VMAXuv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vn, DPR:{ *:[v2i32] }:$Vm)
     /* 124996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv2i32),
     /* 124999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125001 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125003 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125005 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125008 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125014 */   GIR_RootConstrainSelectedInstOperands,
     /* 125015 */   // GIR_Coverage, 1201,
     /* 125015 */   GIR_EraseRootFromParent_Done,
     /* 125016 */ // Label 2459: @125016
     /* 125016 */ GIM_Reject,
     /* 125017 */ // Label 2453: @125017
     /* 125017 */ GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(125063), // Rule ID 1200 //
     /* 125022 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125028 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 125031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125039 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125043 */   // (umax:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)  =>  (VMAXuv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vn, DPR:{ *:[v4i16] }:$Vm)
     /* 125043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i16),
     /* 125046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125048 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125050 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125052 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125055 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125061 */   GIR_RootConstrainSelectedInstOperands,
     /* 125062 */   // GIR_Coverage, 1200,
     /* 125062 */   GIR_EraseRootFromParent_Done,
     /* 125063 */ // Label 2460: @125063
     /* 125063 */ GIM_Reject,
     /* 125064 */ // Label 2454: @125064
     /* 125064 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(125303),
     /* 125069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125072 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 125075 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(125138), // Rule ID 6027 //
     /* 125080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125110 */     // (umax:{ *:[v4i32] } (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm), MQPR:{ *:[v4i32] }:$Qd)  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125124 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125130 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125136 */     GIR_RootConstrainSelectedInstOperands,
     /* 125137 */     // GIR_Coverage, 6027,
     /* 125137 */     GIR_EraseRootFromParent_Done,
     /* 125138 */   // Label 2462: @125138
     /* 125138 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(125201), // Rule ID 3700 //
     /* 125143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125171 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125173 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm))  =>  (MVE_VMAXAs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qd, MQPR:{ *:[v4i32] }:$Qm)
     /* 125173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs32),
     /* 125176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125184 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125187 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125193 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125199 */     GIR_RootConstrainSelectedInstOperands,
     /* 125200 */     // GIR_Coverage, 3700,
     /* 125200 */     GIR_EraseRootFromParent_Done,
     /* 125201 */   // Label 2463: @125201
     /* 125201 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(125241), // Rule ID 1203 //
     /* 125206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125213 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125221 */     // (umax:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)  =>  (VMAXuv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vn, QPR:{ *:[v4i32] }:$Vm)
     /* 125221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv4i32),
     /* 125224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125233 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125239 */     GIR_RootConstrainSelectedInstOperands,
     /* 125240 */     // GIR_Coverage, 1203,
     /* 125240 */     GIR_EraseRootFromParent_Done,
     /* 125241 */   // Label 2464: @125241
     /* 125241 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(125302), // Rule ID 3324 //
     /* 125246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125261 */     // (umax:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)  =>  (MVE_VMAXu32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$Qm, MQPR:{ *:[v4i32] }:$Qn)
     /* 125261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu32),
     /* 125276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125282 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125285 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125291 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125297 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125300 */     GIR_RootConstrainSelectedInstOperands,
     /* 125301 */     // GIR_Coverage, 3324,
     /* 125301 */     GIR_EraseRootFromParent_Done,
     /* 125302 */   // Label 2465: @125302
     /* 125302 */   GIM_Reject,
     /* 125303 */ // Label 2461: @125303
     /* 125303 */ GIM_Reject,
     /* 125304 */ // Label 2455: @125304
     /* 125304 */ GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(125350), // Rule ID 1204 //
     /* 125309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 125315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 125318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125330 */   // (umax:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)  =>  (VMAXuv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vn, DPR:{ *:[v8i8] }:$Vm)
     /* 125330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i8),
     /* 125333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125335 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125337 */   GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125339 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125342 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125348 */   GIR_RootConstrainSelectedInstOperands,
     /* 125349 */   // GIR_Coverage, 1204,
     /* 125349 */   GIR_EraseRootFromParent_Done,
     /* 125350 */ // Label 2466: @125350
     /* 125350 */ GIM_Reject,
     /* 125351 */ // Label 2456: @125351
     /* 125351 */ GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(125590),
     /* 125356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125359 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 125362 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(125425), // Rule ID 6026 //
     /* 125367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125397 */     // (umax:{ *:[v8i16] } (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm), MQPR:{ *:[v8i16] }:$Qd)  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125411 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125417 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125423 */     GIR_RootConstrainSelectedInstOperands,
     /* 125424 */     // GIR_Coverage, 6026,
     /* 125424 */     GIR_EraseRootFromParent_Done,
     /* 125425 */   // Label 2468: @125425
     /* 125425 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(125488), // Rule ID 3698 //
     /* 125430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 125453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125458 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125460 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm))  =>  (MVE_VMAXAs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qd, MQPR:{ *:[v8i16] }:$Qm)
     /* 125460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs16),
     /* 125463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125471 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125474 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125480 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125486 */     GIR_RootConstrainSelectedInstOperands,
     /* 125487 */     // GIR_Coverage, 3698,
     /* 125487 */     GIR_EraseRootFromParent_Done,
     /* 125488 */   // Label 2469: @125488
     /* 125488 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(125528), // Rule ID 1202 //
     /* 125493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125508 */     // (umax:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)  =>  (VMAXuv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vn, QPR:{ *:[v8i16] }:$Vm)
     /* 125508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv8i16),
     /* 125511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125513 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125517 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125520 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125526 */     GIR_RootConstrainSelectedInstOperands,
     /* 125527 */     // GIR_Coverage, 1202,
     /* 125527 */     GIR_EraseRootFromParent_Done,
     /* 125528 */   // Label 2470: @125528
     /* 125528 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(125589), // Rule ID 3321 //
     /* 125533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125548 */     // (umax:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)  =>  (MVE_VMAXu16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$Qm, MQPR:{ *:[v8i16] }:$Qn)
     /* 125548 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125551 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125555 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu16),
     /* 125563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125569 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125572 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125578 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125584 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125587 */     GIR_RootConstrainSelectedInstOperands,
     /* 125588 */     // GIR_Coverage, 3321,
     /* 125588 */     GIR_EraseRootFromParent_Done,
     /* 125589 */   // Label 2471: @125589
     /* 125589 */   GIM_Reject,
     /* 125590 */ // Label 2467: @125590
     /* 125590 */ GIM_Reject,
     /* 125591 */ // Label 2457: @125591
     /* 125591 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(125830),
     /* 125596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125599 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 125602 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(125665), // Rule ID 6025 //
     /* 125607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 125618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125635 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125637 */     // (umax:{ *:[v16i8] } (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm), MQPR:{ *:[v16i8] }:$Qd)  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qd
     /* 125644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125651 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125657 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125663 */     GIR_RootConstrainSelectedInstOperands,
     /* 125664 */     // GIR_Coverage, 6025,
     /* 125664 */     GIR_EraseRootFromParent_Done,
     /* 125665 */   // Label 2473: @125665
     /* 125665 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(125728), // Rule ID 3696 //
     /* 125670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 125685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ABS),
     /* 125689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 125693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 125700 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm))  =>  (MVE_VMAXAs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qd, MQPR:{ *:[v16i8] }:$Qm)
     /* 125700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXAs8),
     /* 125703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qd
     /* 125707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Qm
     /* 125711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125714 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125720 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125726 */     GIR_RootConstrainSelectedInstOperands,
     /* 125727 */     // GIR_Coverage, 3696,
     /* 125727 */     GIR_EraseRootFromParent_Done,
     /* 125728 */   // Label 2474: @125728
     /* 125728 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(125768), // Rule ID 1205 //
     /* 125733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125740 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125748 */     // (umax:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)  =>  (VMAXuv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vn, QPR:{ *:[v16i8] }:$Vm)
     /* 125748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VMAXuv16i8),
     /* 125751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /* 125755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vm
     /* 125757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125760 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125766 */     GIR_RootConstrainSelectedInstOperands,
     /* 125767 */     // GIR_Coverage, 1205,
     /* 125767 */     GIR_EraseRootFromParent_Done,
     /* 125768 */   // Label 2475: @125768
     /* 125768 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(125829), // Rule ID 3318 //
     /* 125773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 125776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125780 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 125788 */     // (umax:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)  =>  (MVE_VMAXu8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$Qm, MQPR:{ *:[v16i8] }:$Qn)
     /* 125788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 125791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 125795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 125800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXu8),
     /* 125803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 125805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Qm
     /* 125807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Qn
     /* 125809 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 125812 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125818 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 125827 */     GIR_RootConstrainSelectedInstOperands,
     /* 125828 */     // GIR_Coverage, 3318,
     /* 125828 */     GIR_EraseRootFromParent_Done,
     /* 125829 */   // Label 2476: @125829
     /* 125829 */   GIM_Reject,
     /* 125830 */ // Label 2472: @125830
     /* 125830 */ GIM_Reject,
     /* 125831 */ // Label 2458: @125831
     /* 125831 */ GIM_Reject,
     /* 125832 */ // Label 58: @125832
     /* 125832 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(4), GIMT_Encode2(16), /*)*//*default:*//*Label 2483*/ GIMT_Encode4(126302),
     /* 125843 */ /*GILLT_v2s32*//*Label 2477*/ GIMT_Encode4(125891), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125855 */ /*GILLT_v4s16*//*Label 2478*/ GIMT_Encode4(125929),
     /* 125859 */ /*GILLT_v4s32*//*Label 2479*/ GIMT_Encode4(125967), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125871 */ /*GILLT_v8s8*//*Label 2480*/ GIMT_Encode4(126066),
     /* 125875 */ /*GILLT_v8s16*//*Label 2481*/ GIMT_Encode4(126104), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 125887 */ /*GILLT_v16s8*//*Label 2482*/ GIMT_Encode4(126203),
     /* 125891 */ // Label 2477: @125891
     /* 125891 */ GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(125928), // Rule ID 1507 //
     /* 125896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 125902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125906 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125910 */   // (abs:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VABSv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 125910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv2i32),
     /* 125913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125915 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125917 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125920 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125926 */   GIR_RootConstrainSelectedInstOperands,
     /* 125927 */   // GIR_Coverage, 1507,
     /* 125927 */   GIR_EraseRootFromParent_Done,
     /* 125928 */ // Label 2484: @125928
     /* 125928 */ GIM_Reject,
     /* 125929 */ // Label 2478: @125929
     /* 125929 */ GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(125966), // Rule ID 1506 //
     /* 125934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 125940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125944 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 125948 */   // (abs:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VABSv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 125948 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i16),
     /* 125951 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125953 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125955 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 125958 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 125964 */   GIR_RootConstrainSelectedInstOperands,
     /* 125965 */   // GIR_Coverage, 1506,
     /* 125965 */   GIR_EraseRootFromParent_Done,
     /* 125966 */ // Label 2485: @125966
     /* 125966 */ GIM_Reject,
     /* 125967 */ // Label 2479: @125967
     /* 125967 */ GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(126065),
     /* 125972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 125975 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(126009), // Rule ID 1510 //
     /* 125980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 125983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 125991 */     // (abs:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VABSv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 125991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv4i32),
     /* 125994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 125996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 125998 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126001 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126007 */     GIR_RootConstrainSelectedInstOperands,
     /* 126008 */     // GIR_Coverage, 1510,
     /* 126008 */     GIR_EraseRootFromParent_Done,
     /* 126009 */   // Label 2487: @126009
     /* 126009 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(126064), // Rule ID 3669 //
     /* 126014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126025 */     // (abs:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$v)  =>  (MVE_VABSs32:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
     /* 126025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs32),
     /* 126040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126042 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126053 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126062 */     GIR_RootConstrainSelectedInstOperands,
     /* 126063 */     // GIR_Coverage, 3669,
     /* 126063 */     GIR_EraseRootFromParent_Done,
     /* 126064 */   // Label 2488: @126064
     /* 126064 */   GIM_Reject,
     /* 126065 */ // Label 2486: @126065
     /* 126065 */ GIM_Reject,
     /* 126066 */ // Label 2480: @126066
     /* 126066 */ GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(126103), // Rule ID 1505 //
     /* 126071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126081 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126085 */   // (abs:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VABSv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 126085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i8),
     /* 126088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126090 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126092 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126095 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126101 */   GIR_RootConstrainSelectedInstOperands,
     /* 126102 */   // GIR_Coverage, 1505,
     /* 126102 */   GIR_EraseRootFromParent_Done,
     /* 126103 */ // Label 2489: @126103
     /* 126103 */ GIM_Reject,
     /* 126104 */ // Label 2481: @126104
     /* 126104 */ GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(126202),
     /* 126109 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126112 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(126146), // Rule ID 1509 //
     /* 126117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126128 */     // (abs:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VABSv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 126128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv8i16),
     /* 126131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126138 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126144 */     GIR_RootConstrainSelectedInstOperands,
     /* 126145 */     // GIR_Coverage, 1509,
     /* 126145 */     GIR_EraseRootFromParent_Done,
     /* 126146 */   // Label 2491: @126146
     /* 126146 */   GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(126201), // Rule ID 3663 //
     /* 126151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126162 */     // (abs:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$v)  =>  (MVE_VABSs16:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
     /* 126162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs16),
     /* 126177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126179 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126184 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126190 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126196 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126199 */     GIR_RootConstrainSelectedInstOperands,
     /* 126200 */     // GIR_Coverage, 3663,
     /* 126200 */     GIR_EraseRootFromParent_Done,
     /* 126201 */   // Label 2492: @126201
     /* 126201 */   GIM_Reject,
     /* 126202 */ // Label 2490: @126202
     /* 126202 */ GIM_Reject,
     /* 126203 */ // Label 2482: @126203
     /* 126203 */ GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(126301),
     /* 126208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126211 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(126245), // Rule ID 1508 //
     /* 126216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126227 */     // (abs:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VABSv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 126227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VABSv16i8),
     /* 126230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126234 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126237 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126243 */     GIR_RootConstrainSelectedInstOperands,
     /* 126244 */     // GIR_Coverage, 1508,
     /* 126244 */     GIR_EraseRootFromParent_Done,
     /* 126245 */   // Label 2494: @126245
     /* 126245 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(126300), // Rule ID 3657 //
     /* 126250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126261 */     // (abs:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$v)  =>  (MVE_VABSs8:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
     /* 126261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 126264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 126268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VABSs8),
     /* 126276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126278 */     GIR_RootToRootCopy, /*OpIdx*/1, // v
     /* 126280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126283 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126289 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126298 */     GIR_RootConstrainSelectedInstOperands,
     /* 126299 */     // GIR_Coverage, 3657,
     /* 126299 */     GIR_EraseRootFromParent_Done,
     /* 126300 */   // Label 2495: @126300
     /* 126300 */   GIM_Reject,
     /* 126301 */ // Label 2493: @126301
     /* 126301 */ GIM_Reject,
     /* 126302 */ // Label 2483: @126302
     /* 126302 */ GIM_Reject,
     /* 126303 */ // Label 59: @126303
     /* 126303 */ GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(126375),
     /* 126308 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 126311 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(126326), // Rule ID 32 //
     /* 126316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM),
     /* 126319 */     // (br (bb:{ *:[Other] }):$target)  =>  (B (bb:{ *:[Other] }):$target)
     /* 126319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::B),
     /* 126324 */     GIR_RootConstrainSelectedInstOperands,
     /* 126325 */     // GIR_Coverage, 32,
     /* 126325 */     GIR_Done,
     /* 126326 */   // Label 2497: @126326
     /* 126326 */   GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(126350), // Rule ID 283 //
     /* 126331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_IsThumb1Only),
     /* 126334 */     // (br (bb:{ *:[Other] }):$target)  =>  (tB (bb:{ *:[Other] }):$target)
     /* 126334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tB),
     /* 126337 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126342 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126348 */     GIR_RootConstrainSelectedInstOperands,
     /* 126349 */     // GIR_Coverage, 283,
     /* 126349 */     GIR_EraseRootFromParent_Done,
     /* 126350 */   // Label 2498: @126350
     /* 126350 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(126374), // Rule ID 577 //
     /* 126355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV8MBaseline_IsThumb),
     /* 126358 */     // (br (bb:{ *:[Other] }):$target)  =>  (t2B (bb:{ *:[Other] }):$target)
     /* 126358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2B),
     /* 126361 */     GIR_RootToRootCopy, /*OpIdx*/0, // target
     /* 126363 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126366 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126372 */     GIR_RootConstrainSelectedInstOperands,
     /* 126373 */     // GIR_Coverage, 577,
     /* 126373 */     GIR_EraseRootFromParent_Done,
     /* 126374 */   // Label 2499: @126374
     /* 126374 */   GIM_Reject,
     /* 126375 */ // Label 2496: @126375
     /* 126375 */ GIM_Reject,
     /* 126376 */ // Label 60: @126376
     /* 126376 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(16), /*)*//*default:*//*Label 2504*/ GIMT_Encode4(126675),
     /* 126387 */ /*GILLT_v4s16*//*Label 2500*/ GIMT_Encode4(126423), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126403 */ /*GILLT_v8s8*//*Label 2501*/ GIMT_Encode4(126486),
     /* 126407 */ /*GILLT_v8s16*//*Label 2502*/ GIMT_Encode4(126549), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126419 */ /*GILLT_v16s8*//*Label 2503*/ GIMT_Encode4(126612),
     /* 126423 */ // Label 2500: @126423
     /* 126423 */ GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(126485), // Rule ID 1569 //
     /* 126428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126437 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126448 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126452 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126456 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126460 */   // MIs[1] Operand 1
     /* 126460 */   // No operand predicates
     /* 126460 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126462 */   // (vector_insert:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi16),
     /* 126465 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126469 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126471 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126477 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126483 */   GIR_RootConstrainSelectedInstOperands,
     /* 126484 */   // GIR_Coverage, 1569,
     /* 126484 */   GIR_EraseRootFromParent_Done,
     /* 126485 */ // Label 2505: @126485
     /* 126485 */ GIM_Reject,
     /* 126486 */ // Label 2501: @126486
     /* 126486 */ GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(126548), // Rule ID 1568 //
     /* 126491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 126497 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126500 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126511 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126515 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126519 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126523 */   // MIs[1] Operand 1
     /* 126523 */   // No operand predicates
     /* 126523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126525 */   // (vector_insert:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)  =>  (VSETLNi8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$src1, GPR:{ *:[i32] }:$R, (imm:{ *:[i32] }):$lane)
     /* 126525 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSETLNi8),
     /* 126528 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[V]
     /* 126530 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126532 */   GIR_RootToRootCopy, /*OpIdx*/2, // R
     /* 126534 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126537 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126540 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126546 */   GIR_RootConstrainSelectedInstOperands,
     /* 126547 */   // GIR_Coverage, 1568,
     /* 126547 */   GIR_EraseRootFromParent_Done,
     /* 126548 */ // Label 2506: @126548
     /* 126548 */ GIM_Reject,
     /* 126549 */ // Label 2502: @126549
     /* 126549 */ GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(126611), // Rule ID 3433 //
     /* 126554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 126560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126563 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126574 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126586 */   // MIs[1] Operand 1
     /* 126586 */   // No operand predicates
     /* 126586 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126588 */   // (vector_insert:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_16),
     /* 126591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126593 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126595 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126597 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126600 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126603 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126609 */   GIR_RootConstrainSelectedInstOperands,
     /* 126610 */   // GIR_Coverage, 3433,
     /* 126610 */   GIR_EraseRootFromParent_Done,
     /* 126611 */ // Label 2507: @126611
     /* 126611 */ GIM_Reject,
     /* 126612 */ // Label 2503: @126612
     /* 126612 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(126674), // Rule ID 3432 //
     /* 126617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 126620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 126623 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126626 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 126629 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126633 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 126637 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 126645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126649 */   // MIs[1] Operand 1
     /* 126649 */   // No operand predicates
     /* 126649 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126651 */   // (vector_insert:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)  =>  (MVE_VMOV_to_lane_8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, rGPR:{ *:[i32] }:$src2, (imm:{ *:[i32] }):$lane)
     /* 126651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMOV_to_lane_8),
     /* 126654 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 126656 */   GIR_RootToRootCopy, /*OpIdx*/1, // src1
     /* 126658 */   GIR_RootToRootCopy, /*OpIdx*/2, // src2
     /* 126660 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126666 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126672 */   GIR_RootConstrainSelectedInstOperands,
     /* 126673 */   // GIR_Coverage, 3432,
     /* 126673 */   GIR_EraseRootFromParent_Done,
     /* 126674 */ // Label 2508: @126674
     /* 126674 */ GIM_Reject,
     /* 126675 */ // Label 2504: @126675
     /* 126675 */ GIM_Reject,
     /* 126676 */ // Label 61: @126676
     /* 126676 */ GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(126732), // Rule ID 1567 //
     /* 126681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRegs_HasFastVGETLNi32),
     /* 126684 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 126687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 126693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 126705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 126709 */   // MIs[1] Operand 1
     /* 126709 */   // No operand predicates
     /* 126709 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 126711 */   // (extractelt:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)  =>  (VGETLNi32:{ *:[i32] } DPR:{ *:[v2i32] }:$V, (imm:{ *:[i32] }):$lane)
     /* 126711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VGETLNi32),
     /* 126714 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[R]
     /* 126716 */   GIR_RootToRootCopy, /*OpIdx*/1, // V
     /* 126718 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // lane
     /* 126721 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126724 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126730 */   GIR_RootConstrainSelectedInstOperands,
     /* 126731 */   // GIR_Coverage, 1567,
     /* 126731 */   GIR_EraseRootFromParent_Done,
     /* 126732 */ // Label 2509: @126732
     /* 126732 */ GIM_Reject,
     /* 126733 */ // Label 62: @126733
     /* 126733 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2517*/ GIMT_Encode4(127293),
     /* 126744 */ /*GILLT_s32*//*Label 2510*/ GIMT_Encode4(126804), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126756 */ /*GILLT_v2s32*//*Label 2511*/ GIMT_Encode4(126882), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126768 */ /*GILLT_v4s16*//*Label 2512*/ GIMT_Encode4(126920),
     /* 126772 */ /*GILLT_v4s32*//*Label 2513*/ GIMT_Encode4(126958), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126784 */ /*GILLT_v8s8*//*Label 2514*/ GIMT_Encode4(127057),
     /* 126788 */ /*GILLT_v8s16*//*Label 2515*/ GIMT_Encode4(127095), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 126800 */ /*GILLT_v16s8*//*Label 2516*/ GIMT_Encode4(127194),
     /* 126804 */ // Label 2510: @126804
     /* 126804 */ GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(126881),
     /* 126809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 126812 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(126846), // Rule ID 197 //
     /* 126817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 126820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126824 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 126828 */     // (ctlz:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (CLZ:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 126828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::CLZ),
     /* 126831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126833 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126838 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126844 */     GIR_RootConstrainSelectedInstOperands,
     /* 126845 */     // GIR_Coverage, 197,
     /* 126845 */     GIR_EraseRootFromParent_Done,
     /* 126846 */   // Label 2519: @126846
     /* 126846 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(126880), // Rule ID 534 //
     /* 126851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 126854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 126862 */     // (ctlz:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2CLZ:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 126862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2CLZ),
     /* 126865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 126867 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 126869 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126872 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126878 */     GIR_RootConstrainSelectedInstOperands,
     /* 126879 */     // GIR_Coverage, 534,
     /* 126879 */     GIR_EraseRootFromParent_Done,
     /* 126880 */   // Label 2520: @126880
     /* 126880 */   GIM_Reject,
     /* 126881 */ // Label 2518: @126881
     /* 126881 */ GIM_Reject,
     /* 126882 */ // Label 2511: @126882
     /* 126882 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(126919), // Rule ID 1545 //
     /* 126887 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 126893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126901 */   // (ctlz:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)  =>  (VCLZv2i32:{ *:[v2i32] } DPR:{ *:[v2i32] }:$Vm)
     /* 126901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv2i32),
     /* 126904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126906 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126908 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126911 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126917 */   GIR_RootConstrainSelectedInstOperands,
     /* 126918 */   // GIR_Coverage, 1545,
     /* 126918 */   GIR_EraseRootFromParent_Done,
     /* 126919 */ // Label 2521: @126919
     /* 126919 */ GIM_Reject,
     /* 126920 */ // Label 2512: @126920
     /* 126920 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(126957), // Rule ID 1544 //
     /* 126925 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126928 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 126931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126935 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 126939 */   // (ctlz:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)  =>  (VCLZv4i16:{ *:[v4i16] } DPR:{ *:[v4i16] }:$Vm)
     /* 126939 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i16),
     /* 126942 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126944 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126946 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126949 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126955 */   GIR_RootConstrainSelectedInstOperands,
     /* 126956 */   // GIR_Coverage, 1544,
     /* 126956 */   GIR_EraseRootFromParent_Done,
     /* 126957 */ // Label 2522: @126957
     /* 126957 */ GIM_Reject,
     /* 126958 */ // Label 2513: @126958
     /* 126958 */ GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(127056),
     /* 126963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 126966 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(127000), // Rule ID 1548 //
     /* 126971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 126974 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 126982 */     // (ctlz:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)  =>  (VCLZv4i32:{ *:[v4i32] } QPR:{ *:[v4i32] }:$Vm)
     /* 126982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv4i32),
     /* 126985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 126987 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 126989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 126992 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 126998 */     GIR_RootConstrainSelectedInstOperands,
     /* 126999 */     // GIR_Coverage, 1548,
     /* 126999 */     GIR_EraseRootFromParent_Done,
     /* 127000 */   // Label 2524: @127000
     /* 127000 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(127055), // Rule ID 3655 //
     /* 127005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127012 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127016 */     // (ctlz:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)  =>  (MVE_VCLZs32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val)
     /* 127016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs32),
     /* 127031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127033 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127035 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127038 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127044 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127053 */     GIR_RootConstrainSelectedInstOperands,
     /* 127054 */     // GIR_Coverage, 3655,
     /* 127054 */     GIR_EraseRootFromParent_Done,
     /* 127055 */   // Label 2525: @127055
     /* 127055 */   GIM_Reject,
     /* 127056 */ // Label 2523: @127056
     /* 127056 */ GIM_Reject,
     /* 127057 */ // Label 2514: @127057
     /* 127057 */ GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(127094), // Rule ID 1543 //
     /* 127062 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127076 */   // (ctlz:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCLZv8i8:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i8),
     /* 127079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127081 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127083 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127086 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127092 */   GIR_RootConstrainSelectedInstOperands,
     /* 127093 */   // GIR_Coverage, 1543,
     /* 127093 */   GIR_EraseRootFromParent_Done,
     /* 127094 */ // Label 2526: @127094
     /* 127094 */ GIM_Reject,
     /* 127095 */ // Label 2515: @127095
     /* 127095 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(127193),
     /* 127100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127103 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(127137), // Rule ID 1547 //
     /* 127108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127119 */     // (ctlz:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)  =>  (VCLZv8i16:{ *:[v8i16] } QPR:{ *:[v8i16] }:$Vm)
     /* 127119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv8i16),
     /* 127122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127126 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127129 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127135 */     GIR_RootConstrainSelectedInstOperands,
     /* 127136 */     // GIR_Coverage, 1547,
     /* 127136 */     GIR_EraseRootFromParent_Done,
     /* 127137 */   // Label 2528: @127137
     /* 127137 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(127192), // Rule ID 3653 //
     /* 127142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127149 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127153 */     // (ctlz:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)  =>  (MVE_VCLZs16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val)
     /* 127153 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127156 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127160 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs16),
     /* 127168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127170 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127187 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127190 */     GIR_RootConstrainSelectedInstOperands,
     /* 127191 */     // GIR_Coverage, 3653,
     /* 127191 */     GIR_EraseRootFromParent_Done,
     /* 127192 */   // Label 2529: @127192
     /* 127192 */   GIM_Reject,
     /* 127193 */ // Label 2527: @127193
     /* 127193 */ GIM_Reject,
     /* 127194 */ // Label 2516: @127194
     /* 127194 */ GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(127292),
     /* 127199 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127202 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(127236), // Rule ID 1546 //
     /* 127207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127218 */     // (ctlz:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCLZv16i8:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCLZv16i8),
     /* 127221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127223 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127225 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127228 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127234 */     GIR_RootConstrainSelectedInstOperands,
     /* 127235 */     // GIR_Coverage, 1546,
     /* 127235 */     GIR_EraseRootFromParent_Done,
     /* 127236 */   // Label 2531: @127236
     /* 127236 */   GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(127291), // Rule ID 3651 //
     /* 127241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127252 */     // (ctlz:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)  =>  (MVE_VCLZs8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val)
     /* 127252 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127255 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127259 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VCLZs8),
     /* 127267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127269 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 127271 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127274 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127280 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127289 */     GIR_RootConstrainSelectedInstOperands,
     /* 127290 */     // GIR_Coverage, 3651,
     /* 127290 */     GIR_EraseRootFromParent_Done,
     /* 127291 */   // Label 2532: @127291
     /* 127291 */   GIM_Reject,
     /* 127292 */ // Label 2530: @127292
     /* 127292 */ GIM_Reject,
     /* 127293 */ // Label 2517: @127293
     /* 127293 */ GIM_Reject,
     /* 127294 */ // Label 63: @127294
     /* 127294 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(11), GIMT_Encode2(16), /*)*//*default:*//*Label 2535*/ GIMT_Encode4(127401),
     /* 127305 */ /*GILLT_v8s8*//*Label 2533*/ GIMT_Encode4(127325), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127321 */ /*GILLT_v16s8*//*Label 2534*/ GIMT_Encode4(127363),
     /* 127325 */ // Label 2533: @127325
     /* 127325 */ GIM_Try, /*On fail goto*//*Label 2536*/ GIMT_Encode4(127362), // Rule ID 1549 //
     /* 127330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 127336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127340 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 127344 */   // (ctpop:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)  =>  (VCNTd:{ *:[v8i8] } DPR:{ *:[v8i8] }:$Vm)
     /* 127344 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTd),
     /* 127347 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127349 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127351 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127354 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127360 */   GIR_RootConstrainSelectedInstOperands,
     /* 127361 */   // GIR_Coverage, 1549,
     /* 127361 */   GIR_EraseRootFromParent_Done,
     /* 127362 */ // Label 2536: @127362
     /* 127362 */ GIM_Reject,
     /* 127363 */ // Label 2534: @127363
     /* 127363 */ GIM_Try, /*On fail goto*//*Label 2537*/ GIMT_Encode4(127400), // Rule ID 1550 //
     /* 127368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 127371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 127374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::QPRRegClassID),
     /* 127382 */   // (ctpop:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)  =>  (VCNTq:{ *:[v16i8] } QPR:{ *:[v16i8] }:$Vm)
     /* 127382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VCNTq),
     /* 127385 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 127387 */   GIR_RootToRootCopy, /*OpIdx*/1, // Vm
     /* 127389 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127392 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127398 */   GIR_RootConstrainSelectedInstOperands,
     /* 127399 */   // GIR_Coverage, 1550,
     /* 127399 */   GIR_EraseRootFromParent_Done,
     /* 127400 */ // Label 2537: @127400
     /* 127400 */ GIM_Reject,
     /* 127401 */ // Label 2535: @127401
     /* 127401 */ GIM_Reject,
     /* 127402 */ // Label 64: @127402
     /* 127402 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(13), /*)*//*default:*//*Label 2541*/ GIMT_Encode4(127691),
     /* 127413 */ /*GILLT_s32*//*Label 2538*/ GIMT_Encode4(127461), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127441 */ /*GILLT_v4s32*//*Label 2539*/ GIMT_Encode4(127573), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127457 */ /*GILLT_v8s16*//*Label 2540*/ GIMT_Encode4(127632),
     /* 127461 */ // Label 2538: @127461
     /* 127461 */ GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(127572),
     /* 127466 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127469 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(127503), // Rule ID 199 //
     /* 127474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsARM),
     /* 127477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127485 */     // (bswap:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (REV:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::REV),
     /* 127488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127495 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127501 */     GIR_RootConstrainSelectedInstOperands,
     /* 127502 */     // GIR_Coverage, 199,
     /* 127502 */     GIR_EraseRootFromParent_Done,
     /* 127503 */   // Label 2543: @127503
     /* 127503 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(127537), // Rule ID 326 //
     /* 127508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6_IsThumb_IsThumb1Only),
     /* 127511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127515 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::tGPRRegClassID),
     /* 127519 */     // (bswap:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)  =>  (tREV:{ *:[i32] } tGPR:{ *:[i32] }:$Rm)
     /* 127519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tREV),
     /* 127522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127529 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127535 */     GIR_RootConstrainSelectedInstOperands,
     /* 127536 */     // GIR_Coverage, 326,
     /* 127536 */     GIR_EraseRootFromParent_Done,
     /* 127537 */   // Label 2544: @127537
     /* 127537 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(127571), // Rule ID 536 //
     /* 127542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127553 */     // (bswap:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2REV:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2REV),
     /* 127556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127560 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127563 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127569 */     GIR_RootConstrainSelectedInstOperands,
     /* 127570 */     // GIR_Coverage, 536,
     /* 127570 */     GIR_EraseRootFromParent_Done,
     /* 127571 */   // Label 2545: @127571
     /* 127571 */   GIM_Reject,
     /* 127572 */ // Label 2542: @127572
     /* 127572 */ GIM_Reject,
     /* 127573 */ // Label 2539: @127573
     /* 127573 */ GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(127631), // Rule ID 3328 //
     /* 127578 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127581 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127588 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127592 */   // (bswap:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VREV32_8:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src)
     /* 127592 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127595 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127599 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127604 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV32_8),
     /* 127607 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127609 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127611 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127614 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127620 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127626 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127629 */   GIR_RootConstrainSelectedInstOperands,
     /* 127630 */   // GIR_Coverage, 3328,
     /* 127630 */   GIR_EraseRootFromParent_Done,
     /* 127631 */ // Label 2546: @127631
     /* 127631 */ GIM_Reject,
     /* 127632 */ // Label 2540: @127632
     /* 127632 */ GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(127690), // Rule ID 3327 //
     /* 127637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127647 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127651 */   // (bswap:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VREV16_8:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src)
     /* 127651 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 127654 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127658 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127663 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VREV16_8),
     /* 127666 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127668 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 127670 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127673 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127679 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127685 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127688 */   GIR_RootConstrainSelectedInstOperands,
     /* 127689 */   // GIR_Coverage, 3327,
     /* 127689 */   GIR_EraseRootFromParent_Done,
     /* 127690 */ // Label 2547: @127690
     /* 127690 */ GIM_Reject,
     /* 127691 */ // Label 2541: @127691
     /* 127691 */ GIM_Reject,
     /* 127692 */ // Label 65: @127692
     /* 127692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(16), /*)*//*default:*//*Label 2552*/ GIMT_Encode4(128123),
     /* 127703 */ /*GILLT_s32*//*Label 2548*/ GIMT_Encode4(127763), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127731 */ /*GILLT_v4s32*//*Label 2549*/ GIMT_Encode4(127841), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127747 */ /*GILLT_v8s16*//*Label 2550*/ GIMT_Encode4(127935), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 127759 */ /*GILLT_v16s8*//*Label 2551*/ GIMT_Encode4(128029),
     /* 127763 */ // Label 2548: @127763
     /* 127763 */ GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(127840),
     /* 127768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 127771 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(127805), // Rule ID 198 //
     /* 127776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV6T2_IsARM),
     /* 127779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127783 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::GPRRegClassID),
     /* 127787 */     // (bitreverse:{ *:[i32] } GPR:{ *:[i32] }:$Rm)  =>  (RBIT:{ *:[i32] } GPR:{ *:[i32] }:$Rm)
     /* 127787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::RBIT),
     /* 127790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127792 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127794 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127797 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127803 */     GIR_RootConstrainSelectedInstOperands,
     /* 127804 */     // GIR_Coverage, 198,
     /* 127804 */     GIR_EraseRootFromParent_Done,
     /* 127805 */   // Label 2554: @127805
     /* 127805 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(127839), // Rule ID 535 //
     /* 127810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb2),
     /* 127813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 127821 */     // (bitreverse:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)  =>  (t2RBIT:{ *:[i32] } rGPR:{ *:[i32] }:$Rm)
     /* 127821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::t2RBIT),
     /* 127824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 127826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 127828 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 127831 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127837 */     GIR_RootConstrainSelectedInstOperands,
     /* 127838 */     // GIR_Coverage, 535,
     /* 127838 */     GIR_EraseRootFromParent_Done,
     /* 127839 */   // Label 2555: @127839
     /* 127839 */   GIM_Reject,
     /* 127840 */ // Label 2553: @127840
     /* 127840 */ GIM_Reject,
     /* 127841 */ // Label 2549: @127841
     /* 127841 */ GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(127934), // Rule ID 4755 //
     /* 127846 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127849 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 127852 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127856 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127860 */   // (bitreverse:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1)  =>  (MVE_VBRSR32:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$val1, (t2MOVi:{ *:[i32] } 32:{ *:[i32] }))
     /* 127860 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127863 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127867 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127872 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127875 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127879 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127884 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/32,
     /* 127887 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127890 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127896 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127902 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR32),
     /* 127907 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 127909 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 127911 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127914 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127917 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127923 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127929 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 127932 */   GIR_RootConstrainSelectedInstOperands,
     /* 127933 */   // GIR_Coverage, 4755,
     /* 127933 */   GIR_EraseRootFromParent_Done,
     /* 127934 */ // Label 2556: @127934
     /* 127934 */ GIM_Reject,
     /* 127935 */ // Label 2550: @127935
     /* 127935 */ GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(128028), // Rule ID 4756 //
     /* 127940 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 127943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 127946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 127954 */   // (bitreverse:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1)  =>  (MVE_VBRSR16:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$val1, (t2MOVi:{ *:[i32] } 16:{ *:[i32] }))
     /* 127954 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 127957 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 127961 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 127969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 127973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127978 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/16,
     /* 127981 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 127984 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127990 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 127996 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127998 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR16),
     /* 128001 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128003 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128005 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128008 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128011 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128017 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128023 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128026 */   GIR_RootConstrainSelectedInstOperands,
     /* 128027 */   // GIR_Coverage, 4756,
     /* 128027 */   GIR_EraseRootFromParent_Done,
     /* 128028 */ // Label 2557: @128028
     /* 128028 */ GIM_Reject,
     /* 128029 */ // Label 2551: @128029
     /* 128029 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(128122), // Rule ID 4754 //
     /* 128034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 128037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 128040 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128044 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128048 */   // (bitreverse:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1)  =>  (MVE_VBRSR8:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$val1, (t2MOVi:{ *:[i32] } 8:{ *:[i32] }))
     /* 128048 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 128051 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128055 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128060 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 128063 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 128067 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128072 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 128075 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 128078 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128084 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128090 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 128092 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VBRSR8),
     /* 128095 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128097 */   GIR_RootToRootCopy, /*OpIdx*/1, // val1
     /* 128099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128102 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128105 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128111 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128117 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 128120 */   GIR_RootConstrainSelectedInstOperands,
     /* 128121 */   // GIR_Coverage, 4754,
     /* 128121 */   GIR_EraseRootFromParent_Done,
     /* 128122 */ // Label 2558: @128122
     /* 128122 */ GIM_Reject,
     /* 128123 */ // Label 2552: @128123
     /* 128123 */ GIM_Reject,
     /* 128124 */ // Label 66: @128124
     /* 128124 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2564*/ GIMT_Encode4(128386),
     /* 128135 */ /*GILLT_s16*//*Label 2559*/ GIMT_Encode4(128187),
     /* 128139 */ /*GILLT_s32*//*Label 2560*/ GIMT_Encode4(128214),
     /* 128143 */ /*GILLT_s64*//*Label 2561*/ GIMT_Encode4(128241), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128167 */ /*GILLT_v4s32*//*Label 2562*/ GIMT_Encode4(128268), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128183 */ /*GILLT_v8s16*//*Label 2563*/ GIMT_Encode4(128327),
     /* 128187 */ // Label 2559: @128187
     /* 128187 */ GIM_Try, /*On fail goto*//*Label 2565*/ GIMT_Encode4(128213), // Rule ID 680 //
     /* 128192 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128206 */   // (fceil:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTPH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128206 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPH),
     /* 128211 */   GIR_RootConstrainSelectedInstOperands,
     /* 128212 */   // GIR_Coverage, 680,
     /* 128212 */   GIR_Done,
     /* 128213 */ // Label 2565: @128213
     /* 128213 */ GIM_Reject,
     /* 128214 */ // Label 2560: @128214
     /* 128214 */ GIM_Try, /*On fail goto*//*Label 2566*/ GIMT_Encode4(128240), // Rule ID 681 //
     /* 128219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128233 */   // (fceil:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTPS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128233 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPS),
     /* 128238 */   GIR_RootConstrainSelectedInstOperands,
     /* 128239 */   // GIR_Coverage, 681,
     /* 128239 */   GIR_Done,
     /* 128240 */ // Label 2566: @128240
     /* 128240 */ GIM_Reject,
     /* 128241 */ // Label 2561: @128241
     /* 128241 */ GIM_Try, /*On fail goto*//*Label 2567*/ GIMT_Encode4(128267), // Rule ID 682 //
     /* 128246 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128260 */   // (fceil:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTPD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTPD),
     /* 128265 */   GIR_RootConstrainSelectedInstOperands,
     /* 128266 */   // GIR_Coverage, 682,
     /* 128266 */   GIR_Done,
     /* 128267 */ // Label 2567: @128267
     /* 128267 */ GIM_Reject,
     /* 128268 */ // Label 2562: @128268
     /* 128268 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(128326), // Rule ID 3983 //
     /* 128273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128287 */   // (fceil:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32P:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128287 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128290 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128294 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128299 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32P),
     /* 128302 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128304 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128306 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128309 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128315 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128321 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128324 */   GIR_RootConstrainSelectedInstOperands,
     /* 128325 */   // GIR_Coverage, 3983,
     /* 128325 */   GIR_EraseRootFromParent_Done,
     /* 128326 */ // Label 2568: @128326
     /* 128326 */ GIM_Reject,
     /* 128327 */ // Label 2563: @128327
     /* 128327 */ GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(128385), // Rule ID 3971 //
     /* 128332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128335 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128342 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128346 */   // (fceil:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16P:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128346 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128349 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128353 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128358 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16P),
     /* 128361 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128363 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128365 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128368 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128374 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128380 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128383 */   GIR_RootConstrainSelectedInstOperands,
     /* 128384 */   // GIR_Coverage, 3971,
     /* 128384 */   GIR_EraseRootFromParent_Done,
     /* 128385 */ // Label 2569: @128385
     /* 128385 */ GIM_Reject,
     /* 128386 */ // Label 2564: @128386
     /* 128386 */ GIM_Reject,
     /* 128387 */ // Label 67: @128387
     /* 128387 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2573*/ GIMT_Encode4(128524),
     /* 128398 */ /*GILLT_s16*//*Label 2570*/ GIMT_Encode4(128410),
     /* 128402 */ /*GILLT_s32*//*Label 2571*/ GIMT_Encode4(128448),
     /* 128406 */ /*GILLT_s64*//*Label 2572*/ GIMT_Encode4(128486),
     /* 128410 */ // Label 2570: @128410
     /* 128410 */ GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(128447), // Rule ID 688 //
     /* 128415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128429 */   // (fsqrt:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VSQRTH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTH),
     /* 128432 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128434 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128436 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128439 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128445 */   GIR_RootConstrainSelectedInstOperands,
     /* 128446 */   // GIR_Coverage, 688,
     /* 128446 */   GIR_EraseRootFromParent_Done,
     /* 128447 */ // Label 2574: @128447
     /* 128447 */ GIM_Reject,
     /* 128448 */ // Label 2571: @128448
     /* 128448 */ GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(128485), // Rule ID 687 //
     /* 128453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasVFP2),
     /* 128456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128467 */   // (fsqrt:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VSQRTS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128467 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTS),
     /* 128470 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128472 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128474 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128477 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128483 */   GIR_RootConstrainSelectedInstOperands,
     /* 128484 */   // GIR_Coverage, 687,
     /* 128484 */   GIR_EraseRootFromParent_Done,
     /* 128485 */ // Label 2575: @128485
     /* 128485 */ GIM_Reject,
     /* 128486 */ // Label 2572: @128486
     /* 128486 */ GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(128523), // Rule ID 686 //
     /* 128491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasVFP2),
     /* 128494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128501 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128505 */   // (fsqrt:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VSQRTD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128505 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VSQRTD),
     /* 128508 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128510 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128515 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128521 */   GIR_RootConstrainSelectedInstOperands,
     /* 128522 */   // GIR_Coverage, 686,
     /* 128522 */   GIR_EraseRootFromParent_Done,
     /* 128523 */ // Label 2576: @128523
     /* 128523 */ GIM_Reject,
     /* 128524 */ // Label 2573: @128524
     /* 128524 */ GIM_Reject,
     /* 128525 */ // Label 68: @128525
     /* 128525 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2582*/ GIMT_Encode4(128787),
     /* 128536 */ /*GILLT_s16*//*Label 2577*/ GIMT_Encode4(128588),
     /* 128540 */ /*GILLT_s32*//*Label 2578*/ GIMT_Encode4(128615),
     /* 128544 */ /*GILLT_s64*//*Label 2579*/ GIMT_Encode4(128642), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128568 */ /*GILLT_v4s32*//*Label 2580*/ GIMT_Encode4(128669), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128584 */ /*GILLT_v8s16*//*Label 2581*/ GIMT_Encode4(128728),
     /* 128588 */ // Label 2577: @128588
     /* 128588 */ GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(128614), // Rule ID 683 //
     /* 128593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128607 */   // (ffloor:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTMH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMH),
     /* 128612 */   GIR_RootConstrainSelectedInstOperands,
     /* 128613 */   // GIR_Coverage, 683,
     /* 128613 */   GIR_Done,
     /* 128614 */ // Label 2583: @128614
     /* 128614 */ GIM_Reject,
     /* 128615 */ // Label 2578: @128615
     /* 128615 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(128641), // Rule ID 684 //
     /* 128620 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128634 */   // (ffloor:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTMS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMS),
     /* 128639 */   GIR_RootConstrainSelectedInstOperands,
     /* 128640 */   // GIR_Coverage, 684,
     /* 128640 */   GIR_Done,
     /* 128641 */ // Label 2584: @128641
     /* 128641 */ GIM_Reject,
     /* 128642 */ // Label 2579: @128642
     /* 128642 */ GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(128668), // Rule ID 685 //
     /* 128647 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128661 */   // (ffloor:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTMD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::VRINTMD),
     /* 128666 */   GIR_RootConstrainSelectedInstOperands,
     /* 128667 */   // GIR_Coverage, 685,
     /* 128667 */   GIR_Done,
     /* 128668 */ // Label 2585: @128668
     /* 128668 */ GIM_Reject,
     /* 128669 */ // Label 2580: @128669
     /* 128669 */ GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(128727), // Rule ID 3981 //
     /* 128674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128688 */   // (ffloor:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32M:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128688 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128691 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128695 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32M),
     /* 128703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128705 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128707 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128710 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128716 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128722 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128725 */   GIR_RootConstrainSelectedInstOperands,
     /* 128726 */   // GIR_Coverage, 3981,
     /* 128726 */   GIR_EraseRootFromParent_Done,
     /* 128727 */ // Label 2586: @128727
     /* 128727 */ GIM_Reject,
     /* 128728 */ // Label 2581: @128728
     /* 128728 */ GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(128786), // Rule ID 3969 //
     /* 128733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 128739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128747 */   // (ffloor:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16M:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 128747 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128750 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128754 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128759 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16M),
     /* 128762 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 128764 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 128766 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 128769 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128775 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128781 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 128784 */   GIR_RootConstrainSelectedInstOperands,
     /* 128785 */   // GIR_Coverage, 3969,
     /* 128785 */   GIR_EraseRootFromParent_Done,
     /* 128786 */ // Label 2587: @128786
     /* 128786 */ GIM_Reject,
     /* 128787 */ // Label 2582: @128787
     /* 128787 */ GIM_Reject,
     /* 128788 */ // Label 69: @128788
     /* 128788 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(13), /*)*//*default:*//*Label 2593*/ GIMT_Encode4(129083),
     /* 128799 */ /*GILLT_s16*//*Label 2588*/ GIMT_Encode4(128851),
     /* 128803 */ /*GILLT_s32*//*Label 2589*/ GIMT_Encode4(128889),
     /* 128807 */ /*GILLT_s64*//*Label 2590*/ GIMT_Encode4(128927), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128831 */ /*GILLT_v4s32*//*Label 2591*/ GIMT_Encode4(128965), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 128847 */ /*GILLT_v8s16*//*Label 2592*/ GIMT_Encode4(129024),
     /* 128851 */ // Label 2588: @128851
     /* 128851 */ GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(128888), // Rule ID 671 //
     /* 128856 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 128859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 128862 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128866 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 128870 */   // (frint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTXH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 128870 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXH),
     /* 128873 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128875 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128877 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128880 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128886 */   GIR_RootConstrainSelectedInstOperands,
     /* 128887 */   // GIR_Coverage, 671,
     /* 128887 */   GIR_EraseRootFromParent_Done,
     /* 128888 */ // Label 2594: @128888
     /* 128888 */ GIM_Reject,
     /* 128889 */ // Label 2589: @128889
     /* 128889 */ GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(128926), // Rule ID 672 //
     /* 128894 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 128897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 128900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128904 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 128908 */   // (frint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTXS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 128908 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXS),
     /* 128911 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 128913 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 128915 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128918 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128924 */   GIR_RootConstrainSelectedInstOperands,
     /* 128925 */   // GIR_Coverage, 672,
     /* 128925 */   GIR_EraseRootFromParent_Done,
     /* 128926 */ // Label 2595: @128926
     /* 128926 */ GIM_Reject,
     /* 128927 */ // Label 2590: @128927
     /* 128927 */ GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(128964), // Rule ID 673 //
     /* 128932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 128935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 128938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 128946 */   // (frint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTXD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 128946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTXD),
     /* 128949 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 128951 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 128953 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 128956 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 128962 */   GIR_RootConstrainSelectedInstOperands,
     /* 128963 */   // GIR_Coverage, 673,
     /* 128963 */   GIR_EraseRootFromParent_Done,
     /* 128964 */ // Label 2596: @128964
     /* 128964 */ GIM_Reject,
     /* 128965 */ // Label 2591: @128965
     /* 128965 */ GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(129023), // Rule ID 3975 //
     /* 128970 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 128973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 128976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 128984 */   // (frint:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)  =>  (MVE_VRINTf32X:{ *:[v4f32] } MQPR:{ *:[v4f32] }:$val)
     /* 128984 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 128987 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 128991 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 128996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf32X),
     /* 128999 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129001 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129003 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129006 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129012 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129018 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129021 */   GIR_RootConstrainSelectedInstOperands,
     /* 129022 */   // GIR_Coverage, 3975,
     /* 129022 */   GIR_EraseRootFromParent_Done,
     /* 129023 */ // Label 2597: @129023
     /* 129023 */ GIM_Reject,
     /* 129024 */ // Label 2592: @129024
     /* 129024 */ GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(129082), // Rule ID 3963 //
     /* 129029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEFloat),
     /* 129032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129039 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129043 */   // (frint:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)  =>  (MVE_VRINTf16X:{ *:[v8f16] } MQPR:{ *:[v8f16] }:$val)
     /* 129043 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 129046 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 129050 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129055 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VRINTf16X),
     /* 129058 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Qd]
     /* 129060 */   GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 129062 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129065 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129071 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129077 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129080 */   GIR_RootConstrainSelectedInstOperands,
     /* 129081 */   // GIR_Coverage, 3963,
     /* 129081 */   GIR_EraseRootFromParent_Done,
     /* 129082 */ // Label 2598: @129082
     /* 129082 */ GIM_Reject,
     /* 129083 */ // Label 2593: @129083
     /* 129083 */ GIM_Reject,
     /* 129084 */ // Label 70: @129084
     /* 129084 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 2602*/ GIMT_Encode4(129221),
     /* 129095 */ /*GILLT_s16*//*Label 2599*/ GIMT_Encode4(129107),
     /* 129099 */ /*GILLT_s32*//*Label 2600*/ GIMT_Encode4(129145),
     /* 129103 */ /*GILLT_s64*//*Label 2601*/ GIMT_Encode4(129183),
     /* 129107 */ // Label 2599: @129107
     /* 129107 */ GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(129144), // Rule ID 668 //
     /* 129112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 129115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 129118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::HPRRegClassID),
     /* 129126 */   // (fnearbyint:{ *:[f16] } HPR:{ *:[f16] }:$Sm)  =>  (VRINTRH:{ *:[f16] } HPR:{ *:[f16] }:$Sm)
     /* 129126 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRH),
     /* 129129 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129131 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129133 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129136 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129142 */   GIR_RootConstrainSelectedInstOperands,
     /* 129143 */   // GIR_Coverage, 668,
     /* 129143 */   GIR_EraseRootFromParent_Done,
     /* 129144 */ // Label 2603: @129144
     /* 129144 */ GIM_Reject,
     /* 129145 */ // Label 2600: @129145
     /* 129145 */ GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(129182), // Rule ID 669 //
     /* 129150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 129153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 129156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::SPRRegClassID),
     /* 129164 */   // (fnearbyint:{ *:[f32] } SPR:{ *:[f32] }:$Sm)  =>  (VRINTRS:{ *:[f32] } SPR:{ *:[f32] }:$Sm)
     /* 129164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRS),
     /* 129167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Sd]
     /* 129169 */   GIR_RootToRootCopy, /*OpIdx*/1, // Sm
     /* 129171 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129174 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129180 */   GIR_RootConstrainSelectedInstOperands,
     /* 129181 */   // GIR_Coverage, 669,
     /* 129181 */   GIR_EraseRootFromParent_Done,
     /* 129182 */ // Label 2604: @129182
     /* 129182 */ GIM_Reject,
     /* 129183 */ // Label 2601: @129183
     /* 129183 */ GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(129220), // Rule ID 670 //
     /* 129188 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDPVFP_HasFPARMv8),
     /* 129191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 129194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129198 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::DPRRegClassID),
     /* 129202 */   // (fnearbyint:{ *:[f64] } DPR:{ *:[f64] }:$Dm)  =>  (VRINTRD:{ *:[f64] } DPR:{ *:[f64] }:$Dm)
     /* 129202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::VRINTRD),
     /* 129205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Dd]
     /* 129207 */   GIR_RootToRootCopy, /*OpIdx*/1, // Dm
     /* 129209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/14,
     /* 129212 */   GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129218 */   GIR_RootConstrainSelectedInstOperands,
     /* 129219 */   // GIR_Coverage, 670,
     /* 129219 */   GIR_EraseRootFromParent_Done,
     /* 129220 */ // Label 2605: @129220
     /* 129220 */ GIM_Reject,
     /* 129221 */ // Label 2602: @129221
     /* 129221 */ GIM_Reject,
     /* 129222 */ // Label 71: @129222
     /* 129222 */ GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(129237), // Rule ID 12 //
     /* 129227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_UseNaClTrap),
     /* 129230 */   // (trap)  =>  (TRAPNaCl)
     /* 129230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAPNaCl),
     /* 129235 */   GIR_RootConstrainSelectedInstOperands,
     /* 129236 */   // GIR_Coverage, 12,
     /* 129236 */   GIR_Done,
     /* 129237 */ // Label 2606: @129237
     /* 129237 */ GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(129252), // Rule ID 13 //
     /* 129242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_DontUseNaClTrap_IsARM),
     /* 129245 */   // (trap)  =>  (TRAP)
     /* 129245 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::TRAP),
     /* 129250 */   GIR_RootConstrainSelectedInstOperands,
     /* 129251 */   // GIR_Coverage, 13,
     /* 129251 */   GIR_Done,
     /* 129252 */ // Label 2607: @129252
     /* 129252 */ GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(129267), // Rule ID 285 //
     /* 129257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb),
     /* 129260 */   // (trap)  =>  (tTRAP)
     /* 129260 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(ARM::tTRAP),
     /* 129265 */   GIR_RootConstrainSelectedInstOperands,
     /* 129266 */   // GIR_Coverage, 285,
     /* 129266 */   GIR_Done,
     /* 129267 */ // Label 2608: @129267
     /* 129267 */ GIM_Reject,
     /* 129268 */ // Label 72: @129268
     /* 129268 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(129284), // Rule ID 1835 //
     /* 129273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsARM),
     /* 129276 */   // (debugtrap)  =>  (BKPT 0:{ *:[i32] })
     /* 129276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::BKPT),
     /* 129279 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129282 */   GIR_RootConstrainSelectedInstOperands,
     /* 129283 */   // GIR_Coverage, 1835,
     /* 129283 */   GIR_EraseRootFromParent_Done,
     /* 129284 */ // Label 2609: @129284
     /* 129284 */ GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(129311), // Rule ID 1836 //
     /* 129289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsARM_NoV5T),
     /* 129292 */   // (debugtrap)  =>  (UDF 254:{ *:[i32] })
     /* 129292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::UDF),
     /* 129295 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129305 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129309 */   GIR_RootConstrainSelectedInstOperands,
     /* 129310 */   // GIR_Coverage, 1836,
     /* 129310 */   GIR_EraseRootFromParent_Done,
     /* 129311 */ // Label 2610: @129311
     /* 129311 */ GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(129327), // Rule ID 2021 //
     /* 129316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasV5T_IsThumb),
     /* 129319 */   // (debugtrap)  =>  (tBKPT 0:{ *:[i32] })
     /* 129319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tBKPT),
     /* 129322 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129325 */   GIR_RootConstrainSelectedInstOperands,
     /* 129326 */   // GIR_Coverage, 2021,
     /* 129326 */   GIR_EraseRootFromParent_Done,
     /* 129327 */ // Label 2611: @129327
     /* 129327 */ GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(129354), // Rule ID 2022 //
     /* 129332 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsThumb_NoV5T),
     /* 129335 */   // (debugtrap)  =>  (tUDF 254:{ *:[i32] })
     /* 129335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::tUDF),
     /* 129338 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(254),
     /* 129348 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129352 */   GIR_RootConstrainSelectedInstOperands,
     /* 129353 */   // GIR_Coverage, 2022,
     /* 129353 */   GIR_EraseRootFromParent_Done,
     /* 129354 */ // Label 2612: @129354
     /* 129354 */ GIM_Reject,
     /* 129355 */ // Label 73: @129355
     /* 129355 */ GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(129775),
     /* 129360 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129363 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(129661),
     /* 129374 */   /*GILLT_v4s32*//*Label 2614*/ GIMT_Encode4(129406), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129390 */   /*GILLT_v8s16*//*Label 2615*/ GIMT_Encode4(129477), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129402 */   /*GILLT_v16s8*//*Label 2616*/ GIMT_Encode4(129548),
     /* 129406 */   // Label 2614: @129406
     /* 129406 */   GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(129476), // Rule ID 3238 //
     /* 129411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 129430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 129434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129439 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129446 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v4i32] } MQPR:{ *:[v4i32] }:$src1, MQPR:{ *:[v4i32] }:$src2))  =>  (MVE_VMLADAVu32:{ *:[i32] } ?:{ *:[v4i32] }:$src1, ?:{ *:[v4i32] }:$src2)
     /* 129446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu32),
     /* 129449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129462 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129468 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129474 */     GIR_RootConstrainSelectedInstOperands,
     /* 129475 */     // GIR_Coverage, 3238,
     /* 129475 */     GIR_EraseRootFromParent_Done,
     /* 129476 */   // Label 2618: @129476
     /* 129476 */   GIM_Reject,
     /* 129477 */   // Label 2615: @129477
     /* 129477 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(129547), // Rule ID 3239 //
     /* 129482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 129501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 129505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129510 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129517 */     // (vecreduce_add:{ *:[i32] } (mul:{ *:[v8i16] } MQPR:{ *:[v8i16] }:$src1, MQPR:{ *:[v8i16] }:$src2))  =>  (MVE_VMLADAVu16:{ *:[i32] } ?:{ *:[v8i16] }:$src1, ?:{ *:[v8i16] }:$src2)
     /* 129517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu16),
     /* 129520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129545 */     GIR_RootConstrainSelectedInstOperands,
     /* 129546 */     // GIR_Coverage, 3239,
     /* 129546 */     GIR_EraseRootFromParent_Done,
     /* 129547 */   // Label 2619: @129547
     /* 129547 */   GIM_Reject,
     /* 129548 */   // Label 2616: @129548
     /* 129548 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(129660),
     /* 129553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129557 */     GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(129623), // Rule ID 3242 //
     /* 129562 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129565 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 129569 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /* 129573 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 129577 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 129581 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129586 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129591 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 129593 */       // (vecreduce_add:{ *:[i32] } (mul:{ *:[v16i8] } MQPR:{ *:[v16i8] }:$src1, MQPR:{ *:[v16i8] }:$src2))  =>  (MVE_VMLADAVu8:{ *:[i32] } ?:{ *:[v16i8] }:$src1, ?:{ *:[v16i8] }:$src2)
     /* 129593 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMLADAVu8),
     /* 129596 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129598 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // src1
     /* 129602 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // src2
     /* 129606 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129609 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129615 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129621 */       GIR_RootConstrainSelectedInstOperands,
     /* 129622 */       // GIR_Coverage, 3242,
     /* 129622 */       GIR_EraseRootFromParent_Done,
     /* 129623 */     // Label 2621: @129623
     /* 129623 */     GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(129659), // Rule ID 3046 //
     /* 129628 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129631 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129635 */       // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v16i8] }:$vec)  =>  (MVE_VADDVu8no_acc:{ *:[i32] } ?:{ *:[v16i8] }:$vec)
     /* 129635 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu8no_acc),
     /* 129638 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129640 */       GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129642 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129645 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129651 */       GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129657 */       GIR_RootConstrainSelectedInstOperands,
     /* 129658 */       // GIR_Coverage, 3046,
     /* 129658 */       GIR_EraseRootFromParent_Done,
     /* 129659 */     // Label 2622: @129659
     /* 129659 */     GIM_Reject,
     /* 129660 */   // Label 2620: @129660
     /* 129660 */   GIM_Reject,
     /* 129661 */   // Label 2617: @129661
     /* 129661 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(13), /*)*//*default:*//*Label 2625*/ GIMT_Encode4(129774),
     /* 129672 */   /*GILLT_v4s32*//*Label 2623*/ GIMT_Encode4(129692), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129688 */   /*GILLT_v8s16*//*Label 2624*/ GIMT_Encode4(129733),
     /* 129692 */   // Label 2623: @129692
     /* 129692 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(129732), // Rule ID 3084 //
     /* 129697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129708 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v4i32] }:$vec)  =>  (MVE_VADDVu32no_acc:{ *:[i32] } ?:{ *:[v4i32] }:$vec)
     /* 129708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu32no_acc),
     /* 129711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129713 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129718 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129724 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129730 */     GIR_RootConstrainSelectedInstOperands,
     /* 129731 */     // GIR_Coverage, 3084,
     /* 129731 */     GIR_EraseRootFromParent_Done,
     /* 129732 */   // Label 2626: @129732
     /* 129732 */   GIM_Reject,
     /* 129733 */   // Label 2624: @129733
     /* 129733 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(129773), // Rule ID 3074 //
     /* 129738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::tGPREvenRegClassID),
     /* 129745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129749 */     // (vecreduce_add:{ *:[i32] } MQPR:{ *:[v8i16] }:$vec)  =>  (MVE_VADDVu16no_acc:{ *:[i32] } ?:{ *:[v8i16] }:$vec)
     /* 129749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VADDVu16no_acc),
     /* 129752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rda]
     /* 129754 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 129756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129759 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129765 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129771 */     GIR_RootConstrainSelectedInstOperands,
     /* 129772 */     // GIR_Coverage, 3074,
     /* 129772 */     GIR_EraseRootFromParent_Done,
     /* 129773 */   // Label 2627: @129773
     /* 129773 */   GIM_Reject,
     /* 129774 */   // Label 2625: @129774
     /* 129774 */   GIM_Reject,
     /* 129775 */ // Label 2613: @129775
     /* 129775 */ GIM_Reject,
     /* 129776 */ // Label 74: @129776
     /* 129776 */ GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(130055),
     /* 129781 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 129784 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2632*/ GIMT_Encode4(130054),
     /* 129795 */   /*GILLT_v4s32*//*Label 2629*/ GIMT_Encode4(129827), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129811 */   /*GILLT_v8s16*//*Label 2630*/ GIMT_Encode4(129910), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 129823 */   /*GILLT_v16s8*//*Label 2631*/ GIMT_Encode4(129978),
     /* 129827 */   // Label 2629: @129827
     /* 129827 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(129909), // Rule ID 3144 //
     /* 129832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129843 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVs32:{ *:[i32] } (t2MOVi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 129843 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129846 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 129850 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129855 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 129865 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 129868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129880 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs32),
     /* 129885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129887 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129890 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129895 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129901 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129907 */     GIR_RootConstrainSelectedInstOperands,
     /* 129908 */     // GIR_Coverage, 3144,
     /* 129908 */     GIR_EraseRootFromParent_Done,
     /* 129909 */   // Label 2633: @129909
     /* 129909 */   GIM_Reject,
     /* 129910 */   // Label 2630: @129910
     /* 129910 */   GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(129977), // Rule ID 3143 //
     /* 129915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129926 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVs16:{ *:[i32] } (t2MOVi32imm:{ *:[i32] } -32768:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 129926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi32imm),
     /* 129933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129938 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-32768),
     /* 129948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs16),
     /* 129953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 129955 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129958 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 129960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129963 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129969 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 129975 */     GIR_RootConstrainSelectedInstOperands,
     /* 129976 */     // GIR_Coverage, 3143,
     /* 129976 */     GIR_EraseRootFromParent_Done,
     /* 129977 */   // Label 2634: @129977
     /* 129977 */   GIM_Reject,
     /* 129978 */   // Label 2631: @129978
     /* 129978 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(130053), // Rule ID 3142 //
     /* 129983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 129986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 129990 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 129994 */     // (vecreduce_smax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVs8:{ *:[i32] } (t2MVNi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 129994 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129997 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130001 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130006 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130009 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130012 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130018 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVs8),
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130031 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130034 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130036 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130039 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130045 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130051 */     GIR_RootConstrainSelectedInstOperands,
     /* 130052 */     // GIR_Coverage, 3142,
     /* 130052 */     GIR_EraseRootFromParent_Done,
     /* 130053 */   // Label 2635: @130053
     /* 130053 */   GIM_Reject,
     /* 130054 */   // Label 2632: @130054
     /* 130054 */   GIM_Reject,
     /* 130055 */ // Label 2628: @130055
     /* 130055 */ GIM_Reject,
     /* 130056 */ // Label 75: @130056
     /* 130056 */ GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(130344),
     /* 130061 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130064 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2640*/ GIMT_Encode4(130343),
     /* 130075 */   /*GILLT_v4s32*//*Label 2637*/ GIMT_Encode4(130107), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130091 */   /*GILLT_v8s16*//*Label 2638*/ GIMT_Encode4(130190), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130103 */   /*GILLT_v16s8*//*Label 2639*/ GIMT_Encode4(130267),
     /* 130107 */   // Label 2637: @130107
     /* 130107 */   GIM_Try, /*On fail goto*//*Label 2641*/ GIMT_Encode4(130189), // Rule ID 3150 //
     /* 130112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130119 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130123 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVs32:{ *:[i32] } (t2MVNi:{ *:[i32] } -2147483648:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130123 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130126 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MVNi),
     /* 130130 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130135 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(-2147483648),
     /* 130145 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130148 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130154 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130160 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs32),
     /* 130165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130170 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130175 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130181 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130187 */     GIR_RootConstrainSelectedInstOperands,
     /* 130188 */     // GIR_Coverage, 3150,
     /* 130188 */     GIR_EraseRootFromParent_Done,
     /* 130189 */   // Label 2641: @130189
     /* 130189 */   GIM_Reject,
     /* 130190 */   // Label 2638: @130190
     /* 130190 */   GIM_Try, /*On fail goto*//*Label 2642*/ GIMT_Encode4(130266), // Rule ID 3149 //
     /* 130195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130206 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVs16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 32767:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130206 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130209 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130213 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130218 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(32767),
     /* 130228 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130231 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs16),
     /* 130242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130247 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130252 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130258 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130264 */     GIR_RootConstrainSelectedInstOperands,
     /* 130265 */     // GIR_Coverage, 3149,
     /* 130265 */     GIR_EraseRootFromParent_Done,
     /* 130266 */   // Label 2642: @130266
     /* 130266 */   GIM_Reject,
     /* 130267 */   // Label 2639: @130267
     /* 130267 */   GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(130342), // Rule ID 3148 //
     /* 130272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130279 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130283 */     // (vecreduce_smin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVs8:{ *:[i32] } (t2MOVi:{ *:[i32] } 127:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130295 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/127,
     /* 130298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130301 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130307 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVs8),
     /* 130318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130320 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130323 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130328 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130340 */     GIR_RootConstrainSelectedInstOperands,
     /* 130341 */     // GIR_Coverage, 3148,
     /* 130341 */     GIR_EraseRootFromParent_Done,
     /* 130342 */   // Label 2643: @130342
     /* 130342 */   GIM_Reject,
     /* 130343 */   // Label 2640: @130343
     /* 130343 */   GIM_Reject,
     /* 130344 */ // Label 2636: @130344
     /* 130344 */ GIM_Reject,
     /* 130345 */ // Label 76: @130345
     /* 130345 */ GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(130625),
     /* 130350 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130353 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2648*/ GIMT_Encode4(130624),
     /* 130364 */   /*GILLT_v4s32*//*Label 2645*/ GIMT_Encode4(130396), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130380 */   /*GILLT_v8s16*//*Label 2646*/ GIMT_Encode4(130472), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130392 */   /*GILLT_v16s8*//*Label 2647*/ GIMT_Encode4(130548),
     /* 130396 */   // Label 2645: @130396
     /* 130396 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(130471), // Rule ID 3147 //
     /* 130401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130412 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMAXVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130424 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130427 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130430 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130436 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu32),
     /* 130447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130452 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130457 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130463 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130469 */     GIR_RootConstrainSelectedInstOperands,
     /* 130470 */     // GIR_Coverage, 3147,
     /* 130470 */     GIR_EraseRootFromParent_Done,
     /* 130471 */   // Label 2649: @130471
     /* 130471 */   GIM_Reject,
     /* 130472 */   // Label 2646: @130472
     /* 130472 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(130547), // Rule ID 3146 //
     /* 130477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130488 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMAXVu16:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130500 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130512 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu16),
     /* 130523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130528 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130533 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130539 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130545 */     GIR_RootConstrainSelectedInstOperands,
     /* 130546 */     // GIR_Coverage, 3146,
     /* 130546 */     GIR_EraseRootFromParent_Done,
     /* 130547 */   // Label 2650: @130547
     /* 130547 */   GIM_Reject,
     /* 130548 */   // Label 2647: @130548
     /* 130548 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(130623), // Rule ID 3145 //
     /* 130553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130564 */     // (vecreduce_umax:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMAXVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 0:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130576 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 130579 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130582 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130588 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMAXVu8),
     /* 130599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130604 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130609 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130615 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130621 */     GIR_RootConstrainSelectedInstOperands,
     /* 130622 */     // GIR_Coverage, 3145,
     /* 130622 */     GIR_EraseRootFromParent_Done,
     /* 130623 */   // Label 2651: @130623
     /* 130623 */   GIM_Reject,
     /* 130624 */   // Label 2648: @130624
     /* 130624 */   GIM_Reject,
     /* 130625 */ // Label 2644: @130625
     /* 130625 */ GIM_Reject,
     /* 130626 */ // Label 77: @130626
     /* 130626 */ GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(130921),
     /* 130631 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 130634 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(8), GIMT_Encode2(16), /*)*//*default:*//*Label 2656*/ GIMT_Encode4(130920),
     /* 130645 */   /*GILLT_v4s32*//*Label 2653*/ GIMT_Encode4(130677), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130661 */   /*GILLT_v8s16*//*Label 2654*/ GIMT_Encode4(130760), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 130673 */   /*GILLT_v16s8*//*Label 2655*/ GIMT_Encode4(130837),
     /* 130677 */   // Label 2653: @130677
     /* 130677 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(130759), // Rule ID 3153 //
     /* 130682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130693 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v4i32] }:$src)  =>  (MVE_VMINVu32:{ *:[i32] } (t2MOVi:{ *:[i32] } 4294967295:{ *:[i32] }), ?:{ *:[v4i32] }:$src)
     /* 130693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130705 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(4294967295),
     /* 130715 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130718 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130724 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu32),
     /* 130735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130740 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130745 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130751 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130757 */     GIR_RootConstrainSelectedInstOperands,
     /* 130758 */     // GIR_Coverage, 3153,
     /* 130758 */     GIR_EraseRootFromParent_Done,
     /* 130759 */   // Label 2657: @130759
     /* 130759 */   GIM_Reject,
     /* 130760 */   // Label 2654: @130760
     /* 130760 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(130836), // Rule ID 3152 //
     /* 130765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130772 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130776 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v8i16] }:$src)  =>  (MVE_VMINVu16:{ *:[i32] } (t2MOVi16:{ *:[i32] } 65535:{ *:[i32] }), ?:{ *:[v8i16] }:$src)
     /* 130776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi16),
     /* 130783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130788 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(65535),
     /* 130798 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130801 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu16),
     /* 130812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130814 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130817 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130822 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130828 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130834 */     GIR_RootConstrainSelectedInstOperands,
     /* 130835 */     // GIR_Coverage, 3152,
     /* 130835 */     GIR_EraseRootFromParent_Done,
     /* 130836 */   // Label 2658: @130836
     /* 130836 */   GIM_Reject,
     /* 130837 */   // Label 2655: @130837
     /* 130837 */   GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(130919), // Rule ID 3151 //
     /* 130842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMVEInt),
     /* 130845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(ARM::rGPRRegClassID),
     /* 130849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(ARM::MQPRRegClassID),
     /* 130853 */     // (vecreduce_umin:{ *:[i32] } MQPR:{ *:[v16i8] }:$src)  =>  (MVE_VMINVu8:{ *:[i32] } (t2MOVi:{ *:[i32] } 255:{ *:[i32] }), ?:{ *:[v16i8] }:$src)
     /* 130853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(ARM::t2MOVi),
     /* 130860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130865 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(255),
     /* 130875 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/14,
     /* 130878 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130884 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(ARM::MVE_VMINVu8),
     /* 130895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[RdaDest]
     /* 130897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130900 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 130902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130905 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130911 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(ARM::NoRegister), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 130917 */     GIR_RootConstrainSelectedInstOperands,
     /* 130918 */     // GIR_Coverage, 3151,
     /* 130918 */     GIR_EraseRootFromParent_Done,
     /* 130919 */   // Label 2659: @130919
     /* 130919 */   GIM_Reject,
     /* 130920 */   // Label 2656: @130920
     /* 130920 */   GIM_Reject,
     /* 130921 */ // Label 2652: @130921
     /* 130921 */ GIM_Reject,
     /* 130922 */ // Label 78: @130922
     /* 130922 */ GIM_Reject,
     /* 130923 */ }; // Size: 130923 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const ARMSubtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const ARMSubtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
